#include <bits/stdc++.h>
#define int long long
#ifndef LOCAL
#define endl '\n'
#endif

using namespace std;

void solve() {
  int n, m;
  cin >> n >> m;
  int ans = 0;
  long long nmsum = n * m * 1LL * (n * m + 1) / 2;
  long long ans_val = LONG_LONG_MAX;
  int ans_dir = -1;
  { // Vertical cut
    if (m > 1) {
      long long n1sum = n * 1LL * (n - 1) / 2;
      int L = 0;
      int R = m;
      while (R - L > 1) {
        int M = (R + L) / 2;
        long long Lsum = M * 1LL * (M + 1) / 2 * n + M * 1LL * m * n1sum;
        long long Rsum = nmsum - Lsum;
        if (Lsum <= Rsum)
          L = M;
        else
          R = M;
      }
      long long Lsum = L * 1LL * (L + 1) / 2 * n + L * 1LL * m * n1sum;
      long long Rsum = R * 1LL * (R + 1) / 2 * n + R * 1LL * m * n1sum;
      if (abs(Lsum - (nmsum - Lsum)) < abs(Rsum - (nmsum - Rsum))) {
        ans = L;
        ans_val = abs(Lsum - (nmsum - Lsum));
        ans_dir = 0;
      } else {
        ans = R;
        ans_val = abs(Rsum - (nmsum - Rsum));
        ans_dir = 0;
      }
    }
  }
  { // Horizontal cut
    if (n > 1) {
      int L = 0;
      int R = n;
      while (R - L > 1) {
        int M = (L + R) / 2;
        int Llast = M * m;
        long long Lsum = Llast * 1LL * (Llast + 1) / 2;
        long long Rsum = nmsum - Lsum;
        if (Lsum <= Rsum)
          L = M;
        else
          R = M;
      }
      int Llast = L * m;
      long long Lsum = Llast * 1LL * (Llast + 1) / 2;
      int Rlast = R * m;
      long long Rsum = Rlast * 1LL * (Rlast + 1) / 2;
      int cur_ans = 0;
      long long cur_val;
      if (abs(Lsum - (nmsum - Lsum)) < abs(Rsum - (nmsum - Rsum))) {
        cur_val = abs(Lsum - (nmsum - Lsum));
        cur_ans = L;
      } else {
        cur_val = abs(Rsum - (nmsum - Rsum));
        cur_ans = R;
      }
      if (cur_val < ans_val) {
        ans_val = cur_val;
        ans = cur_ans;
        ans_dir = 1;
      }
    }
  }
  assert(ans_dir != -1);
  if (ans_dir) {
    cout << "H ";
  } else {
    cout << "V ";
  }
  cout << ans + 1 << endl;

}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}