#include <bits/stdc++.h>

#ifndef LOCAL
#define endl '\n'
#endif

using namespace std;

char chars[4] = {'A', 'C', 'G', 'T'};

int num_len(int n) {
  if (n == 1)
    return 0;
  int ans = 0;
  while (n > 0) {
    ans++;
    n /= 10;
  }
  return ans;
}

char any_except_two(char f1, char f2) {
  for (auto c : chars) {
    if (c!= f1 && c != f2)
      return c;
  }
  return 0;
}


signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  string s;
  cin >> s;
  vector<pair<char, int>> blocks;
  int len = s.length();
  int cur_cnt = 0;
  for (auto c : s) {
    if ('0' <= c && c <= '9') {
      cur_cnt *= 10;
      cur_cnt += (c - '0');
    } else {
      if (cur_cnt == 0)
        cur_cnt = 1;
      blocks.emplace_back(c, cur_cnt);
      cur_cnt = 0;
    }
  }
  int ans_min = INT_MAX;
  int min_where = -1;
  int ans_max = 0;
  int max_where = -1;
  char max_what = 0;
  int n = blocks.size();
  int prev_cnt = 0;
  for (int i = 0; i < n; i++) {
    auto [c, cur_cnt] = blocks[i];
    int cur_len = num_len(cur_cnt) + 1;
    { // minimize

      int new_cnt = cur_cnt - 1;
      if (new_cnt == 0) {
        if (i == 0 || i == n - 1 || blocks[i - 1].first != blocks[i + 1].first) {
          int new_ans = len - 1;
          if (new_ans < ans_min) {
            ans_min = new_ans;
            min_where = prev_cnt + 1;
          }
        } else {
          int new_prevnext_cnt = blocks[i - 1].second + blocks[i + 1].second;
          int prev_len = num_len(blocks[i - 1].second) + 1;
          int next_len = num_len(blocks[i + 1].second) + 1;
          int new_len = num_len(new_prevnext_cnt) + 1;
          int new_ans = len - (prev_len + next_len + 1 - new_len);
          if (new_ans < ans_min) {
            ans_min = new_ans;
            min_where = prev_cnt + 1;
          }
        }
      } else {
        int new_len = num_len(new_cnt) + 1;
        int new_ans = len - (cur_len - new_len);
        if (new_ans < ans_min) {
          ans_min = new_ans;
          min_where = prev_cnt + 1;
        }
      }

    }
    { // maximize
      char prev_char = c;
      if (i > 0)
        prev_char = blocks[i - 1].first;
      char any_new = any_except_two(c, prev_char);
      if (len + 1 > ans_max) {
        ans_max = len + 1;
        max_where = prev_cnt;
        max_what = any_new;
      }
      if (cur_cnt > 1) {
        int left_cnt= cur_cnt / 2;
        int right_cnt = cur_cnt - left_cnt;
        int left_len = num_len(left_cnt) + 1;
        int right_len = num_len(right_cnt) + 1;
        int new_len = len + (left_len + right_len + 1 - cur_len);
        if (new_len > ans_max) {
          ans_max = new_len;
          max_where = prev_cnt + left_cnt;
          max_what = any_except_two(c, c);
        }
      }
      int new_cnt = cur_cnt + 1;
      int new_len = num_len(new_cnt) + 1;
      int new_ans = len + (new_len - cur_len);
      if (new_ans > ans_max) {
        ans_max = new_ans;
        max_where = prev_cnt;
        max_what = c;
      }
    }
    prev_cnt += cur_cnt;
  }
  cout << 2 << ' ' << min_where << endl;
  cout << 1 << ' ' << max_where << ' ' << max_what;
  return 0;
}