#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>

#define int long long int

using namespace std;

vector <int> checkCol(int n, int m)
{
    int s1 = ((2 + (n - 1) * m) * n) / 2;
    int so = (1 + n * m) * (n * m) / 2;
    int s = s1;
    int bestI = 0, best = abs(s - (so - s));
    for (int i = 1; i < m; i++)
    {
        s = (i + 1) * s1 + n * i * (i + 1) / 2;
        if (abs(s - (so - s)) < best)
        {
            best = abs(s - (so - s));
            bestI = i;
        }
    }
    vector <int> A;
    A.push_back(bestI);
    A.push_back(best);
    return(A);
}
vector <int> checkRow(int n, int m)
{
    int s1 = (1 + m) * m / 2;
    int so = (1 + n * m) * (n * m) / 2;
    int s = s1;
    int bestI = 0, best = abs(s - (so - s));
    for (int i = 1; i < n; i++)
    {
        s = (i + 1) * s1 + n * m * i * (i + 1) / 2;
        //cout << i << " " << s << " " << abs(s - (so - s)) << endl;
        if (abs(s - (so - s)) < best)
        {
            best = abs(s - (so - s));
            bestI = i;
        }
    }
    vector <int> A;
    A.push_back(bestI);
    A.push_back(best);
    return(A);
}

int32_t main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        int n, m;
        cin >> n >> m;
        vector <int> col = checkCol(n, m);
        vector <int> row = checkRow(n, m);
        if (col[1] <= row[1])
        {
            cout << "V " << col[0] + 2 << endl;
        }
        else
        {
            cout << "H " << row[0] + 2 << endl;
        }
    }
}
