#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>

/*
3
1 7
3
1 8
6
2 8
1 6

4
1 5
0
1 0
0
1 3
3
1 0
0
*/

using namespace std;

string intToString(int num)
{
    if (num == 0) return("0");
    string res = "";
    while (num > 0)
    {
        char t = (char)(num % 10 + (int)('0'));
        res = "!" + res;
        res[0] = t;
        num = num / 10;
    }
    return(res);
}
struct str
{
    int m;
    int s;
    vector <int> p;
    int ind;
};
int n, d = -1;
string answer = "";
void gen(vector <str> A, string ans, int last)
{
    //cout << ans << endl;
    if (A.size() == 0)
    {
        answer = ans;
        return;
    }
    if (ans.size() == 0)
    {
        for (int i = 0; i < A.size(); i++)
        {
            vector <str> B = A;
            B.erase(B.begin() + i);
            gen(B, ans + " " + intToString(A[i].ind), A[i].s - A[i].p[A[i].p.size() - 1]);
        }
        return;
    }
    for (int i = 0; i < A.size(); i++)
    {
        if (A[i].p[0] + last == d || A[i].p[0] + last == 0)
        {
            vector <str> B = A;
            B.erase(B.begin() + i);
            gen(B, ans + " " + intToString(A[i].ind), A[i].s - A[i].p[A[i].p.size() - 1]);
        }
    }
}

int main()
{
    cin >> n;
    vector <str> A(n);
    for (int i = 0; i < n; i++)
    {
        cin >> A[i].m >> A[i].s;
        A[i].ind = i + 1;
        A[i].p.resize(A[i].m);
        for (int j = 0; j < A[i].m; j++)
        {
            cin >> A[i].p[j];
            if (j > 0)
            {
                if (d != -1 && d != A[i].p[j] - A[i].p[j - 1])
                {
                    cout << "No";
                    return 0;
                }
                d = A[i].p[j] - A[i].p[j - 1];
            }
        }
    }
    gen(A, "", -1);
    if (answer.size() == 0)
    {
        cout << "No";
        return 0;
    }
    cout << "Yes" << endl << answer.substr(1);
}
