#include <bits/stdc++.h>

using namespace std;

#define endl "\n"
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#define int long long
#define double long double

#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

#ifdef LOCAL
#define cin fin
ifstream fin;
#endif

struct block_t {
    int spos;
    int n;
    char ch;

    int len() {
        if (n == 1) {
            return 1;
        } else {
            return (int) to_string(n).length() + 1;
        }
    }
};

struct op_t {
    int t;
    int x;
    char z;
};

ostream &operator<<(ostream &out, op_t op) {
    out << op.t << " " << op.x + 1;
    if (op.t != 2) {
        out << " " << op.z;
    }
    return out;
}

void solve() {
    string s;
    cin >> s;
    vector<block_t> b;
    string num;
    int _pos = 0;
    for (char ch : s) {
        if (ch >= 'A' && ch <= 'Z') {
            block_t blk{};
            if (num.empty()) {
                blk.n = 1;
            } else {
                blk.n = stoi(num);
                num.clear();
            }
            blk.ch = ch;

            blk.spos = _pos;
            _pos += blk.n;

            b.push_back(blk);
        } else {
            num += ch;
        }
    }

    int min_len = IMAX;
    op_t min_op = {.t = -1, .x = -1, .z = 'Z'};
    int max_len = IMIN;
    op_t max_op = {.t = -1, .x = -1, .z = 'Z'};

    for (int i = 0; i < (int) b.size(); i++) {
        {
            // delete one
            int clen = 0;
            if (b[i].n == 1) {
                if (i == 0 || i == (int) b.size() - 1) {
                    clen = (int) s.length() - 1;
                } else {
                    if (b[i - 1].ch == b[i + 1].ch) {
                        clen = (int) s.length() - ((b[i - 1].len() + b[i + 1].len()) -
                                                   block_t{.spos = -1, .n = b[i - 1].n + b[i + 1].n, .ch = b[i -
                                                                                                             1].ch}.len());
                    } else {
                        clen = (int) s.length() - 1;
                    }
                }
            } else {
                clen = (int) s.length() - (b[i].len() - block_t{.spos = -1, .n = b[i].n - 1, .ch = b[i].ch}.len());
            }
            if (min_len > clen) {
                min_len = clen;
                min_op.t = 2;
                min_op.x = b[i].spos;
            }
        }
        {
            int ch;
            ch = 'A';
            if (ch == b[i].ch || (i > 0 && ch == b[i - 1].ch) || (i + 1 < (int) b.size() && ch == b[i + 1].ch)) {
                ch = 'G';
                if (ch == b[i].ch || (i > 0 && ch == b[i - 1].ch) || (i + 1 < (int) b.size() && ch == b[i + 1].ch)) {
                    ch = 'C';
                    if (ch == b[i].ch || (i > 0 && ch == b[i - 1].ch) || (i + 1 < (int) b.size() && ch == b[i + 1].ch)) {
                        ch = 'T';
                    }
                }
            }
            // insert middle
            for (int j = 0; j < b[i].n; j++) {
                int left = j + 1;
                int right = b[i].n - left;
                int clen = (int) s.length() - (b[i].len() - (
                        block_t{.spos = -1, .n = left, .ch = 'A'}.len() +
                        block_t{.spos = -1, .n = right, .ch = 'A'}.len() +
                        1
                ));
                if (max_len < clen) {
                    max_len = clen;
                    max_op.t = 1;
                    max_op.x = b[i].spos + j;
                    max_op.z = ch;
                }
            }
        }
    }

    cout << min_op << endl << max_op << endl;
}

//#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin = ifstream("in.txt");
#endif
    ON_START
#ifdef MULTITEST
    int32_t tests_;
    cin >> tests_;
    for (int32_t asd = 0; asd < tests_; asd++) {
#endif
    solve();
#ifdef MULTITEST
    }
#endif
    ON_START
}
