#include <bits/stdc++.h>

using namespace std;

#define endl "\n"
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#define int long long
#define double long double

#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

#ifdef LOCAL
#define cin fin
ifstream fin;
#endif

void solve() {
    string a, b, c;
    cin >> a >> b >> c;
    int n = (int)a.length();
    int t1 = 0;
    int t2 = 0;
    int t3 = 0;
    int t4 = 0;
    for (int i = 0; i < n; i++) {
        int f, s, t;
        f = a[i] - '0';
        s = b[i] - '0';
        t = c[i] - '0';
        if (f + s == t) {
            t1++;
        } else if (f + s + 1 == t) {
            t2++;
        } else if (f + s - 10 == t) {
            t3++;
        } else if (f + s + 1 - 10 == t) {
            t4++;
        } else {
            cout << 0 << endl;
            return;
        }
    }

    if (t2 != t3 || (t2 == 0 && t4 != 0)) {
        cout << 0 << endl;
        return;
    }

    const int mod = 1000000007;

    int res = 1;
    for (int i = 2; i <= t1; i++) {
        res = (res * i) % mod;
    }
    for (int i = 2; i <= t2; i++) {
        res = (res * i) % mod;
    }
    for (int i = t1 + 1; i <= t1 + t2; i++) {
        res = (res * i) % mod;
    }
    for (int i = t2; i < t2 + t4; i++) {
        res = (res * i) % mod;
    }


    cout << res << endl;
}

//#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin = ifstream("in.txt");
#endif
    ON_START
#ifdef MULTITEST
    int32_t tests_;
    cin >> tests_;
    for (int32_t asd = 0; asd < tests_; asd++) {
#endif
    solve();
#ifdef MULTITEST
    }
#endif
    ON_START
}
