#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;
typedef vector <vector <int>> matrix;

int n, m, c;
void rec(int i, int j, matrix a) {
	if (i == n) {
		for (int i1 = 0; i1 < n; i1++) {
			for (int j1 = 0; j1 < m; j1++) {
				cout << a[i1][j1] << " ";
			}
			cout << "\n";
		}
		exit(0);
	}

	bool w = true;
	for (int i1 = i - 1; i1 >= 0; i1--) {
		for (int j1 = j - 1; j1 >= 0; j1--) {
			if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 1) {
				w = false;
			}
		}
	}

	if (w) {
		rec(i + (j + 1) / m, (j + 1) % m, a);
	}

	w = true;
	for (int i1 = i - 1; i1 >= 0; i1--) {
		for (int j1 = j - 1; j1 >= 0; j1--) {
			if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 2) {
				w = false;
			}
		}
	}
	if (w) {
		a[i][j] = 2;
		rec(i + (j + 1) / m, (j + 1) % m, a);
	}

	if (c == 3) {
		w = true;
		for (int i1 = i - 1; i1 >= 0; i1--) {
			for (int j1 = j - 1; j1 >= 0; j1--) {
				if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 3) {
					w = false;
				}
			}
		}
		if (w) {
			a[i][j] = 3;
			rec(i + (j + 1) / m, (j + 1) % m, a);
		}
	}
}

int main() {
	cin >> n >> m >> c;
	matrix a(n, vector <int>(m, 1));
	//vector <vector <int>> b1(n), b2(m);
	rec(0, 0, a);
}