#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;
typedef short int sl;
typedef vector <vector <sl>> matrix;

sl n, m, c;
void rec(sl i, sl j, matrix a) {
	sl ix = i + (j + 1) / m, jx = (j + 1) % m;

	if (i == n) {
		for (sl i1 = 0; i1 < n; i1++) {
			for (sl j1 = 0; j1 < m; j1++) {
				cout << a[i1][j1] << " ";
			}
			cout << "\n";
		}
		exit(0);
	}

	bool w = true;
	for (sl i1 = i - 1; i1 >= 0; i1--) {
		for (sl j1 = j - 1; j1 >= 0; j1--) {
			if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 1) {
				w = false;
				i1 = 0;
				j1 = 0;
			}
		}
	}

	if (w && !(j >= 2 && a[i][j - 1] == 1 && a[i][j - 2] == 1)) {
		a[i][j] = 1;
		rec(ix, jx, a);
	}

	w = true;
	for (sl i1 = i - 1; i1 >= 0; i1--) {
		for (sl j1 = j - 1; j1 >= 0; j1--) {
			if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 2) {
				w = false;
				i1 = 0;
				j1 = 0;
			}
		}
	}
	if (w && !(j >= 2 && a[i][j - 1] == 2 && a[i][j - 2] == 2)) {
		a[i][j] = 2;
		rec(ix, jx, a);
	}

	if (c == 3) {
		w = true;
		for (sl i1 = i - 1; i1 >= 0; i1--) {
			for (sl j1 = j - 1; j1 >= 0; j1--) {
				if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 3) {
					w = false;
					i1 = 0;
					j1 = 0;
				}
			}
		}
		if (w && !(j >= 2 && a[i][j - 1] == 3 && a[i][j - 2] == 3)) {
			a[i][j] = 3;
			rec(ix, jx, a);
		}
	}
}

int main() {
	cin >> n >> m >> c;
	matrix a(n, vector <sl>(m, 1));
	//vector <vector <sl>> b1(n), b2(m);
	rec(0, 0, a);
}