#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;
typedef short int sl;
typedef vector <vector <sl>> matrix;

struct T {
	sl c1, c2, c3;
};

sl n, m, c;
void rec(sl i, sl j, matrix a, vector <T> s1, vector <T> s2) {
	sl ix = i + (j + 1) / m, jx = (j + 1) % m;

	if (i == n) {
		for (sl i1 = 0; i1 < n; i1++) {
			for (sl j1 = 0; j1 < m; j1++) {
				cout << a[i1][j1] << " ";
			}
			cout << "\n";
		}
		exit(0);
	}

	bool w = true;
	for (sl i1 = i - 1; i1 >= 0; i1--) {
		for (sl j1 = j - 1; j1 >= 0; j1--) {
			if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 1) {
				w = false;
				i1 = 0;
				j1 = 0;
			}
		}
	}

	if (w && s1[i].c1 < 4 && s2[j].c1 < 4) {
		a[i][j] = 1;
		s1[i].c1++;
		s2[j].c1++;
		rec(ix, jx, a, s1, s2);
		s1[i].c1--;
		s2[j].c1--;
	}

	w = true;
	for (sl i1 = i - 1; i1 >= 0; i1--) {
		for (sl j1 = j - 1; j1 >= 0; j1--) {
			if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 2) {
				w = false;
				i1 = 0;
				j1 = 0;
			}
		}
	}
	if (w && s1[i].c2 < 4 && s2[j].c2 < 4) {
		a[i][j] = 2;
		s1[i].c2++;
		s2[j].c2++;
		rec(ix, jx, a, s1, s2);
		s1[i].c2--;
		s2[j].c2--;
	}

	if (c == 3) {
		w = true;
		for (sl i1 = i - 1; i1 >= 0; i1--) {
			for (sl j1 = j - 1; j1 >= 0; j1--) {
				if (a[i1][j1] == a[i1][j] && a[i1][j1] == a[i][j1] && a[i1][j1] == 3) {
					w = false;
					i1 = 0;
					j1 = 0;
				}
			}
		}
		if (w && s1[i].c3 < 4 && s2[j].c3 < 4) {
			a[i][j] = 3;
			s1[i].c3++;
			s2[j].c3++;
			rec(ix, jx, a, s1, s2);
			s1[i].c3--;
			s2[j].c3--;
		}
	}
}

int main() {
	cin >> n >> m >> c;
	matrix a(n, vector <sl>(m, 1));
	vector <T> s1(n), s2(m);
	rec(0, 0, a, s1, s2);
}