#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define mp make_pair
#define endl '\n'
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef double db;
typedef long double ldb;

ll f_h(ll n, ll m, ll k) {
    ll x = m * k;
    ll sum1 = x * (x + 1) / 2;
    x = n * m;
    ll sum2 = x * (x + 1) / 2 - sum1;
    return abs(sum2 - sum1);
}

pll tern_search_h(ll n, ll m) {
    ll l = -1, r = n, m1, m2;
    while (r - l > 5) {
        m1 = l + (r - l) / 3;
        m2 = l + 2 * (r - l) / 3;
        if (f_h(n, m, m1) < f_h(n, m, m2)) {
            r = m2;
        } else {
            l = m1;
        }
    }
    ll res = INT64_MAX;
    ll resi = -1;
    for (int i = l; i <= r; i++) {
        if (f_h(n, m, i) < res) {
            res = f_h(n, m, i);
            resi = i;
        }
    }
    return {res, resi};
}

ll f_v(ll n, ll m, ll k) {
    ll sum1 = m * (n - 1) * n / 2 * k + k * (k + 1) / 2 * n;
    ll x = n * m;
    ll sum2 = x * (x + 1) / 2 - sum1;
    return abs(sum2 - sum1);
}

pll tern_search_v(ll n, ll m) {
    ll l = -1, r = m, m1, m2;
    while (r - l > 5) {
        m1 = l + (r - l) / 3;
        m2 = l + 2 * (r - l) / 3;
        if (f_v(n, m, m1) < f_v(n, m, m2)) {
            r = m2;
        } else {
            l = m1;
        }
    }
    ll res = INT64_MAX;
    ll resi = -1;
    for (int i = l; i <= r; i++) {
        if (f_v(n, m, i) < res) {
            res = f_v(n, m, i);
            resi = i;
        }
    }
    return {res, resi};
}

signed main() {
    fastream;
    int t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        pll res1 = tern_search_h(n, m);
        pll res2 = tern_search_v(n, m);
        if (res1.first < res2.first) {
            cout << "H " << res1.second + 1 << endl;
        } else {
            cout << "V " << res2.second + 1 << endl;
        }
    }
}
