def vertical(x):
    v_1 = n * (x - 1) * (x + (n - 1) * m) // 2
    v_2 = n * (m - x + 1) * ((x + m) + (n - 1) * m) // 2
    return v_1, v_2


def horizontal(x):
    h_1 = m * (x - 1) * (m + 1 + m * (x - 2)) // 2
    h_2 = m * (n - x + 1) * (m + 1 + m * (x + n - 2)) // 2
    return h_1, h_2


t = int(input())
for i in range(t):
    n, m = map(int, input().split())
    l, r = 0, m + 1
    while l < r - 1:
        mid = (l + r) // 2
        L, R = vertical(mid)
        if L < R:
            l = mid
        else:
            r = mid
    l_1, l_2 = vertical(l)
    r_1, r_2 = vertical(r)
    if r_1 - r_2 < l_2 - l_1:
        V_best = r
        k = r_1 - r_2
    else:
        V_best = l
        k = l_2 - l_1
    l, r = 0, n + 1
    while l < r - 1:
        mid = (l + r) // 2
        L, R = horizontal(mid)
        if L < R:
            l = mid
        else:
            r = mid
    l_1, l_2 = horizontal(l)
    r_1, r_2 = horizontal(r)
    if r_1 - r_2 < l_2 - l_1:
        H_best = r
        w = r_1 - r_2
    else:
        H_best = l
        w = l_2 - l_1
    if w < k:
        print("H", H_best)
    else:
        print("V", V_best)
