// Shrek is love, shrek is life
#include <iostream>
//#include <vector>
//#include <algorithm>
//#include <functional>
//#include <cmath>
//#include <set>
//#include <iomanip>

#define int long long
#define all(x) x.begin() x.end()

using namespace std;

int readInt(){
    int r;
    cin >> r;
    return r;
}

// =========================================
// ============= Horizontal split ==========
// =========================================

int horizontal_split_func(int n, int m, int i){
    int sum_all = (m * n * (m * n + 1)) / 2;
    int d = i - 1;
    int double_left = m * d * (m * d + 1);
    int res = double_left - sum_all;
    return res;
}

int horizontal_split_sub_task(int n, int m, int i){
    return abs(horizontal_split_func(n, m, i));
}

int horizontal_split(int n, int m){
    auto is_left = [&](int i) -> bool{
        if (i == 0){
            return true;
        }
        if (i == n + 1){
            return false;
        }
        return horizontal_split_func(n, m, i) <= 0;
    };

    int bs_left = 0;
    int bs_right = n + 1;
    while (bs_left + 1 < bs_right){
        int mid = (bs_left + bs_right) / 2;
//        (is_left(mid) ? bs_left : bs_right) = mid;
        if (is_left(mid)){
            bs_left = mid;
        } else {
            bs_right = mid;
        }
    }

    int min_res = 3000000000000000000;
    int res_i = -1;

    for (int i = bs_left - 1; i <= bs_right + 1; i++){
        if ((1 <= i) && (i <= n)){
            int res = horizontal_split_sub_task(n, m, i);
            if (res < min_res){
                min_res = res;
                res_i = i;
            }
        }
    }

    return res_i;
}

// =========================================
// ============= Vertical split ============
// =========================================

int vertical_split_func(int n, int m, int i){
    int sum_all = (m * n * (m * n + 1)) / 2;
    int d = i - 1;
    int double_left = (m * d * n * (n - 1)) + (n * d * (d + 1));
    int res = double_left - sum_all;
    return res;
}

int vertical_split_sub_task(int n, int m, int i){
    return abs(vertical_split_func(n, m, i));
}

int vertical_split(int n, int m){
    auto is_left = [&](int i) -> bool{
        if (i == 0){
            return true;
        }
        if (i == m + 1){
            return false;
        }
        return vertical_split_func(n, m, i) <= 0;
    };

    int bs_left = 0;
    int bs_right = m + 1;

    while (bs_left + 1 < bs_right){
        int mid = (bs_left + bs_right) / 2;
//        (is_left(mid) ? bs_left : bs_right) = mid;
        if (is_left(mid)){
            bs_left = mid;
        } else {
            bs_right = mid;
        }
    }

    int min_res = 3000000000000000000;
    int res_i = -1;

    for (int i = bs_left - 1; i <= bs_right + 1; i++){
        if ((1 <= i) && (i <= m)){
            int res = vertical_split_sub_task(n, m, i);
            if (res < min_res){
                min_res = res;
                res_i = i;
            }
        }
    }

    return res_i;
}

signed main(){
    int t = readInt();
    for (int q = 0; q < t; q++){
        int n = readInt();
        int m = readInt();

        int hor_res = horizontal_split(n, m);
        int vert_res = vertical_split(n, m);
        if (horizontal_split_sub_task(n, m, hor_res) < vertical_split_sub_task(n, m, vert_res)){
            cout << "H " << hor_res << "\n";
        } else {
            cout << "V " << vert_res << "\n";
        }
    }
    return 0;
}
