// Mingw ovno ne mogu skompilit
#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>

using namespace std;

int readInt(){
    int res;
    cin >> res;
    return res;
}

struct Segment{
    int length;
    vector<int> perekladini;

    Segment(int _l, vector<int> _p){
        length = _l;
        perekladini = _p;
    }

    Segment()=default;
};

int main(){
    int n = readInt();
    vector<Segment> segments;
    for (int i = 0; i < n; i++){
        int mi = readInt();
        int si = readInt();
        vector<int> pi(mi);
        for (int j = 0; j < mi; j++){
            int pij = readInt();
            pi[j] = pij;
        }
        sort(pi.begin(), pi.end());
        segments.emplace_back(si, pi);
    }

    bool is_possible = false;
    vector<int> result = {};

    function<void(vector<int>)> comb = [&](vector<int> arr) -> void {
        if (arr.size() == n){
            int our_distance = -1;
            int prev_stick_pos = -1;
            int prev_segments_len = 0;

            bool have_problems = false;

            for (int i: arr){
                for (int stick: segments[i].perekladini){
                    int cur_stick_pos = prev_segments_len + stick;
                    if (prev_stick_pos != -1){
                        int cur_distance = cur_stick_pos = prev_stick_pos;
                        if (our_distance == -1){
                            our_distance = cur_distance;
                        } else if (our_distance != cur_distance){
                            have_problems = true;
                        }
                    }
                    prev_stick_pos = cur_stick_pos;
                }
                prev_segments_len += segments[i].length;
            }

            if (!have_problems){
                is_possible = true;
                result = arr;
            }

        } else {
            for (int i = 0; i < n; i++){
                bool have_same = false;
                for (int el: arr){
                    if (el == i){
                        have_same = true;
                        break;
                    }
                }
                if (!have_same){
                    vector<int> new_arr = arr;
                    new_arr.push_back(i);
                    comb(new_arr);
                }
            }
        }
    };

    comb({});

    if (is_possible){
        cout << "Yes\n";
        for (int el: result){
            cout << el + 1 << " ";
        }
        cout << "\n";
    } else {
        cout << "No\n";
    }

    return 0;
}