#include <iostream>
#include <vector>
#include <string>
#include <functional>

#define int long long
#define MOD 1000000009

using namespace std;

string readStr(){
    string res;
    cin >> res;
    return res;
}

struct Column{
    char a, b, c;

    Column(char _a, char _b, char _c){
        a = _a;
        b = _b;
        c = _c;
    }

    Column()=default;
};

signed main(){
    string A_str = readStr();
    string B_str = readStr();
    string C_str = readStr();
    int n = A_str.size();
    vector<Column> columns;
    for (int i = 0; i < n; i++){
        columns.emplace_back(A_str[i], B_str[i], C_str[i]);
    }
    int good_combs = 0;
    function<void(const vector<int>&, const vector<bool>&)> comb = [&](const vector<int>& arr, const vector<bool>& have) -> void{
        if (arr.size() == n){
            string comb_A_str;
            string comb_B_str;
            string comb_C_str;
            for (int i = 0; i < n; i++){
                comb_A_str += columns[arr[i]].a;
                comb_B_str += columns[arr[i]].b;
                comb_C_str += columns[arr[i]].c;
            }
            if ((comb_A_str[0] == '0') || (comb_B_str[0] == '0') || (comb_C_str[0] == '0')){
                return;
            }
//            cout << "====" << "\n";
//            cout << comb_A_str << "\n";
//            cout << comb_B_str << "\n";
//            cout << comb_C_str << "\n";
            int a = stoll(comb_A_str);
            int b = stoll(comb_B_str);
            int c = stoll(comb_C_str);
            if (a + b == c){
                good_combs++;
                good_combs %= MOD;
            }
        } else {
            for (int i = 0; i < n; i++){
                if (!have[i]){
                    vector<int> new_arr = arr;
                    new_arr.push_back(i);
                    vector<bool> new_have = have;
                    new_have[i] = true;
                    comb(new_arr, new_have);
                }
            }
        }
    };
    comb({}, vector<bool>(n, false));
    cout << good_combs << "\n";
    return 0;
}
