#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5 + 10;
const int MAXC = MAXN * 4 + 10;

struct Segm {
  vector<int> mrr;
  int s;
};

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  vector<Segm> arr(n);
  for (int i = 0; i < n; ++i) {
    int m, s;
    cin >> m >> s;
    arr[i].mrr.resize(m);
    arr[i].s = s;
    for (int &el : arr[i].mrr)
      cin >> el;
  }
  vector<int> inds(n);
  iota(inds.begin(), inds.end(), 0);
  do {
    int sm = 0;
    int len = -1;
    int last = -1;
    bool ok = true;
    for (int i : inds) {
      auto &seg = arr[i];
      for (int el : arr[i].mrr) {
        int x = sm + el;
        if (last == -1) {
          last = x;
          continue;
        }
        int ln = x - last;
        last = x;
        if (len == -1) {
          len = ln;
          continue;
        }
        ok &= len == ln;
      }
      sm += seg.s;
    }
    if (ok) {
      cout << "Yes\n";
      for (int i : inds)
        cout << i + 1 << ' ';
      return 0;
    }
  } while (next_permutation(inds.begin(), inds.end()));
  cout << "No";
}
