#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

int mul(int a, int b) {
  return a * b % MOD;
}

int factorial(int x) {
  int f = 1;
  for (int i = 2; i <= x; ++i)
    f = mul(f, i);
  return f;
}

int binpow(int x, int p) {
  if (p == 0)
    return 1;
  if (p % 2 == 0)
    return binpow(x * x % MOD, p / 2);
  else
    return x * binpow(x, p - 1) % MOD;
}

int divi(int a, int b) {
  return a * binpow(b, MOD - 2) % MOD;
}

int C(int n, int k) {
  if (n == 0 && k == 0)
    return 1;
  if (n == 0)
    return 0;
  return divi(divi(factorial(n), factorial(n - k)), factorial(k));
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  string sa, sb, sc;
  cin >> sa >> sb >> sc;
  int n = sa.size();
  int cnt_o = 0, cnt_i = 0, cnt_ = 0, cnt_io = 0;
  int cnte_ = 0, cnte_i;
  for (int i = 0; i < n; ++i) {
    int a = sa[i] - '0', b = sb[i] - '0', c = sc[i] - '0';
    int x = a + b;
    if (x % 10 == c) {
      if (x >= 10) cnt_o++;
      else cnt_++;
      cnte_ += a != 0 && b != 0 && x < 10;
      continue;
    }
    int y = a + b + 1;
    if (y % 10 == c) {
      if (y >= 10) cnt_io++;
      else cnt_i++;
      cnte_i += a != 0 && b != 0 && y < 10;
      continue;
    }
    cout << 0;
    return 0;
  }
  if (cnt_i != cnt_o) {
    cout << 0;
    return 0;
  }
  if (cnt_i == 0 && cnt_io != 0) {
    cout << 0;
    return 0;
  }
  int spos_ = C(cnt_i + cnt_ - 1, cnt_ - 1) * cnte_ % MOD * factorial(cnt_ - 1) % MOD * factorial(cnt_i) % MOD * factorial(cnt_o) % MOD;
  int spos_i = C(cnt_i + cnt_ - 1, cnt_i - 1) * cnte_i % MOD * factorial(cnt_) % MOD * factorial(cnt_i - 1) % MOD * factorial(cnt_o) % MOD;
  int ans = (spos_ + spos_i) % MOD;
  ans = mul(ans, C(cnt_io + cnt_i - 1, cnt_i - 1));
  ans = mul(ans, factorial(cnt_io));
  cout << ans;
  return 0;
}
