#include <iostream>
#include <vector>
#include <queue>
#include <stack>
#include <algorithm>
#include <sstream>
#include <math.h>
#include <cmath>
#include <set>

using namespace std;
#define LL long long

bool isGood(string number) {
	for (int i = 1; i < number.length(); i++)
	{
		if (number[i] != number[i - 1]) {
			return false;
		}
	}
	return true;
}

bool isNearlyGood(string number) {
	set<char> symbols;
	for (int i = 0; i < number.length(); i++)
	{
		symbols.insert(number[i]);
	}

	return symbols.size() < 3;
}

bool stringGreater(string source, string compareTo) {
	if (source.length() > compareTo.length()) {
		return true;
	}
	else if (source.length() > compareTo.length()) {
		return false;
	}

	for (int i = 0; i < source.length(); i++)
	{
		if (source[i] > compareTo[i]) {
			return true;
		}
		else if (compareTo[i] > source[i]) {
			return false;
		}
	}

	return false;
}

string genGood(char base, int length) {
	string res = "";
	for (int i = 0; i < length; i++)
	{
		res += base;
	}
	return res;
}

int main()
{
	string x;
	bool k;
	cin >> x;
	cin >> k;

	if (!k) {
		string guess = genGood(x[0], x.length());
		if (stringGreater(x, guess)) {
			guess = genGood(x[0] + 1, x.length());
		}
		cout << guess;
	}
	else
	{
		if (isNearlyGood(x)) {
			cout << x;
			return 0;
		}
		char second = x[1];
		if (x[1] < x[2]) {
			second = x[1] + 1;
		}
		string answer = "" + x[0];
		for (int i = 0; i < x.length() - 1; i++)
		{
			answer += second;
		}

		cout << answer;
	}

}

