#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
#define int long long

int sum(int n) {
	return (n * (n + 1)) / 2;
}

int f1(int pos, int n, int m) { // vertikal
	int first = (sum(n - 1) * (pos - 1)) * m + sum(pos - 1) * n;
	int second = sum(n * m) - first;
	return abs(first - second);
}

int f2(int pos, int n, int m) { // horizontal
	int first = sum(m * (pos - 1));
	int second = sum(n * m) - first;
	return abs(first - second);
}

int choice(int s1, int s2, int s3) {
	if (s1 > s2) {
		if (s2 > s3) {
			return 3;
		}
		else {
			return 2;
		}
	}
	else {
		if (s1 > s3) {
			return 3;
		}
		else {
			return 1;
		}
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	int l = 1, r = m + 1; // vertikal
	while (r - l > 2) {
		int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
		if (f1(m1, n, m) > f1(m2, n, m)) {
			l = m1;
		}
		else {
			r = m2;
		}
	}
	int s1 = f1(l, n, m), s2 = f1(l + 1, n, m), s3 = f1(r, n, m);
	vector<int> t = { l, l + 1, r };
	int v_ans = t[choice(s1, s2, s3) - 1];
	l = 1, r = n + 1; // horizontal
	while (r - l > 2) {
		int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
		if (f2(m1, n, m) > f2(m2, n, m)) {
			l = m1;
		}
		else {
			r = m2;
		}
	}
	s1 = f2(l, n, m), s2 = f2(l + 1, n, m), s3 = f2(r, n, m);
	t = { l, l + 1, r };
	int h_ans = t[choice(s1, s2, s3) - 1];
	if (f1(v_ans, n, m) > f2(h_ans, n, m)) {
		cout << "H " << h_ans << '\n';
	}
	else {
		cout << "V " << v_ans << '\n';
	}
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}