#include <iostream>
#include <vector>
#include <cassert>
#include <string>
#include <math.h>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define ft first
#define sd second
#define ld long double

#define int long long

void solve() {
	int n, m;
	cin >> n >> m;
	int ans = 4e18;
	int ans_ind = -1;
	char type = 'H'; //horizontal
	int l = 1, r = n - 1;
	while (r - l > 1) {
		int M = (l + r) / 2;
		if (m * n * (m * n + 1) / 2 - m * M * (m * M + 1) > 0)
			l = M;
		else
			r = M;
	}
	for (int i = max(1ll, l - 1); i < min(n, l + 3); i++) {
		int curans = m * n * (m * n + 1) / 2 - m * i * (m * i + 1);
		curans = abs(curans);
		if (curans < ans) {
			ans = curans;
			ans_ind = i + 1;
		}
	}
	l = 1, r = m - 1;
	while (r - l > 1) {
		int M = (l + r) / 2;
		if ((m - 2 * M) * m * n * (n - 1) / 2 + n * (m * (m + 1) / 2 - M * (M + 1)) > 0)
			l = M;
		else
			r = M;
	}
	for (int j = max(1ll, l - 1); j < min(m, l + 3); j++) {
		int curans = (m - 2 * j) * m * n * (n - 1) / 2 + n * (m * (m + 1) / 2 - j * (j + 1));
		curans = abs(curans);
		if (curans < ans || (curans == ans && j + 1 < ans_ind)) {
			ans = curans;
			ans_ind = j + 1;
			type = 'V';
		}
	}
	cout << type << ' ' << ans_ind << '\n';
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int t = 1;
	cin >> t;
	while (t--)
		solve();
}