#include <iostream>
#include <vector>
#include <cassert>
#include <string>
#include <math.h>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second
#define ld long double

void solve() {
	int n;
	cin >> n;
	vector<pii> antenas;
	bool fixed = false;
	int val = -1;
	bool broken = false;
	for (int i = 0; i < n; i++) {
		int m, len;
		cin >> m >> len;
		if (m == 1) {
			int k;
			cin >> k;
			antenas.pb(mp(k, len - k));
		}
		else {
			vector<int> ks(m);
			for (int j = 0; j < m; j++) 
				cin >> ks[j];
			for (int j = 1; j < m; j++) {
				if (!fixed) {
					fixed = true;
					val = ks[j] - ks[j - 1];
				}
				else if (ks[j] - ks[j - 1] != val)
					broken = true;
			}
			antenas.pb(mp(ks[0], len - ks[m - 1]));
		}
	}
	if (broken) {
		cout << "No";
		return;
	}
	if (n == 1) {
		cout << "Yes\n1";
		return;
	}
	vector<int> perm(n);
	for (int i = 0; i < n; i++)
		perm[i] = i;
	for (int i = 0; i < 8 * 7 * 6 * 5 * 4 * 3 * 2; i++) {
		bool good = true;
		int val1;
		if (fixed)
			val1 = val;
		else
			val1 = antenas[perm[1]].ft + antenas[perm[0]].sd;
		for (int j = 1; j < n; j++)
			if (antenas[perm[j]].ft + antenas[perm[j - 1]].sd != val1) {
				good = false;
				break;
			}
		if (good) {
			cout << "Yes\n";
			for (int i = 0; i < n; i++)
				cout << perm[i] + 1 << ' ';
			return;
		}
		next_permutation(perm.begin(), perm.end());
	}
	cout << "No\n";
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--)
		solve();
}