#include <iostream>
#include <vector>
#include <cassert>
#include <string>
#include <math.h>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second
#define ld long double

void solve(ll n, int k) {
	if (k) {
		vector<int> digits;
		while (n > 0) {
			digits.pb(n % 10);
			n /= 10;
		}
		reverse(digits.begin(), digits.end());
		int i = 1;
		while (i < digits.size() && digits[i] == digits[0])
			i++;
		if (i == digits.size() || i == digits.size() - 1) {
			for (int d : digits)
				cout << d;
			return;
		}
		if (i == 1) {
			vector<ll> candidates;
			bool good_a = true;
			for (int i = 2; i < digits.size(); i++)
				if (digits[i] < digits[0])
					break;
				else if (digits[i] > digits[0]) {
					good_a = false;
					break;
				}
			if (good_a) {
				ll cur = digits[0] * 10 + digits[1];
				for (int i = 2; i < digits.size(); i++) {
					cur = cur * 10 + digits[0];
				}
				candidates.push_back(cur);
			}
			bool good_b = true;
			for (int i = 2; i < digits.size(); i++)
				if (digits[i] < digits[1])
					break;
				else if (digits[i] > digits[1]) {
					good_b = false;
					break;
				}
			if (good_b) {
				ll cur = digits[0] * 10 + digits[1];
				for (int i = 2; i < digits.size(); i++) {
					cur = cur * 10 + digits[1];
				}
				candidates.push_back(cur);
			}
			if (digits[1] < 9) {
				ll cur = digits[0] * 10 + digits[1] + 1;
				for (int i = 2; i < digits.size(); i++)
					cur = cur * 10 + digits[0];
				if (digits[1] + 1 == digits[0])
					cur -= cur % 10;
				candidates.push_back(cur);
			}
			sort(candidates.begin(), candidates.end());
			cout << candidates[0];
			return;
		}
		vector<ll> candidates;
		bool good_a = true;
		for (int j = i + 1; j < digits.size(); j++)
			if (digits[j] < digits[0])
				break;
			else if (digits[j] > digits[0]) {
				good_a = false;
				break;
			}
		if (good_a) {
			ll cur = 0;
			for (int j = 0; j < i; j++)
				cur = cur * 10 + digits[0];
			cur = cur * 10 + digits[1];
			for (int j = i + 1; j < digits.size(); j++)
				cur = cur * 10 + digits[0];
			candidates.push_back(cur);
		}
		if (digits[i] < 9) {
			ll cur = 0;
			for (int j = 0; j < i; j++)
				cur = cur * 10 + digits[0];
			cur = cur * 10 + digits[1] + 1;
			for (int j = i + 1; j < digits.size(); j++)
				cur = cur * 10 + digits[0];
			if (digits[1] + 1 == digits[0])
				cur -= cur % 10;
			candidates.push_back(cur);
		}
		if (digits[0] < 9) {
			ll cur = 0;
			for (int j = 0; j < i - 1; j++)
				cur = cur * 10 + digits[0];
			cur = cur * 10 + digits[0] + 1;
			for (int j = i; j < digits.size(); j++)
				cur = cur * 10 + digits[0];
			candidates.push_back(cur);
		}
		sort(candidates.begin(), candidates.end());
		cout << candidates[0];
		return;
	}
	else {
		vector<int> digits;
		while (n > 0) {
			digits.pb(n % 10);
			n /= 10;
		}
		reverse(digits.begin(), digits.end());
		bool good = true;
		for (int i = 1; i < digits.size(); i++)
			if (digits[i] < digits[0])
				break;
			else if (digits[i] > digits[0]) {
				good = false;
				break;
			}
		if (good)
			for (int i = 0; i < digits.size(); i++)
				cout << digits[0];
		else if (digits[0] < 9)
			for (int i = 0; i < digits.size(); i++)
				cout << digits[0] + 1;
		else for (int i = 0; i < digits.size() + 1; i++)
			cout << 1;
	}
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	/*while (t--) {
		ll n; int k;
		cin >> n >> k;
		solve(n, k);
	}*/
	for (int i = 1; i < 1000; i++) {
		cout << i << ' ';
		solve(i, 1);
		cout << '\n';
	}
}
/*
7
1 3
2
1 8
6
1 8
5
1 8
4
1 8
3
1 8
2
2 12
1 8
*/
/*
13
1 8 0
1 6 1
1 8 4
1 13 5
1 8 1
1 6 2
1 8 5
1 13 6
1 8 2
1 6 3
1 8 6
1 13 7
2 13 3 12
*/