#include<iostream>
#include<vector>
#include<algorithm>
#include<cassert>

using namespace std;

constexpr int MOD = 1000 * 1000 * 1000 + 7;

int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	string buff;
	cin >> buff;
	int n = (int)buff.size();
	vector<int> a(n), b(n), c(n);
	for (int i = 0; i < n; ++i) {
		a[i] = buff[i] - '0';
	}
	cin >> buff;
	for (int i = 0; i < n; ++i) {
		b[i] = buff[i] - '0';
	}
	cin >> buff;
	for (int i = 0; i < n; ++i) {
		c[i] = buff[i] - '0';
	}

	int cnt0 = 0;
	int cnt1 = 0;
	int cnt2 = 0;
	for (int i = 0; i < n; ++i) {
		if (!((a[i] + b[i]) % 10 == c[i] || (a[i] + b[i]) % 10 + 1 == c[i])) {
			cout << 0 << endl;
			return 0;
		}
		bool d1 = ((a[i] + b[i]) % 10 + 1) == c[i];
		bool d2 = (a[i] + b[i]) >= 10;
		if (!d1 && !d2) {
			++cnt0;
		}
		else if (d1 && !d2) {
			++cnt1;
		}
		else if (!d1 && d2) {
			++cnt2;
		}
	}
	int cnt3 = n - cnt0 - cnt1 - cnt2;
	vector<vector<vector<vector<pair<int, int>>>>> dp(1 + cnt0, vector<vector<vector<pair<int, int>>>>(1 + cnt1, vector<vector<pair<int, int>>>(1 + cnt2, vector<pair<int, int>>(1 + cnt3, {0, 0}))));
	dp[cnt0][cnt1][cnt2][cnt3].first = 1;
	for (int i0 = cnt0; i0 >= 0; --i0) {
		for (int i1 = cnt1; i1 >= 0; --i1) {
			for (int i2 = cnt2; i2 >= 0; --i2) {
				for (int i3 = cnt3; i3 >= 0; --i3) {
					if (i0 == cnt0 && i1 == cnt1 && i2 == cnt2 && i3 == cnt3) {
						continue;
					}
					
					if (i0 + 1 <= cnt0) {
						dp[i0][i1][i2][i3].first = (dp[i0][i1][i2][i3].first + 1LL * (i0+1) * dp[i0 + 1][i1][i2][i3].first % MOD) % MOD;
					}
					if (i2 + 1 <= cnt2) {
						dp[i0][i1][i2][i3].first = (dp[i0][i1][i2][i3].first + 1LL * (i2 + 1) * dp[i0][i1][i2 + 1][i3].second % MOD) % MOD;
					}

					if (i1 + 1 <= cnt1) {
						dp[i0][i1][i2][i3].second = (dp[i0][i1][i2][i3].first + 1LL * (i1 + 1) * dp[i0][i1 + 1][i2][i3].first % MOD) % MOD;
					}
					if (i3 + 1 <= cnt3) {
						dp[i0][i1][i2][i3].second = (dp[i0][i1][i2][i3].first + 1LL * (i3 + 1) * dp[i0][i1][i2][i3 + 1].second % MOD) % MOD;
					}
				}
			}
		}
	}
	cout << dp[0][0][0][0].first << endl;
	return 0;
}

