#include "bits/stdc++.h"

#define nl '\n'
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) ((int)(x).size())
#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

using namespace std;

const int inf = 1e9;
const ll inf2 = 1e18;

const int maxn = 200005;

// H
__int128 f1(__int128 n, __int128 m, __int128 x) {
	__int128 s2 = (1 + x*m) * x * m / 2;
	__int128 os = n * m * (n * m + 1) / 2;
	return max(os - s2, s2);
}

// V
__int128 f2(__int128 n, __int128 m, __int128 x) {
	__int128 s1 = x * (x + 1) / 2;
	__int128 s2 = (s1 + s1 + (n - 1) * m * x) * n / 2;
	__int128 os = n * m * (n * m + 1) / 2;
	return max(s2, os - s2);
}

__int128 tans;
ll ans = 0;
ll rs = 0;

// Horizontal cut
void solve1(__int128 n, __int128 m) {
	__int128 lb = 1, ub = n - 1;
	
	while (lb <= ub) {
		__int128 m1 = lb + (ub - lb) / 3, m2 = ub - (ub - lb) / 3;
		__int128 r1 = f1(n, m, m1);
		__int128 r2 = f1(n, m, m2);
		if (r1 <= r2) {
			if (r1 < tans) {
				tans = r1;
				ans = m1 + 1;
				rs = 0;
			}
			ub = m2 - 1;
		} else {
			if (r2 < tans) {
				tans = r2;
				ans = m2 + 1;
				rs = 0;
			}
			lb = m1 + 1;
		}
	}
}


// Vertical Cut
void solve2(__int128 n, __int128 m) {
	__int128 lb = 1, ub = m - 1;

	while (lb <= ub) {
		__int128 m1 = lb + (ub - lb) / 3, m2 = ub - (ub - lb) / 3;
		__int128 r1 = f2(n, m, m1);
		__int128 r2 = f2(n, m, m2);
		if (r1 <= r2) {
			if (r1 < tans) {
				tans = r1;
				ans = m1 + 1;
				rs = 1;
			}
			ub = m2 - 1;
		} else {
			if (r2 < tans) {
				tans = r2;
				ans = m2 + 1;
				rs = 1;
			}
			lb = m1 + 1;
		}
	}
}

void solve() {
	ans = 0;
	tans = 1e40;
	ll n, m;
	cin >> n >> m;

	if (m > 1) solve2(n, m);
	if (n > 1) solve1(n, m);


	if (rs == 0) cout << "H ";
	else cout << "V ";
	cout << ans << nl;
}

int main() {
	FAST;

	int t;
	cin >> t;
	while (t--) solve();
}