#include "bits/stdc++.h"

#define nl '\n'
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) ((int)(x).size())
#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

using namespace std;

const int inf = 1e9;
const ll inf2 = 1e18;

const int maxn = 200005;
const ll mod = 1e9+7;

int cnt[8], n;

ll ans = 0;

void solve(int carry, int i) {
	if (i == n) {
		ans++;
		if (ans == mod) ans = 0;
		return;
	}
	if (i == n - 1) {
		if (carry == 0) {
			if (cnt[0]) {
				cnt[0]--;
				solve(0, i + 1);
				cnt[0]++;
			}
			if (cnt[1]) {
				cnt[1]--;
				solve(1, i + 1);
				cnt[1]++;
			}
		} else {
			if (cnt[2]) {
				cnt[2]--;
				solve(0, i + 1);
				cnt[2]++;
			}
			if (cnt[3]) {
				cnt[3]--;
				solve(1, i + 1);
				cnt[3]++;
			}
		}
		return;
	}
	if (carry == 0) {
		if (cnt[0]) {
			cnt[0]--;
			solve(0, i + 1);
			cnt[0]++;
		}
		if (cnt[1]) {
			cnt[1]--;
			solve(1, i + 1);
			cnt[1]++;
		}
		if (cnt[4]) {
			cnt[4]--;
			solve(0, i + 1);
			cnt[4]++;
		}
		if (cnt[5]) {
			cnt[5]--;
			solve(1, i + 1);
			cnt[5]++;
		}
	} else {
		if (cnt[2]) {
			cnt[2]--;
			solve(0, i + 1);
			cnt[2]++;
		}
		if (cnt[3]) {
			cnt[3]--;
			solve(1, i + 1);
			cnt[3]++;
		}
		if (cnt[6]) {
			cnt[6]--;
			solve(0, i + 1);
			cnt[6]++;
		}
		if (cnt[7]) {
			cnt[7]--;
			solve(1, i + 1);
			cnt[7]++;
		}
	}
}

ll f[20];

int brute(string a, string b, string c) {
	vector<int> p(n);
	int ttans = 0;
	for (int i = 0; i < n; i++) {
		p[i] = i;
	}

	do {
		if (a[p[n - 1]] == '0' || b[p[n - 1]] == '0' || c[p[n - 1]] == '0') continue;
		ll x, y, z;
		x = y = z = 0;
		ll cp = 1;
		for (int i = 0; i < n; i++) {
			x += (a[p[i]] - '0') * cp;
			y += (b[p[i]] - '0') * cp;
			z += (c[p[i]] - '0') * cp;
			cp *= 10LL;
		}

		if (x + y == z) {
			ttans++;
			if (ttans == mod) ttans = 0;
		}
	} while (next_permutation(all(p)));

	return ttans;
}

int main() {
	FAST;

	f[0] = 1;
	for (ll i = 1; i < 20; i++) {
		f[i] = i * f[i - 1] % mod;
	}

	string a, b, c;
	cin >> a >> b >> c;
	n = gsize(a);
	cout << brute(a, b, c) << nl;
	return 0;

	for (int i = 0; i < n; i++) {
		int ti = 0;
		if (a[i] == '0' || b[i] == '0' || c[i] == '0') ti = 0;
		int x = a[i] - '0', y = b[i] - '0', z = c[i] - '0';
		if (x + y == z) {
			ti += 0;
		} else if (x + y - 10 == z) {
			ti += 1;
		} else if (x + y + 1 == z) {
			ti += 2;
		} else if (x + y - 9 == z) {
			ti += 3;
		} else {
			cout << 0 << nl;
			return 0;
		}
		cnt[ti]++;
	}
	cout << nl;
	for (int i = 0; i < 8; i++) cout << cnt[i] << ' ';
	cout << nl << nl;

	ll mul = 1;
	for (int i = 0; i < 8; i++) {
		mul *= f[cnt[i]];
	}

	solve(0, 0);

	cout << ans * mul % mod << nl;
}