#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, m;

int getstr(int x)
{
    x = max(x, 0ll);
    x = min(x, n);
    int r1 = (m * x) * (m * x + 1) / 2;
    int r2 = (n * m) * (n * m + 1) / 2 - r1;
    return r1 - r2;
}

int optstr()
{
    int L = 0, R = n - 1;
    while (R - L > 1)
    {
        int sr = (L + R) / 2;
        if (getstr(sr) < 0) L = sr;
        else R = sr;
    }
    return R;
}

int getcol(int x)
{
    x = max(x, 0ll);
    x = min(x, m);
    int r1 = (m * x) * n * (n - 1) / 2 + x * (x + 1) / 2 * n;
    int r2 = (n * m) * (n * m + 1) / 2 - r1;
    return r1 - r2;
}

int optcol()
{
    int L = 0, R = m - 1;
    while (R - L > 1)
    {
        int sr = (L + R) / 2;
        if (getcol(sr) < 0) L = sr;
        else R = sr;
    }
    return R;
}


void solve()
{
    cin >> n >> m;
    char r1;
    int r2;
    int res = 1e18;
    int now = optstr() - 1;
    for (int i = 0; i < 3; ++i, ++now)
        if (abs(getstr(now)) < res)
        {
            res = abs(getstr(now));
            r1 = 'H';
            r2 = now;
        }
    now = optcol() - 1;
    for (int i = 0; i < 3; ++i, ++now)
        if (abs(getcol(now)) < res)
        {
            res = abs(getcol(now));
            r1 = 'V';
            r2 = now;
        }
    cout << r1 << " " << r2 + 1 << endl;


}

signed main()
{
    n = 1;
    m = 3;
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
}
