// ConsoleApplication1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<unordered_map>
#include<cmath>
using namespace std;

#define int long long

const int MOD = 1e9 + 7;

int fi, sc, th, fo;

struct it {
    int t, len, fi, sc, th, fo;
};

bool operator<(it a, it b) {
    return a.len < b.len;
}

map<it, int> dp;

int count_dp(it now) {
    if (dp.find(now) != dp.end()) return dp[now];
    if (now.len == 1) {
        if (now.t == 1) {
            dp[now] = 1;
        }
        if (now.t == 2) {
            dp[now] = 1;
        }
        if (now.t == 3) {
            dp[now] = 0;
        }
        if (now.t == 4) {
            dp[now] = 0;
        }
        return dp[now];
    }
    int ans = 0;
    if (now.t == 1) {
        if (now.fi + 1 <= fi) {
            it next = now;
            next.fi += 1;
            next.len -= 1;
            ans += count_dp(next) * (fi - now.fi);
            ans %= MOD;
        }
        if (now.th + 1 <= th) {
            it next = now;
            next.t = 3;
            next.th += 1;
            next.len -= 1;
            ans += count_dp(next) * (th - now.th);
            ans %= MOD;
        }
    }
    if (now.t == 4) {
        if (now.fo + 1 <= fo) {
            it next = now;
            next.fo += 1;
            next.len -= 1;
            ans += count_dp(next) * (fo - now.fo);
            ans %= MOD;
        }
        if (now.sc + 1 <= sc) {
            it next = now;
            next.t = 2;
            next.sc += 1;
            next.len -= 1;
            ans += count_dp(next) * (sc - now.sc);
            ans %= MOD;
        }
    }
    if (now.t == 2) {
        if (now.fi + 1 <= fi) {
            it next = now;
            next.t = 1;
            next.fi += 1;
            next.len -= 1;
            ans += count_dp(next) * (fi - now.fi);
            ans %= MOD;
        }
        if (now.th + 1 <= th) {
            it next = now;
            next.t = 3;
            next.th += 1;
            next.len -= 1;
            ans += count_dp(next) * (th - now.th);
            ans %= MOD;
        }
    }
    if (now.t == 3) {
        if (now.sc + 1 <= sc) {
            it next = now;
            next.t = 2;
            next.sc += 1;
            next.len -= 1;
            ans += count_dp(next) * (sc - now.sc);
            ans %= MOD;
        }
        if (now.fo + 1 <= fo) {
            it next = now;
            next.t = 4;
            next.fo += 1;
            next.len -= 1;
            ans += count_dp(next) * (fo - now.fo);
            ans %= MOD;
        }
    }
    dp[now] = ans;
    return ans;
}

signed main()
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s1[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        b[i] = s2[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        c[i] = s3[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] == c[i]) {
            ++fi;
        } else if ((a[i] + b[i]) % 10 == c[i]) {
            ++sc;
        } else if (a[i] + b[i] + 1 == c[i]) {
            ++th;
        } else if ((a[i] + b[i] + 1) % 10 == c[i]) {
            ++fo;
        }
        else {
            cout << 0;
            return 0;
        }
    }
    cout << count_dp({1, n, 1, 0, 0, 0}) * fi + count_dp({ 3, n, 0, 0, 1, 0 }) * th;
}

/*
5
1 3
4 7
1 10
3 3
3 5
*/