// ConsoleApplication1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<unordered_map>
#include<cmath>
using namespace std;

#define int long long

const int MOD = 1e9 + 7;

signed main()
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    vector<int> a(n), b(n), c(n), t(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s1[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        b[i] = s2[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        c[i] = s3[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] == c[i]) {
            t[i] = 1;
        } else if ((a[i] + b[i]) % 10 == c[i]) {
            t[i] = 2;
        } else if (a[i] + b[i] + 1 == c[i]) {
            t[i] = 3;
        } else if ((a[i] + b[i] + 1) % 10 == c[i]) {
            t[i] = 4;
        }
    }
    int mx = 1ll << n;
    vector<vector<int>> dp(mx, vector<int>(n, 0));
    int j = 0;
    for (int i = 1; i < mx; i = (i<<1)) {
        if (t[j] == 2 || t[j] == 1) {
            dp[i][j] = 1;
        }
        ++j;
    }
    for (int mask = 0; mask < mx; ++mask) {
        for (int start = 0; start < n; ++start) {
            if (!(mask & (1ll << start))) continue;
            int mm = (mask ^ (1ll << start));
            if (mask == mm) return 1303;
            for (int start2 = 0; start2 < n; ++start2) {
                if (!(mm & (1ll << start2))) continue;
                if (t[start] == 1) {
                    if (t[start2] == 1 || t[start2] == 3) {
                        dp[mask][start] += dp[mm][start2];
                        dp[mask][start] %= MOD;
                    }
                }
                if (t[start] == 2) {
                    if (t[start2] == 1 || t[start2] == 3) {
                        dp[mask][start] += dp[mm][start2];
                        dp[mask][start] %= MOD;
                    }
                }
                if (t[start] == 3) {
                    if (t[start2] == 2 || t[start2] == 4) {
                        dp[mask][start] += dp[mm][start2];
                        dp[mask][start] %= MOD;
                    }
                }
                if (t[start] == 4) {
                    if (t[start2] == 4 || t[start2] == 2) {
                        dp[mask][start] += dp[mm][start2];
                        dp[mask][start] %= MOD;
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (t[i] == 2 || t[i] == 4) continue;
        if ((a[i] == 0 || b[i] == 0) || (c[i] == 0)) continue;
        if (t[i] == 1 || t[i] == 3) {
            ans += dp.back()[i];
            ans %= MOD;
        }
    }
    cout << ans;
}

/*
5
1 3
4 7
1 10
3 3
3 5
*/