#include <iostream>
#include <vector>

using namespace std;

int n, dist;
vector <vector <int>> p;
vector <pair <int, int>> p1;
vector <int> s;
vector <int> m;
vector <int> perm;
vector <bool> mark;
bool f;

void build(int d, int j1 = -1, int j2 = -1) {
    bool f1 = false;
    if (j1 != -1 && dist == -1) {
        dist = p1[j1].second + p1[j2].first;
        f1 = true;
    }
    if (j1 != -1) {
        int dist1 = p1[j1].second + p1[j2].first;
        if (dist1 != dist)
            return;
    }
    if (d == 0) {
        f = true;
        return;
    }
    else {
        for (int i = 0; i < n; i++) {
            if (!mark[i]) {
                mark[i] = true;
                perm.push_back(i);
                build(d - 1, j2, i);
                if (f)
                    return;
                perm.pop_back();
                mark[i] = false;

            }
        }
    }
    if (f1)
        dist = -1;
}

int check() {
    int ans = -1;
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < m[i]; j++) {
            if (ans == -1)
                ans = p[i][j] - p[i][j - 1];
            if (p[i][j] - p[i][j - 1] != ans)
                return -2;
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> n;
    p.resize(n);
    s.resize(n);
    m.resize(n);
    mark.assign(n, false);
    for (int i = 0; i < n; i++) {
        cin >> m[i] >> s[i];
        p[i].resize(m[i]);
        for (auto &x: p[i])
            cin >> x;
    }
    dist = check();
    if (dist == -2) {
        cout << "No" << endl;
        return 0;
    }
    if (n == 1) {
        cout << "Yes" << endl;
        cout << 1 << endl;
        return 0;
    }

    for (int i = 0; i < n; i++)
        p1.push_back(make_pair(p[i][0], s[i] - p[i][m[i] - 1]));

    build(n);
    if (!f) {
        cout << "No" << endl;
        return 0;
    }
    cout << "Yes" << endl;
    for (int i = 0; i < n; i++)
        cout << perm[i] + 1 << " ";

    return 0;
}
