#include <iostream>
#include <vector>

using namespace std;

int n;
string a;
string b;
string c;
vector <int> perm;
vector <bool> mark;

int get(int d) {
    if (d == 0) {
        int i = perm[0];
        if (a[i] == '0' || b[i] == '0' || c[i] == '0')
            return 0;
        int x = 0;
        int y = 0;
        int z = 0;
        for (int j = 0; j < n; j++) {
            i = perm[j];
            x = 10 * x + (a[i] - '0');
            y = 10 * y + (b[i] - '0');
            z = 10 * z + (c[i] - '0');
        }
        if (x + y == z)
            return 1;
        return 0;
    }
    else {
        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (!mark[i]) {
                mark[i] = true;
                perm.push_back(i);
                ans += get(d - 1);
                perm.pop_back();
                mark[i] = false;
            }
        }
        return ans;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> a;
    cin >> b;
    cin >> c;
    n = a.size();
    mark.assign(n, false);
    int ans = get(n);
    cout << ans << endl;

    return 0;
}
