#include "bits/stdc++.h"
#include "iomanip"
#define int long long
#define all(x) (x).begin(), (x).end()
#define fast() ios::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define ld long double
#define pi pair<int, int>
using namespace std;

bool is_digit(char c) {
    return '0' <= c && c <= '9';
}

int len10(int x) { // length in compressed form
    if (x == 0) {
        return 0;
    }
    int ans = (x != 1);
    while(x) {
        ++ans;
        x/=10;
    }
    return ans;
}
int minD = 1;
int minX = 0;

void updMin(int d, int x) {
    if (minD > d) {
        minD = d;
        minX = x;
    }
}

vector<pair<int, char>> work;
char get_char(int x) {
    if (x < 0 || x >= work.size()) {
        return 'A';
    }
    return work[x].second;
}
vector<char> DNA = {'A', 'G', 'C', 'T'};

char get_not(char x, char y, char z) {
    for (auto c : DNA) {
        if (c != x && c != y && c != z) {
            return c;
        }
    }
}

int maxD = -1;
int maxX = 0;
char maxC = '0';
void updMax(int d, int x, char c) {
    if (maxD < d) {
        maxD = d;
        maxX = x;
        maxC = c;
    }
}

int getPow10(int x) {
    int res = 1;
    while (x > res) {
        res *= 10;
    }
    return res;
}

void solve(){
    string s;
    cin >> s;
    work.push_back({0, '0'});
    for (int i = 0; i < s.size(); ++i) {
        if (is_digit(s[i])) {
            work.back().first *= 10;
            work.back().first += s[i] -'0';
        } else {
            work.back().second = s[i];
            if(work.back().first == 0) {
                work.back().first = 1;
            }
            work.push_back({0, '0'});
        }
    }
    work.pop_back();
    int n = work.size();

    vector<int> prefS(n);
    prefS[0] = work[0].first;
    for (int i = 1; i < n; ++i) {
        prefS[i] = prefS[i - 1] + work[i].first;
    }
    for (int i = 0; i < n; ++i) {
        int cnt = work[i].first;
        int curIdx = prefS[i] - cnt;

        if (cnt > 1) {
            int curD = len10(cnt-1) - len10(cnt);
            updMin(curD, curIdx);
        } else {
            int curD = -1;
            updMin(curD, curIdx);
            if (i > 0 && i +1< n ) {
                if (work[i - 1].second == work[i + 1].second) {
                    int cntLe = work[i-1].first;
                    int cntRi = work[i+1].first;
                    int curD = -1 + len10(cntLe + cntRi) - len10(cntLe) - len10(cntRi);
                    updMin(curD, curIdx);
                }
            }
        }
    }
    cout << "2 " << minX + 1 << '\n';
    for (int i = 0; i < n; ++i) {
        int cnt = work[i].first;
        int leIdx = prefS[i] - cnt;
        vector<int> validLe;
        validLe.push_back(cnt/2);
        validLe.push_back(getPow10(cnt/2));
        for (auto le : validLe) {
//        int le = cnt/2;
//        int ri = cnt/2 + cnt%2;
        int ri = cnt - le;
        if (le < 0 || ri < 0) {
            continue;
        }
        int curD = 1 + len10(le) + len10(ri) - len10(cnt);
        updMax(curD, leIdx + le - 1, get_not(get_char(i - 1), get_char(i), get_char(i + 1)));
        }
    }
    cout << "1 " << maxX + 1 << ' ' << maxC << '\n';
}

signed main(){
    int t = 1;
//    fast();
//    system("g++ -o main main.cpp");
//    system("./main");
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}