// ConsoleApplication5.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream> 
#define int long long

//#define int long long
using namespace std; 

long long get_hor(int N, int M, int stb) {
	if (stb < 0) {
		return 0;
	}
	if (stb >= N) {
		return (N * M) * (N * M + 1) / 2;
	}
	return (N * stb) * (N * stb + 1) / 2;
}

long long get_ver(int N, int M, int stb) {
	if (stb < 0) {
		return 0;
	}
	if (stb >= M) {
		return (N * M) * (N * M + 1) / 2;
	}
	return stb * M * N * (N - 1) / 2 + stb * (stb + 1) / 2 * N;
}

pair<int, long long> binshor(int N, int M){
	long long sit = get_hor(N, M, 2e9);
	long long l = -1, r = 2e9;
	while (r - l > 1) {
		long long m = (l + r) / 2;
		if (get_hor(N, M, m) * 2 < sit) {
			l = m;
		}
		else {
			r = m;
		}
	}
	if (abs(get_hor(N, M, l) * 2 - sit) < abs(get_hor(N, M, r) * 2 - sit))
		return { l + 1, get_hor(N, M, l) };
	else
		return { r + 1, get_hor(N, M, r) };
}

pair<int, long long> binsver(int N, int M) {
	long long sit = get_ver(N, M, 2e9);
	long long l = -1, r = 2e9;
	while (r - l > 1) {
		long long m = (l + r) / 2;
		if (get_ver(N, M, m) * 2 < sit) {
			l = m;
		}
		else {
			r = m;
		}
	}
	if (abs(get_ver(N, M, l) * 2 - sit) < abs(get_ver(N, M, r) * 2 - sit))
		return { l + 1, get_ver(N, M, l) };
	else
		return { r + 1, get_ver(N, M, r) };
}

signed main()
{
	int T;
	cin >> T;
	for (int i = 0; i < T; i++) {
		int N, M;
		cin >> N >> M;
		int sit = get_hor(N, M, 2e9);
		pair<int, int> A = binshor(N, M), B = binsver(N, M);
		//for (int i = 0; i < M; i++) {
		//	cout << get_ver(N, M, i) << endl;
		//}
		if (abs(A.second * 2 - sit) >= abs(B.second * 2 - sit)) {
			cout << "V " << B.first << endl; //<< " " << B.second << " " << sit << endl;
		}
		else {
			cout << "H " << A.first << endl; //<< " " << A.second << " " << sit << endl;
		}
	}

}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку" 

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.







