// 5z.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main()
{
    int N;
    cin >> N;
    vector<int> perm(N);
    vector<vector<int>> balks(N);
    vector<int> lens(N);
    int size_now = -1;
    for (int i = 0; i < N; i++) {
        int m, l;
        cin >> m >> l;
        lens[i] = l;
        balks[i].assign(m, 0);
        for (int j = 0; j < m; j++) {
            cin >> balks[i][j];
        }
        perm[i] = i;
    }
    do {
        vector<int> ps;
        int r = 0;
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < balks[perm[i]].size(); j++) {
                ps.push_back(balks[perm[i]][j] + r);
            }
            r += lens[perm[i]];
        }
        if (ps.size() == 1) {
            cout << "Yes" << endl << 1;
            return 0;
        }
        //for (auto i : ps) {
        //    cout << i << " ";
        //}
        //cout << endl;
        int ln = ps[1] - ps[0];
        bool ans = true;
        for (int i = 0; i < ps.size() - 1; i++) {
            if (ps[i + 1] - ps[i] != ln) {
                ans = false;
            }
        }
        if (ans) {
            cout << "Yes\n";
            for (int i : perm) {
                cout << i + 1 << " ";
            }
            return 0;
        }
    } while (next_permutation(perm.begin(), perm.end()));
    cout << "No";
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
