def sum_first(k):
    return k * (k + 1) // 2


def calc_h(x):
    return sum_first(x * m) * 2 - total_sum


def calc_v(x):
    """
     1  2  3  4  5  6  7
     8  9 10 11 12 13 14
    15 16 17 18 19 20 21
    22 23 24 25 26 27 28
    """
    return (sum_first(x) * n + sum_first(n - 1) * m * x) * 2 - total_sum


def solve(k, calc):
    bsl, bsr = 0, k
    while bsl + 1 < bsr:
        bsm = (bsl + bsr) // 2
        if calc(bsm) < 0:
            bsl = bsm
        else:
            bsr = bsm
    if bsr < k and abs(calc(bsl)) > calc(bsr) or not bsl:
        return bsr
    else:
        return bsl


for _ in range(int(input())):
    n, m = map(int, input().split())
    total_sum = sum_first(n * m)
    ans_h = solve(n, calc_h)
    ans_v = solve(m, calc_v)
    if abs(calc_h(ans_h)) < abs(calc_v(ans_v)):
        print("H", ans_h + 1)
    else:
        print("V", ans_v + 1)
