#include <iostream>
#include <vector>
#include <queue>
#include <string>

using namespace std;
#define int long long
const int INF = 1e15;

inline char get1(char c) {
    if (c == 'A') return 'G';
    return 'A';
}

inline int get_ans(string& s) {
    int curkol = 1;
    string result;
    for (int i = 1; i < s.size(); ++i) {
        if (s[i] == s[i - 1]) ++curkol;
        else {
            if (curkol != 1)
                result += to_string(curkol);
            result += s[i - 1];
            curkol = 1;
        }
    }
    if (!s.empty()) {
        if (curkol != 1)
            result += to_string(curkol);
        result += s.back();
    }
    return result.size();
}

string get_flex(const string& s) {
    string lol;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] < '0' || s[i] > '9') {
            lol += s[i];
        } else {
            int cur = 0;
            for (; s[i] >= '0' && s[i] <= '9'; ++i) {
                cur = cur * 10 + s[i] - '0';
            }
            for (int j = 0; j < cur; ++j) lol += s[i];
        }
    }
    return lol;
}

void solve1(const string& s) {
    vector<pair<int, char>> all;
    int len = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] > '9' || s[i] < '0') {
            all.emplace_back(1, s[i]);
            ++len;
        } else {
            int cur = 0;
            for (; s[i] >= '0' && s[i] <= '9'; ++i) {
                cur = cur * 10 + s[i] - '0';
            }
            all.emplace_back(cur, s[i]);
            len += to_string(cur).size() + 1;
        }
    }
    int minn = INF, cminn = -1, posminn = -1;
    char zminn;
    int maxx = -INF, cmaxx = -1, posmaxx = -1;
    char zmaxx;
    int tmp = 0;
    for (auto i : all) {
        if (i.first == 1) {
            if (minn > len - 1) {
                minn = len - 1;
                cminn = 2;
                posminn = tmp + 1;
            }
        } else if (i.first == 2) {
            if (minn > len - 1) {
                minn = len - 1;
                cminn = 2;
                posminn = tmp + 1;
            }
        } else {
            int lencha = to_string(i.first).size(), newlen = to_string(i.first - 1).size();
            if (minn > len - lencha + newlen) {
                minn = len - lencha + newlen;
                cminn = 2;
                posminn = tmp + 1;
            }
        }
        tmp += i.first;
    }
    tmp = 0;
    for (auto i : all) {
        if (i.first == 1) {
            if (maxx < len + 1) {
                maxx = len + 1;
                cmaxx = 1;
                posmaxx = tmp;
                zmaxx = i.second;
            }
        } else {
            int lencha = to_string(i.first).size(), newlen = to_string(i.first + 1).size();
            if (maxx < len - lencha + newlen) {
                maxx = len - lencha + newlen;
                cmaxx = 1;
                posmaxx = tmp;
                zmaxx = i.second;
            }
        }
        if (i.first == 1) {

        } else if (i.first == 2) {
            if (maxx < len - 2 + 3) {
                maxx = len - 2 + 3;
                cmaxx = 1;
                posmaxx = tmp + 1;
                zmaxx = get1(i.second);
            }
        } else if (i.first == 3) {
            if (maxx < len - 2 + 4) {
                maxx = len - 2 + 4;
                cmaxx = 1;
                posmaxx = tmp + 1;
                zmaxx = get1(i.second);
            }
        } else {
            int lencha = to_string(i.first).size(), newlen1 = to_string(
                    i.first / 2).size(), newlen2 = to_string(i.first - i.first / 2).size();
            if (maxx < len - lencha + newlen1 + newlen2 + 2) {
                maxx = len - lencha + newlen1 + newlen2 + 2;
                cmaxx = 1;
                posmaxx = tmp + i.first / 2;
                zmaxx = get1(i.second);
            }
        }
        tmp += i.first;
    }
    tmp = 0;
    for (int i = 0; i < all.size(); ++i) {
        if (i == 0 || i == (int) all.size() - 1 || all[i - 1].second != all[i + 1].second || all[i].first != 1) {
            tmp += all[i].first;
            continue;
        }
        int cur = 0;
        if (all[i - 1].first == 1) cur = 0;
        else cur = to_string(all[i - 1].first).size();
        if (all[i + 1].first == 1) cur += 0;
        else cur += to_string(all[i + 1].first).size();
        if (minn > len - cur - 3 + 1 + to_string(all[i - 1].first + all[i + 1].first).size()) {
            minn = len - cur - 3 + 1 + to_string(all[i - 1].first + all[i + 1].first).size();
            cminn = 2;
            posminn = tmp + 1;
        }
        tmp += all[i].first;
    }
    /*string lol = get_flex(s);
    string tmp1 = lol.substr(0, posminn - 1) + lol.substr(posminn, (int)lol.size() - posminn);
    minn = get_ans(tmp1);
    string tmp2 = lol.substr(0, posmaxx) + zmaxx + lol.substr(posmaxx, (int)lol.size() - posmaxx);
    maxx = get_ans(tmp2);
    return make_pair(minn, maxx);*/
    cout << 2 << " " << posminn << "\n" << 1 << " " << posmaxx << " " << zmaxx << "\n";
}

pair <int, int> solve2(const string& s) {
    char kek[4] = {'A', 'G', 'C', 'T'};
    string lol;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] < '0' || s[i] > '9') {
            lol += s[i];
        } else {
            int cur = 0;
            for (; s[i] >= '0' && s[i] <= '9'; ++i) {
                cur = cur * 10 + s[i] - '0';
            }
            for (int j = 0; j < cur; ++j) lol += s[i];
        }
    }
    int minn = INF, cminn = -1, posminn = -1;
    char zminn;
    int maxx = -INF, cmaxx = -1, posmaxx = -1;
    char zmaxx;
    for (int i = 0; i < lol.size(); ++i) {
        string tmp = lol.substr(0, i) + lol.substr(i + 1, (int)lol.size() - i - 1);
        int flex = get_ans(tmp);
        if (flex < minn) {
            minn = flex;
            cminn = 2;
            posminn = i + 1;
        }
    }
    for (int i = 0; i < lol.size(); ++i) {
        for (int j = 0; j < 4; ++j) {
            string tmp = lol.substr(0, i);
            tmp += kek[j];
            tmp += lol.substr(i, (int)lol.size() - i);
            int cha = get_ans(tmp);
            if (cha > maxx) {
                maxx = cha;
                cmaxx = 1;
                posmaxx = i;
                zmaxx = kek[j];
            }
        }
    }
    return make_pair(minn, maxx);
}

signed main() {
    char kek[4] = {'A', 'G', 'C', 'T'};
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        string s;
        cin >> s;
        solve1(s);
        //pair <int, int> ans1 = solve1(s), ans2 = solve2(s);
        //cout << ans1.first << " " << ans1.second << "\n" << ans2.first << " " << ans2.second;
    } /*else {
        srand(1);
        int t;
        cin >> t;
        while (t--) {
            int n = rand() % 10 + 1;
            string s;
            char last = 'O';
            int kol = 0;
            for (int i = 0; i < n; ++i) {
                if (rand() % 2 && kol <= 2) {
                    s += to_string(max(rand() % 10, 2));
                    ++kol;
                }
                else {
                    int lol = rand() % 4;
                    while (last == kek[lol]) {
                        lol = rand() % 4;
                    }
                    last = kek[lol];
                    s += kek[lol];
                    kol = 0;
                }
            }
            if (s.back() >= '0' && s.back() <= '9') continue;
            cout << s << "\n";
            if (solve1(s) != solve2(s)) {
                cout << s << "\n";
                return 0;
            }
        }
    }*/
}

/*
 T2C6AGTA
 */