#include <iostream>
#include <vector>
#include <queue>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

map <int, vector <int>> all;
vector <vector <int>> a;
vector <int> s, ans;

int dfs(int cha, int r) {
    int start = r - cha;
    if (all[start].empty()) return start;
    ans.push_back(all[start].back());
    all[start].pop_back();
    int end = s[ans.back()] - a[ans.back()].back();
    return dfs(end, r);
}

signed main() {
    int n;
    cin >> n;
    s.resize(n);
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        int kol;
        cin >> kol >> s[i];
        a[i].resize(kol);
        for (int j = 0; j < kol; ++j) cin >> a[i][j];
    }
    int rr = -1;
    for (int i = 0; i < n; ++i) {
        if (a[i].size() > 1) {
            rr = a[i][1] - a[i][0];
        }
    }
    if (rr != -1) {
        for (int i = 0; i < n; ++i) {
            for (int j = 1; j < a[i].size(); ++j) {
                if (a[i][j] - a[i][j - 1] != rr) {
                    cout << "No";
                    return 0;
                }
            }
        }
    }
    if (rr == -1) {
        //xz
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        for (int start = 0; start < n; ++start) {
            if (start == i) continue;
            for (int j = 0; j < n; ++j) {
                if (i == j || j == start) continue;
                all[a[j].front()].push_back(j);
            }
            ans.clear();
            ans.push_back(start);
            int kek = dfs(s[start] - a[start].back(), rr);
            if (ans.size() < n - 1) continue;
            if (a[i].front() == kek) {
                cout << "Yes\n";
                for (int j : ans) cout << j + 1 << " ";
                cout << i + 1;
                return 0;
            }
        }
    }
    cout << "No";
}
