#include <iostream>
#include <vector>
#include <queue>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

map <int, vector <int>> all;
vector <vector <int>> a;
vector <int> s;
vector <pair <int, int>> ord;
map <pair <int, int>, bool> used;
void dfs(int cha, int dol, int r) {
    used[make_pair(dol, cha)] = true;
    if (dol == 0) {
        if (!used[make_pair(1, r - cha)]) {
            dfs(r - cha, 1, r);
        }
        ord.emplace_back(0, cha);
    } else {
        for (int i : all[cha]) {
            if (!used[make_pair(0, s[i] - a[i].back())]) {
                dfs(s[i] - a[i].back(), 0, r);
            }
        }
        ord.emplace_back(dol, cha);
    }
}

deque<int> ans;

void make_flex(int cha, int dol, int r) {
    if (dol == 0) {
        int start = r - cha;
        make_flex(start, 1, r);
    } else {
        while (!all[cha].empty()) {
            int to = all[cha].back();
            all[cha].pop_back();
            make_flex(s[to] - a[to].back(), 0, r);
            ans.push_front(to);
        }
    }
}
signed main() {
    int n;
    cin >> n;
    s.resize(n);
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        int kol;
        cin >> kol >> s[i];
        a[i].resize(kol);
        for (int j = 0; j < kol; ++j) cin >> a[i][j];
    }
    int rr = -1;
    for (int i = 0; i < n; ++i) {
        if (a[i].size() > 1) {
            rr = a[i][1] - a[i][0];
        }
    }
    if (rr != -1) {
        for (int i = 0; i < n; ++i) {
            for (int j = 1; j < a[i].size(); ++j) {
                if (a[i][j] - a[i][j - 1] != rr) {
                    cout << "No";
                    return 0;
                }
            }
        }
    }
    if (rr == -1 || n <= 8) {
        vector <int> p(n);
        int f = 1;
        for (int i = 0; i < n; ++i) {
            p[i] = i + 1;
            f *= i + 1;
        }
        while(f--) {
            bool ok = true;
            int r = rr;
            for (int i = 1; i < n; ++i) {
                if (r == -1) r = a[p[i] - 1][0] + s[p[i - 1] - 1] - a[p[i - 1] - 1].back();
                else {
                    if (r != a[p[i] - 1][0] + s[p[i - 1] - 1] - a[p[i - 1] - 1].back()) {
                        ok = false;
                        break;
                    }
                }
            }
            if (ok) {
                cout << "Yes\n";
                for (int i : p) cout << i << " ";
                return 0;
            }
            next_permutation(p.begin(), p.end());
        }
        cout << "No";
    } else {
        for (int i = 0; i < n; ++i) {
            all[a[i].front()].push_back(i);
        }
        for (int i = 0; i < n; ++i) {
            if (!used[make_pair(0, s[i] - a[i].back())]) dfs(s[i] - a[i].back(), 0, rr);
            if (!used[make_pair(1, a[i].front())]) dfs(a[i].front(), 1, rr);
        }
        reverse(ord.begin(), ord.end());
        for (auto i : ord) {
            make_flex(i.second, i.first, rr);
            if (!ans.empty()) break;
        }
        if (ans.size() != n) cout << "No";
        else {
            cout << "Yes\n";
            for (int i : ans) cout << i + 1 << " ";
        }
    }
}
