def foover(n, m, pos):
    x = (1 + pos) * pos // 2
    d = m * pos
    lsum = (x + x + d*(n - 1)) * n // 2
    sumall = (1 + n * m) * (n * m) // 2
    #print(pos, abs(lsum - (sumall - lsum)))
    return abs(lsum - (sumall - lsum))


def foohor(n, m, pos):
    usum = (1 + m * pos) * (m * pos) // 2
    sumall = (1 + n*m) * (n*m) // 2
    return abs(usum - (sumall - usum))


def solvever(n, m):
    l = 0
    r = m - 1
    while (r - l > 3):
        m1 = (r - l) // 3 + l
        m2 = 2 * (r - l) // 3 + l
        f1 = foover(n, m, m1)
        f2 = foover(n, m, m2)
        if f1 > f2:
            l = m1
        else:
            r = m2
    mnd = 1000000000000000000000
    pos = l
    for i in range(l, r + 1):
        fhere = foover(n, m, i)
        if (fhere < mnd):
            mnd = fhere
            pos = i
    return mnd, pos


def solvehor(n, m):
    l = 0
    r = n - 1
    while r - l > 3:
        m1 = (r - l) // 3 + l
        m2 = 2 * (r - l) // 3 + l
        f1 = foohor(n, m, m1)
        f2 = foohor(n, m, m2)
        if f1 > f2:
            l = m1
        else:
            r = m2
    mnd = 1000000000000000000000
    pos = l
    for i in range(l, r + 1):
        fhere = foohor(n, m, i)
        if (fhere < mnd):
            mnd = fhere
            pos = i
    return mnd, pos


def solve():
    n, m = map(int, input().split())
    ansv, posv = solvever(n, m)
    ansh, posh = solvehor(n, m)
    #print(ansv, posv, ansh, posh)
    if ansv <= ansh:
        print('V {}'.format(posv + 1))
    else:
        print('H {}'.format(posh + 1))


t = int(input())
while t > 0:
    solve()
    t -= 1
