#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>
#include <vector>

#define lng long long
#define lgd long double

using namespace std;

lng s(lng a, lng b)
{
    return (b-a+1)*(a+b)/2;
}

lng bin(lng n)
{
    lng l = 1, r = n;
    while (l != r)
    {
        lng mid = (l + r + 1)/2;
        if (n/mid < mid)
            r = mid-1;
        else
            l = mid;
    }
    if (n/l < l)
        return l-1;
    return l;
}

lng stolb(lng i, lng n, lng m)
{
    lng sum = s(1, n*m);
    lng ans = s(1, i)*n + s(1, n-1)*m*i;
    return abs(sum - 2*ans);
}

lng stroka(lng i, lng n, lng m)
{
    lng sum = s(1, n*m);
    lng ans = s(1, i*m);
    return abs(sum - 2*ans);
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t;
    for (int i = 0; i < t; i++) {
        lng n, m; cin >> n >> m;
        lng mn = 6e18, ans;
        char cans;
        if (n == 1) {
        for (lng j = bin(s(1, m)); j < bin(s(1, m))+2; j++)
        {
            if (stolb(j, n, m) < mn)
            {
                cans = 'V';
                ans = j+1;
                mn = stolb(j, n, m);
            }
        }
        }
        else
        {
            for (lng j = 1; j < m; j++)
        {
            if (stolb(j, n, m) < mn)
            {
                cans = 'V';
                ans = j+1;
                mn = stolb(j, n, m);
            }
        }
        }
        for (lng j = 1; j < n; j++)
        {
            if (stroka(j, n, m) < mn)
            {
                cans = 'H';
                ans = j+1;
                mn = stroka(j, n, m);
            }
        }
        cout << cans << " " << ans << "\n";
    }
}
