#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
long long arpr(long long n) {
	return (n + 1) * n / 2;
}
long long getsum(int vs,int hs,int n, int m) {
	if (vs == 0 || hs == 0) {
		return 0;
	}
	long long sum = arpr(hs) * vs;
	sum += arpr(vs - 1) * m * hs;
	return sum;
}
int main() {
	int tt;
	cin >> tt;
	for (int t = 0; t < tt; t++) {
		int n, m;
		cin >> n >> m;
		int VL = 0;
		int VR = m;
		long long sum = getsum(n, m, n, m);
		while (VR - VL > 1) {
			int med = (VL + VR) / 2;
			if (getsum(n, med, n, m) > sum - getsum(n, med, n, m)) {
				VR = med;
			}
			else {
				VL = med;
			}
		}

		int HL = 0;
		int HR = n;
		while (HR - HL > 1) {
			int med = (HL + HR) / 2;
			if (getsum(med, m, n, m) > sum - getsum(med, m, n, m)) {
				HR = med;
			}
			else {
				HL = med;
			}

		}

		long long minim = min(min(abs(sum - 2 * getsum(HL, m, n, m)), abs(sum - 2 * getsum(HR, m, n, m))), min(abs(sum - 2 * getsum(n, VL, n, m)), abs(sum - 2 * getsum(n, VR, n, m))));
		if (minim == abs(sum - 2 * getsum(n,VL, n, m))) {
			cout << "V " << VL + 1;
		}
		else if (minim == abs(sum - 2 * getsum(n, VR, n, m))) {
			cout << "V " << VR + 1;
		}
		else if (minim == abs(sum - 2 * getsum(HL, m, n, m))) {
			cout << "H " << HL + 1;
		}
		else {
			cout << "H " << HR + 1;
		}
		cout << '\n';

	}
}