#include <iostream>
#include <string>
#include <vector>

using namespace std;

vector<int> t(10);
vector<char> letters = { 'A', 'C', 'G', 'T' };

char gen(char f, char s = 0) {
	for (char i : letters) {
		if (i != f && i != s) {
			return i;
		}
	}
}

int f(int x) {
	int i = 1;
	while (i < 10 && x >= t[i]) {
		++i;
	}
	return i;
}

struct answer {
	int d, pos;
	char c;

	answer(int _d, int _pos, char _c) {
		d = _d;
		pos = _pos;
		c = _c;
	}

	void upd(answer a) {
		if (abs(d) < abs(a.d)) {
			d = a.d;
			pos = a.pos;
			c = a.c;
		}
	}
};

int main() {
	t[0] = 1;
	for (int i = 1; i < 10; ++i) {
		t[i] = t[i - 1] * 10;
	}

	vector<pair<int, int>> v;
	string s;
	cin >> s;
	int n = s.size(), cnt;
	for (int i = 0; i < n; ++i) {
		cnt = 0;
		while (s[i] < 'A') {
			cnt = cnt * 10 + s[i] - '0';
			++i;
		}
		if (cnt) {
			v.push_back(make_pair(cnt, s[i]));
		} else {
			v.push_back(make_pair(1, s[i]));
		}
	}

	answer ans_min(0, 0, 0), curans(0, 0, 0);
	int m = v.size(), Log;
	cnt = 0;
	for (int i = 0; i < m; ++i) {
		if (v[i].first == 1) {
			if (i > 0 && i < m - 1 && v[i - 1].second == v[i + 1].second) {
				curans.d = f(v[i - 1].first) + f(v[i + 1].first) - f(v[i - 1].first + v[i + 1].first) - 2;
				curans.pos = cnt;
			}
			else {
				curans = answer(1, cnt, 'A');
			}
		}
		else {
			Log = f(v[i].first);
			if (v[i].first > t[Log - 1]) {
				curans = answer(0, cnt, 'A');
			} else {
				curans = answer(-1, cnt, 'A');
			}
		}
		cnt += v[i].first;
		ans_min.upd(curans);
	}
	cout << 2 << ' ' << ans_min.pos + 1 << '\n';

	answer ans_max(0, 0, 'A');
	cnt = 0;
	for (int i = 0; i < m; ++i) {
		if (v[i].first <= 2) {
			curans = answer(1, cnt, s[i]);
		}
		else if (v[i].first == 3) {
			curans = answer(2, cnt + 1, gen(v[i].second));
		}
		else {
			Log = f(v[i].first);
			if (Log == 1) {
				curans = answer(3, cnt + 2, gen(v[i].second));
			} else if (v[i].first > 2 * t[Log - 1]) {
				curans = answer(0, cnt, 'A');
			} else if (v[i].first > t[Log - 1] + t[Log - 2]) {
				curans = answer(Log + 1, cnt + t[Log - 1], gen(v[i].second));
			}
			else {
				curans = answer(Log, cnt + t[Log - 2], gen(v[i].second));
			}
		}
		ans_max.upd(curans);
		cnt += v[i].first;
	}
	cout << "1 " << ans_max.pos << ' ' << ans_max.c;
	return 0;
}
