#include <iostream>
#include <vector>

using namespace std;

long long n, dist = -1;
vector<long long> ans_perm, m, s;
vector<vector<long long>> p;

void solve(vector<long long>& perm, vector<long long>& used) {
	if (perm.size() == n) {
		ans_perm = perm;
		return;
	}

	long long k = perm.back();
	for (long long i = 0; i < n; ++i) {
		if (used[i]) {
			continue;
		}
		if (dist == -1) {
			dist = s[k] + p[i][0] - p[k].back();
			perm.push_back(i);
			used[i] = 1;
			solve(perm, used);
			perm.pop_back();
			used[i] = 0;
			dist = -1;
		}
		if (p[k].back() + dist == s[k] + p[i][0]) {
			perm.push_back(i);
			used[i] = 1;
			solve(perm, used);
			perm.pop_back();
			used[i] = 0;
		}
	}
}

int main() {
	cin >> n;
	m.resize(n);
	s.resize(n);
	p.resize(n);
	for (long long i = 0; i < n; ++i) {
		cin >> m[i] >> s[i];
		p[i].resize(m[i]);
		for (long long j = 0; j < m[i]; ++j) {
			cin >> p[i][j];
		}
		if (m[i] > 1) {
			if (dist == -1) {
				dist = p[i][1] - p[i][0];
			}
			if (dist != p[i][1] - p[i][0]) {
				cout << "No";
				return 0;
			}
			for (long long j = 2; j < m[i]; ++j) {
				if (p[i][j] - p[i][j - 1] != dist) {
					cout << "No";
					return 0;
				}
			}
		}
	}

	vector<long long> perm, used(n, 0);
	for (long long i = 0; i < n; ++i) {
		perm.push_back(i);
		used[i] = 1;
		solve(perm, used);
		perm.pop_back();
		used[i] = 0;
	}
	if (!ans_perm.empty()) {
		cout << "Yes\n";
		for (long long i : ans_perm) {
			cout << i + 1 << ' ';
		}
	}
	else {
		cout << "No";
	}
	return 0;
}
