//D 1
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int Mod = 1e9 + 7;

int binpow(long long x, int n) {
	long long res = 1;
	while (n) {
		if (n & 1) {
			res = (res * x) % Mod;
		}
		x = (x * x) % Mod;
		n /= 2;
	}
	return res;
}

int f(int l, int r) {
	int res = 1;
	for (int i = l; i <= r; ++i) {
		res = (res * 1ll * i) % Mod;
	}
	return res;
}

int main() {
	string a, b, c;
	cin >> a >> b >> c;
	int n = a.size();
	for (int i = 0; i < n; ++i) {
		a[i] -= '0';
		b[i] -= '0';
		c[i] -= '0';
	}

	vector<int> x(4, 0);
	for (int i = 0; i < n; ++i) {
		if (a[i] + b[i] == c[i]) {
			++x[0];
		} else if (a[i] + b[i] + 1 == c[i]) {
			++x[1];
		} else if (a[i] + b[i] == c[i] + 10) {
			++x[2];
		} else if (a[i] + b[i] + 1 == c[i] + 10) {
			++x[3];
		} else {
			cout << 0;
			return 0;
		}
	}
	if (x[1] != x[2]) {
		cout << 0;
		return 0;
	}
	long long res = 1;
	res = (res * binpow(f(1, x[1]), 2)) % Mod;
	res = (res * f(x[1] + 1, x[1] + x[0])) % Mod;
	res = (res * f(x[1], x[1] + x[3] - 1)) % Mod;
	cout << res;
	return 0;
}
