#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

const int MOD = 1e9 + 7;

struct pos{
    int a, b, c, d, cur;

    pos() = default;
    pos(int a, int b, int c, int d, int cur) : a(a), b(b), c(c), d(d), cur(cur) {}
    bool operator < (const pos &x) const {
        return tie(a, b, c, d, cur) < tie(x.a, x.b, x.c, x.d, x.cur);
    }
};

map<pos, int> dp;

int A, B, C, D;

long long solve(const pos &p) {
    if (p.a > A || p.b > B || p.c > C || p.d > D) {
        return 0;
    }
    if (dp.find(p) != dp.end()) {
        return dp[p];
    }
    if (p.cur == 0) {
        dp[p] = (solve({p.a + 1, p.b, p.c, p.d, 0}) * (p.a + 1) + solve({p.a, p.b + 1, p.c, p.d, 1}) * (p.b + 1)) % MOD;
    } else if (p.cur == 1) {
        dp[p] = (solve({p.a, p.b, p.c + 1, p.d, 2}) * (p.c + 1) + solve({p.a, p.b, p.c, p.d + 1, 3}) * (p.d + 1)) % MOD;
    } else if (p.cur == 2) {
        dp[p] = (solve({p.a + 1, p.b, p.c, p.d, 0}) * (p.a + 1) + solve({p.a, p.b + 1, p.c, p.d, 1}) * (p.b + 1)) % MOD;
    } else {
        dp[p] = (solve({p.a, p.b, p.c + 1, p.d, 2}) * (p.c + 1) + solve({p.a, p.b, p.c, p.d + 1, 3}) * (p.d + 1)) % MOD;
    }
    return dp[p];
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string a, b, c;
    cin >> a >> b >> c;
    for (int i = 0; i < a.size(); i++) {
        if (a[i] - '0' + b[i] - '0' >= 10) {
            if (a[i] - '0' + b[i] - '0' - 10 == c[i] - '0') {
                B++;
            } else if (a[i] - '0' + b[i] - '0' - 10 == c[i] - '0' - 1) {
                D++;
            } else {
                cout << 0;
                return 0;
            }
        } else {
            if (a[i] - '0' + b[i] - '0' == c[i] - '0') {
                A++;
            } else if (a[i] - '0' + b[i] - '0' == c[i] - '0' - 1) {
                C++;
            } else {
                //cout << "LOL " << a[i] - '0' + b[i] - '0' << ' ' << c[i] - '0' - 1 << '\n';
                cout << 0;
                return 0;
            }
        }
    }
    dp[{A, B, C, D, 0}] = 1;
    dp[{A, B, C, D, 2}] = 1;
    cout << (solve({0, 0, 0, 0, 0}) + solve({0, 0, 0, 0, 1})) % MOD << '\n';
    return 0;
}
