#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

const int MOD = 1e9 + 7;

struct pos{
    int a, b, c, d, cur;

    pos() = default;
    pos(int a, int b, int c, int d, int cur) : a(a), b(b), c(c), d(d), cur(cur) {}
    bool operator < (const pos &x) const {
        return tie(a, b, c, d, cur) < tie(x.a, x.b, x.c, x.d, x.cur);
    }
};

map<pos, int> dp;

int A, B, C, D;

long long solve(const pos &p) {
    if (p.a < 0 || p.b < 0 || p.c < 0 || p.d < 0) {
        return 0;
    }
    if (dp.find(p) != dp.end()) {
        return dp[p];
    }
    if (p.cur == 0) {
        dp[p] = (solve({p.a - 1, p.b, p.c, p.d, 0}) * p.a + solve({p.a - 1, p.b, p.c, p.d, 1}) * p.a) % MOD;
    } else if (p.cur == 1) {
        dp[p] = (solve({p.a, p.b - 1, p.c, p.d, 2}) * p.b + solve({p.a, p.b - 1, p.c, p.d, 3}) * p.b) % MOD;
    } else if (p.cur == 2) {
        dp[p] = (solve({p.a, p.b, p.c - 1, p.d, 0}) * p.c + solve({p.a, p.b, p.c - 1, p.d, 1}) * p.c) % MOD;
    } else {
        dp[p] = (solve({p.a, p.b, p.c, p.d - 1, 2}) * p.d + solve({p.a, p.b, p.c, p.d - 1, 3}) * p.d) % MOD;
    }
    return dp[p];
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string a, b, c;
    cin >> a >> b >> c;
    if (a.size() < 6) {
        vector<int> p(a.size());
        int x = 0, y = 0, z = 0;
        iota(p.begin(), p.end(), 0);
        int ans = 0;
        do {
            for (auto &i : p) {
                x = x * 10 + a[i] - '0';
                y = y * 10 + b[i] - '0';
                z = z * 10 + c[i] - '0';
            }
            if (x + y == z && to_string(z).size() == c.size()) {
                ans++;
            }
            x = y = z = 0;
        } while (next_permutation(p.begin(), p.end()));
        cout << ans << '\n';
        return 0;
    }
    for (int i = 0; i < a.size(); i++) {
        if (a[i] - '0' + b[i] - '0' >= 10) {
            if (a[i] - '0' + b[i] - '0' - 10 == c[i] - '0') {
                B++;
            } else if (a[i] - '0' + b[i] - '0' - 10 == c[i] - '0' - 1) {
                D++;
            } else {
                cout << 0;
                return 0;
            }
        } else {
            if (a[i] - '0' + b[i] - '0' == c[i] - '0') {
                A++;
            } else if (a[i] - '0' + b[i] - '0' == c[i] - '0' - 1) {
                C++;
            } else {
                //cout << "LOL " << a[i] - '0' + b[i] - '0' << ' ' << c[i] - '0' - 1 << '\n';
                cout << 0;
                return 0;
            }
        }
    }
    //cout << A << ' ' << B << ' ' << C << ' ' << D << '\n';
    dp[{0, 0, 0, 0, 0}] = 1;
    for (int i = 0; i <= 1; i++) {
        for (int j = 0; j <= 2; j++) {
            for (int k = 0; k <= 2; k++) {
                for (int c = 0; c < 4; c++) {
                 //   cout << i << ' ' << j << ' ' << k << ' ' << 0 << ' ' << c << ' ' << solve({i, j, k, 0, c}) << '\n';
                }
            }
        }
    }
    cout << (solve({A, B, C, D, 0}) + solve({A, B, C, D, 1})) % MOD << '\n';
    return 0;
}
