#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

map<int, bool> good;
vector<int> goods;

int sz(int x) {
    int res = 0;
    while (x > 0) {
        res++;
        x /= 10;
    }
    return res;
}

int get(int x) {
    if (x == 0) return 0;
    if (x == 1) return 1;
    return (int)  + 1;
}

int get(pair<int, int> x) {
    return get(x.first) + get(x.second);
}

pair<int, int> getlens(int x) {
    pair<int, int> res = {x / 2, x - x / 2};
    for (int i = 0; i < (int) goods.size(); ++i) {
        if (goods[i] <= x) {
            pair<int, int> prob = {goods[i], x - goods[i]};
            if (get(res) < get(prob)) {
                res = prob;
            }
        } else {
            break;
        }
    }
    return res;
}

void solve() {
    int x = 1;
    for (int i = 0; i < 11; ++i) {
        x *= 10LL;
        good[x] = true;
        goods.push_back(x);
    }
    string s;
    cin >> s;
    vector<pair<int, char> > v;
    vector<int> lens;
    int nowlen = 0;
    for (int i = 0; i < (int) s.size(); ++i) {
        if (s[i] >= 'A' && s[i] <= 'Z') {
            if (nowlen == 0) {
                lens.push_back(1);
                v.push_back(make_pair(1, s[i]));
            } else {
                lens.push_back(sz(nowlen) + 1);
                v.push_back(make_pair(nowlen, s[i]));
            }
            nowlen = 0;
        } else {
            nowlen = nowlen * 10 + s[i] - '0';
        }
    }
    /*for (auto i : v) {
        cout << i.first << ' ' << i.second << '\n';
    }
    for (auto i : lens) {
        cout << i << ' ';
    } cout << '\n';*/
    {
        // minimum
        int maxdelta = -1;
        int index = 0;
        int curind = 0;
        for (int i = 0; i < (int) v.size(); ++i) {
            int delta = 0;
            if (i == 0 || i == (int) v.size() - 1) {
                int newnum = v[i].first - 1;
                if (newnum == 0) {
                    delta = 1;
                } else {
                    if (good[v[i].first]) {
                        delta = 1;
                    }
                }
            } else {
                int newnum = v[i].first - 1;
                if (newnum == 0) {
                    delta += 1;
                    if (v[i - 1].second == v[i + 1].second) {
                        int x = (int) sz(v[i - 1].first + v[i + 1].first) + 1;
                        delta += lens[i - 1] + lens[i + 1] - x;
                    }
                } else {
                    if (good[v[i].first]) {
                        delta = 1;
                    }
                }
            }
            if (delta > maxdelta) {
                maxdelta = delta;
                index = curind;
            }
            curind += v[i].first;
        }
        cout << 2 << ' ' << index + 1 << '\n';
    }
    {
        // maximum
        int maxdelta = -1;
        int index = 0;
        char ans = '-';
        int curindex = 0;
        for (int i = 0; i < (int) v.size(); ++i) {
            int x = v[i].first;

            pair<int, int> lx = getlens(x);
            int x1 = lx.first, x2 = lx.second;
            int l1 = get(x1), l2 = get(x2);

            set<char> st;
            st.insert('A');
            st.insert('G');
            st.insert('C');
            st.insert('T');
            for (int j = max(0LL, i - 1); j <= min((int) v.size() - 1, i + 1); ++j) {
                st.erase(v[j].second);
            }
            char prob = *st.begin();
            int delta = 1 + l1 + l2 - lens[i];
            if (delta > maxdelta) {
                maxdelta = delta;
                ans = prob;
                index = curindex + x1;
            }
            curindex += v[i].first;
        }
        cout << 1 << ' ' << index << ' ' << ans << '\n';
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}