#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

/*const int MM = 2e8;
char mem[MM];
int mpos = 0;

inline void * operator new (size_t n) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos < MM);
    return (void*) res;
}

inline void operator delete (void *) {}*/

#define int long long
#define ll long losng
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

int x;
vector<int> s;
vector<int> ans;
int answer = 1e18;

int vtoi(const vector<int> &v) {
    int local = 0;
    for (auto i : v) {
        local *= 10;
        local += i;
    }
    return local;
}


bool dfs(int d, int a, int b, bool is_equal = true) {
    if (d == (int) s.size()) return true;
    if (is_equal) {
        if (a == s[d]) {
            ans.push_back(a);
            if (dfs(d + 1, a, b, is_equal)) return true;
            ans.pop_back();
        } else {
            if (a > s[d]) {
                ans.push_back(a);
                if (dfs(d + 1, a, b, false)) return true;
                ans.pop_back();
            }
        }
        if (b == s[d]) {
            ans.push_back(b);
            if (dfs(d + 1, a, b, is_equal)) return true;
            ans.pop_back();
        } else {
            if (b > s[d]) {
                ans.push_back(b);
                if (dfs(d + 1, a, b, false)) return true;
                ans.pop_back();
            }
        }
    } else {
        ans.push_back(a);
        if (dfs(d + 1, a, b, false)) return true;
        ans.pop_back();
        ans.push_back(b);
        if (dfs(d + 1, a, b, false)) return true;
        ans.pop_back();
    }
    return false;
}

void go(int a, int b) {
    ans.clear();
    if (a == 0 && b == 0) return;
    if (a > b) swap(a, b);
    if (a < s[0] && b < s[0]) return;
    if (dfs(0, a, b, true)) {
        int xx = vtoi(ans);
        answer = min(answer, xx);
    }
}

void solve() {
    cin >> x;
    string ss = to_string(x);
    s.clear();
    for (auto c : ss) {
        s.push_back(c - '0');
    }
    int k;
    cin >> k;
    if (k == 1) {
        for (int a = 0; a < 10; ++a) {
            vector<int> vec(s.size(), a);
            for (int b = 0; b < 10; ++b) {
                for (int i = 0; i < (int) vec.size(); ++i) {
                    vec[i] = b;
                    int xx = vtoi(vec);
                    if (xx >= x) {
                        answer = min(answer, xx);
                    }
                    vec[i] = a;
                }
            }
        }
        cout << answer;
    } else {
        for (int a = 0; a < 10; ++a) {
            vector<int> vec(s.size(), a);
            int xx = vtoi(vec);
            if (xx >= x) {
                answer = min(answer, xx);
            }
        }
        cout << answer;
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}