#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

/*const int MM = 2e8;
char mem[MM];
int mpos = 0;

inline void * operator new (size_t n) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos < MM);
    return (void*) res;
}

inline void operator delete (void *) {}*/

#define int long long
#define ll long losng
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

struct col {
    int a, b, c;
    int typ = 0;
    col() {}
    col(int _a, int _b, int _c) : a(_a), b(_b), c(_c) {
        if (a + b == c) {
            typ = 0;
        } else {
            if ((a + b) % 10 == c) {
                typ = 1;
            } else {
                if (a + b + 1 == c) {
                    typ = 2;
                } else {
                    if ((a + b + 1) % 10 == c) {
                        typ = 3;
                    }
                }
            }
        }
    }
};

void solve() {
    string a, b, c;
    cin >> a >> b >> c;
    int n = (int) a.size();
    vector<col> cols(n);
    for (int i = 0; i < n; ++i) {
        cols[i] = col(a[i] - '0', b[i] - '0', c[i] - '0');
    }
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    int ans = 0;
    do {
        if (cols[p[0]].a == 0 || cols[p[0]].b == 0 || cols[p[0]].c == 0) {
            continue;
        }
        int tadd = 0;
        bool ok = true;
        for (int i = n - 1; i >= 0; --i) {
            if ( (tadd + cols[p[i]].a + cols[p[i]].b) % 10 == cols[p[i]].c ) {
                tadd = (tadd + cols[p[i]].a + cols[p[i]].b) / 10;
            } else {
                ok = false;
                break;
            }
        }
        if (ok && (tadd == 0)) {
            ans++;
        }
    } while (next_permutation(all(p)));
    cout << ans << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}