#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define eb emplace_back
#define mp make_pair
#define pb push_back
#define qpr(x) x.first, x.second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//#pragma GCC optimize(3)
//#pragma GCC target("sse,sse2,sse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")

        long long N, M;
long long pref_vert(long long k)
{
    long long S = (k*(k-1))/2;
    long long Q = (N*(N-1))/2;
    return N*S + Q*(k-1)*M;
}

int main()
{ /// 5e8 op/s!!!
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long t;
    cin >> t;

    for (int i = 0; i < t; ++i) {
        cin >> N >> M;

        //  
        long long maxnum = N*M;
        long long sum = (maxnum * (maxnum+1)) / 2;

        long long best_dist = 1ll<<60;
        long long cut = 0; // cut>0 : H; cut < 0 : V;

        //   --    !!!!
        if (M != 1)
        {
            /*long long prefsum = 0;
            long long base = ((N-1)*M * N)/2;
            for (long long j = 1; j < M; ++j)
            {
                long long curnum = -j;
                base += N;
                prefsum += base;

                long long dist = abs(sum - (2 * prefsum));
                if (best_dist > dist)
                {
                    best_dist = dist;
                    cut = curnum;
                }
            }*/
            long long le = 1, ri = M;
            while (ri - le > 2)
            {
                long long m1 = le + (ri - le)/3;
                long long m2 = ri - (ri - le)/3;
                long long pref_sum1 = pref_vert(m1);
                long long pref_sum2 = pref_vert(m2);
                long long di1 = abs(sum - pref_sum1*2);
                long long di2 = abs(sum - pref_sum2*2);
                if (di1 > di2) le = m1;
                else ri = m2;
            }
            if (le != ri)
            {
                long long p1 = abs(sum - (pref_vert(le))*2);
                long long p2 = abs(sum - (pref_vert((le+1)))*2);
                long long p3 = abs(sum - (pref_vert(ri))*2);

                if (p1<p2)
                {
                    if (p1<p3) cut=-le, best_dist = p1;
                    else cut=-ri, best_dist = p3;
                }
                else
                {
                    if (p2<p3) cut=-le-1, best_dist = p2;
                    else cut=-ri, best_dist = p3;
                }
            }
        }

        //  
        if (N != 1)
        {
            /*long long prefsum = 0;
            long long base = ((-M+1) * M)/2;
            long long M2 = M * M;
            for (long long  j= 1;j < N; ++j)
            {
                long long curnum = j;
                base += M2;
                prefsum += base;

                long long dist = abs(sum - (2 * prefsum));
                if (best_dist > dist)
                {
                    best_dist = dist;
                    cut = curnum;
                }
            }*/
            long long le = 1, ri = N;
            while (ri - le > 2)
            {
                long long m1 = le + (ri - le)/3;
                long long m2 = ri - (ri - le)/3;
                long long pref_sum1 = pref_xor(m1);
                long long pref_sum2 = pref_xor(m2);
                long long di1 = abs(sum - pref_sum1*2);
                long long di2 = abs(sum - pref_sum2*2);
                if (di1 > di2) le = m1;
                else ri = m2;
            }
            if (le != ri)
            {
                long long p1 = abs(sum - (pref_xor(le))*2);
                long long p2 = abs(sum - (pref_xor((le+1)))*2);
                long long p3 = abs(sum - (pref_xor(ri))*2);

                if (p1<p2)
                {
                    if (p1<p3) cut=le, best_dist = p1;
                    else cut=ri, best_dist = p3;
                }
                else
                {
                    if (p2<p3) cut=le+1, best_dist = p2;
                    else cut=ri, best_dist = p3;
                }
            }
        }

        if (cut == 0)
        {
            cout << "This should never be possible!!!";
            return 42;
        } else if (cut > 0) {
            cout << "H " << cut+1 << endl;
        } else {
            cout<< "V " <<-cut << endl;
        }
    }

    return 0;
}
