#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define eb emplace_back
#define mp make_pair
#define pb push_back
#define qpr(x) x.first, x.second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//#pragma GCC optimize(3)
//#pragma GCC target("sse,sse2,sse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")

char code2char(int code)
{
    if (code==0) return 'A';
    if (code==1) return 'G';
    if (code==2) return 'C';
    if (code==3) return 'T';
}
int width10(int x)
{
    int c = 0;
    while(x>0){
        ++c, x/=10;
    }
    return c;
}

int applyop(string str, int code, int pos, int ch)
{
    ch = code2char(ch);
    // RLE length -- Prepare string
    if (code == 1) // insert after pos
        str.insert(str.begin()+pos, ch);
    else if (code==2) // delete pos
        str.erase(str.begin()+pos);
    else if(str[pos] ==ch) return -1;
    else str[pos] = ch;

    // RLE length -- compute answer...
    int len = 0;
    int tmp = 0;
    char chr = '-';
    for (auto c : str)
    {
        if (c==chr) ++tmp;
        else len += 1+(tmp!=0?width10(tmp):0), chr=c, tmp=0;
    }
    return len;
}

int main()
{ /// 5e8 op/s!!!
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;

    string res;
    int tmp=0;
    for (auto ch : s)
    {
        if (ch>='0' && ch<='9')
        {
            tmp = tmp*10+(ch-'0');
        }
        else if(tmp == 0)
            res += ch;
        else
        {
            while(tmp > 0)
            {
                --tmp;
                res += ch;
            }
        }
    }

    pair<int, pair<int, int>> maxop, minop;
    int maxsize = 0;
    int minsize = INT_MAX;

    for (int code = 1; code < 4; ++code)
    {
        for (int pos = 0; pos < res.size(); ++pos)
        {
            for (int ch = 0; ch < 4; ++ch)
            {
                int tttsize = applyop(res, code, pos, ch);
                if (tttsize == -1) continue;
                if (tttsize > maxsize)
                    maxsize = tttsize, maxop = mp(code, mp(pos, ch));
                if (tttsize < minsize)
                    minsize = tttsize, minop = mp(code, mp(pos, ch));
            }
        }
    }
    for (int ch = 0; ch < 4; ++ch)
    {
        int tttsize = applyop(res, 1, res.size(), ch);
        if (tttsize > maxsize)
            maxsize = tttsize, maxop = mp(1, mp(res.size(), ch));
        if (tttsize < minsize)
            minsize = tttsize, minop = mp(1, mp(res.size(), ch));
    }

    if(minop.first!=2)
    cout << minop.first << " " << minop.second.first+(minop.first!=1) << " " << code2char(minop.second.second) << endl;
    else cout << minop.first << " " << minop.second.first+(minop.first!=1) << endl;
    if (maxop.first!=2)
    cout << maxop.first << " " << maxop.second.first+(maxop.first!=1) << " " << code2char(maxop.second.second) << endl;
    else cout << maxop.first << " " << maxop.second.first+(maxop.first!=1) << endl;

    return 0;
}
