#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ll long long
#define lll __int128_t
#define vi vector<ll>
#define pii pair<ll, ll>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define mp make_pair

const ll INF = 1e9;
const ll inf = 1e18;

using namespace std;

void solve() {
    int n; cin >> n;
    vector<pii> edges(n);
    set<int> segs;
    for (int i = 0; i < n; ++i) {
        int m, s; cin >> m >> s;
        vi p(m); for (int i = 0; i < m; ++i) cin >> p[i];
        for (int j = 0; j < m; ++j) {
            if (j) segs.insert(p[j] - p[j - 1]);
            if (!j) edges[i].first = p[j];
            if (j == m - 1) edges[i].second = s - p[j];
        }
    }
    if (segs.size() > 1) {
        cout << "No\n";
        return;
    }
    if (n == 1) {
        cout << "Yes\n";
        cout << "1\n";
        return;
    }
    if (segs.size()) {
        map<int, vi> st;
        map<int, vi> en;
        vi r;
        for (int i = 0; i < n; ++i) {
            st[edges[i].first].push_back(i);
            en[edges[i].second].push_back(i);
        }
        set<int> used;
        int val = *segs.begin();
        used.insert(0);
        int last = 0;
        for (int i = 0; i < n; ++i) {
            if (st.find(val - edges[last].second) == st.end()) break;
            bool f = 0;
            while(st[val - edges[last].second].size()) {
                int j = st[val - edges[last].second].back();
                if (used.find(j) != used.end()) {
                    st[val - edges[last].second].pop_back();
                    continue;
                }
                used.insert(j);
                last = j;
                f = 1;
                r.push_back(j);
                break;
            }
            if (!f) break;
        }
        vi l;
        last = 0;
        for (int i = 0; i < n - 1; ++i) {
            if (en.find(val - edges[last].first) == en.end()) break;
            bool f = 0;
            while(en[val - edges[last].first].size()) {
                int j = en[val - edges[last].first].back();
                if (used.find(j) != used.end()) {
                    en[val - edges[last].first].pop_back();
                    continue;
                }
                used.insert(j);
                last = j;
                l.push_back(j);
                f = 1;
                break;
            }
            if (!f) break;
        }
        if (used.size() == n) {
            cout << "Yes\n";
            reverse(all(l));
            for (int i : l) cout << i + 1 << " ";
            cout << "1 ";
            for (int i : r) cout << i + 1 << " ";
            return;
        }
        st.clear();
        en.clear();
        r.clear();
        for (int h = 0; h < n; ++h) {
            st[edges[h].first].push_back(h);
            en[edges[h].second].push_back(h);
        }
        used.clear();
        used.insert(1);
        int last = 1;
        for (int h = 0; h < n; ++h) {
            if (st.find(val - edges[last].second) == st.end()) break;
            bool f = 0;
            while(st[val - edges[last].second].size()) {
                int j = st[val - edges[last].second].back();
                if (used.find(j) != used.end()) {
                    st[val - edges[last].second].pop_back();
                    continue;
                }
                used.insert(j);
                last = j;
                f = 1;
                r.push_back(j);
                break;
            }
            if (!f) break;
        }
        l.clear();
        last = 1;
        for (int h = 0; h < n; ++h) {
            if (en.find(val - edges[last].first) == en.end()) break;
            bool f = 0;
            while(en[val - edges[last].first].size()) {
                int j = en[val - edges[last].first].back();
                if (used.find(j) != used.end()) {
                    en[val - edges[last].first].pop_back();
                    continue;
                }
                used.insert(j);
                last = j;
                l.push_back(j);
                f = 1;
                break;
            }
            if (!f) break;
        }
        reverse(all(l));
        if (used.size() == n) {
            cout << "Yes\n";
            for (int i : l) cout << i + 1 << " ";
            cout << "2 ";
            for (int i : r) cout << i + 1 << " ";
            return;
        }
    } else {
        for (int i = 1; i < n; ++i) {
            map<int, vi> st;
            map<int, vi> en;
            vi r;
            r.push_back(i);
            for (int h = 0; h < n; ++h) {
                st[edges[h].first].push_back(h);
                en[edges[h].second].push_back(h);
            }
            set<int> used;
            int val = edges[i].first + edges[0].second;
            used.insert(i);
            used.insert(0);
            int last = i;
            for (int h = 0; h < n; ++h) {
                if (st.find(val - edges[last].second) == st.end()) break;
                bool f = 0;
                while(st[val - edges[last].second].size()) {
                    int j = st[val - edges[last].second].back();
                    if (used.find(j) != used.end()) {
                        st[val - edges[last].second].pop_back();
                        continue;
                    }
                    used.insert(j);
                    last = j;
                    f = 1;
                    r.push_back(j);
                    break;
                }
                if (!f) break;
            }
            vi l;
            last = 0;
            for (int h = 0; h < n; ++h) {
                if (en.find(val - edges[last].first) == en.end()) break;
                bool f = 0;
                while(en[val - edges[last].first].size()) {
                    int j = en[val - edges[last].first].back();
                    if (used.find(j) != used.end()) {
                        en[val - edges[last].first].pop_back();
                        continue;
                    }
                    used.insert(j);
                    last = j;
                    l.push_back(j);
                    f = 1;
                    break;
                }
                if (!f) break;
            }
            if (used.size() == n) {
                cout << "Yes\n";
                reverse(all(l));
                for (int i : l) cout << i + 1 << " ";
                cout << "1 ";
                for (int i : r) cout << i + 1 << " ";
                return;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (i == 1) continue;
            map<int, vi> st;
            map<int, vi> en;
            vi r;
            r.push_back(i);
            for (int h = 0; h < n; ++h) {
                st[edges[h].first].push_back(h);
                en[edges[h].second].push_back(h);
            }
            set<int> used;
            int val = edges[i].first + edges[1].second;
            used.insert(i);
            used.insert(1);
            int last = i;
            for (int h = 0; h < n; ++h) {
                if (st.find(val - edges[last].second) == st.end()) break;
                bool f = 0;
                while(st[val - edges[last].second].size()) {
                    int j = st[val - edges[last].second].back();
                    if (used.find(j) != used.end()) {
                        st[val - edges[last].second].pop_back();
                        continue;
                    }
                    used.insert(j);
                    last = j;
                    f = 1;
                    r.push_back(j);
                    break;
                }
                if (!f) break;
            }
            vi l;
            last = 1;
            for (int h = 0; h < n; ++h) {
                if (en.find(val - edges[last].first) == en.end()) break;
                bool f = 0;
                while(en[val - edges[last].first].size()) {
                    int j = en[val - edges[last].first].back();
                    if (used.find(j) != used.end()) {
                        en[val - edges[last].first].pop_back();
                        continue;
                    }
                    used.insert(j);
                    last = j;
                    l.push_back(j);
                    f = 1;
                    break;
                }
                if (!f) break;
            }
            reverse(all(l));
            if (used.size() == n) {
                cout << "Yes\n";
                for (int i : l) cout << i + 1 << " ";
                cout << "2 ";
                for (int i : r) cout << i + 1 << " ";
                return;
            }
        }
    }
    cout << "No\n";
}

int main() {
    srand(time(0));

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
//    ll t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
