#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ll long long
#define lll __int128_t
#define vi vector<ll>
#define pii pair<ll, ll>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define mp make_pair

const ll INF = 1e9;
const ll inf = 1e18;

using namespace std;

void solve() {
    int n; cin >> n;
    vector<pii> edges(n);
    set<int> segs;
    for (int i = 0; i < n; ++i) {
        int m, s; cin >> m >> s;
        vi p(m); for (int i = 0; i < m; ++i) cin >> p[i];
        for (int j = 0; j < m; ++j) {
            if (j) segs.insert(p[j] - p[j - 1]);
            if (!j) edges[i].first = p[j];
            if (j == m - 1) edges[i].second = s - p[j];
        }
    }
    if (segs.size() > 1) {
        cout << "No\n";
        return;
    }
    if (n == 1) {
        cout << "Yes\n";
        cout << "1\n";
        return;
    }
    vi a(n); for (int i = 0; i < n; ++i) a[i] = i;
    do{
        bool ok = 1;
        int val = -1;
        if (segs.size()) val = *segs.begin();
        for (int i = 1; i < n; ++i) {
            if (val == -1) val = edges[a[i]].first + edges[a[i - 1]].second;
            else if (val != edges[a[i]].first + edges[a[i - 1]].second) {
                ok = 0; break;
            }
        }
        if (ok) {
            cout << "YES\n";
            for (int i = 0; i < n; ++i) {
                cout << a[i] + 1 << " ";
            }
            return;
        }
    } while(next_permutation(all(a)));
    cout << "NO\n";
}

int main() {
    srand(time(0));

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
//    ll t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
