#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ll long long
#define lll __int128_t
#define vi vector<ll>
#define pii pair<ll, ll>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define mp make_pair

const ll INF = 1e9;
const ll inf = 2e18;

using namespace std;

int matr[10][10];
int n, m, c;

bool find_color(int i = 0, int j = 0) {
    if (i == n) return 1;
    int ban[3];
    for (int k = 0; k < 3; ++k) ban[k] = 0;
    for (int x = 0; x < i; ++x) {
        for (int y = 0; y < j; ++y) {
            if (matr[x][y] == matr[x][j] && matr[x][j] == matr[i][y]) ban[matr[x][y]] = 1;
        }
    }
    int in = i + (j + 1) / m;
    int jn = (j + 1) % m;
    for (int k = 0; k < c; ++k) {
        if (!ban[k]) {
            matr[i][j] = k;
            if (find_color(in, jn)) return 1;
            matr[i][j] = -1;
        }
    }
    return 0;
}

void solve() {
    cin >> n >> m >> c;
    bool sw = 0;
    if (n < m) swap(n, m), sw = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            matr[i][j] = -1;
        }
    }
    find_color();
    if (sw) {
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                cout << matr[i][j] + 1 << " ";
            }
            cout << "\n";
        }
    } else {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << matr[i][j] + 1 << " ";
            }
            cout << "\n";
        }
    }
}

int main() {
    srand(time(0));

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
//    ll t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
