//#pragma ("Ofast", "fast-math")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ll long long
#define lll __int128_t
#define vi vector<ll>
#define pii pair<ll, ll>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define mp make_pair

const ll INF = 1e9;
const ll inf = 2e18;

using namespace std;

int matr[10][10];
int fin[10][10][3];
int n, m, c;
vi clr;
bool h = 0;

bool find_color(int i = 0, int j = 0) {
    if (i == 10) return 1;
    int in, jn;
    if (!h) {
        if (j == 4 && i == 9) in = 0, jn = 5, h = 1;
        else if (j == 4) in = i + 1, jn = 0;
        else in = i, jn = j + 1;
    } else {
        if (j == 9) in = i + 1, jn = 5;
        else in = i, jn = j + 1;
    }
    random_shuffle(all(clr));
    for (int k : clr) {
        bool ok = 1;
        for (int y = 0; y < j && ok; ++y) {
            if (matr[i][y] == k && fin[y][j][k]) ok = 0;
        }
        if (ok) {
            for (int y = 0; y < j; ++y) fin[y][j][k] += matr[i][y] == k;
            matr[i][j] = k;
            if (find_color(in, jn)) return 1;
            matr[i][j] = -1;
            for (int y = 0; y < j; ++y) fin[y][j][k] -= matr[i][y] == k;
        }
    }
    return 0;
}

void solve() {
    cin >> c;
    for (int i = 0; i < c; ++i) clr.push_back(i);
    bool sw = 0;
    if (n < m) swap(n, m), sw = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            matr[i][j] = -1;
        }
    }
    find_color();
    if (sw) {
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                cout << (matr[i][j]) + 1 << " ";
            }
            cout << "\n";
        }
    } else {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << (matr[i][j]) + 1 << " ";
            }
            cout << "\n";
        }
    }
}

int main() {
    srand(time(0));

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
//    ll t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
