#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <map>


using namespace std;


long long f(long long n, long long m, long long mid1, long long s){
    return abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (mid1 - 1) + (((mid1 - 1) * mid1) / 2) * n));
}

long long F(long long n, long long m, long long mid1){
    return abs(((n * m + 1) * (n * m)) / 2 - (m * mid1 - m + 1) * (m * mid1 - m));
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    long long t;
    cin >> t;
    for (long long i = 0; i < t; ++i) {
        long long n, m;
        cin >> n >> m;
        long long s = 0;
        for (long long j = 1; j < n; ++j) {
            s += m * j;
        }
        long long l = 1, r = m + 1;
        long long ans, ind;
        while (r - l > 2){
            long long mid1 = l + (r - l) / 3, mid2 = r - (r - l) / 3;
            long long f1 = f(n, m, mid1, s);
            long long f2 = f(n, m, mid2, s);
            if (f1 < f2) {
                r = mid2;
            }
            else {
                l = mid1;
            }
        }
        if (r - l == 2 && f(n, m, l + 1, s) < f(n, m, r, s)) r = l + 1;
        ind = r;
        if (f(n, m, l, s) < f(n, m, r, s)) ind = l;
        ans = f(n, m, ind, s);
        long long ans1, ind1;
        l = 1, r = n + 1;
        while (r - l > 2){
            long long mid1 = l + (r - l) / 3, mid2 = r - (r - l) / 3;
            long long f1 = F(n, m, mid1);
            long long f2 = F(n, m, mid2);
            if (f1 < f2) {
                r = mid2;
            }
            else {
                l = mid1;
            }
        }
        if (r - l == 2 && F(n, m, l + 1) < F(n, m, r)) r = l + 1;
        ind1 = r;
        if (F(n, m, l) < F(n, m, r)) ind1 = l;
        ans1 = F(n, m, ind1);
        if (ans > ans1) cout << "H" << " " << ind1 << endl;
        else cout << "V" << " " << ind << endl;
    }
}
