#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <ciso646>
#include <climits>
#include <cmath>
using namespace std;
const long long inf = LLONG_MAX;
const long long mod = 1e9 + 7;
#define pb push_back
#define mp make_pair
using ll = long long;
#define int long
#define int long long
void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
ll n, m;
ll get_sum (ll a) {
    return (a * (a + 1)) / 2;
}
ll get_v (ll i) {
    ll sum = 1e18;
    if (i >= 1 && i <= m) {
            ll sumi = get_sum(n * m);
            ll h = abs(i * (get_sum(n - 1)) * m) + abs(n * abs(get_sum(i)));
            //cout << sum << endl;
            sum = abs(sumi - 2 * h);
    }
    return sum;
}
ll get_h (ll i) {
    ll sum = inf;
    if (i >= 1 && i <= n) {
            ll sumi = get_sum(n * m);
            ll h = abs(get_sum(i * m));
            //cout << sum << endl;
            sum = abs(sumi - 2 * h);
    }
    return sum;
}

void solve () {
    cin >> n >> m;
    ll min_ans = get_sum(n * m);
    ll ans2 = 1;
    char ansi = 'V';
    ll l = 0, r = m, mid1, mid2;
    while (r - l > 2) {
        mid1 = (2 * l + r) / 3;
        mid2 = (2 * r + l) / 3;
        ll a1 = get_v(mid1), a2 = get_v(mid2);
        if (a1 >= a2) {
            l = mid1;
        } else {
            r = mid2;
         }
         //cout << r << endl;
    }
    //cout << l << " " << r << endl;
    for (int i = l; i <= r; i++) {
        ll k = get_v(i);
        if (i > 0 && i + 1 <= m && k < min_ans) {
            min_ans = k;
            ansi = 'V';
            ans2 = i + 1;
        }
        //cout << min_ans << " " << i << endl;
    }
    //cout << min_ans << endl;
    l = 0; r = n, mid1, mid2;
    while (r - l > 2) {
        mid1 = (2 * l + r) / 3;
        mid2 = (l + 2 * r) / 3;
        ll a1 = get_h(mid1), a2 = get_h(mid2);
        if (a1 >= a2) {
            l = mid1;
        } else {
            r = mid2;
        }
    }

    for (int i = l; i <= r; i++) {
        ll w = get_h(i);
        if (i > 0 && i + 1 <= n && w < min_ans) {
            min_ans = w;
            ansi = 'H';
            ans2 = i + 1;
        }
    }
    cout << ansi << " " << ans2 << endl;
}


signed main() {
    fast_stream();
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

