#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define int long long

// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune=native")
// #pragma GCC optimaze("O3")

int mod = 1e9 + 7;


int mul(int a, int b) {
    return (a * b) % mod;
}

int pw(int a, int k) {
    if (k == 0) return 1;
    if (k % 2) return mul(pw(a, k - 1), a);
    return pw(mul(a, a), k / 2);
}


int rv(int a) {
    return pw(a, mod - 2);
}

int maxn = 4e5 + 5;

vector<int> f(maxn);

void init() {
    f[0] = 1;
    for (int i = 1; i < maxn; i++) {
        f[i] = mul(f[i - 1], i);
    }
    return;
}

int c(int a, int b) {
    if (a == -1) return 1;
    return mul(mul(f[a], rv(f[b])), rv(f[a - b]));
}

int gt(int n00, int n01, int n10, int n11) {
    int x = mul(f[n10], f[n10]);
    int ans = mul(mul(f[n00], c(n00 + n01, n00)), mul(f[n11], c(n11 + n01 - 1, n11)));
    ans = mul(ans, x);
    return ans;
}

int gt1(int n00, int n01, int n10, int n11) {
    int x = mul(f[n10 - 1], f[n10]);
    int ans = mul(mul(f[n00], c(n00 + n01 - 1, n00)), mul(f[n11], c(n11 + n01 - 1, n11)));
    ans = mul(ans, x);
    return ans;
}


int32_t main()
{
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    int n00 = 0, n01 = 0, n10 = 0, n11 = 0;
    for (int i = 0; i < n; i++) {
        int a = s1[i] - '0';
        int b = s2[i] - '0';
        int c = s3[i] - '0';
        // if (a * b * c == 0) assert(0);
        if (a + b == c) {
            n00++;
            continue;
        }
        if (a + b == c - 1) {
            n01++;
            continue;
        }
        if (a + b == c + 10) {
            n10++;
            continue;
        }
        if (a + b == c + 9) {
            n11++;
            continue;
        }
        cout << "0" << endl;
        return 0;
    }
    init();
    if (n01 != n10) {
        cout << "0" << endl;
        return 0;
    }
    if (n10 == 0 && n11 != 0) {
        cout << 0 << endl;
        return 0;
    }
    int ans = gt(n00, n01, n10, n11);
    for (int i = 0; i < n; i++) {
        int a = s1[i] - '0';
        int b = s2[i] - '0';
        int c = s3[i] - '0';
        if (a * b * c != 0) continue;
        if (a + b == c + 10) {
            continue;
        }
        if (a + b == c + 9) {
            continue;
        }


        if (a + b == c) {
            ans -= gt(n00 - 1, n01, n10, n11);
            if (ans < 0) ans += mod;
        }
        if (a + b == c - 1) {
            ans -= gt1(n00, n01, n10, n11);
            if (ans < 0) ans += mod;
        }
    }
    cout << ans << endl;
    return 0;
}
