#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <math.h>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

int n;
vector<pair<int, int>> a;
vector<int> ans;

void make(int v, map<int, vector<pair<int, int>>>& mp, map<int, int>& nx) {
    int nn = mp[v].size();
    while(nx[v] < nn) {
        auto t = mp[v][nx[v]];
        nx[v]++;
        make(t.x, mp, nx);
        ans.push_back(t.y);
    }
}

bool check (int mt) {
    map<int, vector<pair<int, int>>> mp;
    map<int, int> balance;
    map<int, int> nx;
    for (int ii{}; ii < n; ++ii) {
        auto i = a[ii];
        mp[i.x].push_back({mt - i.y, ii});
        balance[i.x]++;
        balance[mt - i.y]--;
    }
    int t = 0;
    for (auto i : balance) {
        t += abs(i.y);
    }
    if (t > 2) return false;
    int st = mp.begin()->x;
    if (t == 2) {
        for (auto i : balance) {
            if (i.y > 0) {
                st = i.x;
                break;
            }
        }
    }
    make(st, mp, nx);
    if (ans.size() < n) {
        ans.clear();
        return false;
    }
    reverse(all(ans));
    return true;
}

int32_t main() {
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    cin >> n;
    set<int> must;
    for (int i{}; i < n; ++i) {
        int m, s;
        cin >> m >> s;
        vector<int> p(m);
        for (int j{}; j < m; ++j) {
            cin >> p[j];
        }
        a.push_back({p[0], s - p[m - 1]});
        for (int i{1}; i < m; ++i) {
            must.insert({p[i] - p[i - 1]});
        }
    }
    if (must.size() > 1) {
        cout << "No";
        return 0;
    }
    if (must.size() == 1) {
        if (check(*must.begin())) {
            cout << "Yes\n";
            for (auto i : ans) {
                cout << i + 1 << " ";
            }
        } else {
            cout << "No";
        }
        return 0;
    }

    vector<int> aa, bb;
    for (auto i : a) {
        aa.push_back(i.x);
        bb.push_back(i.y);
    }
    sort(all(aa));
    sort(rall(bb));
    vector<int> possible;
    map<int, int> mp;
    for (int i{}; i < n; ++i) {
        for (int j{}; j < n; ++j) {
            mp[aa[i] + bb[j]]++;
        }
    }
    for (auto i : mp) {
        if (i.y >= n - 1) possible.push_back(i.x);
    }

    for (auto j : possible) {
        if (check(j)) {
            cout << "Yes\n";
            for (auto i : ans) {
                cout << i + 1 << " ";
            }
            return 0;
        }
    }
    cout << "No";
    return 0;
}