#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <math.h>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int mod = 1000000007;
int pow2(int x, int y) {
    if (y == 0) return 1;
    if (y & 1) return x * pow2(x, y - 1) % mod;
    int t = pow2(x, y >> 1);
    return t * t % mod;
}

vector<int> fact(500001);

// x - amount, y - groups
int get(int x, int y) {
    if (y == 0) return fact[x];
    int ret = fact[x];
    int tmp = fact[x + y - 1] * pow2(fact[y - 1], mod - 2) % mod * pow2(fact[x], mod - 2) % mod;
    return ret * tmp % mod;
}

int32_t main() {
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.length();
    fact[0] = 1;
    for (int i{1}; i < fact.size(); ++i) {
        fact[i] = fact[i - 1] * i % mod;
    }
    vector<int> t(4);
    for (int i{}; i < n; ++i) {
        int t1 = a[i] - '0';
        int t2 = b[i] - '0';
        int t3 = c[i] - '0';
        int ind = 0;
        int sm = (t1 + t2);
        if ((t1 + t2) % 10 != t3) {
            ind += 1;
            sm++;
        }
        if (sm >= 10) ind += 2;
        t[ind]++;
    }
    if (t[1] != t[2]) {
        cout << 0;
        return 0;
    }
    int ans = 1;
    for (int i{1}; i <= t[1]; ++i) {
        ans = ans * i % mod;
    }
    ans = pow2(ans, 2);
    ans = ans * get(t[3], t[1]) % mod;
    ans = ans * get(t[0], t[1] + 1) % mod;
    return 0;
}