#include <bits/stdc++.h>
#define int __int128
using namespace std;

int n, m;
int sum;

pair<int, int> get_str_sum(int num) {
    if (num <= 0)
        return {0, sum};
    if (num >= n)
        return {sum, 0};
    int s1 = num * m * (num * m + 1) / 2;
    int s2 = sum - s1;
    return {s1, s2};
}

pair<int, int> get_stb_sum(int num) {
    if (num <= 0)
        return {0, sum};
    if (num >= m)
        return {sum, 0};
    int s1 = (num * (num + 1) / 2) * n + m * num * (n - 1) * n / 2;
    int s2 = sum - s1;
    return {s1, s2};
}

int f1(int num) {
    auto res = get_stb_sum(num);
    return abs(res.second - res.first);
}

int f2(int num) {
    auto res = get_str_sum(num);
    return abs(res.second - res.first);
}

signed main() {
    long long t;
    cin >> t;
    while (t--) {
        long long tn, tm;
        cin >> tn >> tm;
        n = tn;
        m = tm;
        //cin >> n >> m;
        sum = (n * m) * (n * m + 1) / 2;
        /*for (int i = 0; i <= n; ++i) {
            auto res = get_str_sum(i);
            cout << (long long)res.first << ' ' << (long long)res.second << endl;
        }
        cout << endl;
        for (int i = 0; i <= m; ++i) {
            auto res = get_stb_sum(i);
            cout << (long long)res.first << ' ' << (long long)res.second << endl;
        }
        cout << endl;*/
        int left = 0, right = m, mid1, mid2;
        while (right - left > 2) {
            mid1 = left + (right - left) / 3;
            mid2 = left + 2 * ((right - left) / 3);
            int val1 = f1(mid1), val2 = f1(mid2);
            if (val1 <= val2)
                right = mid2;
            else
                left = mid1;
        }

        vector<pair<pair<int, int>, char>> ans;
        ans.push_back({{f1(left), left}, 'V'});
        ans.push_back({{f1(left + 1), left + 1}, 'V'});
        ans.push_back({{f1(left + 2), left + 2}, 'V'});

        left = 0, right = n;
        while (right - left > 2) {
            mid1 = left + (right - left) / 3;
            mid2 = left + 2 * ((right - left) / 3);
            int val1 = f2(mid1), val2 = f2(mid2);
            if (val1 <= val2)
                right = mid2;
            else
                left = mid1;
        }
        ans.push_back({{f2(left), left}, 'H'});
        ans.push_back({{f2(left + 1), left + 1}, 'H'});
        ans.push_back({{f2(left + 2), left + 2}, 'H'});

        int ind = 0;
        for (int i = 1; i < ans.size(); ++i) {
            if (ans[i].first.first < ans[ind].first.first)
                ind = i;
        }
        cout << ans[ind].second << ' ' << (long long)ans[ind].first.second + 1 << '\n';
    }
    return 0;
}
