#include <bits/stdc++.h>
using namespace std;

const int mod = 1e9 + 7;
const int maxn = 2e5 + 5;

long long fact[maxn];

int bpw(int a, int n) {
    if (n == 0)
        return 1;
    long long res = bpw(a, n / 2);
    res = (res * res) % mod;
    if (n & 1)
        res = (res * a) % mod;
    return res;
}

int inv(int a) {
    return bpw(a, mod - 2);
}

int c(int n, int k) {
    long long r1 = fact[n], r2 = fact[k], r3 = fact[n - k];
    r2 = inv(r2), r3 = inv(r3);
    r1 = (r1 * r2) % mod;
    r1 = (r1 * r3) % mod;
    return r1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    string s1, s2, s;
    cin >> s1 >> s2 >> s;
    int n = s.size();
    vector<int> perm(n);
    for (int i = 0; i < n; ++i)
        perm[i] = i;
    int ans = 0;
    do {
        string t1 = s1, t2 = s2, t = s;
        for (int i = 0; i < n; ++i) {
            t[i] = s[perm[i]];
            t1[i] = s1[perm[i]];
            t2[i] = s2[perm[i]];
        }
        if (t[0] != '0' && t1[0] != '0' && t2[0] != '0' && stoi(t1) + stoi(t2) == stoi(t)) {
            ++ans;
        }
    } while (next_permutation(perm.begin(), perm.end()));
    cout << ans << endl;

    /*fact[0] = 1;
   for (int i = 1; i < maxn; ++i)
       fact[i] = (fact[i - 1] * 1ll * i) % mod;

   string s1, s2, s;
   cin >> s1 >> s2 >> s;
   int n = s.size();
   vector<int> t1(n), t2(n), sum(n);
   for (int i = 0; i < n; ++i) {
       t1[i] = s1[i] - '0';
       t2[i] = s2[i] - '0';
       sum[i] = s[i] - '0';
   }
   vector<int> a(4);
   for (int i = 0; i < n; ++i) {
       if ((t1[i] + t2[i]) % 10 == sum[i]) {
           // 0
           if (t1[i] + t2[i] > 9) {
               // 1
               a[1]++;
           } else {
               // 0
               a[0]++;
           }
       } else if ((t1[i] + t2[i] + 1) % 10 == sum[i]) {
           // 1
           if (t1[i] + t2[i] + 1 > 9) {
               // 1
               a[3]++;
           } else {
               // 0
               a[2]++;
           }
       } else {
           cout << 0 << endl;
           return 0;
       }
   }
   int mn = min({a[0], a[1], a[2]});
   int mx = max({a[0], a[1], a[2]});
   if (mx - mn > 1) {
       cout << 0 << endl;
       return 0;
   }
   long long ans = 0;

   // st = 0
   if (a[0] >= a[1] && a[1] >= a[2] && a[2] >= a[3]) {
       ans += c(a[2], a[3]);
   }
   // st = 1
   if (a[1] >= a[2] && a[2] >= a[3] && a[2] >= a[0]) {
       ans += c(a[2], a[3]);
   }
   // st == 2
   if (a[2] >= a[3] && a[2] >= a[0] && a[0] >= a[1]) {
       ans += c(a[2], a[3]);
   }
   // st == 3
   if (a[0] >= a[1] && a[1] >= a[2] && a[2] + 1 >= a[3]) {
       ans += c(a[2], a[3] - 1);
   }
   ans %= mod;
   int temp = 1;
   for (int i = 0; i < 4; ++i)
       temp = (temp * fact[a[i]]) % mod;
   ans = (ans * temp) % mod;
   cout << ans << endl;
     */
    return 0;
}
