#include <bits/stdc++.h>
#define int long long

using namespace std;

int sm(int a, int b) {
    return b * (b + 1) / 2 - a * (a - 1) / 2;
}

int subsm(int l, int r, int ad, int cnt) {
    int s = sm(l, r) * cnt;
    s += sm(1, cnt - 1) * ad * (r - l + 1);
    return s;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--) {
        int n, m;
        cin >> n >> m;

        int ans = LLONG_MAX / 2;
        string an = "V 1";

        if (n > 1) {
            int l = 0, r = n + 1;
            while (r - l > 1) {
                int mid = (l + r) / 2;

                int sml = sm(1, m * (mid - 1)), smr = sm(m * (mid - 1) + 1, m * n);
                if (smr - sml >= 0)
                    l = mid;
                else
                    r = mid;
            }

            if (l > 1) {
                int sml = sm(1, m * (l - 1)), smr = sm(m * (l - 1) + 1, m * n);
                if (abs(smr - sml) < ans) {
                    ans = abs(sml - smr);
                    an = "H " + to_string(l);
                }
            }
            if (r > 1) {
                int sml = sm(1, m * (r - 1)), smr = sm(m * (r - 1) + 1, m * n);
                if (abs(smr - sml) < ans) {
                    ans = abs(sml - smr);
                    an = "H " + to_string(r);
                }
            }
        }

        if (m > 1) {
            int l = 0, r = m + 1;
            while (r - l > 1) {
                int mid = (l + r) / 2;

                int sml = subsm(1, mid - 1, m, n), smr = subsm(mid, m, m, n);
                if (smr - sml >= 0)
                    l = mid;
                else
                    r = mid;
            }

            if (l > 1) {
                int sml = subsm(1, l - 1, m, n), smr = subsm(l, m, m, n);
                if (abs(sml - smr) < ans) {
                    ans = abs(sml - smr);
                    an = "V " + to_string(l);
                }
            }
            if (r > 1) {
                int sml = subsm(1, r - 1, m, n), smr = subsm(r, m, m, n);
                if (abs(sml - smr) < ans) {
                    ans = abs(sml - smr);
                    an = "V " + to_string(r);
                }
            }
        }

        cout << an << "\n";
    }
    return 0;
}
