#include <bits/stdc++.h>
#define int long long

using namespace std;

int n;
vector <int> path;
map <int, set <int>> g;

void dfs(int v, const vector <int>& out, int tar) {
    while (!g[tar - out[v]].empty()) {
        int x = *g[tar - out[v]].begin();
        g[tar - out[v]].erase(g[tar - out[v]].begin());
        dfs(x, out, tar);
    }
    path.push_back(v);
}

void check(int v, map <int, vector <int>>& in, map <int, vector <int>>& out, const vector <int>& st, const vector <int>& fin) {
    vector <int> notok;

    int start = 0;

    for (const auto& pa : in) {
        auto val = pa.first;
        auto vec = pa.second;
        if (out.count(v - val)) {
            if (vec.size() != out[v - val].size()) {
                notok.push_back(val);
                if (vec.size() == 1)
                    start = val;
            }
        } else {
            notok.push_back(val);
            if (vec.size() == 1)
                start = val;
        }
    }

    for (auto& pa : in) {
        int val = pa.first;
        vector <int> x = pa.second;
        for (int i : x)
            g[val].insert(i);
    }
    path.clear();

    if (notok.empty()) {
        g[st[0]].erase(0);
        dfs(0, fin, v);
        if ((int) path.size() == n) {
            reverse(path.begin(), path.end());
            cout << "Yes\n";
            for (int i : path)
                cout << i + 1 << " ";
            cout << "\n";
            exit(0);
        }
    } else if (notok.size() <= 2) {
        int x = *g[start].begin();
        g[st[x]].erase(x);
        dfs(x, fin, v);
        if ((int) path.size() == n) {
            reverse(path.begin(), path.end());
            cout << "Yes\n";
            for (int i : path)
                cout << i + 1 << " ";
            cout << "\n";
            exit(0);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;

    map <int, vector <int>> in, out;
    vector <int> st(n), fin(n);

    int tar = -1;

    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        if (m == 1) {
            int x;
            cin >> x;
            in[x].push_back(i);
            out[s - x].push_back(i);
            st[i] = x;
            fin[i] = s - x;
        } else {
            vector <int> x(m);
            for (int& j : x)
                cin >> j;
            if (tar == -1)
                tar = x[1] - x[0];
            for (int j = 0; j < m - 1; j++) {
                if (x[j + 1] - x[j] != tar) {
                    cout << "No" << endl;
                    return 0;
                }
            }
            in[x.front()].push_back(i);
            out[s - x.back()].push_back(i);
            st[i] = x.front();
            fin[i] = s - x.back();
        }
    }

    if (tar != -1) {
        check(tar, in, out, st, fin);
    } else {
        vector <int> inn, outt;
        for (const auto& pa : in) {
            auto coord = pa.first;
            auto cnt = pa.second;
            inn.push_back(coord);
            if (inn.size() == 3)
                break;
        }
        auto it = out.rbegin();
        outt.push_back(it->first);
        if (out.size() > 1) {
            it++;
            outt.push_back(it->first);
        }
        if (out.size() > 2) {
            it++;
            outt.push_back(it->first);
        }

        for (int i : inn) {
            for (int j : outt) {
                check(i + j, in, out, st, fin);
            }
        }
    }
    cout << "No" << endl;
    return 0;
}
