#include <iostream>
#include <vector>
#define int long long

using namespace std;


string solve(const string& s) {
    bool ok = true;
    for (int i = 1; i < (int) s.size(); i++) {
        if (s[i] > s[0]) {
            ok = false;
        }
        if (s[i] != s[0])
            break;
    }

    if (ok) {
        return string(s.size(), s[0]);
    } else {
        if (s[0] == '9')
            return string(s.size() + 1, '1');
        else
            return string(s.size(), s[0] + 1);
    }
}


signed main() {
    vector <int> pow(19);
    pow[0] = 1;
    for (int i = 1; i < 19; i++)
        pow[i] = pow[i - 1] * 10;

    int x, k;
    cin >> x >> k;

    string s = to_string(x);
    if (k == 0) {
        cout << solve(s) << endl;
    } else {
        int ans = stoll(solve(s));
        for (int i = 0; i < (int) s.size(); i++) {
            string q = s.substr(0, i) + s.substr(i + 1, s.size());
            string now = solve(q);
            for (char c = '0'; c <= '9'; c++) {
                string now2 = now.substr(0, i) + c + now.substr(i, s.size());
                if (stoll(now) < x)
                    now = now.substr(0, i) + s[i] + now.substr(i + 1, s.size());
            }
            ans = min(ans, stoll(now));
        }
        cout << ans << endl;
    }
    return 0;
}
