#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <cmath>
#include <utility>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ii = pair<int, int>;
using vi = vector<int>;
using vii = vector<ii>;
using vvi = vector<vi>;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    for (int q = 0; q < t; ++q) {
        ll n, m;
        cin >> n >> m;
        ll s = n*m + n*m*(n*m - 1)/2;
        ll c1 = n + n*(n-1)*m/2;
        ll r1 = m + m*(m-1)/2;
        ll curr = INF;
        char type;
        int x;
        for (int i = 0; i < m; ++i) {
            ll sum_c1 = c1*i + i*(i-1)*n/2;
            ll ans = abs(2*sum_c1 - s);
            if (ans < curr) {
                curr = ans;
                type = 'V';
                x = i + 1;
            }
        }
        for (int i = 0; i < n; ++i) {
            ll sum_r1 = r1*i + i*(i-1)*m*m/2;
            ll ans = abs(2*sum_r1 - s);
            if (ans < curr) {
                curr = ans;
                type = 'H';
                x = i + 1;
            }
        }
        cout << type << ' ' << x << '\n';
    }

}
