#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <cmath>
#include <utility>
#include <algorithm>

using namespace std;
using ll = long long;
using ii = pair<int, int>;
using vi = vector<ll>;
using vii = vector<ii>;
using vvi = vector<vi>;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll x;
    int k;
    cin >> x >> k;
    vi d;
    while (x != 0) {
        d.push_back(x % 10);
        x /= 10;
    }
    reverse(d.begin(), d.end());
    ll n = d.size();
    if (k == 0) {
        ll target = d[0];
        for (ll i = n-1; i > 0; --i) {
            if (d[i] == 10) {
                d[i] = 0;
                ++d[i-1];
            }
            if (d[i] < target) {
                d[i] = target;
            } else if (d[i] > target) {
                d[i] = target;
                ++d[i-1];
            }
        }
        if (d[0] != target) {
            if (d[0] == 10) {
                d.insert(d.begin(), 1);
                ++n;
                for (ll i = 1; i < n; ++i) {
                    d[i] = 1;
                }
            } else {
                for (ll i = 1; i < n; ++i) {
                    ++d[i];
                }
            }
        }
    } else if (k == 1) {
        ll target, ti;
        bool first;
        for (ll i = 0; i < n-1; ++i) {
            if (d[i] != d[i+1]) {
                ti = i+1;
                break;
            }
        }
        if (d[ti-1] < d[ti]) {
            target = d[ti-1];
            first = true;
        } else {
            target = d[ti];
            first = false;
        }
        for (ll i = n-1; i > ti; --i) {
            if (d[i] == 10) {
                d[i] = 0;
                ++d[i-1];
            }
            if (d[i] < target) {
                d[i] = target;
            } else if (d[i] > target) {
                d[i] = target;
                ++d[i-1];
            }
        }
        if (first) {
            if (d[ti] == 10) {
                d[ti] = target;
                ++d[ti-1];
               /* if (d[0] == 10) {
                    d.insert(d.begin(), 1);
                    ++n;
                    for (ll i = 2; i < n; ++i) {
                        d[i] = 1;
                    }
                } else {
                    for (ll i = 2; i < n; ++i) {
                        ++d[i];
                    }
                }*/
            }
        } else {
            if (d[ti] != target) {
                for (ll i = ti+1; i < n; ++i) {
                    ++d[i];
                }
            }
        }
    }
    for (ll i = 0; i < n; ++i) {
        cout << d[i];
    }
    cout << '\n';
}
