#include <iostream>
#include<vector>
#include<set>
#include <algorithm>
#include <map>
#include <string>
#include <cmath>
#define ll long long
using namespace std;
ll n, m, sg, sv;
ll dif_gor(ll x) {
    ll a1 = x * sg + x * (x - 1) / 2 * n * n;
    ll a2 = sg * (n - x) + (x + n - 1) * (n - x) / 2 * n * n;
    return abs(a2 - a1);
}
ll dif_vert(ll x) {
    ll a1 = x * sv + n * (x - 1) * x / 2;
    ll a2 = (m - x) * sv + n * (m - x) * (m - 1 + x) / 2;
    return abs(a1 - a2);
}
ll solve_gor() {
    /*
    ll a = -n * n;
    ll b = (n * n - 2 * s);
    ll c = (s * n + n * n * n * n / 2 - n * n * n / 2);
    ll d=b*b-4*a*c;
    if()
     */
    ll ans = 0;
    for (ll x = 1; x <= n; ++x)
        if (dif_gor(x) < dif_gor(ans))
            ans = x;
    return ans;
}
ll solve_vert() {
    ll ans = 0;
    for (ll x = 1; x <= m; ++x)
        if (dif_vert(x) < dif_vert(ans))
            ans = x;
    return ans;
}
signed main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    int q;
    cin >> q;
    while (q--) {
        cin >> n >> m;
        sg = m * (m + 1) / 2;
        sv=n*(1+1+(n-1)*m)/2;
        ll ans1 = solve_gor();
        ll ans2 = solve_vert();
        if (dif_gor(ans1) >= dif_vert(ans2))
            cout << 'V' << ' ' << ans2 + 1 << '\n';
        else
            cout << 'H' << ' ' << ans1 + 1 << '\n';
    }
    return 0;
}