#include <iostream>
#include<vector>
#include<set>
#include <algorithm>
#include <map>
#include <string>
#include <cmath>
#define ll long long
#define i128 __int128
using namespace std;
i128 n, m, sg, sv;
i128 dif_gor(i128 x) {
    i128 a1 = x * sg + x * (x - 1) / 2 * m * m;
    i128 a2 = sg * (n - x) + (x + n - 1) * (n - x) / 2 * m * m;
    return a1-a2;
}
i128 dif_vert(i128 x) {
    i128 a1 = x * sv + n * (x - 1) * x / 2;
    i128 a2 = (m - x) * sv + n * (m - x) * (m - 1 + x) / 2;
    return a1-a2;
}
ll solve_gor() {
    ll l = 0, r = n;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (dif_gor(mid) <= 0)
            l = mid;
        else
            r = mid;
    }
    while (abs(dif_gor(l)) > abs(dif_gor(l + 1)))
        l++;
    return l;
}
ll solve_vert() {
    ll l = 0, r = m;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (dif_vert(mid) <= 0)
            l = mid;
        else
            r = mid;
    }

    if (abs(dif_vert(l)) > abs(dif_vert(l + 1)))
        l++;
    return l;
}
signed main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    int q;
    cin >> q;
    while (q--) {
        ll nn, mm;
        cin >> nn >> mm;
        n = nn, m = mm;
        sg = m * (m + 1) / 2;
        sv = n * (1 + 1 + (n - 1) * m) / 2;
        ll ans1 = solve_gor();
        ll ans2 = solve_vert();
        if (abs(dif_gor(ans1)) >= abs(dif_vert(ans2)))
            cout << 'V' << ' ' << ans2 + 1 << '\n';
        else
            cout << 'H' << ' ' << ans1 + 1 << '\n';
    }
    return 0;
}