#include <bits/stdc++.h>

using namespace std;
#define int long long

#define MOD 1000000007

int mul(int a, int b) {
    return a * b % MOD;
}

int sum(int a, int b) {
    int res = a + b;
    if (res >= MOD) {
        res -= MOD;
    }
    if (res < 0) {
        res += MOD;
    }
    return res;
}

int fp(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 1) {
        return mul(fp(a, b - 1), a);
    }
    int res = fp(a, b / 2);
    return mul(res, res);
}

#define MAXN 1000

int fact[MAXN];

int fact_obr[MAXN];

void precalc() {
    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        fact[i] = mul(fact[i - 1], i);
    }
    for (int i = 0; i < MAXN; ++i) {
        fact_obr[i] = fp(fact[i], MOD - 2);
    }
}

int C(int n, int k) {
    if (k < 0) {
        return 0;
    }
    if (k == 0) {
        return 1;
    }
    if (k == n) {
        return 1;
    }
    if (k > n) {
        return 0;
    }
    return mul(mul(fact[n], fact_obr[n - k]), fact_obr[k]);
}

int cnt(int n, int k) {
    if(n==0&&k==0){
        return 1;
    }
    return mul(fact[n], C(n + k - 1, k - 1));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    precalc();
    string a, b, c;
    cin >> a >> b >> c;
    vector<int> pos[4];
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        int x = a[i] - '0';
        int y = b[i] - '0';
        int z = c[i] - '0';
        int cur = x + y;
        bool up = false;
        bool down = false;
        if (cur % 10 != z) {
            down = true;
            cur++;
        }
        if (cur % 10 != z) {
            cout << "0";
            return 0;
        }
        if (cur / 10 > 0) {
            up = true;
        }
        pos[up * 2 + down].push_back(i);
    }
    if (pos[1].size() != pos[2].size()) {
        cout << 0;
        return 0;
    }

    int res = 1;
    res = mul(res, fact[pos[1].size()]);
    res = mul(res, fact[pos[2].size()]);
    res = mul(res, cnt(pos[0].size(), pos[1].size() + 1));
    res = mul(res, cnt(pos[3].size(), pos[2].size()));
    cout << res;
    return 0;
}