#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

char get_next()
{
    char ch = ' ';
    while (ch == ' ' || ch == '\n')
        cin >> ch;
    return ch;
}

bool check1(ll n, ll m, ll mid)
{
    ll v = (mid - 1) * m * ((mid - 1) * m + 1) / 2;
    ll d = n * m * (n * m + 1) / 2 - v;
    return (v <= d);
}

ll get1(ll n, ll m, ll mid)
{
    ll v = (mid - 1) * m * ((mid - 1) * m + 1) / 2;
    ll d = n * m * (n * m + 1) / 2 - v;
    return abs(v - d);
}

bool check2(ll n, ll m, ll mid)
{
    ll d = m - mid + 1;
    ll v = (mid - 1) * ((n - 1) * n / 2) * d + (mid - 1) * n * ((mid - 1) * n + 1) / 2;
    ll dd = n * m * (n * m + 1) / 2 - v;
    return (v <= dd);
}

ll get2(ll n, ll m, ll mid)
{
    ll d = m - mid + 1;
    ll v = (mid - 1) * ((n - 1) * n / 2) * d + (mid - 1) * n * ((mid - 1) * n + 1) / 2;
    ll dd = n * m * (n * m + 1) / 2 - v;
    return abs(v - dd);
}

void solve()
{
    int n, m;
    cin >> n >> m;
    ll l1 = 1;
    ll r1 = n;
    while (l1 + 1 < r1)
    {
        ll mid = (l1 + r1) / 2;
        if (check1(n, m, mid))
            l1 = mid;
        else
            r1 = mid;
    }
    if (get1(n, m, l1) > get1(n, m, l1 + 1LL))
        l1 += 1LL;
    ll l2 = 1;
    ll r2 = m;
    while (l2 + 1 < r2)
    {
        ll mid = (l2 + r2) / 2;
        if (check2(n, m, mid))
            l2 = mid;
        else
            r2 = mid;
    }
    if (get2(n, m, l2) > get2(n, m, l2 + 1LL))
        l2 += 1LL;
    if (get1(n, m, l1) < get2(n, m, l2))
        cout << "H " << l1 << '\n';
    else
        cout << "V " << l2 << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t; cin >> t;
    while (t--)
        solve();
}
