#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
int n, m, c;
int tabl[10][10];
int ans[10][4] =
{ {1, 1, 2, 2},
 {1, 2, 1, 2},
 {1, 2, 2, 1},
 {2, 1, 1, 2},
 {2, 1, 2, 1},
 {2, 2, 1, 0},
 {1, 2, 0, 0},
 {1, 2, 0, 0},
 {1, 2, 0, 0},
 {1, 2, 0, 0}, };
int ans2[5][5] =
{
    {1, 1, 1, 1, 1},
    {1, 2, 2, 2, 2},
    {1, 2, 3, 3, 3},
    {2, 3, 1, 2, 3},
    {2, 3, 1, 3, 2}
};
int ans3[6][4] =
{
    {1, 1, 1, 1},
    {1, 2, 2, 2},
    {1, 2, 3, 3},
    {1, 3, 2, 3},
    {1, 3, 3, 2},
    {2, 1, 2, 3}
};
int fc[3];

bool check()
{
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            for (int i2 = i + 1; i2 < n; ++i2)
                for (int j2 = j + 1; j2 < m; ++j2)
                {
                    fc[0] = 0;
                    fc[1] = 0;
                    fc[2] = 0;
                    fc[tabl[i][j]] = 1;
                    fc[tabl[i][j2]] = 1;
                    fc[tabl[i2][j]] = 1;
                    fc[tabl[i2][j2]] = 1;
                    if (fc[0] + fc[1] + fc[2] == 1)
                        return 0;
                }
    return 1;

}
bool per(int i, int j)
{
    if (i == n)
        return check();
    for (int k = 0; k < c; ++k)
    {
        tabl[i][j] = k;
        if (j == m - 1)
        {
            if (per(i + 1, 0))
                return true;
        }
        else if (per(i, j + 1))
            return true;
    }
}

void do_it()
{
    if (n <= 5 && m <= 5)
    {
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < m; ++j)
                cout << ans2[i][j] << ' ';
            cout << '\n';
        }
    }
    else if ((n == 6 && m == 4) || (n == 4 && m == 6))
    {
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < m; ++j)
            {
                if (n == 6)
                    cout << ans3[i][j] << ' ';
                else
                    cout << ans3[j][i] << ' ';
            }
            cout << '\n';
        }
    }
    else
    {
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < m; ++j)
            {
                if (i == 0 || j == 0)
                    cout << "1 ";
                else if (i == 1 || j == 1)
                    cout << "2 ";
                else
                    cout << "3 ";
            }
            cout << '\n';
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> c;
    if (c == 3)
    {
        do_it();
        return 0;
    }
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if (n > m)
                cout << ans[i][j] << ' ';
            else
                cout << ans[j][i] << ' ';
        }
        cout << '\n';
    }
}
