#include <iostream>
#include <vector>

using namespace std;

#define int long long

signed main() {
    int t; cin >> t;
    while (t--) {
        int n, m; cin >> n >> m;
        int s = ((n * m) * (n * m + 1)) / 2;
        //cout << s << '\n';
        // vertical
        int vL = 0, vR = m;
        while (vL + 1 < vR) {
            int cut = (vL + vR) / 2;
            int d = (n + m * ((n * (n - 1)) / 2)) * cut + n * (((cut - 1) * cut) / 2);
            if (2 * d - s <= 0) {
                vL = cut;
            } else {
                vR = cut;
            }
        }
        int dvL = abs(2 * ((n + m * ((n * (n - 1)) / 2)) * vL + n * (((vL - 1) * vL) / 2)) - s);
        int dvR = abs(2 * ((n + m * ((n * (n - 1)) / 2)) * vR + n * (((vR - 1) * vR) / 2)) - s);
        // horizontal
        int hL = 0, hR = n;
        while (hL + 1 < hR) {
            int cut = (hL + hR) / 2;
            int d = ((cut * m) * (cut * m + 1)) / 2;
            if (2 * d - s <= 0) {
                hL = cut;
            } else {
                hR = cut;
            }
        }
        int dhL = abs(2 * (((hL * m) * (hL * m + 1)) / 2) - s);
        int dhR = abs(2 * (((hR * m) * (hR * m + 1)) / 2) - s);

        int ans = min(min(dvL, dvR), min(dhL, dhR));
        //cout << vL << ' ' << vR << ' ' << hL << ' ' << hR << '\n';
        //cout << dvL << ' ' << dvR << ' ' << dhL << ' ' << dhR << '\n';
        if (ans == dvL) {
            //cout << "vL " << dvL << '\n';
            cout << "V " << vL + 1 << '\n';
        } else if (ans == dvR) {
            //cout << "vR " << dvR << '\n';
            cout << "V " << vR + 1 << '\n';
        } else if (ans == dhL) {
            //cout << "hL " << dhL << '\n';
            cout << "H " << hL + 1 << '\n';
        } else {
            //cout << "hR " << dhR << '\n';
            cout << "H " << hR + 1 << '\n';
        }
    }
}