#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define ld long double


int n;
vector<pii> a;


bool check(vector<int> v, int len) {
	for (int i = 1; i < v.size(); i++) {
		if (a[v[i]].first + a[v[i - 1]].second != len) return 0;
	}
	return 1;
}


void solvel(int len) {
	vector<int> v;
	for (int i = 0; i < n; i++) {
		v.push_back(i);
	}

	while (next_permutation(all(v))) {
		if (check(v, len)) {
			cout << "Yes\n";
			for (auto i : v) {
				cout << i + 1 << ' ';
			}
			exit(0);
		}
	}
}

void solve0() {
	vector<int> v;
	for (int i = 0; i < n; i++) {
		v.push_back(i);
	}

	while (next_permutation(all(v))) {
		if (check(v, a[v[1]].first + a[v[0]].second)) {
			cout << "Yes\n";
			for (auto i : v) {
				cout << i + 1 << ' ';
			}
			exit(0);
		}
	}
	cout << "No\n";
}

int len = -1;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	a.resize(n);

	for (int i = 0; i < n; i++) {
		int m, s;
		cin >> m >> s;
		vector<int> p(m);
		for (int j = 0; j < m; j++) {
			cin >> p[j];
		}
		a[i] = {p[0], s - p.back()};

		for (int i = 1; i < m; i++) {
			if (len != -1 && p[i] - p[i - 1] != len) {
				cout << "No\n";
				exit(0);
			}
			len = p[i] - p[i - 1];
		}
	}

	if (n == 1) {
		cout << "Yes\n1\n";
		exit(0);
	}

	if (len == -1) {
		solve0();
	} else {
		solvel(len);
		cout << "No\n";
		exit(0);
	}

	return 0;
}
