#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define ld long double

const int mod = 1e9 + 7;

int sum(int a, int b) {
	return (a + b) % mod; 
}
int mul(int a, int b) {
	return (ll)a * b % mod;
}

int clas(int a, int b, int c) {
	if ((a + b) % 10 == c) {
		if (a + b >= 10) {
			return 1;
		} else {
			return 0;
		}
	} else if ((a + b + 1) % 10 == c) {
		if (a + b + 1 >= 10) {
			return 3;
		} else {
			return 2;
		}
	}
	return -1;
}

int n;
string sa, sb, sc;
vector<int> a, b, c;

const int maxn = 20;
int dp[4][maxn][maxn][maxn][maxn];

int get(int s, int c0, int c1, int c2, int c3) {
	if (c0 < 0 || c1 < 0 || c2 < 0 || c3 < 0) return 0;

	if (dp[s][c0][c1][c2][c3] == -1) {
		int &h = dp[s][c0][c1][c2][c3];
		if (s == 0) {
			h = sum(mul(c0, get(0, c0 - 1, c1, c2, c3)), mul(c2, get(2, c0, c1, c2 - 1, c3)));
		} else if (s == 1) {
			h = sum(mul(c0, get(0, c0 - 1, c1, c2, c3)), mul(c2, get(2, c0, c1, c2 - 1, c3)));
		} else if (s == 2) {
			h = sum(mul(c3, get(3, c0, c1, c2, c3 - 1)), mul(c1, get(1, c0, c1 - 1, c2, c3)));
		} else {
			h = sum(mul(c3, get(3, c0, c1, c2, c3 - 1)), mul(c1, get(1, c0, c1 - 1, c2, c3)));
		}
	}
	return dp[s][c0][c1][c2][c3];
}

int cnt[4];

// int c01, c03;

signed main() {
	for (int i = 0; i < maxn; i++) {
		for (int j = 0; j < maxn; j++) {
			for (int e = 0; e < maxn; e++) {
				for (int f = 0; f < maxn; f++) {
					for (int s = 0; s < 4; s++) {
						dp[s][i][j][e][f] = -1;
					}
				}
			}
		}
	}

	dp[0][0][0][0][0] = 1;
	dp[1][0][0][0][0] = 1;


	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> sa >> sb >> sc;
	n = sa.size();
	a.resize(n);
	b.resize(n);
	c.resize(n);

	for (int i = 0; i < n; i++) {
		a[i] = sa[i] - '0';
		b[i] = sb[i] - '0';
		c[i] = sc[i] - '0';
	}

	int c00 = 0;
	int c02 = 0;

	for (int i = 0; i < n; i++) {
		int x = clas(a[i], b[i], c[i]);
		if (x == -1){
			cout << "0\n";
			exit(0);
		}
		cnt[x]++;
		if (x == 0) {
			if (a[i] == 0 || b[i] == 0 || c[i] == 0) c00++;
		} else if (x == 2) {
			if (a[i] == 0 || b[i] == 0 || c[i] == 0) c02++;
		}
	}

	cout << sum(mul(cnt[0] - c00, get(0, cnt[0] - 1, cnt[1], cnt[2], cnt[3])), mul(cnt[2] - c02, get(2, cnt[0], cnt[1], cnt[2] - 1, cnt[3])));


	return 0;
}

// g++ -o main main.cpp && time ./main
