#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct Fragment {
    int len;
    int firstP, lastP;
};

vector<Fragment> a;
map<int, vector<int>> kek, rkek;
vector<bool> used;

vector<int> ans;

void rec(int dis, int left, int cur) {
    if (left == 0) {
        cout << "Yes\n";
        for (auto now: ans) {
            cout << now + 1 << ' ';
        }
        exit(0);
    }
    for (auto now: kek[dis + a[cur].lastP - a[cur].len]) {
        if (!used[now]) {
            cur = now;
            used[now] = true;
            ans.push_back(now);
            rec(dis, left - 1, now);
            used[now] = false;
            ans.pop_back();
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    int dist = -1;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        a[i].len = s;
        int p;
        cin >> p;
        a[i].firstP = p;
        for (int j = 1; j < m; j++) {
            int p2;
            cin >> p2;
            if (dist == -1) {
                dist = p2 - p;
            }
            else {
                if (dist != p2 - p) {
                    cout << "No";
                    return 0;
                }
            }
            p = p2;
        }
        a[i].lastP = p;
        kek[a[i].firstP].push_back(i);
        rkek[s - a[i].lastP].push_back(i);
    }
    set<int> azino;
    for (auto now: kek) {
        int k = now.first;
        for (auto wno: a) {
            azino.insert(wno.len - wno.lastP + k);
        }
    }
    if (dist != -1) {
        int dis = dist;
        used.assign(n, false);
        for (int start = 0; start < n; start++) {
            // used.assign(n, false);
            ans.push_back(start);
            used[start] = true;
            rec(dis, n - 1, start);
            used[start] = false;
            ans.pop_back();
        }
    }
    else for (auto dis: azino) {
        used.assign(n, false);
        for (int start = 0; start < n; start++) {
            // used.assign(n, false);
            ans.push_back(start);
            used[start] = true;
            rec(dis, n - 1, start);
            used[start] = false;
            ans.pop_back();
        }
    }
    cout << "No";
    return 0;
}