#include <iostream>
#include <vector>
#include <string.h>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

struct RLE {
	int64_t num_prev;
	int len;
	char c;
	RLE() :num_prev(0), len(0), c(0) {}
	RLE(int64_t p, int l, char code) :num_prev(p), len(l), c(code) {}
	bool operator<(const RLE& item) {
		return len < item.len;
	}
};

map<char, char> shift = { {'A', 'G'}, {'G','C'},{'C','T'},{'T', 'G'} };

vector<RLE> dat;
char str[100001];
int n = 0;

bool check1(int val) {
	if (to_string(val)[0] == '1' && to_string(val - 1)[0] == '9' && val % 10 == 0 && (val - 1) % 10 == 9)return 1;
	else return 0;
}

int main() {
	cin >> str;
	n = strlen(str);
	dat.reserve(n);
	char* endstr = str + n;
	int64_t sum = 0;
	for (char* s = str; s < endstr; s++) {
		char c = *s;
		int l = 0;
		while (c >= '0' && c <= '9') {
			l *= 10;
			l += c - '0';
			c = *(++s);
		}
		if (l < 1)l = 1;
		dat.push_back(RLE(sum, l, c));
		sum += l;
	}
	int mina = 2;
	int minx = 0;
	char minZ = 0;
	int minv = (dat[0].len == 1 || dat[0].len == 2 || (check1(dat[0].len)))?1:0;
	for (int i = 1; i < dat.size(); i++) {
		if (dat[i].len == 2 || (check1(dat[i].len))) {
			if (minv < 1) {
				mina = 2;
				minx = dat[i].num_prev+1;
				minv = 1;
			}
		}
		else if (dat[i].len == 1) {
			if (i < dat.size()-1 && dat[i - 1].c == dat[i + 1].c) {
				int val = 2;
				val += (to_string(dat[i - 1].len).length() + to_string(dat[i + 1].len).length()) - to_string(dat[i - 1].len + dat[i + 1].len).length();
				if (minv < val) {
					minv = val;
					mina = 2;
					minx = dat[i].num_prev + 1;
				}
			}
			else {
				if (minv < 1) {
					mina = 2;
					minx = dat[i].num_prev + 1;
					minv = 1;
				}
			}
		}
	}
	cout << mina << ' ' << minx;
	if (mina != 2)cout << ' ' << minZ << '\n';
	else cout << '\n';

	int maxa = 2;
	int maxx = 0;
	char maxZ = 0;
	int maxv = 0;

	auto item = *max_element(dat.begin(), dat.end());
	maxa = 1;
	maxx = item.num_prev + item.len / 2;
	maxZ = shift[item.c];

	cout << maxa << ' ' << maxx;
	if (maxa != 2)cout << ' ' << maxZ << '\n';
	else cout << '\n';
}