#include <iostream>
#include <cmath>

using namespace std;

int n, m, c;

int dat[10][10] = {
	{1, 2, 1, 2, 1, 2},
	{2, 1, 1, 1, 2, 2},
	{1, 2, 2, 1, 2, 1}
};

void print() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << dat[i][j] << ' ';
		}
		cout << '\n';
	}
}

bool check() {
	for (int y1 = 0; y1 < n; y1++) {
		for (int y2 = y1+1; y2 < n; y2++) {
			for (int x1 = 0; x1 < m; x1++) {
				for (int x2 = x1+1; x2 < m; x2++) {
					if (dat[y1][x1] == dat[y1][x2] && dat[y1][x1] == dat[y2][x1] && dat[y1][x1] == dat[y2][x2]) {
						//cout << x1 << y1 << x2 << y2 << '\n';
						return 0;
					}
				}
			}
		}
	}
	return 1;
}

int main() {
	cin >> n >> m >> c;
	//n = 5;
	//m = 4;
	//cout << check();
	//if (n * m > 25)return 0;
	int num = 10000000;// pow(2, n * m);
	for (int i = 0; i < num; i++) {
		uint64_t v = (((rand() << 16) ^ rand()) << 32)^((rand() << 16) ^ rand());
		for (int y = 0; y < n; y++) {
			for (int x = 0; x < m; x++) {
				//dat[y][x] = ((v&(2 << (y*m+x))) > 0) ? 2 : 1;
				dat[y][x] = v % c + 1;
				v /= c;
			}
		}
		bool val = check();
		if (val) {
			print();
			break;
		}
	}
	//print();
	//cout << check();
	return 0;
}