#include <iostream>
#include <cmath>

using namespace std;

int n, m, c;

int dat[10][10] = {
	{1, 2, 1, 2, 1, 2},
	{2, 1, 1, 1, 2, 2},
	{1, 2, 2, 1, 2, 1}
};

void print(bool r=0) {
	if (r) {
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				cout << dat[j][i] << ' ';
			}
			cout << '\n';
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << dat[i][j] << ' ';
			}
			cout << '\n';
		}
	}

}

bool check() {
	for (int y1 = 0; y1 < n; y1++) {
		for (int y2 = y1+1; y2 < n; y2++) {
			for (int x1 = 0; x1 < m; x1++) {
				for (int x2 = x1+1; x2 < m; x2++) {
					if (dat[y1][x1] == dat[y1][x2] && dat[y1][x1] == dat[y2][x1] && dat[y1][x1] == dat[y2][x2]) {
						//cout << x1 << y1 << x2 << y2 << '\n';
						return 0;
					}
				}
			}
		}
	}
	return 1;
}

inline bool calc(int num, bool r) {
	int64_t errors = 0;
	for (int i = 0; i < num; i++) {
		uint64_t s;
		uint64_t v = s = (((rand() << 16) ^ rand()) << 32) ^ ((rand() << 16) ^ rand());
		for (int y = 0; y < n; y++) {
			for (int x = 0; x < m; x++) {
				//dat[y][x] = ((v&(2 << (y*m+x))) > 0) ? 2 : 1;
				dat[y][x] = v % c + 1;
				v /= c;
				if (v == 0) {
					v = s;// (((rand() << 16) ^ rand()) << 32) ^ ((rand() << 16) ^ rand());
					//cout << "error";
					//return 0;
				}
			}
		}
		bool val = check();
		if (val) {
			//cout << n << 'X' << m << '\n';
			print(r);
			return 1;
		}
	}
	return 0;
}

inline void sawp(int& a, int& b) {
	int tmp = a;
	a = b;
	b = tmp;
}

int main() {
	cin >> n >> m >> c;
	//n = 5;
	//m = 4;
	//cout << check();
	//if (n * m > 25)return 0;
	int count = 0;
	//for (int q1 = 2; q1 <= 10; q1++) {
		//for (int q2 = 2; q2 <= 10; q2++) {
			//n = q1;
			//m = q2;
			int num = 900000;// pow(2, n * m);
			//1M - 55
			//5M - 57
			//10M - 58
			swap(n, m);
			if (!calc(num, 1)) {
				swap(n, m);
				calc(num, 0);
			}
		//}
	//}
	//print();
	//cout << count;
	return 0;
}