

    
/*
for i in range(t):
    n, m = list(map(int, input().split()))

    vx = solve1(n, m)
    vy = solve2(n, m)
    if(abs(cut1(n, m, vx)) <= abs(cut2(n, m, vy))):
        print("V", vx + 1)
    else:
        print("H", vy + 1)
        
*/
    
#include <bits/stdc++.h>

using namespace std;

#define PB push_back

typedef __int128 ll;
typedef pair<int, int> pii;
//typedef pair<ll, ll> pll;


ll cut1(ll n, ll m, ll x){
	ll S = (n * m) * (n * m + 1) / (ll) 2;
    ll a1 = (x * (x + 1)) / (ll) 2;
    ll d = x * m;
    ll sum1 = (2 * a1 + d * (n - 1)) * n / (ll) 2;
    ll sum2 = S - sum1;
   
    return sum2 - sum1;
}

ll cut2(ll n, ll m, ll x){
	ll S = (n * m) * (n * m + 1) / (ll) 2;
    ll a1 = m * (m + 1) / (ll) 2;
    ll d = m * m;
    ll sum1 = (2 * a1 + d * (x - 1)) * x / (ll) 2;
    ll sum2 = S - sum1;

    return sum2 - sum1;
}

ll solve1(ll n, ll m){

    ll l = 0;
    ll r = m - 1;
    while(r - l > 1){
	
        ll mid = (l + r) / 2;
        

        if( cut1(n, m, mid) >=(ll) 0)
            l = mid;
        else
            r = mid;
	}
	
	ll res1 = cut1(n, m, l);
	if(res1 < 0)
		res1 = -res1;
	ll res2 = cut1(n, m, r);
	if(res2 < 0)
		res2 = -res2;
    if (res1 <= res2)
        return l;
    else
        return r;
}


ll solve2(ll n, ll m){

    ll l = 0;
    ll r = n - 1;
    while(r - l > 1){
	
        ll mid = (l + r) / 2;
        

        if( cut2(n, m, mid) >=(ll) 0 )
            l = mid;
        else
            r = mid;
	}
	
	ll res1 = cut2(n, m, l);
	if(res1 < 0)
		res1 = -res1;
	ll res2 = cut2(n, m, r);
	if(res2 < 0)
		res2 = -res2;
    if (res1 <= res2)
        return l;
    else
        return r;
}



int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int t; cin >> t;
	while(t--){
		int _n, _m; cin >> _n >> _m;
		ll n = _n, m = _m;
		ll vx1 = solve1(n, m);
		ll vy1 = solve2(n, m);
		
		ll res1 = cut1(n, m, vx1);
		ll res2 = cut2(n, m, vy1);
		
		if(res1 < 0)
			res1 = - res1;
		if(res2 < 0)
			res2 = - res2;
		int ans1 = vx1;
		int ans2 = vy1;
		
		//cout << (int) res1 << " " << (int) res2 << "\n";
			
		if(res1 <= res2){
			cout << "V" << " " << ans1 + 1 << "\n";
		} else {
			cout << "H" << " " << ans2  + 1 << "\n";
		}
	}
	
	
	
	return 0;
}
