#include <vector>
#include <iostream>
#include <map>
#include <math.h>


using namespace std;
const int MOD = 1000000007;
map<int, map<int, map<int, map<int, map<bool, long long>>>>>dp;

void add(int z, int x, int c, int v, bool a, long long value) {
	if (value == 0)return;
	if (dp.find(z) == dp.end())dp.insert({ z, {} });
	if (dp[z].find(x) == dp[z].end())dp[z].insert({ x, {} });
	if (dp[z][x].find(c) == dp[z][x].end())dp[z][x].insert({ c, {} });
	if (dp[z][x][c].find(v) == dp[z][x][c].end())dp[z][x][c].insert({ v, {} });
	if (dp[z][x][c][v].find(a) == dp[z][x][c][v].end())dp[z][x][c][v].insert({ a, value});
}
long long get(int z, int x, int c, int v, bool a) {
	if (dp.find(z) == dp.end())return 0;
	if (dp[z].find(x) == dp[z].end())return 0;
	if (dp[z][x].find(c) == dp[z][x].end())return 0;
	if (dp[z][x][c][v].find(a) == dp[z][x][c][v].end())return 0;
	return dp[z][x][c][v][a];
}


int main() {
	long long t[20];
	for (int i = 0;i < 20;i++)t[i] = 0;

	string a, b, c;
	cin >> a >> b >> c;
	int sz = a.size();
	int k = 0;
	char q, w, e;
	for (int i = 0;i < sz;i++) {
		q = a[i];
		w = b[i];
		e = c[i];

		

		if (q + w - '0' == e)k = 1;
		else if (q + w + 1 - '0' == e)k = 2;
		else if (q + w - 10 - '0' == e)k = 3;
		else if (q + w - 9 - '0' == e)k = 4;
		else {
			cout << 0;
			return 0;
		}
		t[k]++;
		if (q != '0' && w != '0' && e != '0')t[k+10]++;
	}

	
	if (t[1] != 0)add(1, 0, 0, 0, 0, t[11]);
	if (t[2] != 0)add(0, 1, 0, 0, 1, t[12]);
	long long now[2] = { 0,0 };
	for (int q1 = 0;q1 < t[1]+1;q1++) {
		for (int q2 = 0;q2 < t[2]+1;q2++) {
			for (int q3 = max(q2-1, 0);q3 < min(t[3]+1, (long long)q2+1);q3++) {
				for (int q4 = 0;q4 < t[4]+1;q4++) {
					if (q1 + q2 + q3 + q4 <= 1)continue;
					now[0] = now[1] = 0;
					if (q1 != 0) {
						now[0] += get(q1 - 1,q2,q3,q4,0) * (t[1] - q1 + 1) % MOD;
					}
					if (q2 != 0) {
						now[1] += get(q1, q2-1, q3, q4, 0) * (t[2] - q2 + 1) % MOD;
					}
					if (q3 != 0) {
						now[0] += get(q1, q2, q3-1, q4, 1) * (t[3] - q3 + 1) % MOD;
					}
					if (q4 != 0) {
						now[1] += get(q1, q2, q3, q4-1, 1) * (t[4] - q4 + 1) % MOD;
					}
					add(q1, q2, q3, q4, 0, now[0]);
					add(q1, q2, q3, q4, 1, now[1]);
				}
			}
		}
		
	}
	cout << get(t[1], t[2], t[3], t[4], 0);



	return 0;
}