#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <sstream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <fstream>
#include <complex>
#include <cassert>
#include <vector>
#include <string>
#include <random>
#include <bitset>
#include <regex>
#include <queue>
#include <deque>
#include <cmath>
#include <ctime>
#include <stack>
#include <set>
#include <map>

#define all(q) q.begin(), q.end()
#define ever (;;)
#define Please return
#define AC 0

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("fast-math")

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using cmpl = complex<long double>;

inline ll split_hor(ll n, ll m, ll x) noexcept {
	ll tot_sum = n * m * (n * m + 1) / 2LL;
	ll up_sum = x * m * (x * m + 1) / 2LL;
	ll bot_sum = tot_sum - up_sum;
	return abs(up_sum - bot_sum);
}

inline ll split_ver(ll n, ll m, ll x) noexcept {
	ll left_sum = n * x * (x + 1) / 2LL + m * x * n * (n - 1) / 2LL;
	ll tot_sum = n * m * (n * m + 1) / 2LL;
	ll right_sum = tot_sum - left_sum;
	return abs(left_sum - right_sum);
}

inline void solve() noexcept {
	ll n, m;
	cin >> n >> m;

	ll hl = 1, hr = n - 1;
	ll opt_hor = 1;
	while (hr - hl > 2) {
		ll hm1 = hl + (hr - hl) / 3LL;
		ll hm2 = hr - (hr - hl) / 3LL;

		if (split_hor(n, m, hm1) < split_hor(n, m, hm2))
			hr = hm2;
		else
			hl = hm1;
	}

	for (ll x = hl; x <= hr; ++x)
		if (split_hor(n, m, x) < split_hor(n, m, opt_hor))
			opt_hor = x;

	ll vl = 1, vr = m - 1;
	ll opt_ver = 1;
	while (vr - vl > 2) {
		ll vm1 = vl + (vr - vl) / 3LL;
		ll vm2 = vr - (vr - vl) / 3LL;

		if (split_ver(n, m, vm1) < split_ver(n, m, vm2))
			vr = vm2;
		else
			vl = vm1;
	}

	for (ll x = vl; x <= vr; ++x)
		if (split_ver(n, m, x) < split_ver(n, m, opt_ver))
			opt_ver = x;

	if (split_hor(n, m, opt_hor) < split_ver(n, m, opt_ver))
		cout << "H " << opt_hor + 1 << '\n';
	else
		cout << "V " << opt_ver + 1 << '\n';
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	Please AC;
}