#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <sstream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <fstream>
#include <complex>
#include <cassert>
#include <vector>
#include <string>
#include <random>
#include <bitset>
#include <regex>
#include <queue>
#include <deque>
#include <cmath>
#include <ctime>
#include <stack>
#include <set>
#include <map>

#define all(q) q.begin(), q.end()
#define ever (;;)
#define Please return
#define AC 0

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("fast-math")

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using cmpl = complex<long double>;

inline int block_len(int cnt) noexcept {
	if (cnt == 1)
		return 1;
	int numlen = (int)to_string(cnt).length();
	return numlen + 1;
}

void minlen(const vector<pair<int, char>> &seq) {
	int pcnt = 0;
	int maxdelta = 0;
	int op_ind = -1;

	for (size_t i = 0; i < seq.size(); ++i) {
		int curdelta = 0;
		if (seq[i].first == 1) {
			curdelta = -1;
			if (i > 0 && i + 1 < seq.size() && seq[i - 1].second == seq[i + 1].second)
				curdelta += block_len(seq[i - 1].first + seq[i + 1].first) - block_len(seq[i - 1].first) - block_len(seq[i + 1].first);
		} else {
			curdelta = block_len(seq[i].first - 1) - block_len(seq[i].first);
		}

		if (curdelta < maxdelta) {
			maxdelta = curdelta;
			op_ind = pcnt;
		}
		pcnt += seq[i].first;
	}

	if (op_ind == -1)
		cout << "2 1\n";
	else
		cout << "2 " << op_ind + 1 << '\n';
}

void maxlen(const vector<pair<int, char>> &seq) {
	int pcnt = 0;
	int maxdelta = 0;
	int op_ind = -1;
	char op_symb = 0;

	for (size_t i = 0; i < seq.size(); ++i) {
		int curdelta = 0;
		int cur_ind = -1;
		char cur_symb = 0;
		
		if (seq[i].first == 1) {
			curdelta = 1;
			cur_symb = seq[i].second;
			cur_ind = 0;
		} else {
			curdelta = block_len(seq[i].first + 1) - block_len(seq[i].first);
			cur_symb = seq[i].second;
			cur_ind = 1;

			int dl = block_len(seq[i].first / 2) + 1 + block_len((seq[i].first + 1) / 2);
			if (dl > curdelta) {
				curdelta = dl;
				cur_symb = seq[i].second == 'A' ? 'C' : 'A';
				cur_ind = seq[i].first / 2;
			}
		}

		if (curdelta > maxdelta) {
			maxdelta = curdelta;
			op_ind = pcnt + cur_ind;
			op_symb = cur_symb;
		}
		pcnt += seq[i].first;
	}

	cout << "1 " << op_ind << ' ' << op_symb << '\n';
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	string s;
	cin >> s;
	vector<pair<int, char>> seq;
	int cur = 0;
	for (size_t i = 0; i < s.length(); ++i) {
		if (s[i] == 'A' || s[i] == 'G' || s[i] == 'C' || s[i] == 'T') {
			if (cur == 0) {
				seq.emplace_back(1, s[i]);
			} else {
				seq.emplace_back(cur, s[i]);
				cur = 0;
			}
		} else {
			cur = cur * 10 + s[i] - '0';
		}
	}

	minlen(seq);
	maxlen(seq);

	Please AC;
}