#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <sstream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <fstream>
#include <complex>
#include <cassert>
#include <vector>
#include <string>
#include <random>
#include <bitset>
#include <regex>
#include <queue>
#include <deque>
#include <cmath>
#include <ctime>
#include <stack>
#include <set>
#include <map>

#define all(q) q.begin(), q.end()
#define ever (;;)
#define Please return
#define AC 0

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("fast-math")

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using cmpl = complex<long double>;

inline int block_len(int cnt) noexcept {
	if (cnt < 2)
		return cnt;
	int numlen = (int)to_string(cnt).length();
	return numlen + 1;
}

void minlen(const vector<pair<int, char>> &seq) {
	int pcnt = 0;
	int maxdelta = 0;
	int op_ind = -1;

	for (size_t i = 0; i < seq.size(); ++i) {
		int curdelta = 0;
		if (seq[i].first == 1) {
			curdelta = -1;
			if (i > 0 && i + 1 < seq.size() && seq[i - 1].second == seq[i + 1].second)
				curdelta += block_len(seq[i - 1].first + seq[i + 1].first) - block_len(seq[i - 1].first) - block_len(seq[i + 1].first);
		} else {
			curdelta = block_len(seq[i].first - 1) - block_len(seq[i].first);
		}

		if (curdelta < maxdelta) {
			maxdelta = curdelta;
			op_ind = pcnt;
		}
		pcnt += seq[i].first;
	}

	if (op_ind == -1)
		cout << "2 1\n";
	else
		cout << "2 " << op_ind + 1 << '\n';
}

void maxlen(const vector<pair<int, char>> &seq) {
	int pcnt = 0;
	int maxdelta = 0;
	int op_ind = -1;
	char op_symb = 0;

	for (size_t i = 0; i < seq.size(); ++i) {
		int curdelta = 0;
		int cur_ind = -1;
		char cur_symb = 0;
		
		if (seq[i].first == 1) {
			curdelta = 1;
			cur_symb = seq[i].second;
			cur_ind = 0;
		} else {
			curdelta = block_len(seq[i].first + 1) - block_len(seq[i].first);
			cur_symb = seq[i].second;
			cur_ind = 1;

			if (3 + block_len(seq[i].first - 2) > curdelta) {
				curdelta = 3 + block_len(seq[i].first - 2);
				cur_symb = seq[i].second == 'A' ? 'C' : 'A';
				cur_ind = 2;
			}
			for (int pow10 = 10; pow10 <= seq[i].first; pow10 *= 10) {
				int buf = block_len(pow10) + 1 + block_len(seq[i].first - pow10);
				if (buf > curdelta) {
					curdelta = buf;
					cur_symb = seq[i].second == 'A' ? 'C' : 'A';
					cur_ind = pow10;
				}
			}
		}

		if (curdelta > maxdelta) {
			maxdelta = curdelta;
			op_ind = pcnt + cur_ind;
			op_symb = cur_symb;
		}
		pcnt += seq[i].first;
	}

	cout << "1 " << op_ind << ' ' << op_symb << '\n';
}

int comp_length(const string &s) {
	char last = 0;
	int last_len = 0;
	int res = 0;
	for (size_t i = 0; i < s.length(); ++i) {
		if (s[i] == last) {
			++last_len;
		} else {
			res += block_len(last_len);
			last_len = 1;
		}
		last = s[i];
	}

	res += block_len(last_len);
	return res;
}

void minlen_stupid(const string &s) {
	int res = comp_length(s.substr(1));
	size_t ind = 0;

	for (size_t i = 1; i <= s.length(); ++i) {
		int buf = comp_length(s.substr(0, i) + (i < s.length() ? s.substr(i + 1) : ""));
		if (buf < res) {
			res = buf;
			ind = i;
		}
	}

	cout << "2 " << ind + 1 << '\n';
}

void maxlen_stupid(const string &s) {
	int res = comp_length("A" + s);
	size_t ind = 0;
	char symb = 'A';

	for (size_t i = 0; i <= s.length(); ++i) {
		char c[4] = { 'A', 'C', 'G', 'T' };
		for (int j = 0; j < 4; ++j) {
			int buf = comp_length(s.substr(0, i) + c[j] + s.substr(i));
			if (buf > res) {
				res = buf;
				ind = i;
				symb = c[j];
			}
		}
	}

	cout << "1 " << ind << ' ' << symb;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	/*const char c[4] = { 'A', 'C', 'T', 'G' };

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		vector<pair<int, char>> seq(n);
		for (int j = 0; j < n; ++j) {
			seq[i].first = rand() % 10 + 1;
			seq[i].second = c[rand() % 4];
		}
		string dna;
		for (int ii = 0; ii < n; ++ii)
			for (int jj = 0; jj < seq[ii].first; ++jj)
				dna.push_back(seq[ii].second);

		pair<int, char> op1 = maxlen(seq);
		pair<int, char> op2 = maxlen_stupid(dna);

		string s1 = dna.substr(0, op1.first) + op1.second + dna.substr(op1.first);
		string s2 = dna.substr(0, op2.first) + op2.second + dna.substr(op2.first);
		if (comp_length(s1) != comp_length(s2))
			cout << dna << '\n';
	}*/

	string s;
	cin >> s;
	vector<pair<int, char>> seq;
	int cur = 0;
	for (size_t i = 0; i < s.length(); ++i) {
		if (s[i] == 'A' || s[i] == 'G' || s[i] == 'C' || s[i] == 'T') {
			if (cur == 0) {
				seq.emplace_back(1, s[i]);
			} else {
				seq.emplace_back(cur, s[i]);
				cur = 0;
			}
		} else {
			cur = cur * 10 + s[i] - '0';
		}
	}

	/*string dna;
	for (size_t i = 0; i < seq.size(); ++i)
		for (int j = 0; j < seq[i].first; ++j)
			dna.push_back(seq[i].second);*/

	minlen(seq);
	maxlen(seq);

	Please AC;
}