#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <sstream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <fstream>
#include <complex>
#include <cassert>
#include <vector>
#include <string>
#include <random>
#include <bitset>
#include <regex>
#include <queue>
#include <deque>
#include <cmath>
#include <ctime>
#include <stack>
#include <set>
#include <map>

#define all(q) q.begin(), q.end()
#define ever (;;)
#define Please return
#define AC 0

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("fast-math")

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
using cmpl = complex<long double>;
constexpr ll MOD = (ll)1e9 + 7;
constexpr int MAXN = (int)5e5;
ll fact[MAXN];
ll cnt[2][2] = {};

ll pow_mod(ll x, ll y) {
	ll res = 1;
	while (y) {
		if (y & 1)
			res = (res * x) % MOD;
		x = (x * x) % MOD;
		y >>= 1;
	}
	return res;
}

ll binomial(ll n, ll k) {
	ll res = (pow_mod(fact[k], MOD - 2) * pow_mod(fact[n - k], MOD - 2)) % MOD;
	return (res * fact[n]) % MOD;
}

ll variants(ll n, ll k) {
	return (fact[n] * binomial(n + k - 1, k - 1)) % MOD;
}

ll eval0() {
	ll ans = 1;
	ans = (ans * fact[cnt[0][1]]) % MOD;
	ans = (ans * fact[cnt[1][0]]) % MOD;

	if (cnt[0][1] == 0) {
		if (cnt[1][0] != 0 || cnt[1][1] != 0)
			ans = 0;
		ans = (ans * fact[cnt[0][0]]) % MOD;
	} else if (cnt[0][1] == cnt[1][0]) {
		ans = (ans * variants(cnt[0][0], cnt[0][1] + 1LL)) % MOD;
		ans = (ans * variants(cnt[1][1], cnt[0][1])) % MOD;
	} else {
		ans = 0;
	}
	return ans;
}

ll eval1() {
	ll ans = 1;
	ans = (ans * fact[cnt[0][1]]) % MOD;
	ans = (ans * fact[cnt[1][0]]) % MOD;

	if (cnt[0][1] == 0) {
		ans = 0;
	} else if (cnt[0][1] == cnt[1][0] + 1) {
		ans = (ans * variants(cnt[0][0], cnt[0][1])) % MOD;
		ans = (ans * variants(cnt[1][1], cnt[0][1])) % MOD;
	} else {
		ans = 0;
	}

	return ans;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	string a, b, c;
	cin >> a >> b >> c;

	ll cnt_good[2][2] = {};
	for (size_t i = 0; i < a.length(); ++i) {
		int x = a[i] - '0';
		int y = b[i] - '0';
		int z = c[i] - '0';
		bool zero = x == 0 || y == 0 || z == 0;

		if (x + y == z) {
			++cnt[0][0];
			if (!zero)
				++cnt_good[0][0];
		} else if (x + y == z + 10) {
			++cnt[0][1];
			if (!zero)
				++cnt_good[0][1];
		} else if (x + y + 1 == z) {
			++cnt[1][0];
			if (!zero)
				++cnt_good[1][0];
		} else if (x + y + 1 == z + 10) {
			++cnt[1][1];
			if (!zero)
				++cnt_good[1][1];
		} else {
			cout << 0;
			return 0;
		}
	}

	fact[0] = 1;
	for (ll i = 1; i < MAXN; ++i)
		fact[i] = (fact[i - 1] * i) % MOD;

	ll ans1 = 0;
	if (cnt_good[0][0] > 0) {
		--cnt[0][0];
		ans1 = (cnt_good[0][0] * eval0()) % MOD;
		++cnt[0][0];
	}

	ll ans2 = 0;
	if (cnt_good[1][0] > 0) {
		--cnt[1][0];
		ans2 = (cnt_good[1][0] * eval1()) % MOD;
		++cnt[1][0];
	}

	cout << (ans1 + ans2) % MOD;

	Please AC;
}