#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define along(x) x.begin(), x.end()
#define ralong(x) x.rbegin(), x.rend()
#define ulong unsigned long long
#define pb push_back
#define fi first
#define se second

template<class T>
istream& operator >>(istream &in, vector<T> &a){
    for(auto &i: a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator <<(ostream &out, vector<T> &a){
    for(auto &i: a) {
        out << i << ' ';
    }
    return out;
}

long mod = 1e9 + 7;

struct State {
    long a, b, c, d;
    State(): a(0), b(0), c(0), d(0) {};
    State(long a, long b, long c, long d): a(a), b(b), c(c), d(d) {};
};

long solve(State st, long start, long fcnt = -1) {
    //cout << st.a << ' ' << st.b << ' ' << st.c << ' ' << st.d << '\n';
    long ans = 0;
    if(st.a + st.b + st.c + st.d == 1) {
        if (start == 0 && st.a == 1) {
            return 1;
        }
        if (start == 1 && st.b == 1) {
            return 1;
        }
        if (start == 2 && st.c == 1) {
            return 1;
        }
        if (start == 3 && st.d == 1) {
            return 1;
        }
        return 0;
    }
    if(start == 0 && st.a > 0) {
        long cur = (fcnt == -1) ? st.a : fcnt;
        ans = (ans + (cur*solve(State(st.a - 1, st.b, st.c, st.d), 0) % mod)) % mod;
        ans = (ans + (cur*solve(State(st.a - 1, st.b, st.c, st.d), 2) % mod)) % mod;
    }
    if(start == 1 && st.b > 0) {
        long cur = (fcnt == -1) ? st.b : fcnt;
        ans = (ans + (cur*solve(State(st.a, st.b - 1, st.c, st.d), 0) % mod)) % mod;
        ans = (ans + (cur*solve(State(st.a, st.b - 1, st.c, st.d), 2) % mod)) % mod;
    }
    if(start == 2 && st.c > 0) {
        long cur = (fcnt == -1) ? st.c : fcnt;
        ans = (ans + (cur*solve(State(st.a, st.b, st.c - 1, st.d), 1) % mod)) % mod;
        ans = (ans + (cur*solve(State(st.a, st.b, st.c - 1, st.d), 3) % mod)) % mod;
    }
    if(start == 3 && st.d > 0) {
        long cur = (fcnt == -1) ? st.d : fcnt;
        ans = (ans + (cur*solve(State(st.a, st.b, st.c, st.d - 1), 1) % mod)) % mod;
        ans = (ans + (cur*solve(State(st.a, st.b, st.c, st.d - 1), 3) % mod)) % mod;
    }
    return ans;
}

signed main() {
    cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(false);//cout.precision(4);
    string a, b, c;
    cin >> a >> b >> c;
    long n = a.length();
    vector<long> x(n), y(n);
    long fcnta = 0, fcntc = 0;
    for(long i = 0; i < n; ++i) {
        long k = (a[i] - '0') + (b[i] - '0');
        //cout << k << '\n';
        long nx = 0;
        if(k >= 10) {
            nx = 1;
            k -= 10;
        }
        long prev;
        if(k == c[i] - '0') {
            prev = 0;
        }else if(k == (c[i] - '0') - 1) {
            prev = 1;
        }else if(k == 9 && c[i] - '0' == 0) {
            prev = 1;
            nx = 1;
        }

        x[i] = nx;
        y[i] = prev;

        if(x[i] == 0 && y[i] == 0 && (a[i] == '0' || b[i] == '0' || c[i] == '0')) {
            fcnta ++;
        }
        if(x[i] == 0 && y[i] == 1 && (a[i] == '0' || b[i] == '0' || c[i] == '0')) {
            fcntc ++;
        }
    }
    State st = State(0, 0, 0, 0);
    for(long i = 0; i < n; ++i) {
        //cout << x[i] << ' ' << y[i] << '\n';
        if(x[i] == 0 && y[i] == 0)
            st.a ++;
        if(x[i] == 1 && y[i] == 0)
            st.b ++;
        if(x[i] == 0 && y[i] == 1)
            st.c ++;
        if(x[i] == 1 && y[i] == 1)
            st.d ++;
    }

    int dp1[st.a + 10][st.b + 10][st.c + 10][st.d + 10];
    int dp2[st.a + 10][st.b + 10][st.c + 10][st.d + 10];
    int dp3[st.a + 10][st.b + 10][st.c + 10][st.d + 10];
    int dp4[st.a + 10][st.b + 10][st.c + 10][st.d + 10];

    for(int i = 0; i < st.a + 10; ++i) {
        for(int j = 0; j < st.b + 10; ++j) {
            for(int i1 = 0; i1 < st.c + 10; ++i1) {
                for(int i2 = 0; i2 < st.d + 10; ++i2) {
                    dp1[i][j][i1][i2] = 0;
                    dp2[i][j][i1][i2] = 0;
                    dp3[i][j][i1][i2] = 0;
                    dp4[i][j][i1][i2] = 0;
                }
            }
        }
    }
    //cout << dp[1][0][0][0][0] << '\n';
    dp1[1][0][0][0] = 1;
    dp2[0][1][0][0] = 1;
    dp3[0][0][1][0] = 1;
    dp4[0][0][0][1] = 1;
    //cout << dp[0][0][0][0] << '\n';

    //cout << st.a << ' ' << st.b << ' ' << st.c << ' ' << st.d << "\n\n\n";
    for(long s = 2; s <= (st.a + st.b + st.c + st.d); ++s) {
        for(long a = 0; a <= min(st.a, s); ++a) {
            for(long b = 0; b <= min(st.b, s - a); ++b) {
                for(long c = 0; c <= min(st.c, s - a - b); ++c) {
                    long d = s - a - b - c;
                    if(d > st.d) continue;
                    if(d < 0) break;
                    dp1[a][b][c][d] = a*((dp1[a-1][b][c][d] + dp3[a-1][b][c][d]) % mod) % mod;
                    dp2[a][b][c][d] = b*((dp1[a][b-1][c][d] + dp3[a][b-1][c][d]) % mod) % mod;
                    dp3[a][b][c][d] = c*((dp2[a][b][c-1][d] + dp4[a][b][c-1][d]) % mod) % mod;
                    dp4[a][b][c][d] = d*((dp2[a][b][c][d-1] + dp4[a][b][c][d-1]) % mod) % mod;
                }
            }
        }
    }


    //long ans = (solve(st, 0, st.a - fcnta) + solve(st, 2, st.c - fcntc)) % mod;
    cout << ((dp1[st.a][st.b][st.c][st.d] + dp3[st.a][st.b][st.c][st.d]) % mod);
    //cout << ans;

    return 0;
}

/*
01211
12099
23300
 */