#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

#define int long long

using namespace std;

struct dot {
    char c;
    int x, d;
};

int n, m;

bool cmp(dot a, dot b) {
    if (a.d == b.d && a.c == b.c) {
        return a.x < b.x;
    }

    if (a.d == b.d) {
        return a.c > b.c;
    }
    return a.d < b.d;
}

vector<dot> v;

int d1(int x) {
    return abs(n * m * (n * m + 1) / 2 - 2 * (n * x * (x + 1) / 2 + m * x * n * (n - 1) / 2));
}

int d2(int y) {
    return abs(n * m * (n * m + 1) / 2 - 2 * (y * m * (y * m + 1) / 2));
}

signed main() {
    int q;
    cin >> q;

    while (q--) {
        v.clear();
        cin >> n >> m;

        int x = 0;
        for (x = 0; x <= m; x++) {
            if (x == m || d1(x) <= d1(x + 1)) {
                break;
            }
        }

        int y = 0;
        for (y = 0; y <= n; y++) {
            if (y == n || d2(y) <= d2(y + 1)) {
                break;
            }
        }

        v.push_back({'V', x, d1(x)});
        if (x + 1 <= m) {
            v.push_back({'V', x + 1, d1(x + 1)});
        }
        if (x - 1 >= 0) {
            v.push_back({'V', x - 1, d1(x - 1)});
        }

        v.push_back({'H', y, d2(y)});
        if (y + 1 <= n) {
            v.push_back({'H', y + 1, d2(y + 1)});
        }
        if (y - 1 >= 0) {
            v.push_back({'H', y - 1, d2(y - 1)});
        }

        sort(all(v), cmp);

        /* cout << "v = \n";
        for (auto it :  v) {
            cout << it.c << " " << it.x << " " << it.d << "\n";
        }
        cout << "END\n";*/

        cout << v.begin()->c << " " << v.begin()->x + 1 << "\n";
    }

    return 0;
}
