#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

#define int long long

using namespace std;

const int INF = 2e16 + 109;


struct f {
    int x;
    char c;

    f(int x_, char c_) {
        x = x_, c = c_;
    }
    f() {}
};

struct g {
    int a, b;
    char c;

    g(int a_, int b_, char c_) {
        a = a_, b = b_, c = c_;
    }
    g() {}
};

const char symb[4] = {'A', 'C', 'G', 'T'};
int tenPow[100];

void fill_tenPow() {
    tenPow[1] = 1;
    for (int i = 2; i < 100; i++) {
       tenPow[i] = tenPow[i - 1] * 10;
    }
}

string s;
vector<f> v;

int length(int ind) {
    int ans = 0, x = v[ind].x;
    while (x) {
        x /= 10;
        ans++;
    }

    return ans + 1;
}

int numLen(int x) {
    int ans = 0;
    if (x == 0) {
        return 1;
    }

    while (x) {
        x /= 10;
        ans++;
    }
    return ans;
}


signed main() {
    fill_tenPow();

    cin >> s;
    int n = sz(s);

    int x = 0, LEN = 0;
    v.clear();
    for (int i = 0; i < n; i++) {
        if ('0' <= s[i] && s[i] <= '9') {
            x = x * 10 + (s[i] - '0');
        } else {
            v.push_back({x, s[i]});
            x = 0;
        }
    }
    int m = sz(v);
    for (int i = 0; i < m; i++) {
        LEN += length(i);
    }

    int min_ = INF, max_ = -INF, pos = -1;
    g ans1, ans2;

    for (int i = 0; i < m; i++) {
        //cout << "OK " << i << "\n";

        pos += v[i].x;
        if (v[i].x == 0) {
            pos++;
        }

        int len = 0;

        /*   -   */
        if (v[i].x == 0) {


            if (i - 1 >= 0 && i + 1 < m && v[i - 1].c == v[i + 1].c) {
                len = LEN - length(i - 1) - length(i + 1) - 1;
                len += numLen(v[i - 1].x + v[i + 1].x) + 1;
            } else {
                len = LEN - 1;
            }

            //cout << "CHECK1.1 " << i << " " << len << " " << pos <<  "\n";
        } else if (v[i].x == 2) {
            len = LEN;

            if (i - 1 >= 0) {
                len -= length(i - 1);
            }
            if (i + 1 < m) {
                len -= length(i + 1);
            }
            len -= length(i);

            int d = 0;
            if (i - 1 >= 0 && i + 1 < m && v[i - 1].c == v[i].c && v[i + 1].c == v[i].c) {
                d += numLen(v[i - 1].x + v[i + 1].x + 1) + 1;
            } else {
                if (i - 1 >= 0 && v[i - 1].c != v[i].c) {
                    d += length(i - 1);
                }
                if (i + 1 < m && v[i + 1].c != v[i].c) {
                    d += length(i + 1);
                }

                if (i - 1 >= 0 && v[i - 1].c == v[i].c) {
                    d += numLen(v[i - 1].x + 1) + 1;
                } else if (i + 1 < m && v[i + 1].c == v[i].c) {
                    d += numLen(v[i + 1].x + 1) + 1;
                } else {
                    d++;
                }
            }

            len += d;
        } else {
            len = LEN - numLen(v[i].x) + numLen(v[i].x - 1);
        }
        if (len < min_) {
            min_ = len;
            ans1 = {2, pos + 1, '+'};
        }
        if (len > max_) {
            max_ = len;
            ans2 = {2, pos + 1, '+'};
        }

        /*   -   */

        for (int S = 0; S < 4; S++) {
            char c = symb[S];
            if (c == v[i].c) {
                continue;
            }
            //  
            if (v[i].x > 0) {
                int nL = length(i);
                for (int curLen = 1; curLen <= numLen(v[i].x); curLen++) {
                    len = LEN - nL;
                    if (tenPow[curLen] == 1) {
                        len++;
                    } else if (tenPow[curLen] > 1) {
                        len += numLen(tenPow[curLen]) + 1;
                    }
                    if (v[i].x - tenPow[curLen] == 1) {
                        len++;
                    } else if (v[i].x - tenPow[curLen] > 1) {
                        len += numLen(v[i].x - tenPow[curLen]) + 1;
                    }
                    len++;

                    //cout << "CHECK2.1 " << i << " " << len << " " << max_ << " " << c << " " << v[i].c << "\n";
                    //cout << "POS = " << curLen << " " << pos << " " << pos + 1 - tenPow[curLen] << "\n";
                    if (len < min_) {
                        min_ = len;
                        ans1 = {1, pos + 1 - tenPow[curLen], c};
                    }
                    if (len > max_) {
                        max_ = len;
                        ans2 = {1, pos + 1 - tenPow[curLen], c};
                    }
                }

                len = LEN - nL + (numLen(2) + 2 + numLen(v[i].x - 2)) + 1;
                if (2 == 1) {
                    len--;
                }
                if (v[i].x - 2 == 1) {
                    len--;
                }

                //cout << "CHECK2.1 " << i << " " << len << " " << max_ << " " << c << " " << v[i].c << "\n";
                //cout << "POS = " << 2 << " " << pos << " " << pos + 1 - 2 << "\n";
                if (len < min_) {
                    min_ = len;
                    ans1 = {1, pos + 1 - 2, c};
                }
                if (len > max_) {
                    max_ = len;
                    ans2 = {1, pos + 1 - 2, c};
                }
            }

            //  
            if (i == m - 1 || c != v[i + 1].x) {
                len = LEN + 1;
                if (len < min_) {
                    min_ = len;
                    ans1 = {1, pos + 1, c};
                }
                if (len > max_) {
                    max_ = len;
                    ans2 = {1, pos + 1, c};
                }
            }
        }

        /*   -   */

        if (i - 1 >= 0 && i + 1 < m && v[i - 1].c == v[i + 1].c && v[i].x == 1) {
            len = LEN - length(i - 1) - length(i + 1) - length(i);
            len += numLen(v[i - 1].x + v[i + 1].x + 1) + 1;

            //cout << "CHECK3 " << i << " " << len << "\n";
            if (len < min_) {
                min_ = len;
                ans1 = {3, pos + 1, v[i - 1].c};
            }
            if (len > max_) {
                max_ = len;
                ans2 = {3, pos + 1, v[i - 1].c};
            }
        }
    }

    cout << ans1.a << " " << ans1.b << " ";
    if (ans1.a != 2) {
        cout << ans1.c;
    }
    cout << "\n";

    cout << ans2.a << " " << ans2.b << " ";
    if (ans2.a != 2) {
        cout << ans2.c;
    }
    cout << "\n";

    return 0;
}
