#include <bits/stdc++.h>

using namespace std;

long long sumV(long long n, long long m, long long x) {
    return n * (x - 1) * x / 2 + m * (x - 1) * (n - 1) * n / 2;
}

long long sumH(long long n, long long m, long long x) {
    return (m * (x - 1) + 1) * m * (x - 1) / 2;
}

long long deltaV(long long n, long long m, long long x) {
    return n * m * (n * m + 1) / 2 - 2 * sumV(n, m, x);
}

long long deltaH(long long n, long long m, long long x) {
    return n * m * (n * m + 1) / 2 - 2 * sumH(n, m, x);
}

void solve() {
    long long n, m, s;
    cin >> n >> m;
    s = n * m;
    long long L = 0, R = m + 1;
    while (R - L > 1) {
        long long M = (R + L) / 2;
        if (deltaV(n, m, M) > 0) {
            L = M;
        } else {
            R = M;
        }
    }
    long long ansV = (abs(deltaV(n, m, L)) < abs(deltaV(n, m, R)) ? L : R);
    L = 0, R = n + 1;
    while (R - L > 1) {
        long long M = (R + L) / 2;
        if (deltaH(n, m, M) > 0) {
            L = M;
        } else {
            R = M;
        }
    }
    long long ansH = (abs(deltaH(n, m, L)) < abs(deltaH(n, m, R)) ? L : R);
    if (abs(deltaV(n, m, ansV)) < abs(deltaH(n, m, ansH))) {
        cout << "V " << ansV << "\n";
    } else {
        cout << "H " << ansH << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}

/*
5
1 3
4 7
1 10
3 3
3 5
*/
