#include <bits/stdc++.h>

using namespace std;

int lg(int k) {
    int ans = 0;
    while (k) {
        ans++;
        k /= 10;
    }
    return ans;
}

int lg2(int k) {
    if (k == 0) {
        return 0;
    }
    if (k == 1) {
        return 1;
    }
    return 1 + lg(k);
}

char notThis(char a) {
    return (a == 'A' ? 'C' : 'A');
}

vector<pair<int, char>> makeOkForm(string &s) {
    vector<pair<int, char>> a;
    int num = 0;
    for (int i = 0; i < s.size(); i++) {
        if ('0' <= s[i] && s[i] <= '9') {
            num = 10 * num + (s[i] - '0');
        } else {
            if (num == 0) {
                a.push_back({1, s[i]});
            } else {
                a.push_back({num, s[i]});
                num = 0;
            }
        }
    }
    return a;
}

vector<int> w = {1, 2, 10, 100, 1000, 1000 * 10, 1000 * 100, 1000 * 1000, 1000 * 1000 * 10,
                1000 * 1000 * 100, 1000 * 1000 * 1000, 2000 * 1000 * 1000};

pair<int, int> tryToAdd(int n) {
    if (n == 1) {
        return {1, 0};
    }
    int ans = 0, id = 0;
    for (auto x : w) {
        if (x >= n) {
            break;
        }
        if (ans < lg2(n - x) + lg2(x) + 1 - lg2(n)) {
            ans = lg2(n - x) + lg2(x) + 1 - lg2(n);
            id = x;
        }
    }
    return {ans, id};
}

void solveMax(vector<pair<int, char>> &a) {
    int ansAdd = 0, posAdd = 0, symAdd = 'A';
    int sum = 0;
    for (auto [cnt, c] : a) {
        auto p = tryToAdd(cnt);
        if (p.first > ansAdd) {
            ansAdd = p.first;
            posAdd = p.second + sum;
            symAdd = notThis(c);
        }
        sum += cnt;
    }
    cout << "1 " << posAdd << " " << (char)symAdd << "\n";
}

void solveMin(vector<pair<int, char>> &a) {
    int ansDel = -1, posDel = 0;
    int sum = 0;
    for (auto [cnt, c] : a) {
        int d = lg2(cnt) - lg2(cnt - 1);
        sum += cnt;
        if (d > ansDel) {
            ansDel = d;
            posDel = sum;
        }
    }
    int n = a.size();
    sum = a[0].first;
    for (int i = 1; i < n - 1; i++) {
        sum += a[i].first;
        if (a[i].first == 1) {
            int d = lg2(a[i - 1].first) + lg2(a[i + 1].first) + 1 - lg2(a[i - 1].first + a[i + 1].second);
            if (d > ansDel) {
                ansDel = d;
                posDel = sum;
            }
        }
    }
    cout << "2 " << posDel << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    string s;
    cin >> s;
    vector<pair<int, char>> a = makeOkForm(s);
    solveMin(a), solveMax(a);
}
