#include <bits/stdc++.h>

#define ll long long
using namespace std;

ll n, m, Sigma;

inline ll pref_c(int x) {
    return (n * (x + 1) * x / 2) + (n * (n - 1) / 2 * m * x);
}

inline ll delta_c(int x) {
    return abs(Sigma - (2 * pref_c(x)));
}

inline ll pref_r(int x) {
    return (x*m * (m + 1) / 2) + (m*m * (x - 1) * x / 2);
}

inline ll delta_r(int x) {
    return abs(Sigma - (2 * pref_r(x)));
}


int main() {
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        Sigma = (n * m + 1) * (n * m) / 2;
        int l = 0;
        int r = m;
        ll minnC = 1e18;
        int ansC = -1;
        while (r - l > 2) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if (delta_c(m1) <= delta_c(m2)) r = m2;
            else l = m1;
        }
        for (int i = l; i <= r; i++) {
            if (minnC > delta_c(i)) {
                minnC = delta_c(i);
                ansC = i + 1;
            }
        }
        l = 0;
        r = n;
        ll minnV = 1e18;
        while (r - l > 2) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if (delta_r(m1) <= delta_r(m2)) r = m2;
            else l = m1;
        }
        int ansV = -1;
        for (int i = l; i <= r; i++) {
            if (minnV > delta_r(i)) {
                minnV = delta_r(i);
                ansV = i + 1;
            }
        }
        if (minnC <= minnV) {
            cout << "V " << ansC << '\n';
        } else {
            cout << "H " << ansV << '\n';
        }
    }
    return 0;
}

