#include <bits/stdc++.h>

#define ll long long
using namespace std;

unordered_map<char, ll> toInt = {
        {'0', 0},
        {'1', 1},
        {'2', 2},
        {'3', 3},
        {'4', 4},
        {'5', 5},
        {'6', 6},
        {'7', 7},
        {'8', 8},
        {'9', 9}
};

int main() {
    string s;
    cin >> s;
    ll d = 0;
    vector<pair<int, char>> DNA;
    for (auto c: s) {
        if ('0' <= c && c <= '9') {
            d *= 10;
            d += toInt[c];
        } else {
            DNA.emplace_back(max(1ll, d), c);
            d = 0;
        }
    }
    int minn = 0;
    string minnAns;
    int maxx = 0;
    string maxxAns;
    int pref = 0;
    for (int i = 0; i < DNA.size(); i++) {
        //min
        ll sz = DNA[i].first;
        if (i != 0 && i != DNA.size() - 1 && DNA[i - 1].second == DNA[i + 1].second && sz == 1) {
            int delta =
                    -2 + ((int) log10(DNA[i - 1].first + DNA[i + 1].first) + 1) - ((int) log10(DNA[i - 1].first) + 1) -
                    ((int) log10(DNA[i + 1].first) + 1);
            if (minn > delta) {
                minn = delta;
                minnAns = "2 " + to_string(pref + 1);
            }
        }
        if (sz == 1 || sz == 2 || sz == 10 || sz == 100 || sz == 1000 || sz == 10000 || sz == 100000 || sz == 1000000 ||
            sz == 10000000 || sz == 100000000 || sz == 1000000000) {
            if (minn > -1) {
                minn = -1;
                minnAns = "2 " + to_string(pref + 1);
            }
        }

        //max;
        if (sz != 1) {
            int szl = DNA[i].first / 2;
            int szr = (DNA[i].first + 1) / 2;
            int delta = 2 + (log10(szl) + 1) + (log10(szr) + 1) - (log10(sz) + 1);
            if (delta > maxx) {
                maxx = delta;
                maxxAns = "1 " + to_string(pref + szl) + ' ' + (DNA[i].second == 'A' ? 'C' : 'A');
            }
        }
        pref += DNA[i].first;
    }
    cout << minnAns << '\n';
    cout << maxxAns;
    return 0;
}

