def bin_search(upper, func):
    l = 0
    r = upper
    while r - l - 1:
        mid = (l + r) // 2
        if func(mid) < 0:
            r = mid
        else:
            l = mid
    return l, r


def col_cnt(i):
    # i: 1-numeration
    return (n * m) * (n * m + 1) // 2 - (n * i * (i + 1) + m * n * (n - 1) * i)


def row_cnt(i):
    # i: 1-numeration
    return (n * m) * (n * m + 1) // 2 - (m * m * i * (i - 1) + m * (m + 1) * i)


for _ in range(int(input())):
    n, m = map(int, input().split())
    l, r = bin_search(m + 1, col_cnt)
    col_ans, col_idx = min([(abs(col_cnt(i)), i) for i in (l, r)])
    l, r = bin_search(n + 1, row_cnt)
    row_ans, row_idx = min([(abs(row_cnt(i)), i) for i in (l, r)])
    if col_ans < row_ans:
        print('V', col_idx + 1)
    else:
        print('H', row_idx + 1)
