def decode(s):
    if s == '':
        return ''
    res = ''
    cnt = ''
    for c in s:
        if '0' <= c <= '9':
            cnt += c
        else:
            res += c * (int(cnt) if cnt else 1)
            cnt = ''
    return res


def encode(s):
    if s == '':
        return ''
    res = ''
    cnt = 1
    last = s[0]
    for i in range(1, len(s)):
        c = s[i]
        if c != last:
            if cnt > 1:
                res += str(cnt)
            res += last
            cnt = 1
        else:
            cnt += 1
        last = c
    if cnt > 1:
        res += str(cnt)
    res += last
    return res


def check_val(s, ans):
    global max_val, max_ans, min_val, min_ans

    val = len(s)
    if val > max_val:
        max_val = val
        max_ans = ans
    if val < min_val:
        min_val = val
        min_ans = ans


s = decode(input())
max_val = -1
max_ans = -1
min_val = 10 ** 10
min_ans = -1
for i in range(len(s)):
    sip1 = str(i + 1)
    for z in 'A', 'C', 'G', 'T':
        check_val(encode(s[:i] + z + s[i:]), '1 ' + str(i) + ' ' + z)
        if z != s[i]:
            check_val(encode(s[:i] + z + s[i + 1:]), '3 ' + sip1 + ' ' + z)
    check_val(encode(s[:i] + s[i + 1:]), '2 ' + sip1)

print(min_ans)
print(max_ans)
