#include<bits/stdc++.h>
typedef long long ll;
using namespace std;
ll sum;

ll calc_up(int n, int m, int x)
{
	return abs(((ll)m * x) * ((ll)m * x + 1) / 2);
}

pair<int, ll> hor_search(int n, int m)
{
	int l = 0;
	int r = n - 1;
	while(r - l > 1)
	{
		int mid = (l + r) / 2;
		ll up = calc_up(n, m, mid);
		ll down = sum - up;
		if(up > down)
		{
			r = mid;
		}
		else
		{
			l = mid;
		}
	}
	ll up1 = calc_up(n, m, l);
	ll up2 = calc_up(n, m, r);
	ll down1 = sum - up1;
	ll down2 = sum - up2;
	if(abs(up1 - down1) > abs(up2 - down2))
	{
		return {r, abs(up2 - down2)};
	}
	else
	{
		return {l, abs(up1 - down1)};
	}
}

ll calc_left(int n, int m, int x)
{
	ll res = 0;
	if(x == 0)
	{
		return res;
	}
	res += (ll)n * (((ll)x * (x + 1)) / 2);
	res += (ll)x * m * ((ll)(n - 1) * (n) / 2);
	return res;
}

pair<int, ll> ver_search(int n, int m)
{
	int l = 0;
	int r = m - 1;
	while(r - l > 1)
	{
		int mid = (l + r) / 2;
		ll up = calc_left(n, m, mid);
		ll down = sum - up;
		if(up > down)
		{
			r = mid;
		}
		else
		{
			l = mid;
		}
	}
	ll up1 = calc_left(n, m, l);
	ll up2 = calc_left(n, m, r);
	ll down1 = sum - up1;
	ll down2 = sum - up2;
	if(abs(up1 - down1) > abs(up2 - down2))
	{
		return {r, abs(up2 - down2)};
	}
	else
	{
		return {l, abs(up1 - down1)};
	}
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	int t;
	cin >> t;
	while(t--)
	{
		int n, m;
		cin >> n >> m;
		sum = calc_up(n, m, n);
		auto p1 = hor_search(n, m);
		auto p2 = ver_search(n, m);
		if(p2.second <= p1.second)
		{
			cout << "V " << p2.first + 1 << '\n';
		}
		else
		{
			cout << "H " << p1.first + 1 << '\n';
		}
	}
	//cout << calc_left(3, 5, 1);
}