#include<bits/stdc++.h>
typedef long long ll;
using namespace std;
const int mod = 1000000007;

map<vector<int>, int> dict;
int fact[400];

int solve(int a10, int a01, int a00, int a11, int now)
{
	if(dict.find((vector<int>){a10, a01, a00, a11, now}) != dict.end())
	{
		return dict[(vector<int>){a10, a01, a00, a11, now}];
	}
	int res = 0;
	if(now == 0 && a01 == 0 && a00 == 0)
	{
		if(a10 == 0 && a11 == 0)
		{
			res = 1;
		}
		else
		{
			res = 0;
		}
	}
	else if(now == 1 && a10 == 0 && a11 == 0)
	{
		if(a01 == 0 && a00 == 0)
		{
			res = 1;
		}
		else
		{
			res = 0;
		}
	}
	else
	{
		if(now == 0)
		{
			if(a01 != 0)
			{
				res = solve(a10, a01 - 1, a00, a11, 1);
			}
			if(a00 != 0)
			{
				res = ((ll)res + solve(a10, a01, a00 - 1, a11, 0)) % mod;
			}
		}
		else
		{
			if(a10 != 0)
			{
				res = solve(a10 - 1, a01, a00, a11, 0);
			}
			if(a11 != 0)
			{
				res = ((ll)res + solve(a10, a01, a00, a11 - 1, 1)) % mod;
			}
		}
	}
	dict[(vector<int>){a10, a01, a00, a11, now}] = res;
	return res;
}
int solve1(int a10, int a01, int a00, int a11, int now)
{
	int res = solve(a10, a01, a00, a11, now);
	res = ((ll)res * fact[a10]) % mod;
	res = ((ll)res * fact[a01]) % mod;
	res = ((ll)res * fact[a11]) % mod;
	res = ((ll)res * fact[a00]) % mod;
	return res;
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	string a, b, c;
	cin >> a >> b >> c;
	int n = a.size();
	int a10 = 0, a01 = 0, a11 = 0, a00 = 0;
	int b10 = 0, b01 = 0, b11 = 0, b00 = 0;
	for(int i = 0; i < n; i++)
	{
		int a1 = a[i] - '0';
		int b1 = b[i] - '0';
		int c1 = c[i] - '0';
		if(a1 + b1 == c1)
		{
			++a00;
			if(a1 == 0 || b1 == 0 || c1 == 0)
			{
				++b00;
			}
		}
		else if(a1 + b1 + 1 == c1)
		{
			++a01;
			if(a1 == 0 || b1 == 0 || c1 == 0)
			{
				++b01;
			}
		}
		else if(a1 + b1 == c1 + 10)
		{
			++a10;
			if(a1 == 0 || b1 == 0 || c1 == 0)
			{
				++b10;
			}
		}
		else if(a1 + b1 + 1 == c1 + 10)
		{
			++a11;
			if(a1 == 0 || b1 == 0 || c1 == 0)
			{
				++b11;
			}
		}
		else
		{
			cout << 0;
			return 1 / 0;
		}
	}
	fact[0] = 1;
	for(int i = 1; i < 400; i++)
	{
		fact[i] = ((ll)fact[i - 1] * i) % mod;
	}
	int res = solve1(a10, a01, a00, a11, 0);
	int minus = 0;
	if(b01 != 0)
	{
		minus = ((ll)b01 * solve1(a10, a01 - 1, a00, a11, 1)) % mod;
	}
	if(b00 != 0)
	{
		minus = ((ll)b00 * solve1(a10, a01, a00 - 1, a11, 0) + minus) % mod;
	}
	cout << ((ll)res + mod - minus) % mod;
}