#include <bits/stdc++.h>
using namespace std;
const int maxn = 300, mod = 1e9 + 7;
long long dp[maxn][maxn][maxn];

long long fact(long long a) {
    long long ans = 1;
    for (int i = 2; i <= a; ++i) {
        ans = (ans * i) % mod;
    }
    return ans;
}

long long binpow(long long a, long long p) {
    long long res = 1;
    while (p) {
        if (p & 1) {
            res = (res * a) % mod;
        }
        a = (a * a) % mod;
        p >>= 1;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.length();
    long long a = 0, b = 0, c = 0, a1 = 0, b1 = 0, d = 0;
    for (int i = 0; i < n; ++i) {
        int x = s1[i] - '0';
        int y = s2[i] - '0';
        int z = s3[i] - '0';
        if (x + y == z) {
            ++a;
            if (x != 0 && y != 0 && z != 0) {
                ++a1;
            }
        }
        else if (x + y - 10 == z) {
            ++d;
        }
        else if (x + y + 1 == z) {
            ++b;
            if (x != 0 && y != 0 && z != 0) {
                ++b1;
            }
        }
        else if (x + y + 1 - 10 == z) {
            ++c;
        }
        else {
            cout << 0 << "\n";
            return 0;
        }
    }
    if (d != b) {
        cout << 0 << "\n";
        return 0;
    }
    dp[0][0][0] = 1;
    for (int i = 0; i <= a; ++i) {
        for (int j = 0; j <= b; ++j) {
            for (int k = 0; k <= c; ++k) {
                if (j == 0) {
                    if (k == 0) {
                        dp[i][j][k] = 1;
                    }
                    continue;
                }
                for (int k1 = 0; k1 <= k; ++k1) {
                    dp[i][j][k] += dp[i][j - 1][k1];
                    dp[i][j][k] %= mod;
                }
                if (i != 0) {
                    dp[i][j][k] += dp[i - 1][j][k];
                    dp[i][j][k] %= mod;
                }
            }
        }
    }
    long long ans = fact(b);
    ans *= fact(a);
    ans %= mod;
    ans *= fact(b);
    ans %= mod;
    ans *= fact(c);
    ans %= mod;
    long long real_ans = 0;
    if (a > 0) {
        real_ans = (((dp[a - 1][b][c] * ans) % mod * binpow(a, mod - 2)) % mod * a1) % mod;
    }
    if (b > 0) {
        ans *= binpow(b, mod - 2);
        ans %= mod;
        ans *= b1;
        ans %= mod;
        for (int k1 = 0; k1 <= c; ++k1) {
            real_ans += dp[a][b - 1][k1] * ans;
            real_ans %= mod;
        }
    }
    if (a == 0 && b == 0) {
        real_ans = 0;
    }
    cout << real_ans;
}
/*
123
123
246

01
02
03

01211
12099
23300

121
214
999
 */