#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn = 751, mod = 1e9 + 7;
ll cnt[maxn][maxn], summ[maxn][maxn];

ll fact(ll a) {
    ll ans = 1;
    for (int i = 2; i <= a; ++i) {
        ans = (ans * i) % mod;
    }
    return ans;
}

ll dp(ll a, ll b, ll c) {
    return (cnt[a][b + 1] * cnt[c][b]) % mod;
}

ll binpow(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            res = (res * a) % mod;
        }
        a = (a * a) % mod;
        p >>= 1;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.length();
    ll a = 0, b = 0, c = 0, a1 = 0, b1 = 0, d = 0;
    for (int i = 0; i < n; ++i) {
        int x = s1[i] - '0';
        int y = s2[i] - '0';
        int z = s3[i] - '0';
        if (x + y == z) {
            ++a;
            if (x != 0 && y != 0 && z != 0) {
                ++a1;
            }
        }
        else if (x + y - 10 == z) {
            ++d;
        }
        else if (x + y + 1 == z) {
            ++b;
            if (x != 0 && y != 0 && z != 0) {
                ++b1;
            }
        }
        else if (x + y + 1 - 10 == z) {
            ++c;
        }
        else {
            cout << 0 << "\n";
            return 0;
        }
    }
    if (d != b) {
        cout << 0 << "\n";
        return 0;
    }
    for (int i = 0; i < maxn; ++i) {
        cnt[i][0] = 1;
        summ[i][0] = 1;
        for (int j = 1; j < maxn; ++j) {
            cnt[i][j] = summ[i][j - 1];
            if (i > 0) {
                summ[i][j] = (summ[i - 1][j] + cnt[i][j]) % mod;
            }
            else {
                summ[i][j] = cnt[i][j];
            }
        }
    }
    ll ans = fact(b);
    ans %= mod;
    ans *= fact(a);
    ans %= mod;
    ans *= fact(b);
    ans %= mod;
    ans *= fact(c);
    ans %= mod;
    ll real_ans = (((dp(a - 1, b, c) * ans) % mod * binpow(a, mod - 2)) % mod * a1) % mod;
    ans *= binpow(b, mod - 2);
    ans %= mod;
    ans *= b1;
    ans %= mod;
    for (int k1 = 0; k1 <= c; ++k1) {
        real_ans += dp(a, b - 1, c) * ans;
        real_ans %= mod;
    }
    cout << real_ans;
}