#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

typedef long long ll;

ll calc(ll k, ll a, ll x, ll b, ll y) {
    ll res = 0;
    if ( a > k ) return 0;

    res += (k - a) * x;

    if ( a + b > k ) return res;

    res += (k - a - b) * y;

    return res;
}

int main() {
    ll k;
    ll a, x;
    ll b, y;

    cin >> k;
    cin >> a >> x;
    cin >> b >> y;

    ll case1 = calc(k, a, x, b, y);
    ll case2 = calc(k, b, y, a, x);

    cout << max(case1, case2) << endl;

    return 0;
}