#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int n;

vector<ll> len;
vector<vector<ll>> frag;

int main() {
    cin >> n;
    len = vector<ll>(n);
    frag = vector<vector<ll>>(n, vector<ll>(0));
    int _m;
    for ( int i = 0; i < n; ++i  ){
        cin >> _m >> len[i];
        for ( int j = 0; j < _m; ++j ) {
            ll x;
            cin >> x;
            frag[i].push_back(x);
        }
    }

    ll side;

    bool cs = true;
    for ( int i = 0; i < n; ++i ) {
        if ( frag[i].size() == 1 ) continue;
        if ( !cs ) {
            if ( side != (frag[i][1] - frag[i][0]) ) {
                cout << "No" << endl;
                return 0;
            }
        }
        cs = false;

        side = frag[i][1] - frag[i][0];

        for ( int j = 0; j < frag[i].size() - 1; ++j ) {
            if ( frag[i][j + 1] - frag[i][j] != side ) {
                cout << "No" << endl;
                return 0;
            }

        }
    }

    if ( n == 1 ) {
        cout << "Yes" << endl;
        cout << 1 << endl;
        return 0;
    }

    vector<int> p(n);
    for ( int i = 0; i < n; ++i ) p[i] = i;

    do {
        vector<ll> sides(n - 1, 0);

        for ( int i = 0; i < n - 1; ++i ) {
            sides[i] += frag[p[i + 1]][0];
            sides[i] += len[p[i]] - frag[p[i]].back();
        }

        if ( cs ) side = sides[0];

        bool flag = true;
        for ( int i = 0; i < n - 1; ++i ) flag = flag && ( sides[i] == side );

        if ( flag ) {
            cout << "Yes" << endl;
            for ( int i = 0; i < n; ++i ) cout << p[i] + 1 << " ";
            cout << endl;
            return 0;
        }
    } while ( next_permutation(p.begin(), p.end()) );

    cout << "No" << endl;

    return 0;
}
