#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
using namespace std;
long long n, m;

long long check1(long long z) {
	long long k = n * (n - 1) / 2;
	k *= m;
	k *= z;
	return k + n * (z * (z + 1)) / 2;
}

long long check2(long long z) {
	return (z * m) * (z * m + 1) / 2;
}

void solve() {
 	cin >> n >> m;
	long long sum = (n * m) * (n * m + 1) / 2;
	long long l = 0, r = m;
	while (r - l > 1) {
		long long z = (r + l) / 2;
		long long razn = sum - check1(z) * 2;
		if (razn > 0)
			l = z;
		else
			r = z;
	}
	long long ans1 = 0;
	if (sum - check1(l) * 2 <= check1(r) * 2 - sum)
		ans1 = l;
	else
		ans1 = r;

	l = 0, r = n;
	while (r - l > 1) {
		long long z = (r + l) / 2;
		long long razn = sum - check2(z) * 2;
		if (razn > 0)
			l = z;
		else
			r = z;
	}
	long long ans2 = 0;
	if (sum - check2(l) * 2 <= check2(r) * 2 - sum)
		ans2 = l;
	else
		ans2 = r;

	if (abs(sum - check1(ans1) * 2) <= abs(sum - check2(ans2) * 2))
		cout << "V " << ans1 + 1;
	else
		cout << "H " << ans2 + 1;
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	long long t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
