#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m, sz = -1;
	cin >> n;
	vector<vector<int>> a(n);
	vector<pair<int, int>> s(n);
	vector<int> len(n);
	for (int i = 0; i < n; ++i) {
		cin >> m >> len[i];
		a[i].resize(m);
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
			if (j > 0) {
				if (a[i][j] - a[i][j - 1] != sz && sz != -1) {
					cout << "No";
					return 0;
				}
				sz = a[i][j] - a[i][j - 1];
			}
		}
		s[i].first = a[i][0];
		s[i].second = len[i] - a[i][a[i].size() - 1];
	}
	vector<int> ans(n);
	for (int i = 0; i < n; ++i) {
		ans[i] = i;
	}
	while (next_permutation(ans.begin(), ans.end())) {
		int nsz = sz;
		bool f = true;
		for (int i = 1; i < n; ++i) {
			if (nsz != -1 && s[ans[i]].first + s[ans[i - 1]].second != nsz)
				f = false;
			nsz = s[ans[i]].first + s[ans[i - 1]].second;
		}
		if (f) {
			cout << "Yes\n";
			for (int i = 0; i < n; ++i) {
				cout << ans[i] + 1 << ' ';
			}
			return 0;
		}
	}
	next_permutation(ans.begin(), ans.end());
	int nsz = sz;
	bool f = true;
	for (int i = 1; i < n; ++i) {
		if (nsz != -1 && s[ans[i]].first + s[ans[i - 1]].second != nsz)
			f = false;
		nsz = s[ans[i]].first + s[ans[i - 1]].second;
	}
	if (f) {
		cout << "Yes\n";
		for (int i = 0; i < n; ++i) {
			cout << ans[i] + 1 << ' ';
		}
		return 0;
	}
	cout << "No";
	return 0;
}
