#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
using namespace std;
char ans2[4][6] = { { '1', '1', '1', '2', '2', '2'}, { '1', '2', '2', '2', '1', '1' }, { '2', '1', '2', '1', '2', '1'}, { '2', '2', '1', '1', '1', '2'} };
char ans3[7][9] = { {'1', '1', '1', '2', '2', '2', '3', '3', '3'}, {'1', '2', '2', '2', '3', '3', '3', '1', '1'}, {'1', '3', '3', '2', '1', '1', '3', '2', '3'}, {'2', '1', '2', '3', '2', '3', '1', '3', '1'}, {'3', '1', '3', '1', '2', '1', '2', '3', '2'}, {'2', '2', '1', '3', '3', '2', '1', '1', '3'}, {'3', '3', '1', '1', '1', '2', '2', '2', '3'} };
char ans4[5][10] = { {'3', '3', '3', '3', '3', '3', '1','1', '2', '2'}, {'2', '2', '2', '1', '1', '1', '3', '2', '3', '2'}, {'2', '1', '1', '1', '2', '2', '2', '3', '2', '3'}, {'1', '2', '1', '2', '1', '2', '3', '1', '1', '3'}, {'1', '1', '2', '2', '2', '1', '1', '3', '3', '1'} };
void solve2(int n, int m) {
	if (n == 2) {
		for (int i = 0; i < m; ++i)
			if (i % 2 == 0)
				cout << "1 ";
			else
				cout << "2 ";
		cout << '\n';
		for (int i = 0; i < m; ++i)
			if (i % 2 == 0)
				cout << "2 ";
			else
				cout << "1 ";
	}
	else if (m == 2) {
		for (int i = 0; i < n; ++i) {
			if (i % 2 == 0)
				cout << "1 2\n";
			else
				cout << "2 1\n";
		}
	}
	else{
		bool swapped = false;
		if (n > m) {
			swap(n, m);
			swapped = true;
		}
		if (swapped) {
			for (int i = 0; i < m; ++i) {
				for (int j = 0; j < n; ++j)
					cout << ans2[j][i] << ' ';
				cout << '\n';
			}
		}
		else {
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j)
					cout << ans2[i][j] << ' ';
				cout << '\n';
			}
		}
	}
}

void solve3(int n, int m) {
	if (n <= 3 || m <= 3) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if ((i + j) % 3 == 0)
					cout << "1 ";
				else if ((i + j) % 3 == 1)
					cout << "2 ";
				else
					cout << "3 ";
			}
			cout << '\n';
		}
	}
	else if(max(n, m) < 10){
		bool swapped = false;
		if (n > m) {
			swap(n, m);
			swapped = true;
		}
		if (swapped) {
			for (int i = 0; i < m; ++i) {
				for (int j = 0; j < n; ++j)
					cout << ans3[j][i] << ' ';
				cout << '\n';
			}
		}
		else {
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j)
					cout << ans3[i][j] << ' ';
				cout << '\n';
			}
		}
	}
	else if(min(n, m) <= 5){
		bool swapped = false;
		if (n > m) {
			swap(n, m);
			swapped = true;
		}
		if (swapped) {
			for (int i = 0; i < m; ++i) {
				for (int j = 0; j < n; ++j)
					cout << ans4[j][i] << ' ';
				cout << '\n';
			}
		}
		else {
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j)
					cout << ans4[i][j] << ' ';
				cout << '\n';
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m, c;
	cin >> n >> m >> c;
	if (c == 2)
		solve2(n, m);
	else
		solve3(n, m);
	return 0;
}
