#include <iostream>
#include <cstdio>
#include <vector>
#include <cmath>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;

int main() {
    long long kons = pow(10, 9) + 7;
    string s1, s2, s3;
    getline(cin, s1);
    getline(cin, s2);
    getline(cin, s3);
    vector<int> fis, sec, en;
    for (auto i: s1) {
        fis.push_back(int(i) - int('0'));
    }
    for (auto i: s2) {
        sec.push_back(int(i) - int('0'));
    }
    for (auto i: s3) {
        en.push_back(int(i) - int('0'));
    }
    int n = fis.size();
    vector<bool> good(n, false), pod_pivas(n, false), bolsh(n, false), zero(n, false), vash_zbs(n, false);
    int kol_pod_pivas = 0, kol_bolsh = 0, kol_good = 0, kol_zero = 0, kol_vashe = 0, kol_z_b = 0;
    for (int i = 0; i < n; i++) {
        if (fis[i] + sec[i] >= 10) {
            bolsh[i] = true;
            kol_bolsh++;
        }
        if ((fis[i] + sec[i]) % 10 == en[i]) {
            if (!bolsh[i]) {
                vash_zbs[i] = true;
                kol_vashe++;
            } else {
                good[i] = true;
                kol_good++;
            }
        } else if ((fis[i] + sec[i] + 1) % 10 == en[i]) {
            pod_pivas[i] = true;
            kol_pod_pivas++;
        } else {
            printf("0");
            exit(0);
        }
        if (fis[i] == 0 || sec[i] == 0 || en[i] == 0) {
            zero[i] = true;
            kol_zero++;
            if (bolsh[i]) {
                kol_z_b++;
            }
        }
    }
    if (kol_pod_pivas != kol_bolsh || kol_zero == n) {
        printf("0");
        exit(0);
    }
    vector<int> pre_ans(n, 0);
    pre_ans[0] = n + kol_z_b - kol_zero - kol_bolsh;
    bool next_can_bolsh = true, next_can_mensh = true;
    if (pre_ans[0] == kol_vashe) {
        next_can_bolsh = false;
    }
    kol_vashe--;
    for (int i = 1; i < n; i++) {
        if (!next_can_mensh) {
            next_can_mensh = true;
            next_can_bolsh = false;
            pre_ans[i] = max(kol_bolsh + kol_vashe, 1);
            if (kol_pod_pivas == 0) {
                next_can_mensh = true;
                kol_vashe--;
            }
            kol_bolsh--;
        }
        else if (!next_can_bolsh) {
            next_can_bolsh = true;
            next_can_mensh = false;
            pre_ans[i] = max(kol_pod_pivas + kol_vashe, 1);
            if (kol_bolsh == 0) {
                next_can_mensh = true;
                kol_vashe--;
            }
            kol_pod_pivas--;
        } else {
            pre_ans[i] = max(kol_bolsh + kol_pod_pivas + kol_vashe, 1);
            if (kol_vashe > 0) {
                kol_vashe--;
            } else if(kol_bolsh > 0) {
                kol_bolsh--;
            } else {
                kol_pod_pivas--;
            }
        }
    }
    long long ans = 1;
    for (auto i: pre_ans) {
        ans *= i;
        ans %= kons;
    }
    printf("%lld", ans);
    return 0;
}
