#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ldouble;
#define TEST "B"

ldouble n, m;

ldouble calcH(ldouble h) {
    return  h * m * (m + 1) / 2 + h * (h + 1) / 2 * m;
}

ldouble calcV(ldouble v) {
    return v * (v + 1) / 2 * n + v * n * (n - 1) / 2 * m;
}

void solve() {
    ldouble total = n * m * (n * m + 1) / 4;
    ll l = 0, r = m;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (calcV(mid) < total) l = mid;
        else r = mid;
    }
    if (abs(calcV(l) - total) > abs(calcV(r) - total)) l = r;
    ll V = l;
    l = 0, r = n;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (calcH(mid) < total) r = mid;
        else r = mid;
    }
    if (abs(calcH(l) - total) > abs(calcH(r) - total)) l = r;
    ll H = l;
    if (abs(calcH(H)-total) < abs(calcV(V) - total)) cout << "H " << H + 1 << "\n";
    else cout << "V " << V + 1 << "\n";
}

int main() {
#if defined(LOCAL) && defined(TEST)
    if(!freopen(TEST ".in", "r", stdin))  cerr << "!!!Check input files!!!\n\n\n";
#endif
    ll t;
    cin >> t;
    while(t--) {
        cin >> n>> m;
        solve();
    }
}