#include <bits/stdc++.h>

using namespace std;

typedef int ll;
#define TEST "C"
const ll INF = 1e9;

#pragma GCC optimize(-O3)

bool digit(int c) {
    return '0' <= c && c <= '9';
}

string decode(string s) {
    ll cnt = 0;
    string ans;
    for (auto c: s) {
        if (digit(c)) cnt = 10 * cnt + c - '0';
        else {
            if (cnt) {while (cnt--) ans += c; cnt = 0;}
            else ans += c;
        }
    }
    return ans;
}

string encode(string s) {
    char last = -1;
    ll cnt = 0;
    string ans;
    for (auto c: s) {
        if (c != last) {
            if (cnt > 1) ans += to_string(cnt);
            if (cnt) ans += last;
            cnt = 1;
            last = c;
        } else cnt++;
    }
    if (cnt > 1) ans += to_string(cnt);
    if (cnt) ans += last;
    return ans;
}

 ll lg[(int)1e5 + 1];

void init() {
    lg[0] = 0;
    for(ll i = 1; i < 1e5 + 1; i ++)
        lg[i] = lg[i / 10] + 1;
}

ll len(string s) {
    char last = -1;
    ll cnt = 0;
    ll ans = 0;
    for (auto c: s) {
        if (c != last) {
            if (cnt > 1) ans += lg[cnt];
            if (cnt) ans++;
            cnt = 1;
            last = c;
        } else cnt++;
    }
    if (cnt > 1) ans += lg[cnt];
    if (cnt) ans++;
    return ans;
}

struct mut {
    ll pos = -1, type = -1;
    char c = -1;

    void print() {
        cout << type << " " << pos + ((type == 1)?0:1);
        if (type != 2) cout << " " << c;
        cout << "\n";
    }

    mut(ll pos, ll type, char c = -1) : pos(pos), type(type), c(c) {}
};

bool operator<(mut a, mut b) {
    return true;
}

int main() {
#if defined(LOCAL) && defined(TEST)
    if (!freopen(TEST ".in", "r", stdin)) cerr << "!!!Check input files!!!\n\n\n";
#endif
    init();
    string DNA = "ATGC";
    string s;
    cin >> s;
    s = decode(s);
    pair<ll, mut> ans = {-INF, mut(-1, -1)}, mn = {INF, mut(-1, -1)};
    for (ll i = 0; i <= s.size(); i++) {
        for (auto c : DNA) {
            s.insert(i, 1, c);
            ans = max(ans, {len(s), mut(i, 1, c)});
            mn = min(mn, {len(s), mut(i, 1, c)});
            s.erase(i, 1);
        }
    }
    for (ll i = 0; i < s.size(); i++) {
        char c = s[i];
        s.erase(i, 1);
        ans = max(ans, {len(s), mut(i, 2)});
        mn = min(mn, {len(s), mut(i, 2)});
        s.insert(i, 1, c);
    }
    for (ll i = 0; i < s.size(); i++) {
        for (auto cc:DNA) {
            char c = s[i];
            if(c == cc) continue;
            s[i] = cc;
            ans = max(ans, {len(s), mut(i, 3, cc)});
            mn = min(mn, {len(s), mut(i, 3, cc)});
            s[i] = c;
        }
    }
    mn.second.print();
    ans.second.print();
}