#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <random>
#include <ctime>
#include <string>

using  namespace std;
const long long mod = 1e9 + 7;

long long my_pow(long long a, long long p) {
	if (p == 0) return 1;
	if (p == 1) return a;
	return (my_pow((a * a) % mod, p / 2) * my_pow(a, p % 2)) % mod;
}

long long my_fac(long long a) {
	if (a == 0) return 1;
	long long ans = 1;
	for (long long i = 1; i <= a; i++) {
		ans *= i;
		ans %= mod;
	}
	return ans;
}

long long my_c(long long n, long long k) {
	if (k == 0) return 1;
	return ((my_fac(n) * my_pow(my_fac(n - k), mod - 2)) % mod * my_pow(my_fac(k), mod - 2)) % mod;
}

long long mult(long long a, long long b) {
	return (a * b) % mod;
}

long long mi(long long a, long long b) {
	return (a - b + mod) % mod;
}

int main() {
	string as;
	string bs;
	string cs;
	cin >> as >> bs >> cs;
	vector <long long> next;
	long long n = as.size();
	if (n < 1) {
		for (long long i = 0; i < n; i++) {
			next.push_back(i);
		}
		vector <long long> n_next;
		n_next = next;
		long long ans = 0;
		do {
			string d_a;
			string d_b;
			string d_c;
			for (auto i : n_next) {
				d_a.push_back(as[i]);
				d_b.push_back(bs[i]);
				d_c.push_back(cs[i]);
			}
			if (d_a[0] == '0') {
				next_permutation(n_next.begin(), n_next.end());
				continue;
			}
			if (d_b[0] == '0') {
				next_permutation(n_next.begin(), n_next.end());
				continue;
			}
			if (d_c[0] == '0') {
				next_permutation(n_next.begin(), n_next.end());
				continue;
			}
			long long f = 0;
			bool f2 = true;
			for (long long i = n - 1; i > -1; i--) {
				if (!((f + d_a[i] - '0' + d_b[i] - '0') % 10 == d_c[i] - '0')) {
					f2 = false;
					break;
				}
				if ((f + d_a[i] - '0' + d_b[i] - '0') >= 10) f = 1;
				else f = 0;
			}
			if (f2) ans++;
			next_permutation(n_next.begin(), n_next.end());
		} while (next != n_next);
		cout << ans;
	}
	else {
		long long a, b, c, d, e, f;
		a = 0; b = 0; c = 0; d = 0, e = 0, f = 0;
		for (long long i = 0; i < n; i++) {
			if (as[i] - '0' + bs[i] - '0' == cs[i] - '0') a++;
			else if (as[i] - '0' + bs[i] - '0' == cs[i] - '0' - 1) b++;
			else if (as[i] - '0' + bs[i] - '0' - 10 == cs[i] - '0') d++;
			else if (as[i] - '0' + bs[i] - '0' - 10 + 1 == cs[i] - '0') c++;
			else {
				cout << 0;
				return 0;
			}
			if (as[i] - '0' + bs[i] - '0' == cs[i] - '0' && (as[i] == '0' || bs[i] == '0')) {
				e++;
			}
			if (as[i] - '0' + bs[i] - '0' == cs[i] - '0' - 1 && (as[i] == '0' || bs[i] == '0' || cs[i] == '0')) {
				f++;
			}
		}
		if (b != d || b == 0 && c != 0) {
			cout << 0;
			return 0;
		}
		if (a == n) {
			cout << mi(my_fac(n), mult(e, my_fac(n - 1)));
			return 0;
		}
		long long k = my_fac(b);
		k = mult(k, my_fac(c));
		k = mult(k, my_fac(b));
		k = mult(k, my_c(b + a, a));
		k = mult(k, my_c(c + b - 1, b - 1));
		k = mult(k, my_fac(a));
		long long l = mult(e, my_fac(b));
		l = mult(l, my_fac(c));
		l = mult(l, my_fac(b));
		l = mult(l, my_c(b + a - 1, a - 1));
		l = mult(l, my_c(c + b - 1, b - 1));
		l = mult(l, my_fac(a - 1));
		long long j = f;
		j = mult(j, my_fac(b - 1));
		j = mult(j, my_fac(b));
		j = mult(j, my_fac(c));
		j = mult(j, my_c(b + c - 1, b - 1));
		j = mult(j, my_fac(a));
		j = mult(j, my_c(b + a - 1, a));
		cout << mi(mi(k, l), j);
	}
}