#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <cmath>

using namespace std;

// #define int long long
#define ft first
#define sd second
#define rs resize
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

int get_len(int num)
{
    int cnt = 0;
    while (num > 0)
    {
        cnt++;
        num /= 10;
    }
    return cnt;
}

int round(int num)
{
    int res = 1;
    while (res * 10 <= num)
    {
        res *= 10;
    }
    return res;
}

signed main()
{
    string s;
    cin >> s;
    vector<pair<int, char>> arr;
    int num = 0;
    for (auto c : s)
    {
        if (c >= '0' && c <= '9')
        {
            num = num * 10 + (c - '0');
        }
        else
        {
            if (num == 0)
            {
                num = 1;
            }
            arr.pb({num, c});
            num = 0;
        }
    }
    vector<int> len, rnd;
    for (int i = 0; i < arr.size(); i++)
    {
        len.pb(get_len(arr[i].ft));
        rnd.pb(round(arr[i].ft));
        // cout << arr[i].ft << " ";
    }
    // cout << "\n";
    int cnt = 0, x = 1, mx = 0;
    for (int i = 0; i < arr.size(); i++)
    {
        int temp = 0;
        if (arr[i].ft == 1)
        {
            temp = 1;
            if (i > 0 && i < arr.size() - 1 && arr[i - 1].sd == arr[i + 1].sd)
            {
                temp += len[i - 1] + len[i + 1] - get_len(arr[i - 1].ft + arr[i + 1].ft) + 1;
            }
        }
        else if (arr[i].ft == rnd[i])
        {
            temp = 1;
        }
        if (temp > mx)
        {
            mx = temp;
            x = cnt + 1;
        }
        // cout << temp << "\n";
        cnt += arr[i].ft;
    }
    cout << "2 " << x << "\n";
    cnt = 0; x = 0; mx = 1;
    char z = 'A';
    if (arr[0].sd == 'A')
    {
        z = 'C';
    }
    for (int i = 0; i < arr.size(); i++)
    {
        if (arr[i].ft <= 2)
        {
            continue;
        }
        int temp = 1, k = 0;
        if (arr[i].ft == 3)
        {
            temp = 2;
            k = 1;
        }
        else if (arr[i].ft < 10)
        {
            temp = 3;
            k = 2;
        }
        else if (arr[i].ft == 10)
        {
            temp = 2;
            k = 2;
        }
        else if (arr[i].ft == 11)
        {
            temp = 2;
            k = 2;
        }
        else if (arr[i].ft < 20)
        {
            temp = 3;
            k = 2;
        }
        else if (arr[i].ft < rnd[i] + rnd[i] / 10)
        {
            temp = len[i];
            k = rnd[i] / 10;
        }
        else if (arr[i].ft < rnd[i] * 2)
        {
            temp = len[i] + 1;
            k = rnd[i] / 10;
        }
        else
        {
            temp = len[i] + 2;
            k = rnd[i];
        }
        if (temp > mx)
        {
            mx = temp;
            x = cnt + k;
            if (arr[i].sd == 'A')
            {
                z = 'C';
            }
            else
            {
                z = 'A';
            }
        }
        cnt += arr[i].ft;
    }
    cout << "1 " << x << " " << z << "\n";
    return 0;
}
