#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <numeric>

using namespace std;

//#define int long long
#define ft first
#define sd second
#define rs resize
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

string a, b, c;
int n, ans = 0;
const int MOD = 1e9 + 7;

ll get_ans(int cnt00, int cnt01, int cnt10, int cnt11, int last)
{
    ll res = 0, sum0x = cnt00 + cnt01, sum1x = cnt10 + cnt11;
    if (sum0x == 0 && sum1x != 0)
    {
        return 0;
    }
    if (sum0x + sum1x == 1)
    {
        return 1;
    }
    if (last && cnt01)
    {
        res = (res + cnt01 * get_ans(cnt00, cnt01 - 1, cnt10, cnt11, 0)) % MOD;
    }
    if (last && cnt11)
    {
        res = (res + cnt11 * get_ans(cnt00, cnt01, cnt10, cnt11 - 1, 1)) % MOD;
    }
    if (!last && cnt10)
    {
        res = (res + cnt10 * get_ans(cnt00, cnt01, cnt10 - 1, cnt11, 1)) % MOD;
    }
    if (!last && cnt00)
    {
        res = (res + cnt00 * get_ans(cnt00 - 1, cnt01, cnt10, cnt11, 0)) % MOD;
    }
    return res;
}

signed main()
{
    cin >> a >> b >> c;
    n = a.size();
    int cnt00 = 0, cnt10 = 0, cnt01 = 0, cnt11 = 0;
    for (int i = 0; i < n; i++)
    {
        int x = a[i] - '0', y = b[i] - '0', z = c[i] - '0';
        bool f1 = ((x + y) % 10 != z), f2 = (x + y >= 10);
        if ((x + y) % 10 != z && (x + y + 1) % 10 != z)
        {
            cout << 0;
            return 0;
        }
        if (!f1 && !f2)
        {
            cnt00++;
        }
        if (f1 && !f2)
        {
            cnt01++;
        }
        if (!f1 && f2)
        {
            cnt10++;
        }
        if (f1 && f2)
        {
            cnt11++;
        }
    }
    // cout << cnt00 << cnt01 << cnt10 << cnt11 << "\n";
    cout << get_ans(cnt00, cnt01, cnt10, cnt11, 0) % MOD;
    return 0;
}
