#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <numeric>

using namespace std;

//#define int long long
#define ft first
#define sd second
#define rs resize
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

string a, b, c;
int n;
const ll MOD = 1e9 + 7;
map<tuple<int, int, int, int, int>, ll> dict;
ll dp[18][(1 << 18)];

ll get_ans(int cnt00, int cnt01, int cnt10, int cnt11, int last)
{
    if (dict.find(make_tuple(cnt00, cnt01, cnt10, cnt11, last)) != dict.end())
    {
        return dict[make_tuple(cnt00, cnt01, cnt10, cnt11, last)];
    }
    ll res = 0;//, sum0x = cnt00 + cnt01, sum1x = cnt10 + cnt11;
    if (cnt00 + cnt01 + cnt10 + cnt11 == 0 && last == 1)
    {
        dict[make_tuple(cnt00, cnt01, cnt10, cnt11, last)] = 0;
        return 0;
    }
    if (cnt00 + cnt01 + cnt10 + cnt11 == 0 && last == 0)
    {
        dict[make_tuple(cnt00, cnt01, cnt10, cnt11, last)] = 1;
        return 1;
    }
//    if (sum0x == 0 && sum1x != 0)
//    {
//        dict[make_tuple(cnt00, cnt01, cnt10, cnt11, last)] = 0;
//        return 0;
//    }
//    if (sum0x + sum1x == 1)
//    {
//        dict[make_tuple(cnt00, cnt01, cnt10, cnt11, last)] = 1;
//        return 1;
//    }
    if (last && cnt01)
    {
        res = (res + cnt01 * get_ans(cnt00, cnt01 - 1, cnt10, cnt11, 0)) % MOD;
    }
    if (last && cnt11)
    {
        res = (res + cnt11 * get_ans(cnt00, cnt01, cnt10, cnt11 - 1, 1)) % MOD;
    }
    if (!last && cnt10)
    {
        res = (res + cnt10 * get_ans(cnt00, cnt01, cnt10 - 1, cnt11, 1)) % MOD;
    }
    if (!last && cnt00)
    {
        res = (res + cnt00 * get_ans(cnt00 - 1, cnt01, cnt10, cnt11, 0)) % MOD;
    }
    dict[make_tuple(cnt00, cnt01, cnt10, cnt11, last)] = res;
    return res;
}

bool check(int i, int l)
{
    return ((a[i] - '0') + (b[i] - '0') + ((a[l] - '0') + (b[l] - '0') >= 10)) % 10 == (c[i] - '0');
}

signed main()
{
    cin >> a >> b >> c;
    n = a.size();
    int cnt00 = 0, cnt10 = 0, cnt01 = 0, cnt11 = 0;
    for (int i = 0; i < n; i++)
    {
        int x = a[i] - '0', y = b[i] - '0', z = c[i] - '0';
        bool f1 = ((x + y) % 10 != z), f2 = (x + y >= 10);
        if ((x + y) % 10 != z && (x + y + 1) % 10 != z)
        {
            cout << 0;
            return 0;
        }
        if (!f1 && !f2)
        {
            cnt00++;
        }
        if (f1 && !f2)
        {
            cnt01++;
        }
        if (!f1 && f2)
        {
            cnt10++;
        }
        if (f1 && f2)
        {
            cnt11++;
        }
    }
    if (n <= 18)
    {
        for (int mask = (1 << n) - 1; mask > 0; mask--)
        {
            for (int l = 0; l < n; l++)
            {
                if (mask == (1 << n) - 1)
                {
                    if (a[l] != '0' && b[l] != '0' && c[l] != '0' && (a[l] - '0') + (b[l] - '0') < 10)
                    {
                        dp[l][mask] = 1;
                    }
                    continue;
                }
                if ((mask & (1 << l)) == 0)
                {
                    continue;
                }
                for (int i = 0; i < n; i++)
                {
                    if ((mask & (1 << i)) == 0 && check(i, l))
                    {
                        dp[l][mask] = (dp[l][mask] + dp[i][(mask | (1 << i))]) % MOD;
                    }
                }
            }
        }
        ll ans = 0;
        for (int i = 0; i < n; i++)
        {
            ans = (ans + dp[i][(1 << i)]) % MOD;
        }
        cout << ans;
        return 0;
    }
    // cout << cnt00 << cnt01 << cnt10 << cnt11 << "\n";
    cout << get_ans(cnt00, cnt01, cnt10, cnt11, 0) % MOD;
    return 0;
}
