#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
#define pii pair<int,int>
#define pll pair <ll,ll>
#define fi first
#define se second
#define vi vector <int>
#define vll vector <ll>
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define pb push_back

const int MAXN=3e5+100;
const int INF = 1e9;
const ll INFLL = 1e18;
const int mod1=1e9+7;
const int mod2=1e9+9;
int par[MAXN],ranks[MAXN];
void make_set(int s)
{
    ranks[s]=0;
    par[s]=s;
}
int find_set(int s)
{
    if (par[s]==s)
        return s;
    return par[s]=find_set(par[s]);
}
void union_sets(int u,int v)
{
    u=find_set(u);
    v=find_set(v);
    if (u!=v)
    {
        if (ranks[u]<ranks[v])
            swap(u,v);
        par[v]=u;
        if (ranks[u]==ranks[v])
            ranks[u]++;
    }
}
vector <vector <pair <int,int> > > g;
vector <bool> used;
vector <int> which;
vector <int> path;
int n;
int sz;
void dfs(int s,int was)
{
    for (;which[s]<g[s].size();)
    {
        pii to=g[s][which[s]];
        if (used[to.se]) {
            which[s]++;
            continue;
        }
        used[to.se]=true;
        which[s]++;
        dfs(to.fi,to.se);
    }
    if (was!=-1&&was!=n)
        path.pb(was);
}
void solve()
{
    cin>>n;
    vector <pii> a(n);
    int mod=-1;
    int max_s=0;
    for (int i=0;i<n;i++)
    {
        int m,s;
        cin>>m>>s;
        max_s=max(max_s,s);
        vector <int> b(m);
        for (auto &to:b)
            cin>>to;
        for (int j=0;j+1<m;j++)
        {
            if (mod==-1)
                mod=b[j+1]-b[j];
            else
            {
                if (mod!=b[j+1]-b[j])
                {
                    cout<<"No\n";
                    return;
                }
            }
        }
        a[i]={b[0],s-b.back()};
    }
    vector <int> p(n);
    iota(all(p),0);
    do {
        int now=mod;
        bool ok=true;
        for (int i=0;i+1<n;i++)
        {
            if (now!=-1&&a[p[i+1]].fi+a[p[i]].se!=now)
                ok=false;
            else
                now=a[p[i+1]].fi+a[p[i]].se;
        }
        if (ok)
        {
            cout<<"Yes\n";
            for (auto to:p)
                cout<<to+1<<' ';
            cout<<'\n';
        }
    } while (next_permutation(all(p)));
    cout<<"No\n";
}

int main()
{
#ifdef Mip182
    freopen("a.in","r",stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int _t=1;
    while (_t--)
        solve();
}
