#include <bits/stdc++.h>
#pragma GCC optimize("avx,avx2,fma")
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
#define pii pair<int,int>
#define pll pair <ll,ll>
#define fi first
#define se second
#define vi vector <int>
#define vll vector <ll>
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define pb push_back
#define rep(i,x) for(int i=0;i<(x);i++)

const int MAXN=2 * 2e5+100;
const int MAXNN = 1e8;
const int INF = 1e9;
const ll INFLL = 1e18;
const int mod1=1e9+7;
const int mod2=1e9+9;
int add(int a,int b)
{
    a+=b;
    if (a>=mod1)
        return a-mod1;
    return a;
}
int sub(int a,int b)
{
    a-=b;
    if (a<0)
        return a+mod1;
    return a;
}
int mult(int a,int b)
{
    return 1ll*a*b%mod1;
}
int bin_pow(int base,int deg)
{
    if (deg==0)
        return 1;
    int t=bin_pow(base,deg/2);
    if (deg&1)
        return 1ll*t*t%mod1*base%mod1;
    else
        return 1ll*t*t%mod1;
}
void ad(int &x,int y)
{
    x=add(x,y);
}
int dp[752][752][2],suf[752][752][2];
int fact[MAXN];
int ifact[MAXN];
int C(int n,int k)
{
    if (k>n)
        return 0;
    int ans=fact[n];
    ans=mult(ans,ifact[k]);
    ans=mult(ans,ifact[n-k]);
    return ans;
}
void solve()
{
    string aa,bb,c;
    cin>>aa>>bb>>c;
    int n=aa.size();
    vector <vector <int> > cnt(2,vi(2));
    int cnt00=0,cnt10=0;
    // cnt[i][j] - i ? нужен ли переход перед этим, j - дает ли само переход
    for (int i=0;i<n;i++)
    {
        int x=aa[i]-'0';
        int y=bb[i]-'0';
        int z=c[i]-'0';
        if ((x+y)%10==z)
        {
            if ((x+y)>=10) {
                cnt[0][1]++;
            }
            else {
                if (x==0||y==0||z==0)
                    cnt00++;
                cnt[0][0]++;
            }
        } else if ((x+y+1)%10==z)
        {
            if ((x+y+1)>=10)
                cnt[1][1]++;
            else {
                cnt[1][0]++;
                if (x==0||y==0||z==0)
                    cnt10++;
            }
        }
        else
        {
            cout<<0<<'\n';
            return;
        }
    }
    if (cnt[0][1]!=cnt[1][0])
    {
        cout<<0<<'\n';
        return;
    }
    vector <int> g={cnt[0][0],cnt[0][1],cnt[1][0],cnt[1][1]};
    int ans0=0,ans2=0;
    int per = cnt[0][1]; // количество прегородок
    int a=cnt[0][0];
    int b=cnt[1][1];
    if (cnt[0][1]==0)
    {
        if (a==0)
        {
            cout<<0<<'\n';
            return;
        }
        if (b>0)
        {
            cout<<0<<'\n';
            return;
        }
        ans0=1;
    }
    else {
        if (n<=750) {
            for (int i = 0; i <= a; i++) {
                dp[i][b][0] = 1;
            }
            rep(iii, 2 * per - 1) {
                for (int j = b; j >= 0; j--) {
                    for (int i = a; i >= 0; i--)
                        suf[i][j][1] = add(suf[i + 1][j][1], dp[i][j][1]);
                }
                for (int i = a; i >= 0; i--) {
                    for (int j = b; j >= 0; j--)
                        suf[i][j][0] = add(suf[i][j + 1][0], dp[i][j][0]);
                }
                for (int i = 0; i <= a; i++) {
                    for (int j = 0; j <= b; j++) {
                        for (int now = 0; now < 2; now++) {
                            if (now == 1) {
                                dp[i][j][now] = suf[i][j][1 - now];
                            }
                            if (now == 0) {
                                dp[i][j][now] = suf[i][j][1 - now];
                            }
                        }
                    }
                }
            }
            ans2 = dp[0][0][1];
            for (int i = 1; i <= a; i++) {
                ad(ans0, dp[i][0][1]);
            }
        }
        else
        {
            ans0=mult(C(a+per,per),C(b+per,per));
        }
    }
    int ans=mult(fact[g[1]],fact[g[3]]);
    int sum=0;
    sum=add(sum,mult(mult(fact[g[2]],(cnt00==g[0]?0:mult(g[0]-cnt00,fact[g[0]-1]))),ans0));
    sum=add(sum,mult(mult(fact[g[0]],(cnt10==g[2]?0:mult(g[2]-cnt10,fact[g[2]-1]))),ans2));
    ans=mult(ans,sum);
    cout<<ans<<'\n';
}

int main()
{
    #ifdef Mip182
    freopen("a.in","r",stdin);
    #else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #endif
    fact[0]=1;
    for (int i=1;i<MAXN;i++)
        fact[i]=mult(fact[i-1],i),ifact[i]=bin_pow(fact[i],mod1-2);
    int _t=1;
    while (_t--)
        solve();
}
