#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#include "string"
using namespace std;
typedef long long ll;
#define __int128 ll
__int128 vval(__int128 n, __int128 m, __int128 k){
    __int128 leftval = k * (k + 1) / 2 * n;
    leftval += (n - 1) * n / 2 * m * k;
    __int128 rightval = (n * m + 1) * n * m / 2 - leftval;
    return rightval - leftval;
}
__int128 hval(__int128 n, __int128 m, __int128 k){
    __int128 upval = m * (m + 1) / 2 * k;
    upval += (k - 1) * k / 2 * m * m;
    __int128 downval = (n * m + 1) * n * m / 2 - upval;
    return downval - upval;
}
void solve(){
    ll n, m;
    cin >> n >> m;
    __int128 l = 0, r = m;
    while (l + 1 < r){
        __int128 mm = (l + r) / 2;
        if (vval(n, m, mm) > 0){
            l = mm;
        } else{
            r = mm;
        }
    }
    pair<__int128, int> vans = {vval(n, m, l), l};
    if (vans.first > -vval(n, m, r)){
        vans.first = -vval(n, m, r);
        vans.second = r;
    }
    l = 0, r = n;
    while (l + 1 < r){
        __int128 mm = (l + r) / 2;
        if (hval(n, m, mm) > 0){
            l = mm;
        } else{
            r = mm;
        }
    }
    pair<__int128, int> hans = {hval(n, m, l), l};
    if (hans.first > -hval(n, m, r)){
        hans.first = -hval(n, m, r);
        hans.second = r;
    }
    if (hans.first < vans.first){
        cout << "H " << hans.second + 1 << '\n';
    } else{
        cout << "V " << vans.second + 1 << '\n';
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);cout.tie(nullptr);
    int k;
    cin >> k;
    while (k--)
        solve();
}
