// Задача Хорошие раскраски.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
using namespace std;
vector<vector<int>> a;
int n, m, c;
bool ans = false;

bool good() {
    for (int x1 = 0; x1 < m; x1++) {
        for (int y1 = 0; y1 < n; y1++) {
            for (int x2 = x1 + 1; x2 < m; x2++) {
                for (int y2 = y1 + 1; y2 < n; y2++) {
                    vector<int> res(4, 0);
                    res[a[y1][x1]]++; res[a[y2][x2]]++;
                    res[a[y1][x2]]++; res[a[y2][x1]]++;
                    if (res[1] == 4 || res[2] == 4 || res[3] == 4)
                        return false;
                }
            }
        }
    }
    return true;
}

bool bad(int x, int y, int cur) {
    for (int i = 0; i < x; i++) {
        for (int j = 0; j < y; j++) {
            vector<int> res(4, 0);
            res[a[i][j]]++; res[cur]++;
            res[a[i][y]]++; res[a[x][j]]++;
            if (res[1] == 4 || res[2] == 4 || res[3] == 4)
                return true;
        }
    }
    return false;
}

void func(int x, int y) {
    if (ans) return;
    if (a[n - 1].size() == m) {
        ans = true;
        for (auto c : a) {
            for (auto v : c)
                cout << v << ' ';
            cout << '\n';
        }
        return;
    }
    pair<int, int> next = (y + 1 == m ? pair<int, int>{x + 1, 0} : pair<int, int>{x, y+1});
    for (int cur = 1; cur <= c; cur++) {
        if (bad(x, y, cur)) continue;
        a[x].push_back(cur);
        func(next.first, next.second);
        if (ans) return;
        a[x].pop_back();
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> c;
    a.resize(n);
    func(0, 0);
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
