// Задача A+B.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;
const ll mod = 1000000007;

ll fact(ll x) {
    ll res = 1;
    for (ll i = 2; i <= x; i++)
        res = (res * i) % mod;
    return res;
}

int main()
{
    string a, b, c;
    cin >> a >> b >> c;
    ll n = a.size();
    ll plus = 0, minus = 0;
    for (ll i = 0; i < n; i++) {
        ll v1 = a[i] - '0', v2 = b[i] - '0', v3 = c[i] - '0';
        if (v1 + v2 + 1 == v3) plus++;
        else if (v1 + v2 - 10 == v3) minus++;
        else if (v1 + v2 != v3) {
            cout << 0;
            return 0;
        }
    }
    cout.precision(20);
    if (plus != minus) {
        cout << 0;
        return 0;
    }
    cout << (fact(plus) * fact(n - plus)) % mod;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
