#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

long long t, n, m, s;

int vert(long long i) {

    long long x = (2 + (n - 1) * m) * n / 2;
    x = (2 * x + i * n) * (i + 1) / 2;
    return abs(s - 2 * x);

}

int hor(long long i) {

    long long x = (m + 1) * m / 2;
    x = (2 * x + i * m * m) * (i + 1) / 2;
    return abs(s - 2 * x);

}

int ternarvert(long long l, long long r) {
    if (l >= r) return l;
    long long f = l + (r - l) / 3, s = r - (r - l) / 3;
    if (vert(l) >= vert(f) & vert(s) <= vert(r)) return ternarvert(f + 1, s - 1);
    else if (vert(l) >= vert(f) & vert(f) >= vert(s)) return ternarvert(s + 1, r - 1);
    else if (vert(f) <= vert(s) & vert(s) <= vert(r)) return ternarvert(l + 1, f - 1);
}

int ternarhor(long long l, long long r) {
    if (l >= r) return l;
    long long f = l + (r - l) / 3, s = r - (r - l) / 3;
    if (hor(l) >= hor(f) & hor(s) <= hor(r)) return ternarhor(f + 1, s - 1);
    else if (hor(l) >= hor(f) & hor(f) >= hor(s)) return ternarhor(s + 1, r - 1);
    else if (hor(f) <= hor(s) & hor(s) <= hor(r)) return ternarhor(l + 1, f - 1);
}

 int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> t;
    for (long long i = 0; i < t; ++i) {
        cin >> n >> m;
        s = (n * m + 1) * (n * m) / 2;
        long long vindt = ternarvert(0, m - 2), hindt = ternarhor(0, n - 2), vind = vindt, hind = hindt;
        for (int i = max(vindt - 10, (long long) 0); i <= min(vindt + 10, (long long) m - 2); ++i) {
            if (vert(i) < vert(vind)) vind = i;
        }
        for (int i = max(hindt - 10, (long long) 0); i <= min(hindt + 10, (long long) n - 2); ++i) {
            if (hor(i) < hor(hind)) hind = i;
        }
        if (vert(vind) <= hor(hind)) cout << "V " << vind + 2 << '\n';
        else cout << "H " << hind + 2 << '\n';
    }
    return 0;
}
