#include<iostream>
#include<string>

using namespace std;

string tostr(int a) {

    string res = "";
    while (a > 0) {
        int d = a % 10;
        a = a / 10;
        res = (char) (d + 48) + res;
    }
    return res;
}

string encode(string s) {

    string res = "";
    s += '#';
    int n = 1;
    for (int i = 0; i < s.size() - 1; ++i) {
        if (s[i] != s[i + 1]) {
            if (n > 1) {
                res += tostr(n) + s[i];
            }
            else res += s[i];
            n = 1;
        }
        else n += 1;
    }
    return res;
}

bool isdigit(string s) {

    return (s == "0" | s == "1" | s == "2" | s == "3" | s == "4" | s == "5" | s == "6" | s == "7" | s == "8" | s == "9");

}

int todigit(char s) {

    if (s == '0') return 0;
    else if (s == '1') return 1;
    else if (s == '2') return 2;
    else if (s == '3') return 3;
    else if (s == '4') return 4;
    else if (s == '5') return 5;
    else if (s == '6') return 6;
    else if (s == '7') return 7;
    else if (s == '8') return 8;
    else if (s == '9') return 9;
}

string decode(string s) {

    string res = "";
    int n = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (isdigit(s[i])) {
            n = n * 10 + todigit(s[i]);
        }
        else {
            if (n == 0) {
                res += s[i];
            }
            else {
                for (int j = 0; j < n; ++j) res += s[i];
                n = 0;
            }
        }
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s, str, temp, let = "ACGT";
    cin >> s;
    int mn = 2E9, mx = 0, mnt = 0, mxt = 0, mnx = 0, mxx = 0;
    string mnz = "", mxz = "";
    mx = s.size();
    mn = s.size();
    str = decode(s);
    for (int i = 0; i < str.size(); ++i) {
        for (int j = 1; j <= 3; ++j) {
            if (j == 1) {
                for (int k = 0; k <= 3; ++k) {
                    temp = "";
                    for (int l = 0; l <= i; ++l) temp += str[l];
                    temp += let[k];
                    for (int l = i + 1; l < str.size(); ++l) temp += str[l];
                    temp = encode(temp);
                    if (temp.size() >= mx) {
                        mx = temp.size();
                        mxt = 1;
                        mxx = i + 1;
                        mxz = let[k];
                    }
                    if (temp.size() <= mn) {
                        mn = temp.size();
                        mnt = 1;
                        mnx = i + 1;
                        mnz = let[k];
                    }

                }
            }
            else if (j == 2) {
                temp = "";
                for (int l = 0; l < i; ++l) temp += str[l];
                for (int l = i + 1; l < str.size(); ++l) temp += str[l];
                temp = encode(temp);
                if (temp.size() >= mx) {
                    mx = temp.size();
                    mxt = 2;
                    mxx = i + 1;
                }
                if (temp.size() <= mn) {
                    mn = temp.size();
                    mnt = 2;
                    mnx = i + 1;
                }
            }
            else {
                for (int k = 0; k <= 3; ++k) {
                    if (let[k] == str[i]) continue;
                    temp = "";
                    for (int l = 0; l < i; ++l) temp += str[l];
                    temp += let[k];
                    for (int l = i + 1; l < str.size(); ++l) temp += str[l];
                    temp = encode(temp);
                    if (temp.size() >= mx) {
                        mx = temp.size();
                        mxt = 3;
                        mxx = i + 1;
                        mxz = let[k];
                    }
                    if (temp.size() <= mn) {
                        mn = temp.size();
                        mnt = 3;
                        mnx = i + 1;
                        mnz = let[k];
                    }
                }
            }
        }
    }
    if (mnt == 2) cout << mnt << ' ' << mnx << '\n';
    else cout << mnt << ' ' << mnx << ' ' << mnz << '\n';
    if (mxt == 2) cout << mxt << ' ' << mxx << '\n';
    else cout << mxt << ' ' << mxx << ' ' << mxz << '\n';
}
