#include<iostream>
#include<vector>
#include<cmath>

using namespace std;

bool good(long long x, long long k) {

    vector<long long> dig (10, 0);
        while (x > 0) {
            ++dig[x % 10];
            x = x / 10;
        }
        long long cone = 0, coth = 0;
        for (int i = 0; i < 10; ++i) {
            if (dig[i] == 1) ++cone;
            else if (dig[i] != 1 & dig[i] != 0) ++coth;
        }
        return (cone == 1 & coth == 1 & k == 1) | (cone == 0 & coth == 1 & k == 0);
}

long long gen0(long long ex, long long old) {

    long long res = old;
    for (long long i = 0; i < ex; ++i) res = res * 10 + old;
    return res;

}

long long gen1 (long long ex, long long old, long long k) {

    long long res = x;
    while (!good(res, k)) {
        ++res;
    }
    return res;

}

int main() {

    long long x, k;
    cin >> x >> k;
    if (good(x, k)) {
        cout << x << '\n';
        return 0;
    }
    long long ex = floor(log10(x));
    long long old = x / (long long) pow(10, ex);
    long long y = 0;
    if (k == 0) {
        y = gen0(ex, old);
        if (y < x) y = gen0(ex, old + 1);
    }
    else {
        y = gen1(ex, old, 0);
    }
    cout << y << '\n';
    return 0;
}
