#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

bool good(long long x, long long k) {

    vector<long long> dig (10, 0);
    long long ex = floor(log10(x));
    while (x > 0) {
        ++dig[x % 10];
        x = x / 10;
    }
    return (*max_element(dig.begin(), dig.end()) == ex & k == 1) | (*max_element(dig.begin(), dig.end()) == ex + 1 & k == 0);
}

long long gen0(long long ex, long long old) {

    long long res = old;
    for (long long i = 0; i < ex; ++i) res = res * 10 + old;
    return res;

}

long long gen1 (long long x, long long k) {

    long long res = x;
    while (!good(res, k)) {
        ++res;
    }
    return res;

}

int main() {

    long long x, k;
    cin >> x >> k;
    if (good(x, k)) {
        cout << x << '\n';
        return 0;
    }
    long long ex = floor(log10(x));
    long long old = x / (long long) pow(10, ex);
    long long y = 0;
    if (k == 0) {
        y = gen0(ex, old);
        if (y < x) y = gen0(ex, old + 1);
    }
    else {
        y = gen1(x, k);
    }
    cout << y << '\n';
    return 0;
}
