#include <bits/stdc++.h>

#define int long long
#define pb push_back

using namespace std;

// A G C T

string s;
vector<pair<int, char>> a;
vector<int> pref_len;
int n;

int get(pair<int, char> t) {
	return (t.first == 1 ? 0 : to_string(t.first).size()) + 1;
}

int get(int num, char c) {
	return (num == 1 ? 0 : to_string(num).size()) + 1;
}

int get_len(int l, int r) {
	if (l > r) return 0;
	return pref_len[r + 1] - pref_len[l];
}

char other(char c) {
	return (c == 'A' ? 'G' : 'A');
}

void find_min() {
	int ans = s.size();
	int t = 2, x = 1;
	char c = 'A';

	// delete
	for (int i = 0; i < n; i++) {
		if (a[i].first == 1) {
			ans = ans - 1;
			t = 2;
			x = get_len(0, i - 1) + 1;
			break;
		}
		string num_s = to_string(a[i].first);
		if ((int) num_s.size() > (int) to_string(a[i].first - 1).size()) {
			ans = ans - 1;
			t = 2;
			x = get_len(0, i - 1) + 1;
			break;
		}
	}

	// merge the consistances
	for (int i = 1; i < n - 1; i++) {
		if (a[i].first == 1 && a[i - 1].second == a[i + 1].second) {
			// merge
			int new_a = a[i - 1].first + a[i + 1].first;
			int tans = get(0, i - 2) + get(i + 2, n - 1) + to_string(new_a).size() + 1;
			if (tans < ans) {
				ans = tans;
				t = 2;
				x = get_len(0, i - 1) + 1;
				// cout << "break " << i << "\n";
			}
		}
	}
	if (t == 2) {
		cout << t << " " << x << "\n";
	} else {
		cout << t << " " << x << " " << c << "\n";
	}
}

void find_max() {
	int ans = s.size() + 1;
	int t = 1, x = 0;
	char c = (a[0].second == 'A' ? 'G' : 'A');

	// break the consistance
	for (int i = 0; i < n; i++) {
		if (a[i].first >= 2) {
			// break
			string num_s = to_string(a[i].first);
			int f = num_s[0] - '0';

			int d = a[i].first / 2;
			int e = a[i].first - d;
			int tans = get(0, i - 1) + get(i + 1, n - 1) + to_string(d).size() + to_string(e).size() + 3;
			if (tans > ans) {
				ans = tans;
				t = 1;
				x = get_len(0, i - 1) + d;
				c = other(a[i].second);
			}
		}
	}
	cout << t << " " << x << " " << c << "\n";
}

void solve() {
	cin >> s;
	int t = 0;
	for (auto e : s) {
		if ('0' <= e && e <= '9') {
			t = t * 10 + (e - '0');
		} else {
			if (t == 0) t = 1;
			a.pb({t, e});
			t = 0;
		}
	}
	n = a.size();
	pref_len.assign(n + 1, 0);
	for (int i = 0; i < n; i++) {
		pref_len[i + 1] = pref_len[i] + a[i].first;
	}
	// for (auto e : a) cout << e.first << " " << e.second << endl;
	// for (auto e : pref_len) cout << e << " "; cout << endl;
	// cout << "get = " << get_len(0, 0) << endl;

	find_min();
	find_max();
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}
