//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")


#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

#define INF 1e9
#define INF_LL 1e18
#define endl '\n'

using namespace std;

typedef int64_t ll;

signed main() {
    int n; cin >> n;
    vector<vector<int>> bd(n);
    int ndlen = -1;
    int c = 0;
    for (auto& it : bd) {
        int m, l; cin >> m >> l;
        it.resize(3);
        it[2] = c++;
        cin >> it[0];
        if (m == 1) {
            it[1] = l - it[0];
        } else {
            int prv = it[0];
            for (int i = 0; i < m - 1; ++i) {
                int tmp; cin >> tmp;
                int cur = tmp - prv;
                if (ndlen == -1) {
                    ndlen = cur;
                } else if (ndlen != cur) {
                    cout << "No\n";
                    return 0;
                }
                if (i == m - 2) {
                    it[1] = l - tmp;
                }
                prv = tmp;
            }
        }
    }
    sort(bd.begin(), bd.end());
    auto cur = bd;
    while (true) {
        int newnd = ndlen;
        bool ok = true;
        for (int i = 0; i + 1 < bd.size(); ++i) {
            int cur = bd[i][1] + bd[i + 1][0];
            if (newnd == -1) {
                newnd = cur;
            }
            if (newnd != cur) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << "Yes\n";
            for (auto& it : bd) cout << it[2] + 1 << " ";
            return 0;
        }
        if (!next_permutation(bd.begin(), bd.end())) break;
    }
    cout << "No";
    return 0;
}

//3
//1 7
//3
//1 8
//6
//2 8
//1 6

//1
//1 7
//5

//1
//3 10
//2 5 9

//3
//1 5
//3
//1 3
//3
//1 6
//3

//4
//1 5
//0
//1 0
//0
//1 3
//3
//1 0
//0