#include<iostream>
#include<cmath>
using namespace std;

long long getSum(long long a, long long b){
	if((b + a) % 2 == 0)
		return (b + a) / 2 * (b - a + 1);
	return (b - a + 1) / 2 * (b + a);
}

int main(){
	long long t;
	cin >> t;
	for(long long q = 0; q < t; q++)
	{
		long long n, m;
		cin >> n >> m;
		
		long long l = 0, r = n;
		while(l + 1 != r){
			long long md = (l + r) / 2;
			long long x, y;
			x = getSum(1, md * m);
			y = getSum(md * m + 1, m * n);
			if(x <= y){
				l = md;
			}
			else{
				r = md;
			}
		}
		long long res;
		long long d1 = abs(getSum(1, l * m) - getSum(l * m + 1, m * n));
		long long d2 = abs(getSum(1, r * m) - getSum(r * m + 1, m * n));
		if(d1 <= d2)
			res = l;
		else
			res = r;
		long long rd = abs(getSum(1, res * m) - getSum(res * m + 1, m * n));
		
		//cout << l << " ";
		
		l = 0;
		r = m;
		while(l + 1 != r){
			long long md = (l + r) / 2;
			long long x, y;
			x = getSum(1, md) * n + md * getSum(0, n-1) * m;
			y = getSum(1, n*m) - x; 
			if(x <= y){
				l = md;
			}
			else{
				r = md;
			}
		}
		
		long long res1;
		long long d3 = abs(getSum(1, n*m) - 2 * (getSum(1, l) * n + l * getSum(0, n-1) * m));
		long long d4 = abs(getSum(1, n*m) - 2 * (getSum(1, r) * n + r * getSum(0, n-1) * m));
		if(d3 <= d4)
			res1 = l;
		else
			res1 = r;
		long long rd1 = abs(getSum(1, n*m) - 2 * (getSum(1, res1) * n + res1 * getSum(0, n-1) * m));
		
		//cout << l << endl;
		//cout << rd << " " << rd1 << endl;
		if(rd1 <= rd)
			cout << "V " << res1 + 1;
		else
			cout << "H " << res + 1;
		cout << "\n";
		//cout << d1 << " " << d2 << " " << d3 << " " << d4 << "\n";
	}
}

/*
5
1 3 4 7 1 10 3 3 3 5
*/
