#include <iostream>
#include <string>

typedef long long ll;

using namespace std;

ll findAllSame(ll x) {
    string strNum = to_string(x);
    int n = strNum.length();
    char f = strNum[0];
    bool flag = true;
    for (int i = 1; i < n; i++) {
        if (strNum[i] != f) {
            flag = false;
        }
    }
    if (flag) {
        return x;
    }
    char nextChar = strNum[0];
    int dig = nextChar - '0';
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ans *= 10;
        ans += dig;
    }
    if (ans < x) {
        dig = (int) nextChar - '0';
        dig++;
        ans = 0;
        for (int i = 0; i < n; i++) {
            ans *= 10;
            ans += dig;
        }
    }
    return ans;
}

bool check(ll x) {
    string strNum = to_string(x);
    int n = strNum.length();
    if (n == 1) return true;
    int cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < n; i++) {
        if (strNum[i] == strNum[0]) cnt1++;
        if (strNum[i] == strNum[1]) cnt2++;
    }
    return cnt1 >= n - 1 || cnt2 >= n - 1;
}

ll stupidFind(ll x) {
    for (ll y = x;;y++) {
        if (check(y)) return y;
    }
}

int main() {
    ll x; cin >> x;
    int k; cin >> k;
    if (k == 0) {
        cout << findAllSame(x) << endl;
    } else {
        cout << stupidFind(x) << endl;
    }
}