#include <iostream>
#include <vector>
#include <map>

using namespace std;

const int MOD = 1e9 + 7;

const int MAX_N = 20;
map<int, map<int, map<int, map<int, map<int, map<int, map<int, int>>>>>>> dp;
map<int, map<int, map<int, map<int, map<int, map<int, map<int, bool>>>>>>> calculated;

int calc(int a, int b, int c, int d, int can_a, int can_c, int now) {
    if (a < 0 || b < 0 || c < 0 || d < 0 || can_a < 0 || can_c < 0) return 0;
//    cout << a << ' ' << b << ' ' << c << ' ' << d << ' ' << can_a << ' ' << can_c << ' ' << now << endl;
    if (!calculated[a][b][c][d][can_a][can_c][now]) {
        if (a == 0 && b == 0 && c == 0 && d == 0 && can_a == 0 && can_c == 0) {
            dp[a][b][c][d][can_a][can_c][now] = ((now & (1 << 2)) != 0);
        } else if (now == 0b000 || now == 0b100) {
            dp[a][b][c][d][can_a][can_c][now] = (a * 1ll * calc(a - 1, b, c, d, can_a, can_c, 0b000) + b * 1ll * calc(a, b - 1, c, d, can_a, can_c, 0b001) +
                    can_a * 1ll * calc(a, b, c, d, can_a - 1, can_c, 0b100)) % MOD;
        } else if (now == 0b011) {
            dp[a][b][c][d][can_a][can_c][now] = (d * 1ll * calc(a, b, c, d - 1, can_a, can_c, 0b11) + c * 1ll * calc(a, b, c - 1, d, can_a, can_c, 0b010) +
                    + calc(a, b, c, d, can_a, can_c - 1, 0b110)) % MOD;
        } else if (now == 0b001) {
            dp[a][b][c][d][can_a][can_c][now] = (c * 1ll * calc(a, b, c - 1, d, can_a, can_c, 0b010) + d * 1ll * calc(a, b, c, d - 1, can_a, can_c, 0b011) +
                    can_c * 1ll * calc(a, b, c, d, can_a, can_c - 1, 0b110)) % MOD;
        } else if (now == 0b010 || now == 0b110) {
            dp[a][b][c][d][can_a][can_c][now] = (a * 1ll * calc(a - 1, b, c, d, can_a, can_c, 0b000) + b * 1ll * calc(a, b - 1, c, d, can_a, can_c, 0b001) +
                    can_a * 1ll * calc(a - 1, b, c, d, can_a - 1, can_c, 0b100)) % MOD;
        } else {
            dp[a][b][c][d][can_a][can_c][now] =
                    (a * 1ll * calc(a - 1, b, c, d, can_a, can_c, 0b000) + b * 1ll * calc(a, b - 1, c, d, can_a, can_c, 0b001) + c * 1ll * calc(a, b, c - 1, d, can_a, can_c, 0b010) +
                    d * 1ll * calc(a, b, c, d - 1, can_a, can_c, 0b011) +
                    can_a * 1ll * calc(a, b, c, d, can_a - 1, can_c, 0b100) + can_c * 1ll * calc(a, b, c, d, can_a, can_c - 1, 0b110)) % MOD;
        }
    }
    calculated[a][b][c][d][can_a][can_c][now] = true;
    return dp[a][b][c][d][can_a][can_c][now];
}

int main() {
    string s1, s2, s3; cin >> s1 >> s2 >> s3;
    int n = s1.length();
    int a = 0, b = 0, c = 0, d = 0;
    int can_a = 0, can_c = 0;
    for (int i = 0; i < n; i++) {
        int u = s1[i] - '0', v = s2[i] - '0', w = s3[i] - '0';
        if (u + v == w) {
            if (u != 0 && w != 0) can_a++;
            else a++;
        }
        if (u + v + 1 == w) {
            if (u != 0 && w != 0) can_c++;
            else c++;
        }
        if (u + v == w + 10) {
            b++;
        }
        if (u + v + 1 == w + 10) d++;
    }
    cout << calc(a, b, c, d, can_a, can_c, 8);
}