#include <bits/stdc++.h>

using namespace std;

//#define int long long

string Calc(string s)
{
    if (s.size() == 0)
    {
        return s;
    }
    char ch = s[0];
    string ans = "";
    for (int i = 0; i < s.size(); ++i)
    {
        ans = ans + ch;
    }
    if (ans >= s)
    {
        return ans;
    }
    ch = s[0] + 1;
    ans = "";
    for (int i = 0; i < s.size(); ++i)
    {
        ans = ans + ch;
    }
    return ans;
}

string Normalize(string s)
{
    string ans = "";
    bool is_zero = true;
    for (int i = 0; i < s.size(); ++i)
    {
        if (is_zero && s[i] == '0')
        {
            continue;
        }
        if (is_zero)
        {
            is_zero = false;
        }

        ans = ans + s[i];
    }
    if (ans == "")
    {
        return "0";
    }
    return ans;
}

bool Less(string lhs, string rhs)
{
    lhs = Normalize(lhs);
    rhs = Normalize(rhs);
    if (lhs.size() == rhs.size())
    {
        for (int i = 0; i < lhs.size(); ++i)
        {
            if (lhs[i] == rhs[i])
            {
                continue;
            }
            return (lhs[i] < rhs[i]);
        }
        return false;
    }
    return lhs.size() < rhs.size();
}

string CCalc(string s, int is_good)
{
    if (!is_good)
    {
        return Calc(s);
    }

    string ans = Calc(s);
    for (int i = 0; i < s.size(); ++i)
    {
        string ns = "";
        for (int j = 0; j < s.size(); ++j)
        {
            if (j == i)
            {
                continue;
            }
            ns = ns + s[j];
        }
        string ansn = Calc(ns);
        while (ansn.size() < s.size() - 1)
        {
            ansn = '0' + ansn;
        }
        string ansr = "";
        int d = 0;
        for (int j = 0; j < s.size(); ++j)
        {
            if (j == i)
            {
                ansr = ansr + s[i];
                continue;
            }
            ansr = ansr + ansn[d++];
        }
        if (Less(ansr, ans))
        {
            ans = ansr;
        }
    }
    return ans;
}

string CCalc2(string s, int is_good)
{
    if (!is_good)
    {
        return Calc(s);
    }

    string ans = Calc(s);
    for (int i = 0; i < s.size(); ++i)
    {
        string ns = s;
        ns[i] = '0';
        ns = Normalize(ns);
        string ansn = Calc(ns);
        while (ansn.size() < s.size() - 1)
        {
            ansn = '0' + ansn;
        }
        string ansr = "";
        int d = 0;
        for (int j = 0; j < s.size(); ++j)
        {
            if (j == i)
            {
                ansr = ansr + '0';
                continue;
            }
            ansr = ansr + ansn[d++];
        }
        for (int j = '0'; j <= '9'; ++j)
        {
            ansr[i] = j;
            if (Less(ansr, ans) && !Less(ansr, s))
            {
                ans = ansr;
            }
        }
    }
    return ans;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);

    string s;
    cin >> s;

    int is_good;
    cin >> is_good;

    cout << CCalc2(s, is_good);
    /*
    for (int i = 1; i < 200; ++i)
    {
        string s;
        int ii = i;
        while (ii > 0)
        {
            s = s + (char) ('0' + ii % 10);
            ii /= 10;
        }
        reverse(s.begin(), s.end());
        cout << s << ' ' << CCalc2(s, 1) << '\n';
    }*/

    return 0;
}
