#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
using namespace std;
long long n, m;


unsigned long long check_v(long long i)
{
    return abs((((1 + (n - 1) * m + i + 1) * n * (i + 1)) / 2) - (((i + 2 + m * n) * n * (m - i - 1)) / 2));
}


long long tren_search_v()
{
    long long m1, m2, l = 0, r = m - 1;
    m1 = l + (r - l) / 3;
    m2 = r - (r - l) / 3;
    while (r - l > 2)
    {
        m1 = l + (r - l) / 3;
        m2 = r - (r - l) / 3;
        if (check_v(m1) > check_v(m2))
        {
            l = m1;
        }
        else
        {
            r = m2;
        }
    }
    long long x = check_v((m1 + m2) / 2), x1 = check_v(m1), x2 = check_v(m2), mn;
    mn = min(x, min(x1, x2));
    if (x == mn)
    {
        return (m1 + m2) / 2;
    }
    else if (x1 == mn)
    {
        return m1;
    }
    else
    {
        return m2;
    }
}


unsigned long long check_h(long long i)
{
    return abs((((1 + m * (i + 1)) * m * (i + 1)) / 2) - (((m * (i + 1) + 1 + m * n) * m * (n - i - 1)) / 2));
}


long long tren_search_h()
{
    long long m1, m2, l = 0, r = n - 1;
    m1 = l + (r - l) / 3;
    m2 = r - (r - l) / 3;
    while (r - l > 2)
    {
        m1 = l + (r - l) / 3;
        m2 = r - (r - l) / 3;
        if (check_h(m1) > check_h(m2))
        {
            l = m1;
        }
        else
        {
            r = m2;
        }
    }
    long long x = check_h((m1 + m2) / 2), x1 = check_h(m1), x2 = check_h(m2), mn;
    mn = min(x, min(x1, x2));
    if (x == mn)
    {
        return (m1 + m2) / 2;
    }
    else if (x1 == mn)
    {
        return m1;
    }
    else
    {
        return m2;
    }
}


int main()
{
    long long t;
    pair<char, long long> ans;
    ans.first = 'V';
    ans.second = 1;
    cin >> t;
    for (long long i_ = 0; i_ < t; i_++)
    {
        cin >> n >> m;
        long long mn = 1000000000000, i;
        if (m > 1)
        {
            i = tren_search_v();
            if (mn > abs((((1 + (n - 1) * m + i + 1) * n * (i + 1)) / 2) - (((i + 2 + m * n) * n * (m - i - 1)) / 2)))
            {
                mn = abs(((1 + (n - 1) * m + i + 1) * n * (i + 1) / 2) - ((i + 2 + m * n) * n * (m - i - 1) / 2));
                ans.first = 'V';
                ans.second = i + 2;
            }
        }
        if (n > 1)
        {
            i = tren_search_h();
            if (mn > abs((((1 + m * (i + 1)) * m * (i + 1)) / 2) - (((m * (i + 1) + 1 + m * n) * m * (n - i - 1)) / 2)))
            {
                mn = abs((((1 + m * (i + 1)) * m * (i + 1)) / 2) - (((m * (i + 1) + 1 + m * n) * m * (n - i - 1)) / 2));
                ans.first = 'H';
                ans.second = i + 2;
            }
        }
        cout << ans.first << ' ' << ans.second << endl;
    }
}

