#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
using namespace std;


int to_int(string s)
{
    int ans = 0;
    int ln = s.size();
    for (int i = 0; i < ln; i++)
    {
        ans += pow(10, ln - 1 - i) * (s[i] - '0');
    }
    return ans;
}


int factorial(int x)
{
    int ans = 1;
    for (int i = 1; i <= x; i++)
    {
        ans *= i;
    }
    return ans;
}


int main()
{
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.size();
    int x = factorial(n);
    string perm = "";
    for (int i = 0; i < n; i++)
    {
        perm += i + 48;
    }
    int ans = 0;
    for (int i = 0; i < x; i++)
    {
        string a_n = "", b_n = "", c_n = "";
        for (auto each : perm)
        {
            a_n += a[each - 48];
            b_n += b[each - 48];
            c_n += c[each - 48];
        }
        if ((a_n[0] != '0') && (b_n[0] != '0') && (c_n[0] != '0') and (to_int(a_n) + to_int(b_n) == to_int(c_n)))
        {
            ans++;
        }
        next_permutation(perm.begin(), perm.end());
    }
    cout << ans;
}
