#include <bits/stdc++.h>

#define all(a) begin(a), end(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    string s;
    cin >> s;

    int n = s.size();

    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        x[i] = s[i] - '0';
    }

    int k;
    cin >> k;

    if (k == 0) {
        int d_pref = x[0];
        int pref_len = 1;
        for (int i = 1; i < n && x[i] == d_pref; ++i) {
            ++pref_len;
        }
        int suf_len = n - pref_len;
        vector<int> cur_suf(x.begin() + pref_len, x.end());
        vector<int> suf_option(suf_len, d_pref);

        vector<int> y = x;

        if (cur_suf == suf_option || lexicographical_compare(all(cur_suf), all(suf_option))) {
            copy(all(suf_option), y.begin() + pref_len);
        }
        else {
            fill(all(y), d_pref + 1);
        }

        for (int i = 0; i < n; ++i) {
            cout << y[i];
        }
    }

    return 0;
}
