#include <bits/stdc++.h>

#define all(a) begin(a), end(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

ll p[19];

int len(ll n) {
    int l = 0;
    while (n > 0) {
        ++l;
        n /= 10;
    }
    return l;
}

ll digit(ll x, int n, int pos) {
    return x / p[n - pos - 1] % 10;
}

ll pref(ll x, int n, int pref_len) {
    return x / p[n - pref_len];
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    p[0] = 1;
    for (int i = 1; i <= 18; ++i) {
        p[i] = p[i - 1] * 10;
    }

    string s;
    cin >> s;

    int k;
    cin >> k;

    if (k == 0) {
        int n = s.size();

        vector<int> x(n);
        for (int i = 0; i < n; ++i) {
            x[i] = s[i] - '0';
        }

        int d_pref = x[0];
        int pref_len = 1;
        for (int i = 1; i < n && x[i] == d_pref; ++i) {
            ++pref_len;
        }
        int suf_len = n - pref_len;
        vector<int> cur_suf(x.begin() + pref_len, x.end());
        vector<int> suf_option(suf_len, d_pref);

        vector<int> y = x;

        if (cur_suf == suf_option || lexicographical_compare(all(cur_suf), all(suf_option))) {
            copy(all(suf_option), y.begin() + pref_len);
        }
        else {
            fill(all(y), d_pref + 1);
        }

        for (int i = 0; i < n; ++i) {
            cout << y[i];
        }
    }
    else {
        ll x = stoll(s);

        int n = len(x);

        ll dp[n][10][10][2];

        memset(dp, -1, sizeof(dp));

        for (int d = 0; d <= 9; ++d) {
            for (int k = 0; k <= 9; ++k) {
                if (d < digit(x, n, 0)) {
                    dp[0][d][k][d != k] = -1;
                }
                else {
                    dp[0][d][k][d != k] = d;
                }
            }
        }

        for (int i = 1; i < n; ++i) {
            for (int d = 0; d <= 9; ++d) {
                for (int k = 0; k <= 9; ++k) {
                    for (int c = 0; c <= 1; ++c) {
                        if (d != k && c != 1) {
                            dp[i][d][k][c] = -1;
                        }
                        else {
                            int pc = c - (d != k);
                            for (int pd = 0; pd <= 9; ++pd) {
                                if (dp[i - 1][pd][k][pc] == -1)
                                    continue;
                                ll option = dp[i - 1][pd][k][pc] * 10 + d;
                                if (option >= pref(x, n, i + 1) && (dp[i][d][k][c] == -1 || option < dp[i][d][k][c])) {
                                    dp[i][d][k][c] = option;
                                }
                            }
                        }
                    }
                }
            }
        }

        ll ans = -1;
        for (int d = 0; d <= 9; ++d) {
            for (int k = 0; k <= 9; ++k) {
                for (int c = 0; c <= 1; ++c) {
                    if (dp[n - 1][d][k][c] != -1) {
                        if (ans == -1) {
                            ans = dp[n - 1][d][k][c];
                        }
                        else {
                            ans = min(ans, dp[n - 1][d][k][c]);
                        }
                    }
                }
            }
        }

        cout << ans;
    }

    return 0;
}
