#include <bits/stdc++.h>

#define dbg(x) #x << "=" << x

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

vector<vector<int>> a;
int c;

void print() {
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < a[i].size(); ++j) {
            cout << a[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "\n";
}

bool check() {
    for (int li = 0; li < a.size(); ++li) {
        for (int ri = li + 1; ri < a.size(); ++ri) {
            for (int lj = 0; lj < a[li].size(); ++lj) {
                for (int rj = lj + 1; rj < a[li].size(); ++rj) {
                    if (a[li][lj] == a[ri][lj] && a[ri][lj] == a[ri][rj] && a[ri][rj] == a[li][rj]) {
                        return false;
                    }
                }
            }
        }
    }
    return true;
}


void gen(int i, int j) {
    if (i == a.size()) {
        if (check()) {
            print();
            exit(0);
        }
        return;
    }
    for (int v = 1; v <= c; ++v) {
        a[i][j] = v;
        int ni, nj;
        if (j == a[i].size() - 1) {
            ni = i + 1;
            nj = 0;
        }
        else {
            ni = i;
            nj = j + 1;
        }
        gen(ni, nj);
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n, m;
    cin >> n >> m >> c;

    assert(n * m <= 50);

    a = vector<vector<int>>(n, vector<int>(m));

    if (c == 2) {
        gen(0, 0);
    }


    return 0;
}
