#include <bits/stdc++.h>

#define dbg(x) #x << "=" << x
#define all(a) begin(a), end(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

vector<vector<int>> a;
int c;

void print() {
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < a[i].size(); ++j) {
            cout << a[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "\n";
}

void gen(int i, int j) {
    if (i == a.size()) {
        print();
        exit(0);
    }
    for (int x = 1; x <= c; ++x) {
        a[i][j] = x;
        bool ok = true;
        for (int v = 0; v < i; ++v) {
            for (int u = 0; u < j; ++u) {
                if (a[v][u] == a[i][j] && a[v][u] == a[i][u] && a[v][u] == a[v][j]) {
                    ok = false;
                    break;
                }
            }
        }

        if (!ok)
            continue;

        int ni, nj;
        if (j == a[i].size() - 1) {
            ni = i + 1;
            nj = 0;
        }
        else {
            ni = i;
            nj = j + 1;
        }
        gen(ni, nj);
    }
}
int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n, m;
    cin >> n >> m >> c;

    a = vector<vector<int>>(n, vector<int>(m));

    if (c == 2) {
        gen(0, 0);
    }
    else {
        if (n <= 3) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << i + 1 << " ";
                }
                cout << "\n";
            }
        }
        else if (m <= 3) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << j + 1 << " ";
                }
                cout << "\n";
            }
        }
        else {
            gen(0, 0);
        }
    }


    return 0;
}
