#include <bits/stdc++.h>

#define dbg(x) #x << "=" << x
#define all(a) begin(a), end(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

vector<vector<int>> a;
int c;

void print() {
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < a[i].size(); ++j) {
            cout << a[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "\n";
}

const int down_dir = 0;
const int left_dir = 1;

void gen(int i, int j, int cnt, int dir, int start_j) {
//    cout << i << " " << j << "\n";

    if (j == a[0].size()) {
        print();
        exit(0);
    }

    vector<int> options(c);
    iota(all(options), 1);
    random_shuffle(all(options));

    for (int x : options) {
        a[i][j] = x;

        bool ok = true;

        int ncnt = cnt;

        if (c == 3 && i > 0 && a[i][j] == a[i - 1][j]) {
            if (cnt == 0) {
                ++ncnt;
            }
            else {
                ok = false;
            }
        }

        if (dir == down_dir) {
            for (int v = 0; v < i && ok; ++v) {
                for (int u = 0; u < j && ok; ++u) {
                    if (a[i][j] == a[v][u] && a[i][j] == a[i][u] && a[i][j] == a[v][j]) {
                        ok = false;
                    }
                }
            }
        }
        else {
            for (int v = 0; v < i && ok; ++v) {
                for (int u = j + 1; u <= start_j && ok; ++u) {
                    if (a[i][j] == a[v][u] && a[i][j] == a[v][j] && a[i][j] == a[i][u]) {
                        ok = false;
                    }
                }
            }
        }


        if (!ok)
            continue;

        int ni, nj, ndir, nstart_j;

        if (dir == down_dir) {
            if (i == a.size() - 1 || i == j) {
                ndir = left_dir;
                ni = i;
                nj = j - 1;
            }
            else {
                ndir = down_dir;
                ni = i + 1;
                nj = j;
            }
            nstart_j = j;
        }
        else {
            if (j == 0) {
                ndir = down_dir;
                ni = 0;
                nj = start_j + 1;
                nstart_j = start_j + 1;
            }
            else {
                ndir = left_dir;
                ni = i;
                nj = j - 1;
                nstart_j = start_j;
            }
        }

        gen(ni, nj, ncnt, ndir, nstart_j);
    }
//    cout << "-----\n";
}
int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n, m;
    cin >> n >> m >> c;

    a = vector<vector<int>>(n, vector<int>(m));

    if (c == 2) {
        gen(0, 0, 0, left_dir, 0);
    }
    else {
        if (n <= 3) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << i + 1 << " ";
                }
                cout << "\n";
            }
        }
        else if (m <= 3) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << j + 1 << " ";
                }
                cout << "\n";
            }
        }
        else {
            gen(0, 0, 0, left_dir, 0);
        }
    }


    return 0;
}
