#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
typedef long long ll;
using namespace std;

ll t, n, m, l, r, ev, sm;

bool check(ll m1, ll m2) {
    ll z1 = m1 * ev + n * (m1 - 1) * m1 / 2; ll z2 = sm - z1;
    ll z3 = m2 * ev + n * (m2 - 1) * m2 / 2; ll z4 = sm - z3;
    return abs(z3 - z4) < abs(z2 - z1);
}

bool check2(ll m1, ll m2) {
    ll z1 = m1 * ev + m * m * (m1 - 1) * m1 / 2; ll z2 = sm - z1;
    ll z3 = m2 * ev + m * m * (m2 - 1) * m2 / 2; ll z4 = sm - z3;
    return abs(z3 - z4) < abs(z2 - z1);
}

int main() {
    cin >> t;
    vector<pair<char, int>> ans;
    for (int q = 0; q < t; ++q) {
        cin >> n >> m;
        ev = n + m * (n - 1) * n / 2, sm = (n * m) * (n * m + 1) / 2;
        l = 0, r = m;
        while (r - l > 2) {
            ll m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
            if (check(m1, m2)) {
                l = m1;
            }
            else {
                r = m2;
            }
        }
        ll v1 = (l + r) / 2;
        ev = m * (m + 1) / 2;
        l = 0, r = n;
        while (r - l > 2) {
            ll m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
            if (check2(m1, m2)) {
                l = m1;
            }
            else {
                r = m2;
            }
        }
        ll v2 = (l + r) / 2;
        ll z1 = v2 * ev + m * m * (v2 - 1) * v2 / 2; ll z2 = sm - z1;
        ll mx2 = abs(z1 - z2);
        ev = n + m * (n - 1) * n / 2;
        z1 = v1 * ev + n * (v1 - 1) * v1 / 2; z2 = sm - z1;
        ll mx1 = abs(z1 - z2);
        if (mx1 <= mx2) {
            ans.push_back({ 'V', v1 + 1 });
        }
        else {
            ans.push_back({ 'H', v2 + 1 });
        }

    }
    for (auto u : ans) {
        cout << u.first << ' ' << u.second << '\n';
    }
    return 0;
    
}