#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
typedef long long ll;
using namespace std;

map<int, vector<int>> a, b, w;
int n, o;
vector<vector<int>> graph;
bool bl = false;
vector<int> p = {};
vector<bool> used;

void dfs(int v, int path) {
    if (path == n) {
        bl = true;
        return;
    }
    for (auto u : graph[v]) {
        if (!used[u]) {
            used[u] = true;
            p.push_back(u);
            dfs(u, path + 1);
            if (bl) {
                return;
            }
            p.pop_back();
            used[u] = false;
        }
    }
}

int main() {
    cin >> n;
    o = -1;
    for (int i = 0; i < n; ++i) {
        int m, s, mi;
        cin >> m >> s;
        int prev = 0;
        int ai = -1, bi = -1;
        for (int j = 0; j < m; ++j) {
            cin >> mi;
            if (j != 0) {
                if (o != -1 && mi - prev != 0) {
                    cout << "No";
                    return 0;
                }
                o = mi - prev;
            }
            if (j == 0) {
                ai = mi - prev;
                if (a.find(mi - prev) == a.end()) {
                    a.insert({ mi - prev, {i} });
                }
                else {
                    a[mi - prev].push_back(i);
                }
            }
            if (j == m - 1) {
                bi = s - mi;
                if (b.find(s - mi) == b.end()) {
                    b.insert({ s - mi, {i} });
                }
                else {
                    b[s - mi].push_back(i);
                }
            }
            prev = mi;
        }
        w.insert({ i, {ai, bi} });
    }
    if (o > -1) {
        for (int i = 0; i < n; ++i) {
            graph.push_back({});
            used.push_back(false);
            if (a.find(o - w[i][1]) == a.end()) continue;
            for (int j = 0; j < a[o - w[i][1]].size(); ++j) {
                graph[i].push_back(a[o - w[i][1]][j]);
            }
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                used[j] = false;
            }
            p.push_back(i);
            used[i] = true;
            dfs(i, 1);
            used[i] = false;
            if (bl) {
                cout << "Yes" << '\n';
                for (auto u : p) {
                    cout << u + 1 << ' ';
                }
                return 0;

            }
            p = {};
        }
        cout << "No";
    }
    else {
        for (int i = 0; i < n; ++i) {
            graph.push_back({});
            used.push_back(false);
        }
        for (int o = 0; o < 101; ++o) {
            for (int i = 0; i < n; ++i) {
                graph[i] = {};
                if (a.find(o - w[i][1]) == a.end()) continue;
                for (int j = 0; j < a[o - w[i][1]].size(); ++j) {
                    graph[i].push_back(a[o - w[i][1]][j]);
                }
            }
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    used[j] = false;
                }
                p.push_back(i);
                used[i] = true;
                dfs(i, 1);
                used[i] = false;
                if (bl) {
                    cout << "Yes" << '\n';
                    for (auto u : p) {
                        cout << u + 1 << ' ';
                    }
                    return 0;

                }
                p = {};
            }
        }
        cout << "No";
    }
    return 0;
    
}