#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
typedef long long ll;
using namespace std;

string a, b, c;
vector<vector<int>> graph;
int cnt = 0, n;
vector<bool> used;
vector<vector<int>> d;

void dfs(int v, int path) {
    used[v] = true;
    if (path == n && d[v][0] != 0 && d[v][1] != 0 && d[v][2] != 0) {
        ++cnt;
        if (cnt == 1e9 + 7) {
            cnt = 0;
        }
    }
    for (auto u : graph[v]) {
        if (!used[u]) {
            dfs(u, path + 1);
            used[u] = false;
        }
    }
}

int main() {
    cin >> a >> b >> c;
    set<int> in_t, out_t;
    n = a.size();
    for (int i = 0; i < n; ++i) {
        if ((a[i] - '0' + b[i] - '0') % 10 != c[i] - '0') {
            in_t.insert(i);
        }if ((a[i] - '0' + b[i] - '0') % 10 == c[i] - '0' && a[i] - '0' + b[i] - '0' != c[i] - '0') {
            out_t.insert(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        graph.push_back({});
        d.push_back({ a[i] - '0' , b[i] - '0' , c[i] - '0' });
        if (out_t.find(i) != out_t.end()) {
            for (auto u : in_t) {
                graph[i].push_back(u);
            }
        }
        else {
            for (int j = 0; j < n; ++j) {
                if (in_t.find(j) == in_t.end()) {
                    graph[i].push_back(j);
                }
            }
        }
        used.push_back(false);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            used[j] = false;
        }
        dfs(i, 1);
    }
    cout << cnt;
    return 0;
}