#include <bits/stdc++.h>
#define int long long
#define pb push_back

using namespace std;

typedef vector<int> vi;

void fast_io(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
}

int n, m;

int checkvert(int x){
	int ans1 = n * (n-1)/2 * m * x+ x*(x+1)/2 * n; 
	int all = n * m * (n * m + 1)/2;
	int ans2 = all - ans1;
	return abs(ans2 - ans1);
}

int checkhor(int x){
	int ans1 = n * x * (n * x + 1) / 2;
	int all_ans = n * m * (n*m + 1) / 2;
	int ans2 = all_ans - ans1;
	return abs(ans1 - ans2);

}

signed main(){
	fast_io();
	int q;
	cin >> q;
	while(q--){
		pair<int, pair<int, int> > ans = make_pair(1e18, make_pair(1e18, 1e18));
		cin >> n >> m;
		int l = 1, r = m-1;
		while(l + 3 < r){
			int m1 = l + (r-l)/3;
			int m2 = r - (r-l)/3;
			int ans1 = checkvert(m1);
			int ans2 = checkvert(m2);
			if(ans1 <= ans2){
				r = m2;
			} else{
				l = m1;
			}
		}
		for(int i = l; i <= r; i++)
			ans = min(ans, make_pair(checkvert(i), make_pair(1ll, i)));
		l = 1, r = n - 1;
		while(l + 3 < r){
			int m1 = l + (r-l)/3;
			int m2 = r - (r-l)/3;
			int ans1 = checkhor(m1);
			int ans2 = checkhor(m2);
			if(ans1 <= ans2){
				r = m2;
			} else{
				l = m1;
			}
		}
		for(int i = l; i <= r; i++)
			ans = min(ans, make_pair(checkhor(i), make_pair(2ll, i)));
		if(ans.second.first == 1){
			cout << "V " << ans.second.second + 1 << endl;
		} else{
			cout << "H " << ans.second.second + 1 << endl;
		}
	}
	return 0;
}
