#include <bits/stdc++.h>

#define endl "\n"


using namespace std;


void setup() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #else
    ios::sync_with_stdio(0);
    cin.tie(0);
    #endif
}

struct frag {
    int m, s;
    vector<int> ps;
    frag(int _m, int _s, vector<int> &_ps) : m(_m), s(_s), ps(_ps) {}
};


void solve1(int n, vector<frag> &frags) {
    vector<int> p;
    for (int i = 0; i < n; i++) p.push_back(i);
    bool f = true;
    while (next_permutation(p.begin(), p.end()) || f) {
        f = false;
        vector<frag> nw;
        for (int i = 0; i < n; i++)
            nw.push_back(frags[p[i]]);
        int dist = -1;
        int last = -1;
        int total = 0;
        bool no = false;
        for (int i = 0; i < n; i++) {
            for (int it : nw[i].ps) {
                if (dist == -1) {
                    if (last != -1) {
                        dist = total + it - last;
                    }
                }
                else {
                    if (dist != total + it - last) {
                        no = true;
                        break;
                    }
                }
                last = total + it;
            }
            total += nw[i].s;
        }
        if (!no) {
            cout << "Yes" << endl;
            for (int it : p) {
                cout << it + 1 << " ";
            }
            cout << endl;
            return;
        }
    }
    cout << "No" << endl;
}


int main()
{
    setup();
    int n;
    cin >> n;
    vector<frag> frags;
    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        vector<int> ps(m);
        for (int &it : ps) cin >> it;
        frags.push_back(frag(m, s, ps));
    }
    if (n <= 8)
        solve1(n, frags);
}
