#include <bits/stdc++.h>

#define endl "\n"


using namespace std;


void setup() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #else
    ios::sync_with_stdio(0);
    cin.tie(0);
    #endif
}

string solve0(string& x) {
    const int n = x.size();
    char m = x[0];
    for (int i = 1; i < n; i++) {
        if (x[i] < m) {
            break;
        }
        if (x[i] > m) {
            return string(n, m + 1);
        }
    }
    return string(n, m);
}

string solve1(string& x) {
    const int n = x.size();
    if (n <= 2) {
        return x;
    }
    string res = "a";
    for (int i = 0; i < n; i++) {
        char m = i == 0 ? x[1] : x[0];
        bool bad = false, no = false;
        for (int j = 0; j < n; j++) {
            if (i != j) {
                if (x[j] > m) {
                    string s = x;
                    for (int k = 0; k < n; k++) {
                        if (k != i) {
                            s[k] = m + 1;
                        }
                    }
                    res = min(res, s);
                    bad = false;
                    no = true;
                    break;
                }
                if (x[j] < m) {
                    bad = true;
                    break;
                }
            }
        }
        if (bad && !no) {
            string s = x;
            for (int k = 0; k < n; k++) {
                if (k != i) {
                    s[k] = m;
                }
            }
            res = min(res, s);
        }
        if (!bad && !no) {
            return x;
        }
    }
    return res;
}

string solve0Bad(string& x) {
    int n = stoi(x);
    while (true){
        int m = n;
        int c = n % 10;
        bool ok = true;
        while (m) {
            if (c != m % 10) {
                ok = false;
                break;
            }
            m /= 10;
        }
        if (ok) {
            break;
        }
        n++;
    }
    return to_string(n);
}

void test() {
    for (int i = 1; i <= 1e5; i++) {
        string x = to_string(i);
        if (solve0(x) != solve0Bad(x)) {
            cout << "!!! " << x<< endl;
        }
    }
}


int main()
{
    setup();
    //test();
    string x;
    cin >> x;
    int k;
    cin >> k;
    if (k == 1) {
        cout << solve1(x) << endl;
    } else {
        cout << solve0(x) << endl;
    }
}
