#include <bits/stdc++.h>

#define endl "\n"


using namespace std;


void setup() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #else
    ios::sync_with_stdio(0);
    cin.tie(0);
    #endif
}

string solve0(string& x) {
    const int n = x.size();
    char m = x[0];
    for (int i = 1; i < n; i++) {
        if (x[i] < m) {
            break;
        }
        if (x[i] > m) {
            return string(n, m + 1);
        }
    }
    return string(n, m);
}

string solve1(string& x) {
    const int n = x.size();
    if (n <= 2) {
        return x;
    }
    for (int i = 0; i < n; i++) {
        char m = i == 0 ? x[1] : x[0];

    }
}

string solve0Bad(string& x) {
    int n = stoi(x);
    while (true){
        int m = n;
        int c = n % 10;
        bool ok = true;
        while (m) {
            if (c != m % 10) {
                ok = false;
                break;
            }
            m /= 10;
        }
        if (ok) {
            break;
        }
        n++;
    }
    return to_string(n);
}

string solve1Bad(string& x) {
    int n = stoi(x);
    if (n < 100) {
        return x;
    }
    while (true) {
        int m = n;
        int k = 0;
        vector<int> co(10);
        while (m) {
            co[m % 10]++;
            m /= 10;
            k++;
        }
        bool f = true;
        for (int i = 0; i < 10; i++) {
            if (co[i] == 0) {
                continue;
            }
            if (co[i] == 1) {
                f = false;
            }
            else if (co[i] >= k - 1){
                return to_string(n);
            }
        }
        n++;
    }
    return to_string(n);
}

void test0() {
    for (int i = 1; i <= 1e5; i++) {
        string x = to_string(i);
        if (solve0(x) != solve0Bad(x)) {
            cout << "!!! " << x<< endl;
        }
    }
}

void test1() {
    for (int i = 1; i <= 1e4; i++) {
        string x = to_string(i);
        if (solve1(x) != solve1Bad(x)) {
            cout << "!!! " << x<< endl;
        }
    }
}


int main()
{
    setup();
    //test1();
    string x;
    cin >> x;
    int k;
    cin >> k;
    if (k == 1) {
        cout << solve1Bad(x) << endl;
    } else {
        cout << solve0(x) << endl;
    }
}
