#include <bits/stdc++.h>

#define endl "\n"


using namespace std;


void setup() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #else
    ios::sync_with_stdio(0);
    cin.tie(0);
    #endif
}

long long solve0(long long x) {
    int n = 0;
    long long temp = x;
    while (temp) {
        n++;
        temp /= 10;
    }
    long long ones = 0;
    for (int i = 0; i < n; i++) {
        ones = ones * 10 + 1;
    }
    long long res = ones;
    while (res < x) {
        res += ones;
    }
    return res;
}

long long solve1(long long x) {
    int n = 0;
    long long temp = x;
    vector<long long> pow10(19);
    pow10[0] = 1;
    for (int i = 1; i < 19; i++) {
        pow10[i] = pow10[i - 1] * 10;
    }
    while (temp) {
        n++;
        temp /= 10;
    }
    long long ones = 0;
    for (int i = 0; i < n; i++) {
        ones = ones * 10 + 1;
    }
    long long res = 0;
    int d = 0;
    long long mn = LLONG_MAX;
    while (res < x) {
        for (int i = n; i > 0; i--) {
            for (int j = 0; j < 10 - d; j++) {
                if (res + pow10[i] * j >= x) {
                    mn = min(mn, res + pow10[i] * j);
                }
            }
        }
        res += ones;
        d++;
    }
    mn = min(mn, res);
    return mn;
}

string solve0Bad(string& x) {
    int n = stoi(x);
    while (true){
        int m = n;
        int c = n % 10;
        bool ok = true;
        while (m) {
            if (c != m % 10) {
                ok = false;
                break;
            }
            m /= 10;
        }
        if (ok) {
            break;
        }
        n++;
    }
    return to_string(n);
}

string solve1Bad(string& x) {
    int n = stoi(x);
    if (n < 100) {
        return x;
    }
    while (true) {
        int m = n;
        int k = 0;
        vector<int> co(10);
        while (m) {
            co[m % 10]++;
            m /= 10;
            k++;
        }
        bool f = true;
        for (int i = 0; i < 10; i++) {
            if (co[i] == 0) {
                continue;
            }
            if (co[i] == 1) {
                f = false;
            }
            else if (co[i] >= k - 1){
                return to_string(n);
            }
        }
        n++;
    }
    return to_string(n);
}

void test0() {
    for (int x = 1; x <= 1e5; x++) {
        //if (solve0(x) != solve0Bad(x)) {
            cout << "!!! " << x<< endl;
        //}
    }
}

void test1() {
    for (int x = 1; x <= 1e4; x++) {
        //if (solve1(x) != solve1Bad(x)) {
            cout << "!!! " << x<< endl;
        //}
    }
}


int main()
{
    setup();
    //test1();
    long long x;
    cin >> x;
    int k;
    cin >> k;
    if (k == 1) {
        cout << solve1(x) << endl;
    } else {
        cout << solve0(x) << endl;
    }
}
