#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline bool chkmin(T1 &a, const T2 &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &a, const T2 &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
#define files(FILENAME) read(FILENAME); write(FILENAME)
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define left left228
#define right right228
#define y1 y1228
#define mp make_pair
#define pb push_back
#define y2 y2228
using ll = long long;
using ld = long double;
const string FILENAME = "input";



ll n, m;


ll getv(ll mid) {
	ll fl = n * mid * (mid - 1) / 2;
	fl += m * n * (n - 1) * (mid - 1) / 2;
	return fl - (n * m * (n * m + 1) / 2 - fl);
}


ll geth(ll mid) {
	ll fl = m * (m + 1) / 2 * (mid - 1);
	fl += m * (mid - 2) * (mid - 1) / 2 * n;
	return fl - (n * m * (n * m + 1) / 2 - fl);
}


void solve() {
	cin >> n >> m;
	ll opt = 1e18;
	ll ans = -1;
	int t = 1;
	if (m > 1) {
		ll l = 2;
		ll r = m;
		while (l + 500 < r) {
			ll mid = (l + r) >> 1;
			ll val = getv(mid);
			if (val >= 0) {
				r = mid;
			} else {
				l = mid;
			}
		}
		for (ll pos = max(l - 2, 2LL); pos <= min(r + 2, m); pos++) {
			ll d = getv(pos);
			if (abs(d) < opt) {
				opt = abs(d);
				ans = pos;
				t = 1;
			}
		}
	}
	if (n > 1) {
		ll l = 2;
		ll r = n;
		while (l + 500 < r) {
			ll mid = (l + r) >> 1;
			ll val = geth(mid);
			if (val >= 0) {
				r = mid;
			} else {
				l = mid;
			}
		}
		for (ll pos = max(l - 2, 2LL); pos <= min(r + 2, n); pos++) {
			ll d = geth(pos);
			if (abs(d) < opt) {
				opt = abs(d);
				ans = pos;
				t = 2;
			}
		}
	}
	//cout << opt << endl;
	if (t == 1) {
		cout << "V" << ' ';
	} else {
		cout << "H" << ' ';
	}
	cout << ans << '\n';
}


int  main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//read(FILENAME);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}	
	return 0;
}