#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll summ_rows(ll r, ll m)
{
    ll mx = r * m;
    return mx * (mx + 1) / 2;
}

ll summ_cols(ll n, ll m, ll c)
{
    ll row_summ = c * (c + 1) / 2;
    ll kek = m * c * n * (n - 1) / 2;
    return kek + row_summ * n;
}

struct Split{
    long long sp;
    char dir;
    int x;
};

void solve()
{
    long long n, m;
    cin >> n >> m;
    long long tot = summ_rows(n, m);
    vector<Split> ans;
    {
        ll L = 1, R = m + 1;
        while (L + 1 < R)
        {
            int M = (L + R) / 2;
            long long si_before = summ_cols(n, m, M - 1);
            if (si_before * 2 <= tot)
                L = M;
            else
                R = M;
        }
        for (int i = max(L - 1, 1ll); i <= min(m, L + 1); i++)
        {
            ans.push_back({summ_cols(n, m, i - 1), 'V', i});
        }
    }
    {
        ll L = 1, R = n + 1;
        while (L + 1 < R)
        {
            int M = (L + R) / 2;
            ll si_before = summ_rows(M - 1, m);
            if (si_before * 2 <= tot)
                L = M;
            else
                R = M;
        }
        for (int i = max(L - 1, 1ll); i <= min(n, L + 1); i++)
        {
            ans.push_back({summ_rows(i - 1, m), 'H', i});
        }
    }
    sort(ans.begin(), ans.end(), [&](Split a, Split b){
         if (abs(tot - 2 * a.sp) != abs(tot - 2 * b.sp))
            return abs(tot - 2 * a.sp) < abs(tot - 2 * b.sp);
         if (a.dir != b.dir)
            return a.dir > b.dir;
         return a.x < b.x;
         });
    cout << ans[0].dir << " " << ans[0].x << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}
