#include <bits/stdc++.h>

using namespace std;

int digits(int x)
{
    if (x == 1) return 0;
    int cnt = 0;
    while (x > 0)
    {
        x /= 10;
        cnt++;
    }
    return cnt;
}

int isdigit(char c)
{
    return '0' <= c && c <= '9';
}

struct Ans{
    int delta;
    int op;
    int x;
    char Z;
};

Ans minima, maxima;

int main()
{
    string s;
    cin >> s;
    vector<pair<int, char> > a;
    int i = 0;
    while (i < s.size())
    {
        int x = 0;
        while (isdigit(s[i]))
        {
            x = 10 * x + s[i] - '0';
            i++;
        }
        x = max(x, 1);
        a.push_back({x, s[i]});
        i++;
    }
    int k = a.size();
    for (auto e : a)
    {
        ;//cout << e.first << " " << e.second << "\n";
    }
    int skip = 0;
    for (int i = 0; i < k; i++)
    {
        if (a[i].first > 1)
        {
            int delta = digits(a[i].first - 1) - digits(a[i].first);
            if (delta < minima.delta)
            {
                minima.delta = delta;
                minima.op = 2;
                minima.x = skip + 1;
            }
        }
        else
        {
            int delta = -1;
            if (i > 0 && i + 1 < k && a[i - 1].second == a[i + 1].second)
            {
                delta -= digits(a[i - 1].first);
                delta -= digits(a[i + 1].first);
                delta -= 1;
                delta += digits(a[i - 1].first + a[i + 1].first);
            }
            if (delta < minima.delta)
            {
                minima.delta = delta;
                minima.op = 2;
                minima.x = skip + 1;
            }
        }
        skip += a[i].first;
    }
    maxima.delta = 1;
    maxima.op = 1;
    maxima.x = 1;
    maxima.Z = 'A';
    if (a[0].second == 'A') maxima.Z = 'C';

    skip = 0;
    for (int i = 0; i < k; i++)
    {
        int len = a[i].first;
        if (len > 1)
        {
            for (int cut = 1; cut < a[i].first; cut *= 10)
            {
                int newL = 3 + digits(cut) + digits(a[i].first - cut);
                int oldL = 1 + digits(a[i].first);
                if (newL - oldL > maxima.delta)
                {
                    maxima.delta = newL - oldL;
                    maxima.x = skip + cut + 1;
                    maxima.Z = 'A';
                    if (a[i].second == 'A') maxima.Z = 'C';
                }
            }
        }
        skip += a[i].first;
    }

    if (minima.op != 2) cout << minima.op << " " << minima.x << " " << minima.Z << "\n";
    else cout << minima.op << " " << minima.x << "\n";
    cout << maxima.op << " " << maxima.x << " " << maxima.Z << "\n";
}

/*
5AC5A2C
*/
