#include <bits/stdc++.h>

#define ft first
#define sd second
#define pb push_back
#define all(s) s.begin(), s.end()
#define all2(s) s.begin(), s.begin() + n

using namespace std;

const int MAXN = 1e5 + 10;

array<int, MAXN> begs;
array<int, MAXN> finishes;
array<int, MAXN> sbegs;
array<int, MAXN> sfinishes;
map<int, int> cntbegs;
map<int, int> cntfinishes;
map<int, vector<int>> posbegs;
map<int, vector<int>> posfinishes;

bool solve(int dist, int start, int end, int n) {
    if (start != -1) {
        int now = start;
        vector<int> ans;
        while (cntbegs[dist - finishes[now]] > 0) {
            //cout << now << endl;
            ans.pb(now);
            now = posbegs[dist - finishes[now]][--cntbegs[dist - finishes[now]]];
        }
        ans.pb(now);
        if (ans.size() != n) {
            return false;
        }
        if (end != -1 && ans.back() != -1) {
            return false;
        }
        cout << "Yes\n";
        for (auto elem : ans) {
            cout << elem + 1 << ' ';
        }
        return true;
    }
    if (end != -1) {
        int now = end;
        vector<int> ans;
        while (cntfinishes[dist - begs[now]] > 0) {
            ans.pb(now);
            now = posfinishes[dist - begs[now]][--cntfinishes[dist - begs[now]]];
        }
        ans.pb(now);
        if (ans.size() != n) {
            return false;
        }
        reverse(all(ans));
        cout << "Yes\n";
        for (auto elem : ans) {
            cout << elem + 1 << ' ';
        }
        return true;
    }
    int dif = 0;
    for (auto elem : cntbegs) {
        dif += abs(cntfinishes[dist - elem.ft] - elem.sd);
    }
    if (dif > 2) return false;
    if (dif != 0) {
        for (auto elem : cntbegs) {
             if(cntfinishes[dist - elem.ft] - elem.sd == 1){ start = posbegs[elem.ft][0];break;}
             else if (cntfinishes[dist - elem.ft] - elem.sd == -1) {end = posfinishes[dist - elem.ft][0];break;}
        }
        cout << start << ' ' << end << endl;
        if (start == -1 && end == -1) return false;
    } else {
        start = 0;
    }
    return solve(dist, start, end, n);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int dist = -1;
    for (int i = 0; i < n; ++i) {
        int m, s;
        cin >> m >> s;
        int prev = -1;
        for (int j = 0; j < m; ++j) {
            int p;
            cin >> p;
            if (prev == -1) {
                begs[i] = p;
                sbegs[i] = p;
            } else {
                if (dist == -1) {
                    dist = p - prev;
                } else if (dist != p - prev) {
                    cout << "No";
                    return 0;
                }
            }
            prev = p;
        }
        finishes[i] = s - prev;
        sfinishes[i] = s - prev;
    }
    for (int i = 0; i < n; ++i) {
        cntbegs[begs[i]]++;
        posbegs[begs[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cntfinishes[finishes[i]]++;
        posfinishes[finishes[i]].push_back(i);
    }
    //cout << dist << endl;
    if (dist != -1) {
        if (!solve(dist, -1, -1, n)) {
            cout << "No";
        }
        return 0;
    }
    //sort()
    //if (solve(, -1, -1, n))
    return 0;
}
