#include <bits/stdc++.h>

#define ft first
#define sd second
#define pb push_back
#define all(s) s.begin(), s.end()
#define all2(s) s.begin(), s.begin() + n
#define int long long

using namespace std;

const int MAXN = 2e5 + 10;
const int MOD = 1e9 + 7;

array<int, MAXN> a, b, c, fact;

int fastpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int x = fastpow(a, n / 2);
        return x * x % MOD;
    } else {
        return fastpow(a, n - 1) * a % MOD;
    }
}

int fc(int n, int k) {
    return fact[n] * fastpow(fact[k], MOD - 2) % MOD * fastpow(fact[n - k], MOD - 2) % MOD;
}

signed main() {
    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        fact[i] = fact[i - 1] * i;
    }
    string sa, sb, sc;
    cin >> sa >> sb >> sc;
    int n = sa.size();
    for (int i = 0; i < n; ++i) {
        a[i] = sa[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        b[i] = sb[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        c[i] = sc[i] - '0';
    }
    int t1 = 0, t2 = 0, t3 = 0, t4 = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] == c[i]) {
            t1++;
            continue;
        }
        if (a[i] + b[i] == c[i] + 10) {
            t3++;
            continue;
        }
        if (a[i] + b[i] + 1 == c[i]) {
            t2++;
            continue;
        }
        t4++;
    }
    //cout << t1 << ' ' << t2  << ' ' << t3 << ' ' << t4 << endl;
    if (t2 != t3 + 1 && t2 != t3) {
        cout << 0;
        return 0;
    }
    int ans1 = fc(t3 + t1, t1);
    int ans2 = fc(max(t2 - 1 + t4, 0LL), t4);
    //cout << ans1 << ' ' << ans2 << endl;
    cout << ans1 * ans2 % MOD * fact[t1]% MOD * fact[t2] % MOD * fact[t3] % MOD * fact[t4] % MOD;
    return 0;
}

