#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

int main() {
    int n, m, c;
    cin >> n >> m >> c;
    vector<vector<int>> v(n, vector<int> (m, 1));
    vector<vector<int>> used(n, vector<int> (m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            v[i][j] = abs(rand()) % c + 1;
        }
    }
    for (int kk = 0; kk < 10000; kk++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                for (int i2 = i + 1; i2 < n; i2++) {
                    for (int j2 = j + 1; j2 < m; j2++) {
                        if (v[i][j] == v[i2][j2] && v[i2][j] == v[i][j2] && v[i2][j] == v[i][j]) {
                            int min_used = min(used[i][j], min(used[i2][j2], min(used[i2][j], used[i][j2])));
                            if (used[i][j] == min_used) {
                                v[i][j] = (v[i][j] + min_used) % c + 1;
                                used[i][j]++;
                            } else if (used[i2][j2] == min_used) {
                                v[i2][j2] = (v[i2][j2] + min_used) % c + 1;
                                used[i2][j2]++;
                            } else if (used[i2][j] == min_used) {
                                v[i2][j] = (v[i2][j] + min_used) % c + 1;
                                used[i2][j]++;
                            } else if (used[i][j2] == min_used) {
                                v[i][j2] = (v[i][j2] + min_used) % c + 1;
                                used[i][j2]++;
                            }
                        }
                    }
                }
            }
        }
    }
    for (int kk = 0; kk < 10000; kk++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                for (int i2 = i + 1; i2 < n; i2++) {
                    for (int j2 = j + 1; j2 < m; j2++) {
                        if (v[i][j] == v[i2][j2] && v[i2][j] == v[i][j2] && v[i2][j] == v[i][j]) {
                            int max_used = max(used[i][j], max(used[i2][j2], max(used[i2][j], used[i][j2])));
                            if (used[i][j] == max_used) {
                                v[i][j] = (v[i][j] + max_used) % c + 1;
                                used[i][j]++;
                            } else if (used[i2][j2] == max_used) {
                                v[i2][j2] = (v[i2][j2] + max_used) % c + 1;
                                used[i2][j2]++;
                            } else if (used[i2][j] == max_used) {
                                v[i2][j] = (v[i2][j] + max_used) % c + 1;
                                used[i2][j]++;
                            } else if (used[i][j2] == max_used) {
                                v[i][j2] = (v[i][j2] + max_used) % c + 1;
                                used[i][j2]++;
                            }
                        }
                    }
                }
            }
        }
    }
    for (int kk = 0; kk < 10000; kk++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                for (int i2 = i + 1; i2 < n; i2++) {
                    for (int j2 = j + 1; j2 < m; j2++) {
                        if (v[i][j] == v[i2][j2] && v[i2][j] == v[i][j2] && v[i2][j] == v[i][j]) {
                            int min_used = min(used[i][j], min(used[i2][j2], min(used[i2][j], used[i][j2])));
                            if (used[i][j] != min_used) {
                                v[i][j] = (v[i][j] + min_used) % c + 1;
                                used[i][j]++;
                            } else if (used[i2][j2] != min_used) {
                                v[i2][j2] = (v[i2][j2] + min_used) % c + 1;
                                used[i2][j2]++;
                            } else if (used[i2][j] != min_used) {
                                v[i2][j] = (v[i2][j] + min_used) % c + 1;
                                used[i2][j]++;
                            } else {
                                v[i][j2] = (v[i][j2] + min_used) % c + 1;
                                used[i][j2]++;
                            }
                        }
                    }
                }
            }
        }
    }
    for (int kk = 0; kk < 10000; kk++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                for (int i2 = i + 1; i2 < n; i2++) {
                    for (int j2 = j + 1; j2 < m; j2++) {
                        if (v[i][j] == v[i2][j2] && v[i2][j] == v[i][j2] && v[i2][j] == v[i][j]) {
                            int max_used = max(used[i][j], max(used[i2][j2], max(used[i2][j], used[i][j2])));
                            if (used[i][j] != max_used) {
                                v[i][j] = (v[i][j] + max_used) % c + 1;
                                used[i][j]++;
                            } else if (used[i2][j2] != max_used) {
                                v[i2][j2] = (v[i2][j2] + max_used) % c + 1;
                                used[i2][j2]++;
                            } else if (used[i2][j] != max_used) {
                                v[i2][j] = (v[i2][j] + max_used) % c + 1;
                                used[i2][j]++;
                            } else {
                                v[i][j2] = (v[i][j2] + max_used) % c + 1;
                                used[i][j2]++;
                            }
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << v[i][j] << " ";
        }
        cout << endl;
    }
}
