#include <iostream>
#include <vector>
#include <string>

using namespace std;

int numd(int n) {
    return to_string(n).size();
}

bool is_pow(int n) {
    int x = 10;
    while (x < n) {
        x *= 10;
    }
    return x == n;
}

int near_pow(int n) {
    int x = 10;
    while (x < n) {
        x *= 10;
    }
    if (x == n) {
        x /= 10;
    }
    return x;
}

string backconv(string s) {
    string s1 = "";
    char prev = 'h';
    int n = 0;
    for (auto el : s) {
        if (el == prev) {
            n += 1;
        } else {
            if (n > 1) {
                s1 += to_string(n);
            }
            if (n > 0) {
                s1 += prev;
            }
            n = 1;
            prev = el;
        }
    }
    if (n > 1) {
        s1 += to_string(n);
    }
    s1 += prev;
    return s1;
}

signed main() {
    string s;
    cin >> s;
    vector<pair<int, char>> a;
    int l = s.size();
    int n = 0;
    for (int i = 0; i < l; ++i) {
        if ('0' <= s[i] and s[i] <= '9') {
            n *= 10;
            n += s[i] - 48;
        } else {
            if (n == 0) {
                a.push_back({1, s[i]});
            } else {
                a.push_back({n, s[i]});
            }
            n = 0;
        }
    }
    int l1 = a.size();
    int minn = 0, ind = 1;
    int sm = 0;
    for (int i = 0; i < l1; ++i) {
        if (a[i].first <= 2) {
            minn = -1;
            ind = sm + 1;
            break;
        } else if (is_pow(a[i].first)) {
            minn = -1;
            ind = sm + 1;
            break;
        }
        sm += a[i].first;
    }
    sm = a[0].first;
    for (int i = 1; i < l1 - 1; ++i) {
        if (a[i].first == 1 and a[i - 1].second == a[i + 1].second) {
            int now = numd(a[i - 1].first) + numd(a[i + 1].first) + 3;
            int neww = numd(a[i - 1].first + a[i + 1].first) + 1;
            if (neww - now < minn) {
                minn = neww - now;
                ind = sm + 1;
            }
        }
        sm += a[i].first;
    }
    cout << 2 << " " << ind << endl;
    if (n <= 100) {
        string s1 = "";
        for (auto el : a) {
            for (int i = 0; i < el.first; ++i) {
                s1 += el.second;
            }
        }
        int ln = s1.size();
        int maxx = 0;
        ind = -1;
        char c1;
        for (int i = 0; i <= ln; ++i) {
            char c;
            if ((i == 0 or s[i - 1] == 'A') or (i == ln or s[i + 1] == 'A')) {
                c = 'C';
                if ((i == 0 or s[i - 1] == 'C') or (i == ln or s[i + 1] == 'C')) {
                    c = 'G';
                }
            } else {
                c = 'A';
            }
            string tr = s1.substr(0, i) + c;
            if (i < ln) {
                tr += s1.substr(i, ln - i);
            }
            string trc = backconv(tr);
            if (trc.size() > maxx) {
                maxx = trc.size();
                ind = i;
                c1 = c;
            }
        }
        cout << 1 << " " << ind << " " << c1 << endl;
    } else {
        int maxx = 0;
        char c = 'h';
        ind = l;
        if (s[l - 1] == 'A') {
            maxx = 1;
            c = 'C';
        } else {
            maxx = 1;
            c = 'A';
        }
        sm = 0;
        for (int i = 0; i < l1; ++i) {
            if (a[i].first > 1) {
                if (a[i].first < 10) {
                    if (maxx < 3) {
                        maxx = 3;
                        ind = sm + 2;
                        if (a[i].second == 'A') {
                            c = 'C';
                        } else {
                            c = 'A';
                        }
                    }
                } else {
                    int now = numd(a[i].first) + 1;
                    int mx = 0, n1;
                    for (int j = 2; j < a[i].first - 1; ++j) {
                        int tr = numd(j) + numd(a[i].first - j);
                        if (tr > mx) {
                            mx = tr;
                            n1 = numd(j);
                        }
                    }
                    int tr = mx + 3 - now;
                    if (tr > maxx) {
                        maxx = tr;
                        ind = sm + n1 + 1;
                        if (a[i].second == 'A') {
                            c = 'C';
                        } else {
                            c = 'A';
                        }
                    }
                }
            }
            sm += a[i].first;
        }
        cout << 1 << " " << ind << " " << c << endl;
    }
}