#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<vector<long long>> g;
vector<bool> used;
vector<long long> chld;
long long n;

bool dfs(long long v) {
    bool good = true;
    for (long long i = 0; i < n; ++i) {
        if (i != v and chld[i] == -1) {
            good = false;
        }
    }
    if (good) {
        return true;
    }
    used[v] = true;
    for (auto u : g[v]) {
        if (not used[u]) {
            vector<long long> chldc = chld;
            vector<bool> usedc = used;
            chld[v] = u;
            bool tr = dfs(u);
            if (tr) {
                return true;
            }
            used = usedc;
            chld = chldc;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<pair<long long, long long>> a;
    vector<long long> lens(n);
    for (long long i = 0; i < n; ++i) {
        a.push_back({});
    }
    long long d = -1;
    for (long long i = 0; i < n; ++i) {
        long long m, s; cin >> m >> s;
        lens[i] = s;
        vector<long long> tr(m);
        for (long long j = 0; j < m; ++j) {
            cin >> tr[j];
        }
        for (long long j = 0; j < m - 1; ++j) {
            long long d1 = tr[j + 1] - tr[j];
            if (d == -1) {
                d = d1;
            } else if (d != d1) {
                cout << "No" << endl;
                return 0;
            }
        }
        a[i].first = tr[0];
        a[i].second = s - tr[m - 1];
    }
    if (n == 1) {
        cout << "Yes" << endl;
        cout << 1 << endl;
        return 0;
    }
    /*cout << d << endl;
    for (auto el : a) {
        cout << el.first << " " << el.second << endl;
    }*/
    if (n > 8) {
        return 0;
    }
    if (d > -1) {
        g.resize(n, {});
        chld.resize(n, -1);
        used.resize(n, false);
        for (long long i = 0; i < n; ++i) {
            for (long long j = i + 1; j < n; ++j) {
                if (a[i].second + a[j].first == d) {
                    g[i].push_back(j);
                }
                if (a[j].second + a[i].first == d) {
                    g[j].push_back(i);
                }
            }
        }
        for (long long i = 0; i < n; ++i) {
            chld.assign(n, -1);
            used.assign(n, false);
            if (dfs(i)) {
                cout << "Yes" << endl;
                vector<long long> ans;
                long long cur = i;
                while (cur != -1) {
                    ans.push_back(cur + 1);
                    cur = chld[cur];
                }
                for (auto el : ans) {
                    cout << el << " ";
                }
                cout << endl;
                return 0;
            }
        }
        cout << "No" << endl;
    } else {
        g.resize(n, {});
        chld.resize(n, -1);
        used.resize(n, false);
        set<long long> st;
        long long d;
        for (long long i = 0; i < n; ++i) {
            for (long long j = 0; j < n; ++j) {
                if (i != j) {
                    d = a[i].second + a[j].first;
                    if (st.find(d) == st.end()) {
                        st.insert(d);
                        g.assign(n, {});
                        chld.assign(n, -1);
                        used.assign(n, false);
                        for (long long k = 0; k < n; ++k) {
                            for (long long l = 0; l < n; ++l) {
                                if (k != l) {
                                    if (a[k].second + a[l].first == d) {
                                        g[k].push_back(l);
                                    }
                                }
                            }
                        }
                        /*cout << "----------" << endl;
                        cout << d << endl;
                        for (auto el : g) {
                            cout << "g ";
                            for (auto el1 : el) {
                                cout << el1 + 1 << " ";
                            }
                            cout << endl;
                        }*/
                        for (long long i = 0; i < n; ++i) {
                            chld.assign(n, -1);
                            used.assign(n, false);
                            if (dfs(i)) {
                                cout << "Yes" << endl;
                                vector<long long> ans;
                                long long cur = i;
                                while (cur != -1) {
                                    ans.push_back(cur + 1);
                                    cur = chld[cur];
                                }
                                for (auto el : ans) {
                                    cout << el << " ";
                                }
                                cout << endl;
                                return 0;
                            }
                        }
                    }
                }
            }
        }
        cout << "No" << endl;
    }
}