//#include <pch.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
#include <limits.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)x.size()

bool is_10_pow(int x) {
	if (x < 10) return false;
	for (int i = 10; i <= x; i *= 10) {
		if (x == i) return true;
	}
	return false;
}

int dif(int x, int y) {
	if (x == 1 && y == 1) {
		return 0;
	}
	if (x == 1) {
		int len1 = 2;
		int y1 = y;
		while (y1) {
			++len1;
			y1 /= 10;
		}
		int len2 = 1;
		y1 = y + 1;
		while (y1) {
			++len2;
			y1 /= 10;
		}
		return len1 - len2;
	}
	if (y == 1) {
		int len1 = 2;
		int x1 = x;
		while (x1) {
			++len1;
			x1 /= 10;
		}
		int len2 = 1;
		x1 = x + 1;
		while (x1) {
			++len2;
			x1 /= 10;
		}
		return len1 - len2;
	}
	int len1 = 2;
	int x1 = x, y1 = y;
	while (x1) {
		++len1;
		x1 /= 10;
	}
	while (y1) {
		++len1;
		y1 /= 10;
	}
	int len2 = 1;
	x1 = x + y;
	while (x1) {
		++len2;
		x1 /= 10;
	}
	return len1 - len2;
}

int dif_insert(int x, int y) {
	if (y == 1) {
		if (x == 2 || is_10_pow(x))
			return 0;
		else
			return 1;
	}
	int len1 = 1, x1 = x;
	while (x1) {
		++len1;
		x1 /= 10;
	}
	int x2 = y, y2 = x - y;
	int len2 = 2;
	while (x2) {
		++len2;
		x2 /= 10;
	}
	while (y2) {
		++len2;
		y2 /= 10;
	}
	return len2 - len1;
}

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	string s;
	cin >> s;

	int len = sz(s);
	vector<pair<int, char>> a;

	int cnt = 0;
	for (int i = 0; i < sz(s); ++i) {
		if (!('0' <= s[i] && s[i] <= '9')) {
			if (cnt == 0) {
				a.push_back({ 1, s[i] });
			}
			else {
				a.push_back({ cnt, s[i] });
				cnt = 0;
			}
		}
		else {
			cnt = cnt * 10 + (int)(s[i] - '0');
		}
	}

	pair<int, int> ans_min = { 1, 1 };
	pair<int, char> ans_max = { 0, 'A' };

	//minimum
	{
		int l_min = len;
		//erase
		{
			int pos = 0;
			for (int i = 0; i < sz(a); ++i) {
				if (a[i].first == 2 || is_10_pow(a[i].first)) {
					if (len - 1 < l_min) {
						l_min = len - 1;
						ans_min = { 2, pos + 1 };
					}
				}
				else if (a[i].first != 1) {
					
				}
				else {
					if (i == 0 || i == sz(a) - 1 || a[i - 1].second != a[i + 1].second) {
						if (len - 1 < l_min) {
							l_min = len - 1;
							ans_min = { 2, pos + 1 };
						}
					}
					else {
						int cur_len = len - 1 - dif(a[i - 1].first, a[i + 1].first);
						if (cur_len < l_min) {
							l_min = cur_len;
							ans_min = { 2, pos + 1 };
						}
					}
				}
				pos += a[i].first;
			}
		}
	}

	cout << ans_min.first << " " << ans_min.second << "\n";

	//maximum
	{
		int l_max = len;
		// insert in front
		{
			l_max = len + 1;
			if (a[0].second == 'A') {
				ans_max.second = 'G';
			}
		}
		// insert inside
		{
			int pos = 0;
			for (int i = 0; i < sz(a); ++i) {
				if (a[i].first > 1) {
					for (int j = 1; j <= a[i].first / 2; ++j) {
						int cur_len = len + 1 + dif_insert(a[i].first, j);
						//cout << i << " " << j << " " << cur_len << "\n";
						if (cur_len > l_max) {
							l_max = cur_len;
							ans_max.second = (a[i].second == 'A' ? 'G' : 'A');
							ans_max.first = pos + j;
						}
					}
				}
				pos += a[i].first;
			}
		}
	}

	cout << 1 << " " << ans_max.first << " " << ans_max.second;

	return 0;
}
