#include <pch.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
#include <limits.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)x.size()

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	vector<pair<int, vector<int>>> a(n);

	for (int i = 0; i < n; ++i) {
		int m, l;
		cin >> m >> l;
		a[i].first = l;
		for (int j = 0; j < m; ++j) {
			int s;
			cin >> s;
			a[i].second.push_back(s);
		}
	}

	vector<int> p(n);

	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}

	do {
		vector<pair<int, vector<int>>> b(n);
		for (int i = 0; i < n; ++i) {
			b[i] = a[p[i]];
		}
		vector<int> pos;
		int prev_len = 0;
		for (int i = 0; i < n; ++i) {
			for (int d : b[i].second) {
				pos.push_back(prev_len + d);
			}
			prev_len += b[i].first;
		}
		bool ok = 1;
		for (int i = 2; i < sz(pos); ++i) {
			if (pos[i] - pos[i - 1] != pos[i - 1] - pos[i - 2]) {
				ok = 0;
			}
		}
		if (ok) {
			cout << "Yes\n";
			for (int i = 0; i < n; ++i) {
				cout << p[i] + 1 << " ";
			}
			return 0;
		}
	} while (next_permutation(all(p)));

	cout << "No";

	return 0;
}
