//#include <pch.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
#include <limits.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <iomanip>
#include <deque>

typedef long long ll;
typedef long double ld;

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)x.size()

int n;
vector<pair<int, vector<int>>> a;

void stupid() {
	vector<int> p(n);

	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}

	do {
		vector<pair<int, vector<int>>> b(n);
		for (int i = 0; i < n; ++i) {
			b[i] = a[p[i]];
		}
		vector<int> pos;
		int prev_len = 0;
		for (int i = 0; i < n; ++i) {
			for (int d : b[i].second) {
				pos.push_back(prev_len + d);
			}
			prev_len += b[i].first;
		}
		bool ok = 1;
		for (int i = 2; i < sz(pos); ++i) {
			if (pos[i] - pos[i - 1] != pos[i - 1] - pos[i - 2]) {
				ok = 0;
			}
		}
		if (ok) {
			cout << "Yes\n";
			for (int i = 0; i < n; ++i) {
				cout << p[i] + 1 << " ";
			}
			return;
		}
	} while (next_permutation(all(p)));

	cout << "No";
}

void group4() {
	int needed_s = -1;
	for (int i = 0; i < n; ++i) {
		if (sz(a[i].second) > 1) {
			needed_s = a[i].second[1] - a[i].second[0];
			break;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (sz(a[i].second) > 1) {
			for (int j = 1; j < sz(a[i].second); ++j) {
				if (a[i].second[j] - a[i].second[j - 1] != needed_s) {
					cout << "No";
					return;
				}
			}
		}
	}
	vector<bool> used(n, 0);
	used[0] = 1;
	deque<int> q;
	q.push_back(0);
	int left = a[0].second[0], right = a[0].first - a[0].second.back();
	map<int, vector<int>> cl, cr;
	for (int i = 1; i < n; ++i) {
		cl[a[i].second[0]].push_back(i);
		cr[(a[i].first - a[i].second.back())].push_back(i);
	}
	int cnt = 1;
	while (cnt < n) {
		vector<int>& s = cr[needed_s - left];
		vector<int>& ss = cl[needed_s - right];
		if (ss.empty() && s.empty()) {
			cout << "No";
			return;
		}
		while (sz(s) > 1 && used[s.back()])
				s.pop_back();
		if (!s.empty()) {
			q.push_front(s.back());
			used[s.back()] = 1;
			left = a[s.back()].second[0];
			s.pop_back();
			++cnt;
			continue;
		}
		while (sz(ss) > 1 && used[ss.back()])
			ss.pop_back();
		if (!ss.empty()) {
			q.push_back(s.back());
			used[s.back()] = 1;
			right = needed_s - a[s.back()].second[0];
			s.pop_back();
			++cnt;
		}
	}
	cout << "Yes\n";
	while (!q.empty()) {
		cout << q.front() + 1 << " ";
		q.pop_front();
	}
}

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n;
	a.resize(n);

	for (int i = 0; i < n; ++i) {
		int m, l;
		cin >> m >> l;
		a[i].first = l;
		for (int j = 0; j < m; ++j) {
			int s;
			cin >> s;
			a[i].second.push_back(s);
		}
	}

	if (n <= 8) {
		stupid();
	}
	else {
		group4();
	}

	return 0;
}
