//#include "pch.h"
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <bitset>

typedef long long ll;
typedef long double ld;

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)x.size()

int n, m, c;
vector<int> a(10);
bool printed = 0;

void print() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << a[i] % 2 << " ";
			a[i] >>= 1;
		}
		cout << "\n";
	}
}

bool check(int x, int y) {
	int z = (x & y);
	bitset<10> zz = z;
	if (zz.count() > 1)
		return false;
	z = (x | y);
	zz = z;
	if (zz.count() < m - 1)
		return false;
	return true;
}

void gen(int i) {
	if (printed) {
		return;
	}
	if (i == n) {
		print();
		printed = 1;
		return;
	}
	for (int mask = 0; mask < (1 << m); ++mask) {
		bool ok = 1;
		for (int j = 0; j < i; ++j) {
			if (!check(a[j], mask)) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			a[i] = mask;
			gen(i + 1);
			a[i] = 0;
		}
	}
}

void masks() {
	gen(0);
}

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> m >> c;

	if (c == 2) {
		masks();
	}

	return 0;
}
