#include <bits/stdc++.h>

using namespace std;

int n;
int expdist = -1;
vector< pair<int, int> > a;
int xx[200000];

void gogogo() {
	for(int i = 0; i < n; i++) {
		xx[i * 2] = a[i].first;
		xx[i * 2 + 1] = expdist - a[i].second;
	}
	sort(xx, xx + 2 * n);
	auto xxend = unique(xx, xx + 2 * n);
	vector< vector< pair<int, int> > > adj(xxend - xx);
	vector<int> adjinsz(xxend - xx);
	for(int i = 0; i < n; i++) {
		int u = lower_bound(xx, xxend, a[i].first) - xx;
		int v = lower_bound(xx, xxend, expdist - a[i].second) - xx;
		adj[u].emplace_back(v, i);
		adjinsz[v]++;
	}
	int from = -1;
	int to = -1;
	for(int i = 0; i < adj.size(); i++) {
		if(adj[i].size() > adjinsz[i]) {
			// More outputs than inputs
			if(adj[i].size() - adjinsz[i] >= 2) {
				return;
			}
			if(from != -1) {
				return;
			}
			from = i;
		}
		if(adj[i].size() < adjinsz[i]) {
			// More inputs than outputs
			if(adjinsz[i] - adj[i].size() >= 2) {
				return;
			}
			if(to != -1) {
				return;
			}
			to = i;
		}
	}

	list<int> order;
	vector<decltype(order.cend())> posof(n);

	int u = from == -1 ? 0 : from;
	auto it = order.cend();
	while(adj[u].size() > 0) {
		auto [v, j] = adj[u].back();
		adj[u].pop_back();
		it = posof[j] = order.insert(it, j);
		++it;
		u = v;
	}

	for(int i: order) {
		int u = lower_bound(xx, xxend, expdist - a[i].second) - xx;
		auto it = posof[i];
		++it;
		while(adj[u].size() > 0) {
			auto [v, j] = adj[u].back();
			adj[u].pop_back();
			it = posof[j] = order.insert(it, j);
			++it;
			u = v;
		}
	}

	if(order.size() < n) {
		return;
	}

	cout << "Yes" << endl;
	for(int i: order) {
		cout << i + 1 << " ";
	}
	cout << endl;
	exit(0);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;

	a.resize(n);
	for(int i = 0; i < n; i++) {
		int m, s;
		cin >> m >> s;

		vector<int> p(m);
		for(int j = 0; j < m; j++) {
			cin >> p[j];
		}

		if(m >= 2) {
			for(int j = 1; j < m; j++) {
				if(expdist != -1 && expdist != p[j] - p[j - 1]) {
					cout << "No" << endl;
					return 0;
				}
				expdist = p[j] - p[j - 1];
			}
		}

		a[i] = {p[0], s - p[m - 1]};
	}

	if(n == 1) {
		cout << "Yes" << endl << 1 << endl;
		return 0;
	}

	if(expdist != -1) {
		gogogo();
		cout << "No" << endl;
		return 0;
	}

	map<int, int> adjoutsz, adjinsz;
	for(int i = 0; i < n; i++) {
		adjoutsz[a[i].first]++;
		adjinsz[-a[i].second]++;
	}

	for(int i = 0; i < adjoutsz.size() && i < 5; i++) {
		for(int j = 0; j < adjinsz.size() && j < 5; j++) {
			expdist = next(adjoutsz.begin(), i)->first - next(adjinsz.begin(), j)->first;
			gogogo();
		}
	}

	vector<int> lstoutsz, lstinsz;
	for(auto [k, v]: adjoutsz) {
		lstoutsz.push_back(v);
		// outbyval[v].push_back(k);
	}
	for(auto [k, v]: adjinsz) {
		lstinsz.push_back(v);
	}
	sort(lstoutsz.begin(), lstoutsz.end());
	sort(lstinsz.begin(), lstinsz.end());

	/*
	lstoutsz = {1, 2, 3, 3, 3, 4, 6, 8, 10};
	lstinsz = {1, 2, 3, 3, 4, 4, 7, 8, 10};
	*/

	vector<int> diff(lstoutsz.size() + lstinsz.size());
	if(set_symmetric_difference(lstoutsz.begin(), lstoutsz.end(), lstinsz.begin(), lstinsz.end(), diff.begin()) - diff.begin() > 4) {
		cout << "No" << endl;
		return 0;
	}

	// cerr << "DIFF=" << set_symmetric_difference(lstoutsz.begin(), lstoutsz.end(), lstinsz.begin(), lstinsz.end(), diff.begin()) - diff.begin() << endl;

	/*
	int maxoutk = adjoutsz.begin()->first;
	for(auto [k, v]: adjoutsz) {
		if(v > adjoutsz[maxoutk]) {
			maxoutk = k;
		}
	}
	int maxink = adjinsz.begin()->first;
	for(auto [k, v]: adjinsz) {
		if(v > adjinsz[maxink]) {
			maxink = k;
		}
	}
	*/

	vector<int> conds;
	for(int i = 0; i < n; i++) {
		if(i != 0) {
			conds.push_back(a[0].second + a[i].first);
		}
		if(i != 1) {
			conds.push_back(a[1].second + a[i].first);
		}
	}
	sort(conds.begin(), conds.end());
	conds.erase(unique(conds.begin(), conds.end()), conds.end());
	for(int cond: conds) {
		expdist = cond;
		gogogo();
	}
	cout << "No" << endl;
	return 0;
}