#include <bits/stdc++.h>

using namespace std;

char a[10][10];
char forbidden[10][10][3];

int n, m, c;

bool put(int i, int j, int x) {
	a[i][j] = x;

	bool ok = true;
	for(int i1 = 0; i1 < i; i1++) {
		for(int j1 = j + 1; j1 < m; j1++) {
			if(a[i1][j1] == x && a[i1][j] == x) {
				forbidden[i][j1][x] = 1;
			}
			if(forbidden[i][j1][0] && forbidden[i][j1][1] && forbidden[i][j1][2]) {
				ok = false;
			}
		}
	}
	return ok;
}

int bestc1;

void gen(int i, int j) {
	if(j == m) {
		i++;
		j = 0;
	}
	if(i == n) {
		int c1 = 0;
		for(int i = 0; i < n; i++) {
			for(int j = 0; j < m; j++) {
				cout << a[i][j] + 1 << " ";
			}
			cout << endl;
		}
		exit(0);
		return;
	}

	int order[2];
	order[0] = 0;
	order[1] = 1;
	if(rand() % 2) {
		swap(order[0], order[1]);
	}

	for(int pos = 0; pos < 2; pos++) {
		int x = order[pos];
		if(!forbidden[i][j][x]) {
			char prevforbidden[10][3];
			memcpy(prevforbidden, forbidden[i], sizeof(prevforbidden));
			bool ok = put(i, j, x);
			if(ok) {
				gen(i, j + 1);
			}
			memcpy(forbidden[i], prevforbidden, sizeof(prevforbidden));
		}
	}
}


int ans99[9][9] = {
	{3, 3, 2, 1, 3, 2, 3, 2, 1},
	{1, 2, 1, 1, 3, 1, 2, 2, 3},
	{2, 2, 3, 3, 2, 1, 1, 3, 1},
	{1, 2, 2, 3, 3, 3, 1, 1, 2},
	{3, 1, 3, 1, 2, 3, 1, 2, 2},
	{2, 3, 3, 1, 1, 2, 2, 1, 2},
	{3, 2, 1, 2, 1, 2, 1, 3, 3},
	{1, 3, 2, 2, 2, 3, 2, 3, 1},
	{2, 1, 3, 2, 1, 1, 3, 2, 3},
};

int ans108[10][8] = {
	{2, 3, 1, 2, 2, 1, 3, 3},
	{3, 1, 2, 2, 3, 1, 3, 1},
	{3, 1, 1, 3, 2, 2, 1, 3},
	{3, 2, 3, 2, 1, 1, 1, 2},
	{2, 3, 3, 3, 3, 2, 1, 2},
	{1, 3, 1, 1, 2, 3, 2, 2},
	{3, 2, 2, 1, 2, 3, 1, 1},
	{1, 1, 2, 3, 1, 3, 3, 2},
	{2, 2, 3, 1, 1, 3, 2, 3},
	{3, 3, 1, 2, 1, 2, 2, 1}
};


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	srand(time(0));

	cin >> n >> m >> c;

	if(c == 2) {
		gen(0, 0);
	} else {
		if(n <= 9 && m <= 9) {
			for(int i = 0; i < n; i++) {
				for(int j = 0; j < m; j++) {
					cout << ans99[i][j] << " ";
				}
				cout << endl;
			}
		} else if(n == 10 && m <= 8) {
			for(int i = 0; i < n; i++) {
				for(int j = 0; j < m; j++) {
					cout << ans108[i][j] << " ";
				}
				cout << endl;
			}
		} else if(n <= 8 && m == 10) {
			for(int i = 0; i < n; i++) {
				for(int j = 0; j < m; j++) {
					cout << ans108[j][i] << " ";
				}
				cout << endl;
			}
		}
	}

	return 0;
}