#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	string s(n, '#');
	string carry(n, '#');
	string d(n, '#');
	for(int i = 0; i < n; i++) {
		a[i] -= '0';
		b[i] -= '0';
		c[i] -= '0';
		s[i] = a[i] + b[i];
		carry[i] = (10 + c[i] - s[i]) % 10;
		if(carry[i] > 1) {
			cout << 0 << endl;
			return 0;
		}
		d[i] = s[i] + carry[i] >= 10;
	}

	int ans = 0;

	for(int order0 = 0; order0 < n; order0++) {
		if(a[order0] == 0 || b[order0] == 0 || c[order0] == 0 || carry[order0] != 0) {
			continue;
		}

		vector<int> order(n - 1);
		for(int i = 0; i < n - 1; i++) {
			order[i] = i < order0 ? i : i + 1;
		}

		do {
			bool ok = true;
			for(int i = 0; i < n - 2; i++) {
				ok = ok && d[order[i]] == carry[order[i + 1]];
			}
			if(d[order0] == carry[order[0]] && d[order.back()] == 0 && ok) {
				ans++;
			}
		} while(next_permutation(order.begin(), order.end()));
	}

	cout << ans << endl;

	return 0;
}