#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	string s(n, '#');
	string carry(n, '#');
	string d(n, '#');
	for(int i = 0; i < n; i++) {
		a[i] -= '0';
		b[i] -= '0';
		c[i] -= '0';
		s[i] = a[i] + b[i];
		carry[i] = (10 + c[i] - s[i]) % 10;
		if(carry[i] > 1) {
			cout << 0 << endl;
			return 0;
		}
		d[i] = s[i] + carry[i] >= 10;
	}

	int ans = 0;

	for(int first = 0; first < n; first++) {
		if(!(!d[first] && a[first] != 0 && b[first] != 0 && c[first] != 0)) {
			continue;
		}

		vector< pair<int, int> > edges;
		for(int i = 0; i < n; i++) {
			edges.emplace_back(d[i], carry[i]);
		}

		vector< pair<int, int> > order;
		int cnt_by_type[4];
		memset(cnt_by_type, 0, sizeof(cnt_by_type));
		for(int i = 0; i < n; i++) {
			if(i != first) {
				order.push_back(edges[i]);
				cnt_by_type[edges[i].first * 2 + edges[i].second]++;
			}
		}
		sort(order.begin(), order.end());

		int localans = 0;
		do {
			bool ok = carry[first] == order[0].first;
			for(int i = 0; i < n - 2; i++) {
				ok = ok && order[i].second == order[i + 1].first;
			}
			ok = ok && order[n - 2].second == 0;
			localans += ok;
		} while(next_permutation(order.begin(), order.end()));

		for(int x: cnt_by_type) {
			for(int i = 1; i <= x; i++) {
				localans *= i;
				localans %= 1000000007;
			}
		}

		ans += localans;
	}

	ans %= 1000000007;

	cout << ans << endl;

	return 0;
}