#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define len(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, l, r) for (int i = (l); i < (r); i++)

#ifdef LOCAL
#include "/home/olymp/codes/debug.h"
#else
#define dbg(...)
#endif

inline void gg() {
	cout << "No\n";
	exit(0);
}

void dfsTopsort(int v, vector<vector<int>> &g, vector<int> &topsort, vector<char> &used, int n) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (!used[u]) dfsTopsort(u, g, topsort, used, n);
	}
	if (v < n) topsort.push_back(v);
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;
	vector<pair<int, int>> a;
	int del = -1;
	forn (i, 0, n) {
		int m, s;
		cin >> m >> s;
		vector<int> positions(m);
		forn (j, 0, m) cin >> positions[j];
		a.emplace_back(positions[0], s - positions.back());
		if (m == 1) continue;

		forn (j, 1, m) {
			int cur = positions[j] - positions[j - 1];
			if (del == -1) del = cur;
			else if (del != cur) gg();
		}
	}

	// auto brute = [&]() {
	// 	vector<int> perm(n);
	// 	iota(all(perm), 0);
	// 	do {
	// 		bool ok = true;
	// 		int curVal = -1;
	// 		forn (i, 1, n) {
	// 			int cur = perm[i];
	// 			int prev = perm[i - 1];
	// 			int x = a[cur].first + a[prev].second;
	// 			if (del != -1) ok &= (x == del);
	// 			else if (curVal == -1) curVal = x;
	// 			else ok &= (curVal == x);
	// 		}
	// 		if (ok) {
	// 			cout << "Yes\n";
	// 			forn (i, 0, n) cout << perm[i] + 1 << " \n"[i == n - 1];
	// 			exit(0);
	// 		}
	// 	} while (next_permutation(all(perm)));
	// 	gg();
	// };
	// if (n <= 8) brute();

	auto solveFixed = [&](int del) {
		map<int, vector<int>> classes;
		forn (i, 0, n) classes[a[i].first].push_back(i);
		int nClasses = len(classes);

		map<int, int> index;
		int curIndex = n;
		for (auto [cl, vec] : classes) {
			index[cl] = curIndex;
			curIndex++;
		}

		vector<vector<int>> g(n + nClasses);
		forn (i, 0, n) {
			int sec = a[i].second;
			if (sec > del) continue;
			if (classes.find(del - sec) == classes.end()) continue;
			g[i].push_back(index[del - sec]);
		}

		forn (i, 0, n) {
			int fir = a[i].first;
			if (fir > del) continue;
			g[index[fir]].push_back(i);
		}
		dbg(g);

		vector<int> topsort;
		vector<char> used(n + nClasses);
		forn (i, 0, n + nClasses) {
			if (used[i]) continue;
			dfsTopsort(i, g, topsort, used, n);
		}
		reverse(all(topsort));
		dbg(topsort);

		bool correct = true;
		forn (i, 1, n) {
			int cur = topsort[i];
			int prev = topsort[i - 1];
			int x = a[prev].second + a[cur].first;
			correct &= (x == del);
			if (!correct) break;
		}

		if (correct) {
			cout << "Yes\n";
			forn (i, 0, n) cout << topsort[i] + 1 << " \n"[i == n - 1];
			exit(0);
		}
	};

	if (del != -1) solveFixed(del);
	else {
		map<int, int> cnt;
		forn (i, 0, n) {
			forn (j, 0, n) {
				if (i != j) cnt[a[i].first + a[j].second]++;
			}
		}
		for (auto [x, num] : cnt) {
			// if (num >= n - 1) solveFixed(x);
			solveFixed(x);
		}
		solveFixed(0);
	}
	gg();
}
