#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define len(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, l, r) for (int i = (l); i < (r); i++)

#ifdef LOCAL
#include "/home/olymp/codes/debug.h"
#else
#define dbg(...)
#endif

void bruteSolve(int n, int m, int c) {
	vector<int> pc(n * m + 1, 1);
	forn (i, 1, n * m + 1) pc[i] = pc[i - 1] * c;

	auto getBit = [&](int mask, int bit) {
		return (mask / pc[bit]) % c;
	};

	forn (mask, 0, pc.back()) {
		vector<vector<int>> grid(n, vector<int>(m));
		forn (i, 0, n) {
			forn (j, 0, m) grid[i][j] = getBit(mask, i * m + j);
		}

		bool ok = true;
		forn (i, 0, n) {
			forn (j, 0, m) {
				forn (ii, i + 1, n) {
					forn (jj, j + 1, m) {
						if (grid[i][j] == grid[ii][j] && grid[i][j] == grid[ii][jj] && grid[i][j] == grid[i][jj]) {
							ok = false;
							break;
						}
					}
					if (!ok) break;
				}
				if (!ok) break;
			}
			if (!ok) break;
		}
		if (!ok) continue;

		forn (i, 0, n) {
			forn (j, 0, m) cout << grid[i][j] + 1 << " \n"[j == m - 1];
		}
		exit(0);
	}
	assert(false);
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m, c;
	cin >> n >> m >> c;

	if (c == 2) bruteSolve(n, m, c);

	if (n == 2) {
		forn (i, 0, m - 1) cout << 1 << ' ';
		cout << "2\n";
		forn (i, 0, m) cout << 1 << " \n"[i == m - 1];
		return 0;
	}
	if (m == 2) {

	}
}
