#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <map>

using namespace std;
using __gnu_pbds::gp_hash_table;
int n;


void rec(int u, int d, vector<bool> used, vector<int> result, vector<pair<int, int>> &a)
{
    if ((int) result.size() == n)
    {
        cout << "Yes" << endl;
        for (int i: result) cout << i << ' ';
        cout << endl;
        exit(0);
    }
    for (int i(0); i < (int) used.size(); ++i)
    {
        if (used[i] || (d != -1 && a[u].second + a[i].first != d)) continue;
        result.push_back(i + 1);
        used[i] = true;
        rec(i, a[u].second + a[i].first, used, result, a);
        result.pop_back();
        used[i] = false;
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    int d = -1;
    map<int, vector<int>> prefs, suffs;
    int max_s = -1;
    vector<pair<int, int>> a;
    for (int i(0); i < n; ++i)
    {
        int m, s;
        cin >> m >> s;
        max_s = max(max_s, s);
        int p = -1;
        int pref = -1;
        int suff = -1;
        for (int j(0); j < m; ++j)
        {
            int x;
            cin >> x;
            if (pref == -1) pref = x;
            int now_d = -1;
            if (p != -1) now_d = x - p;
            if (d == -1) d = now_d;
            else
            {
                if (d != now_d)
                {
                    return 1;
                    cout << "No" << endl;
                    return 0;
                }
            }
            p = x;
        }
        suff = s - p;
        prefs[pref].push_back(i);
        suffs[suff].push_back(i);
        a.push_back({pref, suff});
    }
    bool dd = false;
    if (d != -1) dd = true;
    for (int i(0); i < n; ++i)
    {
        vector<int> result;
        vector<bool> used(n);
        used[i] = true;
        result.push_back(i + 1);
        if (dd) rec(i, d, used, result, a);
        else rec(i, -1, used, result, a);
        used[i] = false;
        result.pop_back();
    }
    cout << "No" << endl;
    return 0;
}
