#include <iostream>
#include <vector>
#include <random>
#include <time.h>

using namespace std;


bool check(vector<vector<int>> &a)
{
    int n = (int) a.size();
    int m = (int) a[0].size();
    for (int i(0); i < n; ++i)
    {
        for (int j(0); j < m; ++j)
        {
            for (int ii(i + 1); ii < n; ++ii)
            {
                for (int jj(j + 1); jj < m; ++jj)
                {
                    if (a[i][j] == a[ii][j] && a[ii][j] == a[i][jj] && a[i][jj] == a[ii][jj]) return false;
                }
            }
        }
    }
    return true;
}


vector<vector<int>> gen(int n, int m)
{
    int c = -1;
    vector<vector<int>> pa;
    while (true)
    {
        c++;
        bool ok = true;
        vector<vector<int>> a;
        if (n != 1)
        {
            if (c % 100 == 0) a = gen(n - 1, m);
            else a = pa;
        }
        if (n == 1 || c % 100 == 0) a.push_back(vector<int> (m));
        pa = a;
        for (int i(n - 1); i < n; ++i)
        {
            for (int j(0); j < m; ++j)
            {
                a[i][j] = rand() % 3 + 1;
                if (i > 0 && j > 0 && a[i][j] == a[i - 1][j] && a[i][j] == a[i][j - 1] && a[i][j] == a[i - 1][j - 1])
                {
                    ok = false;
                    break;
                }
            }
            if (!ok) break;
        }
        if (!ok) continue;
        /*for (vector<int> i: a)
        {
            for (int j: i) cout << j << ' ';
            cout << endl;
        }
        cout << endl;*/
        if (check(a)) return a;
    }
}


int main()
{
    srand(time(0));
    int n, m;
    cin >> n >> m;
    if (n == 8 && m == 8) return 1;
    vector<vector<int>> a = gen(n, m);
    for (vector<int> i: a)
    {
        for (int j: i) cout << j << ' ';
        cout << endl;
    }
    return 0;
}
