#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define ft first
#define sd second

typedef long long ll;

int len(int n)
{
    return n == 0 ? -1 : n == 1 ? 0 : to_string(n).size();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	string s; cin >> s;
    vector<pair<int, char>> a;
	int n = s.size(),
        cur = 0,
        i = 0;
    vector<int> pref(n + 1, 0);
    for (int i = 0; i <= n; i++)
        pref[i] = 0;
    while (i < n) {
        while (isdigit(s[i]))
            cur = 10 * cur + s[i++] - '0';
        a.push_back({cur == 0 ? 1 : cur, s[i]});
        pref[a.size()] = pref[a.size() - 1] + cur;
        cur = 0;
        i++;
    }

    // find min
    ll best = 0;
    pair<int, pair<int, char>> min_res;
    for (int i = 0; i < a.size(); i++) {
        // delete one
        int del_one = len(a[i].ft) + 1 - (len(a[i].ft - 1) + 1);
        if (del_one >= best) {
            best = del_one;
            min_res = {2, {pref[i] + 1, ' '}};
        }

        // unite neighbors
        //if (i == 1)
            //cout << a[i - 1].sd << ' ' << a[i + 1].sd << '\n';
        if (i != 0 && i != n && a[i].ft == 1 && a[i - 1].sd == a[i + 1].sd) {
            int unite_neighbors = len(a[i - 1].ft) + 1 + 1 + len(a[i + 1].ft) + 1 - (len(a[i - 1].ft + 1 + a[i + 1].ft) + 1);
            //cout << i << ' ' << len(a[i - 1].ft) + 1 + 1 + len(a[i + 1].ft) + 1 << ' ' << (len(a[i - 1].ft + 1 + a[i + 1].ft) + 1) << '\n';
            if (unite_neighbors >= best) {
                best = unite_neighbors;
                //cout << i << ' ' << a[i - 1].ft << ' ' << a[i - 1].sd << '\n';
                min_res = {3, {pref[i] + 1, a[i - 1].sd}};
            }
        }

        // that's all for now...
    }

    //find max
    best = 0;
    pair<int, pair<int, char>> max_res;
    for (int i = 0; i < a.size(); i++) {
        // insert one
        int insert_one = len(a[i].ft + 1) + 1 - (len(a[i].ft) + 1);
        if (insert_one >= best) {
            best = insert_one;
            max_res = {1, {pref[i], a[i].sd}};
        }

        // split in two
        if (a[i].ft > 1) {
            int l = a[i].ft / 2;
            int r = a[i].ft - l;
            int split = len(l) + 1 + 1 + len(r) + 1 - (len(a[i].ft) + 1);
            //cout << i << ' ' << l << ' ' << ' ' << r << ' ' << split << '\n';
            if (split >= best) {
                best = split;
                max_res = {1, {pref[i] + l, a[i].sd == 'A' ? 'C' : 'A'}};
            }
        }
    }
    cout << min_res.ft << ' ' << min_res.sd.ft << ' ' << min_res.sd.sd << '\n';
    cout << max_res.ft << ' ' << max_res.sd.ft << ' ' << max_res.sd.sd << '\n';

    return 0;
}
