#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int n, m, c;
vector<vector<int>> a;

bool check(int N = n, int M = m) {
    for (int i1 = 0; i1 < N - 1; ++i1)
        for (int j1 = 0; j1 < M - 1; ++j1)
            for (int i2 = i1 + 1; i2 < N; ++i2)
                for (int j2 = j1 + 1; j2 < M; ++j2)
                    if (a[i1][j1] == a[i1][j2] && a[i1][j1] == a[i2][j2] && a[i1][j1] == a[i2][j1])
                        return false;
    return true;
}

vector<vector<vector<int>>> d;

void req(int pos) {
    if (pos == n * m) {
        if (check()) {
            for (auto& i : a) {
                for (auto& j : i)
                    cout << j << ' ';
                cout << '\n';
            }
            exit(0);
       }
    }
    else {
        int i = pos / m,
            j = pos % m;
        for (int color = 1; color <= c; ++color) {
            a[i][j] = color;
            req(pos + 1);
        }
    }
}

void req1(int pos)
{
    if (pos == 9 && check(10, 9)) {
        for (int i = 0; i < 10; i++) {
            for (int j = 0; j < 9; j++) {
                cout << a[i][j] << ' ';
            }
            cout << '\n';
        }
    }
    else if (pos < 9) {
        for (int color = 1; color <= 3; color++) {
            a[9][pos] = color;
            req1(pos + 1);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    cin >> n >> m >> c;
    a = vector<vector<int>> (n + 1, vector<int>(m, 0));

    if (c == 2)
        req(0);
    if (n <= 9 && m <= 9) {
        a = {{2,1,3,3,2,1,3,1,3},{3,3,1,2,2,1,2,2,1},{2,1,3,1,1,3,2,3,2},{3,2,2,2,1,1,1,3,3},{2,2,3,1,3,2,1,2,1},{1,1,1,2,3,2,1,3,2},{1,3,2,1,2,1,3,3,2},{1,3,2,3,3,2,2,1,1},{3,2,1,1,3,3,3,1,2},{0,0,0,0,0,0,0,0,0}};
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << a[i][j] << ' ';
            }
            cout << '\n';
        }
    }
    else if (n <= 10 && m <= 6) {
        a = {{3,1,3,2,1,1,2},{1,2,3,3,3,2,1},{2,3,1,3,1,2,2},{3,3,2,1,1,2,1},{3,1,1,3,2,2,1},{1,2,3,1,2,3,2},{3,1,2,1,3,3,2},{2,3,2,2,2,1,3},{2,2,1,1,3,1,3},{1,2,2,3,1,3,3}};
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << a[i][j] << ' ';
            }
            cout << '\n';
        }
    }
    else if (n <= 6 && m <= 10) {
        a = {{3,1,3,2,1,1,2},{1,2,3,3,3,2,1},{2,3,1,3,1,2,2},{3,3,2,1,1,2,1},{3,1,1,3,2,2,1},{1,2,3,1,2,3,2},{3,1,2,1,3,3,2},{2,3,2,2,2,1,3},{2,2,1,1,3,1,3},{1,2,2,3,1,3,3}};
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << a[j][i] << ' ';
            }
            cout << '\n';
        }
    }
    cout << 31337;
    return 0;
}

