#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>

using namespace std;

typedef long long ll;

ll n, ans = 0, mod = 1e9 + 7;
string A, B, C;
vector<int> a, b, c, order;
bitset<18> used, need_one, has_one;

bool check()
{
    int add = 0;
    for (auto i : order) {
        if ((add + a[i] + b[i]) % 10 != c[i])
            return false;
        add = (add + a[i] + b[i]) / 10;
    }
    if (add > 0 || a[order.back()] == 0 || b[order.back()] == 0 || c[order.back()] == 0)
        return false;
    return true;
}

void req(int pos)
{
    //if (pos >= n) {
     //   for (auto i : order)
     //       cout << i << ' ';
     //   cout << '\n';
    //}
    if (pos >= n && check())
        ans = (ans + 1) % mod;
    else if (pos < n) {
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                if (!order.empty() && has_one[order.back()] && need_one[i]) {
                    order.push_back(i);
                    used[i] = 1;
                    req(pos + 1);
                    order.pop_back();
                    used[i] = 0;
                }
                else if (order.empty() || !has_one[order.back()]){
                    order.push_back(i);
                    used[i] = 1;
                    req(pos + 1);
                    order.pop_back();
                    used[i] = 0;
                }
            }
        }
    }
}

int main()
{
    cin >> A >> B >> C;
    n = A.size();
    for (int i = 0; i < n; i++) {
        a.push_back(A[i] - '0');
        b.push_back(B[i] - '0');
        c.push_back(C[i] - '0');
    }

    for (int i = 0; i < n; i++) {
        if (a[i] + b[i] > 9)
            has_one[i] = 1;
        if ((a[i] + b[i] + 1) % 10 == c[i])
            need_one[i] = 1;
        else if ((a[i] + b[i]) % 10 != c[i]) {
            cout << 0;
            return 0;
        }
    }

    req(0);

    cout << ans;
    return 0;
}
