#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define all(x) (x).begin(), x.end()
#define sz(x) (int)x.size()
#ifndef MY
    #define endl '\n'
#endif // MY

typedef long double db;
typedef long long ll;
typedef pair < int, int > pii;

struct Col {
    int a, b, c, k;
    bool in, out, st;
    Col(int a = 0, int b = 0, int c = 0) : a(a), b(b), c(c) {
        in = 0;
        out = 0;
        st = 0;
        k = 0;
    }
};

const ll mod = 1e9 + 7;

struct Int {
    ll x;
    Int(ll x = 0) : x(x) {}
    Int operator + (Int a) {
        return Int((x + a.x) % mod);
    }
    Int operator += (Int a) {
        return Int(x = (x + a.x) % mod);
    }
    Int operator * (Int a) {
        return Int((x * a.x) % mod);
    }
    Int operator *= (Int a) {
        return Int(x = (x * a.x) % mod);
    }
    Int operator - (Int a) {
        return Int((x + mod - a.x) % mod);
    }
    Int operator -= (Int a) {
        return Int(x = (x + mod - a.x) % mod);
    }
};

const int N = 4e5 + 5;
string inp[3];
Col lst[N];
vector < int > type[4];
Int fact[N];
Int rev[N];

Int deg(Int a, int d) {
    Int res(1);
    while (d) {
        if (d % 2) {
            res *= a;
        }
        a *= a;
        d /= 2;
    }
    return res;
}

void build() {
    fact[0] = 1;
    for (int i = 1; i < N; i++) {
        fact[i] = fact[i - 1] * i;
    }
    rev[N - 1] = deg(fact[N - 1], mod - 2);
    for (int i = N - 2; i >= 0; i--) {
        rev[i] = rev[i + 1] * (i + 1);
    }
}

Int kek(int x, int y) {
    if (y == 0) {
        return fact[x];
    }
    Int a = fact[x - 1] * rev[y] * rev[x - y - 1];
    return deg(a, x - y);
}

bool used[N];
vector < int > cur;
Int answer = 0;
void solve(int t, int n) {
    if (t == n) {
        bool fl = 1;
        if (!lst[cur[0]].st) {
            fl = 0;
        }
        for (int i = 0; i < n && fl; i++) {
            int j = cur[i];
            if (lst[j].k & 1) {
                if (i + 1 == n || ((lst[cur[i + 1]].k & 2) == 0)) {
                    fl = 0;
                    continue;
                }
            }
            if (lst[j].k & 2) {
                if (i == 0 || ((lst[cur[i - 1]].k & 1) == 0)) {
                    fl = 0;
                    continue;
                }
            }
        }
        answer += fl;
        return;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = 1;
            cur.pb(i);
            solve(t + 1, n);
            cur.pop_back();
            used[i] = 0;
        }
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    build();
    for (int i = 0; i < 3; i++) {
        cin >> inp[i];
    }
    int n = sz(inp[0]);
    for (int i = 0; i < n; i++) {
        lst[i].a = inp[0][i] - '0';
        lst[i].b = inp[1][i] - '0';
        lst[i].c = inp[2][i] - '0';
        int sum = (lst[i].a + lst[i].b);
        lst[i].in = ((sum % 10) != lst[i].c);
        lst[i].out = (sum > 9);
        lst[i].st = (lst[i].a > 0 && lst[i].b > 0 && !lst[i].out);
        assert(lst[i].st || (lst[i].c != 0));
        if ((sum % 10) != lst[i].c && ((sum + 1) % 10) != lst[i].c) {
            cout << 0;
            return 0;
        }
        lst[i].k = 1 * lst[i].in + 2 * lst[i].out;
        type[lst[i].k].pb(i);
    }
    solve(0, n);
    cout << answer.x << endl;
    //return 0;
    if (sz(type[1]) != sz(type[2]) || (sz(type[1]) == 0 && sz(type[3]) > 0)) {
        cout << 0;
        return 0;
    }
    int a = sz(type[1]), b = sz(type[2]), c = sz(type[3]), k = sz(type[0]);
    Int res(1);
    if (a) {
        res *= fact[c + a - 1] * rev[a - 1] * fact[b];// * (rev[c] * fact[c]) ;
    }
    int x = 0, y = 0;
    for (auto i : type[0]) {
        if (lst[i].st == 0) {
            x++;
        }
    }
    for (auto i : type[1]) {
        if (lst[i].st == 0) {
            y++;
        }
    }
    Int ans(0);
    for (int i = 0; i < k - x; i++) {
        ans += res * fact[a + k - 1];// * (rev[a] * fact[a]) * (rev[k - 1] * fact[k - 1]);
    }
    for (int i = 0; i < a - y; i++) {
        ans += res * fact[k + a - 1];// * (rev[a - 1] * fact[a]) * (rev[k] * fact[k]);
    }
    cout << ans.x;
    return 0;
}
