#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

string alll = "AGTC";

vector<pair<int, char>> read() {
	int n = 0;
	char c;
	string s;
	cin >> s;
	vector<pair<int, char>> ans;
	for (char c : s) {
		if ('0' <= c && c <= '9') {
			n *= 10;
			n += c - '0';
		} else {
			ans.push_back({max(1, n), c});
			n = 0;
		}
	}
	return ans;
}
	
int getlen(pair<int, char> kek) {
	if (kek.first == 0)
		return 0;
	if (kek.first == 1) {
		return 1;
	}
	return to_string(kek.first).size() + 1;
}

vector<pair<int, char>> encode(string s) {
	vector<pair<int, char>> arr;
	for (char c : s) {
		if (arr.empty() || arr.back().second != c) {
			arr.push_back({1, c});
		} else {
			arr.back().first++;
		}
	}
	return arr;
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	auto arr = read();
	int n = arr.size();
	int len = 0;
	for (auto pp : arr)
		len += pp.first;
	string s;
	for (auto el : arr) {
		for (int i = 0; i < el.first; i++) {
			s.push_back(el.second);
		}
	}
	assert(s.size() == len);
	pair<int, string> mn = {INT_MAX, ""}, mx = {-1, ""};
	for (int i = 0; i <= len; i++) {
		for (char c : alll) {
			auto s2 = s;
			s2.insert(s2.begin() + i, c);
			auto arr2 = encode(s2);
			int ln = 0;
			for (auto pp : arr2) {
				ln += getlen(pp);
			}
			pair<int, string> kek = {ln, "1 " + to_string(i) + " " + c};
			mn = min(mn, kek);
			mx = max(mx, kek);
		}
	}
	for (int i = 0; i < len; i++) {
		auto s2 = s;
		s2.erase(s2.begin() + i);
		auto arr2 = encode(s2);
		int ln = 0;
		for (auto pp : arr2)
			ln += getlen(pp);
		pair<int, string> kek = {ln, "2 " + to_string(i + 1)};
		mn = min(mn, kek);
		mx = max(mx, kek);
	}
	cout << mn.second << endl;
	cout << mx.second << endl;
}
