#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

void solve(vector<pair<int, int>> arr, int dist) {
	int n = arr.size();
	map<int, set<int>> byfirst, bysecond;
	map<pair<int, int>, set<int>> byboth;
	for (int i = 1; i < n; i++) {
		byfirst[arr[i].first].insert(i);
		bysecond[arr[i].second].insert(i);
		byboth[arr[i]].insert(i);
	}
	deque<int> ans = {0};
	while (!byfirst[dist - arr[ans.back()].second].empty()) {
		int kek = dist - arr[ans.back()].second;
		int i = *byfirst[kek].begin();
		byfirst[arr[i].first].erase(i);
		bysecond[arr[i].second].erase(i);
		byboth[arr[i]].erase(i);
		ans.push_back(i);
	}
	while  (!bysecond[dist - arr[ans[0]].first].empty()) {
		int kek = dist - arr[ans[0]].first;
		int i = *bysecond[kek].begin();
		byfirst[arr[i].first].erase(i);
		bysecond[arr[i].second].erase(i);
		byboth[arr[i]].erase(i);
		ans.push_front(i);
	}
	vector<int> ans2;
	for (auto &j : ans) {
		if (!ans2.empty()) {
			int i = ans2.back();
			pair<int, int> kek = {arr[j].first, arr[i].second};
			while (!byboth[kek].empty()) {
				int k = *byboth[kek].begin();
				byfirst[arr[k].first].erase(k);
				bysecond[arr[k].second].erase(k);
				byboth[arr[k]].erase(k);
				ans2.push_back(k);
			}
		}
		ans2.push_back(j);
	}
	if (ans2.size() == n) {
		cout << "Yes" << endl;
		for (int i = 0; i < n; i++) {
			cout << ans2[i] + 1 << " ";
		}
		cout << endl;
		exit(0);
	}
}

signed main() {
	auto start = clock();
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<pair<int, int>> arr(n);
	int mnneed = INT_MAX;
	int mxneed = -1;
	for(int i = 0; i < n; i++) {
		int k;
		cin >> k;
		int s;
		cin >> s;
		vector<int> arr2(k);
		for (int i = 0; i < k; i++) {
			cin >> arr2[i];
		}
		for (int i = 1; i < k; i++) {
			int ln = arr2[i] - arr2[i - 1];
			mxneed = max(mxneed, ln);
			mnneed = min(mnneed, ln);
		}
		arr[i] = {arr2[0], s - arr2.back()};
	}
	if (mxneed != -1) {
		if (mxneed != mnneed) {
			cout << "No" << endl;
			return 0;
		}
		solve(arr, mnneed);
		cout << "No" << endl;
		return 0;
	}
	if (n == 1) {
		cout << "Yes" << endl;
		cout << 1 << endl;
		return 0;
	}
	set<int> was;
	for (int j = 1; j < n; j++) {
		int cnt = arr[0].second + arr[j].first;
		if (!was.count(cnt)) {
			solve(arr, cnt);
			was.insert(cnt);
		}
		cnt = arr[0].first + arr[j].second;
		if (!was.count(cnt)) {
			solve(arr, cnt);
			was.insert(cnt);
		}
	}

	cout << "No" << endl;
}
