#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;


int n;
vector<pair<int, vector<int>>> arr;

int mxdiff = -1;
int mndiff = INT_MAX;

bool check(vector<int> perm) {
	int mx = mxdiff;
	int mn = mndiff;
	for (int i = 1; i < n; i++) {
		int df = arr[perm[i]].second[0] + (arr[perm[i - 1]].first - arr[perm[i - 1]].second.back());
		mx = max(mx, df);
		mn = min(mn, df);
	}
	if (mx == -1) {
		return 1;
	}
	if (mx == mn) {
		return true;
	}
	return false;
}

signed main() {
	auto start = clock();
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	arr.resize(n);
	for(int i = 0; i < n; i++) {
		int k;
		cin >> k;
		int s;
		cin >> s;
		vector<int> arr2(k);
		for (int i = 0; i < k; i++) {
			cin >> arr2[i];
		}
		arr[i] = {s, arr2};
		for (int i = 1; i < k; i++) {
			int df = arr2[i] - arr2[i - 1];
			mndiff = min(mndiff, df);
			mxdiff = max(mxdiff, df);
		}
	}
	vector<int> perm(n);
	iota(perm.begin(), perm.end(), 0);
	do {
		if (check(perm)) {
			cout << "Yes" << endl;
			for (int i = 0; i < n; i++) {
				cout << perm[i] + 1 << ' ';
			}
			cout << endl;
			exit(0);
		}
	} while (next_permutation(perm.begin(), perm.end()));
	cout << "No" << endl;
}
