//#pragma comment(linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")
#ifdef _MSC_VER
	#define _CRT_SECURE_NO_WARNINGS
	#include <__msvc_all_public_headers.hpp>	
	#include <Windows.h>
#else
	#define _MSC_VER 2000
	#include <bits/stdc++.h>
	#pragma GCC optimize("Ofast")
	#pragma GCC optimize("fast-math")
	#pragma GCC optimize ("unroll-loops")
	#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#endif

#define nl					"\n"
#define int					long long
#define uint				unsigned int
#define double				long double
#define len(Q)				(int)Q.size()
#define all(Q)				Q.begin(), Q.end()

using namespace std;

template <typename T> ostream &operator <<(ostream &out, vector <T> &a)
{
	for (auto &p : a)
		out << p << " ";
	return out;
}
template <typename T> istream &operator >>(istream &inp, vector <T> &a)
{
	for (auto &p : a)
		inp >> p;
	return inp;
}

int sumv(int j, int n, int m)
{
	return (j + 1) * n * (j + 2 + (n - 1) * m) / 2;
}

int sums(int j, int n, int m)
{
	return (j + 1) * m * (m + 1 + m * j) / 2;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	srand((signed)time(NULL));

	int t;
	cin >> t;
	while (t--)
	{
		int n, m;
		cin >> n >> m;

		pair <char, int> ans = { 'V', -1 };

		int ans1 = 0;
		int l = 0, r = m;
		while (r - l > 1)
		{
			int mt = (l + r) / 2;
			if (2 * sumv(mt, n, m) < sumv(m - 1, n, m))
				l = mt;
			else
				r = mt;
		}

		ans = { 'V', l };
		if (abs(2 * sumv(l, n, m) - sumv(m - 1, n, m)) > abs(2 * sumv(r, n, m) - sumv(m - 1, n, m)))
			ans = { 'V', r };

		l = 0, r = n;
		while (r - l > 1)
		{
			int mt = (l + r) / 2;
			if (2 * sums(mt, n, m) < sums(n - 1, n, m))
				l = mt;
			else
				r = mt;
		}

		if (abs(2 * sumv(ans.second, n, m) - sumv(m - 1, n, m)) > abs(2 * sums(l, n, m) - sums(n - 1, n, m)) || abs(2 * sumv(ans.second, n, m) - sumv(m - 1, n, m)) > abs(2 * sums(r, n, m) - sums(n - 1, n, m)))
		{
			ans = { 'H', l };
			if (abs(2 * sums(l, n, m) - sums(n - 1, n, m)) > abs(2 * sums(r, n, m) - sums(n - 1, n, m)))
				ans = { 'H', r };
		}

		if (ans.first == 'V' && ans.second + 2 > m)
			ans.second = m;
		if (ans.first == 'H' && ans.second + 2 > n)
			ans.second = n;
		
		cout << ans.first << ' ' << ans.second + 2 << nl;
	}

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}