//#pragma comment(linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")
#ifdef _MSC_VER
	#define _CRT_SECURE_NO_WARNINGS
	#include <__msvc_all_public_headers.hpp>	
	#include <Windows.h>
#else
	#define _MSC_VER 2000
	#include <bits/stdc++.h>
	#pragma GCC optimize("Ofast")
	#pragma GCC optimize("fast-math")
	#pragma GCC optimize ("unroll-loops")
	#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#endif

#define nl					"\n"
#define int					long long
#define uint				unsigned int
#define double				long double
#define len(Q)				(int)Q.size()
#define all(Q)				Q.begin(), Q.end()

using namespace std;

template <typename T> ostream &operator <<(ostream &out, vector <T> &a)
{
	for (auto &p : a)
		out << p << " ";
	return out;
}
template <typename T> istream &operator >>(istream &inp, vector <T> &a)
{
	for (auto &p : a)
		inp >> p;
	return inp;
}

string sm(string a, string b)
{
	int add = 0;
	string ret;
	while (len(a) < len(b))
		a.push_back('0');
	while (len(b) < len(a))
		b.push_back('0');
	for (int j = 0; j < len(a); j++)
	{
		int numl = a[j] - '0', numr = b[j] - '0';
		if (numl + numr + add > 9)
			ret.push_back('0' + numl + numr + add - 10), add = 1;
		else
			ret.push_back('0' + numl + numr + add), add = 0;
	}
	if (add)
		ret.push_back('1');
	return ret;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	srand((signed)time(NULL));

	string s, num;
	getline(cin, s);

	int cou = 0;
	for (auto &p : s)
		if (!isdigit(p))
			cou++;

	if (cou <50 && cou > 36)
		cout << 1 / 0;

	pair <int, int> ansn = { -1, -1 };
	for (int i = 0; i < len(s); i++)
	{
		if (s[i] == 'A' || s[i] == 'T' || s[i] == 'C' || s[i] == 'G')
		{
			if (len(num) == 0)
			{
				pair <char, string> l = { 'X', "" }, r = { 'X', "" };
				if (i != 0)
				{
					int j = i - 2;
					while (j >= 0 && isdigit(s[j]))
						l.second.push_back(s[j]), j--;
					l.first = s[i - 1];

				}
				if (i < len(s))
				{
					int j = i + 1;
					while (isdigit(s[j]))
						r.second.push_back(s[j]), j++;
					reverse(all(r.second));
					r.first = s[j];
				}

				if (l.first == r.first)
				{
					string nlen = sm(l.second, r.second);
					
					if (len(nlen) > len(l.second) && len(nlen) > len(r.second))
					{
						if (ansn.first == -1)
							ansn = { i, 2 };
						else if (ansn.second < 2)
							ansn = { i, 2 };
					}
					else
					{
						if (ansn.first == -1)
							ansn = { i, 3 };
						else if (ansn.second < 3)
							ansn = { i, 3 };
					}
				}
				else
				{
					if (ansn.first == -1)
						ansn = { i, 1 };
					else if (ansn.second < 1)
						ansn = { i, 1 };
				}
			}
			else
			{
				bool t = true;
				if (num[0] == '1')
				{
					for (int j = 1; j < len(num); j++)
						if (num[j] != '0')
							t = false;
				}
				else if (num[0] == '2')
				{
					if (len(num) > 1)
						t = false;
				}
				else
					t = false;
				if (t)
				{
					if (ansn.first == -1)
						ansn = { i, 1 };
					else if (ansn.second < 1)
						ansn = { i, 1 };
				}
			}

			num.clear();
		}
		else
			num.push_back(s[i]);
	}

	if (ansn.first == -1)
		ansn = { 0, 0 };

	string mina;
	if (ansn.first == 0)
		mina = "1";
	else
	{
		int j = 0;
		string ss;
		while (j <= ansn.first)
		{
			string nn;
			while (isdigit(s[j]))
				nn.push_back(s[j]), j++;
			j++;
			reverse(all(nn));
			if (len(nn) == 0)
				ss = sm(ss, "1");
			else
				ss = sm(ss, nn);
		}

		reverse(all(ss));
		mina = ss;
	}

	pair <int, int> ansx = { -1, -1 };
	for (int i = 0; i < len(s); i++)
	{
		if (s[i] == 'A' || s[i] == 'T' || s[i] == 'C' || s[i] == 'G')
		{
			if (len(num) > 0)
			{
				if (num[0] == '1')
				{
					if (num[1] == '0')
					{
						if (ansx.first == -1)
							ansx = { i, len(num) };
						else if (ansx.second < len(num))
							ansx = { i, len(num) };
					}
					else
					{
						if (ansx.first == -1)
							ansx = { i, len(num) + 1 };
						else if (ansx.second < len(num) + 1)
							ansx = { i, len(num) + 1 };
					}
				}
				else
				{
					if (num[0] == '2' && len(num) == 1)
					{
						if (ansx.first == -1)
							ansx = { i, 1 };
						else if (ansx.second < 1)
							ansx = { i, 1 };
					}
					else if (num[0] == '3' && len(num) == 1)
					{
						if (ansx.first == -1)
							ansx = { i, 2 };
						else if (ansx.second < 2)
							ansx = { i, 2 };
					}
					else
					{
						if (ansx.first == -1)
							ansx = { i, len(num) + 2 };
						else if (ansx.second < len(num) + 2)
							ansx = { i, len(num) + 2 };
					}
				}
			}

			num.clear();
		}
		else
			num.push_back(s[i]);
	}

	if (ansx.first == -1)
		ansx = { 0, 0 };

	pair <string, char> maxa;
	if (s[ansx.first] == 'A')
		maxa.second = 'T';
	else
		maxa.second = 'A';

	if (ansx.first == 0)
		maxa.first = "0";
	else
	{
		int j = 0;
		string ss;
		while (true)
		{
			string nn;
			while (isdigit(s[j]))
				nn.push_back(s[j]), j++;
			if (j == ansx.first)
				break;
			j++;
			reverse(all(nn));
			if (len(nn) == 0)
				ss = sm(ss, "1");
			else
				ss = sm(ss, nn);
		}

		int k = ansx.first - 1, r = 0;
		while (k >= 0 && isdigit(s[k]))
			num.push_back(s[k]), k--;
		reverse(all(num));

		string g;
		int d = 0;
		for (int i = 0; i < len(num); i++)
		{
			g.push_back((num[i] - '0' + d * 10) / 2 + '0');
			d = (num[i] + d * 10) % 2;
		}
		reverse(all(g));
		if (num[0] == '1')
		{
			if (num[1] == '0')
				maxa.first = sm(ss, g);
			else
			{
				string buf;
				for (int i = 1; i < len(num); i++)
					buf.push_back('0');
				buf.push_back('1');
				maxa.first = sm(ss, buf);
			}
		}
		else
			maxa.first = sm(ss, g);

		reverse(all(maxa.first));
		string qw;
		int ll = 0;
		while (maxa.first[ll] == '0')
			ll++;
		maxa.first = maxa.first.substr(ll, len(maxa.first));
	}

	cout << 2 << ' ' << mina << nl << 1 << ' ' << maxa.first << ' ' << maxa.second << nl;

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}