//#pragma comment(linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")
#ifdef _MSC_VER
	#define _CRT_SECURE_NO_WARNINGS
	#include <__msvc_all_public_headers.hpp>	
	#include <Windows.h>
#else
	#define _MSC_VER 2000
	#include <bits/stdc++.h>
	#pragma GCC optimize("Ofast")
	#pragma GCC optimize("fast-math")
	#pragma GCC optimize ("unroll-loops")
	#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#endif

#define nl					"\n"
#define int					long long
#define uint				unsigned int
#define double				long double
#define len(Q)				(int)Q.size()
#define all(Q)				Q.begin(), Q.end()

using namespace std;

template <typename T> ostream &operator <<(ostream &out, vector <T> &a)
{
	for (auto &p : a)
		out << p << " ";
	return out;
}
template <typename T> istream &operator >>(istream &inp, vector <T> &a)
{
	for (auto &p : a)
		inp >> p;
	return inp;
}

int n, m, c;

vector <vector <int>> a;

void check()
{
	bool isok = true;
	for (int i1 = 0; i1 < n; i1++)
	{
		for (int j1 = 0; j1 < m; j1++)
		{
			for (int i2 = i1 + 1; i2 < n; i2++)
			{
				for (int j2 = j1 + 1; j2 < m; j2++)
				{
					if (a[i1][j1] == a[i2][j1] && a[i2][j1] == a[i1][j2] && a[i1][j2] == a[i2][j2])
					{
						isok = false;
						return;
					}
				}
			}
		}
	}

	if (isok)
	{
		for (auto &p : a)
		{
			for (auto &q : p)
				cout << q << ' ';
			cout << nl;
		}

		exit(0);
	}
}

void rec(int i, int j)
{
	for (int itt = 1; itt <= c; itt++)
	{
		a[i][j] = itt;
		if (j == m - 1)
		{
			if (i == n - 1)
				check();
			else
				rec(i + 1, 0);
		}
		else
			rec(i, j + 1);
	}
}


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	srand((signed)time(NULL));

	cin >> n >> m >> c;
	a.resize(n, vector <int>(m));

	rec(0, 0);

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}