#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <string>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 100;

char nt(char a, char b) {
	vector<char> nw = { 'A', 'G', 'C', 'T' };
	for (auto cur : nw) {
		if (cur != a && cur != b) return cur;
	}
}

ll pw(ll a) {
	ll cnt = 0;
	if (a > 1) cnt++;
	while (a > 0) {
		a /= 10;
		cnt++;
	}


	return cnt;
}

int main() {
	fastInp;

	string s;

	cin >> s;
	vector<pair<ll, char>> vec;
	string s2 = s;
	while (!s.empty()) {
		string num;
		ll n = 0;
		char ch = s.back();
		s.pop_back();
		while (s.size() > 0 && '0' <= s.back() && s.back() <= '9') {
			num.push_back(s.back());
			s.pop_back();
		}

		for (int i = num.size() - 1; i >= 0; i--) {
			n *= 10;
			n += num[i] - '0';
		}

		if (n == 0) n = 1;
		vec.push_back({ n, ch });
	}

	tuple<ll, ll, ll, char> mx = { 0, 0, 0, 0 }, mn = { INF, INF, INF, 0 };
	ll pr = 0;
	char prv = '0';
	ll n = vec.size();
	reverse(vec.begin(), vec.end());
	s = s2;

	for (int i = 0; i < vec.size(); i++) {
		// mx----

		mx = max(mx, { s.size() + 1, 1, pr, nt(vec[i].second, prv) });

		if (vec[i].first >= 2) {
			for (int j = 0; j <= vec[i].first; j++) {
				ll k = pw(vec[i].first - j) + pw(j) - pw(vec[i].first);
				mx = max(mx, { s.size() + 1 + k, 1, pr + j, nt(vec[i].second, vec[i].second) });
			}
		}

		// mn----

		mn = min(mn, { s.size() - pw(vec[i].first) + pw(vec[i].first - 1), 2, pr + 1, 0 });
		if (vec[i].first == 1) {
			if (i > 0 && i < n - 1) {
				if (vec[i - 1].second == vec[i + 1].second) {
					mn = min(mn, { s.size() - 1 - pw(vec[i - 1].first) - pw(vec[i + 1].first) + pw(vec[i - 1].first + vec[i + 1].first), 2, pr + 1, 0 });
				}
			}
		}
		pr += vec[i].first;
		prv = vec[i].second;
	}

	cout << get<1>(mn) << " " << get<2>(mn) << "\n";
	cout << get<1>(mx) << " " << get<2>(mx) << " " << get<3>(mx);

	return 0;
}