#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 1e5 + 100;
ll n;

map<ll, vector<pair<ll, ll>>> ins;
map<ll, ll> outt;
ll gt[SZ];

void check(ll d) {
	set<ll> st;
	for (auto cur : ins) {
		//if (cur.first > d) return;

		ll lft = d - cur.first;
		if (cur.second.size() > outt[lft]) {
			if (cur.second.size() - outt[lft] >= 2) return;

			st.insert(cur.first);
		}

		if (st.size() >= 2) return;
	}

	ll str = 0;
	if (st.size() > 0) str = (*st.begin());

	vector<ll> ans;
	
	ans.push_back(ins[str].back().second);
	ins[str].pop_back();

	while (ans.size() != n) {
		ll lft = d - gt[ans.back()];

		if (ins[lft].size() == 0) {
			cout << "No";
			exit(0);
		}
		ll v = ins[lft].back().second;
		ans.push_back(v);
		ins[lft].pop_back();
	}
	
	cout << "Yes\n";
	for (auto cur : ans) cout << cur + 1 << " ";

	exit(0);
}

int main() {
	fastInp;
	
	cin >> n;

	set<ll> st;
	for (int i = 0; i < n; i++) {
		ll m, s;
		cin >> m >> s;
		vector<ll> ps(m);
		for (auto &cur : ps) cin >> cur;

		for (int i = 0; i < ps.size() - 1; i++) {
			st.insert(ps[i + 1] - ps[i]);
		}
		ins[ps[0]].push_back({ s - ps.back(), i });
		outt[s - ps.back()]++;
		gt[i] = s - ps.back();
	}

	if (st.size() > 1) {
		cout << "No";
		return 0;
	}

	if (st.size() == 1) {
		check(*(st.begin()));
	}
	else {
		for (int i = 0; i < 110; i++) {
			check(i);
		}
	}

	cout << "No";

	return 0;
}


/*
3
1 7
3
1 8
6
2 8
1 6
*/