#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 1e5 + 100;
ll n;

map<ll, vector<pair<ll, ll>>> ins, ins2, ins3;
map<ll, vector<ll>> bad, good;
map<ll, ll> outt, outt2, cnt;
vector<pair<ll, ll>> vec;
ll gt[SZ];

void check(ll d) {
	ins = ins2;
	outt = outt2;
	set<ll> st;


	for (auto cur : ins) {
		//if (cur.first > d) return;

		ll lft = d - cur.first;
		if (cur.second.size() > outt[lft]) {
			if (cur.second.size() - outt[lft] >= 2) return;

			st.insert(cur.first);
		}

		if (st.size() >= 2) return;
	}

	ll str = (*ins.begin()).first;
	if (st.size() > 0) str = (*st.begin());

	vector<ll> ans;
	ins = ins2;
	for (auto &t : ins) {
		int j = -1;
		for (int j = 0; j < t.second.size(); j++) {
			ll lft = d - t.second[j].first;
			if (cnt[lft] < outt[t.second[j].first]) break;
		}

		
		if (j != -1) {
			pair<ll, ll> nd = t.second[j];
			t.second.erase(t.second.begin() + j);

			t.second.insert(t.second.begin(), nd);
		}


	}

	if (d == 5) {
		cout << "";
	}
	ins3 = ins;
	for (int i = 0; i < ins2[str].size(); i++) {
		ans.clear();
		ins = ins3;
		ans.push_back(ins[str][i].second);
		ins[str].erase(ins[str].begin() + i);
	
		while (ans.size() != n) {
			ll lft = d - gt[ans.back()];

			if (ins[lft].size() == 0) {
				return;
			}

			ll v = ins[lft].back().second;
			ans.push_back(v);
			ins[lft].pop_back();
		}

		cout << "Yes\n";
		for (auto cur : ans) cout << cur + 1 << " ";

		exit(0);
	}
}

void check3(ll d) {
	bad.clear();
	good.clear();
	vector<ll> to(n, -1), par(n, -1);
	for (int i = 0; i < n; i++) {
		if (vec[i].first + vec[i].second == d) {
			ll lft = d - vec[i].second;
			bad[vec[i].first].push_back(i);
		}
		else {
			ll lft = d - vec[i].second;
			good[vec[i].first].push_back(i);
		}
	}

	for (int i = 0; i < n; i++) {
		ll lft = d - vec[i].second;
		for (int j = bad[lft].size() - 1; j >= 0; j--) {
			ll ind = bad[lft][j];
			if (ind != i) {
				bad[lft].erase(bad[lft].begin() + j);
				to[i] = ind;
				par[ind] = i;
				break;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		ll lft = d - vec[i].second;
		if (to[i] != -1) continue;
		if (good[lft].size() == 0) continue;
		ll v = good[lft].back();
		good[lft].pop_back();
		to[i] = v;
		par[v] = i;
	}

	ll cnt = 0, st = 0;

	for (int i = 0; i < n; i++) {
		if (to[i] == -1) {
			cnt++;
		}
		if (par[i] == -1) st = i;
	}

	if (cnt >= 2) {
		return;
	}
	
	vector<ll> ans;
	ll v = st;
	ans.push_back(v);
	cout << "Yes\n";
	while (to[v] != -1) {
		v = to[v];
		ans.push_back(v);
	}

	for (auto c : ans) cout << c + 1 << " ";
	exit(0);
}

map<ll, vector<ll>> nd;

void check2(ll d) {
	ins = ins2;
	outt = outt2;
	set<ll> st;

	if (d == 5) {
		cout << "";
	}
	vector<ll> to(n), order;
	for (auto cur : ins) {
		order.clear();
		//if (cur.first > d) return;
		ll cntBad = 0;
		for (auto c : cur.second) {
			to[c.second] = -1;
			if (vec[c.second].first + vec[c.second].second == d) cntBad++;
		}

		if (cntBad == cur.second.size()) return;
		ll lft = d - cur.first;
		for (auto c : nd[lft]) {
			order.push_back(c);
		}

		
		if (cur.second.size() > outt[lft]) {
			if (cur.second.size() - outt[lft] >= 2) return;

			st.insert(cur.first);
		}

		if (st.size() >= 2) return;

		if (order.size() > 1) rotate(order.begin(), order.begin() + 1, order.end());
		for (int i = 0; i < min(order.size(), cur.second.size()); i++) {
			to[cur.second[i].second] = order[i];
		}
		
	}

	ll str = (*ins.begin()).first;
	if (st.size() > 0) str = (*st.begin());

	vector<ll> ans;

	ans.push_back(ins[str].back().second);
	ins[str].pop_back();

	while (ans.size() != n) {
		ll lft = d - gt[ans.back()];

		if (to[ans.back()] == -1) {
			return;
		}
		ll v = to[ans.back()];
		ans.push_back(v);
	}

	cout << "Yes\n";
	for (auto cur : ans) cout << cur + 1 << " ";

	exit(0);
}

set<ll> st;

void brute() {
	vector<ll> perm;
	for (int i = 0; i < n; i++) perm.push_back(i);

	do {
		bool f = 1;
		ll pr = -1;
		for (int i = 0; i < perm.size() - 1; i++) {
			ll v = perm[i], u = perm[i + 1];
			if (pr == -1 || vec[v].second + vec[u].first == pr) {
				pr = vec[v].second + vec[u].first;
				
			}
			else {
				f = 0;
			}
		}

		if (st.size() == 1 && pr != -1 && pr != (*st.begin())) f = 0;
		if (f) {
			cout << "Yes\n";
			for (auto c : perm) cout << c + 1 << " ";

			exit(0);
		}
	} while (next_permutation(perm.begin(), perm.end()));

	cout << "No";
	exit(0);
}

int main() {
	fastInp;
	
	cin >> n;

	for (int i = 0; i < n; i++) {
		ll m, s;
		cin >> m >> s;
		vector<ll> ps(m);
		for (auto &cur : ps) cin >> cur;

		for (int i = 0; i < ps.size() - 1; i++) {
			st.insert(ps[i + 1] - ps[i]);
		}
		ins[ps[0]].push_back({ s - ps.back(), i });
		outt[s - ps.back()]++;
		gt[i] = s - ps.back();
		cnt[ps[0]]++;
		nd[s - ps.back()].push_back(i);

		vec.push_back({ ps[0], s - ps.back() });
	}

	ins2 = ins;
	outt2 = outt;
	if (st.size() > 1) {
		cout << "No";
		return 0;
	}

	if (n <= 8) {
		brute();
	}
	if (st.size() == 1) {
		check3(*(st.begin()));
	}
	else {
		for (int i = 0; i < 110; i++) {
			check3(i);
		}
	}

	cout << "No";

	return 0;
}


/*
3
1 7
3
1 8
6
2 8
1 6

4
1 5
0
1 0
0
1 3
3
1 0
0

4
1 5
2
1 3
2
1 5
4
1 6
4
*/