#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 2e5 + 100, MOD = 1e9 + 7;

ll zer, one, gib;
ll fact[SZ];

int main() {
	fastInp;
	
	
	string a, b, c;
	cin >> a >> b >> c;

	fact[0] = 1;
	for (int i = 1; i < SZ; i++) fact[i] = (fact[i - 1] * i) % MOD;

	for (int i = 0; i < a.size(); i++) {
		ll sm = (a[i] + b[i] - '0' - '0');
		if (sm % 10 != c[i] - '0') {
			if ((sm + 1) % 10 == c[i] - '0') {
				one++;
				gib += (sm + 1) / 10;
			}
			else {
				cout << "0";
				return 0;
			}
		}
		else {
			gib += sm / 10;
			zer++;
		}
	}

	if (gib != one) {
		cout << "0";
		return 0;
	}

	cout << (fact[zer] * fact[gib]) % MOD;

	return 0;
}