#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 2e5 + 100, MOD = 1e9 + 7;

ll type[5];
ll fact[SZ];

ll bpow(ll a, ll p) {
	if (p == 0) return 1ll;
	if (p % 2) return (bpow(a, p - 1) * a) % MOD;
	ll b = bpow(a, p / 2);
	return (b * b) % MOD;
}

ll cn(ll n, ll k) {
	if (k >= n) return 1;
	return fact[n] * bpow((fact[n - k] * fact[k]) % MOD, MOD - 2);
}
int main() {
	fastInp;

	string a, b, c;
	cin >> a >> b >> c;

	fact[0] = 1;
	for (int i = 1; i < SZ; i++) fact[i] = (fact[i - 1] * i) % MOD;

	ll bad = 0;
	for (int i = 0; i < a.size(); i++) {
		ll sm = (a[i] + b[i] - '0' - '0');
		ll fl = 0;
		if (a[i] == '0' || b[i] == '0' || c[i] == '0') fl = 1;
		if (sm % 10 != c[i] - '0') {
			if ((sm + 1) % 10 == c[i] - '0') {
				if ((sm + 1) / 10) {
					type[2]++;
				}
				else {
					type[3]++;
					bad += fl;
				}
			}
			else {
				cout << "0";
				return 0;
			}
		}
		else {
			if (sm / 10) {
				type[1]++;
			}
			else {
				type[0]++;
				bad += fl;
			}
		}
	}


	if (type[1] == 0 && type[2] != 0) {
		cout << "0";
		return 0;
	}

	if (type[1] != type[3]) {
		cout << "0";
		return 0;
	}
	ll goodBlocks = type[1] + type[0];
	ll k = (fact[goodBlocks] * fact[type[3]]) % MOD;
	if (type[2] != 0) return 1;
	ll boxes = type[1], balls = type[2];
	ll withzs = ((k * cn(boxes + balls - 1, balls)) % MOD * fact[balls]) % MOD;
	cout << withzs;

	return 0;
}

/*
197
126
313
*/