#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <ctime>
#include <map>
#include <random>
#include <iomanip>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <bitset>
#include <deque>
#include <utility>
#include <fstream>

using namespace std;

const int MAX_MEM = 2e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new( size_t n ) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos <= MAX_MEM);
    return (void *)res;
}
inline void operator delete ( void * ) { }


#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")


#define int long long

const int INF = 1e18;

int32_t main()
{
    int t; cin >> t;
    for (int q = 0; q < t; q++)
    {
        int n, m; cin >> n >> m;
        int cor_row = -1, dif_row = INF;
        int l = 0, r = n + 1;
        while (l + 1 < r)
        {
            int md = (l + r) / 2;
            int all_sum = (n * m) * (n * m + 1) / 2;
            int sum_bm = (md * m) * (md * m + 1) / 2;
            if (all_sum - 2 * sum_bm >= 0)
                l = md;
            else
                r = md;
        }
        cor_row = l;

        l = 0, r = m + 1;
        while (l + 1 < r)
        {
            int md = (l + r) / 2;
            int all_sum = (n * m) * (n * m + 1) / 2;
            int a1 = (1 + ((n - 1) * m + 1)) * n / 2;
            int abm = a1 + (md - 1) * n;
            int sum_bm = (a1 + abm) * md / 2;
            if (all_sum - 2 * sum_bm >= 0)
                l = md;
            else
                r = md;
        }
        int cor_col = l;

        int ans_r = 1, dif_r = INF, ans_c = 1, dif_c = INF;
        for (int j = min(cor_row + 1, n); j <= min(cor_row + 2, n); j++)
        {
            int all_sum = (n * m) * (n * m + 1) / 2;
            int sum_bm = ((j - 1) * m) * ((j - 1) * m + 1) / 2;
            if (abs(all_sum - 2 * sum_bm) < dif_r)
            {
                ans_r = j;
                dif_r = abs(all_sum - 2 * sum_bm);
            }
        }
        for (int j = min(cor_col + 1, m); j <= min(cor_col + 2, m); j++)
        {
            int all_sum = (n * m) * (n * m + 1) / 2;
            int a1 = (1 + ((n - 1) * m + 1)) * n / 2;
            int abm = a1 + ((j - 1) - 1) * n;
            int sum_bm = (a1 + abm) * (j - 1) / 2;
            if (abs(all_sum - 2 * sum_bm) < dif_c)
            {
                ans_c = j;
                dif_c = abs(all_sum - 2 * sum_bm);
            }
        }

        if (dif_r < dif_c)
            cout << "H " << ans_r << endl;
        else
            cout << "V " << ans_c << endl;
    }
    return 0;
}
