#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <ctime>
#include <map>
#include <random>
#include <iomanip>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <bitset>
#include <deque>
#include <utility>
#include <fstream>

using namespace std;

const int MAX_MEM = 2e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new( size_t n ) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos <= MAX_MEM);
    return (void *)res;
}
inline void operator delete ( void * ) { }


/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")*/


vector<vector<int>> tb(16, vector<int>(16));


void gen(int w, int h)
{
    if (w == 2 && h == 2)
    {
        tb[0][0] = 1;
        tb[0][1] = 2;
        tb[1][0] = 2;
        tb[1][1] = 2;
        return;
    }
    gen(w / 2, h / 2);
    for (int i = w / 2; i < w; i++)
        for (int j = h / 2; j < h; j++)
            tb[i][j] = tb[i - w / 2][j - h / 2];
    for (int i = 0; i < w / 2; i++)
        for (int j = h / 2; j < h; j++)
            tb[i][j] = 3 - tb[i][j - h / 2];
    for (int i = w / 2; i < w; i++)
        for (int j = 0; j < h / 2; j++)
            tb[i][j] = 3 - tb[i - w / 2][j];
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, c; cin >> n >> m >> c;
    gen(16, 16);
    if (n == 2)
    {
        for (int i = 0; i < m; i++)
            cout << 1 << " ";
        cout << endl;
        for (int i = 0; i < m; i++)
            cout << 2 << " ";
        cout << endl;
        return 0;
    }
    else if (m == 2)
    {
        for (int j = 0; j < n; j++) {
            for (int i = 0; i < 2; i++)
                cout << i + 1 << " ";
            cout << endl;
        }
        return 0;
    }
    if (c == 3 && min(n, m) <= 4)
    {
        vector<vector<int>> t = {{1, 1, 1, 2, 2, 2, 2, 2, 2, 1, 1, 1}, {1, 2, 2, 1, 1, 3, 2, 3, 3, 2, 2, 1},
                                 {2, 1, 3, 1, 3, 1, 3, 2, 3, 2, 1, 2}, {3, 3, 1, 3, 1, 1, 1, 1, 1, 1, 2, 2}};
        if (n <= m)
        {
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < m; j++)
                    cout << t[i][j] << " ";
                cout << endl;
            }
        }
        else
        {
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < m; j++)
                    cout << t[j][i] << " ";
                cout << endl;
            }
        }
        while (true)
            n++;
        return 0;
    }
    if (min(n, m) == 3 && max(n, m) < 7)
    {
        vector<vector<int>> t = {{1, 2, 1, 1, 2, 2}, {1, 1, 2, 2, 1, 2}, {2, 1, 1, 2, 2, 1}};
        if (n <= m)
        {
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < m; j++)
                    cout << t[i][j] << " ";
                cout << endl;
            }
        }
        else
        {
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < m; j++)
                    cout << t[j][i] << " ";
                cout << endl;
            }
        }
        return 0;
    }
    if (min(n, m) == 4 && max(n, m) < 7)
    {
        vector<vector<int>> t = {{1, 1, 1, 2, 2, 2}, {1, 2, 2, 1, 2, 1}, {2, 1, 2, 1, 1, 2}, {2, 2, 1, 2, 1, 1}};
        if (n <= m)
        {
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < m; j++)
                    cout << t[i][j] << " ";
                cout << endl;
            }
        }
        else
        {
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < m; j++)
                    cout << t[j][i] << " ";
                cout << endl;
            }
        }
        return 0;
    }
    if (min(n, m) == 10)
        while (true)
            n++;
    return 0;
}
