#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <chrono>
#include <functional>
#include <iomanip>
#include <istream>
#include <ostream>
#include <limits>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& x, const T2& y) {if (y < x) {x = y; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& x, const T2& y) {if (x < y) {x = y; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const pair<T, T>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> istream& operator>> (istream& in, vector<T>& a) {
	for (auto& k : a) {
		in >> k;
	}
	return in;
}

template<typename T> istream& operator>> (istream& in, pair<T, T>& a) {
	in >> a.first >> a.second;
	return in;
}

#define int long long 
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define ld long double
#define pii pair<int, int>

// #pragma GCC optimize("Ofast,unroll-loops,fast-math")
// #pragma GCC target("avx2")

#define time ((ld)clock() / (ld)CLOCKS_PER_SEC)

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else
	#define dbg(x)
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int k, a, x, b, y;
	cin >> k >> a >> x >> b >> y;
	int ans = 0;
	chkmax(ans, max(0ll, k - a) * x + max(0ll, k - a - b) * y);
	chkmax(ans, max(0ll, k - b) * y + max(0ll, k - a - b) * x);
	cout << ans << "\n";
}	
/*

*/