#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <chrono>
#include <functional>
#include <iomanip>
#include <istream>
#include <ostream>
#include <limits>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& x, const T2& y) {if (y < x) {x = y; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& x, const T2& y) {if (x < y) {x = y; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const pair<T, T>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> istream& operator>> (istream& in, vector<T>& a) {
	for (auto& k : a) {
		in >> k;
	}
	return in;
}

template<typename T> istream& operator>> (istream& in, pair<T, T>& a) {
	in >> a.first >> a.second;
	return in;
}

#define int long long 
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define ld long double
#define pii pair<int, int>

// #pragma GCC optimize("Ofast,unroll-loops,fast-math")
// #pragma GCC target("avx2")

#define time ((ld)clock() / (ld)CLOCKS_PER_SEC)

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else
	#define dbg(x)
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

int n;
string s;

string unpack(string s) {
	int ind = 0;
	int ssz = s.size();
	string ans;
	while (ind < ssz) {
		int k = 1;
		if (s[ind] >= '0' && s[ind] <= '9') {
			k = s[ind] - '0';
			ind++;
			while (ind < ssz && s[ind] >= '0' && s[ind] <= '9') {
				k = k * 10 + s[ind] - '0';
				ind++;
			}
		}
		for (int i = 0; i < k; i++) {
			ans.pb(s[ind]);
		}
		ind++;
	}
	return ans;
}

string pack(string s) {
	int ind = 0;
	int ssz = s.size();
	string ans;
	while (ind < ssz) {
		int cnt = 1;
		ind++;
		while (ind < ssz && s[ind] == s[ind - 1]) {
			cnt++;
			ind++;
		}
		if (cnt > 1) {
			ans += to_string(cnt);
		}
		ans.pb(s[ind - 1]);
	}
	return ans;
}

const vector<char> alp = {'A', 'C', 'G', 'T'}; 

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> s;
	string ans1 = s + s;
	string ans2;
	s = unpack(s);
	n = s.size();
	string opans1 = "";
	string opans2 = "";
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++) {
			string s1 = s.substr(0, i) + alp[j] + s.substr(i, n - i);
			s1 = pack(s1);
			if (s1.size() < ans1.size()) {
				ans1 = s1;
				opans1 = "1 ";
				opans1 += to_string(i);
				opans1.pb(' ');
				opans1.pb(alp[j]);
			}
			if (s1.size() > ans2.size()) {
				ans2 = s1;
				opans2 = "1 ";
				opans2 += to_string(i);
				opans2.pb(' ');
				opans2.pb(alp[j]);
			}
		} 
	}
	for (int i = 0; i < n; i++) {
		string s1 = s.substr(0, max(0ll, i)) + s.substr(i + 1, n - i - 1);
		s1 = pack(s1);
		if (s1.size() < ans1.size()) {
			ans1 = s1;
			opans1 = "2 ";
			opans1 += to_string(i + 1);
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++) {
			if (alp[j] != s[i]) {
				string s1 = s.substr(0, max(0ll, i)) + alp[j] + s.substr(i + 1, n - i - 1);
				s1 = pack(s1);
				if (s1.size() < ans1.size()) {
					ans1 = s1;
					opans1 = "3 ";
					opans1 += to_string(i + 1) + " " + alp[j];
				}
				if (s1.size() > ans2.size()) {
					ans2 = s1;
					opans2 = "3 ";
					opans2 += to_string(i + 1) + " " + alp[j];
				}
			}
		}
	}
	// cout << opans1 << "\n" << opans2 << "\n";
	// dbg(ans1);
	// dbg(ans2);
	cout << ans1.size() << " " << ans2.size() << "\n";
	// cout << opans1 << "\n" << opans2 << "\n";
}	
/*
5AC5A2C
*/