#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <chrono>
#include <functional>
#include <iomanip>
#include <istream>
#include <ostream>
#include <limits>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& x, const T2& y) {if (y < x) {x = y; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& x, const T2& y) {if (x < y) {x = y; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const pair<T, T>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> istream& operator>> (istream& in, vector<T>& a) {
	for (auto& k : a) {
		in >> k;
	}
	return in;
}

template<typename T> istream& operator>> (istream& in, pair<T, T>& a) {
	in >> a.first >> a.second;
	return in;
}

// #define int long long 
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define ld long double
#define pii pair<int, int>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx2")

#define time ((ld)clock() / (ld)CLOCKS_PER_SEC)

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	// const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else
	#define dbg(x)
	// const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

const ld PI = 4.0 * atan(1);

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

const int N = 10;

int n, m, c;

int a[N][N];

int used[N][N];
int sz = 0;
vector<pii> order;

void f(int ind) {
	if (ind == sz) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << a[i][j] << " ";
			}
			cout << "\n";
		}
		exit(0);
	}
	auto[x, y] = order[ind];
	if (x >= n || y >= m) {
		f(ind + 1);
		return;
	}
	for (int val = 1; val <= c; val++) {
		a[x][y] = val;
		bool ok = 1;
		for (int x1 = 0; x1 < x; x1++) {
			for (int y1 = 0; y1 < y; y1++) {
				if (a[x1][y1] == a[x][y] && a[x1][y] == a[x][y] && a[x][y1] == a[x][y]) {
					ok = 0;
					break;
				}
			}
			if (!ok) break;
		}
		if (!ok) continue;
		// dbg(ok);
		// for (int i = 0; i < n; i++) {
		// 	for (int j = 0; j < m; j++) {
		// 		cout << a[i][j] << " ";
		// 	}
		// 	cout << "\n";
		// }
		f(ind + 1);
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> c;
	for (int i = 0; i < 10; i++) {
		for (int j = 0; j < i; j++) {
			if (!used[i][j]) {
				sz++;
				order.pb({i, j});
				used[i][j] = 1;
			}
			// if (!used[j][i]) {
			// 	sz++;
			// 	order.pb({j, i});
			// 	used[j][i] = 1;
			// }
		}
		for (int j = 0; j < i; j++) {
			if (!used[j][i]) {
				sz++;
				order.pb({j, i});
				used[j][i] = 1;
			}
		}
		if (!used[i][i]) {
			sz++;
			order.pb({i, i});
			used[i][i] = 1;
		}
	}
	f(0);
}	
/*

*/