#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <chrono>
#include <functional>
#include <iomanip>
#include <istream>
#include <ostream>
#include <limits>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& x, const T2& y) {if (y < x) {x = y; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& x, const T2& y) {if (x < y) {x = y; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const pair<T, T>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> istream& operator>> (istream& in, vector<T>& a) {
	for (auto& k : a) {
		in >> k;
	}
	return in;
}

template<typename T> istream& operator>> (istream& in, pair<T, T>& a) {
	in >> a.first >> a.second;
	return in;
}

#define int long long 
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define ld long double
#define pii pair<int, int>

// #pragma GCC optimize("Ofast,unroll-loops,fast-math")
// #pragma GCC target("avx2")

#define time ((ld)clock() / (ld)CLOCKS_PER_SEC)

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else
	#define dbg(x)
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

const ld PI = 4.0 * atan(1);

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

#ifdef LOCAL 
	const int N = 1e3 + 10;
#else 
	const int N = 2e5 + 10;
#endif

const int mod = 1e9 + 7;

int n;
string a, b, c;

int f[N], rf[N];
int cnt[2][2], goodcnt[2][2];

int powmod(int a, int p) {
	if (p == 0) return 1;
	if (p == 1) return a;
	if (p & 1) return a * powmod(a, p - 1) % mod;
	int k = powmod(a, p / 2);
	return k * k % mod;
}

int rev(int x) {
	return powmod(x, mod - 2);
}

int C(int n, int k) {
	if (k > n || k < 0) return 0;
	int ans = f[n];
	ans = ans * rf[k] % mod;
	ans = ans * rf[n - k] % mod;
	return ans;
}

void mul(int& a, int b) {
	a = a * b % mod;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	f[0] = 1;
	for (int i = 1; i < N; i++) {
		f[i] = f[i - 1] * i % mod;
	}
	rf[N - 1] = rev(f[N - 1]);
	for (int i = N - 1; i > 0; i--) {
		rf[i - 1] = rf[i] * i % mod;
	}
	cin >> a >> b >> c;
	n = a.size();
	for (int i = 0; i < n; i++) {
		int d1 = a[i] - '0', d2 = b[i] - '0', d3 = c[i] - '0';
		int res = d1 + d2;
		if (d3 != res % 10 && d3 != (res + 1) % 10) {
			cout << "0\n";
			return 0;
		}
		int t1, t2;
		if (d3 == res % 10) {
			t1 = 0;
		} else {
			t1 = 1;
		}
		if (res + t1 < 10) {
			t2 = 0;
		} else {
			t2 = 1;
		}
		cnt[t1][t2]++;
		if (d1 && d2 && d3) {
			goodcnt[t1][t2]++;
		}
	}
	if (cnt[0][1] != cnt[1][0] || (cnt[0][1] == 0 && cnt[1][1] > 0)) {
		cout << "0\n";
		return 0;
	}
	// for (int i = 0; i < 2; i++) {
	// 	for (int j = 0; j < 2; j++) {
	// 		cout << cnt[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }
	int ans = 0, add;
	// 00 -> 00
	if (cnt[0][0] > 0 && cnt[0][0]) {
		add = f[cnt[0][1]];
		mul(add, f[cnt[1][0]]);
		mul(add, f[cnt[0][0] - 1]);
		mul(add, f[cnt[1][1]]);
		// dbg(add);
		if (cnt[0][1] && cnt[1][1]) mul(add, C(cnt[0][1] - 1 + cnt[1][1], cnt[1][1]));
		// dbg(add);
		if (cnt[1][0]) mul(add, C(cnt[1][0] + cnt[0][0] - 2, cnt[0][0] - 2));
		// dbg(add);
		mul(add, C(goodcnt[0][0], 2));
		// dbg(add);
		ans += add;
		if (ans >= mod) ans -= mod;
	}
	// dbg(ans);
	// 00 -> 10
	if (cnt[1][0] > 0 && cnt[0][0]) {
		add = f[cnt[0][1]];
		mul(add, f[cnt[1][0] - 1]);
		mul(add, f[cnt[0][0]]);
		mul(add, f[cnt[1][1]]);
		if (cnt[1][1]) mul(add, C(cnt[0][1] - 1 + cnt[1][1], cnt[1][1]));
		if (cnt[0][0] > 1) mul(add, C(cnt[1][0] + cnt[0][0] - 1, cnt[0][0] - 1));
		mul(add, goodcnt[1][0]);
		ans += add;
		if (ans >= mod) ans -= mod;
	}
	// dbg(ans);
	// 01 -> 10
	if (cnt[1][0] > 0) {
		add = f[cnt[0][0]];
		mul(add, f[cnt[0][1]]);
		mul(add, f[cnt[1][0] - 1]);
		mul(add, f[cnt[1][1]]);
		if (cnt[0][0]) mul(add, C(cnt[1][0] - 2 + cnt[0][0], cnt[0][0]));
		if (cnt[1][1]) mul(add, C(cnt[0][1] - 1 + cnt[1][1], cnt[1][1]));
		mul(add, goodcnt[1][0]);
		ans += add;
		if (ans >= mod) ans -= mod;
	}
	// dbg(ans);
	// 01 -> 00
	if (cnt[0][0] > 0) {
		add = f[cnt[0][0] - 1];
		mul(add, f[cnt[0][1]]);
		mul(add, f[cnt[1][0]]);
		mul(add, f[cnt[1][1]]);
		if (cnt[1][0] > 0) mul(add, C(cnt[1][0] - 1 + cnt[0][0] - 1, cnt[0][0] - 1));
		if (cnt[1][1]) mul(add, C(cnt[0][1] - 1 + cnt[1][1], cnt[1][1]));
		mul(add, goodcnt[0][0]);
		ans += add;
		if (ans >= mod) ans -= mod;
	}
	// dbg(ans);
	cout << ans << "\n";
}	
/*
test 567
06
42
48
correct :
1
wrong :
0



123
123
246
-> 6

01
02
03
-> 1

01211
12099
23300
-> 4

121
214
999
-> 0
*/