#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int MAXN = 1e6 + 75;

int used[MAXN];
int used1[MAXN];

vector<vector<int>> g(MAXN);

int in[MAXN];
int out[MAXN];
int ind[MAXN];

vector<int> ans;

int all = 0;

void go(int u)
{
    if (ind[u] < 0)
    {
        return;
    }
    while (ind[u] >= 0)
    {
        int v = g[u][ind[u]--];
        ++all;
        go(v);
    }
    ans.push_back(u);
    return;
}

bool find()
{
    int sum = 0;
    for (int i = 0; i < MAXN; ++i)
    {
        in[i] = 0;
    }
    for (int i = 0; i < MAXN; ++i)
    {
        out[i] = g[i].size();
        sum += out[i];
        for (auto j : g[i])
        {
            ++in[j];
        }
    }
    int u = 0;
    int v = 0;
    int cnt1 = 0;
    int cnt2 = 0;
    int cnt = 0;
    for (int i = 0; i < MAXN; ++i)
    {
        if (out[i] == in[i] + 1)
        {
            u = i;
            ++cnt1;
        }
        if (out[i] == in[i] - 1)
        {
            v = i;
            ++cnt2;
        }
        if (out[i] != in[i])
        {
            ++cnt;
        }
    }
    if (cnt == 2 && cnt1 == 1 && cnt2 == 1)
    {
        g[v].push_back(u);
        cnt = 0;
        ++sum;
    }
    for (int i = 0; i < MAXN; ++i)
    {
        ind[i] = g[i].size() - 1;
    }
    if (cnt != 0)
    {
        return false;
    }
    all = 0;
    go(v);
    if (all != sum)
    {
        return false;
    }
    return true;
}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> len(n);
    vector<pair<int, int>> a(n);
    set<int> r;
    for (int i = 0; i < n; ++i)
    {
        int m;
        cin >> m >> len[i];
        vector<int> cur = {0};
        for (int j = 0; j < m; ++j)
        {
            int x;
            cin >> x;
            cur.push_back(x);
        }
        cur.push_back(len[i]);
        for (int j = 2; j < cur.size() - 1; ++j)
        {
            r.insert(cur[j] - cur[j - 1]);
        }
        a[i] = {cur[1], len[i] - cur[m]};
    }
    if (r.size() > 1)
    {
        cout << "No" << endl;
        return 0;
    }
    int dist = 0;
    if (r.size() == 1)
    {
        dist = (*r.begin());
        for (int i = 0; i < MAXN; ++i)
        {
            g[i] = {};
        }
        set<int> t;
        for (int i = 0; i < n; ++i)
        {
            t.insert(dist - a[i].first);
            t.insert(a[i].second);
        }
        unordered_map<int, int> num;
        map<pair<int, int>, int> was;
        int cnt = 1;
        for (auto el : t)
        {
            num[el] = cnt++;
        }
        for (int i = 0; i < n; ++i)
        {
            g[i].push_back(MAXN - num[a[i].second]);
            g[MAXN - num[dist - a[i].first]].push_back(i);
        }
        if (find())
        {
            cout << "Yes" << endl;
            reverse(ans.begin(), ans.end());
            for (auto el : ans)
            {
                if (el < n)
                {
                    cout << el + 1 << " ";
                }
            }
            cout << endl;
            return 0;
        }
        else
        {
            cout << "No" << endl;
            return 0;
        }
    }
    if (r.size() == 0)
    {
        if (n == 1)
        {
            cout << "Yes" << endl;
            cout << 1 << endl;
            return 0;
        }
        vector<int> xx;
        vector<int> yy;
        for (int i = 0; i < n; ++i)
        {
            xx.push_back(a[i].first);
            yy.push_back(a[i].second);
        }
        sort(xx.begin(), xx.end());
        reverse(xx.begin(), xx.end());
        sort(yy.begin(), yy.end());
        vector<int> dd = {xx[0] + yy[0], xx[1] + yy[0], xx[0] + yy[1], xx[1] + yy[1]};
        for (auto el : dd)
        {
            dist = el;
            for (int i = 0; i < MAXN; ++i)
            {
                g[i] = {};
            }
            set<int> t;
            for (int i = 0; i < n; ++i)
            {
                t.insert(dist - a[i].first);
                t.insert(a[i].second);
            }
            unordered_map<int, int> num;
            map<pair<int, int>, int> was;
            int cnt = 1;
            for (auto el : t)
            {
                num[el] = cnt++;
            }
            for (int i = 0; i < n; ++i)
            {
                g[i].push_back(MAXN - num[a[i].second]);
                g[MAXN - num[dist - a[i].first]].push_back(i);
            }
            if (find())
            {
                cout << "Yes" << endl;
                reverse(ans.begin(), ans.end());
                for (auto el : ans)
                {
                    if (el < n)
                    {
                        cout << el + 1 << " ";
                    }
                }
                cout << endl;
                return 0;
            }
        }
        cout << "No" << endl;
        return 0;
    }
    cout << "No" << endl;
    return 0;
}


