#include <bits/stdc++.h>
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

int start;

int sum(int x) {
    return x * (x + 1) / 2;
}

int my_abs(int a) {
    if (a < 0)
        a *= -1;
    return a;
}

pair <int, int> get_hor(int n, int m) {
    int l = 0, r = n;
    int total = sum(n * m);
    while (r - l > 1) {
        int mid = (r + l) / 2;
        int s1 = sum(mid * m);
        int s2 = total - s1;
        //cout << mid << " " << s1 << " " << s2 << " aa\n";
        if (s1 >= s2)
            r = mid;
        else
            l = mid;
    }
    int s1 = sum(r * m);
    int s2 = total - s1;
    int s3 = sum((r - 1) * m);
    int s4 = total - s3;
    //cout << r << " " << s1 << " " << s2 << " " << s3 << " " << s4 << " aa\n";
    if (my_abs(s3 - s4) <= my_abs(s2 - s1))
        return {r - 1, my_abs(s3 - s4)};
    return {r, my_abs(s1 - s2)};
}

int get_sum_of_verts(int x, int n) {
    return start * x + (x - 1) * x / 2 * n;
}

pair <int, int> get_vert(int n, int m) {
    int l = 0, r = m;
    start = n * (n + 1) / 2 + n * (n - 1) / 2 * m;
    int total = sum(n * m);
    while (r - l > 1) {
        int mid = (r + l) / 2;
        int s1 = get_sum_of_verts(mid, n);
        int s2 = total - s1;
        //cout << mid << " " << s1 << " " << s2 << " aa\n";
        if (s1 >= s2)
            r = mid;
        else
            l = mid;
    }
    int s1 = get_sum_of_verts(r, n);
    int s2 = total - s1;
    int s3 = get_sum_of_verts(r - 1, n);
    int s4 = total - s3;
    if (my_abs(s3 - s4) <= my_abs(s2 - s1))
        return {r - 1, my_abs(s3 - s4)};
    return {r, my_abs(s1 - s2)};
}

void solve() {
    int n, m;
    cin >> n >> m;
    pair <int, int> hor = get_hor(n, m);
    pair <int, int> vert = get_vert(n, m);
    if (vert.second <= hor.second) {
        cout << "V " << vert.first + 1 << "\n";
        return;
    }
    cout << "H " << hor.first + 1 << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
