#include <iostream>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <functional>
#include <bitset>
#include <queue>
#include <deque>
#include <cassert>
#include <chrono>
#include <random>
#include <ctime>
#include <cstdio>
#include <cmath>
#include <stack>
#include <string>
#include <iomanip>
#include <utility>
#include <algorithm>

/*
#pragma GCC optimize("Ofast")
#pragma	GCC optimize("unroll-loops")
#pragma	GCC optimize("O3")
#pragma	GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,mmx,abm,avx,avx2,tune=native")
*/

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

#define int long long
#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define siz(x) (long long)x.size()
#define all(x) x.begin(),x.end()
#define left left1337
#define right right1337
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto&x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)

using namespace std;

template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}
template<typename T>ostream& operator << (ostream &os, const vector<T> &a) {
	fx(x, a)
		os << x << ' ';
	return os;
}

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vch;
typedef vector<vch> vvch;
typedef vector<str> vs;


const int MOD = (int)1e9 + 7; //998244353
const int INF = (int)1e9 + 50;
const ll BIG = (ll)2e18 + 50;
const int MX = (int)2e5 + 50;
const double EPS = 1e-9;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int s[MX];
int a[MX];
int b[MX];
vi in[MX];

void no() {
	cout << "No\n";
	exit(0);
}

void out(const vi & p) {
	cout << "Yes\n";
	fx(x, p)
		cout << x + 1 << ' ';
	cout << '\n';
	exit(0);
}

vi g[MX];
vi gt[MX];
int used[MX];

void check(int v) {
	//cout << "checked" << ' ' << v << '\n';
	used[v] = 1;
	fx(to, g[v]) {
		if (!used[to]) {
			check(to);
		}
	}
	fx(to, gt[v]) {
		if (!used[to]) {
			check(to);
		}
	}
} 

vi eul;

void dfs(int v) {
	//cout << v << ' ';
	while (g[v].size()) {
		int to = g[v].back();
		g[v].ppb;
		dfs(to);
	}
	eul.pb(v);
}

map<pii, vi> kek;


int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vi p(n);
	int must = -1;
	fi(0, n) {
		p[i] = i;
		int m;
		cin >> m >> s[i];
		in[i].resize(m);
		fj(0, m) {
			cin >> in[i][j];
			if (j > 0) {
				int must2 = in[i][j] - in[i][j - 1];
				if (must == -1) must = must2;
				if (must2 != must) {
					no();
				} 
			}
		}
		a[i] = in[i][0];
		b[i] = s[i] - in[i].back();
	}
	if (n == 1) {
		cout << "Yes\n1\n";
		return 0;
	}
	if (must != -1) {
		vi nums(2 * n);
		fi(0, n) {
			nums[2 * i] = a[i];
			nums[2 * i + 1] = must - b[i];
			if (b[i] > must)
				no(); 
		}
		sort(all(nums));
		nums.resize(unique(all(nums)) - nums.begin());
		auto pos = [&](int x) {
			return lb(all(nums), x) - nums.begin();
		};
		int m = nums.size();
		//dbg(nums);
		fi(0, n) {
			int v = pos(a[i]);
			int to = pos(must - b[i]);
			g[v].pb(to);
			gt[to].pb(v);
			//cout << a[i] << ' ' << must - b[i] << '\n';
			kek[{v, to}].pb(i);
		}

		vi odd;
		check(0);
		fi(0, m) {
			if ((g[i].size() + gt[i].size()) % 2)
				odd.pb(i);
			if (!used[i] || odd.size() > 2)
				no();
		}
		int v = (odd.size() ? odd[0] : 0);
		dfs(v);
		//cout << '\n';
		//dbg(eul);
		if (eul.size() != n + 1) {
			eul.clear();
			assert(odd.size() == 2);
			fi(0, m) g[i].clear();
			fi(0, n) g[pos(a[i])].pb(pos(must - b[i]));
			v = odd[1];
			dfs(v);
			//cout << '\n';
			//dbg(eul);
		}
		vi ans;
		reverse(all(eul));
		fi(1, siz(eul)) {
			v = eul[i - 1];
			int to = eul[i];
			//dbg(v);
			//dbg(to);
			//cout << kek[{v, to}] << endl;
			ans.pb(kek[{v, to}].back());
			kek[{v, to}].ppb;
		}
		out(ans);
	} else {
		do {
			bool good = true;
			must = a[p[1]] + b[p[0]];
			for (int i = 2; i < n && good; ++i) {
				int dx = b[p[i - 1]] + a[p[i]];
				good &= (dx == must);
			}
			if (good) out(p);
		} while (next_permutation(all(p)));
	}
	no();
}
