#include <iostream>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <functional>
#include <bitset>
#include <queue>
#include <deque>
#include <cassert>
#include <chrono>
#include <random>
#include <ctime>
#include <cstdio>
#include <cmath>
#include <stack>
#include <string>
#include <iomanip>
#include <utility>
#include <algorithm>


#pragma GCC optimize("Ofast")
#pragma	GCC optimize("unroll-loops")
#pragma	GCC optimize("O3")
#pragma	GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,mmx,abm,avx,avx2,tune=native")


#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define siz(x) (long long)x.size()
#define all(x) x.begin(),x.end()
#define left left1337
#define right right1337
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto&x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)

using namespace std;

template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}
template<typename T>ostream& operator << (ostream &os, const vector<T> &a) {
	fx(x, a)
		os << x << ' ';
	return os;
}

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vch;
typedef vector<vch> vvch;
typedef vector<str> vs;


const int MOD = (int)1e9 + 7; //998244353
const int INF = (int)1e9 + 50;
const ll BIG = (ll)2e18 + 50;
const int MX = (int)2e5 + 50;
const double EPS = 1e-9;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
bool used[4][10][10];
int a[10][10];

void solve2(int n, int m) {
	if (n < m) swap(n, m);
	vi p(m);
	fi(0, m / 2)
		p[i] = 1;
	fi(m / 2, m) 
		p[i] = 2;
	int rest = n / 2;
	fi(0, n) {
		if (rest == 0) {
			fj(0, m / 2) p[j] = 2;
			fj(m / 2, m) p[j] = 1;
		}
		--rest;
		bool done = false;
		while (!done) {
			shuffle(all(p), rng);
			done = true;
			for (int j = 0; j < m && done; ++j) {
				for (int k = j + 1; k < m && done; ++k) {
					if (p[j] == p[k] && used[p[j]][j][k])
						done = false;
				}
			}
		}
		fj(0, m) {
			a[i][j] = p[j];
			fk(j + 1, m) {
				if (p[j] == p[k])
					used[p[j]][j][k] = 1;
			}
		}
	}
}	


void solve3(int n, int m) {
	if (n < m) swap(n, m);
	vi p;
	int c1 = m / 3;
	int c2 = m / 3;
	int c3 = m / 3;
	if (c3 + c2 + c1 != m) ++c3;
	if (c3 + c2 + c1 != m) ++c2;
	vi perm = {1, 2, 3};
	auto make = [&]() {
		p.clear();
		fi(0, c1) p.pb(perm[0]);
		fi(0, c2) p.pb(perm[1]);
		fi(0, c3) p.pb(perm[2]);
		rotate(perm.begin(), perm.begin() + 1, perm.end());
	};
	make();
	int rest = n / 3;
	fi(0, n) {
		if (rest == 0) {
			make();
			rest = n / 3;
		}
		--rest;
		bool done = false;
		while (!done) {
			shuffle(all(p), rng);
			done = true;
			for (int j = 0; j < m && done; ++j) {
				for (int k = j + 1; k < m && done; ++k) {
					if (p[j] == p[k] && used[p[j]][j][k])
						done = false;
				}
			}
		}
		fj(0, m) {
			a[i][j] = p[j];
			fk(j + 1, m) {
				if (p[j] == p[k])
					used[p[j]][j][k] = 1;
			}
		}
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, c;
	cin >> n >> m >> c;
	if (c == 2)
		solve2(n, m);
	else
		solve3(n, m);
	fi(0, n) {
		fj(0, m) {
			cout << (n < m ? a[j][i] : a[i][j]) << ' ';
		}
		cout << '\n';
	}
}
