#include <iostream>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <functional>
#include <bitset>
#include <queue>
#include <deque>
#include <cassert>
#include <chrono>
#include <random>
#include <ctime>
#include <cstdio>
#include <cmath>
#include <stack>
#include <string>
#include <iomanip>
#include <utility>
#include <algorithm>


#pragma GCC optimize("Ofast")
#pragma	GCC optimize("unroll-loops")
#pragma	GCC optimize("O3")
#pragma	GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,mmx,abm,avx,avx2,tune=native")


#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define siz(x) (long long)x.size()
#define all(x) x.begin(),x.end()
#define left left1337
#define right right1337
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto&x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)

using namespace std;

template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}
template<typename T>ostream& operator << (ostream &os, const vector<T> &a) {
	fx(x, a)
		os << x << ' ';
	return os;
}

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<vvvi> vvvvi;
typedef vector<vvvvi> vvvvvi;
typedef vector<char> vch;
typedef vector<vch> vvch;
typedef vector<str> vs;


const int MOD = (int)1e9 + 7; //998244353
const int INF = (int)1e9 + 50;
const ll BIG = (ll)2e18 + 50;
const int MX = (int)2e5 + 50;
const double EPS = 1e-9;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int add(int a, int b) {
	a += b;
	if (a >= MOD) return a - MOD;
	return a;
}

int sub(int a, int b) {
	a -= b;
	if (a < 0) return a + MOD;
	return a;
}

int mult(int a, int b) {
	return 1ll * a * b % MOD;
}

int rc() {
	char x;
	cin >> x;
	return (int)(x - '0');
}

const vi pos = {-1, 0, 9, 10};

int id(int x) {
	if (x == -1) return 0;
	if (x == 0) return 1;
	if (x == 9) return 2;
	return 3; 		
}


vi c(4, 0);
vi unb(4, 0);
bool z[MX];
vvvvvi dp;

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	str s;
	cin >> s;
	int n = s.size();
	//dbg(n);
	vi a(n);
	fi(0, n) {
		a[i] = (int)(s[i] - '0');
		z[i] |= a[i] == 0; 
	}
	fi(0, n) {
		int x = rc();
		z[i] |= x == 0;
		a[i] += x;
	}
	fi(0, n) {
		int x = rc();
		z[i] |= x == 0;
		a[i] -= x;
		if (a[i] != -1 && a[i] != 0 && a[i] != 9 && a[i] != 10) {
			cout << "0\n";
			return 0;
		}
		++c[id(a[i])];
		if (!z[i]) ++unb[id(a[i])];
	}
	dp = vvvvvi(c[0] + 1, vvvvi(c[1] + 1, vvvi(c[2] + 1, vvi(c[3] + 1, vi(2, 0)))));
	dp[0][0][0][0][0] = 1;
	for (int c0 = 0; c0 <= c[0]; ++c0) {
		for (int c1 = 0; c1 <= c[1]; ++c1) {
			for (int c2 = 0; c2 <= c[2]; ++c2) {
				for (int c3 = 0; c3 <= c[3]; ++c3) {
					if (c0) { //-1
						dp[c0][c1][c2][c3][0] = mult(c0, dp[c0 - 1][c1][c2][c3][1]);
					}
					if (c1) { //0
						dp[c0][c1][c2][c3][0] = add(dp[c0][c1][c2][c3][0], mult(c1, dp[c0][c1 - 1][c2][c3][0]));
					}
					if (c2) { //9
						dp[c0][c1][c2][c3][1] = mult(c2, dp[c0][c1][c2 - 1][c3][1]);
					}
					if (c3) { //10
						dp[c0][c1][c2][c3][1] = add(dp[c0][c1][c2][c3][1], mult(c3, dp[c0][c1][c2][c3 - 1][0]));
					}
				}
			}
		}
	}
	int ans = 0;
	
	if (unb[0]) {
		--c[0];
		ans = mult(unb[0], dp[c[0]][c[1]][c[2]][c[3]][1]);
		++c[0];
	} 
	if (unb[1]) {
		--c[1];
		ans = add(ans, mult(unb[1], dp[c[0]][c[1]][c[2]][c[3]][0]));
		++c[1];
	}
	cout << ans << '\n';
}
