#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <stdlib.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2")

using namespace std;

int n, m, c;

void print(vector<vector<int>> &matr) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << matr[i][j] << ' ';
        }
        cout << '\n';
    }
}

void gen(int i, int j, int left, vector<vector<int>> &matr) {
    if (left == 0) {
        print(matr);
        exit(0);
    }
    for (int curr = 1; curr <= c; ++curr) {
        bool ok = true;
        matr[i - 1][j - 1] = curr;
        for (int d1 = 1; i - d1 > 0; ++d1) {
            for (int d2 = 1; j - d2 > 0; ++d2) {
                if (matr[i - 1][j - 1] == matr[i - d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j - d2 - 1] && matr[i - 1][j - 1] == matr[i - d1 - 1][j - d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        int i1 = i;
        int j1 = j + 1;
        if (j1 == m + 1) {
            j1 = 1;
            i1 = i + 1;
        }
        if (ok) {
            gen(i1, j1, left - 1, matr);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> c;
    vector<vector<int>> matr(n, vector<int> (m, 1));
    gen(1, 1, n * m, matr);
}
