#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <stdlib.h>
#include <time.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2")

#define int long long

using namespace std;

/*const int mod = 1e9 + 7;

int bp(int x, int n = mod - 2) {
    if (n == 0) {
        return 1;
    }
    if (n & 1) {
        return (bp(x, n - 1) * x) % mod;
    }
    int y = bp(x, n / 2);
    return (y * y) % mod;
}

int fact[300000];

int C(int n, int k) {
    int ans = fact[n];
    ans *= bp(fact[k]);
    ans %= mod;
    ans *= bp(fact[n - k]);
    ans %= mod;
    return ans;
}

int clever (string s1, string s2, string s3) {
    int n = s1.size();
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s1[i] - '0';
        b[i] = s2[i] - '0';
        c[i] = s3[i] - '0';
    }
    vector<bool> go(n, false);
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] > 9) {
            go[i] = 1;
        } else if (a[i] + b[i] > c[i]) {
            go[i] = 1;
        }
    }
    vector<bool> need(n, false);
    for (int i = 0; i < n; ++i) {
        if ((a[i] + b[i]) % 10 != c[i]) {
            if ((a[i] + b[i] + 1) % 10 != c[i]) {
                cout << 0;
                return 0;
            } else {
                need[i] = 1;
            }
        }
    }
    int can_go = 0, needed = 0;
    for (int i : need) {
        needed += i;
    }
    for (int i : go) {
        can_go += i;
    }
    if (needed != can_go) {
        cout << 0;
        return 0;
    }
    // stupid

    fact[0] = 1;
    for (int i = 1; i < 300000; ++i) {
        fact[i] = fact[i - 1] * i;
        fact[i] %= mod;
    }
    int left = n - 2 * needed;
    int ans = fact[needed];
    vector<vector<int>> dp(needed + 1, vector<int> (left + 1, 0));
    int sum = 0;
    for (int i = 0; i <= left; ++i) {
        dp[0][i] = 1;
    }
    for (int i = 1; i < needed; ++i) {
        for (int j = 0; j <= left; ++j) {
            for (int k = j; k >= 0; --k) {
                dp[i][j] += dp[i - 1][k];
                dp[i][j] %= mod;
            }
        }
    }
    if (needed > 0) {
        for (int i = 0; i <= left; ++i) {
            sum += dp[needed - 1][i];
        }
    } else {
        sum = 1;
    }
    ans *= sum;
    ans %= mod;
    ans *= fact[n - needed * 2];
    ans %= mod;
    cout << ans;
}

int stupid(string s1, string s2, string s3) {
    int n = s1.size();
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s1[i] - '0';
        b[i] = s2[i] - '0';
        c[i] = s3[i] - '0';
    }
    int ans = 0;
    do {
        vector<int> aa, bb, cc;
        for (int i = 0; i < n; ++i) {
            aa.push_back(a[p[i]]);
            bb.push_back(b[p[i]]);
            cc.push_back(c[p[i]]);
        }
        if (aa[0] == 0 || bb[0] == 0 || cc[0] == 0) {
            continue;
        }
        int a, b, c;
        a = b = c = 0;
        for (int i : aa) {
            a *= 10;
            a += i;
        }
        for (int i : bb) {
            b *= 10;
            b += i;
        }
        for (int i : cc) {
            c *= 10;
            c += i;
        }
        if (a + b == c) {
            ++ans;
        }
    } while (next_permutation(p.begin(), p.end()));
    return ans;
}

int stupid1(string s1, string s2, string s3) {
    int n = s1.size();
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s1[i] - '0';
        b[i] = s2[i] - '0';
        c[i] = s3[i] - '0';
    }
    vector<bool> ok(n, false);
    for (int i = 0; i < n; ++i) {
        if (a[i] != 0 && b[i] != 0 && c[i] != 0) {
            ok[i] = 1;
        }
    }
    vector<vector<vector<int>>> dp((1 << n), vector<vector<int>> (2, vector<int> (2, 0)));
    dp[0][0][0] = 1;
    for (int mask = 0; mask < (1 << n); ++mask) {
        for (int cc = 0; cc < 2; ++cc) {
            for (int j = 0; j < 2; ++j) {
                for (int nw = 0; nw < n; ++nw) {
                    if ((mask & (1 << nw)) == 0) {
                        if ((a[nw] + b[nw] + j) % 10 == c[nw]) {
                            dp[mask | (1 << nw)][ok[nw]][(a[nw] + b[nw] + j) / 10] += dp[mask][cc][j];
                            dp[mask | (1 << nw)][ok[nw]][(a[nw] + b[nw] + j) / 10] %= mod;
                        }
                    }
                }
            }
        }
    }
    return dp[(1 << n) - 1][1][0];
}

int32_t main() {
    /*for (int i = 0; i < 100; ++i) {
        int len = rand() % 8 + 1;
        string a, b, c;
        for (int j = 0; j < len; ++j) {
            a += char('1' + rand() % 9);
            b += char('1' + rand() % 9);
            int x = a.back() - '0';
            int y = b.back() - '0';
            if (rand() % 2) {
                if ((x + y + 1) % 10 == 0) {
                    c += '9';
                } else {
                    c += char((x + y + 1) % 10 + '0');
                }
            } else {
                if (x + y == 10) {
                    c += char((x + y + 1) % 10 + '0');
                } else {
                    c += char((x + y) % 10 + '0');
                }
            }
        }
        cout << "====================" << endl;
        cout << a << '\n';
        cout << b << '\n';
        cout << c << '\n';
        cout << stupid(a, b, c) << ' ' << clever(a, b, c) << endl;
        if (stupid(a, b, c) != clever(a, b, c)) {
            return 0;
        }
    }*//*
    string a, b, c;
    cin >> a >> b >> c;
    cout << stupid1(a, b, c);
}*/
int32_t main() {
    srand(time(0));
    int n, m, c;
    n = 10, m = 10, c = 3;
    for (int i = 0; i < 100; ++i) {
        vector<vector<int>> matr(n, vector<int>(m, 1));
        double T = 4000;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                ans += (n - i - 1) * (m - j - 1);
            }
        }
        for (int i = 0; i < 100000; ++i) {
            vector<vector<int>> pr = matr;
            int curr = ans;
            for (int j = 0; j < (int) (T / 10); ++j) {
                int u = rand() % n;
                int v = rand() % m;
                int cv = rand() % c + 1;

                for (int d1 = 1; u - d1 >= 0; ++d1) {
                    for (int d2 = 1; v - d2 >= 0; ++d2) {
                        if (matr[u - d1][v - d2] == matr[u][v] && matr[u - d1][v] == matr[u][v] &&
                            matr[u][v - d2] == matr[u][v]) {
                            --curr;
                        }
                    }
                }
                for (int d1 = -1; u - d1 < n; --d1) {
                    for (int d2 = 1; v - d2 >= 0; ++d2) {
                        if (matr[u - d1][v - d2] == matr[u][v] && matr[u - d1][v] == matr[u][v] &&
                            matr[u][v - d2] == matr[u][v]) {
                            --curr;
                        }
                    }
                }
                for (int d1 = -1; u - d1 < n; --d1) {
                    for (int d2 = -1; v - d2 < m; --d2) {
                        if (matr[u - d1][v - d2] == matr[u][v] && matr[u - d1][v] == matr[u][v] &&
                            matr[u][v - d2] == matr[u][v]) {
                            --curr;
                        }
                    }
                }
                for (int d1 = 1; u - d1 >= 0; ++d1) {
                    for (int d2 = -1; v - d2 < m; --d2) {
                        if (matr[u - d1][v - d2] == matr[u][v] && matr[u - d1][v] == matr[u][v] &&
                            matr[u][v - d2] == matr[u][v]) {
                            --curr;
                        }
                    }
                }
                matr[u][v] = cv;
                for (int d1 = 1; u - d1 >= 0; ++d1) {
                    for (int d2 = 1; v - d2 >= 0; ++d2) {
                        if (matr[u - d1][v - d2] == matr[u][v] && matr[u - d1][v] == matr[u][v] &&
                            matr[u][v - d2] == matr[u][v]) {
                            ++curr;
                        }
                    }
                }
                for (int d1 = -1; u - d1 < n; --d1) {
                    for (int d2 = 1; v - d2 >= 0; ++d2) {
                        if (matr[u - d1][v - d2] == matr[u][v] && matr[u - d1][v] == matr[u][v] &&
                            matr[u][v - d2] == matr[u][v]) {
                            ++curr;
                        }
                    }
                }
                for (int d1 = -1; u - d1 < n; --d1) {
                    for (int d2 = -1; v - d2 < m; --d2) {
                        if (matr[u - d1][v - d2] == matr[u][v] && matr[u - d1][v] == matr[u][v] &&
                            matr[u][v - d2] == matr[u][v]) {
                            ++curr;
                        }
                    }
                }
                for (int d1 = 1; u - d1 >= 0; ++d1) {
                    for (int d2 = -1; v - d2 < m; --d2) {
                        if (matr[u - d1][v - d2] == matr[u][v] && matr[u - d1][v] == matr[u][v] &&
                            matr[u][v - d2] == matr[u][v]) {
                            ++curr;
                        }
                    }
                }
            }
            //cout << ans << endl;
            if (curr >= ans) {
                if (rand() % 4000 > T) {
                    matr = pr;
                } else {
                    ans = curr;
                }
            } else {
                ans = curr;
            }
            if (ans == 0) {
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        cout << matr[i][j] << ' ';
                    }
                    cout << endl;
                }
                return 0;
            }
            T *= 0.9999;
        }
        cout << ans << endl;
    }
}