#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <stdlib.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2")

#define int long long

using namespace std;

const int mod = 1e9 + 7;

int bp(int x, int n = mod - 2) {
    if (n == 0) {
        return 1;
    }
    if (n & 1) {
        return (bp(x, n - 1) * x) % mod;
    }
    int y = bp(x, n / 2);
    return (y * y) % mod;
}

int fact[300000];

int C(int n, int k) {
    int ans = fact[n];
    ans *= bp(fact[k]);
    ans %= mod;
    ans *= bp(fact[n - k]);
    ans %= mod;
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s1[i] - '0';
        b[i] = s2[i] - '0';
        c[i] = s3[i] - '0';
    }
    vector<bool> go(n, false);
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] > 9) {
            go[i] = 1;
        } else if (a[i] + b[i] > c[i]) {
            go[i] = 1;
        }
    }
    vector<bool> need(n, false);
    for (int i = 0; i < n; ++i) {
        if ((a[i] + b[i]) % 10 != c[i]) {
            if ((a[i] + b[i] + 1) % 10 != c[i]) {
                cout << 0;
                return 0;
            } else {
                need[i] = 1;
            }
        }
    }
    int can_go = 0, needed = 0;
    for (int i : need) {
        needed += i;
    }
    for (int i : go) {
        can_go += i;
    }
    if (needed != can_go) {
        cout << 0;
        return 0;
    }
    // stupid
    vector<int> p;
    vector<int> ms;
    for (int i = 0; i < n; ++i) {
        if (need[i]) {
            ms.push_back(i);
        }
        if (go[i]) {
            p.push_back(i);
        }
    }
    int cnt = 0;
    do {
        bool ok = true;
        for (int i = 0; i < needed; ++i) {
            if (p[i] == ms[i]) {
                ok = false;
            }
        }
        cnt += ok;
    } while (next_permutation(p.begin(), p.end()));
    fact[0] = 1;
    for (int i = 1; i < 300000; ++i) {
        fact[i] = fact[i - 1] * i;
        fact[i] %= mod;
    }
    int left = n - 2 * needed;
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        if (go[i] || need[i]) {
            mx += (1 << i);
        }
    }
    int ans = cnt;
    vector<vector<int>> dp(needed + 1, vector<int> (left + 1, 0));
    int sum = 0;
    for (int i = 0; i <= left; ++i) {
        dp[0][i] = 1;
    }
    for (int i = 1; i < needed; ++i) {
        for (int j = 0; j <= left; ++j) {
            for (int k = j; k >= 0; --k) {
                dp[i][j] += dp[i - 1][k];
                dp[i][j] %= mod;
            }
        }
    }
    if (needed > 0) {
        for (int i = 0; i <= left; ++i) {
            sum += dp[needed - 1][i];
        }
    } else {
        sum = 1;
    }
    ans *= sum;
    ans %= mod;
    ans *= fact[needed];
    ans %= mod;
    ans *= fact[n - needed * 2];
    ans %= mod;
    cout << ans;
}