#include <iostream>

#define fi first
#define se second

using namespace std;

typedef __int128 ll;

ll n, m, allsum;
ll zer = 0;

ll hor(ll k) {
  ll cursum = ((k - 1) * m) * ((k - 1) * m + 1) / 2;
  return cursum;
}

ll ver(ll k) {
  ll cursum = n * (k - 1) * k / 2 + (k - 1) * m * (n - 1) * n / 2;
  return cursum;
}

ll myabs(ll x) {
  if (x > zer)
    return x;
  return -x;
}

const ll INF = 1e36;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int t;
  cin >> t;
  while (t--) {
    long long _n, _m;
    cin >> _n >> _m;
    n = _n, m = _m;
    allsum = (n * m) * (n * m + 1) / 2;
    ll L = 1, R = n;
    while (L != R) {
      ll M = (L + R) / 2;
      ll F1 = hor(M);
      ll F2 = allsum - F1;
      if (F1 < F2)
        L = M + 1;
      else
        R = M;
    }
    // a = 'V', b = 'H';
    pair <ll, pair <char, int>> ans = {INF, {'a', 1}};
    for (ll M = max(zer + 1, L - 1); M <= L; M++) {
      ll F1 = hor(M);
      ll F2 = allsum - F1;
      ans = min(ans, {myabs(F1 - F2), {'b', M}});
    }
    L = 1, R = m;
    while (L != R) {
      ll M = (L + R) / 2;
      ll F1 = ver(M);
      ll F2 = allsum - F1;
      if (F1 < F2)
        L = M + 1;
      else
        R = M;
    }
    for (ll M = max(zer + 1, L - 1); M <= L; M++) {
      ll F1 = ver(M);
      ll F2 = allsum - F1;
      ans = min(ans, {myabs(F1 - F2), {'a', M}});
    }
    if (ans.se.fi == 'a')
      cout << "V ";
    else
      cout << "H ";
    cout << ans.se.se << '\n';
  }
  return 0;
}