#include <iostream>
#include <vector>
#include <string>

#define fi first
#define se second

using namespace std;

int len(int x) {
  int cnt = 0;
  while (x) {
    x /= 10;
    cnt++;
  }
  return cnt;
}

int firstdigit(int x) {
  while (x >= 10)
    x /= 10;
  return x;
}

int seconddigit(int x) {
  while (x >= 100)
    x /= 10;
  return x % 10;
}

char neravn(char c) {
  if (c == 'A')
    return 'G';
  return 'A';
}

vector <int> p10 = {1, 10, 100, 1'000, 10'000, 100'000, 1'000'000, 10'000'000, 100'000'000, 1'000'000'000};

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  string s;
  cin >> s;
  int n = (int)s.size();
  vector <pair <int, char>> arr;
  int curval = 0;
  for (int i = 0; i < n; i++) {
    if ('0' <= s[i] && s[i] <= '9') {
      curval = (curval * 10 + (s[i] - '0'));
    } else {
      if (curval == 0) {
        arr.push_back({1, s[i]});
      } else {
        arr.push_back({curval, s[i]});
        curval = 0;
      }
    }
  }
  int curlen = 0;
  for (auto &now : arr)
    curlen += len(now.fi) + (now.fi != 1);
  int m = arr.size();
  pair <int, int> ans = {2e9, 0};
  int prev = 0;
  for (int i = 0; i < m; i++) {
    if (arr[i].fi > 1) {
      int diff = len(arr[i].fi) - len(arr[i].fi - 1) + (arr[i].fi == 2);
      ans = min(ans, {n - diff, prev + 1});
    } else {
      ans = min(ans, {n - 1, prev + 1});
      if (i > 0 && i + 1 < m && arr[i - 1].se == arr[i + 1].se) {
        int diff = len(arr[i - 1].fi) + len(arr[i + 1].fi) + (arr[i - 1].fi != 1) + (arr[i + 1].fi != 1) - len(arr[i - 1].fi + arr[i + 1].fi);
        ans = min(ans, {n - diff, prev + 1});
      }
    }
    prev += arr[i].fi;
  }
  prev = 0;
  cout << 2 << ' ' << ans.se << '\n';
  pair <pair <int, int>, char> an = {{n + 1, 0}, neravn(arr[0].se)};
  for (int i = 0; i < m; i++) {
    if (arr[i].fi <= 2) {
      prev += arr[i].fi;
      continue;
    }
    char toadd = neravn(arr[i].se);
    if (arr[i].fi == 11) {
      an = max(an, {{n + 2, prev + 5}, toadd});
      prev += arr[i].fi;
      continue;
    }
    if (arr[i].fi == 3) {
      an = max(an, {{n + 2, prev + 2}, toadd});
    }
    if (arr[i].fi < 10) {
      an = max(an, {{n + 3, prev + 2}, toadd});
    }
    if (arr[i].fi >= 10) {
      if (firstdigit(arr[i].fi) != 1) {
        an = max(an, {{n + len(arr[i].fi) + 2, prev + p10[len(arr[i].fi) - 1]}, toadd});
      } else {
        if (seconddigit(arr[i].fi) != 0)
          an = max(an, {{n + len(arr[i].fi) + 1, prev + p10[len(arr[i].fi) - 1]}, toadd});
        else
          an = max(an, {{n + len(arr[i].fi), prev + arr[i].fi / 2}, toadd});
      }
    }
    prev += arr[i].fi;
  }
  cout << 1 << ' ' << an.fi.se << ' ' << an.se;
  return 0;
}