#include <iostream>
#include <ctime>
#include <vector>
#include <algorithm>
#include <random>
#include <map>

using namespace std;

int a;
vector <vector <int>> mat(10, vector <int>(10));
int ans[10][10];
vector <pair <int, int>> e;

int n, m, c;
mt19937 gen(time(0));

void solve(int pos) {
  if (pos == e.size()) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++)
        cout << mat[i][j] + 1 << ' ';
      cout << '\n';
    }
    exit(0);
  }
  int x = e[pos].first, y = e[pos].second;
  vector <int> allc;
  for (int i = 0; i < c; i++)
    allc.push_back(i);
  shuffle(allc.begin(), allc.end(), default_random_engine());
  for (int newc : allc) {
    mat[x][y] = newc;
    bool flag = true;
    for (int x1 = 0; x1 < n; x1++)
      for (int y1 = 0; y1 < m; y1++) {
        if (x1 == x || y1 == y)
          continue;
        if (mat[x][y] == mat[x1][y1] && mat[x][y] == mat[x][y1] && mat[x][y] == mat[x1][y]) {
          flag = false;
          break;
        }
      }
    if (!flag)
      continue;
    solve(pos + 1);
  }
  mat[x][y] = -1;
}

int main() {
  cin >> n >> m >> c;
  a = clock();
  mat[0] = {1, 2, 3, 1, 2, 3, 1, 2, 3, 1};
  mat[1] = {2, 1, 1, 3, 1, 2, 3, 3, 3, 1};
  mat[2] = {3, 3, 2, 2, 1, 1, 1, 2, 3, 3};
  mat[3] = {3, 1, 3, 3, 3, 1, 2, 2, 2, 2};
  mat[4] = {2, 3, 1, 2, 3, 3, 1, 3, 1, 2};
  mat[5] = {3, 2, 2, 1, 1, 3, 3, 1, 1, 2};
  mat[6] = {1, 1, 3, 2, 2, 2, 2, 3, 1, 3};
  mat[7] = {1, 2, 1, 2, 3, 1, 3, 1, 2, 3};
  mat[8] = {2, 1, 2, 3, 2, 3, 1, 1, 2, 3};
  if (n <= 9 && c == 3) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++)
        cout << mat[i][j] << ' ';
      cout << endl;
    }
    return 0;
  }
  for (int i = 1; i < n; i++)
    for (int j = 1; j < m; j++)
      e.push_back({i, j});
  for (int j = 0; j < m; j++)
    mat[0][j] = j % c;
  for (int i = 0; i < n; i++)
    mat[i][0] = i % c;
  for (int it = 0; it < 1000000; it++) {
    int tmp1 = gen() % min(50, (int)e.size()), tmp2 = gen() % min(50, (int)e.size());
    swap(e[tmp1], e[tmp2]);
  }
  //shuffle(e.begin(), e.end(), default_random_engine());
  solve(0);
  return 0;
}

/*
1 2 3 1 2 3 1 2 3 1
2 1 1 3 1 2 3 3 3 1
3 3 2 2 1 1 1 2 3 3
3 1 3 3 3 1 2 2 2 2
2 3 1 2 3 3 1 3 1 2
3 2 2 1 1 3 3 1 1 2
1 1 3 2 2 2 2 3 1 3
1 2 1 2 3 1 3 1 2 3
2 1 2 3 2 3 1 1 2 3
                3 3
 */