#include <iostream>
#include <map>
#include <vector>
#include <set>
using namespace std;
int main()
{
	ios_base::sync_with_stdio(false);
	long long n;
	cin >> n;
	vector<long long> s(n);
	vector<long long> m(n);
	vector<vector<long long>> p(n);
	map<long long, set<long long>> st, fi;
	long long allS = 0;
	for (long long i = 0; i < n; i++)
	{
		cin >> m[i] >> s[i];
		p[i].resize(m[i]);
		for (long long j = 0; j < m[i]; j++)
		{
			cin >> p[i][j];
		}
		st[p[i][0]].insert(i);
		fi[s[i] - p[i][p[i].size() - 1]].insert(i);
		if (p[i].size() > 1)
		{
			allS = p[i][1] - p[i][0];
		}
	}
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < p[i].size() - 1; j++)
		{
			if (p[i][j + 1] - p[i][j] != allS)
			{
				cout << "No";
				return 0;
			}
		}
	}
	long long curSt, curFi;
	vector<pair<long long, long long>> ans(n, make_pair(-1, -1));
	set<long long>::iterator a, b;
	for (auto elem : st)
	{
		curSt = elem.first;
		curFi = allS - curSt;
		while (elem.second.size() != 0)
		{
			a = elem.second.begin();
			b = fi[curFi].begin();
			while (a != elem.second.end() && b != fi[curFi].end() && *a == *b && (ans[*b].second == *a || ans[*a].first == *b))
			{
				if (elem.second.size() > 1)
				{
					a++;
				}
				else
				{
					b++;
				}
			}
			if (a == elem.second.end() || b == fi[curFi].end())
			{
				if (b == fi[curFi].end())
				{
					elem.second.erase(a);
				}
				continue;
			}
			ans[*a].second = *b;
			ans[*b].first = *a;
			elem.second.erase(a);
			fi[curFi].erase(b);
		}
	}
	long long curI = -1;
	//long long done = 0;
	for (long long i = 0; i < ans.size(); i++)
	{
		if (ans[i].first == -1)
		{
			curI = i;
		}
	}
	if (curI == -1)
	{
		cout << "No";
		return 0;
	}
	vector<long long> ansSorted;
	while (curI != -1)
	{
		ansSorted.push_back(curI + 1);
		curI = ans[curI].second;
		//done++;
	}
	if (ansSorted.size() != ans.size())
	{
		cout << "No";
		return 0;
	}
	cout << "Yes\n";
	for (long long i = ansSorted.size() - 1; i >= 0; i--)
	{
		cout << ansSorted[i] << " ";
	}
	return 0;
}