#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>


constexpr int MAXN = 1e3 + 5;
struct Data {
	int a, b;
	int num;
};
int n, dlt = -1;
Data input[MAXN];


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;
	for (int i = 0; i < n; i++) {
		int m, s;
		std::cin >> m >> s;
		std::vector<int> vec(m);
		for (int &v : vec) {
			std::cin >> v;
		}
		input[i] = { vec.front(), s - vec.back(), i };
		for (int i = 1; i < m; i++) {
			if (dlt == -1) {
				dlt = vec[i] - vec[i - 1];
			} else if (dlt != (vec[i] - vec[i - 1])) {
				std::cout << "No\n";
				return 0;
			}
		}
	}
	std::sort(input, input + n, [](auto a, auto b) {return a.num < b.num; });
	do {
		int dlt = ::dlt;
		bool may = true;
		for (int i = 1; i < n; i++) {
			if (dlt == -1) {
				dlt = input[i - 1].b + input[i].a;
			} else if (dlt != (input[i - 1].b + input[i].a)) {
				may = false;
				break;
			}
		}
		if (may) {
			std::cout << "Yes\n";
			for (int i = 0; i < n; i++) {
				std::cout << input[i].num + 1 << " \n"[i == (n - 1)];
			}
			return 0;
		}
	} while (std::next_permutation(input, input + n, [](auto a, auto b) {return a.num < b.num; }));

	std::cout << "No\n";

	return 0;
}/*
3
1 7
3
1 8
6
2 8
1 6

 */