#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
using namespace std;
#define int long long
int fact[1000 * 101];
const int mod = 1e9 + 7;

int clever(string aa, string bb, string cc) {
    fact[1] = 1;
    fact[0] = 1;
    for (int i = 2; i <= 1e5; i++) {
        fact[i] = fact[i - 1] * i % mod;
    }
    int have = 0;
    int need = 0;
    int both = 0;
    vector<int> a;
    vector<int> b;
    vector<int> c;
    for (int i = 0; i < aa.size(); i++) {
        a.push_back(aa[i] - '0');
        b.push_back(bb[i] - '0');
        c.push_back(cc[i] - '0');
    }
    for (int i = 0; i < aa.size(); i++) {
        if (a[i] + b[i] == 9 && c[i] == 0) {
            both++;
            continue;
        }
        if (a[i] + b[i] > 9)
        {
            if ((a[i] + b[i]) % 10 == c[i])
            {
                have++;
                continue;
            }
            else if ((a[i] + b[i] + 1) % 10 == c[i])
            {
                both++;
                continue;
            }
            else {
                cout << 0;
                exit(0);
            }
        }
        else {
            if (a[i] + b[i] == c[i]) {

            }
            else if (a[i] + b[i] + 1 == c[i]) {
                need++;
            }
            else {
                cout << 0;
                exit(0);
            }
        }
    }
    if (need == 0 && both != 0) {
        cout << 0;
        exit(0);
    }
    if (need != have) {
        cout << 0;
        exit(0);
    }
    int ans = fact[need];
    int dp[201][201];
    dp[0][0] = 1;
    for (int i = 0; i <= need; i++) {
        dp[0][i] = 1;
    }
    dp[1][1] = 1;
    for (int i = 2; i <= need; i++) {
        dp[1][i] = i;
    }
    for (int i = 2; i <= 200; i++) {
        for (int j = 1; j <= 200; j++) {
            for (int ii = 0; ii <= i; ii++) {
                dp[i][j] += dp[ii][j - 1];
                dp[i][j] %= mod;
            }
        }
    }
    ans *= dp[both][need];
    ans %= mod;
    ans *= fact[both];
    ans %= mod;
    int dp2[201][201];
    for (int i = 0; i <= need; i++) {
        dp2[0][i] = 1;
    }
    int rest = a.size() - both - need - have;
    for (int i = 1; i <= rest; i++) {
        for (int j = 0; j <= 200; j++) {
            for (int k = 0; k <= j; k++) {
                dp2[i][j] += dp2[i - 1][k];
                dp2[i][j] %= mod;
            }
        }
    }
    ans *= fact[rest];
    ans %= mod;
    ans *= fact[need];
    ans %= mod;
    ans *= dp2[rest][need];
    ans %= mod;
    return ans;
}

int stupid(string a, string b, string c) {

    vector<int> pum(a.size());
    iota(pum.begin(), pum.end(), 0);
    int ans = 0;
    do {
        string nowa;
        string nowb;
        string nowc;
        for (int i = 0; i < pum.size(); i++) {
            nowa.push_back(a[pum[i]]);
            nowb.push_back(b[pum[i]]);
            nowc.push_back(c[pum[i]]);
        }
        if (nowa[0] == '0' || nowb[0] == '0' || nowc[0] == '0')
        {
            continue;
        }
        int ai = stoll(nowa);
        int bi = stoll(nowb);
        int ci = stoll(nowc);
        if (ai + bi == ci)
        {
            ans++;
        }
    } while (next_permutation(pum.begin(), pum.end()));
    return ans;
}

signed main() {
    string a, b, c;
    cin >> a >> b >> c;
    cout << clever(a, b, c);
}
