#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
using namespace std;
#define int long long
int fact[100001];
const int mod = 1e9 + 7;

int binup(int x, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int pre = binup(x, p / 2);
        return pre * pre % mod;
    }
    return binup(x, p - 1) * x % mod;
}

int inv(int x) {
    return binup(x, mod - 2);
}

int C(int n, int k) {
    return fact[n] % mod * inv(fact[n - k]) % mod * inv(fact[k]) % mod;
}

int stupid(int a, int b) {
    int dp[751];
    for (int i = 0; i <= 750; i++) {
        dp[i] = 1;
    }
    for (int j = 2; j <= a; j++) {
        int pref = 0;
        for (int i = 0; i <= 750; i++) {
            pref += dp[i];
            pref %= mod;
            dp[i] = pref;
        }
    }
    return dp[b];
}

int clever(int a, int b) {
    int ans = 0;
    for (int i = 0; i <= b; i++) {
        ans += C(a - i + 1, b - i);
    }
    return ans;
}

signed main() {
    fact[1] = 1;
    fact[0] = 1;
    for (int i = 2; i <= 100000; i++) {
        fact[i] = fact[i - 1] * i % mod;
    }
    string aa, bb, cc;
    cin >> aa>> bb >> cc;
    fact[1] = 1;
    fact[0] = 1;
    for (int i = 2; i <= 100000; i++) {
        fact[i] = fact[i - 1] * i % mod;
    }
    int have = 0;
    int need = 0;
    int both = 0;
    int need_zero = 0;
    int rest_zero = 0;
    vector<int> a;
    vector<int> b;
    vector<int> c;
    for (int i = 0; i < aa.size(); i++) {
        a.push_back(aa[i] - '0');
        b.push_back(bb[i] - '0');
        c.push_back(cc[i] - '0');
    }
    for (int i = 0; i < aa.size(); i++) {
        if (a[i] + b[i] == 9 && c[i] == 0) {
            both++;
            continue;
        }
        if (a[i] + b[i] > 9)
        {
            if ((a[i] + b[i]) % 10 == c[i])
            {
                have++;
                continue;
            }
            else if ((a[i] + b[i] + 1) % 10 == c[i])
            {
                both++;
                continue;
            }
            else {
                cout << 0;
                exit(0);
            }
        }
        else {
            if (a[i] + b[i] == c[i]) {
                if (a[i] == 0 || b[i] == 0 || c[i] == 0) {
                    rest_zero++;
                }
            }
            else if (a[i] + b[i] + 1 == c[i]) {
                if (a[i] == 0 || b[i] == 0 || c[i] == 0) {
                    need_zero++;
                }
                need++;
            }
            else {
                cout << 0;
                exit(0);
            }
        }
    }
    if (need == 0 && both != 0) {
        cout << 0;
        exit(0);
    }
    if (need != have) {
        cout << 0;
        exit(0);
    }
    int ans = fact[need];

    ans *= clever(need, both);
    ans %= mod;
    ans *= fact[both];
    ans %= mod;
    int bukkit_cnt = ans;
    int dp2[751];
    for (int i = 0; i <= need; i++) {
        dp2[i] = 1;
    }
    int rest = a.size() - both - need - have;
    int bed = ans * fact[rest] % mod * need_zero % mod * clever(rest + 1, need - 1) % mod * fact[need - 1] % mod + ans * rest_zero % mod * fact[rest - 1] % mod * clever(rest, need) % mod * fact[need] % mod;
    ans *= fact[rest];
    ans %= mod;
    ans *= fact[need];
    ans %= mod;
    ans *= clever(rest + 1, need);
    ans %= mod;
    cout << ((ans - bed) % mod + mod) % mod;
}




