#define __GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second
#define int long long
#define ld long double

mt19937 rnd(time(0));

int get1(int n, int m, int t) {
    int s1 = (t - 1) * t / 2;
    s1 *= n;
    int s2 = n * (n - 1) / 2;
    int l = s1 + s2 * m * (t - 1);

    int r = m * n * (m * n + 1) / 2 - l;
    return abs(r - l);
}

int get2(int n, int m, int t) {
    int l = m * (t - 1) * (m * (t - 1) + 1) / 2;
    int r = m * n * (m * n + 1) / 2 - l;
    return abs(r - l);
}

pair<int, int> f1(int n, int m) {
    int l = 1, r = m;
    pair<int, int> ans = {LLONG_MAX, 0};
    for (int i = l; i <= r; i++) {
        if (get1(n, m, i) < ans.fi) {
            ans = {get1(n, m, i), i};
        }
    }
    return ans;
}

pair<int, int> f2(int n, int m) {
    int l = 1, r = n;
    pair<int, int> ans = {LLONG_MAX, 0};
    for (int i = l; i <= r; i++) {
        if (get2(n, m, i) < ans.fi) {
            ans = {get2(n, m, i), i};
        }
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(3);

    int t;
    cin >> t;
    while (t --> 0) {
        int n, m;
        cin >> n >> m;
        pair<int, int> a1 = f1(n, m);
        pair<int, int> a2 = f2(n, m);
        if (a1.fi <= a2.fi) {
            cout << "V " << a1.se << '\n';
        } else {
            cout << "H " << a2.se << '\n';
        }
    }

    return 0;
}
/*
5
1 3
4 7
1 10
3 3
3 5
*/
