#include <iostream>
#include <vector>

using namespace std;

int n, * m, * s, ** p;

vector<int> order;
vector<int> now;

int get_back_sz(int i)
{
	return s[i] - p[i][m[i] - 1];
}

void check(int dist, int mask)
{
	if (mask == (1 << n) - 1)
	{
		order.clear();
		for (int i = 0; i < now.size(); i++)
		{
			order.push_back(now[i]);
		}
		return;
	}
	for (int i = 0; i < n; i++)
	{
		if ((mask >> i) % 2)
			continue;
		if (now.size() == 0)
		{
			now.push_back(i);
			check(dist, mask | (1 << i));
			now.pop_back();
			continue;
		}
		int d = p[i][0] + get_back_sz(now.back());
		if (dist != -1 && d != dist)
			continue;
		now.push_back(i);
		check(d, mask | (1 << i));
		now.pop_back();
	}
}

int main()
{
	cin >> n;
	m = new int[n];
	s = new int[n];
	p = new int* [n];
	for (int i = 0; i < n; i++)
	{
		cin >> m[i] >> s[i];
		p[i] = new int[m[i]];
		for (int j = 0; j < m[i]; j++)
		{
			cin >> p[i][j];
		}
	}
	int dist = -1;
	for (int i = 0; i < n; i++)
	{
		if (m[i] == 1)
			continue;
		for (int j = 0; j < m[i] - 1; j++)
		{
			int d = p[i][j + 1] - p[i][j];
			if (dist != -1 && d != dist)
			{
				cout << "No" << "\n";
				return 0;
			}
			dist = d;
		}
	}
	check(dist, 0);
	if (order.empty())
	{
		cout << "No" << "\n";
		return 0;
	}
	cout << "Yes" << "\n";
	for (int el : order)
	{
		cout << el + 1 << " ";
	}
	cout << "\n";
}
