#include <iostream>
#include <vector>
#include <random>
#include <ctime>

using namespace std;

int n, m, c;
//bool** good;
int* p;

/*int mpow(int a, int n)
{
	if (n == 0)
		return 1;
	if (n == 1)
		return a;
	int p = mpow(a, n / 2);
	p *= p;
	p *= mpow(a, n % 2);
	return p;
}*/

int cnt[3];

bool is_good(int mask1, int mask2)
{
	for (int i = 0; i < c; i++)
		cnt[i] = 0;
	for (int i = 0; i < n; i++)
	{
		int e1 = mask1 % p[i + 1] / p[i], e2 = mask2 % p[i + 1] / p[i];
		if (e1 == e2)
			cnt[e1]++;
	}
	for (int i = 0; i < c; i++)
	{
		if (cnt[i] > 1)
			return false;
	}
	return true;
}

void build_p()
{
	p = new int[n + 1];
	p[0] = 1;
	for (int i = 1; i <= n; i++)
	{
		p[i] = p[i - 1] * c;
	}
}

vector<int> masks, next_masks;

void build_next_masks()
{
	if (n * m <= 20)
	{
		for (int mask = 0; mask < p[n]; mask++)
		{
			next_masks.push_back(mask);
		}
		return;
	}
	int from = n / 3, to = (n + 2) / 3;
	bool ok;
	for (int mask = 0; mask < p[n]; mask++)
	{
		for (int i = 0; i < c; i++)
			cnt[i] = 0;
		for (int i = 0; i < n; i++)
		{
			int e = mask % p[i + 1] / p[i];
			cnt[e]++;
		}
		ok = true;
		for (int i = 0; i < c; i++)
		{
			if (cnt[i] < from || cnt[i] > to)
				ok = false;
		}
		if (ok)
			next_masks.push_back(mask);
	}
	int sz = next_masks.size();
	for (int i = 0; i < sz; i++)
	{
		int j = rand() % sz;
		swap(next_masks[i], next_masks[j]);
	}
}

void next()
{
	if (masks.size() == m)
		return;
	for (int mask : next_masks)
	{
		vector<int> deleted;
		for (int i = next_masks.size() - 1; i >= 0; i--)
		{
			if (!is_good(next_masks[i], mask))
			{
				deleted.push_back(next_masks[i]);
				next_masks.erase(next_masks.begin() + i);
			}
		}
		masks.push_back(mask);
		next();
		if (masks.size() == m)
			return;
		masks.pop_back();
		for (auto del_mask : deleted)
		{
			next_masks.push_back(del_mask);
		}
	}
	/*bool ok;
	for (int mask = 0; mask < p[n]; mask++)
	{
		ok = true;
		for (int last_mask : masks)
		{
			if (!good[last_mask][mask])
			{
				ok = false;
				break;
			}
		}
		if (!ok)
			continue;
		masks.push_back(mask);
		next();
		if (masks.size() == m)
			return;
		masks.pop_back();
	}*/
}

int main()
{
	srand(time(NULL));
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	cin >> n >> m >> c;
	build_p();
	build_next_masks();
	/*int mx = p[n];
	good = new bool* [mx];
	for (int mask1 = 0; mask1 < mx; mask1++)
	{
		next_masks.push_back(mask1);
		good[mask1] = new bool[mx];
		for (int mask2 = 0; mask2 < mx; mask2++)
		{
			for (int i = 0; i < c; i++)
				cnt[i] = 0;
			for (int i = 0; i < n; i++)
			{
				int e1 = mask1 % p[i + 1] / p[i], e2 = mask2 % p[i + 1] / p[i];
				if (e1 == e2)
					cnt[e1]++;
			}
			good[mask1][mask2] = true;
			for (int i = 0; i < c; i++)
			{
				if (cnt[i] > 1)
					good[mask1][mask2] = false;
			}
		}
	}*/
	next();
	if (masks.size() == 0)
	{
		cout << -1 << "\n";
		return 0;
	}
	int** a = new int* [n];
	for (int i = 0; i < n; i++)
	{
		a[i] = new int[m];
	}
	for (int j = 0; j < m; j++)
	{
		for (int i = 0; i < n; i++)
		{
			a[i][j] = masks[j] % p[i + 1] / p[i] + 1;
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cout << a[i][j] << " ";
		}
		cout << "\n";
	}
}
