#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, m;
int INF = 1e18;

int sm(int fst, int lst, int k){
    return (fst + lst) * k / 2;
}

int geth(int i) {
    int ans1 = (i * m + 1 + n * m) * (n - i) / 2;
    int ans2 = i * (i * m + 1) / 2;
    return abs(ans1 - ans2) * m;
}

int getv(int i){
    int first_line1 = sm(1, i, i);
    int first_line2= sm(i + 1, m, m - i);
    int last_line1 = sm((n - 1) * m + 1, (n - 1) * m + i, i);
    int last_line2 = sm((n - 1) * m + i + 1, n * m, m - i);
    return abs(sm(first_line1, last_line1, n) - sm(first_line2, last_line2, n));
}

struct ans{
    int ans1, i, ind;
    ans(int a, int b, int c){
        ans1 = a;
        i = b;
        ind = c;
    }
    bool operator<(ans t){
        if (ans1 == t.ans1){
            if (ind == t.ind){
                return i < t.i;
            }
            return  ind < t.ind;
        }
        return ans1 < t.ans1;
    }
};

ans max(ans a, ans b){
    if (a < b){
        return a;
    }
    return b;
}

signed main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        ans answ= {INF, 0, 0};
        cin >> n >> m;
        int l = 0, r = n;
        while(l < r - 2){
            int a = (l + l + r) / 3;
            int b = (l + r + r) / 3;
            if (geth(a) < geth(b)){
                r = b;
            }
            else{
                l = a;
            }
        }
        r = l + 1;
        answ = max(ans(geth(l), l, 0), ans(geth(r), r, 0));
        l = 0, r = m;
        while(l < r - 2){
            int a = (l + l + r) / 3;
            int b = (l + r + r) / 3;
            if (getv(a) < getv(b)){
                r = b;
            }
            else{
                l = a;
            }
        }
        r = l + 1;
        //cout << l << " " << getv(l) << endl << r << " " << getv(r) << endl;
        answ = max(ans(getv(l), l, 1), answ);
        answ = max(answ, ans(getv(r), r, 1));
        if (answ.ind == 0){
            cout << "H " << answ.i + 1 << "\n";
        }
        else{
            cout << "V " << answ.i + 1 << "\n";
        }
    }
}
