#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define ll long long
#define ld long double
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

#define prev prev228
#define dist dist228
#define left left228
#define right right228

using namespace std;
mt19937 rnd(time(nullptr));

const ll INF = 1e18 + 10, inf = 1e9 + 10, P = 1e9 + 7, N = 2e5 + 10;
string a, b, c;
int fact[N], n;

string sum(string a, string b) {
    string ans = "";
    int n = a.size(), fl = 0;
    for (int i = n - 1; i > -1; i--) {
        int x = a[i] - '0', y = b[i] - '0';
        x += y;
        if (fl) {
            x++;
            fl = 0;
        }
        if (x >= 10) {
            fl = 1;
            x -= 10;
        }
        ans += "0";
        ans.back() += x;
    }
    reverse(all(ans));
    if (fl) {
        return "";
    }
    return ans;
}

int check(vector<int> id) {
    string a1 = "", b1 = "", c1 = "";
    for (int i = 0; i < n; i++) {
        a1 += "0";
        a1.back() = a[id[i]];
    }
    for (int i = 0; i < n; i++) {
        b1 += "0";
        b1.back() = b[id[i]];
    }
    for (int i = 0; i < n; i++) {
        c1 += "0";
        c1.back() = c[id[i]];
    }
    if (a1[0] == '0' || b1[0] == '0' || c1[0] == '0') {
        return 0;
    }
    string t = sum(a1, b1);
    if (t == c1) {
        return 1;
    }
    return 0;
}

void solve_2() {
    vector<int> id;
    for (int i = 0; i < n; i++) {
        id.push_back(i);
    }
    int ans = 0;
    while (1) {
        ans += check(id);
        ans %= P;
        if (!next_permutation(all(id))) {
            break;
        }
    }
    cout << ans;
}

int get_pow(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 1) {
        return (get_pow(a, b - 1) * a) % P;
    }
    int t = get_pow(a, b / 2);
    return (t * t) % P;
}

int divide(int a, int b) {
    return (a * get_pow(b, P - 2)) % P;
}

int get_c(int n, int k) {
    if (k == 0) {
        return 1;
    }
    if (n < k) {
        return 0;
    }
    return divide(fact[n], (fact[k] * fact[n - k]) % P);
}

void solve() {
    fact[0] = 1;
    for (int i = 1; i < N; i++) {
        fact[i] = fact[i - 1] * i % P;
    }
    cin >> a >> b >> c;
    n = a.size();
    int c011 = 0, c001 = 0, c110 = 0, c100 = 0, c010 = 0, c000 = 0;
    for (int i = 0; i < n; i++) {
        //cout << i << ": ";
        int f1 = 0, f2 = 0, f3 = 0;
        int x = a[i] - '0', y = b[i] - '0', z = c[i] - '0';
        if ((x + y) % 10 == z) {
            f2 = 0;
            if (x + y >= 10) {
                f1 = 1;
            } else {
                f1 = 0;
            }
        } else if ((x + y + 1) % 10 == z) {
            f2 = 1;
            if (x + y + 1 >= 10) {
                f1 = 1;
            } else {
                f1 = 0;
            }
        } else {
            cout << 0;
            return;
        }
        if (x != 0 && y != 0 && z != 0 && f1 == 0) {
            f3 = 1;
        }
        //cout << f1 << ' ' << f2 << ' ' << f3 << "\n";
        if (!f1 && f2 && f3) {
            c011++;
        }
        if (!f1 && !f2 && f3) {
            c001++;
        }
        if (f1 && f2 && !f3) {
            c110++;
        }
        if (f1 && !f2 && !f3) {
            c100++;
        }
        if (!f1 && f2 && !f3) {
            c010++;
        }
        if (!f1 && !f2 && !f3) {
            c000++;
        }
    }
    //cout << c011 << ' ' << c001 << ' ' << c110 << ' ' << c100 << ' ' << c010 << ' ' << c000 << "\n";
    int ans = 1;
    int cnt_b = (c011 + c010);
    if ((c011 + c010) != c100) {
        cout << 0;
        return ;
    }
    int cnt_start = c011 + c001;
    ans = cnt_start * fact[cnt_b + c000 + c001 - 1]; /// кол-во способов расставить все блоки
    ans %= P;
    //cout << ans << "\n";
    ans *= fact[cnt_b]; /// кол-во способов распредилить у блоков начало и конец
    ans %= P;
    //cout << ans << "\n";
    ans *= fact[c110]; /// учесть, что 110 могут распределяться в любом порадке
    ans %= P;
    //cout << ans << "\n";
    if (c110 > 0) {
        int cur = 0;
        for (int k = 0; k < cnt_b; k++) { /// расставить РОВНО k перегородок
            int cur1 = 1;
            cur1 *= get_c(cnt_b, k + 1); /// выбрать нужные перегородки
            cur1 %= P;
            //cur1 *= fact[k + 1]; /// любой порядок перегородок
            //cur1 %= P;
            cur1 *= get_c(c110 - 1, k); /// расставил перегородки
            //cout << "get_c(c110 - 1, k) " << c110 - 1 << ' ' << k << ' ' << get_c(c110 - 1, k) << "\n";
            cur1 %= P;
            cur += cur1;
            cur %= P;
            //cout << "do k " << k << ' ' << cur1 << "\n";
        }
        ans *= cur;
        ans %= P;
    }
    cout << ans << "\n";
    //solve_2();
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
}
/*
123
123
246

01211
12099
23300

1155999
1055000
3200000

*/
