def factorial(n):
    sum = 0
    for i in range(n):
        sum+=i
    return sum


def sumleft(x,y,m):
    return factorial(y)*x*(m-1)+sum(list(range(1, m)))*y


def sumright(x,y,m):
    return factorial(y)*x*(x-m+1)+sum(list(range(m, x+1)))*y


def sumup(x,y,m):
    return sum(list(range(1, x+1)))*(m-1)+factorial(m-1)*x*x

def sumdown(x,y,m):
    return sum(list(range(1,x+1)))*(y-m+1)+(factorial(y)-factorial(m-1))*x*x


def vertbinsearch(x,y):
    l = 1
    r = x+1
    while (r-l)>1:
        m = l+(r-l)//2
        m1 = m+1
        ml = sumleft(x,y,m)
        mr = sumright(x,y,m)
        m1l = sumleft(x,y,m1)
        m1r = sumright(x,y,m1)
        if m1r==m1l:
            return [m1, 0]
        if mr==ml:
            return [m,0]
        if abs(mr-ml)>abs(m1r-m1l):
            if mr>ml:
                l=m
            else:
                r=m
        else:
            if m1r>m1l:
                l=m
            else:
                r=m
    return [r, abs(sumleft(x,y,r)-sumright(x,y,r))]
    
    
def horbinsearch(x,y):
    l = 1
    r = y+1
    while (r-l)>1:
        m = l+(r-l)//2
        m1 = m+1
        ml = sumup(x,y,m)
        mr = sumdown(x,y,m)
        m1l = sumup(x,y,m1)
        m1r = sumdown(x,y,m1)
        if m1r==m1l:
            return [m1, 0]
        if mr==ml:
            return [m,0]
        if abs(mr-ml)>abs(m1r-m1l):
            if mr>ml:
                l=m
            else:
                r=m
        else:
            if m1r>m1l:
                l=m
            else:
                r=m
    return [r, abs(sumup(x,y,r)-sumdown(x,y,r))]
        


def schet(x,y):
    raznvert = vertbinsearch(x,y)
    raznhor = horbinsearch(x,y)
    if raznvert[1]>raznhor[1]:
        print("H", raznhor[0])
    else:
        print("V", raznvert[0])


def main():
    n = int(input())
    for i in range(n):
        y,x = map(int, input().split())
        schet(x,y)
    

if __name__=="__main__":
    main()