#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

int factorial(int n ){
    int sum = 0;
    for (int i = 0;i<n;++i){
        sum+=i;
    }
    return sum;
}

int sumleft(int x, int y, int m){
    return factorial(y)*x*(m-1)+factorial(m)*y;
}

int sumright (int x, int y, int m){
    return factorial(y)*x*(x-m+1)+(factorial(x+1)-factorial(m))*y;
}

int sumup(int x, int y, int m){
    return factorial(x+1)*(m-1)+factorial(m-1)*x*x;
}

int sumdown(int x, int y, int m){
    return factorial(x+1)*(y-m+1)+(factorial(y)-factorial(m-1))*x*x;
}

int* vertbinsearch(int x, int y){
    int l = 1;
    int r = x+1;
    int* out = new int[2];
    while ((r-l)>1){
        int m = l+(r-l)/2;
        int m1 = m+1;
        int ml = sumleft(x,y,m);
        int mr = sumright(x,y,m);
        int m1l = sumleft(x,y,m1);
        int m1r = sumright(x,y,m1);
        if (m1r==m1l){
            out[0] = m1;
            out[1] = 0;
            return out;
        }
        if (mr==ml){
            out[0] = m;
            out[1] = 0;
            return out;
        }
        if (abs(mr-ml)>abs(m1r-m1l)){
            if (mr>ml){
                l=m;
            }
            else{
                r=m;
            }
        }
        else{
            if (m1r>m1l){
                l=m;
            }
            else{
                r=m;
            }
        }
    }
    out[0] = r;
    out[1] = ((sumleft(x,y,r)-sumright(x,y,r))>0?(sumleft(x,y,r)-sumright(x,y,r)):-(sumleft(x,y,r)-sumright(x,y,r)));
    return out;
}

int* horbinsearch(int x, int y){
    int l = 1;
    int r = y+1;
    int* out = new int[2];
    while ((r-l)>1){
        int m = l+(r-l)/2;
        int m1 = m+1;
        int ml = sumup(x,y,m);
        int mr = sumdown(x,y,m);
        int m1l = sumup(x,y,m1);
        int m1r = sumdown(x,y,m1);
        if (m1r==m1l){
            out[0] = m1;
            out[1] = 0;
            return out;
        }
        if (mr==ml){
            out[0] = m;
            out[1] = 0;
            return out;
        }
        if (abs(mr-ml)>abs(m1r-m1l)){
            if (mr>ml){
                l=m;
            }
            else{
                r=m;
            }
        }
        else{
            if (m1r>m1l){
                l=m;
            }
            else{
                r=m;
            }
        }
    }
    out[0] = r;
    out[1] = ((sumup(x,y,r)-sumdown(x,y,r))>0?(sumup(x,y,r)-sumdown(x,y,r)):-(sumup(x,y,r)-sumdown(x,y,r)));
    return out;
}

void schet(int x, int y){
    int* raznvert = vertbinsearch(x,y);
    int* raznhor = horbinsearch(x,y);
    if (raznvert[1]>raznhor[1]){
        cout<<"H "<<raznhor[0];
    }
    else{
        cout<<"V "<<raznvert[0];
    }
}

int main()
{
    int n;
    cin>>n;
    for (int i = 0; i<n; ++i){
        int x,y;
        cin>>y>>x;
        schet(x,y);
    }
}
