#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main()
{
    long long t, n, m;
    cin >> t;
    vector <pair <char, long long> > ans(t);
    for (long long i = 0; i < t; i++){
        cin >> n >> m;
        long long sum = (n * m * (n * m + 1))/2;
        long long min_raz_v = -1;
        long long min_raz_h = -1;
        long long min_row = -1;
        long long min_col = -1;
        //        
        long long l = 2;
        long long r = n;
        long long prev_l = -1;
        long long prev_r = -1;
        //cout << "SUM == " << sum << '\n';
        while (r - l > 0){
            long long m1 = l + (r - l)/3;
            long long m2 = r - (r - l)/3;
            long long sum1 = ((m1 - 1) * m * ((m1 - 1) * m + 1))/2;
            long long sum2 = ((m2 - 1) * m * ((m2 - 1) * m + 1))/2;
            if (abs(sum1 - (sum - sum1)) > abs(sum2 - (sum - sum2))){
                l = m1;
            }
            else{
                r = m2;
            }
            if ((l == prev_l) && (r == prev_r)){
                break;
            }
            prev_l = l;
            prev_r = r;
        }
        //cout << "ROWS" << '\n';
        for (long long i = l; i <= r; i++){
            long long sum1 = ((i - 1) * m * ((i - 1) * m + 1))/2;
            //cout << "row == " << i << " and sum1 == " << sum1 << '\n';
            if (min_raz_h == -1){
                min_raz_h = abs(sum1 - (sum - sum1));
                min_row = i;
            }
            if (abs(sum1 - (sum - sum1)) < min_raz_h){
                min_raz_h = abs(sum1 - (sum - sum1));
                min_row = i;
            }
        }
        //        
        l = 2;
        r = m;
        prev_l = -1;
        prev_r = -1;
        while (r - l > 0){
            long long m1 = l + (r - l)/3;
            long long m2 = r - (r - l)/3;
            long long sum1 = sum - (m * (n * (n + 1))/2) * (m - m1 + 1) + n * ((m - m1) * (m - m1 + 1))/2;
            long long sum2 = sum - (m * (n * (n + 1))/2) * (m - m2 + 1) + n * ((m - m2) * (m - m2 + 1))/2;
            if (abs(sum1 - (sum - sum1)) > abs(sum2 - (sum - sum2))){
                l = m1;
            }
            else{
                r = m2;
            }
            if ((prev_l == l) && (prev_r == r)){
                break;
            }
            prev_l = l;
            prev_r = r;
        }
        //cout << "COLS" << '\n';
        for (long long i = l; i <= r; i++){
            long long sum1 = sum - (m * (n * (n + 1))/2) * (m - i + 1) + n * ((m - i) * (m - i + 1))/2;
            //cout << "col == " << i << " and sum1 == " << sum1 << '\n';
            if (min_raz_v == -1){
                min_raz_v = abs(sum1 - (sum - sum1));
                min_col = i;
            }
            if (abs(sum1 - (sum - sum1)) < min_raz_v){
                min_raz_v = abs(sum1 - (sum - sum1));
                min_col = i;
            }
        }
        if (min_raz_v == -1){
            ans[i] = {'H', min_row};
            continue;
        }
        if (min_raz_h == -1){
            ans[i] = {'V', min_col};
            continue;
        }
        if (min_raz_v <= min_raz_h){
            ans[i] = {'V', min_col};
        }
        else{
            ans[i] = {'H', min_row};
        }
    }
    for (long long i = 0; i < t; i++){
        cout << ans[i].first << ' ' << ans[i].second << '\n';
    }
    return 0;
}
