#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <time.h>
#define all(x) x.begin(), x.end()
#define mp make_pair
#define int ll

typedef long long ll;
typedef long double ld;
using namespace std;
const ll INF = 1e9 + 7, N = 3e5 + 5;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }



ll n, m, k, d = -1, s, t;
vector<bool> used(10);
vector<pair<int, int>> arr;
vector<int> path;

bool check() {

	int dd = d;

	for (int i = 1; i < n; i++) {
		if (dd == -1) {
			dd = arr[path[i]].first + arr[path[i - 1]].second;
		}
		else if (dd != arr[path[i]].first + arr[path[i - 1]].second) {
			return false;
		}
	}

	return true;
}

bool flag = false;

void perm() {
	if (flag || path.size() > n) { return; }
	if (path.size() == n) {
		if (check()) {
			cout << "Yes\n";
			for (int x : path) {
				cout << x + 1 << " ";
				flag = true;
			}
		}
		return;
	}
	else {
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				used[i] = true;
				path.push_back(i);
				perm();
				path.pop_back();
				used[i] = false;
			}
		}
	}
}


signed main()
{
	//srand(time(NULL));
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n;

	s = 2 * n, t = s + 1;
	ll maxlen = 0;
	arr.resize(n);


	for (int i = 0; i < n; i++) {
		ll len;
		cin >> m >> len;
		maxlen = max(len, maxlen);
		vector<int> tmp(m);
		for (int j = 0; j < m; j++) {
			cin >> tmp[j];
			if (j && d != -1 && tmp[j] - tmp[j - 1] != d) {
				cout << "No";
				return 0;
			}
			if (j && d == -1) {
				d = tmp[j] - tmp[j - 1];
			}
		}

		arr[i] = mp(tmp[0], len - tmp.back());
	}


	perm();
	
	if (!flag) {
		cout << "No";
	}

}