#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <time.h>
#define all(x) x.begin(), x.end()
#define mp make_pair
#define int ll

typedef long long ll;
typedef long double ld;
using namespace std;
const ll INF = 1e9 + 7, N = 4e5 + 5;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }


ll n, m, k;
int cnt[2][2], dp[N][2];

vector<int> zero(5);
ll sum = 0;

ll perm(int a, int b, int c, int d, int last) {

	if (a < 0 || b < 0 || c < 0 || d < 0) {
		return 0;
	}
	if (!a && !b && !c && !d && last == 0) {
		return 1;
	}

	ll ans = 0;

	if (!last) {
		if (a + b + c + d == sum) {
			ans += MOD(perm(a - 1, b, c, d, 0) * (a - zero[0]));
			ans += MOD(perm(a, b, c - 1, d, 1) * (c - zero[2]));
		}
		else {
			ans += MOD(perm(a - 1, b, c, d, 0) * a);
			ans += MOD(perm(a, b, c - 1, d, 1) * c);
		}
	}
	else {
		if (a + b + c + d == sum) {
			ans += MOD(perm(a, b - 1, c, d, 0) * (b - zero[1]));
			ans += MOD(perm(a, b, c, d - 1, 1) * (d - zero[3]));
		}
		else {
			ans += MOD(perm(a, b - 1, c, d, 0) * b);
			ans += MOD(perm(a, b, c, d - 1, 1) * d);
		}
	}

	return ans;
}


signed main()
{
	srand(time(nullptr));
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	string aa, bb, cc;
	cin >> aa >> bb >> cc;

	//vector<int> a, b, c;

	for (int i = 0; i < aa.size(); i++) {
		int x, y, z, d;

		//a.push_back(aa[i] - '0');
		//b.push_back(bb[i] - '0');
		//c.push_back(cc[i] - '0');

		x = aa[i] - '0';
		y = bb[i] - '0';
		z = cc[i] - '0';

		int p = -1;

		if (z == (x + y) % 10) {
			p = 0;
		}
		else if (z == (x + y + 1) % 10) {
			p = 1;
		}
		else {
			cout << 0;
			return 0;
		}

		d = (x + y) / 10;

		cnt[d][p]++;
		if (!x || !y || z == 0) {
			zero[d * 2 + p]++;
		}

	}

	int a, b, c, d;

	a = cnt[0][0];
	b = cnt[0][1];
	c = cnt[1][0];
	d = cnt[1][1];

	sum = a + b + c + d;

	cout << perm(a, b, c, d, 0);

}