#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")

using namespace std;

#define x first
#define y second
#define forn(i, n) for (int (i) = 0; (i) < (n); i++)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define firn(i, n) for (int (i) = 1; (i) < (n); i++)
typedef long long ll;
typedef long double ld;

const int inf = 1e9, mod = 1000'000'007;
const ll llinf = 1e18;
const char el = '\n';

mt19937 rnd(time(nullptr));

const int N = 300'001;
vector<int> g[N];
int cnt, st;
vector<int> find_euler_path() {
    vector<int> ans;
    vector<int> r(cnt);
    vector<int> stack;
    stack.push_back(st);
    while(!stack.empty()) {
        int v = stack.back();
        if (r[v] == (int)g[v].size()) {
            stack.pop_back();
            ans.push_back(v);
        } else {
            stack.push_back(g[v][r[v]++]);
        }
    }
    reverse(all(ans));
    return ans;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    bool ok = false;
    int dist = -1;
    int n;
    cin >> n;
    vector<int> l(n), r(n);
    forn(i, n) {
        int m, s;
        cin >> m >> s;
        vector<int> a(m);
        forn(j, m) cin >> a[j];
        if (m == 1) {
            l[i] = a[0];
            r[i] = s - a[0];
        } else {
            ok = true;
            if (dist != -1 && dist != a[1] - a[0]) return cout << "No" << el, 0;
            dist = a[1] - a[0];
            firn(j, a.size())
                if (dist != a[j] - a[j - 1]) return cout << "No" << el, 0;
            l[i] = a[0];
            r[i] = s - a.back();
        }
    }
    if (ok) {
        map<int, vector<int>> L, R;
        vector<int> t;
        forn(i, n) {
//            if (l[i] > dist || r[i] > dist) return cout << "No" << el, 0;
            t.push_back(l[i]);
            t.push_back(dist - r[i]);
            L[l[i]].push_back(i);
            R[r[i]].push_back(i);
        }
        sort(all(t));
        t.resize(distance(t.begin(), unique(all(t))));
        int ll = 0, rr = 0;
        st = cnt = n;
        for (auto w : t) {
            int a = (int)L[w].size(), b = (int)R[dist - w].size();
            if (abs(a - b) > 1) return cout << "No" << el, 0;
            if (a > b) ll++, st = cnt;
            else if (b > a) rr++;
            for (auto i : R[dist - w]) g[i].push_back(cnt);
            for (auto i : L[w]) g[cnt].push_back(i);
            cnt++;
        }
        if (ll > 1 || rr > 1) return cout << "No" << el, 0;
        auto ans = find_euler_path();
        vector<int> out;
        for (auto i : ans)
            if (i < n) out.push_back(i);
        if ((int)out.size() < n) return cout << "No" << el, 0;
        cout << "Yes" << el;
        forn(j, out.size())
            cout << out[j] + 1 << ' ';
        cout << el;
    }
    return 0;
}
