/*
 * 0000000  K   K
 * 0     0  K  K
 * 0     0  KKK
 * 0     0  K  K
 * 0000000  K   K
 */

#include <iostream>
#include <vector>
#include <cmath>
#include <string.h>

using namespace std;

void solve(int n, int m)
{
    int ans = n*m*(n*m + 1)/2, ansidx;
    char ansch;
    int l = 0;
    int r = m;
    while (r - l > 2)
    {
        int mid1 = l + (r - l)/3, mid2 = l + max((r - l)/3*2, (int)1);
        long long ans1 = abs(n*m*(n*m + 1)/2 - n*mid1*(1 + mid1 + n*m - m));
        long long ans2 = abs(n*m*(n*m + 1)/2 - n*mid2*(1 + mid2 + n*m - m));
        if (ans1 > ans2)
            l = mid1 + 1;
        if (ans1 < ans2)
            r = mid2 - 1;
    }
    long long ans11 = abs(n*m*(n*m + 1)/2 - n*l*(1 + l + n*m - m));
    long long ans22 = abs(n*m*(n*m + 1)/2 - n*r*(1 + r + n*m - m));
    long long ans33 = abs(n*m*(n*m + 1)/2 - n*(l + 1)*(1 + l + 1 + n*m - m));
    if (ans11 < ans)
    {
        ans = ans11;
        ansch = 'V';
        ansidx = l;
    }
    if (ans33 < ans)
    {
        ans = ans33;
        ansch = 'V';
        ansidx = l + 1;
    }
    if (ans22 < ans)
    {
        ans = ans22;
        ansch = 'V';
        ansidx = r;
    }
    l = 0;
    r = n;
    while (r - l > 2)
    {
        //cout << l << ' ' << r << endl;
        int mid1 = l + (r - l)/3, mid2 = l + max((r - l)/3*2, (int)1);
        long long ans1 = abs(n*m*(n*m + 1)/2 - (mid1 * m)*(mid1*m + 1));
        long long ans2 = abs(n*m*(n*m + 1)/2 - (mid2 * m)*(mid2*m + 1));
        if (ans1 > ans2)
            l = mid1 + 1;
        if (ans1 < ans2)
            r = mid2 - 1;
    }
    ans11 = abs(n*m*(n*m + 1)/2 - (l * m)*(l*m + 1));
    ans22 = abs(n*m*(n*m + 1)/2 - (r * m)*(r*m + 1));
    ans33 = abs(n*m*(n*m + 1)/2 - (l + 1 * m)*((l + 1)*m + 1));
    if (ans11 < ans)
    {
        ans = ans11;
        ansidx = l;
        ansch = 'H';
    }
    if (ans33 < ans)
    {
        ans = ans11;
        ansidx = l + 1;
        ansch = 'H';
    }
    if (ans22 < ans)
    {
        ans = ans22;
        ansidx = r;
        ansch = 'H';
    }
    cout << ansch << ' ' << ansidx + 1 << '\n';
}


signed main()
{

    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
    {
        int n, m;
        cin >> n >> m;
        solve(n, m);
    }
}
// 5AC5A2C