/*
 * 0000000  K   K
 * 0     0  K  K
 * 0     0  KKK
 * 0     0  K  K
 * 0000000  K   K
 */

#include <iostream>
#include <vector>
#include <cmath>
#include <string.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;
int F[200001];
int _F[200001];

int binpow(int x, int p)
{
    if (!p)
        return 1;
    int tmp = binpow(x, p/2);
    if (p % 2)
        return ((tmp * tmp) % MOD)*x % MOD;
    else
        return (tmp * tmp) % MOD;
}

void fill()
{
    F[0] = 1;
    for (int i = 1; i < 200001; ++i)
    {
        F[i] = F[i - 1] * i % MOD;
    }
    for (int i = 0; i < 200001; ++i)
    {
        _F[i] =binpow(F[i], MOD - 2);
    }
}

int C(int n, int k)
{
    return (((F[n] * _F[k]) % MOD) * _F[n - k]) % MOD;
}


int main1()
{
    fill();
    string a, b, c;
    int cnt00, cnt01, cnt10, cnt11;
    cin >> a >> b >> c;
    for (int i = 0; i < a.size(); ++i)
    {
        if ((a[i] - '0' + b[i] - '0') % 10 == (c[i] - '0') % 10)
        {
            if ((a[i] - '0' + b[i] - '0') == (c[i] - '0'))
                ++cnt00;
            else
                ++cnt01;
        }
        else if ((a[i] - '0' + b[i] - '0' + 1) % 10 == (c[i] - '0') % 10)
        {
            if ((a[i] - '0' + b[i] - '0' + 1) == c[i] - '0')
                ++cnt10;
            else
                ++cnt11;
        }
        else
        {
            cout << 0 << endl;
            return 0;
        }
    }
    if (cnt01 != cnt10)
    {
        cout << 0 << endl;
        return 0;
    }
    if (cnt01 + cnt10 % 2)
    {
        cout << 0 << endl;
        return 0;
    }
    cout << (((((C(cnt00 + cnt01, cnt01) * C(cnt11 + cnt01, cnt01)) % MOD) * F[cnt11] % MOD) * F[cnt00] % MOD) * F[cnt01] % MOD) * F[cnt00] % MOD;
}


signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    //cout << dredisolve(22970);
    main1();
}
// 5AC5A2C