#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

ll plusik(char a, char b) {
	return a - '0' + b - '0';
}

ll ctoi(char c) {
	return c - '0';
}

const ll mod = 1e9 + 7;

ll fact(ll a, ll b = 1) {
	ll ans = 1;
	while (a >= b) {
		ans *= a;
		ans %= mod;
		a--;
	}
	return ans;
}

ll power(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n % 2 == 0) {
		ll tmp = power(a, n / 2);
		return tmp * tmp % mod;
	}
	return power(a, n - 1) * a % mod;
}

ll main1(string a, string b, string c) {
	ll cnt0 = 0, need_plus = 0, pluscnt = 0, plus_and_need = 0, not0notplus = 0;
	ll n = a.size();
	for (ll i = 0; i < n; ++i) {
		if (ctoi(c[i]) != (plusik(a[i], b[i]) % 10) && ctoi(c[i]) != (plusik(a[i], b[i]) + 1) % 10) {
			return 0;
		}
		if (a[i] == '0' || b[i] == '0' || c[i] == '0')
			cnt0++;
		if (ctoi(c[i]) == (plusik(a[i], b[i]) + 1) % 10 && plusik(a[i], b[i]) >= 9)
			plus_and_need++;
		else if (ctoi(c[i]) == (plusik(a[i], b[i]) + 1) % 10) {
			need_plus++;
			if (!(a[i] == '0' || b[i] == '0' || c[i] == '0'))
				not0notplus++;
		}
		else if (plusik(a[i], b[i]) > 9)
			pluscnt++;
		else if (!(a[i] == '0' || b[i] == '0' || c[i] == '0'))
			not0notplus++;
	}
	if (plus_and_need > 0 && (need_plus == 0 || pluscnt == 0)) {
		return 0;
	}
	if (pluscnt != need_plus) {
		return 0;
	}
	ll ans = not0notplus % mod;
	ans *= fact(n - pluscnt - plus_and_need - 1);
	ans %= mod;
	ans *= power(need_plus, plus_and_need);
	ans %= mod;
	ans *= fact(plus_and_need);
	ans %= mod;
	ans *= fact(pluscnt);
	ans %= mod;
	return ans;
}

ll main2(string a1, string  b1, string c1) {
	vector<pair<char, int>> a, b, c;
	for (int i = 0; i < a1.size(); ++i) {
		a.push_back({ i, a1[i] });
	}
	for (int i = 0; i < a1.size(); ++i) {
		b.push_back({ i, b1[i] });
	}
	for (int i = 0; i < a1.size(); ++i) {
		c.push_back({ i, c1[i] });
	}
	ll ans = 0;
	do {
		a1 = b1 = c1 = "";
		for (auto i : a)
			a1 += i.second;
		for (auto i : b)
			b1 += i.second;
		for (auto i : c)
			c1 += i.second;
		if (stoi(a1) + stoi(b1) == stoi(c1) && a1[0] != '0' && b1[0] != '0' && c1[0] != '0')
			ans++;
		next_permutation(b.begin(), b.end());
		next_permutation(c.begin(), c.end());
	} while (next_permutation(a.begin(), a.end()));
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	string a, b, c;
	cin >> a >> b >> c;
	cout << main1(a, b, c);
	return 0;
}
