#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <utility>
#include <algorithm>
#define int long long
#define pb push_back
#define eb emplace_back
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pass (void)0
using namespace std;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using vb = vector<bool>;


constexpr int N{100000};
int s[N];
int l[N], r[N];


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    int d = -1;

    for (int i = 0; i < n; i++)
    {
        int m;
        cin >> m >> s[i];

        vi p(m);
        for (int j = 0; j < m; j++)
            cin >> p[j];

        if (m >= 2)
        {
            if (d == -1)
                d = p[1] - p[0];
            for (int j = 0; j < m-1; j++)
                if (p[j+1] - p[j] != d)
                {
                    cout << "No";
                    return 0;
                }
        }

        /*if (d != -1 && (p[0] > d || p[m-1] < s[i]-d))
        {
            cout << "No";
            return 0;
        }*/

        l[i] = p[0], r[i] = s[i] - p[m-1];
    }

    if (n == 1)
    {
        cout << "Yes\n1";
        return 0;
    }

    vi p(n);
    for (int i = 0; i < n; i++)
        p[i] = i;

    bool ok = false;

    while (true)
    {
        int cd = d;
        if (d == -1)
            cd = r[p[0]] + l[p[1]];

        ok = true;
        for (int i = 0; i < n-1 && ok; i++)
            ok = ok && (r[p[i]] + l[p[i+1]] == cd);

        if (ok)
            break;

        if (!next_permutation(all(p)))
            break;
    }

    if (ok)
    {
        cout << "Yes\n";
        for (int i = 0; i < n; i++)
            cout << p[i]+1 << ' ';
    }
    else
        cout << "No\n";

    return 0;
}
/*
3
1 7 3
1 8 6
2 8 1 6

1
1 7 5

1
3 10 2 5 9

3
1 5 3
1 3 3
1 6 3

4
1 5 0
1 0 0
1 3 3
1 0 0
*/
