#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pb push_back
#define eb emplace_back
#define int long long
using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using pii = pair<int, int>;


inline void digs(int n, vi &a)
{
    a.clear();
    while (n)
    {
        a.pb(n % 10);
        n /= 10;
    }
    reverse(all(a));
}


inline int binpow(int x, int n)
{
    int res = 1;
    while (n)
    {
        if (n & 1)
            res *= x;
        x *= x;
        n >>= 1;
    }
    return res;
}


inline void solve1(int n)
{
    vi dg;
    digs(n, dg);

    int d0 = dg[0];
    int k = dg.size();

    bool ok = true;
    for (int i = 1; i < k && ok; i++)
    {
        if (dg[i] < d0)
            break;
        if (dg[i] > d0)
            ok = false;
    }

    int fd = d0;
    if (!ok)
        fd++;

    for (int i = 0; i < k; i++)
        cout << fd;
}


inline void solve2(int n)
{
    vi dg;
    digs(n, dg);

    int d0 = dg[0];
    int k = dg.size();

    int fp = 0;
    while (fp+1 < k && dg[fp+1] == d0)
        fp++;

    if (fp >= k-1)
    {
        cout << n;
        return;
    }

    int d1 = dg[fp+1];
    bool fls = d1 < d0;

    int lp = k - fp - 2;
    int num = n % (binpow(10, lp));

    int v0 = 0;
    for (int i = 0; i < lp; i++)
    {
        v0 *= 10;
        v0 += d0;
    }

    int v1 = 0;
    for (int i = 0; i < lp; i++)
    {
        v1 *= 10;
        v1 += d1;
    }

    if (fls)
    {
        for (int i = 0; i <= fp; i++)
            cout << d0;

        if (fp == 0)
        {
            if (v1 >= num)
            {
                cout << d1;
                cout << v1;
            }
            else if (v0 >= num)
            {
                cout << d1;
                cout << v0;
            }
            else
            {
                if (d1+1 == d0)
                {
                    cout << d0;
                    cout << "0";
                    for (int i = 0; i < lp-1; i++)
                        cout << d0;
                }
                else
                {
                    cout << d1+1;
                    for (int i = 0; i < lp; i++)
                        cout << min(d0, d1+1);
                }
            }
        }
        else
        {
            if (v0 >= num)
            {
                cout << d1;
                cout << v0;
            }
            else
            {
                if (d1+1 == d0)
                {
                    cout << d0;
                    cout << "0";
                    for (int i = 0; i < lp-1; i++)
                        cout << d0;
                }
                else
                {
                    cout << d1+1;
                    for (int i = 0; i < lp; i++)
                        cout << d0;
                }
            }
        }
    }
    else
    {
        if (fp == 0)
        {
            for (int i = 0; i <= fp; i++)
                cout << d0;

            if (v0 >= num)
            {
                cout << d1;
                cout << v0;
            }
            else if (v1 >= num)
            {
                cout << d1;
                cout << v1;
            }
            else
            {
                cout << d1+1;
                cout << v0;
            }
        }
        else
        {
            if (v0 >= num)
            {
                for (int i = 0; i <= fp; i++)
                    cout << d0;
                cout << d1;
                cout << v0;
            }
            else if (d1 < 9)
            {
                for (int i = 0; i <= fp; i++)
                    cout << d0;
                cout << d1+1;
                cout << v0;
            }
            else
            {
                for (int i = 0; i < fp; i++)
                    cout << d0;
                cout << d0+1;
                for (int i = 0; i < lp+1; i++)
                    cout << d0;
            }
        }
    }

}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    if (k == 0)
        solve1(n);
    else
        solve2(n);

    return 0;
}



