#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pb push_back
#define eb emplace_back
#define int long long
using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using pii = pair<int, int>;


inline void digs(int n, vi &a)
{
    a.clear();
    while (n)
    {
        a.pb(n % 10);
        n /= 10;
    }
    reverse(all(a));
}


inline int binpow(int x, int n)
{
    int res = 1;
    while (n)
    {
        if (n & 1)
            res *= x;
        x *= x;
        n >>= 1;
    }
    return res;
}


inline void solve1(int n)
{
    vi dg;
    digs(n, dg);

    int d0 = dg[0];
    int k = dg.size();

    bool ok = true;
    for (int i = 1; i < k && ok; i++)
    {
        if (dg[i] < d0)
            break;
        if (dg[i] > d0)
            ok = false;
    }

    int fd = d0;
    if (!ok)
        fd++;

    for (int i = 0; i < k; i++)
        cout << fd;
}

inline int solve2(int n)
{
    int m = n;
    while (true)
    {
        vi a;
        digs(m, a);

        vi cnt(10, 0);
        for (int x : a)
            cnt[x]++;

        int c1 = 0, c2 = 0;
        for (int i = 0; i < 10; i++)
        {
            if (cnt[i] == 1)
                c1++;
            if (cnt[i] >= 1)
                c2++;
        }

        bool ok = true;
        if (c2 > 2)
            ok = false;
        if (c2 == 2 && c1 == 0)
            ok = false;

        if (ok)
            break;
        m++;
    }

    return m;
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    if (k == 0)
        solve1(n);
    else
        cout << solve2(n);

    return 0;
}
