#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

vector<long long> pr(1e7);

int main()
{
	pr[0] = 0;
	for (int i = 1; i < pr.size(); ++i) {
		pr[i] = pr[i - 1] + i;
	}

	int t;
	cin >> t;
	for (; t > 0; --t) {
		int n, m;
		cin >> n >> m;
		long long sum1 = pr[n - 1] * m * m + pr[m] * n;
		int an = 1; long long mn = 1e18, nw = 0;
		for (int i = 1; i < m; ++i) {
			nw += pr[n - 1] * m + (long long)i * n;
			if (abs(sum1 - nw * 2) < mn) {
				mn = abs(sum1 - 2 * nw); an = i + 1;
			}
			else {
				break;
			}
		}
		long long sum2 = pr[n - 1] * m * m + pr[m] * n;
		int an2 = 1; long long mn2 = 1e18; nw = 0;
		for (int i = 1; i < n; ++i) {
			nw += (long long)(i - 1) * m * m + pr[m];
			if (abs(sum2 - nw * 2) < mn2) {
				mn2 = abs(sum2 - 2 * nw); an2 = i + 1;
			}
			else {
				break;
			}
		}
		if (mn < mn2) {
			cout << "V " << an << "\n";
		}
		else {
			cout << "H " << an2 << "\n";
		}
	}
}