#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
#define int long long
int f(int x){
    return x * (x + 1);
}

int min_x(int m){
    int mm = f(m) / 2;
    int l = 0, r = m;
    while (r - l > 1){
        int mid = (l + r) / 2;
        if (f(mid) <= mm){
            l = mid;
        }
        else {
            r = mid;
        }
    }
    int first = l;
    l = 0;
    r = m;
    while (r - l > 1){
        int mid = (l + r) / 2;
        if (f(mid) >= mm){
            r = mid;
        }
        else {
            l = mid;
        }
    }
    int second = r;
    if (abs(mm - f(second)) <= abs(mm - f(first))){
        return second;
    }
    else{
        return first;
    }
}

int get_ans(int n, int m, int x, bool type){
    if (type){
        return abs(x * (x + 1) * n + x * m * (n - 1) * n - n * m * (n * m + 1) / 2);
    }
    else{
        return abs(x * m * (x * m + 1) - n * m * (n * m + 1) / 2);
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int extra_ind = 0; extra_ind < t; ++extra_ind) {
        int n, m;
        cin >> n >> m;
        int min_ans = n * m * (n * m + 1) / 2;
        for (int i = 0; i < m; ++i){
            min_ans = min(min_ans, get_ans(n, m, i, true));
        }
        for (int i =0; i < n; ++i){
            min_ans = min(min_ans, get_ans(n, m, i, false));
        }
        bool f = false;
        for (int i = 0; i < m && !f; ++i){
            if (min_ans == get_ans(n, m, i, true) && !f){
                cout << "V" << ' ' << i + 1 << "\n";
                f = true;
                break;
            }
        }
        for (int i =0; i < n && !f; ++i){
            if (min_ans == get_ans(n, m, i, false) && !f){
                cout << "H" << ' ' << i + 1 << "\n";
                f = true;
                break;
            }
        }
    }
}