#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
#define int long long
int f(int x){
    return x * (x + 1);
}

int min_x(int m){
    int mm = f(m) / 2;
    int l = 0, r = m;
    while (r - l > 1){
        int mid = (l + r) / 2;
        if (f(mid) <= mm){
            l = mid;
        }
        else {
            r = mid;
        }
    }
    int first = l;
    l = 0;
    r = m;
    while (r - l > 1){
        int mid = (l + r) / 2;
        if (f(mid) >= mm){
            r = mid;
        }
        else {
            l = mid;
        }
    }
    int second = r;
    if (abs(mm - f(second)) <= abs(mm - f(first))){
        return second;
    }
    else{
        return first;
    }
}

int get_ans(int n, int m, int x, bool type){
    if (type){
        return (x * (x + 1) * n + x * m * (n - 1) * n - n * m * (n * m + 1) / 2);
    }
    else{
        return (x * m * (x * m + 1) - n * m * (n * m + 1) / 2);
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int extra_ind = 0; extra_ind < t; ++extra_ind) {
        int n, m;
        cin >> n >> m;
        int l = 0, r = m;
        while (r - l > 1){
            int mid = (l + r) / 2;
            if (get_ans(n, m, mid, true) > 0){
                r = mid;
            }
            else{
                l = mid;
            }
        }
        int first = l;
        l = 0;
        r = n;
        while (r - l > 1){
            int mid = (l + r) / 2;
            if (get_ans(n, m, mid, false) > 0){
                r = mid;
            }
            else{
                l = mid;
            }
        }
        int second = l;
        int ans11 = abs(get_ans(n, m, first, true));
        int ans12 = abs(get_ans(n, m, first + 1, true));
        int ans21 = abs(get_ans(n, m, second, false));
        int ans22 = abs(get_ans(n, m, second + 1, false));
        int ans = min(min(ans11, ans12), min(ans21, ans22));
        if (ans == ans11){
            cout << "V" << ' ' << first + 1 << "\n";
        }
        else if (ans == ans12){
            cout << "V" << ' ' << first + 2 << "\n";
        }
        else if (ans == ans21){
            cout << "H" << ' ' << second + 1 << "\n";
        }
        else {
            cout << "H" << ' ' << second + 2 << "\n";
        }
    }
}