#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int len_n(int x){
    if (x == 1){
        return 0;
    }
    int cnt = 0;
    while (x > 0){
        cnt++;
        x -= x % 10;
        x /= 10;
    }
    return cnt;
}

int len_s(vector<int> &len){
    int cnt = 0;
    for (int i = 0; i < len.size(); ++i) {
        if (len[i] != 0) {
            cnt++;
            cnt += len_n(len[i]);
        }
    }
    return cnt;
}

int get_ind(vector<int> &len, int ind, int ind1){
    int cnt = 1;
    for (int i = 0; i < ind; ++i){
        cnt = len[i];
    }
    cnt += ind1;
    return cnt;
}

char other(char c){
    if (c == 'A'){
        return 'G';
    }
    return 'A';
}

int main(){
    string s;
    getline(cin, s);
    vector<char> sym;
    vector<int> len;
    int x = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == 'A' || s[i] == 'T' || s[i] == 'G' || s[i] == 'C'){
            if (x == 0) {
                len.push_back(1);
                sym.push_back(s[i]);
            }
            else {
                len.push_back(x);
                sym.push_back(s[i]);
                x = 0;
            }
        }
        else{
            x *= 10;
            x += (s[i] - '0');
        }
    }
    /*string t;
    for (int i = 0; i < sym.size(); ++i) {
        for (int j = 0; j < len[i]; ++j) {
            t += sym[i];
        }
    }
    cout << t << endl;*/
    int max_ans = s.size();
    int min_ans = s.size();
    if (true){
        // delete block
        for (int i = 0; i < len.size(); ++i) {
            if (len[i] == 1){
                if (i != 0 && i != len.size() -1 && sym[i - 1] == sym[i + 1]){
                    int save = len[i + 1];
                    len[i - 1] += len[i + 1];
                    len[i + 1] = 0;
                    len[i] = 0;
                    max_ans = max(len_s(len), max_ans);
                    min_ans = min(min_ans, len_s(len));
                    len[i] = 1;
                    len[i + 1] = save;
                    len[i - 1] -= save;
                }
                else{
                    len[i] = 0;
                    max_ans = max(len_s(len), max_ans);
                    min_ans = min(min_ans, len_s(len));
                    len[i] = 1;
                }
            }
        }
    }
    if (true){
        // delete elem from block
        for (int i = 0; i < len.size(); ++i) {
            if (len[i] != 1) {
                len[i]--;
                max_ans = max(len_s(len), max_ans);
                min_ans = min(min_ans, len_s(len));
                len[i]++;
            }
        }
    }
    if (true) {
        // split block
        for (int i = 0; i < len.size(); ++i) {
            if (len[i] >= 3) {
                int new_ans =
                        s.size() - len_n(len[i]) + len_n((len[i] - 1) / 2) + len_n(len[i] - (len[i] - 1) / 2 - 1) + min(2, len[i] - 3);
                max_ans = max(new_ans, max_ans);
                min_ans = min(min_ans, new_ans);
            }
        }
    }
    if (true){
        // insert
        for (int i = 0; i < len.size(); ++i){
            int new_ans = s.size() - len_n(len[i]) + len_n(len[i] + 1);
            max_ans = max(new_ans, max_ans);
            min_ans = min(min_ans, new_ans);
        }
    }
    int type_ = -1;//max
    int ind_ = -1;
    char letter_ = 'A';
    int type = -1;
    int ind = -1;
    char letter = 'A';
    if (true){
        // delete block
        for (int i = 0; i < len.size(); ++i) {
            if (len[i] == 1){
                if (i != 0 && i != len.size() -1 && sym[i - 1] == sym[i + 1]){
                    int save = len[i + 1];
                    len[i - 1] += len[i + 1];
                    len[i + 1] = 0;
                    len[i] = 0;
                    if (max_ans == len_s(len)){
                        type_ = 2;
                        ind_ = get_ind(len, i, 0);
                    }
                    if (min_ans == len_s(len)){
                        type = 2;
                        ind = get_ind(len, i, 0);
                    }
                    len[i] = 1;
                    len[i + 1] = save;
                    len[i - 1] -= save;
                }
                else{
                    len[i] = 0;
                    if (max_ans == len_s(len)){
                        type_ = 2;
                        ind_ = get_ind(len, i, 0);
                    }
                    if (min_ans == len_s(len)){
                        type = 2;
                        ind = get_ind(len, i, 0);
                    }
                    len[i] = 1;
                }
            }
        }
    }
    if (true){
        // delete elem from block
        for (int i = 0; i < len.size(); ++i) {
            if (len[i] != 1) {
                len[i]--;
                if (max_ans == len_s(len)){
                    type_ = 2;
                    ind_ = get_ind(len, i, 0);
                }
                if (min_ans == len_s(len)){
                    type = 2;
                    ind = get_ind(len, i, 0);
                }
                len[i]++;
            }
        }
    }
    if (true) {
        // split block
        for (int i = 0; i < len.size(); ++i) {
            if (len[i] >= 3) {
                int new_ans =
                        s.size() - len_n(len[i]) + len_n((len[i] - 1) / 2) + len_n(len[i] - (len[i] - 1) / 2 - 1) + min(2, len[i] - 3);
                if (max_ans == new_ans){
                    type_ = 3;
                    ind_ = get_ind(len, i, len[i] / 2);
                    letter_ = other(sym[i]);
                }
                if (min_ans == new_ans){
                    type = 3;
                    ind = get_ind(len, i, len[i] / 2);
                    letter = other(sym[i]);
                }
            }
        }
    }
    if (true){
        // insert
        for (int i = 0; i < len.size(); ++i){
            int new_ans = s.size() - len_n(len[i]) + len_n(len[i] + 1);
            if (max_ans == new_ans){
                type_ = 1;
                ind_ = get_ind(len, i, 0);
                letter_ = sym[i];
            }
            if (min_ans == new_ans){
                type = 1;
                ind = get_ind(len, i, 0);
                letter = sym[i];
            }
        }
    }
    cout << type_ << ' ' << ind_ << ' ' << letter_ << endl;
    cout << type << ' ' << ind << ' ' << letter << endl;

}