#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
vector<int> s;
vector<vector<int>> v;
vector<int> path;
vector<bool> used;

bool can_used(int i1, int i2, int m){
    return s[i1] - v[i1][v[i1].size() - 1] + v[i2][0] == m;
}

int n;

void generate(){
    bool fl = true;
	for (int i = 0; i < n; ++i){
		if (!used[i]){
		    fl = false;
			used[i] = true;
			path.push_back(i);
			generate();
			path.pop_back();
			used[i] = false;
		}
	}
	if (fl){
	    bool f = true;
	    int m = s[path[0]] - v[path[0]][v[path[0]].size() - 1] + v[path[1]][0];

        for (int i = 0; i < n - 1; ++i) {
            if (!can_used(path[i], path[i + 1], m)){
                f = false;
                break;
            }
        }
        if (f){
            cout << "Yes" << endl;
            for (int i = 0; i < n; ++i) {
                cout << path[i] + 1 << ' ';
            }
            cout << endl;
            exit(0);
        }
	}
}

int main(){
    cin >> n;
    s.resize(n);
    v.resize(n);
    used.resize(n);
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;
        cin >> s[i];
        v[i].resize(m);
        for (int j = 0; j < m; ++j) {
            cin >> v[i][j];
        }
    }
    generate();
    cout << "No" << endl;
}