#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#define endl '\n'
#define int long long
using namespace std;

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
	int n;
	cin >> n;
	vector<pair<int, int>> v(n);
	for (int i = 0; i < n; ++i) {
		int m, s, p;
		cin >> m >> s;
		vector<int> p(m);
		for (int i = 0; i < m; ++i) {
			cin >> p[i];
		}
		v[i] = make_pair(p.front(), s - p.back());
	}
	if (n == 1) {
		cout << "Yes" << endl << 1;
		return 0;
	}
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
	do {
		int l = v[p[0]].second + v[p[1]].first;
		bool ok = true;
		for (int i = 0; i + 1 < n && ok; ++i) {
			if (v[p[i]].second + v[p[i + 1]].first != l) {
				ok = false;
			}
		}
		if (ok) {
			cout << "Yes" << endl;
			for (int i = 0; i < n; ++i) {
				cout << p[i] + 1 << " ";
			}
			return 0;
		}
	} while (next_permutation(p.begin(), p.end()));
	cout << "No";
	return 0;
}
