#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#define endl '\n'
#define int long long
using namespace std;

int n, m, c;
vector<string> v;

bool gen(int i, int j) {
	if (j == m) {
		++i;
		j = 0;
	}
	if (i == n) {
		return true;
	}
	for (int k = 0; k < c; ++k) {
		v[i][j] = '1' + k;
		bool ok = true;
		for (int ii = 0; ii < i && ok; ++ii) {
			if (v[i][j] == v[ii][j])
			for (int jj = 0; jj < j && ok; ++jj) {
				if (v[i][j] == v[i][jj] && v[i][j] == v[ii][jj]) {
					ok = false;
				}
			}
		}
		if (ok && gen(i, j + 1)) {
			return true;
		}
	}
	return false;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
	cin >> n >> m >> c;
	v.assign(n, string(m, '1'));
	gen(0, 0);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << v[i][j] << " ";
		}
		cout << endl;
	}
	return 0;
}
