#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#define endl '\n'
#define int long long
using namespace std;

int n, ans = 0;
vector<tuple<char, char, char>> v;
set<int> noused;

void gen(int i, char off) {
	if (i == -1) {
		if (off == 0) {
			ans = (ans + 1) % (int)(1e9 + 7);
		}
	} else {
		vector<int> good;
		for (const int &j : noused) {
			if ((get<0>(v[j]) + get<1>(v[j]) + off) % 10 == get<2>(v[j]) && (i > 0 || get<0>(v[j]) * get<1>(v[j]) * get<2>(v[j]) > 0)) {
				good.push_back(j);
			}
		}
		for (const int &j : good) {
			noused.erase(j);
			gen(i - 1, (get<0>(v[j]) + get<1>(v[j]) + off) / 10);
			noused.insert(j);
		}
	}
}

bool check() {
	char off = 0;
	for (int i = n - 1; i >= 0; --i) {
		if ((get<0>(v[i]) + get<1>(v[i]) + off) % 10 == get<2>(v[i])) {
			off = (get<0>(v[i]) + get<1>(v[i]) + off) / 10;
		} else {
			return false;
		}
	}
	return get<0>(v[0]) * get<1>(v[0]) * get<2>(v[0]) > 0 && off == 0;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
	string a, b, c;
	cin >> a >> b >> c;
	n = a.size();
	v.assign(n, make_tuple(0, 0, 0));
	for (int i = 0; i < n; ++i) {
		v[i] = make_tuple(a[i] - '0', b[i] - '0', c[i] - '0');
		noused.insert(i);
	}
	gen(n - 1, 0);
	cout << ans;
	return 0;
}
