#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#define endl '\n'
#define int long long
using namespace std;

pair<char, char> etype(char a, char b, char c) {
	if (a + b == c) {
		return make_pair(0, 0);
	}
	if (a + b + 1 == c) {
		return make_pair(1, 0);
	}
	if (a + b == c + 10) {
		return make_pair(0, 1);
	}
	if (a + b + 1 == c + 10) {
		return make_pair(1, 1);
	}
	return make_pair(-1, -1);
}

bool check(string &a, string &b, string &c) {
	char off = 0;
	int n = a.size();
	for (int i = n - 1; i >= 0; --i) {
		if ((a[i] - '0' + b[i] - '0' + off) % 10 == c[i] - '0') {
			off = (a[i] - '0' + b[i] - '0' + off) / 10;
		}
	}
	return (a[0] - '0') * (b[0] - '0') * (c[0] - '0') > 0 && off == 0;
}

int p = 1e9 + 7;

vector<int> f;

int dp(int a, int b) {
	int ans = 1;
	for (int i = 1; i <= a - 1; ++i) {
		ans = (ans * f[b + i]) % p;
	}
	ans /= f[a - 1];
	return ans;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
	int n, zero0 = 0, zero1 = 0, ans = 0;
	string a, b, c;
	cin >> a >> b >> c;
	n = a.size();
	vector<vector<int>> v(2, vector<int>(2, 0));
	for (int i = 0; i < n; ++i) {
		pair<char, char> e = etype(a[i] - '0', b[i] - '0', c[i] - '0');
		if (e == pair<char, char>(-1, -1)) {
			cout << 0;
			return 0;
		}
		if ((a[i] - '0') * (b[i] - '0') * (c[i] - '0') == 0 && e.second == 0) {
			if (e.first == 0) {
				++zero0;
			} else {
				++zero1;
			}
		}
		++v[e.first][e.second];
	}
	if (v[0][1] != v[1][0]) {
		cout << 0;
		return 0;
	}
	int m = max(max(v[0][0], v[1][1]), v[0][1]);
	f.assign(m + 1, 1);
	for (int i = 2; i <= m; ++i) {
		f[i] = (f[i - 1] * i) % p;
	}
	int zero0q = ((dp(v[0][1] + 1, v[0][0] - 1) * f[v[0][0] - 1] % p) * (dp(v[0][1], v[1][1]) * f[v[1][1]] % p) % p * (f[v[0][1]] * f[v[0][1]] % p) % p);
	int zero1q = ((dp(v[0][1], v[0][0]) * f[v[0][0]]) % p) * ((dp(v[0][1], v[1][1]) * f[v[1][1]]) % p) % p * ((f[v[0][1]] * f[max(0ll, v[0][1] - 1)]) % p) % p;
	cout << (((dp(v[0][1] + 1, v[0][0]) * f[v[0][0]] % p) * (dp(v[0][1], v[1][1]) * f[v[1][1]] % p) % p * (f[v[0][1]] * f[v[0][1]] % p) % p + p - zero0 * zero0q % p + p - zero1 * zero1q % p) % p + p - ans) % p;
	return 0;
}
