#include <bits/stdc++.h>
using namespace std;

#define ll long long

template <typename t>
t vrtcl_dif(t n, t m, t x){
    t s = (n*m)*(n*m + 1)/2;
    t l = (x*(x + 1)*n + n*m*(n-1)*x) / 2;
    t r = s - l;
    return abs(l - r);
}
template <typename t>
t vrtcl_srch(t n, t m){
    t l = 1;
    t r = m+1;
    t j;
    while(r - l > 1){
        j = (l+r)/2;
        if(vrtcl_dif(n,m,j-1) < vrtcl_dif(n,m,j - 2)){
            l = j;
        }else{
            r = j;
        }
    }
    if(j - 1 && vrtcl_dif(n,m,j-2) <= vrtcl_dif(n,m,j-1))
        j--;
    return j;
}
template <typename t>
t hrsntl_dif(t n, t m, t x){
    t s = (n*m)*(n*m + 1)/2;
    t top = (m*x)*(m*x + 1)/2;
    t bot = s - top;
    return abs(top - bot);
}
template <typename t>
t hrsntl_srch(t n, t m){
    t l = 1;
    t r = n+1;
    t j;
    while(r - l > 1){
        j = (l+r)/2;
        if(hrsntl_dif(n,m,j-1) < hrsntl_dif(n,m,j - 2)){
            l = j;
        }else{
            r = j;
        }
    }
    if(j - 1 && hrsntl_dif(n,m,j-2) <= hrsntl_dif(n,m,j-1))
        j--;
    return j;
}

int main(){
    ll t, n, m;
    cin >> t;
    for(int i = 0; i < t; i++){
        cin >> n >> m;
        ll v = vrtcl_srch(n,m);
        ll h = hrsntl_srch(n,m);
        if(vrtcl_dif(n,m,v-1) <= hrsntl_dif(n,m,h-1)){
            cout << "V " << v << endl;
        }else{
            cout << "H " << h << endl;
        }
    }
}

