#include <bits/stdc++.h>
using namespace std;

#define X first
#define Y second
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef string str;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pii;

int n, m;

ll ans_s(ll a, ll b) {
    return (b * (b + 1) - a * (a - 1)) / 2;
}

ll ans_v(ll i) {
    return (ans_s(1, i) - ans_s(i + 1, m)) * n + m * ans_s(1, n - 1) * (2 * i - m);
}

ll ans_h(ll i) {
    return ans_s(1, i * m) - ans_s(i * m + 1, n * m);
}

void solve() {
    cin >> n >> m;

    ll l = 1;
    ll r = m - 1;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (ans_v(mid) > 0) r = mid;
        else l = mid;
    }

    ll ans_1 = l;
    if (abs(ans_v(l)) > abs(ans_v(r))) ans_1 = r;
    if (m == 1) ans_1 = 1;

    l = 1;
    r = n - 1;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (ans_h(mid) > 0) r = mid;
        else l = mid;
    }

    ll ans_2 = l;
    if (abs(ans_h(l)) > abs(ans_h(r))) ans_2 = r;
    if (n == 1) ans_2 = 1;

    if (abs(ans_v(ans_1)) <= abs(ans_h(ans_2))) cout << "V " << ans_1 + 1 << '\n';
    else cout << "H " << ans_2 + 1 << '\n';
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();
}