#include <bits/stdc++.h>
using namespace std;

#define X first
#define Y second
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define int ll

typedef long long ll;
typedef string str;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pii;

bool is_10_pow(int x) {
    if (x == 1) return false;
    while (x > 1) {
        if (x % 10 != 0) return false;
        x /= 10;
    }
    return true;
}

int count_digits(int x) {
    int count = 0;
    while (x > 0) {
        x /= 10;
        count++;
    }
    return count;
}

pii to_components(int x) {
    if (x == 1) return {1, 1};
    int now = 2;
    int now_size = 1;
    int ans = 0;
    int ans_now = 2;
    while (now <= x) {
        int res = now_size + count_digits(x - now);
        if (res > ans) {
            ans_now = now;
            ans = res;
        }
        if (now == 2) now = 1;
        now *= 10;
        now_size++;
    }
    return {ans, ans_now};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    str s;
    cin >> s;
    int s_size = s.size();
    vector<pair<char, int>> code;
    code.pb({' ', 0});
    for (char c : s) {
        if (isdigit(c)) {
            code[code.size() - 1].Y = code[code.size() - 1].Y * 10 + (c - '0');
        } else {
            code[code.size() - 1].X = c;
            if (code[code.size() - 1].Y == 0) code[code.size() - 1].Y = 1;
            code.pb({' ', 0});
        }
    }
    code.pop_back();

    int n = code.size();
    int min_ans = s_size;
    int min_ans_sym = 1;
    int count_sym = 0;
    for (int i = 0; i < n; i++) {
        count_sym += code[i].Y;
        if (code[i].Y == 1) {
            if (i == 0 || i == n - 1 || code[i - 1].X != code[i + 1].X) {
                int res = s_size - 1;
                if (res < min_ans) {
                    min_ans = res;
                    min_ans_sym = count_sym;
                }
            } else {
                int res = s_size - 2 - count_digits(code[i - 1].Y) - count_digits(code[i + 1].Y) + count_digits(code[i - 1].Y + code[i + 1].Y);
                if (res < min_ans) {
                    min_ans = res;
                    min_ans_sym = count_sym;
                }
            }
        } else {
            int res = s_size - is_10_pow(code[i].Y);
            if (res < min_ans) {
                min_ans = res;
                min_ans_sym = count_sym;
            }
        }
    }

    int max_ans = s_size + 1;
    int max_ans_sym = 0;
    char max_ans_let = 'A';
    count_sym = 0;
    if (code[0].X == 'A') max_ans_let = 'C';
    for (int i = 0; i < n; i++) {
        int res = s_size + 2 + to_components(code[i].Y).X - count_digits(code[i].Y);
        if (res > max_ans) {
            max_ans = res;
            max_ans_sym = count_sym + to_components(code[i].Y).Y;
            max_ans_let = 'A';
            if (code[i].X == 'A') max_ans_let = 'C';
        }
        count_sym += code[i].Y;
    }

    if (s_size > 10000) exit(0);

    cout << 2 << ' ' << min_ans_sym << '\n';
    cout << 1 << ' ' << max_ans_sym << ' ' << max_ans_let << '\n';
}