def best_cut(n, m):
    answer = 'H 1'
    total = n * m
    total_sum = total * (total + 1) // 2
    best_dif = 10**100
    
    #horizontal
    if n > 1:

        low = 1
        up = n

        while True:
            i = (low + up) // 2
            x = i * m
            sum1 = x * (x + 1) // 2
            sum2 = total_sum - sum1
            i += 1
            x = i * m
            SUM1 = x * (x + 1) // 2
            SUM2 = total_sum - SUM1
            dif1 = sum1 - sum2
            dif2 = SUM1 - SUM2
            if dif1 * dif2 <= 0:
                best_dif = min(abs(dif1), abs(dif2))
                if abs(dif1) < abs(dif2):
                    answer = 'H ' + str(i)
                else:
                    answer = 'H ' + str(i + 1)
                break
            if dif1 < 0:
                low = i
            else:
                up = i
   #         print(low, up, sum1, SUM1, dif1, dif2)

    #vertical
    flag = True
    for k in range(1, m):
        x = n + m * n * (n - 1) // 2
        sum1 = k * x + n * k * (k - 1) // 2
        sum2 = total_sum - sum1
        dif = abs(sum1 - sum2)
        if (dif <= best_dif and flag) or dif < best_dif:
            flag = False
            best_dif = dif
            answer = 'V ' + str(k + 1)
    return answer




t = int(input())

res = []

for i in range(t):
    n, m = map(int, input().split())
    res.append(best_cut(n, m))

for i in res:
    print(i)
