#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>


using namespace std;


int n;
int ln;
vector<int> m;
vector<int> s;
vector<vector<int>> a;
vector<bool> used;
vector<int> x;
bool good = false;


bool ok() {
	int nln = -1;
	for (int i = 1; i < n; ++i) {
		if (nln == -1 || nln == (s[x[i - 1]] - a[x[i - 1]].back()) + a[x[i]][0]) {
			nln = (s[x[i - 1]] - a[x[i - 1]].back()) + a[x[i]][0];
		}
		else {
			return false;
		}
	}
	return ln == -1 || nln == -1 || ln == nln;
}


void get_perm() {
	bool stp = true;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			stp = false;
			used[i] = true;
			x.push_back(i);
			get_perm();
			if (good) {
				return;
			}
			x.pop_back();
			used[i] = false;
		}
	}
	if (stp) {
		good = ok();
	}
}



int main() {
	cin >> n;
	m.resize(n);
	s.resize(n);
	a.resize(n);
	ln = -1;
	for (int i = 0; i < n; ++i) {
		cin >> m[i] >> s[i];
		a[i].resize(m[i]);
		for (int j = 0; j < m[i]; ++j) {
			cin >> a[i][j];
			if (j != 0) {
				if (ln == -1) {
					ln = a[i][j] - a[i][j - 1];
				}
				else if (ln != a[i][j] - a[i][j - 1]) {
					cout << "No" << "\n";
					return 0;
				}
			}
		}
	}
	used.resize(n, false);
	get_perm();
	if (good) {
		cout << "Yes" << "\n";
		for (auto c : x) {
			cout << c + 1 << " ";
		}
		cout << "\n";
	}
	else {
		cout << "No" << "\n";
	}
	return 0;
}


/*
3
1 7
3
1 8
6
2 8
1 6

Yes
2 1 3
*/