#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>


using namespace std;


string get_string(char x, int n) {
	string res;
	for (int i = 0; i < n; ++i) {
		res.push_back(x);
	}
	return res;
}


long long find_next_good(long long x) {
	string s = to_string(x);
	long long a = stoll(get_string(s[0], s.size()));
	if (a >= x) {
		return a;
	}
	else {
		return stoll(get_string(s[0] + 1, s.size()));
	}
}


long long find_next_good(string s, int ign){
	if (s.size() == 1) {
		return stoll(s);
	}
	long long x = stoll(s);
	char c = s[0];
	if (ign == 0) {
		c = s[1];
	}
	string a = get_string(c, s.size());
	int beg = 0;
	if (ign == 0) {
		beg = 1;
	}
	for (int i = beg; i < 10; ++i) {
		a[ign] = '0' + i;
		long long y = stoll(a);
		if (y >= x) {
			return y;
		}
	}
	a = get_string(c + 1, s.size());
	for (int i = beg; i < 10; ++i) {
		a[ign] = '0' + i;
		long long y = stoll(a);
		if (y >= x) {
			return y;
		}
	}
}


long long find_next_ok(long long x) {
	string s = to_string(x);
	long long res = 1e18;
	for (int i = 0; i < s.size(); ++i) {
		res = min(res, find_next_good(s, i));
	}
	return res;
}


int main() {
	long long x;
	cin >> x;
	int k;
	cin >> k;
	if (k == 0) {
		cout << find_next_good(x) << "\n";
	}
	else if (k == 1) {
		cout << find_next_ok(x) << "\n";
	}
	return 0;
}


/*
700
0
*/

/*
700
1
*/