#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>


using namespace std;


string get_string(char x, int n) {
	string res;
	for (int i = 0; i < n; ++i) {
		res.push_back(x);
	}
	return res;
}


bool compare_strings(string s1, string s2) {
	if (s1.size() != s2.size()) {
		return s1.size() < s2.size();
	}
	int i = 0;
	while (i < s1.size() && s1[i] == s2[i]) {
		++i;
	}
	return i == s1.size() || s1[i] <= s2[i];
}


string find_next_good(string s) {
	string a = get_string(s[0], s.size());
	if (compare_strings(s, a)) {
		return a;
	}
	else {
		return get_string(s[0] + 1, s.size());
	}
}


string find_next_ok(string s, int ign){
	if (s.size() == 1) {
		return s;
	}
	char c = s[0];
	if (ign == 0) {
		c = s[1];
	}
	string res = string("1") + get_string('0', 22);
	string a = get_string(c, s.size());
	int beg = 0;
	if (ign == 0) {
		beg = 1;
	}
	for (int i = beg; i < 10; ++i) {
		a[ign] = '0' + i;
		if (compare_strings(s, a) && compare_strings(a, res)) {
			res = a;
		}
	}
	if (c >= '9') {
		return res;
	}
	a = get_string(c + 1, s.size());
	for (int i = beg; i < 10; ++i) {
		a[ign] = '0' + i;
		if (compare_strings(s, a) && compare_strings(a, res)) {
			res = a;
		}
	}
	return res;
}


string find_next_ok(string s) {
	string res = string("1") + get_string('0', 22);
	for (int i = 0; i < s.size(); ++i) {
		string numb = find_next_ok(s, i);
		if (compare_strings(numb, res)) {
			res = numb;
		}
	}
	return res;
}


int main() {
	string x;
	cin >> x;
	int k;
	cin >> k;
	if (k == 0) {
		cout << find_next_good(x) << "\n";
	}
	else if (k == 1) {
		cout << find_next_ok(x) << "\n";
	}
	return 0;
}


/*
700
0
*/

/*
700
1
*/