#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdlib>


using namespace std;


int n, m;
int c;
vector<vector<int>> res;


bool ok() {
	for (int i1 = 0; i1 < n; ++i1) {
		for (int i2 = i1 + 1; i2 < n; ++i2) {
			for (int j1 = 0; j1 < m; ++j1) {
				for (int j2 = j1 + 1; j2 < m; ++j2) {
					if (res[i1][j1] == res[i2][j1] && res[i1][j1] == res[i2][j2] && res[i1][j1] == res[i1][j2]) {
						return false;
					}
				}
			}
		}
	}
	return true;
}


bool get_random3() {
	res.assign(n, vector<int>(m, -1));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			int i1 = i;
			int j1 = j;
			vector<bool> norm = {true, true, true};
			for (int i2 = 0; i2 < i1; ++i2) {
				for (int j2 = 0; j2 < j1; ++j2) {
					if (res[i2][j1] == res[i2][j2] && res[i2][j1] == res[i1][j2]) {
						norm[res[i2][j1]] = false;
					}
				}
			}
			if ((!norm[0]) && (!norm[1]) && (!norm[2])) {
				return false;
			}
			int c = (rand() % 3);
			while (!norm[c]) {
				c = (rand() % 3);
			}
			res[i][j] = c;
		}
	}
	return true;
}


bool get_random2() {
	res.assign(n, vector<int>(m, -1));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			int i1 = i;
			int j1 = j;
			vector<bool> norm = { true, true };
			for (int i2 = 0; i2 < i1; ++i2) {
				for (int j2 = 0; j2 < j1; ++j2) {
					if (res[i2][j1] == res[i2][j2] && res[i2][j1] == res[i1][j2]) {
						norm[res[i2][j1]] = false;
					}
				}
			}
			if ((!norm[0]) && (!norm[1])) {
				return false;
			}
			int c = (rand() % 2);
			while (!norm[c]) {
				c = (rand() % 2);
			}
			res[i][j] = c;
		}
	}
	return true;
}


void print_res() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << res[i][j] + 1 << " ";
		}
		cout << "\n";
	}
}


int main() {
	srand(100);
	cin >> n >> m >> c;
	if (c == 2) {
		res.resize(n, vector<int>(m));
		while (!get_random2()) {}
		print_res();
	}
	else if (c == 3) {
		res.resize(n, vector<int>(m));
		while (!get_random3()) {	}
		print_res();
	}
	return 0;
}