#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


struct col {
	int nd;
	int gv;
};


const long long mod = 1e9 + 7;
string a, b, c;
int n;


int main() {
	cin >> a >> b >> c;
	n = a.size();
	int who_nd = 0;
	int who_dont_nd = 0;
	int who_gv = 0;
	int who_dont_gv = 0;
	int ac = 0;
	int bc = 0;
	int cc = 0;
	int dc = 0;
	for (int i = 0; i < n; ++i) {
		int x = a[i] - '0';
		int y = b[i] - '0';
		int z = c[i] - '0';
		col r;
		if ((x + y) % 10 == z) {
			r.nd = 0;
			who_dont_nd += 1;
		}
		else if((x + y + 1) % 10 == z){
			r.nd = 1;
			who_nd += 1;
		}
		else {
			cout << 0 << "\n";
			return 0;
		}
		if ((x + y + r.nd) >= 10) {
			r.gv = 1;
			who_gv += 1;
		}
		else {
			r.gv = 0;
			who_dont_gv += 1;
		}
		if (r.gv == 0 && r.nd == 0) {
			dc += 1;
		}
		else if (r.gv == 0 && r.nd == 1) {
			cc += 1;
		}
		else if (r.gv == 1 && r.nd == 0) {
			bc += 1;
		}
		else if (r.gv == 1 && r.nd == 1) {
			ac += 1;
		}
	}
	if (who_gv != who_nd || who_dont_gv != who_dont_nd) {
		cout << 0 << "\n";
		return 0;
	}
	long long res = 1;
	for (int i = 1; i <= who_nd - 1; ++i) {
		res = (res * i) % mod;
	}
	for (int i = 1; i <= who_dont_nd; ++i) {
		res = (res * i) % mod;
	}
	cout << res << "\n";
	return 0;
}


/*
1881
2322
3114
*/


/*
123
123
246
*/


/*
01211
12099
23300
*/


/*
121
214
999
*/