#include<iostream>
#include<vector>
#include<set>
#include<algorithm>
#include<cmath>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<string>
#include<queue>
#include<deque>
#include<stack>

#define veci vector<int>
#define FORN(i, a, b) for (int i = a; i < b; ++i)
#define fastio ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
#define ll long long
#define li long int
#define nint signed
#define ull unsigned long long
#define precision(x) cout << fixed; cout << setprecision(x);
#define PAI pair<int, int>
#define MP make_pair
#define ld long double
#define pb push_back
#define MAXN 200000
#define MOD ((int)1e9 + 7)
#define HASH ((ll)1e12 + 39)

using namespace std;
#define int ll
int gett(veci X) {
	int ans = 0;
	for (int a : X) {
		ans *= 10;
		ans += a;
	}
	return ans;
}

bool check(veci& perm, veci& tip, int n, vector<veci>& A) {
	int prev = 0;
	veci X1, X2, X3;
	for (int i : perm) {
		int a = A[0][i], b = A[1][i], c = A[2][i];
		X1.pb(a);
		X2.pb(b);
		X3.pb(c);
	}
	reverse(all(X1));
	reverse(all(X2));
	reverse(all(X3));
	if (X1[0] != 0 && X2[0] != 0 && X3[0] != 0) {
		int AA = gett(X1), B = gett(X2), C = gett(X3);
		if (AA + B == C) {
			return 1;
		}
	}
	return 0;
}

bool F(int n, vector<veci>& A, veci& tip, veci& perm, veci & have) {
	int prev = 0;
	for (int i : perm) {
		int col = tip[i];
		if (col == 0 && prev % 2 == 1) {
			return 0;
		}
		else if (col == 1 && prev % 2 == 1) {
			return 0;
		}
		else if (col == 2 && prev % 2 == 0) {
			return 0;
		}
		else if (col == 3 && prev % 2 == 0) {
			return 0;
		}
		prev = col;
	}
	if (prev % 2 == 1 || have[perm.back()] == 1) {
		return 0;
	}
	return 1;
}

int SLOW(int n, vector<veci>&A) {
	int n_0 = 0, n_1 = 0, n_2 = 0, n_3 = 0, n_0_have_0 = 0, n_2_have_0 = 0;
	veci tip(n), have(n, 0);

	FORN(j, 0, n) {
		int a = A[0][j], b = A[1][j], c = A[2][j];
		if (min({ a, b, c }) == 0) {
			have[j] = 1;
		}
		if (a + b == c) {
			n_0++;
			if (have[j]) {
				n_0_have_0++;
			}
			tip[j] = 0;
		}
		else if ((a + b) % 10 == c) {
			n_1++;
			tip[j] = 1;
		}
		else if (a + b + 1 == c) {
			n_2++;
			if (have[j]) {
				n_2_have_0++;
			}
			tip[j] = 2;
		}
		else if (((a + b + 1) % 10) == c) {
			n_3++;
			tip[j] = 3;
		}
		else {
			return 0;
		}
	}
	if (n_1 != n_2) {
		return 0;
	}
	veci ANS(n);
	FORN(i, 0, n) {
		ANS[i] = i;
	}
	ll ans = 0;

	if (check(ANS, tip, n, A)) {
		++ans;
	}
	while (next_permutation(all(ANS))) {
		if (check(ANS, tip, n, A)) {
			++ans;
		}
	}
	return ans;
}

int FAST(int n, veci& tip, vector < veci> & A, veci& have) {
	veci ANS(n);
	FORN(i, 0, n) {
		ANS[i] = i;
	}
	ll ans = 0;
	if (F(n, A, tip, ANS, have)) {
		++ans;
	}
	while (next_permutation(all(ANS))) {
		if (F(n, A, tip, ANS, have)) {
			++ans;
		}
	}
	return ans;
}

int fac[2 * MAXN + 1], obr[2 * MAXN + 1];
int treug[1000][1000] = { {0} };

int c_n_k(int n, int k) {
	if (min(n, k) < 0 || n < k) {
		return 1;
	}
	return treug[n][k];
}

int clev(int n, vector<veci>&A) {
	int n_0 = 0, n_1 = 0, n_2 = 0, n_3 = 0, n_0_have_0 = 0, n_2_have_0 = 0;
	veci tip(n), have(n, 0);

	FORN(j, 0, n) {
		int a = A[0][j], b = A[1][j], c = A[2][j];
		if (min({ a, b, c }) == 0) {
			have[j] = 1;
		}
		if (a + b == c) {
			n_0++;
			if (have[j]) {
				n_0_have_0++;
			}
			tip[j] = 0;
		}
		else if ((a + b) % 10 == c) {
			n_1++;
			tip[j] = 1;
		}
		else if (a + b + 1 == c) {
			n_2++;
			if (have[j]) {
				n_2_have_0++;
			}
			tip[j] = 2;
		}
		else if (((a + b + 1) % 10) == c) {
			n_3++;
			tip[j] = 3;
		}
		else {
			return 0;
		}
	}
	if (n_1 != n_2) {
		return 0;
	}
	treug[0][0] = 1;
	treug[1][0] = 1;
	treug[1][1] = 1;
	FORN(N, 2, 1000) {
		FORN(K, 0, 1000) {
			treug[N][K] = (treug[N - 1][K - 1] + treug[N - 1][K]) % MOD;
		}
	}
	if (n_3 > 0 && n_1 == 0) {
		return 0;
	}
	if (n_2_have_0 == n_2) {
		if (n_0_have_0 == n_0) {
			return 0;
		}
		int ANS = (n_0 - n_0_have_0);
		ANS = (ANS * fac[n_2]) % MOD;
		ANS = (ANS * fac[n_2]) % MOD;
		ANS = (ANS * c_n_k(n_3 + n_2 - 1, n_2 - 1)) % MOD;
		ANS = (ANS * c_n_k(n_0 + n_2 - 1, n_2)) % MOD;
		ANS = (ANS * fac[n_0 - 1]) % MOD;
		return ANS;
	}
	if (n_0_have_0 == n_0) {
		int ANS = (n_2 - n_2_have_0);
		ANS = (ANS * fac[n_2]) % MOD;
		ANS = (ANS * fac[n_2]) % MOD;
		ANS = (ANS * c_n_k(n_3 + n_2 - 1, n_2 - 1)) % MOD;
		ANS = (ANS * c_n_k(n_0 + n_2 - 1, n_2 - 1)) % MOD;
		ANS = (ANS * fac[n_0]) % MOD;
		return ANS;
	}
	int ANS1 = (n_0 - n_0_have_0);
	ANS1 = (ANS1 * fac[n_2]) % MOD;
	ANS1 = (ANS1 * fac[n_2]) % MOD;
	ANS1 = (ANS1 * c_n_k(n_3 + n_2 - 1, n_2 - 1)) % MOD;
	ANS1 = (ANS1 * c_n_k(n_0 + n_2 - 1, n_2)) % MOD;
	ANS1 = (ANS1 * fac[n_0 - 1]) % MOD;
	int ANS2 = (n_2 - n_2_have_0);
	ANS2 = (ANS2 * fac[n_2]) % MOD;
	ANS2 = (ANS2 * fac[n_2]) % MOD;
	ANS2 = (ANS2 * c_n_k(n_3 + n_2 - 1, n_2 - 1)) % MOD;
	ANS2 = (ANS2 * c_n_k(n_0 + n_2 - 1, n_2 - 1)) % MOD;
	ANS2 = (ANS2 * fac[n_0]) % MOD;
	return (ANS1 + ANS2) % MOD;
}

nint main() {
	if (1 == 1) {
		vector<veci> A(3);
		string s; cin >> s;
		int n = s.size();
		for (char c : s) {
			A[0].pb((int)(c - '0'));
		}
		FORN(i, 0, n) {
			char c; cin >> c;
			A[1].pb((int)(c - '0'));
		}
		FORN(i, 0, n) {
			char c; cin >> c;
			A[2].pb((int)(c - '0'));
		}
		int n_0 = 0, n_1 = 0, n_2 = 0, n_3 = 0, n_0_have_0 = 0, n_2_have_0 = 0;
		veci tip(n), have(n, 0);

		FORN(j, 0, n) {
			int a = A[0][j], b = A[1][j], c = A[2][j];
			if (min({ a, b, c }) == 0) {
				have[j] = 1;
			}
			if (a + b == c) {
				n_0++;
				if (have[j]) {
					n_0_have_0++;
				}
				tip[j] = 0;
			}
			else if ((a + b) % 10 == c) {
				n_1++;
				tip[j] = 1;
			}
			else if (a + b + 1 == c) {
				n_2++;
				if (have[j]) {
					n_2_have_0++;
				}
				tip[j] = 2;
			}
			else if (((a + b + 1) % 10) == c) {
				n_3++;
				tip[j] = 3;
			}
			else {
				cout << 0; return 0;
			}
		}
		if (n_1 != n_2) {
			cout << 0; return 0;
		}
		fac[0] = 1;
		fac[1] = 1;
		FORN(x, 2, 2 * MAXN + 1) {
			fac[x] = (fac[x - 1] * x) % MOD;
		}
		cout << clev(n, A);
		return 0;
	}
	//cout << FAST(n, tip, A, have);
	fac[0] = 1;
	fac[1] = 1;
	FORN(x, 2, 2 * MAXN + 1) {
		fac[x] = (fac[x - 1] * x) % MOD;
	}
	while (1) {
		int n = rand() % 6 + 1;
		vector<veci>A(3);
		FORN(i, 0, 3) {
			FORN(j, 0, n) {
				A[i].pb(rand() % 10);
			}
		}
		int x1 = SLOW(n, A);
		int x2 = clev(n, A);
		if (x1 != x2) {
			cout << n << '\n';
			for (auto out : A) {
				for (int x : out) {
					cout << x << ' ';
				}
				cout << '\n';
			}
			cout << '\n';
			cout << x1 << ' ' << x2;
			return 0;
		}
		cout << "OK\n";
	}

	

	
}