#include <iostream>
#include <vector>
#include <sstream>
#include <string>

#define cin(a) for(auto& elem: a) cin >> elem;
#define cout(a) { for(auto& elem: a) cout << elem << " "; cout << endl; }

using namespace std;

int stoi(string& a, int from, int to) {
    stringstream help;
    for (int i = from; i < to; i++) {
        help << a[i];
    }
    int answ;
    help >> answ;
    return answ;
}
int len(int a) {
    if (a <= 1) return 0;
    int answ = 0;
    while (a > 0) {
        answ++;
        a /= 10;
    }
    return answ;
}

bool is_digit(char& a) {
    return ('0' <= a && a <= '9');
}

//   len  pos
pair<int, int> found_best_split(int group_len) {
    if (group_len == 1) return {2, 1};
    if (group_len == 2) return {3, 1};
    int avaible_split[11] = {1, 2, 10, 100, (int) 1e3, (int) 1e4, (int) 1e5, (int) 1e6, (int) 1e7, (int) 1e8, (int) 1e9};

    int best_pos = -1;
    int best_l = -1;
    for (int i = 0; i < 11; i++) {
        int l_now = 0;
        int pos_now = 0;
        if (group_len < avaible_split[i]) break;
        else if (group_len == avaible_split[i]) {
            l_now = len(avaible_split[i]) + 1 + 1;
            pos_now = avaible_split[i];
        }
        else {
            int r = avaible_split[i];
            int l = group_len - r;
            l_now = len(r) + 1 + 1 + len(l) + 1;
            pos_now = avaible_split[i];
        }
        if (l_now > best_l) {
            best_l = l_now;
            best_pos = pos_now;
        }

    }
    return {best_l, best_pos};
}


int main() {
    string line;
    cin >> line;
    int n = line.length();
    vector<pair<int, char>> groups;
    groups.reserve(n);
    int last_digit = -1;
    for (int i = 0; i < n; i++) {
        if (is_digit(line[i]) && last_digit == -1) {
            last_digit = i;
        }
        else {
            int c = 1;
            if (last_digit != -1) c = stoi(line, last_digit, i);
            groups.push_back({ c, line[i] });
            last_digit = -1;
        }
    }
    n = groups.size();

    // find min
    int change_id = -1;
    int delt = 1000;
    for (int i = 0; i < n; i++) {
        int delt_now = 1000;
        if (groups[i].first == 1) {
            delt_now = -1;
            if (i != 0 && i != n - 1) {
                if (groups[i-1].second == groups[i+1].second) {
                    int l_before = len(groups[i-1].first) + 1 + 1 + len(groups[i+1].first) + 1;
                    int l_after = len(groups[i-1].first + groups[i+1].first) + 1;
                    delt_now = l_after - l_before;
                }
            }
        }
        else {
            delt_now = len(groups[i].first - 1) - len(groups[i].first);
        }
        if (delt_now < delt) {
            delt = delt_now;
            change_id = i;
        }
    }

    int pos = 0;
    for (int i = 0; i < change_id; i++) pos += groups[i].first;
    cout << "2 " << pos + 1 << endl;

    // find max

    change_id = -1;
    delt = 1;
    for (int i = 0; i < n; i++) {
        if (groups[i].first == 1) continue;
        int l_best = found_best_split(groups[i].first).first;
        int delt_now = l_best - (len(groups[i].first) + 1);
        if (delt_now > delt) {
            delt = delt_now;
            change_id = i;
        }
    }

    if (change_id == -1) {
        int pos = 0;
        char last_ch = '?';
        for (int i = 0; i < n; i++) {
            pos += groups[i].first;
            last_ch = groups[i].second;
        }
        if (last_ch != 'A') {
            cout << "1 " << pos << " A\n";
        }
        else cout << "1 " << pos << " C\n";
    }
    else {
        int pos = 0;
        for (int i = 0; i < change_id; i++) pos += groups[i].first;
        pos += found_best_split(groups[change_id].first).second;
        if (groups[change_id].second != 'A') {
            cout << "1 " << pos << " A\n";
        }
        else {
            cout << "1 " << pos << " C\n";
        }
    }
}
