#include <iostream>
#include <vector>
#include <random>
#include <algorithm>

#define cin(a) for(auto& elem: a) cin >> elem;
#define cout(a) { for(auto& elem: a) cout << elem << " "; cout << endl; }

using namespace std;

struct line {
    int f;
    int s;
    int index = -1;
    line() {
        f = 0;
        s = 0;
    }
    line(int first, int second) {
        this->f = first;
        this->s = second;
    }
};


int main() {
    srand(1);
    int n = 0;
    cin >> n;

     vector<line> data(n);
    bool has_h = false;
    bool ok = true;
    int h = 0;
    int max_s = 0;
    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        max_s = max(s, max_s);
        int first_l = -1;
        int last_l = -1;
        int last = -1;
        int d_now = -1;
        if (has_h) d_now = h;
        for (int j = 0; j < m; j++) {
            int p = 0;
            cin >> p;
            if (first_l == -1) first_l = p;
            last_l = p;
            if (last != -1) {
                int d = p - last;
                if (d_now != -1 && d != d_now) ok = false;
                d_now = d;
            }
            last = p;
        }
        if (d_now != -1) {
            has_h = true;
            h = d_now;
        }
        data[i] = line(first_l, s - last_l);
        data[i].index = i + 1;
    }

    if (!ok) {
        cout << "No\n";
        return 0;
    }

    for (int Try = 0; Try < 1e6 * 3; Try++) {
        for (int ch = 0; ch < 1e1; ch++) {
            int a = rand() % n;
            int b = rand() % n;
            swap(data[a], data[b]);
        }
        int h_now = -1;
        if (has_h) h_now = h;
        bool ok = true;
        for (int i = 1; i < n; i++) {
            int d_now = data[i].f + data[i-1].s;
            if (h_now == -1) h_now = d_now;
            if (d_now != h_now) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << "Yes\n";
            for (auto& l: data) cout << l.index << " ";
            return 0;
        }
    }
    cout << "No\n";



}
