#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 239;

int numlen(int x) {
	assert(x > 0);
	int ans = 0;
	while (x) {
		ans++;
		x /= 10;
	}
	return ans;
}

tuple<int, int, int> solve_mn(vector<pair<int, char>> a) {
	int n = (int)a.size();
	int ans = INF;
	int A, B, C;
	auto relax = [&](int cand, int a, int b, int c) {
		b++;
		if (cand < ans) {
			ans = cand;
			A = a;
			B = b;
			C = c;
		} 
	};
	auto gl = [&](int i) {
		if (a[i].first == 1) return 1;
		return 1 + numlen(a[i].first);
	};
	auto rc = [&](int x) {
		if (x == 0) return 0;
		if (x == 1) return 1;
		return numlen(x) + 1;
	};

	int all = 0;
	int ps = 0;
	
	for (int i = 0; i < n; i++) {
		all += gl(i);
	}
	for (int i = 0; i < n; i++) {
		if (a[i].first > 1) {
			relax(all - rc(a[i].first) + rc(a[i].first - 1), 2, ps, -1);
		} else {
			if (0 < i && i + 1 < n && a[i - 1].second == a[i + 1].second) {
				relax(all - gl(i - 1) - gl(i) - gl(i + 1) + numlen(a[i - 1].first + a[i + 1].first) + 1, 2, ps, -1);
			} else {
				relax(all - gl(i), 1, ps, -1);
			}
		}
		ps += a[i].first;
	}

	cerr << "min " << ans << endl;
	tuple<int, int, int> ret = make_tuple(A, B, C);
	return ret;	
}

tuple<int, int, int> solve_mx(vector<pair<int, char>> a) {
	int n = (int)a.size();
	int ans = 0;
	int A, B, C;
	auto relax = [&](int cand, int a, int b, int c) {
		if (cand > ans) {
			ans = cand;
			A = a;
			B = b;
			C = c;
		} 
	};
	auto gl = [&](int i) {
		if (a[i].first == 1) return 1;
		return 1 + numlen(a[i].first);
	};
	auto rc = [&](int x) {
		if (x == 0) return 0;
		if (x == 1) return 1;
		return numlen(x) + 1;
	};

	int all = 0;
	int ps = 0;
	
	for (int i = 0; i < n; i++) {
		all += gl(i);
	}
	string S = "ACTG";
	for (int i = 0; i < n; i++) {
		relax(all - gl(i) + numlen(a[i].first + 1) + 1, 1, ps, a[i].second);
		for (int tot = 0; tot <= a[i].first; tot++) {
			char need = 'F';
			for (auto t : S) {
				int ok = 1;
				ok &= (t != a[i].second);
				if (i > 0) ok &= (t != a[i - 1].second);
				if (i + 1 < n) ok &= (t != a[i + 1].second);
				if (ok) need = t;    
			}                 
    		relax(all - gl(i) + rc(tot) + rc(a[i].first - tot) + 1, 1, ps + tot, need);    
        }
        ps += a[i].first;
	}

	cerr << "max " << ans << endl;
	tuple<int, int, int> ret = make_tuple(A, B, C);
	return ret;	
}



void print(tuple<int, int, int> op) {
	int a, b, c;
	tie(a, b, c) = op;
	if (a == 2) {
		cout << a << ' ' << b << endl;
	} else {
		cout << a << ' ' << b << ' ' << (char)c << endl;  
	}
}

vector<pair<int, char>> parse() {
	vector<pair<int, char>> ans;
	string s;
	cin >> s;
	for (int i = 0; i < (int)s.size(); i++) {
		if ('0' <= s[i] && s[i] <= '9') {
			int j = i;
			while ('0' <= s[j] && s[j] <= '9') j++;
			string tmp;
			for (int p = i; p < j; p++) tmp.push_back(s[p]);
			ans.push_back({stoi(tmp), s[j]});
			i = j;	
		} else {
			ans.push_back({1, s[i]});
		}
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("test", "r", stdin);
	#endif
	
	vector<pair<int, char>> v = parse();
	/*for (auto [f, s] : v) {
		cout << f << ' ' << s << endl;
	}*/
	tuple<int, int, int> mn = solve_mn(v);
	print(mn);
	tuple<int, int, int> mx = solve_mx(v);
	print(mx);
}
