#include <bits/stdc++.h>

using namespace std;

const int N = 1e1 + 7;

int n;
int pf[N];
int su[N];

int need;
int gsz;

vector<int> ie;

int pe = 0;
int used[8 * N];
int ed[10 * N];
int alive[8 * N];

map<pair<int, int>, int> cnt;
map<pair<int, int>, vector<int>> ind;

vector<pair<int, int>> g[8 * N];

void dfs(int cur) {
	used[cur] = 1;
	while (!g[cur].empty()) {
		int ind = (g[cur].back().first);
		if (alive[ind]) {
			alive[ind] = 0;
			dfs(cur ^ ed[ind]);
		}
		if (!g[cur].empty()) g[cur].pop_back();
	}
	ie.push_back(cur);
}

void init() {
	pe = 0;
	for (int i = 0; i < gsz; i++) {
		used[i] = 0;
		g[i].clear();
	}
	cnt.clear();
	ind.clear();
}

void ae(int u, int v, int I) {
	if (u < v) {
	    //cerr << "up " << u << ' ' << v << ' ' << I << endl;
		ind[{u, v}].push_back(I);
	}
    //cerr << u << ' ' << v << endl;
	ed[pe] = (u ^ v);
	alive[pe] = 1;
	g[u].push_back({pe, I});
	pe++;
	cnt[{u, v}]++;
}

int et(int st) {
	//cerr << "st " << st << endl;
	assert(st != -1);
	ie.clear();
	dfs(st);
	reverse(ie.begin(), ie.end());
	/*cerr << "et\n";
	for (auto t : ie) {
		cerr << t << ' ';
	}
	cerr << endl;*/
	int ok = 1; 
	map<pair<int, int>, int> now;
	for (int i = 0; i + 1 < (int)ie.size(); i++) {
		int u = ie[i];
		int v = ie[i + 1];
		now[{u, v}]++;
		ok &= (cnt[{u, v}] >= now[{u, v}]); 	
	}
	if (!ok) {
		return 0;
	}
	return 1;
}

int check(int X) {
	int st = -1;
	int en = -1;
	vector<int> v;
	for (int i = 0; i < n; i++) {
		if (pf[i] > X) {
			if (st != -1) return 0;
			st = i;
		}
		if (su[i] > X) {
			if (en != -1) return 0;
			en = i;
		}
		if (pf[i] <= X) {
			v.push_back(X - pf[i]);
			v.push_back(pf[i]);
		}
		if (su[i] <= X) {
			v.push_back(X - su[i]);
			v.push_back(su[i]);
		}
		//cerr << pf[i] << ' ' << su[i] << endl;
	}
	//cerr << "st en " << st << ' '<< en << endl;  
	if (st == en) return 0;


	sort(v.begin(), v.end());
	v.resize(unique(v.begin(), v.end()) - v.begin());
	auto gi = [&](int x) {
		return lower_bound(v.begin(), v.end(), x) - v.begin();
		return x;
	};

	//cerr << "g" << endl;

	int sz = (int)v.size();
	gsz = 2 * sz;
	init();
	
	for (int i = 0; i < n; i++) {
		if (i != st && i != en) ae(gi(pf[i]), sz + gi(su[i]), i);	
	}
	for (auto x : v) {
		ae(sz + gi(x), gi(X - x), -1);
	}
	need = n - (st != -1) - (en != -1);

    if (st == -1) {
    	st = 0;
    }
    if (!et(gi(X - su[st]))) {
    	return 0;
    }        
    int c = 0;
    c += (st != -1);
    c += (en != -1);
    for (int i = 0; i + 1 < (int)ie.size(); i++) {
     	int u = ie[i];
     	int v = ie[i + 1];
     	if (u < v) c++;
    }
    if (c == n) {
    	cout << "Yes\n";
    	if (st != -1) cout << st + 1 << ' ';
    	for (int i = 0; i + 1 < (int)ie.size(); i++) {
     		int u = ie[i];
     		int v = ie[i + 1];
     		if (u < v) {
     			//cerr << ind[{u, v}].size() << endl;
     			cout << ind[{u, v}].back() + 1 << ' ';
     			ind[{u, v}].pop_back();
     		}
    	}
    	if (en != -1) cout << en + 1 << '\n';
    	exit(0);
    }
    return 0;
}               

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("test", "r", stdin);
	#endif

	/*{
		gsz = 4;
		init();
		ae(1, 2, 1);
		ae(2, 3, 2);
		ae(3, 4, 3);
		ae(4, 1, 4);         
		int can = et();
		cout << can << endl;
		exit(0);
		for (auto t : ans) {
			cout << t << '\n';
		}
		exit(0);
	}*/

	cin >> n;
	for (int i = 0; i < n; i++) {
		int m, S;
		cin >> m >> S;
		vector<int> v(m);
		for (auto &t : v) {
			cin >> t;
		}
		pf[i] = v.front();
		su[i] = S - v.back();
	}
	//check(5);
	//return 0;
	for (int i = 1; i <= 200; i++) {
		check(i);
	}
	cout << "No\n";
}
