#include <bits/stdc++.h>

using namespace std;

mt19937 rng(10);                    

const int N = 10;

int cnt[4];
int a[N][N];

int n, m, c;
int sw;
vector<int> pos;

void gen(int i, int j) {
	if (i == n) {
		if (!sw) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					cout << a[i][j] << ' ';
				}
				cout << endl;
			}
		} else {
			for (int j = 0; j < m; j++) {
				for (int i = 0; i < n; i++) {
					cout << a[i][j] << ' ';
				}
				cout << endl;
			}
		}
		exit(0);
	}
	shuffle(pos.begin(), pos.end(), rng);
	sort(pos.begin(), pos.end(), [&](int i, int j) {
		return cnt[i] < cnt[j];
	});
	for (auto r : pos) {
		int ok = 1;
		a[i][j] = r;
		for (int ti = 0; ti < i; ti++) {
			for (int tj = 0; tj < j; tj++) {
				if (a[ti][tj] == a[i][j] && a[ti][j] == a[i][j] && a[i][tj] == a[i][j]) ok = 0;
			}
		}
		if (ok) {
			cnt[r]++;
			int ni = i;
			int nj = j + 1;
			if (nj == m) {
				ni++;
				nj = 0;
			}
			gen(ni, nj);
			cnt[r]--;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("test", "r", stdin);
	freopen("ans_10", "w", stdout);
	#endif

	cin >> n >> m >> c;
	if (n < m) {
		swap(n, m);
		sw = 1;
	}
	for (int i = 1; i <= c; i++) pos.push_back(i);
	gen(0, 0);	
}
