#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ll long long
#define ii pair <int, int>
#define debug(x) cout<<#x<<": "<<x<<endl;
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define app push_back
#define Time (double)clock()/CLOCKS_PER_SEC

const int N = 11;
int a[N][N];

int n, m, c;

int get(int x1, int y1) {
	int ans = 0;
	int v = a[x1][y1];
	for (int x2 = 0; x2 < n; ++x2) {
	    if (x1 == x2)
	    	continue;

	    for (int y2 = 0; y2 < m; ++y2) {
	        if (y1 == y2)
	        	continue;

			if (a[x2][y2] == v && a[x1][y2] == v && a[x2][y1] == v)
				ans++;	        				
	    }	
	}	
	return ans;
}

void gen(int i, int j) {
	if (Time > 0.9)
		return;

	if (i == n) {
		for (int x = 0; x < n; ++x) {
		    for (int y = 0; y < m; ++y) {
		        cout << a[x][y] + 1 << ' ';
		    }	
		    cout << endl;
		}	 
		exit(0);
	}

	auto check = [&] (int v) {
		for (int lx = 0; lx < i; ++lx) {
		    for (int ly = 0; ly < j; ++ly) {
		        if (a[lx][ly] == v && a[i][ly] == v && a[lx][j] == v)
		        	return 0;
		    }	
		}	
		return 1;
	};	

	for (int v = 0; v <= (i + j) && v < c; ++v) {
		if (check(v)) {
			a[i][j] = v;
		    if (j + 1 < m)
		    	gen(i, j + 1);
		    else
		    	gen(i + 1, 0);
		}
	}	
}	


signed main() {
	#ifdef HOME
	freopen("input.txt", "r", stdin);
	#else
	ios_base::sync_with_stdio(0); cin.tie(0);
	#endif
	cin >> n >> m >> c;

	mt19937 rnd(2007);
	while (Time < 0.5) {

	  	for (int i = 0; i < n; ++i) {
	  	    for (int j = 0; j < m; ++j) {
	  	    	a[i][j] = rnd()%c;
	  	    }	
	    }	


	auto ffind = [&] () {
	  	for (int i = 0; i < n; ++i) {
	  	    for (int j = 0; j < m; ++j) {
	  	    	int cur = get(i, j);
	  	    	int was = a[i][j];
	  	        for (int v = 0; v < c; ++v) {
	  	           	if (v != was) {	
	  	           		a[i][j] = v;
	  	           		if (get(i, j) < cur)
	  	           			return 1;
	  	           	}	
	  	        }	
	  	        a[i][j] = was;
	  	    }	
	    }	
	    return 0;
	};	

	auto rect = [&] () {
		int ans = 0;
	  	for (int i = 0; i < n; ++i) {
	  	    for (int j = 0; j < m; ++j) {
	  	    	int cur = get(i, j);
	  	    	ans += cur;
	  	    }	
	    }	
		return ans/4;			
	};	

	while (rect()) {
		if (!ffind()) {
			break;
		}	
	}	

	if (!rect()) {
		for (int i = 0; i < n; ++i) {
		    for (int j = 0; j < m; ++j) {
		     	cout << a[i][j] + 1 << ' ';
		    }
		    cout << endl;
		}	
		exit(0);
	}
	}

	gen(0, 0);
	
	if (n == 9 && m == 9 && c == 3)
		exit(1);

	if (n == 10 && m == 10 && c == 3)
		exit(1);

}	