from sys import exit
from collections import defaultdict
n = int(input())
frags = [list(map(int, input().split())) + [list(map(int, input().split()))] for _ in range(n)]

frags_edges = []

szx = None
starts = []
ends = []
for i, frag in enumerate(frags):
    starts.append([frag[2][0], i])
    ends.append([frag[1] - frag[2][-1], i])
    frags_edges.append([starts[-1][0], ends[-1][0]])
    if frag[0] >= 2:
        if szx is None: szx = frag[2][1] - frag[2][0]
        for j in range(1, frag[0]):
            if frag[2][j] - frag[2][j-1] != szx:
                print('No')
                exit()

if n == 1:
    print('Yes')
    print('1')
    exit()

if szx is None:
    req = None
else:
    req = szx
szx = []
starts.sort()
ends.sort(reverse=True)
for i in range(2):
    for j in range(2):
        newsize = starts[i][0] + ends[j][0]
        bdi, bdj = i, j
        k, l = i+1, j+1
        running = check = True if req is None else newsize == req
        while max(k, l) < n and running:
            sm = starts[k][0] + ends[l][0]
            if sm == newsize:
                k += 1
                l += 1
            else:
                if sm > newsize:
                    if bdj:
                        running = False
                        check = False
                    bdj += 1
                    l += 1
                else:
                    if bdi:
                        running = False
                        check = False
                    bdi += 1
                    k += 1
        if check:
            szx.append(newsize)

if szx == []:
    print('No')
    exit()

for size in szx:
    diff_starts = set()
    starts_d = defaultdict(list)
    for el in starts:
        starts_d[el[0]].append(el[1])
        diff_starts.add(el[0])
    diff_ends = set()
    ends_d = defaultdict(list)
    for el in ends:
        ends_d[el[0]].append(el[1])
        diff_ends.add(el[0])
    diff_starts = sorted(diff_starts)
    diff_ends = sorted(diff_ends, reverse=True)
    for start in sorted(diff_starts):
        end_f = size - start
        if len(starts_d[start]) > len(ends_d[end_f]):
            break
    for end in diff_ends:
        start_f = size - end
        if len(starts_d[start_f]) < len(ends_d[end]):
            break
    start_vertex = starts_d[start].pop()
    res = [start_vertex]
    while starts_d[size - frags_edges[res[-1]][1]]:
        res.append(starts_d[size - frags_edges[res[-1]][1]].pop())
    if len(res) == n:
        print('Yes')
        print(*map(lambda x: x + 1, res))
        exit()
    i = 0
    while i < len(res):
        if starts_d[size - frags_edges[res[i]][1]]:
            starts_d[size - frags_edges[res[i]][1]].insert(0, res[i+1])
            qres = [res[i]]
            while starts_d[size - frags_edges[qres[-1]][1]]:
                qres.append(starts_d[size - frags_edges[qres[-1]][1]].pop())
            res = res[:i] + qres + res[i+2:]
        else:
            i += 1
    if len(res) == n:
        print('Yes')
        print(*map(lambda x: x + 1, res))
        exit()

print('No')
