#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int md = 1e9 + 7;
const int N = 5e5 + 7;

int f[N], fi[N];

void add(int &a, int b) {
 	a += b;
 	if (a >= md) a -= md;
}

void sub(int &a, int b) {
	a -= b;
	if (a < 0) a += md;
}

int mul(int a, int b) {
	return ((ll)a * b) % md;
}

int power(int a, ll b) {
 	int res = 1;
 	while (b > 0) {
 		if (b & 1) res = mul(res, a);
 		a = mul(a, a);
 		b >>= 1;
   }
   return res;
}

int inv(int a) {
	return power(a, md - 2);
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	f[0] = 1;
	for (int i = 1; i < N; ++i) f[i] = mul(f[i - 1], i);
	fi[N - 1] = inv(f[N - 1]);
	for (int i = N - 2; i >= 0; --i) fi[i] = mul(fi[i + 1], i + 1);
	string a, b, c;
	cin >> a >> b >> c;
	int n = a.size();
	vector <vector <int>> cnt(2, vector <int> (2));
	for (int i = 0; i < n; ++i) {
	 	int d1 = a[i] - '0', d2 = b[i] - '0', d3 = c[i] - '0';
	 	bool ok = false;
	 	for (int d = 0; d <= 1; ++d) {
	 	 	if ((d1 + d2 + d) % 10 == d3) {
	 	 		ok = true;
	 	 		int f = (d1 + d2 + d) >= 10;
	 	 		++cnt[f][d];
           	}
	 	}
		//cout << d1 << ' '<< d2 << ' ' << d3 << endl;
	 	if (!ok) {
	 		cout << "0\n";
	 		return 0;
	   	}	
	}
	if (cnt[1][0] != cnt[0][1]) {
		cout << "0\n";
		return 0;
	}
	if (cnt[1][0] == 0 && cnt[1][1] > 0) {
		cout << "0\n";
		return 0;
	}

	int cc = cnt[0][1];
	int ans = mul(f[cc], f[cc]);
	if (cnt[1][1] > 0) ans = mul(ans, mul(f[cc + cnt[1][1] - 1], fi[cc - 1]));
	ans = mul(ans, mul(f[cc + cnt[0][0]], fi[cc]));

	for (int i = 0; i < n; ++i) {
	 	int d1 = a[i] - '0', d2 = b[i] - '0', d3 = c[i] - '0';
	 	int gol, gor;
	 	for (int d = 0; d <= 1; ++d) {
	 	 	if ((d1 + d2 + d) % 10 == d3) {
	 	 		int f = (d1 + d2 + d) >= 10;
	 	 		gol = f;
	 	 		gor = d;
           	}
	 	}
		if ((d1 == 0 || d2 == 0 || d3 == 0) && gol == 0) {
			int cur = 0;
			if (gor == 0) {
				--cnt[0][0];
				int cc = cnt[0][1];
				cur = mul(f[cc], f[cc]);
				if (cnt[1][1] > 0) cur = mul(cur, mul(f[cc + cnt[1][1] - 1], fi[cc - 1]));
				cur = mul(cur, mul(f[cc + cnt[0][0]], fi[cc]));
				++cnt[0][0];
		 	} else {
		 		int cc = cnt[0][1];
				cur = mul(f[cc - 1], f[cc]);
				if (cnt[1][1] > 0) cur = mul(cur, mul(f[cc + cnt[1][1] - 1], fi[cc - 1]));
				cur = mul(cur, mul(f[cc + cnt[0][0] - 1], fi[cc - 1]));
		 	}
		 	sub(ans, cur);
		}
	}

	cout << ans << '\n';
}	