def sum_seq(fr, to, cnt=None):
    if cnt is None:
        cnt = to - fr + 1
    return (to + fr) * (cnt // 2) + (to + fr) // 2 * (cnt % 2)


def search_v_f(n, m, i):
    return abs(sum_seq(1, i - 1 + m * (n - 1), n * (i - 1)) - sum_seq(i, m * n, n * (m - i + 1)))


def search_v(nn, mm):
    r = mm
    l = 1
    while r - l > 1:
        m = (r + l) // 2
        if search_v_f(nn, mm, r) > search_v_f(nn, mm, l):
            r = m
        else:
            l = m
    return r

def search_h_f(n, m, i):
    return abs(sum_seq(1, i * m, m ) - sum_seq(i, m * n, n * (m - i + 1)))


def search_h(nn, mm):
    r = mm
    l = 1
    while r - l > 1:
        m = (r + l) // 2
        if search_v_f(nn, mm, r) > search_v_f(nn, mm, l):
            r = m
        else:
            l = m
    return r


for _ in range(int(input())):
    n, m = map(int, input().split())
    step_base = sum_seq(0, n - 1) * m
    all = sum_seq(1, n * m)
    idx = search_v(n, m)
    res = 'V ' + str(idx)
    res_val = search_v_f(n, m, idx)
    for i in range(n // 2, n + 1):
        start = sum_seq(1, m * i, m * i)
        if res_val == -1 or res_val > abs(all - start - start):
            res = 'H ' + str(i + 1)
            res_val = abs(all - start - start)
    print(res)
