#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn = 2e6 + 1;
const ll mod = 1e9 + 7;

ll fact[maxn];

ll powp(ll x, ll p) {
    if (p == 0) return 1;
    if (p == 1) return x;
    ll ansx = powp(((x * x) % mod + mod) % mod, p / 2);
    if (p % 2 == 0) {
        //cout << "@x=" << x << " p=" << p << ": " << ansx << "\n";
        return ansx;
    }
    //cout << "@x=" << x << " p=" << p << ": " << ((ansx * x) % mod + mod) % mod << "\n";
    return ((ansx * x) % mod + mod) % mod;
}

ll split(ll a, ll x) {
    if (a == 0) return 1;
    if (x == 0) {
        exit(1);
    }
    x--;
    //cout << a << " " << x << " FIND!\n";
    ll ans = fact[a + x];
    ll tms = powp(fact[x], mod - 2);
    //cout << ans << " " << tms << " " << fact[x] << "!\n";
    return ((ans * tms) % mod + mod) % mod;
}
int main() {
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();

    int a = 0, b = 0, c = 0, d = 0;
    for (int i = 0; i < n; i++) {
        int x = s1[i] - '0', y = s2[i] - '0', z = s3[i] - '0';
        int cR = 0;
        if ((x + y) % 10 != z) {
            cR = 1;
            if ((x + y + 1) % 10 != z) {
                cout << 0;
                return 0;
            }
        }
        int cD = 0;
        if (x + y + cR >= 10) cD = 1;

        int t = cR * 2 + cD;
        if (t == 0) { //a
            a++;
        }
        if (t == 1) {
            b++;
        }
        if (t == 2) {
            c++;
        }
        if (t == 3) {
            d++;
        }
    }
    //cout << a << " " << b << " " << c << " " << d << "\n";

    if (c != b) {
        cout << 0;
        return 0;
    }

    //cout << powp(2, mod - 2) << "\n";
    //return 0;
    fact[0] = 1;
    fact[1] = 1;
    //cout << "factorials : ";
    for (int i = 2; i <= 2 * n; i++) {
        fact[i] = ((fact[i - 1] * i) % mod + mod) % mod;
        //cout << fact[i] << " ";
    }
    //cout << '\n';

    ll x = split(a, c + 1);
    ll y = split(d, c);
    //cout << x << " " << y << "\n";
    ll ans = x;
    ans = ((ans * y) % mod + mod) % mod;
    ans = ((ans * fact[c]) % mod + mod) % mod;
    ans = (((ans * fact[b]) % mod) + mod) % mod;

    cout << ans;
}
