#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 1e5;
ll n, m;
ll sumArifm(ll start, ll d, ll cnt) {
	return start * cnt + (cnt * (cnt - 1)) / 2 * d;
}
ll getCol(ll num) {
	ll sumCol = sumArifm(1, m, n);
	ll sumCnt = sumArifm(sumCol, +n, num);

	return sumCnt;
}
ll getOtherCol(ll num) {
	return sumArifm(1, 1, n * m) - getCol(num);
}

ll fCol(ll num) {
	return llabs(getCol(num) - getOtherCol(num));
}

ll getRow(ll num) {
	ll sumRow = sumArifm(1, 1, m);
	ll sumCnt = sumArifm(sumRow, +m * m, num);
	// debug(sumRow << ' ' << sumCnt)
	return sumCnt;
}
ll getOtherRow(ll num) {
	return sumArifm(1, 1, n * m) - getRow(num);
}
ll fRow(ll num) {
	return llabs(getRow(num) - getOtherRow(num));
}
void solve() {
	ll minAnsw = 1e18;
	ll minRow = -1, minCol = -1;
	{
		ll l = 0, r = m + 1;
		while (r - l > 1) {
			ll tm = (l + r) / 2;
			if (getCol(tm) < getOtherCol(tm)) {
				l = tm;
			}
			else {
				r = tm;
			}
		}
		if (fCol(l) < minAnsw) {
			minCol = l + 1;
			minRow = -1;
			minAnsw = fCol(l);
		}

		if (fCol(r) < minAnsw) {
			minCol = r + 1;
			minRow = -1;
			minAnsw = fCol(r);
		}	
	}
	{
		ll l = 0, r = n + 1;
		while (r - l > 1) {
			ll tm = (l + r) / 2;

			if (getRow(tm) < getOtherRow(tm)) {
				l = tm;
			}
			else {
				r = tm;
			}
		}
		// debug("KEK")
		// debug(l << ' ' << getRow(l) << ' ' << getRow(l + 1))
		// debug(fRow(l) << ' ' << fRow(r))
		if (fRow(l) < minAnsw) {
			minCol = -1;
			minRow = l + 1;
			minAnsw = fRow(l);
		}

		if (fRow(r) < minAnsw) {
			minCol = -1;
			minRow = r + 1;
			minAnsw = fRow(r);
		}	
	}
	// debug(minAnsw)
	if (minRow == -1) {
		minCol = std::min(minCol, m);
		minCol = std::max(minCol, 1LL);

		std::cout << "V " << minCol << '\n';
	}
	if (minCol == -1) {
		minRow = std::min(minRow, n);
		minRow = std::max(minRow, 1LL);

		std::cout << "H " << minRow << '\n';
	}
}

int main() {
	ll t;
	std::cin >> t;
	while(t--) {
		std::cin >> n >> m;

		solve();
	}
}	