#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 2e5 + 10;
const int mod = 1e9 + 7;
std::string a[N];
ll cnt[2][2];

ll add(ll a, ll b) {
	return (a + b) % mod;
}
ll mul(ll a, ll b) {
	return a * b % mod;
}
ll fact[N], rev[N];
ll bin_p(ll a, ll b) {
	if (!b) return 1;
	if (b % 2 == 0) {
		ll cur = bin_p(a, b / 2);
		return mul(cur, cur);
	}
	return mul(a, bin_p(a, b - 1));
}
ll toRev(ll x) {
	return bin_p(x, mod - 2);
}
ll solve1(ll cnt00, ll cnt01, ll cnt10, ll cnt11) {
	if (cnt01 != cnt10) {
		return 0;
	}
	if (cnt01 == 0) {
		if (cnt11 != 0) {
			return 0;
		}

		return fact[cnt00];
	}
	// debug(cnt[0][1])
	// debug(cnt[1][0])

	ll cnt1 = fact[cnt01];
	ll cnt2 = fact[cnt10];
	ll check1 = mul(fact[cnt00 + cnt01], rev[cnt01]);
	ll check2 = mul(fact[cnt11 + cnt01 - 1], rev[cnt01 - 1]);

	return mul(mul(cnt1, cnt2), mul(check1, check2));
}
ll solve2(ll cnt00, ll cnt01, ll cnt10, ll cnt11) {
	if (cnt01 != cnt10 + 1) {
		return 0;
	}
	if (cnt01 == 0) {
		return 0;
	}

	ll cnt1 = fact[cnt01];
	ll cnt2 = fact[cnt10];
	ll check1 = mul(fact[cnt00 + cnt01 - 1], rev[cnt01 - 1]);
	ll check2 = mul(fact[cnt11 + cnt01 - 1], rev[cnt01 - 1]);

	return mul(mul(cnt1, cnt2), mul(check1, check2));
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	fact[0] = 1;
	for (int i = 1; i < N; ++i) {
		fact[i] = mul(fact[i - 1], i);
	}
	FOR(i, N) {
		rev[i] = toRev(fact[i]);
	}

	FOR(i, 3) {
		std::cin >> a[i];
	}
	// debug(a[0] << ' ' << a[1] << ' ' << a[2])
	FOR(i, a[0].size()) {
		int t1 = a[0][i] - '0', t2 = a[1][i] - '0', t3 = a[2][i] - '0';
		// debug(t1 << ' ' << t2 << ' ' << t3)
		
		int check = (t1 + t2) % 10;

		if (check == t3) {
			cnt[0][(t1 + t2) / 10]++;
		}
		else if ((check + 1) % 10 == t3) {
			cnt[1][(t1 + t2 + 1) / 10]++;
		}
		else {
			std::cout << 0;
			return 0;
		}
	}
	ll answ = 0;
	FOR(i, a[0].size()) {
		int t1 = a[0][i] - '0', t2 = a[1][i] - '0', t3 = a[2][i] - '0';

		if (t1 != 0 && t2 != 0 && t3 != 0) {
			int check = (t1 + t2) % 10;

			int realS = t1 + t2;
			if (check != t3) {
				realS++;
			}

			if (realS / 10 != 0) {
				continue;
			}

			// debug(i)

			if (check != t3) {
				answ = add(answ, solve2(cnt[0][0], cnt[0][1], cnt[1][0] - 1, cnt[1][1]));
			} // 01
			else {
				answ = add(answ, solve1(cnt[0][0] - 1, cnt[0][1], cnt[1][0], cnt[1][1]));
			} // 00
		}
	}
	std::cout << answ;
}