#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 7e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
ll q;

bool check(ll n) {
	vector <ll> a;
	while (n) {
		a.push_back(n % 10);
		n /= 10;
	}
	if (a.size() == 1) return true;
	if (set <ll>(a.begin(), a.end()).size() == 1) return true;
	if (a.back() != a[a.size() - 2]) {
		ll ptr = a.size() - 3;
		while (ptr >= 0) {
			if (a[ptr] != a[a.size() - 2]) return false;
			--ptr;
		}
		return true;
	}
	return false;
}

ll build(vector <ll>& a) {
	ll n = a.back();
	for (int i = a.size() - 2; i >= 0; --i) {
		n = n * 10 + a[a.size() - 2];
	}
	return n;
}

bool check2(ll n) {
	vector <ll> a;
	while (n) {
		a.push_back(n % 10);
		n /= 10;
	}
	ll ptr = a.size() - 1;
	while (a[ptr] >= 0 && a[ptr] == a.back()) {
		--ptr;
	}
	if (ptr == -1) return true;
	ll ptr2 = ptr - 1;
	while (ptr2 >= 0 && a[ptr2] == a.back()) {
		--ptr2;
	}
	return ptr2 == -1;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll beg = clock();

	cin >> n;
	ll x;
	cin >> x;
	if (x == 0) {
		vector <ll> a;
		ll nn = n;
		while (n) {
			a.push_back(n % 10);
			n /= 10;
		}
		ll newnum = 0;
		for (int i = 0; i < a.size(); ++i) {
			newnum = newnum * 10 + a.back();
		}
		if (newnum >= nn) {
			cout << newnum << '\n';
		}
		else {
			if (a.back() == 9) {
				a.pop_back();
				a.push_back(0);
				a.push_back(1);
			}
			else {
				a.back() += 1;
			}
			ll newnum = 0;
			for (int i = 0; i < a.size(); ++i) {
				newnum = newnum * 10 + a.back();
			}
			cout << newnum << '\n';
		}
		return 0;
	}
	else if (x == 1) {
		while (!check(n) && !check2(n)) ++n;
		cout << n << '\n';
	}

	cerr << "Proccess terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";
	
	return 0;
}
/*
30 12 7
18 1 2021
*/