#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = int;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e9 + 10;
const long long mod = 1e9 + 7;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
ll q;

inline ll add(ll a, ll b) {
	a += b;
	if (a >= mod) a -= mod;
	return a;
}

inline void addr(ll& a, ll b) {
	a += b;
	if (a >= mod) a -= mod;
}

bool check(vector <vector <ll>> a) {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			for (int k = i + 1; k < n; ++k) {
				for (int l = j + 1; l < m; ++l) {
					if (a[i][j] == a[i][l] && a[i][j] == a[k][j] &&
						a[i][j] == a[k][l]) {
						//						cout << "Failed:\n";
						//						cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << ' ' << l + 1 << '\n';
						return false;
					}
				}
			}
		}
	}
	return true;
}

vector <vector <ll>> kek
{
	{ 1, 1, 2, 2, 3, 3 },
	{ 1, 2, 2, 3, 3, 1 },
	{ 2, 2, 3, 3, 1, 1 },
	{ 2, 3, 3, 1, 1, 2 },
	{ 3, 3, 1, 1, 2, 2 },
	{ 3, 1, 1, 2, 2, 3 }
};

vector <vector <ll>> lol
{
	{ 1, 1, 2, 1, 2, 2 },
	{ 1, 2, 1, 2, 1, 2 },
	{ 2, 1, 1, 2, 2, 1 },
	{ 2, 2, 2, 1, 1, 1 }
};


/*
types:
0: straight up ok
1: takes 1 and keeps it
2: only gives 1
3: takes 1 and gives away 1
*/

ll cnt = 0;
vector <vector <ll>> cur;
void go() {
	if (cnt == n * m) {
		if (check(cur)) {
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					cout << cur[i][j] << ' ';
				}
				cout << '\n';
			}
			cout << '\n';
			exit(0);
		}
		return;
	}
	cur[cnt / m][cnt % m] = 1;
	++cnt;
	go();
	--cnt;
	cur[cnt / m][cnt % m] = 2;
	++cnt;
	go();
	--cnt;
	cur[cnt / m][cnt % m] = 3;
	++cnt;
	go();
	--cnt;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll beg = clock();

	ll c;
	cin >> n >> m >> c;
	cur.resize(n, vector <ll>(m));
	if (n == 4 && m <= 6) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				cout << lol[i][j] << ' ';
			}
			cout << '\n';
		}
	}
	else if (m == 4 && n <= 6) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				cout << lol[j][i] << ' ';
			}
			cout << '\n';
		}
	}
	else if (mmin(n, m) == 3 && mmax(n, m) <= 6 || mmin(n, m) == 2) {
		for (ll mask = 0; mask < (1 << n * m); ++mask) {
			vector <vector <ll>> a(n, vector <ll>(m));
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					a[i][j] = ((mask >> (m * i + j)) & 1) + 1;
				}
			}
			if (check(a)) {
				for (auto& x : a) {
					for (auto& y : x) {
						cout << y << ' ';
					}
					cout << '\n';
				}
				cout << '\n';
				return 0;
			}
		}
	}
	else {
		if (mmax(n, m) <= 6) {
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					cout << kek[i][j] << ' ';
				}
				cout << '\n';
			}
		}
		else {
			if (n == 3) {
				for (int i = 0; i < m; ++i) {
					cout << 1 << ' ';
				}
				cout << '\n';
				for (int i = 0; i < m; ++i) {
					cout << 2 << ' ';
				}
				cout << '\n';
				for (int i = 0; i < m; ++i) {
					cout << 3 << ' ';
				}
				cout << '\n';
				return 0;
			}
			if (m == 3) {
				for (int i = 0; i < n; ++i) {
					cout << 1 << ' ' << 2 << ' ' << 3 << '\n';
				}
				return 0;
			}
			if (n == 4 && m == 7) {
				for (int i = 0; i < 7; ++i) {
					cout << 1 << ' ';
				}
				cout << '\n';
				cout << 1 << " 2 2 2 2 2 3\n";
				cout << "2 3 3 1 2 3 3\n";
			}
			else if (n == 7 && m == 4) {
				cout << "2 2 1 1\n";
				cout << "3 1 2 1\n";
				cout << "3 2 2 1\n";
				cout << "1 3 2 1\n";
				cout << "2 3 2 1\n";
				cout << "3 3 2 1\n";
				cout << "3 2 3 1\n";
			}
			go();
		}
	}


	cerr << "Proccess terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";

	return 0;
}
/*
123
123
246

01
02
03

01211
12099
23300

121
214
999
*/