//
// Created by olymp on 16.01.2021.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

template <typename T>
using vec = vector<T>;

#define int __int128

int n, m;

int sumh(int i) {
  return (i * m + 1) * i * m / 2;
}

int sumv(int i) {
  int one = (1 + 1 * m * (n - 1) + 1) * n / 2;
  return one * i + i * (i - 1) / 2 * n;
}

istream& operator>>(istream& in, __int128 &a) {
  ll t;
  in >> t;
  a = t;
  return in;
}

ostream& operator<<(ostream &out, __int128 a) {
  out << ll(a);
  return out;
}

int ans = INT64_MAX;
char chans = 'V';
int at = 0;

void chkans(int pos, char tp) {
  int cans = int(INT64_MAX) * int(1'000'000'000);
  if (tp == 'H') {
    cans = abs(2 * sumh(pos) - sumh(n));
  } else {
    cans = abs(2 * sumv(pos) - sumv(m));
  }
  if (cans < ans) {
    ans = cans;
    at = pos;
    chans = tp;
  }
}

void run() {
  ans = int(INT64_MAX) * int(1'000'000'000);
  cin >> n >> m;

  int l = 0;
  int r = m + 1;
  while (l + 1 < r) {
    int mid = (l + r) / 2;
    int cr = 2 * sumv(mid) - sumv(m);
//    cerr << sumv(mid) << ' ' << sumv(m) - sumv(mid) << endl;
    if (cr > 0) {
      r = mid;
    } else {
      l = mid;
    }
  }
  chkans(l, 'V');
  chkans(l + 1, 'V');
 l = 0;
  r = n + 1;
  while (l + 1 < r) {
    int mid = (l + r) / 2;
    int cr = 2 * sumh(mid) - sumh(n);
//    cerr << sumh(mid) << ' ' << sumh(n) - sumh(mid) << endl;
    if (cr > 0) {
      r = mid;
    } else {
      l = mid;
    }
  }
  chkans(l, 'H');
  chkans(l + 1, 'H');
  cout << char(chans) << ' ' << ll(at) + 1 << '\n';
//  cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  int t = 1;
  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}