//
// Created by olymp on 16.01.2021.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

template <typename T>
using vec = vector<T>;

#define int ll

string compress(string &s) {
  int cr = 1;
  string ans;
  for (int i = 1; i < s.size(); i++) {
    if (s[i] == s[i - 1])
      cr++;
    else {
      if (cr != 1)
        ans += to_string(cr);
      ans += s[i - 1];
      cr = 1;
    }
  }
  if (cr != 1)
    ans += to_string(cr);
  ans += s.back();
  return ans;
}

void run() {
  string s;
  cin >> s;
  int n = s.size();
//  int n = s.size();
  int cr = 0;
  string t;
  for (int i = 0; i < n; i++) {
    if (isdigit(s[i])) {
      cr = cr * 10 + s[i] - '0';
    } else {
      if (cr == 0) cr = 1;
      t += string(cr, s[i]);
      cr = 0;
    }
  }
  int ans1 = INT64_MAX, ans2 = 0;
  string sans1, sans2;
  tuple<int, int, char> tans1, tans2;
  string all = "AGCT";
  for (int i = 0; i < t.size(); i++) {
    string c;
    for (int j = 0; j < i; j++) {
      c.push_back(t[j]);
    }
    for (int j = i + 1; j < t.size(); j++) {
      c.push_back(t[j]);
    }
    c = compress(c);
    if (c.size() < ans1) {
      ans1 = c.size();
      tans1 = {2, i + 1, ' '};
      sans1 = c;
    }
    if (c.size() > ans2) {
      ans2 = c.size();
      tans2 = {2, i + 1, ' '};
      sans2 = c;
    }
    for (auto rp : all) {
      c.clear();
      for (int j = 0; j < i; j++) {
        c.push_back(t[j]);
      }
      c.push_back(rp);
      for (int j = i; j < t.size(); j++) {
        c.push_back(t[j]);
      }
      c = compress(c);
      if (c.size() < ans1) {
        ans1 = c.size();
        tans1 = {1, i, rp};
        sans1 = c;
      }
      if (c.size() > ans2) {
        ans2 = c.size();
        tans2 = {1, i, rp};
        sans2 = c;
      }
      c.clear();
      for (int j = 0; j < i; j++) {
        c.push_back(t[j]);
      }
      c.push_back(rp);
      for (int j = i + 1; j < t.size(); j++) {
        c.push_back(t[j]);
      }
      c = compress(c);
      if (c.size() < ans1) {
        ans1 = c.size();
        tans1 = {3, i + 1, rp};
        sans1 = c;
      }
      if (c.size() > ans2) {
        ans2 = c.size();
        tans2 = {3, i + 1, rp};
        sans2 = c;
      }
    }
  }
  auto [a, b, c] = tans1;
  cout << a << ' ' << b << ' ' << c << '\n';
  tie(a, b, c) = tans2;
  cout << a << ' ' << b << ' ' << c << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  int t = 1;
//  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}