//
// Created by olymp on 18.01.2021.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

template <typename T>
using vec = vector<T>;

#define int ll

bool check(vec<vec<int>> &a) {
  bool ok = true;
  for (int i = 0; i < a.size(); i++) {
    for (int j = 0; j < a[i].size(); j++) {
      for (int x = i + 1; x < a.size(); x++) {
        for (int y = j + 1; y < a[x].size(); y++) {
          ok = ok && (a[i][j] != a[i][y] || a[i][j] != a[x][j] || a[i][j] != a[x][y]);
        }
      }
    }
  }
  if (ok) {
    for (auto &rw : a) {
      for (auto &el : rw) {
        cout << el << ' ';
      }
      cout << '\n';
    }
    exit(0);
  }
  return ok;
}

void run() {
  int n, m, c;
  cin >> n >> m >> c;
  if (n == 2) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        cout << i + 1 << ' ';
      }
      cout << '\n';
    }
    return;
  }
  if (m == 2) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        cout << j + 1 << ' ';
      }
      cout << '\n';
    }
    return;
  }
  vec<vec<int>> a(n, vec<int>(m));
  if (c <= 2) {
    for (int shift = 0; shift < 4; shift++) {
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
          if ((i + j + shift) % 4 < 2) {
            a[i][j] = 1;
          } else {
            a[i][j] = 2;
          }
        }
      }
      check(a);
    }
  } else {
    if (n == 3) {
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
          cout << i + 1 << ' ';
        }
        cout << '\n';
      }
      return;
    } else if (m == 3) {
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
          cout << j + 1 << '\n';
        }
        cout << '\n';
      }
      return;
    }
    for (int shift = 0; shift < 6; shift++) {
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
          if ((i + j + shift) % 6 < 2) {
            a[i][j] = 1;
          } else if ((i + j + shift) % 6 < 4) {
            a[i][j] = 2;
          } else {
            a[i][j] = 3;
          }
        }
//        cout << "\n";
      }
      check(a);
    }
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  int t = 1;
//  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}