//
// Created by olymp on 18.01.2021.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

template <typename T>
using vec = vector<T>;

#define int ll

bool check(vec<vec<int>> &a) {
  bool ok = true;
  for (int i = 0; i < a.size(); i++) {
    for (int j = 0; j < a[i].size(); j++) {
      for (int x = i + 1; x < a.size(); x++) {
        for (int y = j + 1; y < a[x].size(); y++) {
          ok = ok && (a[i][j] != a[i][y] || a[i][j] != a[x][j] || a[i][j] != a[x][y]);
        }
      }
    }
  }
  if (ok) {
    for (auto &rw : a) {
      for (auto &el : rw) {
        cout << el << ' ';
      }
      cout << '\n';
    }
    exit(0);
  }
  return ok;
}

void rec(int n, int m, int c) {
  vec<vec<int>> a(n, vec<int>(m));
  for (int i = 0; i < m / 2; i++) {
    a[0][i] = 1;
  }
  for (int j = m / 2; j < m; j++) {
    a[0][j] = 2;
  }
  for (int i = 1; i < n; i++) {
    for (int j = 0; j < m; j++) {
      a[i][j] = a[i - 1][j];
      bool ok = true;
      for (int iter = 0; iter < c - 2; iter++) {
        for (int x = 0; x < i; x++) {
          for (int y = 0; y < j; y++) {
            if (a[i][j] == a[x][y] && a[i][j] == a[x][j] && a[i][j] == a[i][y]) {
              ok = false;
              break;
            }
          }
          if (!ok) break;
        }
        if (!ok) {
          a[i][j] = (a[i][j]) % c + 1;
        }
        if (ok) break;
        ok = true;
      }
    }
  }
  check(a);
}

void brute(int n, int m) {
  vec<vec<int>> a(n, vec<int>(m));
  for (int mask = 0; mask < (1 << (n * m)); mask++) {
    for (int i = 0; i < n * m; i++) {
      a[i / m][i % m] = ((mask >> i) & 1) + 1;
    }
    check(a);
  }
}

void run() {
  int n, m, c;
  cin >> n >> m >> c;
//  assert(c != 3);
  if (n * m <= 20) {
    brute(n, m);
  }
  if (c == 3) {
    if (n == 4 || m == 4) {
      vec<vec<int>> ans = {
          {1, 1, 2, 3},
          {1, 2, 1, 3},
          {1, 2, 3, 1},
          {2, 1, 3, 1},
          {2, 3, 1, 1},
          {2, 1, 1, 3},
          {2, 2, 1, 3},
          {2, 1, 2, 3},
          {2, 1, 3, 2},
          {1, 2, 3, 2}
      };
      if (m == 4) {
        for (int i = 0; i < n; i++) {
          for (int j = 0; j < m; j++) {
            cout << ans[i][j] << ' ';
          }
          cout << "\n";
        }
        return;
      } else {
        for (int i = 0; i < n; i++) {
          for (int j = 0; j < m; j++) {
            cout << ans[j][i] << ' ';
          }
          cout << "\n";
        }
        return;
      }
    }
  }
  if (n == 6 && m == 4) {
    cout << "1 1 2 2 \n"
            "1 2 1 2 \n"
            "2 1 1 2 \n"
            "1 2 2 1 \n"
            "2 1 2 1 \n"
            "2 2 1 1 ";
    return;
  }
  if (n == 4 && m == 6) {
    cout << "1 1 2 1 2 2\n"
            "1 2 1 2 1 2\n"
            "2 1 1 2 2 1\n"
            "2 2 2 1 1 1\n";
    return;
  }
  if (m == 4 && n == 5) {
    cout << "1 1 2 2\n"
            "1 2 2 1\n"
            "2 2 1 1\n"
            "2 1 1 2\n"
            "2 1 2 1\n";
    return;
  } else if (n == 4 && m == 5) {
    cout << "1 1 2 2 2\n"
            "1 2 2 1 1\n"
            "2 2 1 1 2\n"
            "2 1 1 2 1\n";
    return;
  }
  if (n == 2) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        cout << i + 1 << ' ';
      }
      cout << '\n';
    }
    return;
  }
  if (m == 2) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        cout << j + 1 << ' ';
      }
      cout << '\n';
    }
    return;
  }
  vec<vec<int>> a(n, vec<int>(m));
  if (c <= 2) {
    for (int shift = 0; shift < 4; shift++) {
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
          if ((i + j + shift) % 4 < 2) {
            a[i][j] = 1;
          } else {
            a[i][j] = 2;
          }
        }
      }
      check(a);
    }
    rec(n, m, c);
  } else {
    if (n == 3) {
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
          cout << i + 1 << ' ';
        }
        cout << '\n';
      }
      return;
    } else if (m == 3) {
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
          cout << j + 1 << '\n';
        }
        cout << '\n';
      }
      return;
    }
    if (min(n, m) <= 6  && max(n, m) <= 9) {
      a = {
          {1, 2, 3, 1, 2, 3, 1, 2, 3, 1},
          {2, 3, 1, 2, 3, 1, 2, 3, 1, 1},
          {3, 1, 2, 3, 1, 2, 3, 1, 2, 1},
          {1, 1, 1, 2, 2, 2, 3, 3, 3, 2},
          {2, 2, 2, 3, 3, 3, 1, 1, 1, 2},
          {3, 3, 3, 1, 1, 1, 2, 2, 2, 2}
      };
      if (n == 6) {
        for (int i = 0; i < n; i++) {
          for (int j = 0; j < m; j++) {
            cout << a[i][j] << ' ';
          }
          cout << '\n';
        }
        return;
      } else {
        for (int i = 0; i < n; i++) {
          for (int j = 0; j < m; j++) {
            cout << a[j][i] << ' ';
          }
          cout << '\n';
        }
        return;
      }
    }
    for (int shift = 0; shift < 6; shift++) {
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
          if ((i + j + shift) % 6 < 2) {
            a[i][j] = 1;
          } else if ((i + j + shift) % 6 < 4) {
            a[i][j] = 2;
          } else {
            a[i][j] = 3;
          }
        }
//        cout << "\n";
      }
      check(a);
    }
    rec(n, m, c);
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  int t = 1;
//  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}