//
// Created by olymp on 18.01.2021.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

template <typename T>
using vec = vector<T>;

#define int ll

void run() {
  string a, b, c;
  cin >> a >> b >> c;
  int n = a.size();
  if (n <= 18) {
    if (n <= 1) {
      vec<int> p(n);
      iota(p.begin(), p.end(), 0);
      int ans = 0;
      do {
        string ca = a, cb = b, cc = c;
        if (cc[p[0]] == '0' || ca[p[0]] == '0' || cb[p[0]] == '0') continue;
        for (int i = 0; i < n; i++) {
          ca[i] = a[p[i]];
          cb[i] = b[p[i]];
          cc[i] = c[p[i]];
        }
        if (stoll(ca) + stoll(cb) == stoll(cc)) {
          ans++;
        }
      } while (next_permutation(p.begin(), p.end()));
      cout << ans << '\n';
    } else {
      int N = (1 << n);
      vec<vec<int>> dp(N, vec<int>(2));
      vec<int> isp(n);
      vec<int> per(n);
      for (int i = 0; i < n; i++) {
        int ca = a[i] - '0';
        int cb = b[i] - '0';
        int cc = c[i] - '0';
        if ((ca + cb) % 10 != cc) {
          isp[i] = 1;
          if ((ca + cb + 1) % 10 != cc) {
            cout << "0\n";
            return;
          }
        } else {
          dp[(1 << i)][(ca + cb) / 10] = 1;
        }
        if ((ca + cb) >= 10)
          per[i] = 1;
      }
      for (int mask = 0; mask < N; mask++) {
        int cnt = __builtin_popcount(mask);
//      cerr << mask << ' ' << dp[mask][0] << ' ' << dp[mask][1] << endl;
        int ccc = 0;
        for (int i = 0; i < n; i++) {
          if (mask & (1 << i)) continue;
          int ca = a[i] - '0';
          int cb = b[i] - '0';
          int cc = c[i] - '0';
          if ((ca == 0 || cb == 0 || cc == 0))
            ccc++;
        }
        if (ccc == n - cnt)
          continue;
        for (int i = 0; i < n; i++) {
          if (mask & (1 << i)) continue;
          int ca = a[i] - '0';
          int cb = b[i] - '0';
          int cc = c[i] - '0';
          if (cnt == n - 1 && (ca == 0 || cb == 0 || cc == 0))
            continue;
          if (isp[i]) {
            dp[mask + (1 << i)][(ca + cb + 1) / 10] += dp[mask][1];
          } else {
            dp[mask + (1 << i)][(ca + cb) / 10] += dp[mask][0];
          }
        }
      }
      const int MOD = 1e9 + 7;
      cout << dp[N - 1][0] % MOD << '\n';
    }
  } else {
    vec<int> fact(n + 10);
    fact[0] = fact[1] = 1;
    for (int i = 2; i < fact.size(); i++) {
      fact[i] = (fact[i - 1] * i) % MOD;
    }
    auto C = [&](int n, int k) {
      return fact[n] * pw(fact[k], MOD - 2) % MOD * pw(fact[n - k], MOD - 2) % MOD;
    };
    int cnt_good = 0, cnt_pr = 0, cnt_suf = 0, cnt_b = 0;
    for (int i = 0; i < n; i++) {
      int ca = a[i] - '0';
      int cb = b[i] - '0';
      int cc = c[i] - '0';
      bool af = false;
      bool pr = false;
      if ((ca + cb) % 10 != cc && (ca + cb + 1) % 10 != cc) {
        cout << "0\n";
        return;
      }
      if ((ca + cb) % 10 != cc && (ca + cb + 1) % 10 == cc) {
        pr = true;
      }
      if ((ca + cb) % 10 != cc) {
        pr = true;
      }
      if ((ca + cb + pr) / 10 == 1) {
        af = true;
      }
      if (!pr && !af)
        cnt_good++;
      if (!pr && af)
        cnt_pr++;
      if (pr && af) {
        cnt_b++;
      }
      if (pr && !af) {
        cnt_suf++;
      }
    }
    if (cnt_suf != cnt_pr || cnt_suf == 0 && cnt_b > 0) {
      cout << "0\n";
      return;
    }
    int ans = fact[cnt_good];
    ans = ans * C(cnt_good + 1 + cnt_suf - 1, cnt_suf) % MOD;
    ans = ans * fact[cnt_suf] % MOD * fact[cnt_suf] % MOD;
    ans = ans * C(cnt_b + cnt_suf - 1, cnt_suf - 1) % MOD;
    ans = ans * fact[cnt_b] % MOD;
    cout << ans << '\n';
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  int t = 1;
//  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}