//
// Created by omega_alpha on 16.01.2021
//
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define FF first
#define SS second
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define pb push_back
#define mp make_pair

using ll = long long;
using ld = long double;

const int INFI = 1e9 + 228;
const int INFL = 1e18 + 228;
const ld INFLD = 1e18 + 228;
const ld PI = acos(-1);
const int MAXN = 1e5 + 228;
int tabl[15][15];
mt19937_64 rnd(time(nullptr));
bool check(int x, int y, int color) {
    for (int i = 0; i < x; ++i) {
        for (int j = 0; j < y; ++j) {
            if (tabl[x][j] == color && tabl[i][y] == color && tabl[i][j] == color) return false;
        }
    }
    return true;
}
void f1(int n, int m, int c) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            tabl[i][j] = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            vector<int> may;
            for (int col = 1; col <= c; ++col) {
                if (check(i, j, col)) {
                    may.pb(col);
                }
            }
            random_shuffle(ALL(may));
            if (may.size() == 0) return;
            tabl[i][j] = may[0];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << tabl[i][j] << ' ';
        }
        cout << "\n";
    }
    exit(0);
}
void f3(int n, int m, int c) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            tabl[i][j] = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            vector<int> may;
            for (int col = 1; col <= 2; ++col) {
                if (check(i, j, col)) {
                    may.pb(col);
                }
            }
            random_shuffle(ALL(may));
            if (may.size() == 0) {
                if (c == 2) return;
                tabl[i][j] = 3;
            }
            else tabl[i][j] = may[0];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!check(i, j, tabl[i][j])) return;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << tabl[i][j] << ' ';
        }
        cout << "\n";
    }
    exit(0);
}
void f2(int n, int m, int c) {
    for (int mask = 0; mask < (1 << (n * m)); ++mask) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                tabl[i][j] = ((mask & (1 << (i * m + j))) > 0);
            }
        }
        bool good = true;
        for (int i = 0; i < n && good; ++i) {
            for (int j = 0; j < m && good; ++j) {
                if (!check(i, j, tabl[i][j])) {
                    good = false;
                    break;
                }
            }
        }
        if (good) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << tabl[i][j] + 1 << ' ';
                }
                cout << endl;
            }
            exit(0);
        }
    }
}
void run() {
    int n, m, c;
    cin >> n >> m >> c;
    for (int it = 0; it < 50000; ++it) f3(n, m, c);
    for (int it = 0; it < 10000; ++it) f1(n, m, c);
    if (c == 2) {
        if (n * m <= 20) {
            f2(n, m, c);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    //cin >> t;
    t = 1;
    while (t--) run();
    return 0;
}

