#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;

int main()
{
    int n;
    cin >> n;

    set < long long > ltoget;
    int m;
    vector < vector < long long > > l(n);
    vector < long long > s(n);
    for (int i = 0; i < n; i++) {
        cin >> m >> s[i];
        l[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> l[i][j];
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 1; j < l[i].size(); j++) {
            ltoget.insert(l[i][j] - l[i][j - 1]);
        }
    }
    if (ltoget.size() > 1) {
        cout << "No";
        return 0;
    }

    if (n == 1) {
        cout << "Yes\n1";
        return 0;
    }
    
    vector < pair < long long, int > > st;
    vector < pair < long long, int > > f;
    long long sts = 0;
    long long fs = 0;
    for (int i = 0; i < n; i++) {
        f.push_back({ l[i][0], i });
        st.push_back({ s[i] - l[i].back(), i });
    }
    for (auto e : st)
        sts += e.first;
    for (auto e : f)
        fs += e.first;

    // переберем пару и проверим
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
            // i - f (начало), j - st (конец);
            for (int l = 0; l <= 200; l++) {
                if (ltoget.size() > 0 && *ltoget.begin() != l) {
                    continue;
                }
                vector < bool > used(n, false);
                used[i] = used[j] = true;
                int id = i;
                int connected = 0;
                vector < int > order;
                while (true) {
                    bool fnd = false;
                    order.push_back(id);
                    for (int t = 0; t < n; t++) {
                        if (!used[t] && st[id].first + f[t].first == l) {
                            fnd = true;
                            id = t;
                            used[t] = true;
                            connected++;
                            break;
                        }
                    }
                    if (!fnd) {
                        break;
                    }
                }
                if (connected < n - 2) {
                    continue;
                }
                if (st[id].first + f[j].first == l) {
                    cout << "Yes\n";
                    order.push_back(j);
                    for (int i = 0; i < order.size(); i++) {
                        cout << order[i] + 1 << " ";
                    }
                    return 0;
                }
            }
        }
    }
    cout << "No";
}