#include <iostream>
#include <vector>
//#pragma GCC optim("Ofast, inline-mode")
#define int long long

using namespace std;

int sum(int a, int b) {
    return max(0ll, (b + 1) * b / 2 - a * (a - 1) / 2);
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        if (n == 1) {
            int ans = -1;
            int delta = 1e18 + 179;
            for (int i = m / 3; i < m; ++i) {
                int d = abs(sum(1, i) - sum(i + 1, m));
                if (delta > d) {
                    delta = d;
                    ans = i;
                }
            }
            cout << 'V' << ' ' << ans + 1 << '\n';
            continue;
        }
        int ans1 = -1;
        int delta1 = 1e18 + 179;
        for (int i = n / 3; i < n; ++i) {
            int d = abs(sum(1, i * m) - sum(i * m + 1, n * m));
            if (delta1 > d) {
                delta1 = d;
                ans1 = i;
            }
        }
        cerr << "1- " << 'H' << ' ' << ans1 + 1 << '\n';

        vector<int> s(m);
        int all = 0;
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                s[j] += i * m + j + 1;
            }
            all += s[j];
        }
        int ans2 = -1;
        int delta2 = 1e18 + 179;
        int l = 0;
        int r = all;
        for (int i = 0; i < m; ++i) {
            if (delta2 > abs(r - l)) {
                delta2 = abs(r - l);
                ans2 = i;
            }
            l += s[i];
            r -= s[i];
        }
        cerr << "2- " << 'V' << ' ' << ans2 + 1 << '\n';

        if (delta1 < delta2) {
            cout << 'H' << ' ' << ans1 + 1 << '\n';
        } else {
            cout << 'V' << ' ' << ans2 + 1 << '\n';
        }
    }
    return 0;
}
