#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <deque>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using mset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

int n, m;

int vc(int co) {
    int len = n - co + 1;
    //cout << len << endl;
    int in = (len - 1) * len / 2 + co * len;
    //cout << in << endl;
    return abs(
        (in * m + n * len * (m - 1) * m / 2) -
        ((n * m) * (n * m + 1) / 2 - (in * m + n * len * (m - 1) * m / 2))
    );
}

int vter() {
    int  l = 1, r = n;
    while (r - l > 1) {
        int a = (l * 2 + r) / 3;
        int b = (r * 2 + l) / 3;
        if (vc(a) < vc(b)) {
            r = a;
        } else {
            l = b;
        }
    }
    return (vc(l) < vc(r) ? l : r);
}

int hc(int co) {
    co--;
    return abs(
        (co * n + 1) * (co * n) / 2 -
        ((n * m) * (n * m + 1) / 2 - (co * n + 1) * (co * n) / 2)
    );
}

int hter() {
    int  l = 1, r = m;
    while (r - l > 1) {
        int a = (l * 2 + r) / 3;
        int b = (r * 2 + l) / 3;
        if (hc(a) < hc(b)) {
            r = a;
        } else {
            l = b;
        }
    }
    return (hc(l) < hc(r) ? l : r);
}

signed main() {
    int t; cin >> t;
    while (t--) {
        cin >> m >> n;
        int a = 1, b = 1;
        for (int i = 1; i <= n; ++i) {
            if (vc(i) < vc(a)) {
                a = i;
            }
        }
        for (int i = 1; i <= m; ++i) {
            if (hc(i) < hc(b)) {
                b = i;
            }
        }
        if (vc(a) < hc(b)) {
            cout << "V " << a << endl;
        } else {
            cout << "H " << b << endl;
        }
    }
}
