#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <deque>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using mset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

int n, m;

int vc(int co) {
    int len = n - co + 1;
    //cout << len << endl;
    int in = (len - 1) * len / 2 + co * len;
    //cout << in << endl;
    return abs(
        (in * m + n * len * (m - 1) * m / 2) -
        ((n * m) * (n * m + 1) / 2 - (in * m + n * len * (m - 1) * m / 2))
    );
}

int vter() {
    int  l = 1, r = n + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (vc(mid) > vc(mid - 1)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r - 1;
}

int hc(int co) {
    co--;
    return abs(
        (co * n + 1) * (co * n) / 2 -
        ((n * m) * (n * m + 1) / 2 - (co * n + 1) * (co * n) / 2)
    );
}

int hter() {
    int  l = 1, r = m + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (hc(mid) > hc(mid - 1)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r - 1;
}

signed main() {
    int t; cin >> t;
    while (t--) {
        cin >> m >> n;
        int a = vter(), b = hter();
        //cout << a << " " << b << endl;
        if (vc(a) <= hc(b)) {
            cout << "V " << a << endl;
        } else {
            cout << "H " << b << endl;
        }
    }
}
