#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <deque>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using mset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

int fn(int n) {
    return to_string(n)[0] - '0';
}

int ln(int n) {
    return to_string(n).size();
}

int num(int m, int len) {
    int ans = 0;
    while (len--) {
        ans *= 10;
        ans += m;
    }
    return ans;
}

int numIsert(int m, int len, int i, int mInsert) {
    int ans = 0;
    for (int j = 0; j < len; ++j) {
        ans *= 10;
        if (j == i) {
            ans += mInsert;
        } else {
            ans += m;
        }
    }
    return ans;
}

signed main() {
    int n; cin >> n;
    bool k; cin >> k;
    if (!k) {
        //cout << fn(n) << " " << ln(n) << " " << num(fn(n), ln(n)) << endl;
        if (num(fn(n), ln(n)) - n >= 0) {
            cout << num(fn(n), ln(n));
        } else {
            cout << num(fn(n) + 1, ln(n));
        }
    } else {
        int ans = 1e9;
        bool isAns = 0;
        for (int i = ln(n) - 1; i > 0; --i) {
            for (int j = 0; j <= 9; ++j) {
                //cout << "sas " << numIsert(fn(n), ln(n), i, j) << endl;
                if (numIsert(fn(n), ln(n), i, j) - n >= 0) {
                    isAns = 1;
                    if (ans > numIsert(fn(n), ln(n), i, j)) {
                        ans = numIsert(fn(n), ln(n), i, j);
                    }
                }
            }
        }

        for (int j = 0; j <= 9; ++j) {
            //cout << "sis " << numIsert(j, ln(n), 0, fn(n)) << endl;
            if (numIsert(j, ln(n), 0, fn(n)) - n >= 0) {
                isAns = 1;
                if (ans > numIsert(j, ln(n), 0, fn(n))) {
                    ans = numIsert(j, ln(n), 0, fn(n));
                }
            }
        }
        if (isAns) {
            cout << ans;
        } else {
            cout << (fn(n) + 1) * pow(10, ln(n) - 1);
        }
    }
}
