#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

vector<int> getSeq() {
    vector<int> seq;
    for (int n = 0; n < 19; ++n) {
        for (int v = 1; v < 10; ++v) {
            for (int pos = 0; pos < n; ++pos) {
                for (int v2 = 1; v2 < 10; ++v2) {
                    int x = ((int)ceil(pow(10, n)) - 1) / 9 * v;
                    //seq.push_back(x);
                    seq.push_back(x + (int)ceil(pow(10, pos)) * (v2-v));
                }
            }
        }
    }

    sort(seq.begin(), seq.end());
    seq.resize(unique(seq.begin(), seq.end()) - seq.begin());
    return seq;
}

signed main() {
    int x, k;
    cin >> x >> k;
    if (k == 0) {
        // Bad -----------------------------
        int a = 1;
        while (a*9 < x) {
            a = 10*a + 1;
        }
        for (int i = 1; i < 11; ++i) {
            if (a * i >= x) {
                cout << a * i;
                return 0;
            }
        }
    } else {
        // Good ----------------------------
        vector<int> seq = getSeq();
        for (int y : seq) {
            if (y >= x) {
                cout << y;
                return 0;
            }
        }
        return 1;
    }
}

