#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 42;
int a[MAX_N][MAX_N];
int n, m;

bool check() {
    bool flag = 1;
    for (int x1 = 0; x1 < n - 1; x1++) {
        for (int x2 = x1 + 1; x2 < n; x2++) {
            for (int y1 = 0; y1 < m - 1; y1++) {
                for (int y2 = y1 + 1; y2 < m; y2++) {
                    if (a[x1][y1] == 0 || a[x1][y2] == 0 || a[x2][y1] == 0 || a[x2][y2] == 0) {
                        continue;
                    }
                    if (a[x1][y1] == a[x1][y2] && a[x1][y2] == a[x2][y1] && a[x2][y1] == a[x2][y2]) {
                        //cout << x1 << " " << x2 << " " << y1 << " " << y2 << endl;
                        flag = 0;
                    }
                }
            }
        }
    }
    return flag;
}

void brute_force(int i, int j) {
    if (i == n) {
        if (check()) {
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    cout << a[x][y] << " ";
                }
                cout << "\n";
            }
            exit(0);
        }
        return;
    }
    if (!check()) {
        return;
    }
    a[i][j] = 1;
    if (j != m - 1) {
        brute_force(i, j + 1);
    } else {
        brute_force(i + 1, 0);
    }
    a[i][j] = 2;
    if (j != m - 1) {
        brute_force(i, j + 1);
    } else {
        brute_force(i + 1, 0);
    }
    a[i][j] = 0;
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin >> n >> m;
    brute_force(0, 0);
    return 0;
}
