#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 42;
int a[MAX_N][MAX_N];
int n, m, c;

bool check() {
    bool flag = 1;
    for (int x1 = 0; x1 < n - 1; x1++) {
        for (int x2 = x1 + 1; x2 < n; x2++) {
            for (int y1 = 0; y1 < m - 1; y1++) {
                for (int y2 = y1 + 1; y2 < m; y2++) {
                    if (a[x1][y1] == 0 || a[x1][y2] == 0 || a[x2][y1] == 0 || a[x2][y2] == 0) {
                        continue;
                    }
                    if (a[x1][y1] == a[x1][y2] && a[x1][y2] == a[x2][y1] && a[x2][y1] == a[x2][y2]) {
                        return 0;
                    }
                }
            }
        }
    }
    return 1;
}

bool good(int x2, int y2) {
    for (int x1 = 0; x1 < x2; x1++) {
        for (int y1 = 0; y1 < y2; y1++) {
            if (a[x1][y1] == a[x1][y2] && a[x1][y2] == a[x2][y1] && a[x2][y1] == a[x2][y2]) {
                return 0;
            }
        }
    }
    return 1;
}

int cnt = 0;

void brute_force(int i, int j) {
    if (i == n) {
        if (check()) {
//            cnt++;
//            return;
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    cout << a[x][y] << " ";
                }
                cout << "\n";
            }
            //cout << endl << endl;
            exit(0);
        }
        return;
    }
    for (int k = 1; k <= c; k++) {
        a[i][j] = k;
        if (!good(i, j)) {
            continue;
        }
        if (j != m - 1) {
            brute_force(i, j + 1);
        } else {
            brute_force(i + 1, 0);
        }
    }
    a[i][j] = 0;
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin >> n >> m >> c;
   // brute_force(0, 0);
    if (c == 2) {
        brute_force(0, 0);
        return 0;
    }
    vector < vector < int > > b = {
                                    {1, 1, 1, 1, 1, 1, 1, 2},
                                    {1, 2, 2, 2, 3, 3, 3, 1},
                                    {2, 2, 3, 3, 1, 2, 3, 1},
                                    {2, 3, 2, 3, 2, 3, 1, 1},
                                    {2, 3, 3, 2, 3, 1, 2, 1},
                                    {3, 1, 2, 3, 3, 2, 2, 1},
                                    {3, 2, 3, 1, 2, 3, 2, 1},
                                    {3, 3, 1, 2, 2, 2, 3, 1}
                                };
    if (n > 8 || m > 8) {
        brute_force(0, 0);
        return 0;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << b[i][j] << " ";
        }
        cout << "\n";
    }
    return 0;
}
