#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;


const int mx_MEM = 2 * 1e8;
int mpos = 0;
char mem[mx_MEM];

inline void *operator new(size_t n) {
    assert((mpos += n) <= mx_MEM);
    return (void *) (mem + mpos - n);
}

inline void operator delete(void *) noexcept {}


#define int long long

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int a, x;
    int b, y;
    int k;
    cin >> k >> a >> x >> b >> y;
    int n = max((int) 0, (k - a - b) * (x + y));
    int m = n;
    if (k > a + b) k = a + b;
    n += max((int) 0, (k - a) * x);
    m += max((int) 0, (k - b) * y);
    cout << max(n, m) << "\n";
    return 0;
}
