//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;

/*
const int mx_MEM = 2 * 1e8;
int mpos = 0;
char mem[mx_MEM];

inline void *operator new(size_t n) {
    assert((mpos += n) <= mx_MEM);
    return (void *) (mem + mpos - n);
}

inline void operator delete(void *) noexcept {}
*/

#define int long long

// A C G T

int n;
vector<char> type = {'A', 'C', 'G', 'T'};
vector<pair<int, int> > ms;

int leng(int x) {
    int cnt = 0;
    if (x == 0) return 0;
    if (x == 1) return 1;
    cnt++;
    while (x > 0) {
        cnt++;
        x /= 10;
    }
    return cnt;
}

pair<int, int> pos(int len) {
    int l = leng(len);
    if (l == leng(len / 2)) {
        return {len / 2, l + 1};
    } else {
        int cur = 1;
        for (int i = 0; i < l - 1; ++i) {
            cur *= 10;
        }
        cur /= 10;
        if (leng(len % cur) == l - 1) {
            return {len - len % cur, l};
        } else {
            int a = (len + 1) / 2;
            return {a, leng(a) + leng(len - a) + 1 - l};
        }
    }
}

void get_max() {
    int cur = 0;
    int mx = 1;
    int po = 0;
    int typ = 3 - ms[0].second;
    for (int i = 0; i < n; ++i) {
        if (ms[i].first != 1) {
            pair<int, int> ps = pos(ms[i].first);
            if (ps.second > mx) {
                mx = ps.second;
                po = cur + ps.first;
                typ = 3 - ms[i].second;
            }
        }
        cur += ms[i].first;
    }
    cout << "1 " << po << " " << type[typ] << "\n";
}


void get_min() {
    int mx = leng(ms[0].first) - leng(ms[0].first - 1);
    int po = 1;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        int cur = leng(ms[i].first) - leng(ms[0].first - 1);
        if (cur > mx) {
            mx = cur;
            po = cnt + 1;
        }
        if (ms[i].first == 1) {
            if (i != 0 && i + 1 != n) {
                if (ms[i - 1].second == ms[i + 1].second) {
                    cur = leng(ms[i - 1].first) + leng(ms[i + 1].first) - leng(ms[i - 1].first + ms[i + 1].first);
                    if (cur > mx) {
                        mx = cur;
                        po = cnt + 1;
                    }
                }
            }
        }
        cnt += ms[i].first;
    }
    cout << "2 " << po << "\n";
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    string s;
    cin >> s;
    int cur = 0;
    bool ch = false;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] >= '0' && s[i] <= '9') {
            cur *= 10;
            cur += s[i] - '0';
        } else {
            int t = 0;
            if (s[i] == 'C') t = 1;
            if (s[i] == 'G') t = 2;
            if (s[i] == 'T') t = 3;
            ms.push_back({max(cur, (int) 1), t});
            cur = 0;
        }
    }
    n = ms.size();

    get_min();
    get_max();
    return 0;
}
