//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <assert.h>
#include <map>

using namespace std;

/*
const int mx_MEM = 2 * 1e8;
int mpos = 0;
char mem[mx_MEM];

inline void *operator new(size_t n) {
    assert((mpos += n) <= mx_MEM);
    return (void *) (mem + mpos - n);
}

inline void operator delete(void *) noexcept {}
*/

#define int long long

int get_(int y, int cnt) {
    int a = 0;
    for (int i = 0; i < cnt; ++i) {
        a *= 10;
        a += y;
    }
    return a;
}

int build(vector<int> ms) {
    int n = ms.size();
    int x = 0;
    for (int i = 0; i < n; ++i) {
        x *= 10;
        x += ms[i];
    }
    return x;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int x, k;
    cin >> x >> k;
    int y = x;
    int cnt = 1;
    while (y >= 10) {
        y /= 10;
        cnt++;
    }
    if (k == 0) {
        if (get_(y, cnt) >= x) {
            cout << get_(y, cnt);
        } else {
            cout << get_(y + 1, cnt);
        }
    } else {
        int mn = 1e18;
        vector<int> ms(cnt, y);
        for (int i = 1; i < cnt; ++i) {
            for (int j = 0; j < 10; ++j) {
                ms[i] = j;
                if (build(ms) >= x) mn = min(mn, build(ms));
            }
            ms[i] = y;
        }
        for (int i = 0; i < 10; ++i) {
            for (int j = 1; j < cnt; ++j) {
                ms[j] = i;
            }
            if (build(ms) >= x) mn = min(mn, build(ms));
        }
        
        cout << mn << "\n";
    }
    return 0;
}
