#include <bits/stdc++.h>
using namespace std;

#define int long long

int n, m;

int getH(int x) {
	return n * x * (x + 1) / 2 + x * m * (n - 1) * n / 2;
}

int getV(int x) {
	return m * x * (m * x + 1) / 2;
}

void solve() {
	cin >> n >> m;

	int sum = n * m * (n * m + 1) / 2;
	int diff = sum;
	char type = 'H';
	int pos = 1;
	{
		int l = 1, r = m + 1;
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			int val = getH(mid);
			if (val <= sum - val) {
				l = mid;
			} else {
				r = mid;
			}
		}
		for (int x = max(1LL, l - 3); x <= min(m - 1, l + 3); ++x) {
			int val = getH(x);
			int cur = abs(val - (sum - val));
			if (cur < diff) {
				diff = cur;
				type = 'V';
				pos = x + 1;
			}
		}
	}

	{
		int l = 1, r = n + 1;
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			int val = getV(mid);
			if (val <= sum - val) {
				l = mid;
			} else {
				r = mid;
			}
		}
		for (int x = max(1LL, l - 3); x <= min(n - 1, l + 3); ++x) {
			int val = getV(x);
			int cur = abs(val - (sum - val));
			if (cur < diff) {
				diff = cur;
				type = 'H';
				pos = x + 1;
			}
		}
	}
	cout << type << " " << pos << endl;
}

signed main() {
	int t;
	cin >> t;
	while(t--) {
		solve();
	}
	return 0;
}