#include <bits/stdc++.h>
using namespace std;

template<typename T> void uin(T & a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T & a, T b) {
	if (b > a) {
		a = b;
	}
}

#define int long long

const int INF = 1e18 + 228;

bool is_digit(char c) {
	return '0' <= c && c <= '9';
}

int get_len(int x) {
	if (x == 0 || x == 1) return 0;
	int res = 0;
	while (x) {
		++res;
		x /= 10;
	}
	return res;
}

string s;
vector< pair<int, char> > v;

void getMin() {
	int type = 2, before = 1;

	int delta = 0;
	int sz = (int)v.size();
	int bef = 0;
	for (int i = 0; i < sz; ++i) {
		// try to delete 1 symbol from block i

		if (v[i].first == 1) {
			int old = 0;
			int nw = 0;

			old += 1;
			if (i > 0) {
				old += 1 + get_len(v[i - 1].first);
			}
			if (i + 1 < sz) {
				old += 1 + get_len(v[i + 1].first);
			}
			if (i > 0 && i + 1 < sz) {
				if (v[i - 1].second == v[i + 1].second) {
					nw = 1 + get_len(v[i - 1].first + v[i + 1].first);
				} else {
					nw = 1 + get_len(v[i - 1].first) + 1 + get_len(v[i + 1].first);
				}
			} else {
				if (i > 0) {
					nw += 1 + get_len(v[i - 1].first);
				}
				if (i + 1 < sz) {
					nw += 1 + get_len(v[i + 1].first);
				}
			}

			if (old - nw > delta) {
				delta = old - nw;
				type = 2; // DELETE
				before = bef + 1;
			}
		} else {
			if (get_len(v[i].first) - get_len(v[i].first - 1) > delta) {
				delta = get_len(v[i].first) - get_len(v[i].first - 1);
				type = 2; // DELETE
				before = bef + 1;
			}
		}
		bef += v[i].first;
	}

	cout << type << " " << before << '\n';
}

string out() {
	string res = "";
	for (auto p : v) {
		for (int i = 0; i < p.first; ++i) {
			res += p.second;
		}
	}
	return res;
}

int get_val(string s) {
	int sz = (int)s.size();
	int i = 0;
	int res = 0;
	while (i < sz) {
		int j = i;
		while (j + 1 < sz && s[j + 1] == s[j]) ++j;
		res += get_len(j - i + 1) + 1;
		i = j + 1;
	}
	return res;
}

int base[20];

void getMax() {
	base[0] = 1;
	base[1] = 1;
	for (int i = 2; i <= 10; ++i) {
		base[i] = base[i - 1] * 10;
	}
	++base[1];
	int ini = 0;
	for (auto p : v) {
		ini += get_len(p.first) + 1;
	}
	int ans = ini + 1;
	int type = 1, pos = 0;
	char symb = 'A';
	if (v[0].second == 'A') symb = 'C';
	int bef = 0;
	for (auto p : v) {
		int len = p.first;
		char c = p.second;

		for (int i = 1; i < min(17LL, len); ++i) {
			int cur = ini - 1 - get_len(len);
			cur += 1 + get_len(i);
			cur += 1 + get_len(len - i);
			cur += 1;
			if (cur > ans) {
				ans = cur;
				type = 1;
				pos = bef + i;
				symb = 'A';
				if (symb == c) {
					symb = 'G';
				}
			}
		}
		for (int l = 0; l <= 10; ++l) {
			for (int r = 0; r <= 10; ++r) {
				if (base[l] + base[r] <= len) {
					int cur = ini - 1 - get_len(len);
					int i = base[l];
					cur += 1 + get_len(i);
					cur += 1 + get_len(len - i);
					cur += 1;
					if (cur > ans) {
						ans = cur;
						type = 1;
						pos = bef + i;
						symb = 'A';
						if (symb == c) {
							symb = 'G';
						}
					}
				}
			}
		}
		bef += len;
	}

	cout << type << " " << pos << " " << symb << endl;
}

void solve() {
	cin >> s;
	int n = (int)s.size();

	{
		int i = 0;
		int cur_len = 0;
		while (i < n) {
			if (is_digit(s[i])) {
				int len = 0;
				len = len * 10 + (s[i] - '0');
				int j = i;
				while (j + 1 < n && is_digit(s[j + 1])) {
					len = len * 10 + (s[j + 1] - '0');
					++j;
				}
				cur_len = len;
				i = j + 1;
			} else {
				if (cur_len == 0) {
					v.emplace_back(1, s[i]);
				} else {
					v.emplace_back(cur_len, s[i]);
				}
				cur_len = 0;
				++i;
			}
		}
	}

	getMin();
	getMax();
}

signed main() {
	solve();
	return 0;
}

/*
5AC5A2C


*/