#include <bits/stdc++.h>
using namespace std;

template<typename T> void uin(T & a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T & a, T b) {
	if (b > a) {
		a = b;
	}
}

#define int long long
#define all(v) v.begin(), v.end()
#define list list228

const int N = 100 * 1000 + 228;

int n;
int m[N], s[N];
int pref[N], suff[N];
int pr[N], su[N];
int degin[N], degout[N];
int fir[N];

vector<pair<int,int> > g[N];

vector<int> crd1, crd2;
int sz1 = 0, sz2 = 0;

int get(int u) {
	if (u <= sz1) return crd1[u - 1];
	return crd2[u - sz1 - 1];
}

map< pair<int,int> , int > cnt;

void add_edge(int u, int v) {
	// cout << get(u) << " -> " << get(v) << endl;
	g[u].emplace_back(v, 1);
	++degout[u];
	++degin[v];
	++cnt[{u, v}];
}

vector<int> order;

void dfs(int v) {
	while (fir[v] < (int)g[v].size()) {
		if (g[v][fir[v]].second == 1) {
			g[v][fir[v]].second = 0;
			dfs(g[v][fir[v]].first);
			++fir[v];
		} else {
			++fir[v];
		}
	}
	order.emplace_back(v);
}

map< pair<int, int> , vector<int> > kek;

void tru(int d) {
	for (int i = 1; i <= 2 * n; ++i) {
		g[i].clear();
		degin[i] = degout[i] = 0;
		fir[i] = 0;
	}

	for (int i = 1; i <= n; ++i) {
		add_edge(pr[i], su[i]);
		int TO = d - suff[i];
		int to = lower_bound(all(crd1), TO) - crd1.begin() + 1;
		if (crd1[to - 1] == TO) {
			add_edge(su[i], to);
		}
	}
	vector<int> list;
	for (int i = 1; i <= sz1 + sz2; ++i) {
		if (degin[i] != degout[i]) {
			list.emplace_back(i);
		}
	}
	if (!list.empty() && list.size() != 2) {
		return;
	}
	int start = 1;
	if (list.size() == 2) {
		int x = list[0];
		int y = list[1];
		if (degout[y] > degin[y]) {
			// add_edge(x, y);
			--cnt[{x, y}];
			start = y;
			// cout << "x=" << x << " y=" << y << endl;
		} else {
			// add_edge(y, x);
			--cnt[{y, x}];
			start = x;
		}
	}
	order.clear();
	dfs(start);
	reverse(all(order));
	cout << "Yes\n";
	for (int i = 0; i < (int)order.size() - 1; ++i) {
		if (order[i] < order[i + 1]) {
			cout << kek[{order[i],order[i+1]}].back() << " ";
			kek[{order[i],order[i + 1]}].pop_back();
		}
	}
	cout << endl;
	exit(0);
}


signed main() {
	cin >> n;
	bool OK = true;
	int d = 0;
	for (int i = 1; i <= n; ++i) {
		cin >> m[i] >> s[i];
		vector<int> p(m[i]);
		for (int j = 0; j < m[i]; ++j) {
			cin >> p[j];
		}
		if (m[i] > 1) {
			if (d != 0 && p[1] - p[0] != d) {
				OK = false;
				break;
			}
			d = p[1] - p[0];
		}
		for (int j = 0; j < m[i] - 1; ++j) {
			if (p[j + 1] - p[j] != d) {
				OK = false;
				break;
			}
		}
		pref[i] = p[0];
		suff[i] = s[i] - p.back();
	}
	for (int i = 1; i <= n; ++i) {
		cout << pref[i] << " " << suff[i] << ")\n";
	}
	if (!OK) {
		cout << "No\n";
		return 0;
	}
	{
		for (int i = 1; i <= n; ++i) {
			crd1.emplace_back(pref[i]);
			crd2.emplace_back(suff[i]);
		}
		sort(all(crd1));
		sort(all(crd2));
		crd1.erase(unique(all(crd1)), crd1.end());
		crd2.erase(unique(all(crd2)), crd2.end());
		sz1 = (int)crd1.size();
		sz2 = (int)crd2.size();

		for (int i = 1; i <= n; ++i) {
			pr[i] = lower_bound(all(crd1), pref[i]) - crd1.begin() + 1;
			su[i] = lower_bound(all(crd2), suff[i]) - crd2.begin() + 1;
			su[i] += (int)crd1.size();
			kek[{pr[i],su[i]}].emplace_back(i);
		}
	}
	if (d != 0) {
		tru(d);
	} else {
		for (int d = 0; d <= 100; ++d) {
			tru(d);
		}
	}
	cout << "No\n";

	// map<int, int> inp, outp, ins, outs;
	// for (int i = 1; i <= n; ++i) {
	// 	++outp[pref[i]];
	// 	++ins[suff[i]];

	// 	++outs[suff[i]];
	// 	++inp[d - suff[i]];
	// }
	return 0;
}


/*
3 
1 7
3
1 8
6
2 8
1 6



1
1 7
5



1
3 10
2 5 9



3
1 5
3
1 3
3
1 6
3



4
1 5
0
1 0
0
1 3
3
1 0
0




*/