#include <bits/stdc++.h>
using namespace std;

template<typename T> void uin(T & a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T & a, T b) {
	if (b > a) {
		a = b;
	}
}

#define int long long

int n, m, c;

int a[11][11];

void solve2() {
	for (int mask = 0; mask < (1 << (n * m)); ++mask) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				int num = (i - 1) * m + j;
				a[i][j] = (mask >> (num - 1)) & 1;
			}
		}
		bool OK = true;
		for (int x1 = 1; x1 <= n; ++x1) {
			for (int x2 = x1 + 1; x2 <= n; ++x2) {
				for (int y1 = 1; y1 <= m; ++y1) {
					for (int y2 = y1 + 1; y2 <= m; ++y2) {
						if (a[x1][y1] == a[x1][y2] && a[x1][y2] == a[x2][y1] && a[x2][y1] == a[x2][y2]) {
							OK = false;
							break;
						}
					}
				}
			}
		}
		if (OK) {
			for (int i = 1; i <= n; ++i) {
				for (int j = 1; j <= m; ++j) {
					cout << a[i][j] + 1 << " ";
				}
				cout << endl;
			}
			return;
		}
	}
}

int cnt[11];

void gen(int row, int col) {
	if (row == n + 1) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				cout << a[i][j] << " ";
			}
			cout << endl;
		}
		exit(0);
	}
	int nrow = row;
	int ncol = col + 1;
	if (col == m + 1) {
		ncol = 1;
		++nrow;
	}
	for (int c = 1; c <= 3; ++c) {
		a[row][col] = c;
		vector<int> _cnt(row);
		for (int i = 1; i < row; ++i) {
			_cnt[i] = cnt[i];
		}
		int mx = 0;
		for (int r = 1; r < row; ++r) {
			if (a[r][col] == c) {
				++cnt[r];
				uax(mx, cnt[r]);
			}
		}
		if (mx < 2) {
			if (nrow > row) {
				for (int i = 1; i <= row; ++i) {
					cnt[i] = 0;
				}
			}
			gen(nrow, ncol);
		}
		for (int r = 1; r < row; ++r) {
			cnt[r] = _cnt[r];
		}
	}
}

void solve3() {
	if (n <= 3) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				cout << i << " ";
			}
			cout << endl;
		}
		exit(0);
	}
	if (m <= 3) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				cout << j << " ";
			}
			cout << endl;
		}
		exit(0);
	}
	gen(1, 1);
}

void solve() {
	if (c == 2) {
		solve2();
	} else {
		solve3();
	}
}

signed main() {
	cin >> n >> m >> c;
	solve();
	return 0;
}

/*
5AC5A2C


*/