#include <bits/stdc++.h>
using namespace std;

template<typename T> void uin(T & a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T & a, T b) {
	if (b > a) {
		a = b;
	}
}

#define int long long
#define all(v) v.begin(), v.end()
#define list list228

const int N = 428228;
const int MOD = 1e9 + 7;

long long mod(long long x) {
	x %= MOD;
	if (x < 0) x += MOD;
	return x;
}

int n;
int a[N], b[N], c[N];
bool ok[5][5];
int f[N];

int dp1[800][800], dp2[800][800];

void pre() {
	dp1[0][0] = 1;
	dp2[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= i; ++j) {
			for (int x = 1; x <= i; ++x) {
				dp1[i][j] = mod(dp1[i][j] + dp1[i - x][j - 1]);
			}
			for (int x = 2; x <= i; ++x) {
				dp2[i][j] = mod(dp2[i][j] + dp2[i - x][j - 1]);
			}
		}
	}
}

int fp(int a, int b) {
	int res = 1;
	while (b) {
		if (b & 1) {
			res = mod(res * a);
		}
		a = mod(a * a);
		b >>= 1;
	}
	return res;
}

int back(int x) {
	return fp(x, MOD - 2);
}

int C(int n, int k) {
	return f[n] * back(mod(f[k] * f[n - k]));
}

int F(int n, int k) {
	if (n == 0) return 1;
	return C(n + k - 1, n);
}

void solve() {
	string sa, sb, sc;
	cin >> sa >> sb >> sc;
	n = (int)sa.size();
	{
		f[0] = 1;
		for (int i = 1; i <= n * 2; ++i) {
			f[i] = mod((long long)f[i - 1] * i);
		}
	}
	int cnt[5];
	memset(cnt,0,sizeof cnt);
	int nonz[5];
	memset(nonz,0,sizeof nonz);
	for (int i = 1; i <= n; ++i) {
		a[i] = (sa[i - 1] - '0');
		b[i] = (sb[i - 1] - '0');
		c[i] = (sc[i - 1] - '0');
		if ((a[i] + b[i]) % 10 == c[i]) {
			if (a[i] + b[i] < 10) {
				++cnt[1];
				if (a[i] != 0 && b[i] != 0 && c[i] != 0) {
					++nonz[1];
				}
			} else {
				++cnt[3];
			}
		} else if ((a[i] + b[i] + 1) % 10 == c[i]){
			if (a[i] + b[i] + 1 < 10) {
				++cnt[2];
				if (a[i] != 0 && b[i] != 0 && c[i] != 0) {
					++nonz[2];
				}
			} else {
				++cnt[4];
			}
		} else {
			cout << 0 << endl;
			return ;
		}
	}
	if (cnt[2] != cnt[3]) {
		cout << 0 << endl;
		return ;
	}
	if (cnt[2] == 0 && cnt[4]) {
		cout << 0 << endl;
		return;
	}
	pre();
	int blocks = cnt[2];
	// cout << "F=" << F(cnt[4], blocks) << endl;
	int c = F(cnt[4], blocks);
	int call = F(cnt[1], blocks + 1);
	int c1 = 0;
	int c2 = F(cnt[1], blocks);
	c1 = mod(call - c2);

	c1 = mod(c1 * c);
	c2 = mod(c2 * c);

	// cout << "cnt : ";
	// for (int i = 1;i <= 4; ++i) {
	// 	cout << cnt[i] << " ";
	// }
	// cout << endl;

	// cout << "c1=" << c1 << " c2=" << c2 << endl;
	int ans = 0;
	if (cnt[1] > 0) {
		ans = mod(ans + (long long)mod((long long)c1 * nonz[1]) * f[cnt[1] - 1]);
		ans = mod((long long)ans * f[cnt[2]]);
	}
	if (cnt[2] > 0) {
		int cur = mod( (long long)mod((long long)c2 * nonz[2]) * f[cnt[2] - 1]);
		cur = mod((long long)cur * f[cnt[1]]);
		ans = mod(ans + cur);
	}
	ans = mod((long long)ans * f[cnt[3]]);
	ans = mod((long long)ans * f[cnt[4]]);
	cout << ans << endl;
}

signed main() {
	solve();
	return 0;
}


/*
3 
1 7
3
1 8
6
2 8
1 6



1
1 7
5

	// int c = mod(mod( f[blocks] * fp(blocks, cnt[4]) ) * f[blocks]);


1
3 10
2 5 9



3
1 5
3
1 3
3
1 6
3



4
1 5
0
1 0
0
1 3
3
1 0
0

// for (int pref_block = 0; pref_block < 2; ++pref_block) {
	// 	for (int suff_block = 0; suff_block < 2; ++suff_block) {
	// 		if (pref_block == 0 && suff_block == 0) {
	// 			int one_block = blocks - 1;
	// 			int cur = dp1[cnt[1]][one_block];
	// 			cur = mod(cur * dp2[n - cnt[1]][blocks]);

	// 			c2 = mod(c2 + cur);
	// 		} else if (suff_block == 1 && pref_block == 0) {
	// 			int one_block = blocks;
	// 			int cur = dp1[cnt[1]][one_block];
	// 			cur = mod(cur * dp2[n - cnt[1]][blocks]);

	// 			c1 = mod(c1 + cur);
	// 		} else if (suff_block == 0 && pref_block == 1) {
	// 			int one_block = blocks;
	// 			int cur = dp1[cnt[1]][one_block];
	// 			cur = mod(cur * dp2[n - cnt[1]][blocks]);

	// 			c2 = mod(c2 + cur);
	// 		} else {
	// 			// pref_block = suff_block = 1
	// 			int one_block = blocks + 1;
	// 			int cur = dp1[cnt[1]][one_block];
	// 			cur = mod(cur * dp2[n - cnt[1]][blocks]);

	// 			c1 = mod(c1 + cur);
	// 		}
	// 	}
	// }


*/