//#pragma GCC optimize("Ofast,unroll-loops,fast-math")
//#pragma GCC target("avx,avx2,abm,sse,popcnt")

#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <cctype>
#include <string>
#include <cmath>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

int main()
{
	ios::sync_with_stdio(false);
	cout.tie(0), cin.tie(0);

	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	vector<int> perm(n);
	iota(all(perm), 0);

	ll cnt = 0;
	do {
		string a1(n, '0'), b1(n, '0'), c1(n, '0');
		for (int i = 0; i < n; ++i)
		{
			a1[i] = a[perm[i]];
			b1[i] = b[perm[i]];
			c1[i] = c[perm[i]];
		}

		if (a[0] != 0 && b[0] != 0 && c[0] != 0 && stoll(a) + stoll(b) == stoll(c))
			++cnt;

	} while (next_permutation(all(perm)));

	cout << cnt;

	return 0;
}