#include<bits/stdc++.h>
#define int long long

using namespace std;

int l = 10;

int vert(int n, int m, int r) {
    r--;
    int a = r * (r + 1) / 2;
    int b = m * (m + 1) / 2 - a;
    int c = n * (n - 1) / 2 * m;
    return abs((a * n + r * c) - (b * n + (m - r) * c));
}

int hor(int n, int m, int r) {
    r--;
    int c = m * (m + 1) / 2;
    int a = r * (r - 1) / 2;
    int b = n * (n - 1) / 2 - a;
    a *= m;
    b *= m;
    return abs((a * m + r * c) - (b * m + (n - r) * c));
}

void solve() {
    int n, m;
    cin >> n >> m;
    int L = 0, R = m + 1;
    int S1, S2;
    int q1, q2;
    while (R - L > 2) {
        S1 = L + (R - L) / 3;
        S2 = R - (R - L) / 3;
        q1 = vert(n, m, S1);
        q2 = vert(n, m, S2);
        if (q1 > q2) {
            L = S1;
        } else {
            R = S2;
        }
    }
    int ans = 1e18;
    int type = -1;
    int val = -1;
    for (int i = max(0ll, L - l); i - l <= R && i <= m; ++i) {
        int ab = vert(n, m, i);
        if (ab < ans) {
            ans = ab;
            type = 1;
            val = i;
        }
    }
    L = 0;
    R = n + 1;
    while (R - L > 2) {
        S1 = L + (R - L) / 3;
        S2 = R - (R - L) / 3;
        q1 = hor(n, m, S1);
        q2 = hor(n, m, S2);
        if (q1 > q2) {
            L = S1;
        } else {
            R = S2;
        }
    }
    for (int i = max(0ll, L - l); i - l <= R && i <= n; ++i) {
        int ab = hor(n, m, i);
        if (ab < ans) {
            ans = ab;
            type = 2;
            val = i;
        }
    }
    if (type == 1) {
        cout << "V ";
    } else if (type == 2) {
        cout << "H ";
    } else {
        exit(-1);
    }
    cout << val << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
