#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <tuple>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <numeric>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
bool is_digit(char c) {
    return c >= '0' && c <= '9';
}
int to_int(string & s) {
    int ans = 0;
    for (auto c : s)
        ans = 10 * ans + (c - '0');
    return max(ans, 1);
}
int code_size(string & s) {
    if (s.empty())
        return 0;
    string ans;
    ans.push_back(s[0]);
    int count = 1;
    for (int i = 1; i < s.size(); ++i) {
        if (s[i] == s[i - 1])
            ++count;
        else {
            if (count >  1)
                ans += to_string(count);
            ans.push_back(s[i]);
            count = 1;
        }
    }
    return ans.size() + count;
}
int slv1(string s, int i) {
    s.erase(i, 1);
    return code_size(s);
}
int slv2(string s, int i, char c) {
    s.insert(i, 1, c);
    return code_size(s);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    const int INF = 1e9;
    const string x("AGCT");
    char letter;
    string t, p;
    cin >> t;
    t = ' ' + t;
    vector<char> s(1, ' ');
    vector<string> c(1);
    for (int i = 1; i < t.size(); ++i) {
        if (is_digit(t[i])) {
            if (!is_digit(t[i - 1]))
                c.push_back("");
            c.back().push_back(t[i]);
        } else {
            if (!is_digit(t[i - 1]))
                c.push_back("");
            s.push_back(t[i]);
        }
    }
    int n = s.size() - 1;
    s.push_back(' ');
    c.push_back("");
    vector<int> a(s.size()), sum(s.size());
    for (int i = 1; i <= n; ++i)
        a[i] = to_int(c[i]);
    for (int i = 1; i <= n; ++i)
        p += string(a[i], s[i]);
    int j = 1, k = 0, ans = INF;
    for(int i = 0; i < p.size(); ++i) {
        int res = slv1(p, i);
        if (res < ans) {
            ans = res;
            j = i + 1;
        }
    }
    for(int i = 0; i <= p.size(); ++i) {
        for (auto it : x) {
            int res = slv2(p, i, it);
            if (res > ans) {
                ans = res;
                k = i;
                letter = it;
            }
        }
    }
    cout << 2 << ' ' << j << endl;
    cout << 1 << ' ' << k << ' ' << x[x.find_first_not_of(p)] << endl;
    return 0;
}
