#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <tuple>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <numeric>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
bool is_digit(char c) {
    return c >= '0' && c <= '9';
}
int to_int(string & s) {
    int ans = 0;
    for (auto c : s)
        ans = 10 * ans + (c - '0');
    return max(ans, 1);
}
int len(int a) {
    int count = 0;
    while (a) {
        ++count;
        a /= 10;
    }
    return count;
}
bool pow10(string & s) {
    if (s.size() <= 1)
        return false;
    else
        return s[0] == 1 && s.find_first_not_of('0', 1) == string::npos;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    const string x("AGCT");
    string t;
    cin >> t;
    t = ' ' + t;
    vector<char> s(1, ' ');
    vector<string> c(1);
    for (int i = 1; i < t.size(); ++i) {
        if (is_digit(t[i])) {
            if (!is_digit(t[i - 1]))
                c.push_back("");
            c.back().push_back(t[i]);
        } else {
            if (!is_digit(t[i - 1]))
                c.push_back("");
            s.push_back(t[i]);
        }
    }
    int n = s.size() - 1;
    s.push_back(' ');
    c.push_back("");
    vector<int> a(s.size()), sum(s.size());
    for (int i = 1; i <= n; ++i)
        a[i] = to_int(c[i]);
    partial_sum(a.begin(), a.end(), sum.begin());
    int k = max_element(a.begin() + 1, a.end() - 1) - a.begin();
    if (!c[k].empty() && c[k][0] == '1') {
        if (c[k].size() == 2) {
            auto it = find_if(a.begin(), a.end(), [](auto & a) { return 4 <= a && a < 10; });
            if (it != a.end())
                k = it - a.begin();
        } else if (c[k].size() > 2) {
            auto it = find_if(c.begin(), c.end(), [x = int(c[k].size()) - 1](auto & a) { return a.size() == x && a[0] >= '2'; });
            if (it != c.end())
                k = it - c.begin();
        }
    }
    string p;
    p.push_back(s[k - 1]);
    p.push_back(s[k]);
    p.push_back(s[k + 1]);
    int j = 1, ans = 0;
    for (int i = 1; i <= n; ++i) {
        if (a[i] == 1) {
            int res = 1;
            if (t[i - 1] == t[i + 1])
                res += len(a[i + 1] + a[i - 1]) + 1 - c[i - 1].size() - c[i + 1].size();
            if (res > ans) {
                ans = res;
                j = sum[i];
            }
        }
    }
    if (!ans)
        for (int i = 1; i <= n; ++i)
            if (a[i] == 2 || pow10(c[i]))
                j = sum[i];
    cout << 2 << ' ' << j << endl;
    cout << 1 << ' ' << sum[k] - a[k] / 2 << ' ' << x[x.find_first_not_of(p)] << endl;
    return 0;
}
