#include <bits/stdc++.h>
#define int long long
#ifndef LOCAL
#define endl '\n'
#endif

using namespace std;

void solve() {
  int n, m;
  cin >> n >> m;
  int ans = 0;
  long long nmsum = n * m * 1LL * (n * m + 1) / 2;
  long long ans_val = LONG_LONG_MAX;
  int ans_dir = -1;
  { // Vertical cut
    if (m > 1) {
      long long n1sum = n * 1LL * (n - 1) / 2;
      int L = 0;
      int R = m - 1;
      while (R - L > 1) {
        int M = (R + L) / 2;
        long long Lsum = M * 1LL * (M + 1) / 2 * n + M * 1LL * m * n1sum;
        long long Rsum = nmsum - Lsum;
        if (Lsum <= Rsum)
          L = M;
        else
          R = M;
      }
      for (int cur = L - 1; cur <= L + 1; cur++) {
        if (cur < 0 || cur >= m)
          continue;
        long long cursum = cur * 1LL * (cur + 1) / 2 * n + cur * 1LL * m * n1sum;
        if (abs(cursum - (nmsum - cursum)) < ans_val) {
          ans = cur;
          ans_val = abs(cursum - (nmsum - cursum));
          ans_dir = 0;
        }
      }
    }
  }
  { // Horizontal cut
    if (n > 1) {
      int L = 0;
      int R = n - 1;
      while (R - L > 1) {
        int M = (L + R) / 2;
        int Llast = M * m;
        long long Lsum = Llast * 1LL * (Llast + 1) / 2;
        long long Rsum = nmsum - Lsum;
        if (Lsum <= Rsum)
          L = M;
        else
          R = M;
      }
      for (int cur = L - 1; cur <= L + 1; cur++) {
        if (cur < 0 || cur >= n)
          continue;
        int curlast = cur * m;
        int cursum = curlast * (curlast + 1) / 2;
        if (abs(cursum - (nmsum - cursum)) < ans_val) {
          ans_val = abs(cursum - (nmsum - cursum));
          ans_dir = 1;
          ans = cur;
        }
      }
    }
  }
  assert(ans_dir != -1);
  if (ans_dir) {
    cout << "H ";
  } else {
    cout << "V ";
  }
  cout << ans + 1 << endl;

}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}