#include <bits/stdc++.h>

using namespace std;

char chars[4] = {'A', 'C', 'G', 'T'};

char any_except_two(char f1, char f2) {
  for (auto c : chars) {
    if (c!= f1 && c != f2)
      return c;
  }
  return 0;
}


int codelen(string& target) {
  string res;
  int cnt = 0;
  char cur = target[0];
  for (auto c : target) {
    if (c == cur)
      cnt++;
    else {
      if (cnt > 1)
        res.append(to_string(cnt));
      res.push_back(cur);
      cur = c;
      cnt = 1;
    }
  }
  return res.length();
}

signed main() {
  string s;
  cin >> s;
  int cur_cnt = 0;
  string orig;
  for (auto c : s) {
    if ('0' <= c && c <= '9') {
      cur_cnt *= 10;
      cur_cnt += (c - '0');
    } else {
      if (cur_cnt == 0)
        cur_cnt = 1;
      orig.append(string(cur_cnt, c));
      cur_cnt = 0;
    }
  }
  int n = orig.size();
  int ans_min = INT_MAX;
  int min_where = -1;
  int ans_max = 0;
  int max_where = -1;
  char max_what = 0;
  for (int i = 0; i < n; i++) {
    char prev_c = orig[i];
    char cur_c = orig[i];
    if (i > 0) {
      prev_c = orig[i - 1];
    }
    char any_new = any_except_two(cur_c, prev_c);
    orig.erase(orig.begin() + i);
    int del_len = codelen(orig);
    orig.insert(orig.begin() + i, cur_c);
    if (del_len < ans_min) {
      ans_min = del_len;
      min_where = i;
    }
    orig.insert(orig.begin() + i + 1, any_new);
    int new_ins_len = codelen(orig);
    orig.erase(orig.begin() + i + 1);
    if (new_ins_len > ans_max) {
      ans_max = new_ins_len;
      max_where = i;
      max_what = any_new;
    }
    orig.insert(orig.begin() + i + 1, cur_c);
    int cur_ins_len = codelen(orig);
    orig.erase(orig.begin() + i + 1);
    if (cur_ins_len > ans_max) {
      ans_max = cur_ins_len;
      max_where = i;
      max_what = cur_c;
    }
  }
  cout << 2 << ' ' << min_where + 1 << endl;
  cout << 1 << ' ' << max_where + 1 << ' ' << max_what << endl;
  return 0;
}