#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>

#define int long long int

using namespace std;

vector <int> checkCol(int n, int m)
{
    int s1 = ((2 + (n - 1) * m) * n) / 2;
    int so = ((1 + n * m) * (n * m)) / 2;
    int s = s1;
    int bestI = 0, best = abs(s - (so - s));
    for (int i = 1; i < m; i++)
    {
        s = (i + 1) * s1 + (n * i * (i + 1)) / 2;
        if (abs(s - (so - s)) < best)
        {
            best = abs(s - (so - s));
            bestI = i;
        }
    }
    /*int B[n][m];
    B[0][0] = 1;
    for (int i = 0; i < n; i++)
    {
        if (i != 0) B[i][0] = B[i - 1][m - 1] + 1;
        for (int j = 1; j < m; j++)
        {
            B[i][j] = B[i][j - 1] + 1;
        }
    }
    int sum = 1e9, ans = -1;
    for (int c = 0; c < m; c++)
    {
        int sum1 = 0, sum2 = 0;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < c; j++)
            {
                sum1 = sum1 + B[i][j];
            }
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = c; j < m; j++)
            {
                sum2 = sum2 + B[i][j];
            }
        }
        if (abs(sum1 - sum2) < sum)
        {
            sum = abs(sum1 - sum2);
            ans = c;
        }
    }
    vector <int> A;
    A.push_back(ans);
    A.push_back(sum);
    return(A);*/
    //cout << ans + 1 << " " << sum << endl;
    vector <int> A;
    A.push_back(bestI);
    A.push_back(best);
    return(A);
}
vector <int> checkRow(int n, int m)
{
    int s1 = ((1 + m) * m) / 2;
    int so = ((1 + n * m) * (n * m)) / 2;
    int s = s1;
    int bestI = 0, best = abs(s - (so - s));
    for (int i = 1; i < n; i++)
    {
        s = (i + 1) * s1 + (n * m * i * (i + 1)) / 2;
        //cout << i << " " << s << " " << abs(s - (so - s)) << endl;
        if (abs(s - (so - s)) < best)
        {
            best = abs(s - (so - s));
            bestI = i;
        }
    }
    vector <int> A;
    A.push_back(bestI);
    A.push_back(best);
    return(A);
    /*int B[n][m];
    B[0][0] = 1;
    for (int i = 0; i < n; i++)
    {
        if (i != 0) B[i][0] = B[i - 1][m - 1] + 1;
        for (int j = 1; j < m; j++)
        {
            B[i][j] = B[i][j - 1] + 1;
        }
    }
    int sum = 1e9, ans = -1;
    for (int c = 0; c < n; c++)
    {
        int sum1 = 0, sum2 = 0;
        for (int i = 0; i < c; i++)
        {
            for (int j = 0; j < m; j++)
            {
                sum1 = sum1 + B[i][j];
            }
        }
        for (int i = c; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                sum2 = sum2 + B[i][j];
            }
        }
        if (abs(sum1 - sum2) < sum)
        {
            sum = abs(sum1 - sum2);
            ans = c;
        }
    }
    vector <int> A;
    A.push_back(ans);
    A.push_back(sum);
    return(A);*/
}

int32_t main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        int n, m;
        cin >> n >> m;
        vector <int> col = checkCol(n, m);
        vector <int> row = checkRow(n, m);
        if (col[1] <= row[1])
        {
            cout << "V " << col[0] + 2 << endl;
        }
        else
        {
            cout << "H " << row[0] + 2 << endl;
        }
    }
}
