#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>

#define int long long int

using namespace std;

struct str
{
    int a;
    char s;
};
int numberLength(int num)
{
    if (num == 1) return(0);
    int cou = 0;
    while (num > 0)
    {
        num = num / 10;
        cou++;
    }
    return(cou);
}
string intToString(int num)
{
    string res = "";
    while (num > 0)
    {
        char t = (char)(num % 10 + (int)('0'));
        res = "!" + res;
        res[0] = t;
        num = num / 10;
    }
    return(res);
}

int32_t main()
{
    string s;
    getline(cin, s);
    vector <str> A;
    int mini = s.size(), maxi = s.size(), length = s.size();
    while(s.size() > 0)
    {
        if (s[0] >= '0' && s[0] <= '9')
        {
            int num = 0, i = 0;
            while (s[i] >= '0' && s[i] <= '9')
            {
                num = num * 10 + (int)(s[i]) - (int)('0');
                i++;
            }
            A.push_back({num, s[i]});
            s.erase(0, i + 1);
        }
        else
        {
            A.push_back({1, s[0]});
            s.erase(0, 1);
        }
    }
    string miniAns = "", maxiAns = "";
    int sum = A[0].a;
    for (int i = 1; i < A.size() - 1; i++)
    {
        if (A[i].a == 1)
        {
            if (A[i - 1].s == A[i + 1].s)
            {
                int len = length - numberLength(A[i - 1].a) - numberLength(A[i + 1].a) - 2 + numberLength(A[i - 1].a + A[i + 1].a);
                if (mini > len)
                {
                    mini = len;
                    miniAns = "2 " + intToString(sum + 1);
                }
            }
            else
            {
                if (mini > length - 1)
                {
                    mini = length - 1;
                    miniAns = "2 " + intToString(sum + 1);
                }
            }
        }
        else
        {
            int len = length - numberLength(A[i].a) + numberLength(A[i].a - 1);
            if (mini > len)
            {
                mini = len;
                miniAns = "2 " + intToString(sum + 1);
            }
        }
        sum = sum + A[i].a;
    }
    if (A[0].a == 1)
    {
        if (mini > length - 1)
        {
            mini = length - 1;
            miniAns = "2 1";
        }
    }
    else
    {
        int len = length - numberLength(A[0].a) + numberLength(A[0].a - 1);
        if (mini > len)
        {
            mini = len;
            miniAns = "2 1";
        }
    }
    if (A[A.size() - 1].a == 1)
    {
        if (mini > length - 1)
        {
            mini = length - 1;
            miniAns = "2 " + intToString(A.size());
        }
    }
    else
    {
        int len = length - numberLength(A[A.size() - 1].a) + numberLength(A[A.size() - 1].a - 1);
        if (mini > len)
        {
            mini = len;
            miniAns = "2 " + intToString(A.size());
        }
    }
    if (miniAns.size() == 0)
    {
        miniAns = "2 1";
    }
    cout << miniAns << endl;
    maxi = length + 1;
    maxiAns = "1 0 C";
    if (A[0].s == 'C') maxiAns = "1 0 A";
    sum = 0;
    for (int i = 0; i < A.size(); i++)
    {
        if (A[i].a != 1)
        {
            if (A[i].a == 2)
            {
                if (maxi < length + 1)
                {
                    maxi = length + 2;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 1) + " A";
                    else maxiAns = "1 " + intToString(sum + 1) + " C";
                }
            }
            if (A[i].a == 3)
            {
                if (maxi < length + 2)
                {
                    maxi = length + 2;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 1) + " A";
                    else maxiAns = "1 " + intToString(sum + 1) + " C";
                }
            }
            if (A[i].a > 3 && A[i].a < 12)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 5)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 5;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 2) + " A";
                    else maxiAns = "1 " + intToString(sum + 2) + " C";
                }
            }
            if (A[i].a >= 12 && A[i].a < 20)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 6)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 6;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 10) + " A";
                    else maxiAns = "1 " + intToString(sum + 10) + " C";
                }
            }
            if (A[i].a >= 20 && A[i].a < 110)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 7)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 7;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 10) + " A";
                    else maxiAns = "1 " + intToString(sum + 10) + " C";
                }
            }
            if (A[i].a >= 110 && A[i].a < 200)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 8)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 8;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 100) + " A";
                    else maxiAns = "1 " + intToString(sum + 100) + " C";
                }
            }
            if (A[i].a >= 200 && A[i].a < 1100)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 9)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 9;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 100) + " A";
                    else maxiAns = "1 " + intToString(sum + 100) + " C";
                }
            }
            if (A[i].a >= 1100 && A[i].a < 2000)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 10)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 10;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 1000) + " A";
                    else maxiAns = "1 " + intToString(sum + 1000) + " C";
                }
            }
            if (A[i].a >= 2000 && A[i].a < 11000)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 11)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 11;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 1000) + " A";
                    else maxiAns = "1 " + intToString(sum + 1000) + " C";
                }
            }
            if (A[i].a >= 11000 && A[i].a < 20000)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 12)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 12;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 10000) + " A";
                    else maxiAns = "1 " + intToString(sum + 10000) + " C";
                }
            }
            if (A[i].a >= 20000)
            {
                if (maxi < length - numberLength(A[i].a) - 1 + 13)
                {
                    maxi = length - numberLength(A[i].a) - 1 + 13;
                    if (A[i].s == 'C') maxiAns = "1 " + intToString(sum + 10000) + " A";
                    else maxiAns = "1 " + intToString(sum + 10000) + " C";
                }
            }
        }
        sum = sum + A[i].a;
    }
    cout << maxiAns << endl;
    return 0;
}
//5AC5A2C
