#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>

/*
3
1 7
3
1 8
6
2 8
1 6

4
1 5
0
1 0
0
1 3
3
1 0
0
*/

using namespace std;

string intToString(int num)
{
    if (num == 0) return("0");
    string res = "";
    while (num > 0)
    {
        char t = (char)(num % 10 + (int)('0'));
        res = "!" + res;
        res[0] = t;
        num = num / 10;
    }
    return(res);
}
struct str
{
    int m;
    int s;
    vector <int> p;
    int ind;
};
int n, dG = -1;
string answer = "";
void gen(vector <str> A, vector <str> ans, int last, int d)
{
    if (answer.size() != 0) return;
    if (A.size() == 0)
    {
        for (int i = 0; i < ans.size(); i++)
        {
            answer = answer + intToString(ans[i].ind) + " ";
        }
        return;
    }
    if (ans.size() == 0)
    {
        for (int i = 0; i < A.size(); i++)
        {
            vector <str> B = A;
            B.erase(B.begin() + i);
            vector <str> ans2 = ans;
            ans2.push_back(A[i]);
            gen(B, ans2, A[i].s - A[i].p[A[i].p.size() - 1], d);
        }
        return;
    }
    if (ans.size() == 1 && d == -1)
    {
        for (int i = 0; i < A.size(); i++)
        {
            vector <str> B = A;
            B.erase(B.begin() + i);
            vector <str> ans2 = ans;
            ans2.push_back(A[i]);
            gen(B, ans2, A[i].s - A[i].p[A[i].p.size() - 1], A[i].p[0] + ans[0].s - ans[0].p[ans[0].p.size() - 1]);
        }
        return;
    }
    for (int i = 0; i < A.size(); i++)
    {
        if (A[i].p[0] + last == d || A[i].p[0] + last == 0)
        {
            vector <str> B = A;
            B.erase(B.begin() + i);
            vector <str> ans2 = ans;
            ans2.push_back(A[i]);
            gen(B, ans2, A[i].s - A[i].p[A[i].p.size() - 1], d);
        }
    }
}

int main()
{
    cin >> n;
    vector <str> A(n);
    for (int i = 0; i < n; i++)
    {
        cin >> A[i].m >> A[i].s;
        A[i].ind = i + 1;
        A[i].p.resize(A[i].m);
        for (int j = 0; j < A[i].m; j++)
        {
            cin >> A[i].p[j];
            if (j > 0)
            {
                if (dG != -1 && dG != A[i].p[j] - A[i].p[j - 1])
                {
                    cout << "No";
                    return 0;
                }
                dG = A[i].p[j] - A[i].p[j - 1];
            }
        }
    }
    vector <str> t;
    gen(A, t, -1, dG);
    if (answer.size() == 0)
    {
        cout << "No";
        return 0;
    }
    cout << "Yes" << endl << answer;
}
