#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <stack>

#define int long long int

using namespace std;

vector <vector <int> > P;

void genPermuts(vector <int> A, vector <int> res)
{
    if (A.size() == 0)
    {
        P.push_back(res);
        return;
    }
    for (int i = 0; i < A.size(); i++)
    {
        vector <int> t = A;
        vector <int> res2 = res;
        res2.push_back(A[i]);
        t.erase(t.begin() + i);
        genPermuts(t, res2);
    }
}

int32_t main()
{
    int a, b, c;
    cin >> a >> b >> c;
    vector <int> A, B, C;
    while (a > 0)
    {
        A.push_back(a % 10);
        a = a / 10;
    }
    while (b > 0)
    {
        B.push_back(b % 10);
        b = b / 10;
    }
    while (c > 0)
    {
        C.push_back(c % 10);
        c = c / 10;
    }
    int maxi = max(max(A.size(), B.size()), C.size());
    while (A.size() < maxi)
    {
        A.push_back(0);
    }
    while (B.size() < maxi)
    {
        B.push_back(0);
    }
    while (C.size() < maxi)
    {
        C.push_back(0);
    }
    vector <int> t;
    for (int i = 0; i < A.size(); i++)
    {
        t.push_back(i);
    }
    vector <int> res;
    genPermuts(t, res);
    int cou = 0;
    for (int i = 0; i < P.size(); i++)
    {
        if (A[P[i][0]] == 0 || B[P[i][0]] == 0 || C[P[i][0]] == 0) continue;
        a = b = c = 0;
        for (int j = 0; j < P[i].size(); j++)
        {
            a = a * 10 + A[P[i][j]];
            b = b * 10 + B[P[i][j]];
            c = c * 10 + C[P[i][j]];
        }
        if (a + b == c)
        {
            cou++;
        }
    }
    cout << cou;
    return 0;
}
