#include <bits/stdc++.h>

using namespace std;

#define endl "\n"
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#define int long long
#define double long double

#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

#ifdef LOCAL
#define cin fin
ifstream fin;
#endif

int total(int n, int m) {
    int v = n * m;
    return (v * (v + 1)) / 2;
}

int cut_v(int n, int m, int j) {
    int start = ((1 + (j + 1)) * (j + 1)) / 2;
    int end = (((n * m - m + 1) + (j + n * m - m + 1)) * (j + 1)) / 2;
    int lef = ((start + end) * n) / 2;
    return lef * 2 - total(n, m);
}

int cut_h(int n, int m, int i) {
    int val = (i + 1) * m;
    int up = (val * (val + 1)) / 2;
    return up * 2 - total(n, m);
}

void solve() {
    int n, m;
    cin >> n >> m;

    int resv = IMAX;
    char resl = 0;
    int res = 0;

    int l, r;
    l = 0, r = m - 1;
    while (r > l + 1) {
        int mid = (l + r) / 2;
        if (cut_v(n, m, mid) <= 0) {
            l = mid;
        } else {
            r = mid;
        }
    }
    for (int j = max(l - 10, (int)0); j < min(l + 10, m); j++) {
        int curr = abs(cut_v(n, m, j));
        if (curr < resv) {
            resv = curr;
            res = j + 1;
            resl = 'V';
        }
    }

    l = 0, r = n - 1;
    while (r > l + 1) {
        int mid = (l + r) / 2;
        if (cut_h(n, m, mid) <= 0) {
            l = mid;
        } else {
            r = mid;
        }
    }
    for (int i = max(l - 10, (int)0); i < min(l + 10, n); i++) {
        int curr = abs(cut_h(n, m, i));
        if (curr < resv) {
            resv = curr;
            res = i + 1;
            resl = 'H';
        }
    }

    cout << resl << " " << res + 1 << endl;
}

#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin = ifstream("in.txt");
#endif
    ON_START
#ifdef MULTITEST
    int32_t tests_;
    cin >> tests_;
    for (int32_t asd = 0; asd < tests_; asd++) {
#endif
    solve();
#ifdef MULTITEST
    }
#endif
    ON_START
}
