#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

int main() {
	ll t, n, m, x, sum;
	cin >> t;
	for (ll tt = 0; tt < t; tt++) {
		cin >> n >> m;
		ll ans1 = 2e18, ans2 = 2e18, x1, x2;
		sum = (n * m) * (n * m + 1) / 2;
		ll l = 0, r = m, mid;
		while (l + 1 < r) {
			mid = (l + r) / 2;
			x = mid * (mid + 1) / 2 * n + m * mid * n * (n - 1) / 2;

			if (ans1 > abs(x - (sum - x))) {
				ans1 = abs(x - (sum - x));
				x1 = mid;
			}

			if (ans1 == abs(x - (sum - x)) && mid < x1) {
				x1 = mid;
			}

			if (x < sum - x) {
				l = mid;
			}
			else {
				r = mid;
			}
		}



		l = 0; r = n;
		while (l + 1 < r) {
			mid = (l + r) / 2;
			x = (mid * m) * (mid * m + 1) / 2;
			if (ans2 > abs(x - (sum - x))) {
				ans2 = abs(x - (sum - x));
				x2 = mid;
			}

			if (ans2 == abs(x - (sum - x)) && mid < x2) {
				x2 = mid;
			}

			if (x < sum - x) {
				l = mid;
			}
			else {
				r = mid;
			}
		}

		if (ans1 <= ans2) {
			cout << "V " << x1 + 1;
		}
		else {
			cout << "H " << x2 + 1;
		}
		cout << "\n";
	}
}