#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

vector <ll> ans;

void build() {
	//vector <ll> num(18);
	for (ll size_num = 1; size_num <= 18; size_num++) {
		for (ll i = 0; i < size_num; i++) {
			for (ll x = 0; x <= 9; x++) {
				for (ll y = 0; y <= 9; y++) {
					ll res = 0;
					for (ll j = 0; j < size_num; j++) {
						res *= 10;
						if (i != j) {
							res += y;
						}
						else {
							res += x;
						}
					}
					ans.push_back(res);
				}
			}
		}
	}
	sort(ans.begin(), ans.end());
}

int main() {
	ll x, k;
	string s;
	cin >> x >> k;
	ll xx, n;
	xx = x;
	while (xx > 0) {
		s += char('0' + xx % 10);
		xx /= 10;
	}
	reverse(s.begin(), s.end());

	if (k == 1) {
		build();
		cout << (*lower_bound(ans.begin(), ans.end(), x));
	}
	else {
		ll x1 = 0, x2 = 0;
		for (int i = 0; i < s.size(); i++) {
			x1 *= 10;
			x2 *= 10;

			x1 += ll(s[0] - '0');
			if (s[0] != '9') {
				x2 += ll(s[0] - '0' + 1);
			}
			else {
				x2 += 1;
			}
		}

		if (s[0] == '9') {
			x2 *= 10;
			x2 += 1;
		}
		if (x <= x1) {
			cout << x1;
		}
		else {
			cout << x2;
		}
	}
}