#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define mp make_pair
#define endl '\n'
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef double db;
typedef long double ldb;
typedef unsigned long long ull;

const int MOD = 1000000007;

random_device rd;
mt19937 rnd(rd());
int cnt[4];
const int N = 400040;
const int kek = 783075876;
ll facts[N], nofacts[N];

ll mult(ll a, ll b) {
    return a * b % MOD;
}

ll C(ll n, ll k) {
    if (k > n) {
        return 1;
    }
    return mult(facts[n], mult(nofacts[k], nofacts[n - k]));
}

signed main() {
    fastream;
    facts[0] = 1;
    for (int i = 1; i < N; i++) {
        facts[i] = mult(facts[i - 1], i);
    }
    nofacts[N - 1] = kek;
    for (int i = N - 2; i >= 0; i--) {
        nofacts[i] = mult(nofacts[i + 1], (i + 1));
    }

    string a, b, c;
    cin >> a >> b >> c;
    int n = a.size();
    for (int i = 0; i < n; i++) {
        int x = a[i] - '0', y = b[i] - '0', z = c[i] - '0';
        if (x + y == z) {
            cnt[0]++;
        } else if (x + y + 1 == z) {
            cnt[1]++;
        } else if (x + y - 10 == z) {
            cnt[2]++;
        } else if (x + y - 10 + 1 == z) {
            cnt[3]++;
        } else {
            cout << "0\n";
            return 0;
        }
    }
    if (abs(cnt[1] - cnt[2]) > 0) {
        cout << "0\n";
        return 0;
    }
    ll res = 1;
    if (cnt[1] == 0 && cnt[2] == 0) {
        if (cnt[0] != 0 && cnt[3] != 0) {
            cout << "0\n";
            return 0;
        }
        if (cnt[0] == 0 && cnt[3] != 0) {
            cout << "0\n";
            return 0;
        }
    } else {
        res = mult(C(cnt[0] + cnt[2], cnt[0]), C(cnt[3] + cnt[2] - 1, cnt[3]));
        // res += mult(C(cnt[0] + cnt[1] - 1, cnt[0]), C(cnt[3] + cnt[1], cnt[3]));
        res %= MOD;
    }
    for (int i = 0; i < 4; i++) {
        res = mult(res, facts[cnt[i]]);
    }
    cout << res << endl;
}
