// Shrek is love, shrek is life
#include <iostream>
//#include <vector>
//#include <algorithm>
//#include <functional>
//#include <cmath>
//#include <set>
//#include <iomanip>

#define int long long
#define all(x) x.begin() x.end()

using namespace std;

int readInt(){
    int r;
    cin >> r;
    return r;
}

int horizontal_split_sub_task(int n, int m, int i, int sum_all){
    int d = i - 1;
    int double_left = m * d * (m * d + 1);
    int res = abs(double_left - sum_all);
    return res;
}

pair<int, int> horizontal_split(int n, int m){
    int min_res = 3000000000000000000;
    int res_i = -1;

    int subtract_const = (m * n * (m * n + 1)) / 2;

    for (int i = 1; i <= n; i++){
        int res = horizontal_split_sub_task(n, m, i, subtract_const);
        if (res < min_res){
            min_res = res;
            res_i = i;
        }
    }
    return {min_res, res_i};
}

int vertical_split_sub_task(int n, int m, int i, int sum_all){
    int d = i - 1;
    int double_left = (m * d * n * (n - 1)) + (n * d * (d + 1));
    int res = abs(double_left - sum_all);
    return res;
}

pair<int, int> vertical_split(int n, int m){
    int min_res = 3000000000000000000;
    int res_i = -1;

    int subtract_const = (m * n * (m * n + 1)) / 2;

    for (int i = 1; i <= m; i++){
        int res = vertical_split_sub_task(n, m, i, subtract_const);
        if (res < min_res){
            min_res = res;
            res_i = i;
        }
    }
    return {min_res, res_i};
}

signed main(){
    int t = readInt();
    for (int q = 0; q < t; q++){
        int n = readInt();
        int m = readInt();

        pair<int, int> hor_res = horizontal_split(n, m);
        pair<int, int> vert_res = vertical_split(n, m);
        if (hor_res.first < vert_res.first){
            cout << "H " << hor_res.second << "\n";
        } else {
            cout << "V " << vert_res.second << "\n";
        }
    }
    return 0;
}
