def getH(n, m, h):
    a1 = (m * h + 1) * (m * h) // 2
    a2 = (n * m) * (n * m + 1) // 2 - a1
    return abs(a1 - a2)


def solveH(n, m):
    l = 0
    r = n + 1
    while r - l > 6:
        m1 = l + (r - l) // 3
        m2 = l + (r - l) * 2 // 3
        if getH(n, m, m1) > getH(n, m, m2):
            l = m1
        else:
            r = m2
    res = getH(n, m, l)
    ind = l
    for i in range(l + 1, r + 1):
        nres = getH(n, m, i)
        if nres < res:
            res = nres
            ind = i
    return ind, res


def getW(n, m, w):
    a1 = n * (n - 1) // 2 * m * w + n * ((1 + w) * w) // 2
    a2 = (n * m) * (n * m + 1) // 2 - a1
    return abs(a1 - a2)


def solveW(n, m):
    l = 0
    r = m + 1
    while r - l > 6:
        m1 = l + (r - l) // 3
        m2 = l + (r - l) * 2 // 3
        if getW(n, m, m1) > getW(n, m, m2):
            l = m1
        else:
            r = m2
    res = getW(n, m, l)
    ind = l
    for i in range(l + 1, r + 1):
        nres = getW(n, m, i)
        if nres < res:
            res = nres
            ind = i
    return ind, res


def solve(n, m):
    h, resh = solveH(n, m)
    v, resv = solveW(n, m)
    if resh < resv:
        print('H', h + 1)
    else:
        print('V', v + 1)


for i in range(int(input())):
# for i in range(1):
    n, m = map(int, input().split())
    # n, m = 4, 7
    solve(n, m)
