#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

int mul(int a, int b) {
  return a * b % MOD;
}

int factorial(int x) {
  int f = 1;
  for (int i = 2; i <= x; ++i)
    f = mul(f, i);
  return f;
}

int binpow(int x, int p) {
  if (p == 0)
    return 1;
  if (p % 2 == 0)
    return binpow(x * x % MOD, p / 2);
  else
    return x * binpow(x, p - 1) % MOD;
}

int divi(int a, int b) {
  return a * binpow(b, MOD - 2) % MOD;
}

int C(int n, int k) {
  return divi(divi(factorial(n), factorial(n - k)), factorial(k));
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  string sa, sb, sc;
  cin >> sa >> sb >> sc;
  int n = sa.size();
  int cnt_o = 0, cnt_i = 0, cnt_ = 0, cnt_io = 0;
  int cnte = 0;
  for (int i = 0; i < n; ++i) {
    int a = sa[i] - '0', b = sb[i] - '0', c = sc[i] - '0';
    int x = (a + b) % 10;
    if (x == c) {
      if (x >= 10) cnt_o++;
      else cnt_++;
      cnte += a != 0 && b != 0 && x < 10;
      continue;
    }
    int y = (a + b + 1) % 10;
    if (y == c) {
      if (x >= 10) cnt_io++;
      else cnt_i++;
      cnte += a != 0 && b != 0 && y < 10;
      continue;
    }
    cout << 0;
    return 0;
  }
  if (cnt_i != cnt_o) {
    cout << 0;
    return 0;
  }
  int ans = C(cnt_i + cnt_, cnt_);
  ans = mul(ans, factorial(cnt_));
  ans = mul(ans, factorial(cnt_i));
  ans = mul(ans, factorial(cnt_i));
  ans = mul(ans, C(cnt_io + cnt_i - 1, cnt_i - 1));
  ans = mul(ans, factorial(cnt_io));
  cout << ans;
  return 0;
}
