#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

int mul(int a, int b) {
  return a * b % MOD;
}

int factorial(int x) {
  int f = 1;
  for (int i = 2; i <= x; ++i)
    f = mul(f, i);
  return f;
}

int binpow(int x, int p) {
  if (p == 0)
    return 1;
  if (p % 2 == 0)
    return binpow(x * x % MOD, p / 2);
  else
    return x * binpow(x, p - 1) % MOD;
}

int divi(int a, int b) {
  return a * binpow(b, MOD - 2) % MOD;
}

int C(int n, int k) {
  return divi(divi(factorial(n), factorial(n - k)), factorial(k));
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  string sa, sb, sc;
  cin >> sa >> sb >> sc;
  int n = sa.size();
  vector<int> inds(n);
  iota(inds.begin(), inds.end(), 0);
  int ans = 0;
  do {
    string a, b, c;
    for (int i : inds) {
      a.push_back(sa[i]);
      b.push_back(sb[i]);
      c.push_back(sc[i]);
    }
    if (a[0] == '0' || b[0] == '0' || c[0] == '0')
      continue;
    int aa = stoll(a);
    int bb = stoll(b);
    int cc = stoll(c);
    ans += aa + bb == cc;
  } while (next_permutation(inds.begin(), inds.end()));
  cout << ans;
}
