#include <iostream>
#include <vector>
#include <queue>
#include <stack>
#include <algorithm>
#include <sstream>
#include <math.h>
#include <cmath>
#include <set>

using namespace std;
#define LL long long

bool genGood(int c, vector<vector<int>> previous, vector<vector<int>>& result) {
    bool ok = true;
    for (int i = 0; i < previous.size(); i++)
    {
        for (int j = 0; j < previous[i].size(); j++)
        {
            for (int k = i+1; k < previous.size(); k++)
            {
                for (int l = j+1; l < previous[k].size(); l++)
                {
                    int base = previous[i][j];
                    if (base == -1) {
                        continue;
                    }
                    if (previous[i][l] != base) {
                        continue;
                    }
                    if (previous[k][j] != base) {
                        continue;
                    }
                    if (previous[k][l] != base) {
                        continue;
                    }

                    ok = false;
                    break;
                }
                if (!ok) break;
            }
            if (!ok) break;
        }
        if (!ok) break;
    }
    if (!ok) return false;

    bool found = false;
    for (int i = 0; i < previous.size(); i++)
    {
        for (int j = 0; j < previous[i].size(); j++)
        {
            if (previous[i][j] == -1) {
                found = true;
                for (int k = 0; k < c; k++)
                {
                    vector<vector<int>> res;
                    vector<vector<int>> prevcpy = previous;
                    prevcpy[i][j] = k;
                    bool ok = genGood(c, prevcpy, res);
                    if (ok) {
                        result = res;
                        return true;
                    }
                }
                break;
            }
            
        }
        if (found) break;
    }

    if (!found) {
        result = previous;
        return true;
    }
    else
    {
        return false;
    }
}

int main()
{
    int a, b, c;
    cin >> a;
    cin >> b;
    cin >> c;

    vector<vector<int>> t;
    t.resize(a);
    for (int i = 0; i < a; i++)
    {
        t[i].resize(b, -1);
    }

    vector<vector<int>> answer;
    genGood(c, t, answer);
    for (int i = 0; i < answer.size(); i++)
    {
        for (int j = 0; j < answer[i].size(); j++)
        {
            cout << answer[i][j] + 1 << " ";
        }
        cout << endl;
    }
}
