#include <iostream>
#include <vector>
#include <queue>
#include <stack>
#include <algorithm>
#include <sstream>
#include <math.h>
#include <cmath>
#include <set>

using namespace std;
#define LL long long

bool isOk(vector<vector<int>> previous) {
    bool ok = true;
for (int i = 0; i < previous.size(); i++)
{
    for (int j = 0; j < previous[i].size(); j++)
    {
        for (int k = i+1; k < previous.size(); k++)
        {
            for (int l = j+1; l < previous[k].size(); l++)
            {
                int base = previous[i][j];
                if (base == -1) {
                    continue;
                }
                if (previous[i][l] != base) {
                    continue;
                }
                if (previous[k][j] != base) {
                    continue;
                }
                if (previous[k][l] != base) {
                    continue;
                }

                ok = false;
                break;
            }
            if (!ok) break;
        }
        if (!ok) break;
    }
    if (!ok) break;
}
if (!ok) return false;
return true;
}

bool genGood(int c, vector<vector<int>> previous, vector<vector<int>>& result) {


    bool found = false;
    for (int i = 0; i < previous.size(); i++)
    {
        for (int j = 0; j < previous[i].size(); j++)
        {
            if (previous[i][j] == -1) {
                found = true;
                for (int k = 0; k < c; k++)
                {
                    bool ok = true;
                    for (int l = 0; l < i; l++)
                    {
                        for (int m = 0; m < j; m++)
                        {
                            int base = k;
                            if (previous[l][m] != base) {
                                continue;
                            }
                            if (previous[i][m] != base) {
                                continue;
                            }
                            if (previous[l][j] != base) {
                                continue;
                            }

                            ok = false;
                            break;
                        }
                        if (!ok) break;
                    }
                    if (!ok) continue;

                    vector<vector<int>> res;
                    vector<vector<int>> prevcpy = previous;
                    prevcpy[i][j] = k;
                    bool ok1 = genGood(c, prevcpy, res);
                    if (ok1) {
                        result = res;
                        return true;
                    }
                }
                break;
            }
            
        }
        if (found) break;
    }

    if (!found) {
        result = previous;
        return true;
    }
    else
    {
        return false;
    }
}

int main()
{
    int a, b, c;
    cin >> a;
    cin >> b;
    cin >> c;

    vector<vector<int>> t;
    t.resize(a);
    for (int i = 0; i < a; i++)
    {
        t[i].resize(b, -1);
    }

    if (c == 2 || a * b < 50)
    {
        vector<vector<int>> answer;
        bool res = genGood(c, t, answer);
        if (res) {
            for (int i = 0; i < answer.size(); i++)
            {
                for (int j = 0; j < answer[i].size(); j++)
                {
                    cout << answer[i][j] + 1 << " ";
                }
                cout << endl;
            }
        }
    }
    else
    {
        vector<vector<int>> answer1 = {
            {1, 2, 1, 1, 2, 3, 2, 3, 3},
            {3, 1, 2, 1, 1, 2, 3, 2, 3},
            {3, 3, 1, 2, 1, 1, 2, 3, 2},
            {2, 3, 3, 1, 2, 1, 1, 2, 3},
            {3, 2, 3, 3, 1, 2, 1, 1, 2},
            {2, 3, 2, 3, 3, 1, 2, 1, 1},
            {1, 2, 3, 2, 3, 3, 1, 2, 1},
            {1, 1, 2, 3, 2, 3, 3, 1, 2},
            {2, 1, 1, 2, 3, 2, 3, 3, 1}
        };
        for (int p = 0; p < b; p++)
        {
            for (int q = 0; q < a; q++)
            {
                cout << answer1[p][q] << " ";
            }
            cout << endl;
        }
    }
    
}
