#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>
using namespace std;
#define int long long
vector<char> dna = { 'A', 'C', 'G', 'T' };

vector<pair<char, int>> v;

int del(int i) {
	if (v[i].second == 1) {
		if (i - 1 >= 0 && i + 1 < v.size()) {
			if (v[i - 1].first == v[i + 1].first) {
				return (to_string(v[i - 1].second) + "C" + "C" + to_string(v[i + 1].second) + "C").size() -
					(to_string(v[i - 1].second) + to_string(v[i + 1].second) + 'C').size();
			}
		}
		return 1;
	}
	else if (v[i].second == 2){
		return 1;
	}
	else {
		return (to_string(v[i].second).size() - to_string(v[i].second - 1).size());
	}
}

int add(int i) {
	if (v[i].second == 1)
		return 1;
	return (to_string(v[i].second / 2) + 'C' + 'C' + to_string(v[i].second / 2) + 'C').size() - (to_string(v[i].second) + 'C').size();
}

void solve() {
	string s;
	cin >> s;
	for (int i = 0; i < s.size(); ++i) {
		char c;
		int count = 0;
		while (isdigit(s[i])) {
			count = count * 10 + s[i++] - '0';
		}
		v.emplace_back(s[i], (count == 0 ? 1 : count));
	}
	int char_count = 0;
	int del_c = 0;
	int del_pos;
	int add_c = 0;
	int add_pos;
	char add_char;
	for (int i = 0; i < v.size(); ++i) {
		if (del(i) > del_c) {
			del_c = del(i);
			del_pos = char_count + 1;
		}
		if (add(i) > add_c) {
			add_c = add(i);
			add_pos = char_count + v[i].second / 2;
			add_char = v[i].first;
		}
		char_count += v[i].second;
	}
	for (char each : dna) {
		if (add_char != each) {
			add_char = each;
		}
	}
	cout << 2 << ' ' << del_pos << '\n';
	cout << 1 << ' ' << add_pos << ' ' << add_char;
}

signed main() {
	int t = 1;
	while (t--) {
		solve();
	}
}