#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>
using namespace std;
#define int long long
vector<char> dna = { 'A', 'C', 'G', 'T', 'A', 'C', 'G', 'T' };

vector<pair<char, int>> v;

int del(int i) {
	if (v[i].second == 1) {
		if (i - 1 >= 0 && i + 1 < v.size()) {
			if (v[i - 1].first == v[i + 1].first) {
				return (to_string(v[i - 1].second) + "C" + "C" + to_string(v[i + 1].second) + "C").size() -
					(to_string(v[i - 1].second) + to_string(v[i + 1].second) + 'C').size();
			}
		}
		return 1;
	}
	else if (v[i].second == 2){
		return 1;
	}
	else {
		return (to_string(v[i].second).size() - to_string(v[i].second - 1).size());
	}
}

pair<int, int> add(int i) {
	if (v[i].second == 1)
		return { 1, 1 };
	if (v[i].second == 2)
	{
		return { 1, 1 };
	}
	if (v[i].second == 3)
	{
		return { 2, 1 };
	}
	pair<int, int> fs = { (to_string(v[i].second / 2) + 'C' + 'C' + to_string(v[i].second / 2) + 'C').size() - (to_string(v[i].second) + 'C').size(), v[i].second / 2 };
	string dig = to_string(v[i].second);
	string digit = "";
	int pos;
	bool find = false;
	for (int j = 1; j < dig.size(); ++j)
	{
		if (dig[j] != '0')
		{
			digit = string(dig.begin() + j, dig.end());
			pos = v[i].second - stoll(digit);
			find = true;
			break;
		}
	}
	int sum = (digit + 'C' + 'C' + to_string(v[i].second) + 'C').size() - (to_string(v[i].second) + 'C').size();
	if (!find) {
		return fs;
	}
	else {
		if (fs.first > sum)
		{
			return fs;
		}
		return { sum, pos };
	}
}

void solve() {
	string s;
	cin >> s;
	for (int i = 0; i < s.size(); ++i) {
		char c;
		int count = 0;
		while (isdigit(s[i])) {
			count = count * 10 + s[i++] - '0';
		}
		v.emplace_back(s[i], (count == 0 ? 1 : count));
	}
	int char_count = 0;
	int del_c = 0;
	int del_pos = 1;
	int add_c = 0;
	int add_pos = 1;
	char add_char = 'C';
	for (int i = 0; i < v.size(); ++i) {
		if (del(i) > del_c) {
			del_c = del(i);
			del_pos = char_count + 1;
		}
		if (add(i).first > add_c) {
			add_c = add(i).first;
			add_pos = char_count + add(i).second;
			add_char = v[i].first;
		}
		char_count += v[i].second;
	}
	char start = add_char;
	for (char each : dna) {
		if (each != start) {
			add_char = each;
		}
	}
	cout << 2 << ' ' << del_pos << '\n';
	cout << 1 << ' ' << add_pos << ' ' << add_char;
}

signed main() {
	int t = 1;
	while (t--) {
		solve();
	}
}