#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <vector>
using namespace std;
//#define int long long

//int cnt = 0;
int n, m, c;
vector <vector <char>> v;

bool check(int x1, int y1, int x2, int y2) {
	return (v[x1][y2] == v[x2][y2] && v[x2][y1] == v[x2][y2]);
}

vector<bool> can_be(int x1, int y1) {
	vector <bool> can(c + 1, true);
	for (int x2 = 0; x2 < n; ++x2) {
		if (x2 == x1) {
			continue;
		}
		for (int y2 = 0; y2 < m; ++y2) {
			if (y2 == y1) {
				continue;
			}
			if (check(x1, y1, x2, y2)) {
				can[v[x2][y2]] = false;
			}
		}
	}
	return can;
}

bool gen(int i, int j) {
	if (i == n) {
		return true;
	}
	else {
		vector<bool> can = can_be(i, j);
		for (int k = 1; k <= c; ++k) {
			if (can[k]) {
				v[i][j] = k;
				if (gen(i + ((j + 1) == m), (j + 1) % m)) {
					return true;
				}
			}
		}
		if (i >= 6)
			v[i][j] = 0;
	}
	return false;
}

void solve() {
	cin >> n >> m >> c;
	if (c == 3 && (n >= 8 && m <= 6 || m >= 8 && n <= 6)) {
		v =
		{ {1, 1, 2, 3, 2, 1, 1, 1, 1, 2},
		{1, 2, 1, 1, 1, 3, 2, 2, 3, 1},

		{3, 2, 1, 2, 2, 3, 1, 3, 2, 3 },
		{	2, 1, 1, 2, 3, 2, 2, 3, 3, 2},
		{	2, 1, 2, 3, 3, 3, 3,2, 2, 1 },
		{3, 3, 3, 3, 2, 2, 1, 2, 3, 1} };
		if (n > m) {
			auto nv = v;
			v.resize(n, vector <char>(m));
			for (int j = 0; j < m; ++j) {
				for (int i = 0; i < n; ++i) {
					v[i][j] = nv[j][i];
				}
			}
		}
	}
	else {
		v.resize(n, vector<char>(m, 0));
		gen(0, 0);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << (int)(v[i][j]) << ' ';
		}
		cout << '\n';
	}
}

signed main() {
	int t = 1;
	while (t--) {
		solve();
	}
	return 0;
}