#include <iostream>
#include <vector>
#include <cassert>
#include <string>
#include <math.h>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define ft first
#define sd second
#define ld long double

#define int long long

void solve() {
	int n, m;
	cin >> n >> m;
	int ans = 1e18;
	int ans_ind = -1;
	char type = 'H'; //horizontal
	for (int i = 1; i < n; i++) {
		int curans = m * n * (m * n + 1) / 2 - m * i * (m * i + 1);
		curans = abs(curans);
		if (curans < ans) {
			ans = curans;
			ans_ind = i + 1;
		}
	}
	for (int j = 1; j < m; j++) {
		int curans = (m - 2 * j) * m * n * (n - 1) / 2 + n * (m * (m + 1) / 2 - j * (j + 1));
		curans = abs(curans);
		if (curans < ans) {
			ans = curans;
			ans_ind = j + 1;
			type = 'V';
		}
	}
	cout << type << ' ' << ans_ind << '\n';
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int t = 1;
	cin >> t;
	while (t--)
		solve();
}