#include <iostream>
#include <vector>
#include <cassert>
#include <string>
#include <math.h>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second
#define ld long double

#define int long long

int readnumber(string& s, int& i) {
	if (s[i] < '0' || s[i] > '9')
		return 1;
	int ans = 0;
	while (i < s.length() && s[i] >= '0' && s[i] <= '9') {
		ans = ans * 10 + s[i] - '0';
		i++;
	}
	return ans;
}

bool power_of_ten(int x) {
	bool ans = 
		x == 10 ||
		x == 100 ||
		x == 1000 ||
		x == 10000 ||
		x == 100000 ||
		x == 1000000 ||
		x == 10000000 ||
		x == 100000000 ||
		x == 1000000000;
	return ans;
}

int max_power_of_ten(int x) {
	int ans = 1000000000;
	while (ans > x)
		ans /= 10;
	return ans;
}

string ToString(int num) {
	string ans;
	while (num > 0) {
		ans.pb(num % 10);
		num /= 10;
	}
	reverse(ans.begin(), ans.end());
	return ans;
}

int len(int num) {
	if (num == 1)
		return 0;
	int ans = 0;
	while (num > 0) {
		ans++;
		num /= 10;
	}
	return ans;
}

void solve() {
	vector<pair<int, char>> dnk;
	string s;
	cin >> s;
	int i = 0;
	while (i < s.length()) {
		int num = readnumber(s, i);
		char c = s[i++];
		dnk.pb(mp(num, c));
	}
	int ans = 0;
	int index = 1;
	// to make as short as possible need to delete single symbol between same symbols
	if (dnk[0].ft == 2 || dnk[0].ft == 1 || power_of_ten(dnk[0].ft)) {
		ans = 1;
		index = 1;
	}
	int prefixsum = dnk[0].ft;
	int n = dnk.size();
	for (int i = 1; i < n - 1; i++) {
		if (dnk[i].ft == 2 || power_of_ten(dnk[0].ft))
			if (ans < 1) {
				ans = 1;
				index = prefixsum + 1;
			}
		if (dnk[i].ft == 1)
			if (dnk[i - 1].sd == dnk[i + 1].sd) {
				int curans = 2 + len(dnk[i - 1].ft) + len(dnk[i + 1].ft) - len(dnk[i - 1].ft + dnk[i + 1].ft);
				if (ans < curans) {
					ans = curans;
					index = prefixsum + 1;
				}
			}
			else
				if (ans < 1) {
					ans = 1;
					index = prefixsum + 1;
				}
		prefixsum += dnk[i].ft;
	}
	if (dnk[n - 1].ft == 2 || dnk[n - 1].ft == 1 || power_of_ten(dnk[n - 1].ft))
		if (ans < 1) {
			ans = 1;
			index = prefixsum + 1;
		}
	cout << "2 " << index << '\n';
	map<char, char> next = {
		{'A', 'C'},
		{'C', 'A'},
		{'G', 'T'},
		{'T', 'G'} };
	ans = 1;
	index = 0;
	char val = next[dnk[0].sd];
	prefixsum = 0;
	for (int i = 0; i < n; i++) {
		if (dnk[i].ft > 2) {
			int num1;
			if (dnk[i].ft >= 10)
				num1 = max_power_of_ten(dnk[i].ft);
			else
				num1 = dnk[i].ft / 2;
			if (dnk[i].ft != num1) {
				int curans = 2 + len(num1) + len(dnk[i].ft - num1) - len(dnk[i].ft);
				if (ans < curans) {
					ans = curans;
					index = prefixsum + num1;
					val = next[dnk[i].sd];
				}
			}
			num1 /= 10;
			if (num1 > 0) {
				int curans = 2 + len(num1) + len(dnk[i].ft - num1) - len(dnk[i].ft);
				if (ans < curans) {
					ans = curans;
					index = prefixsum + num1;
					val = next[dnk[i].sd];
				}
			}
		}
		prefixsum += dnk[i].ft;
	}
	cout << "1 " << index << " " << val;
	int zero = 0;
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--)
		solve();
}