#include <iostream>
#include <vector>
#include <cassert>
#include <string>
#include <math.h>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second
#define ld long double

bool is_good(ll n) {
	vector<int> cnt(10);
	while (n > 0) {
		cnt[n % 10]++;
	n /= 10;
}
	vector<pii> digs;
	for (int i = 0; i < 10; i++)
		if (cnt[i] > 0)
			digs.push_back(mp(cnt[i], i));
	if (digs.size() > 2)
		return false;
	if (digs.size() == 1)
		return true;
	sort(digs.begin(), digs.end());
	if (digs[0].ft > 1)
		return false;
	return true;
}

void solve(ll n, int k) {
	if (k) {
		vector<int> digits;
		while (n > 0) {
			digits.pb(n % 10);
			n /= 10;
		}
		reverse(digits.begin(), digits.end());
		int i = 1;
		while (i < digits.size() && digits[i] == digits[0])
			i++;
		if (i == digits.size() || i == digits.size() - 1) {
			for (int d : digits)
				cout << d;
			return;
		}
		//ab....
		if (i == 1) {
			vector<ll> candidates;
			bool good_a = true;
			for (int i = 2; i < digits.size(); i++)
				if (digits[i] < digits[0])
					break;
				else if (digits[i] > digits[0]) {
					good_a = false;
					break;
				}
			if (good_a) {
				ll cur = digits[0] * 10 + digits[1];
				for (int i = 2; i < digits.size(); i++) {
					cur = cur * 10 + digits[0];
				}
				candidates.push_back(cur);
			}
			bool good_b = true;
			for (int i = 2; i < digits.size(); i++)
				if (digits[i] < digits[1])
					break;
				else if (digits[i] > digits[1]) {
					good_b = false;
					break;
				}
			if (good_b) {
				ll cur = digits[0] * 10 + digits[1];
				for (int i = 2; i < digits.size(); i++) {
					cur = cur * 10 + digits[1];
				}
				candidates.push_back(cur);
			}
			if (digits[1] < 9)
				if (digits[1] + 1 == digits[0]) {
					ll cur = (digits[0] * 10 + digits[0]) * 10;
					for (int i = 3; i < digits.size(); i++)
						cur = cur * 10 + digits[0];
					candidates.push_back(cur);
				}
				else {
					ll cur = digits[0] * 10 + digits[1] + 1;
					for (int i = 2; i < digits.size(); i++)
						cur = cur * 10 + min(digits[0], digits[1] + 1);
					candidates.push_back(cur);
				}
			sort(candidates.begin(), candidates.end());
			cout << candidates[0];
			return;
		}
		vector<ll> candidates;
		bool good_a = true;
		for (int j = i + 1; j < digits.size(); j++)
			if (digits[j] < digits[0])
				break;
			else if (digits[j] > digits[0]) {
				good_a = false;
				break;
			}
		if (good_a) {
			ll cur = 0;
			for (int j = 0; j < i; j++)
				cur = cur * 10 + digits[0];
			cur = cur * 10 + digits[1];
			for (int j = i + 1; j < digits.size(); j++)
				cur = cur * 10 + digits[0];
			candidates.push_back(cur);
		}
		if (digits[i] < 9)
			if (digits[1] + 1 == digits[0]) {
				ll cur = (digits[0] * 10 + digits[0]) * 10;
				for (int i = 3; i < digits.size(); i++)
					cur = cur * 10 + digits[0];
				candidates.push_back(cur);
			}
			else {
				ll cur = digits[0] * 10 + digits[1] + 1;
				for (int i = 2; i < digits.size(); i++)
					cur = cur * 10 + digits[0];
				candidates.push_back(cur);
			}
		if (digits[0] < 9) {
			ll cur = 0;
			for (int j = 0; j < i - 1; j++)
				cur = cur * 10 + digits[0];
			cur = cur * 10 + digits[0] + 1;
			for (int j = i; j < digits.size(); j++)
				cur = cur * 10 + digits[0];
			candidates.push_back(cur);
		}
		sort(candidates.begin(), candidates.end());
		cout << candidates[0];
		return;
	}
	else {
		vector<int> digits;
		while (n > 0) {
			digits.pb(n % 10);
			n /= 10;
		}
		reverse(digits.begin(), digits.end());
		bool good = true;
		for (int i = 1; i < digits.size(); i++)
			if (digits[i] < digits[0])
				break;
			else if (digits[i] > digits[0]) {
				good = false;
				break;
			}
		if (good)
			for (int i = 0; i < digits.size(); i++)
				cout << digits[0];
		else if (digits[0] < 9)
			for (int i = 0; i < digits.size(); i++)
				cout << digits[0] + 1;
		else for (int i = 0; i < digits.size() + 1; i++)
			cout << 1;
	}
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--) {
		ll n; int k;
		cin >> n >> k;
		solve(n, k);
	}
	/*vector<int> good;
	for (int i = 1; i < 100000; i++) {
		if (is_good(i))
			good.push_back(i);
	}
	for (int i = 1; i < 3000; i++) {
		cout << i << ' ';
		solve(i, 1);
		cout << ' ';
		cout << *lower_bound(good.begin(), good.end(), i) << '\n';
	}*/
}
