#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cassert>

using namespace std;

int num(int& ind, const string& s) {
	int res = 0;
	while ('0' <= s[ind] && s[ind] <= '9') {
		res = res * 10 + s[ind] - '0'; 
		++ind;
	}
	return res;
}

int firstDeg10(int num) {
	int res = 1;
	while (1LL * res * 10 <= num) {
		res *= 10;
	}
	return res;
}

int cntDigits(int num) {
	if (num == 0) {
		return 1;
	}
	if (num == 1) {
		return 0;
	}
	int res = 0;
	while (num > 0) {
		++res;
		num /= 10;
	}
	return res;
}

void ansMin(const vector<pair<int, char>>& in, int L) {
	int ans = L;
	int ind = 0;
	int type = 2;
	char symb = '-';

	int currInd = 0;
	for (int i = 0; i < in.size(); ++i) {
		if (in[i].first == 2 || firstDeg10(in[i].first) == in[i].first) {
			ind = currInd;
			type = 2;
			ans = L - 1;
			break;
		}
		else if (in[i].first == 1) {
			ind = currInd;
			type = 2;
			ans = L - 1;
		}
		currInd += in[i].first;
	}

	currInd = 0;
	for (int i = 0; i < in.size(); ++i) {
		if (0 < i && i + 1 < (int)in.size() && in[i].first == 1 && in[i - 1].second == in[i + 1].second) {
			int ss = L - 3 - cntDigits(in[i - 1].first) - cntDigits(in[i + 1].first);
			int cnt = cntDigits(in[i - 1].first + in[i + 1].first + 1);
			if (ans > ss + cnt + 1) {
				ans = ss + cnt + 1;
				ind = currInd;
				type = 3;
				symb = in[i - 1].second;
			}
		}
		currInd += in[i].first;
	}

	cout << type;
	if (type == 3) {
		cout <<  " " << ind + 1 << " " << symb << endl;
	}
	else {
		cout << " " << ind + 1 << endl;
	}
}

void ansMax(const vector<pair<int, char>>& in, int L) {
	int ans = L + 1;
	int ind = 0;
	int type = 1;
	char symb = '-';
	if (in[0].second == 'A') {
		symb = 'C';
	}
	else {
		symb = 'A';
	}

	int currInd = 0;
	for (int i = 0; i < in.size(); ++i) {
		
		if (in[i].first > 2) {
			int ss = L - cntDigits(in[i].first) - 1;

			int newSymb = '-';
			if (in[i].second == 'A') {
				newSymb = 'C';
			}
			else {
				newSymb = 'A';
			}

			
			int var1 = ss + cntDigits(in[i].first / 2) + cntDigits((in[i].first + 1) / 2) + 2 + 1;
			int ind1 = currInd + cntDigits(in[i].first / 2) + 1;

			if (in[i].first > 10) {
				int d = firstDeg10(in[i].first);
				int var2 = ss + cntDigits(in[i].first - d) + cntDigits(d) + 2 + 1;
				int ind2 = currInd + cntDigits(d) + 1;

				if (var1 >= var2 && ans < var1) {
					ans = var1;
					ind = ind1;
					symb = newSymb;
				}
				else if(ans < var2) {
					ans = var2;
					ind = ind2;
					symb = newSymb;
				}
			}
			else if(ans < var1) {
				ans = var1;
				ind = ind1;
				symb = newSymb;
			}
		}
		
		currInd += in[i].first;
	}
	cout << type << " " << ind << " " << symb << endl;
}
		
int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	string s;
	cin >> s;

	vector<pair<int, char>> in;
	int ind = 0;
	while (ind < s.size()) {
		if (s[ind] == 'A' || s[ind] == 'G' || s[ind] == 'C' || s[ind] == 'T') {
			in.push_back({ 1, s[ind] });
		}
		else {
			in.push_back({ num(ind, s), s[ind] });
		}
		++ind;
	}

	/*for (int i = 0; i < in.size(); ++i) {
		cout << in[i].first << " " << in[i].second << endl;
	}*/

	assert(!s.empty());

	ansMin(in, (int)s.size());
	ansMax(in, (int)s.size());
	return 0;
}

