#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	vector<int> s(n);
	vector<vector<int>> x(n);
	for (int i = 0; i < n; ++i) {
		int m;
		cin >> m >> s[i];
		x[i].resize(m);
		for (int j = 0; j < m; ++j) {
			cin >> x[i][j];
		}
	}

	int dist = -1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j + 1 < x[i].size(); ++j) {
			if (dist == -1 || (x[i][j + 1] - x[i][j] == dist)) {
				dist = x[i][j + 1] - x[i][j];
			}
			else {
				cout << "No" << endl;
				return 0;
			}
		}
	}

	vector<int> brute(n);
	for (int i = 0; i < n; ++i) {
		brute[i] = i;
	}

	do {
		int currDist = dist;
		bool flag = true;
		for (int i = 1; i < n; ++i) {
			if (dist == -1 && currDist == -1) {
				currDist = s[brute[i - 1]] + x[brute[i]][0] - x[brute[i - 1]].back();
			}
			else if (currDist != s[brute[i - 1]] + x[brute[i]][0] - x[brute[i - 1]].back()) {
				flag = false;
				break;
			}
		}

		if (flag) {
			cout << "Yes" << endl;
			for (int i = 0; i < n; ++i) {
				cout << brute[i] + 1 << " ";
			}
			return 0;
		}

	} while (next_permutation(brute.begin(), brute.end()));
	cout << "No" << endl;
	return 0;
}

