#include "bits/stdc++.h"

#define nl '\n'
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) ((int)(x).size())
#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

using namespace std;

const int inf = 1e9;
const ll inf2 = 1e18;

const int maxn = 200005;

int main() {
	FAST;

	int n;
	cin >> n;

	vector<vector<ll>> a(n);
	vector<ll> s(n);
	for (int i = 0; i < n; i++) {
		int m;
		cin >> m;
		cin >> s[i];
		while (m--) {
			ll tx;
			cin >> tx;
			a[i].push_back(tx);
		}
	}

	vector<int> p(n);

	for (int i = 0; i < n; i++) p[i] = i + 1;

	do {
		ll ts = 0;
		ll pd = -1;
		ll px = -1;
		bool good = true;
		for (int i = 0; i < n; i++) {
			for (auto x: a[p[i] - 1]) {
				ll cx = x + ts;
				if (pd != -1) {
					if (cx - px != pd) {
						good = false;
						break;
					}
				}
				if (px != -1) {
					pd = cx - px;
				}
				px = cx;
			}
			if (!good) break;
			ts += s[p[i] - 1];
		}

		if (good) {
			cout << "Yes" << nl;
			for (int x: p) cout << x << ' ';
			cout << nl;
			return 0;
		}
	} while (next_permutation(p.begin(), p.end()));

	cout << "No" << nl;
	return 0;
}