#include "bits/stdc++.h"

#define nl '\n'
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) ((int)(x).size())
#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

using namespace std;

const int inf = 1e9;
const ll inf2 = 1e18;

const int maxn = 200005;

vector<vector<ll>> a;
vector<pair<ll, ll>> b;
vector<ll> s;
map<ll, ll> cntl, cntr;
int n;

set<ll> used;

bool solve(ll d) {
	if (used.count(d)) return false;
	used.insert(d);
	// cout << nl << d << nl;

	int d1 = 0, d2 = 0, n1 = 0, n2 = 0;
	for (auto p: cntl) {
		int dst = p.second - cntr[d - p.first];
		if (abs(dst) > 1) {
			// cout << p.first << ' ' << dst << nl;
			return false;
		}
		if (dst == 1) {
			d1++;
			n1 = p.first;
		}
	}

	for (auto p: cntr) {
		int dst = p.second - cntl[d - p.first];
		if (abs(dst) > 1) {
			return false;
		}
		// cout << p.first << ' ' << dst << nl;
		if (dst == 1) {
			d2++;
			n2 = p.first;
		}
	}
	// cout << d1 << ' ' << d2 << endl;

	if (d2 > 1 || d1 > 1 || (d2 != d1)) {
		return false;
	}

	map<ll, set<ll>> ml, mr;
	for (int i = 0; i < n; i++) {
		ml[b[i].first].insert(i);
		mr[b[i].second].insert(i);
	}


	vector<int> p(n);

	int si = 0;
	if (d1 != 0) {
		si = *ml[n1].begin();
	} else {
		n2 = d - b[si].first;
	}

	ml[b[si].first].erase(si);	
	mr[b[si].second].erase(si);

	p[0] = si;

	ll pr = b[si].second;

	// cout << n1 << ' ' << n2 << nl;

	for (int _ = 1; _ < n; _++) {
		int ir = -1;

		for (int i: ml[d - pr]) {
			if (_ == n - 1) {
				ir = i;
				break;
			}
			if (b[i].second != n2 || gsize(mr[b[i].second]) > 1) {
				ir = i;
				break;
			}
		}
		if (ir == -1) {
			p[n + 1] = 1;
		}

		p[_] = ir;
		pr = b[ir].second;
		ml[b[ir].first].erase(ir);	
		mr[b[ir].second].erase(ir);
	}

	cout << "Yes" << nl;
	for (int i = 0; i < n; i++) cout << p[i] + 1 << ' ';
	cout << nl;
	return true;
}

int main() {
	FAST;

	cin >> n;

	a.resize(n);
	s.resize(n);

	for (int i = 0; i < n; i++) {
		int m;
		cin >> m;
		cin >> s[i];
		while (m--) {
			ll tx;
			cin >> tx;
			a[i].push_back(tx);
		}
	}

	ll fd = -1;

	for (int i = 0; i < n; i++) {
		if (gsize(a[i]) > 1) {
			fd = a[i][1] - a[i][0];
			break;
		}
	}


	if (fd != -1) {
		for (int i = 0; i < n; i++) {
			for (int j = 1; j < gsize(a[i]); j++) {
				if (a[i][j] - a[i][j - 1] != fd) {
					cout << "No" << nl;
					return 0;
				}
			}
		}
	} 

	for (int i = 0; i < n; i++) {
		ll a1, a2;
		a1 = a[i][0]; a2 = s[i] - a[i].back();
		b.emplace_back(a1, a2);
	}
	for (int i = 0; i < n; i++) {
		cntl[b[i].first]++; 
		cntr[b[i].second]++;
	}
	// cout << nl << nl;
	// for (auto p: b) cout << p.first << ' ' << p.second << nl;
	// cout << nl << nl;	

	if (fd != -1) {
		if (!solve(fd)) {
			cout << "No" << nl;
		}
		return 0;
	}

	if (n == 1) {
		cout << "Yes" << nl;
		cout << 1 << nl;
		return 0;
	}
	// cout << nl;
	// for (int i = 0; i < n; i++) cout << b[i].first << ' ' << b[i].second << nl;
	// cout << nl;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) continue;
			if (solve(b[i].second + b[j].first)) return 0;
		}
	}

	cout << "No" << nl;
}