#include "bits/stdc++.h"

#define nl '\n'
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) ((int)(x).size())
#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

using namespace std;

const int inf = 1e9;
const ll inf2 = 1e18;

const int maxn = 10;

int a[maxn][maxn];

bool check(int i, int j, int c) {
	for (int i1 = 0; i1 < i; i1++) {
		for (int j1 = 0; j1 < j; j1++) {
			if (a[i1][j] == c && a[i][j1] == c && a[i1][j1] == c) return false;
		}
	}
	return true;
}

int n, m, c;
bool solve(int i, int j) {
	if (i >= n) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) cout << a[i][j] + 1 << ' ';
			cout << nl;
		}
		return true;
	}

	for (int tc = 0; tc < c; tc++) {
		if (check(i, j, tc)) {
			a[i][j] = tc;
			if (j == m - 1) {
				if (solve(i + 1, 0)) {
					return true;
				}
			} else {
				if (solve(i, j + 1)) {
					return true;
				}
			}
		}
	}
	return false;
}

const vector<string> ta = {"1112", "111122", "11111222", "1111112222", "111111122222", "11111111222222", "0", "0", "0", "111122123", "111112221233", "111111222212333", "111111122222123333", "111111112222221233333", "0", "0", "0", "1111122212331323", "11111122221233323123", "111111122222212333233123", "1111111122222321233322331233", "0", "0", "0", "1111112222123332312323132", "111111122223123332231232231323", "11111111222233123332223123232313232", "0", "0", "0", "111111122223123332231232231323333122", "111111112223331233223231323223323213123322", "0", "0", "0", "1111111122233312332232323231233232131233223132232", "0", "0", "0", "0", "0", "0", "0", "0", "0"};
int main() {
	FAST;

	cin >> n >> m >> c;
	if (n > m) swap(n, m);
	if (c == 2) {
		solve(0, 0);
	} else {
		int ci = 0;
		for (int tn = 2; tn <= 10; tn++) {
			for (int tm = tn; tm <= 10; tm++) {
				if (tn == n && tm == m) {
					if (ta[ci] != "0") {
						for (int i = 0; i < n; i++) {
							for (int j = 0; j < m; j++) {
								cout << ta[ci][i*m + j] << ' ';
							}
							cout << nl;
						}
					}
					return 0;
				}
				ci++;
			}
		}
	}
}