#include "bits/stdc++.h"

#define nl '\n'
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) ((int)(x).size())
#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define vec vector

typedef long long ll;
typedef long double ld;

using namespace std;

const int inf = 1e9;
const ll inf2 = 1e18;

const int maxn = 200005;
const ll mod = 1000000007;


int n;
ll f[100], cnt[8];

void add(ll &a, ll b) {
	a = (a + b) % mod;
}

ll mul (ll a, ll b) {
	return (a * b) % mod;
}

// int brute(string a, string b, string c) {
// 	vector<int> p(n);
// 	int ttans = 0;
// 	for (int i = 0; i < n; i++) {
// 		p[i] = i;
// 	}

// 	do {
// 		if (a[p[n - 1]] == '0' || b[p[n - 1]] == '0' || c[p[n - 1]] == '0') continue;
// 		ll x, y, z;
// 		x = y = z = 0;
// 		ll cp = 1;
// 		for (int i = 0; i < n; i++) {
// 			x += (a[p[i]] - '0') * cp;
// 			y += (b[p[i]] - '0') * cp;
// 			z += (c[p[i]] - '0') * cp;
// 			cp *= 10LL;
// 		}

// 		if (x + y == z) {
// 			ttans++;
// 			if (ttans == mod) ttans = 0;
// 		}
// 	} while (next_permutation(all(p)));

// 	return ttans;
// }

int main() {
	FAST;

	f[0] = 1;
	for (ll i = 1; i < 20; i++) {
		f[i] = i * f[i - 1] % mod;
	}

	string a, b, c;
	cin >> a >> b >> c;
	n = gsize(a);
	// cout << brute(a, b, c) << nl;

	for (int i = 0; i < 8; i++) cnt[i] = 0;

	for (int i = 0; i < n; i++) {
		int ti = 0;
		if (a[i] == '0' || b[i] == '0' || c[i] == '0') ti += 4;
		int x = a[i] - '0', y = b[i] - '0', z = c[i] - '0';
		if (x + y == z) {
			ti += 0;
		} else if (x + y - 10 == z) {
			ti += 1;
		} else if (x + y + 1 == z) {
			ti += 2;
		} else if (x + y - 9 == z) {
			ti += 3;
		} else {
			cout << 0 << nl;
			return 0;
		}
		cnt[ti]++;
	}
	// cout << nl;
	// for (int i = 0; i < 8; i++) cout << cnt[i] << ' ';
	// cout << nl << nl;

	ll ans = 0;
	ll mul1 = 1;
	for (int i = 4; i < 8; i++) cnt[i - 4] += cnt[i];
	for (int i = 0; i < 4; i++) {
		mul1 = mul(mul1, f[cnt[i]]);
	}


	vec<vec<vec<vec<vec<ll>>>>> dp(cnt[0] + 1, vec<vec<vec<vec<ll>>>> (cnt[1] + 1, vec<vec<vec<ll>>> (cnt[2] + 1, vec<vec<ll>> (cnt[3] + 1, vec<ll>(2, 0)))));
	
	dp[0][0][0][0][0] = 1;

	for (int i = 0; i < cnt[0] + 1; i++) {
		for (int j = 0; j < cnt[1] + 1; j++) {
			for (int k = 0; k < cnt[2] + 1; k++) {
				for (int x = 0; x < cnt[3] + 1; x++) {
					if (i > 0) {
						add(dp[i][j][k][x][0], dp[i - 1][j][k][x][0]);
					}
					if (j > 0) {
						add(dp[i][j][k][x][1], dp[i][j - 1][k][x][0]);
					}
					if (k > 0) {
						add(dp[i][j][k][x][0], dp[i][j][k - 1][x][1]);
					}
					if (x > 0) {
						add(dp[i][j][k][x][1], dp[i][j][k][x - 1][1]);
					}
				}
			}
		}
	}

	add(ans, dp[cnt[0]][cnt[1]][cnt[2]][cnt[3]][0]);

	cout << mul(ans, mul1) << nl;
}