// ConsoleApplication1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<cmath>
using namespace std;

#define int long long

const int MAXN = 1e5 + 1;

int n;

int sz[MAXN], first[MAXN], last[MAXN];

map<int, int> cnt;
map<int, set<pair<int, int>>> gg;
vector<int> ans;

void dfs(int v) {
    auto cur = gg[v];
    for (auto u : cur) {
        if (gg[v].find(u) == gg[v].end()) continue;
        int pipi = u.second + 1;
        int next = u.first;
        gg[v].erase(u);
        dfs(next);
        ans.push_back(pipi);
        while (ans.size() > n) {
            ++v;
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    int bet = -1;
    bool is_good = true;
    int mx_size = 0;
    for (int i = 0; i < n; i++)
    {
        int mi;
        cin >> mi >> sz[i];
        mx_size = max(mx_size, sz[i]);
        int prev = 0;
        for (int j = 0; j < mi; ++j) {
            int a;
            cin >> a;
            last[i] = a;
            if (j == 0) {
                first[i] = a;
            }
            else {
                int dd = a - prev;
                if (bet == -1) {
                    bet = dd;
                }
                else if (dd != bet) {
                    is_good = false;
                }
            }
            prev = a;
        }
    }
    if (!is_good) {
        cout << "No";
        return 0;
    }
    if (bet != -1) {
        for (int i = 0; i < n; i++)
        {
            int f = first[i];
            int s = last[i];
            s = sz[i] - s;
            s = bet - s;
            --cnt[f];
            ++cnt[s];
            gg[f].insert({ s, i });
        }
        int mn = -1, pl = -1;
        int any = 0;
        for (auto i : cnt) {
            any = i.first;
            int j = i.second;
            if (j < 0) {
                if (j < -1) {
                    cout << "No";
                    return 0;
                }
                if (mn != -1) {
                    cout << "No";
                    return 0;
                }
                mn = i.first;
            }
            if (j > 0) {
                if (j > 1) {
                    cout << "No";
                    return 0;
                }
                if (pl != -1) {
                    cout << "No";
                    return 0;
                }
                pl = i.first;
            }
        }
        if (mn == -1) mn = any;
        dfs(mn);
        if (ans.size() == n) {
            cout << "Yes\n";
            reverse(ans.begin(), ans.end());
            for (auto moo : ans) {
                cout << moo << " ";
            }
        }
        else {
            cout << "No";
        }
        return 0;
    }
    
}

/*
5
1 3
4 7
1 10
3 3
3 5
*/