#include <bits/stdc++.h>
#define int long long
using namespace std;

int n;
vector<vector<int>> g;
vector<int> ans;

struct edge {
    int to, num;
};

vector<vector<edge>> gr;
vector<bool> used;

bool check() {
    ans.clear();
    int v, u, mask;
    vector<vector<int>> dp(1 << n, vector<int>(n, -1));
    for (v=0; v < n; ++v)
        dp[1 << v][v] = v;
    for (mask=0; mask < (1 << n); ++mask) {
        for (v=0; v < n; ++v) {
            if ((1 << v) & mask && dp[mask][v] != -1) {
                for (int u : g[v]) {
                    if (!((1 << u) & mask)) {
                        dp[mask ^ (1 << u)][u] = v;
                    }
                }
            }
        }
    }
    for (v=0; v < n; ++v) {
        if (dp[(1 << n) - 1][v] >= 0) {
            mask = (1 << n) - 1;
            while (dp[mask][v] != -1) {
                ans.push_back(v);
                int help = v;
                v = dp[mask][v];
                mask ^= (1 << help);
            }
            return true;
        }
    }
    return false;
}

void dfs(int v) {
    for (edge e : gr[v]) {
        if (!used[e.num]) {
            used[e.num] = true;
            ans.push_back(e.num);
            dfs(e.to);
            ans.push_back(e.num);
        }
    }
}

signed main()
{
    int m, i, j, k, l;
    cin >> n;
    g.resize(n);
    vector<int> siz(n), st(n), fin(n);
    vector<vector<int>> per(n);
    bool poss = true, det = false;
    int dist = -1, maxfin = 0, maxst = 0;
    for (i=0; i < n; ++i) {
        cin >> m >> siz[i];
        if (m > 1)
            det = true;
        per[i].resize(m);
        for (j=0; j < m; ++j) {
            cin >> per[i][j];
            if (det && j > 0) {
                if (dist == -1)
                    dist = per[i][j] - per[i][j - 1];
                else if (dist != per[i][j] - per[i][j - 1])
                    poss = false;
            }
        }
        st[i] = per[i][0];
        fin[i] = siz[i] - per[i][m - 1];
        siz[i] = st[i] + fin[i];
        maxst = max(maxst, st[i]);
        maxfin = max(maxfin, fin[i]);
    }
    if (!poss) {
        cout << "No";
        return 0;
    }
    if (n == 1) {
        cout << "Yes\n1";
        return 0;
    }
    if (det) {
        for (i=0; i < n; ++i)
            fin[i] = dist - fin[i];
        vector<int> hlp;
        unordered_map<int, int> mp;
        for (int x : st)
            hlp.push_back(x);
        for (int x : fin)
            hlp.push_back(x);
        sort(hlp.begin(), hlp.end());
        int cur=0;
        for (i=0; i < 2 * n; ++i) {
            if (i > 0 && hlp[i] > hlp[i - 1])
                ++cur;
            mp[hlp[i]] = cur;
        }
        for (i=0; i < n; ++i)
            st[i] = mp[st[i]];
        for (i=0; i < n; ++i)
            fin[i] = mp[fin[i]];
        gr.resize(cur + 1);
        vector<int> revgr(cur + 1);
        used.resize(n, false);
        for (i=0; i < n; ++i) {
            gr[st[i]].push_back(edge{fin[i], i});
            ++revgr[fin[i]];
        }
        bool flag = false;
        for (int v=0; v < gr.size(); ++v) {
            if (revgr[v] == 0) {
                flag = true;
                dfs(v);
                break;
            }
        }
        if (!flag)
            dfs(0);
        if (ans.size() < 2 * n)
            cout << "No";
        else {
            cout << "Yes\n";
            vector<bool> done(n, false);
            for (int x = ans.size() - 1; x >=0; --x) {
                if (!done[ans[x]]) {
                    done[ans[x]] = true;
                    cout << ans[x] + 1 << " ";
                }
            }
        }
        return 0;
        /*for (i=0; i < n; ++i)
            for (j=0; j < n; ++j)
                if (i != j)
                    if (fin[i] + st[j] == dist)
                        g[i].push_back(j);
        if (check()) {
            cout << "Yes\n";
            for (int x = ans.size() - 1; x >= 0; --x)
                cout << ans[x] + 1 << " ";
        }
        else
            cout << "No";
        return 0;*/
    }
    for (i=0; i < n; ++i) {
        for (j=0; j < n; ++j) {
            if (i != j) {
                g.clear();
                g.resize(n);
                for (k=0; k < n; ++k)
                    for (l=0; l < n; ++l)
                        if (k != l)
                            if (fin[k] + st[l] == fin[i] + st[j])
                                g[k].push_back(l);
                if (check()) {
                    cout << "Yes\n";
                    for (int x = ans.size() - 1; x >= 0; --x)
                        cout << ans[x] + 1 << " ";
                    return 0;
                }
            }
        }
    }
    cout << "No";
    return 0;
}
