#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define int long long
#define v vector
#define pr pair<int, int>
#define inf 1e18

int t;

int n, m;

int total;

int fv(int x) {
    if (x == m + 1 || x == 1) return 1e18;
    int sm = x * (x - 1) / 2 * n + m * n * (n - 1) / 2 * (x - 1);
    int sm2 = total - sm;
    return abs(sm - sm2);
}

int fh(int x) {
    if (x == n + 1 || x == 1) return 1e18;
    int sm = ((x - 1) * m + 1) * ((x - 1) * m) / 2;
    int sm2 = total - sm;
    return abs(sm - sm2);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> t;
    for (int test = 0; test < t; test++) {
        cin >> n >> m;
        total = (n * m + 1) * (n * m) / 2;
        /*cout << (n * m + 1) << " " << n * m << " " << total << "\n";*/
        /*cout << fh(4) << " " << fv(5) << "\n";*/
        int L = 1, R = m + 1;
        while (R - L > 9) {
            int M1 = L + (R - L) / 3;
            int M2 = R - (R - L) / 3;
            if (fv(M1) < fv(M2)) {
                R = M2;
            } else {
                L = M1;
            }
        }

        char ch;
        int ans = inf, p;
        for (int i = L; i <= R; i++) {
            int new_ans = fv(i);
            if (new_ans < ans) {
                ch = 'V';
                ans = new_ans;
                p = i;
            }
        }

        L = 1; R = n + 1;
        while (R - L > 9) {
            int M1 = L + (R - L) / 3;
            int M2 = R - (R - L) / 3;
            if (fh(M1) < fh(M2)) {
                R = M2;
            } else {
                L = M1;
            }
        }

        for (int i = L; i <= R; i++) {
            int new_ans = fh(i);
            if (new_ans < ans) {
                ch = 'H';
                ans = new_ans;
                p = i;
            }
        }
        cout << ch << " " << p << "\n";
    }
    return 0;
}
