#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define int long long
#define v vector
#define pr pair<int, int>


string a, b, c;
int n;

const int MOD = 1e9 + 7;

v<int> lst;
v<int> f;

int x1, y1, new_x, new_y;

int gcd(int A, int B) {
    if (B == 0) {
        x1 = 1;
        y1 = 0;
        return A;
    }
    int d = gcd(B, A % B);
    new_x = y1;
    new_y = (x1 - A / B * y1 + MOD) % MOD;
    x1 = new_x;
    y1 = new_y;
    return d;
}

int get_dp(int N, int K) {
    int res = f[N];
    gcd(f[K], -MOD);
    res = (res * ((x1 + MOD) % MOD)) % MOD;
    gcd(f[N - K], -MOD);
    res = (res * ((x1 + MOD) % MOD)) % MOD;
    return res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> a >> b >> c;
    n = a.size();
    lst.resize(4, 0);
    int zero = 0;
    for (int i = 0; i < n; i++) {
        int sm = (a[i] + b[i] - 48 * 2);
        int id = 0;
        if ((sm + 1) % 10 == c[i] - 48) {
            id += 1;
        }
        if (sm > 9 || (id == 1 && (sm + 1) > 9)) {
            id += 2;
        }
        lst[id]++;
        if ((a[i] == '0' || b[i] == '0' || c[i] =='0') && id != 2 && id != 3) {
            zero++;
        }
        if ((sm + 1) % 10 != c[i] - 48 && sm % 10 != c[i] - 48) {
            cout << 0;
            return 0;
        }
    }
    f.resize(n + 1);
    f[0] = 1;
    for (int i = 1; i <= n; i++) {
        f[i] = (f[i - 1] * i) % MOD;
    }
    if (lst[1] != lst[2]) {
        cout << 0;
        return 0;
    }
    if (lst[1] == 0 && lst[3] > 0) {
        cout << 0;
        return 0;
    }
    int ans = f[lst[1]];
    ans = (ans * f[lst[3]]) % MOD;
    int cnt = 0;
    for (int i = 1; i <= min(lst[1] - 1, lst[3] + 1); i++) {
        cnt = (cnt + (get_dp(lst[3] + 1, i) * get_dp(lst[1] - 1 - 1, i - 1)) % MOD) % MOD;
    }
    if (lst[3] == 0 || lst[1] - 1 == 0) cnt = 1;
    ans = (ans * cnt) % MOD;
    int perm = (f[lst[1] + lst[0]] - (zero * f[lst[1] + lst[0] - 1]) % MOD + MOD) % MOD;
    ans = (ans * perm) % MOD;
    cout << ans;
    return 0;
}
