#include "bits/stdc++.h"
#include "iomanip"
#define int long long
#define all(x) (x).begin(), (x).end()
#define fast() ios::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define ld long double
#define pi pair<int, int>
using namespace std;

struct Segment{
    int le;
    int ri;
    int number;
    Segment() {};
};

bool cmp(Segment a, Segment b) {
    return a.number < b.number;
}

vector<int> st;
unordered_map<int, vector<int>> mapa;
vector<bool> used;
int n;
vector<Segment> work;
void dfs(int u, int d) {
    st.push_back(u);
    used[u] = true;
    if (st.size() == n) {
        cout << "Yes\n";
        for (auto v:st) {
            cout << v + 1 << ' ';
        }
        exit(0);
    }
    if (d == -1) {
        for (int v = 0; v < n; ++v) {
            if (v == u) {
                continue;
            }
            dfs(v, work[u].ri + work[v].le);
        }
    } else {
        for (auto v : mapa[d - work[u].ri]) {
            if (used[v]) {
                continue;
            }
            dfs(v, d);
        }
    }
    used[u] = false;
    st.pop_back();
}

void solve(){
    cin >> n;
    used.assign(n, false);
    set<int> d;
    for (int i = 0; i < n;++i) {
        int m, s;
        cin >> m >> s;
        int p, pp = 0;
        Segment cur;
        cur.number = i;
        for (int j = 0; j < m; ++j) {
            cin >> p;
            cur.ri = s - p;
            if (j == 0) {
                cur.le = p;
            }
            if (j > 0) {
                d.insert(p - pp);
            }
            pp = p;
        }
        work.push_back(cur);
        mapa[cur.le].push_back(i);
    }
    if (d.size() > 1) {
        cout << "No\n";
        return;
    }
    int dist = -1;
    if (d.size() == 1) {
        dist = *d.begin();
    }
    for (int u = 0; u < n; ++u) {
        dfs(u, dist);
    }
    cout << "No\n";
    return;
}

signed main(){
    int t = 1;
    fast();
//    system("g++ -o main main.cpp");
//    system("./main");
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}