#include "bits/stdc++.h"
#include "iomanip"

#define int long long
#define all(x) (x).begin(), (x).end()
#define fast() ios::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define ld long double
#define pi pair<int, int>
using namespace std;

struct Col{
    int a;
    int b;
    int c;
    int number;
};

bool cmp(Col a, Col b) {
    return a.number < b.number;
}

vector<Col> c;

bool goodPerm() {
    if (c[0].c == 0 || c[0].a == 0 || c[0].b == 0) {
        return false;
    }
    int apb = 0;
    int sc = 0;
    for (int i = 0; i < c.size(); ++i) {
        apb *= 10;
        apb += c[i].a + c[i].b;
        sc *= 10;
        sc += c[i].c;
    }
    return apb == sc;
}

void solve() {
    string sa, sb, sc;
    cin >> sa >> sb >> sc;
    int n = sa.size();
    c.resize(n);
    for (int i= 0; i < n; ++i) {
        c[i].a = sa[i] - '0';
        c[i].b = sb[i] - '0';
        c[i].c = sc[i] - '0';
        c[i].number = i;
    }
    int ans = 0;
    do {
        ans += goodPerm();
    } while(next_permutation(all(c), cmp));
    cout << ans << '\n';
}

signed main() {
    int t = 1;
    fast();
//    system("g++ -o main main.cpp");
//    system("./main");
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}