#include "bits/stdc++.h"
#include "iomanip"
#define int long long
#define all(x) (x).begin(), (x).end()
#define fast() ios::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define ld long double
#define pi pair<int, int>
using namespace std;

bool isTableGood(vector<vector<int>> &t) {
    int n = t.size();
    int m = t[0].size();
    bool flag = true;
    for (int x1 = 0; x1 < n; ++x1) {
        for (int x2 = x1 + 1; x2 < n; ++x2) {
            for (int y1 = 0; y1 < m; ++y1) {
                for (int y2 = y1 + 1; y2 < m; ++y2) {
                    if (t[x1][y1] == t[x1][y2] && t[x1][y2] == t[x2][y2] && t[x2][y2] == t[x2][y1]) {
                        flag = false;
                        return false;
                    }
                }
            }
        }
    }
    return true;
}

vector<vector<int>> table;

vector<vector<int>> work;
vector<int> cur;

const int LEN  = 10;

void fillWork(int idx) {
    if (idx == LEN) {
        work.push_back(cur);
        return;
    }
    for (int i = 0; i < 3; ++i) {
        cur.push_back(i);
        fillWork(idx + 1);
        cur.pop_back();
    }
}

vector<bool> visited;



bool goodLines(int i, int j) {
    for (int x1 = 0; x1 < LEN; ++x1) {
        for (int x2 = x1 + 1; x2 < LEN; ++x2) {
            if (work[i][x1] == work[i][x2] && work[i][x2] == work[j][x2] && work[j][x2] == work[j][x1]) {
                return false;
            }
        }
    }
    return true;
}


vector<int> ccur;
void print() {
    for (auto v : ccur) {
        for (auto x : work[v]) {
            cout  << x + 1 << ' ';
        }
        cout  << '\n';
    }
    cout << "\n\n";
    }
void dfs(int idx) {
    if (idx >= 7) {
        cout << idx << '\n';
        print();
    }
    for (int u = 0; u < work.size(); ++u) {
        if (visited[u]) {
            continue;
        }
        bool flag = true;
        for (auto v : ccur) {
            if (!goodLines(u, v)) {
                flag = false;
            }
        }
        if (flag) {
            ccur.push_back(u);
            visited[u] = true;
            dfs(idx + 1);
            visited[u] = false;
            ccur.pop_back();
        }
    }
}

void solve10() {
    fillWork(0);
    random_shuffle(all(work));
    visited.assign(work.size(), false);
    dfs(0);
}

void solve(){
    int n, m, c;
    cin >> n >> m >> c;
//    solve10();
    if (n == 5 && m == 10) {
        cout << "3 1 2 1 3 2 2 1 1 2 \n"
                "1 2 2 3 2 1 1 2 1 3 \n"
                "2 3 1 2 1 1 2 2 3 3 \n"
                "2 2 1 3 3 2 1 1 3 1 \n"
                "3 2 3 2 1 3 1 3 2 3 ";
        return;
    }
    if (n == 6 && m == 10) {
        cout << "3 1 3 1 2 3 1 2 2 1 \n"
                "2 2 2 3 3 3 3 2 1 2 \n"
                "3 3 1 2 1 2 2 1 2 1 \n"
                "2 3 1 1 2 2 3 3 1 3 \n"
                "1 3 3 2 3 1 1 1 3 2 \n"
                "3 1 1 3 2 1 2 3 3 2 ";
        return;
    }
    table.resize(n);
    for (auto &q:table) {
        q.resize(m);
    }
    ofstream fout("output.txt");
    while(1) {
        for (int x = 0; x < n; ++x) {
            for (int y = 0; y < m; ++y) {
                table[x][y] = rand() % c;
            }
        }
        if (isTableGood(table)) {
            for (int x = 0; x < n; ++x) {
                for (int y = 0; y < m; ++y) {
                    fout << table[x][y] + 1 << ' ';
                }
                fout << '\n';
            }
            return;
        }
    }
    if (c == 3) {
        assert(0);
    }
}

signed main(){
    int t = 1;
//    fast();
//    system("g++ -o main main.cpp");
//    system("./main");
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}