#include "bits/stdc++.h"
#include "iomanip"
#define int long long
#define all(x) (x).begin(), (x).end()
#define fast() ios::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define ld long double
#define pi pair<int, int>
using namespace std;


int matrix[2][2];
int nonZero[2];

const int MOD = 1000000007;

struct State{
    int m[2][2];
    int v; // prevIdx;
};

int cnt(State &st);

int fact(int x);


int fact(int x) {
    int res = 1;
    for (int i = 1;i <=x;++i) {
        res *= i;
    }
    return res;
}

const int MAX = 20;

int dp[4][MAX][MAX][MAX][MAX];
int cntDP(int v, int a, int b ,int c, int d) {
    if (a < 0 || b < 0 || c < 0 || d < 0) {
        return 0;
    }
    if (a == 0 && b == 0 && c == 0 && d == 0) {
        return 1;
    }
    if (dp[v][a][b][c][d] != 0) {
        return dp[v][a][b][c][d];
    }
    int ans = 0;
    if (v == 0) {
        ans += cntDP(0, a-1, b, c, d);
        ans += cntDP(1, a, b-1, c, d);
    } else if (v == 1) {
        ans += cntDP(2, a, b, c-1, d);
        ans += cntDP(3, a, b, c, d-1);
    } else if (v == 2) {
        ans += cntDP(0, a-1,b, c,d);
        ans += cntDP(1, a, b-1, c, d);
    } else if (v == 3) {
        ans += cntDP(2, a, b, c-1,d);
        ans += cntDP(3, a, b, c, d-1);
    }
    return (dp[v][a][b][c][d] = ans);
}

int nextState(int x, int y, int v, State &st) {
    st.m[x][y] -= 1;
    int prevV = st.v;
    st.v = v;
    int ans = 1;
       for (int i = 0; i < 2; ++i) {
            for (int j = 0; j < 2; ++j) {
                ans *= fact(st.m[i][j]);
            }
        }
        int a = st.m[0][0];
        int b = st.m[0][1];
        int c = st.m[1][0];
        int d = st.m[1][1];
        ans *= cntDP(v, a, b, c, d);

    st.v = prevV;
    st.m[x][y] += 1;
    return ans;
}

void solve(){
    string sa, sb, sc;
    cin >> sa >> sb >>sc;
    int n = sa.size();
    for (int i = 0; i < n; ++i) {
        int a = sa[i] - '0';
        int b = sb[i] - '0';
        int c = sc[i] - '0';
        if ((a + b) % 10 == c % 10) {
            ++matrix[0][(a + b) >= 10];
            if (a != 0 && b != 0 && c != 0) {
                ++nonZero[0];
            }
        } else if ((a + b + 1) % 10 == c % 10) {
            ++matrix[1][(a + b + 1) >= 10];
            if (a != 0 && b != 0 && c != 0) {
                ++nonZero[1];
            }
        } else {
            cout << "0\n";
            return;
        }
    }

    int ans = 0;
    State st;
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < 2; ++j)  {
            st.m[i][j] = matrix[i][j];
        }
    }
    ans += nonZero[0]*nextState(0, 0, 0, st);
    ans += nonZero[1]*nextState(1, 0, 2, st);
    cout << ans;
}

signed main(){
    int t = 1;
    fast();
//    system("g++ -o main main.cpp");
//    system("./main");
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}