#include <iostream>
#include <vector>
#include <queue>
#include <string>
#include <algorithm>
#include <map>
#include <bits/stdc++.h>

using namespace std;
#define int long long
const int INF = 1e18;

inline int get_bit(int a, int num) {
    for (int i = 0; i < num; ++i) a /= 3;
    return a % 3;
}

void gen(int n, int m, int cur, vector<vector<bool>> &cha, vector<vector<int>> &ans) {
    if (cur == m) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << ans[i][j] + 1 << " ";
            }
            cout << "\n";
        }
        exit(0);
    }
    int power = 1;
    for (int i = 0; i < n; ++i) power *= 3;
    bool flex = false;
   // vector <int> hmm;
    //for (int i = 0; i < power; ++i) hmm.push_back(i);
    //random_shuffle(hmm.begin(), hmm.end());
    for (int mask = 0; mask < power; ++mask) {
        int kol1 = 0, kol2 = 0;
        for (int j = 0; j < n; ++j) {
            if (get_bit(mask, j) == 1) ++kol1;
            if (get_bit(mask, j) == 2) ++kol2;
        }
        if (n % 3 == 0) {
            if (kol1 != n / 3 || kol2 != n / 3) continue;
        }
        if (n % 3 == 1) {
            if (cur % 3 == 0) {
                if (kol1 != kol2 || n - kol1 - kol2 != kol1 + 1) continue;
            }
            if (cur % 3 == 1) {
                if (kol1 != kol2 + 1 || n - kol1 - kol2 != kol2) continue;
            }
            if (cur % 3 == 2) {
                if (kol2 != kol1 + 1 || n - kol1 - kol2 != kol1) continue;
            }
        }
        if (n % 3 == 2) {
            if (cur % 3 == 0) {
                if (kol1 != kol2 || n - kol1 - kol2 != kol1 - 1) continue;
            }
            if (cur % 3 == 1) {
                if (kol1 != kol2 - 1 || n - kol1 - kol2 != kol2) continue;
            }
            if (cur % 3 == 2) {
                if (kol2 != kol1 - 1 || n - kol1 - kol2 != kol1) continue;
            }
        }
        bool ok = true;
        for (int f = 0; f < n; ++f) {
            for (int s = f + 1; s < n; ++s) {
                int fb = get_bit(mask, f), sb = get_bit(mask, s);
                if (fb != sb) continue;
                if (cha[f * n + s][fb]) {
                    ok = false;
                    break;
                }
            }
            if (!ok) break;
        }
        if (!ok) continue;
        for (int f = 0; f < n; ++f) {
            for (int s = f + 1; s < n; ++s) {
                int fb = get_bit(mask, f), sb = get_bit(mask, s);
                if (fb != sb) continue;
                cha[f * n + s][fb] = true;
            }
        }
        for (int j = 0; j < n; ++j) {
            ans[j][cur] = get_bit(mask, j);
        }
        gen(n, m, cur + 1, cha, ans);
        for (int f = 0; f < n; ++f) {
            for (int s = f + 1; s < n; ++s) {
                int fb = get_bit(mask, f), sb = get_bit(mask, s);
                if (fb != sb) continue;
                cha[f * n + s][fb] = false;
            }
        }
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        int n, m, c;
        cin >> n >> m >> c;
        if (c == 2) {
            vector<vector<int>> ans(n, vector<int>(m));
            vector<pair<bool, bool>> cur(n * n);
            for (int i = 0; i < m; ++i) {
                bool flex = false;
                for (int mask = 0; mask < (1 << n); ++mask) {
                    int kol1 = 0;
                    for (int j = 0; j < n; ++j) {
                        if ((mask >> j) & 1) ++kol1;
                    }
                    if (n % 2 == 0 && kol1 * 2 != n) continue;
                    if (n % 2 == 1) {
                        if (i % 2 == 0 && kol1 != n - kol1 - 1) continue;
                        if (i % 2 == 1 && kol1 != n - kol1 + 1) continue;
                    }
                    bool ok = true;
                    for (int f = 0; f < n; ++f) {
                        for (int s = f + 1; s < n; ++s) {
                            int fb = ((mask >> f) & 1), sb = ((mask >> s) & 1);
                            if (fb != sb) continue;
                            if (fb == 0 && cur[f * n + s].first) {
                                ok = false;
                                break;
                            }
                            if (fb == 1 && cur[f * n + s].second) {
                                ok = false;
                                break;
                            }
                        }
                        if (!ok) break;
                    }
                    if (!ok) continue;
                    for (int f = 0; f < n; ++f) {
                        for (int s = f + 1; s < n; ++s) {
                            int fb = ((mask >> f) & 1), sb = ((mask >> s) & 1);
                            if (fb != sb) continue;
                            if (fb == 0) {
                                cur[f * n + s].first = true;
                            }
                            if (fb == 1) {
                                cur[f * n + s].second = true;
                            }
                        }
                    }
                    for (int j = 0; j < n; ++j) {
                        ans[j][i] = ((mask >> j) & 1);
                    }
                    break;
                }
            }
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << ans[i][j] + 1 << " ";
                }
                cout << "\n";
            }
        } else {
            if (n == 10) assert(m <= 7);
            if (m == 10) assert(n <= 7);
            vector <vector <bool>> cha(n * n, vector <bool> (3));
            vector <vector <int>> ans(n, vector <int> (m));
            gen(n, m, 0, cha, ans);
        }
    } else {
        int n, m, c;
        cin >> n >> m >> c;
        vector<vector<int>> tmp(n, vector<int>(m));
        for (int mask = 0; mask < (1 << (n * m)); ++mask) {
            for (int j = 0; j < n * m; ++j) {
                tmp[j / n][j % n] = ((mask >> j) & 1);
            }
            bool ok = true;
            vector<pair<bool, bool>> cur(n * n);
            for (int x1 = 0; x1 < n; ++x1) {
                for (int x2 = x1 + 1; x2 < n; ++x2) {
                    for (int y1 = 0; y1 < m; ++y1) {
                        for (int y2 = y1 + 1; y2 < m; ++y2) {
                            if (tmp[x1][y1] == tmp[x1][y2] && tmp[x1][y1] == tmp[x2][y1] &&
                                tmp[x1][y1] == tmp[x2][y2]) {
                                ok = false;
                                break;
                            }
                        }
                        if (!ok) break;
                    }
                    if (!ok) break;
                }
                if (!ok) break;
            }
            if (ok) {
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        cout << tmp[i][j] << " ";
                    }
                    cout << "\n";
                }
                return 0;
            }
        }
    }
}

/*
3 3 1 2 2 1 3 2 1 1
3 2 3 1 3 2 2 3 1 1
3 1 2 3 1 3 2 2 1 1
2 3 3 3 1 2 1 1 1 1
2 3 1 2 3 3 2 1 1 1
2 1 2 3 3 1 3 1 1 1
1 2 2 2 1 1 3 3 1 1
1 1 1 1 2 2 1 3 1 1

3 3 1 2 2 1 3 1 2 1
3 2 3 1 3 2 1 1 2 1
3 1 2 3 1 3 2 2 2 1
2 3 3 1 1 3 2 3 1 1
2 3 1 2 3 2 1 2 1 1
2 1 2 3 3 1 3 3 1 1
1 2 3 3 2 1 1 2 3 1
1 2 2 2 1 3 3 1 3 1
1 1 1 1 2 2 2 3 3 1
 */