#include<bits/stdc++.h>

using namespace std;

long long mod = 1e9 + 7;

struct three{
    int h, n, z;
};

long long gen(long long pp, long long pm, long long mp, long long mm, int ln) {
    long long cnt = 0;
    if (pp == 0 && pm == 0 && mp == 0 && mm == 0) {
        if (ln == 0) {
            return 1;
        }
        else {
            return 0;
        }
    }
    if (pp != 0 && ln == 1) {
        cnt += gen(pp - 1, pm, mp, mm, 1) * pp;
        cnt %= mod;
    }
    if (pm != 0 && ln == 1) {
        cnt += gen(pp, pm - 1, mp, mm, 0) * pm;
        cnt %= mod;
    }
    if (mp != 0 && ln == 0) {
        cnt += gen(pp, pm, mp - 1, mm, 1) * mp;
        cnt %= mod;
    }
    if (mm != 0 && ln == 0) {
        cnt += gen(pp, pm, mp, mm - 1, 0) * mm;
        cnt %= mod;
    }
    return cnt;
}

int main() {
    int n;
    string s; cin >> s;
    n = s.size();
    vector<three> d(n);
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        char c = s[i];
        v[i] = (c - '0');
        if (v[i] == 0) {
            d[i].z = 1;
        }
        else {
            d[i].z = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        char c; cin >> c;
        int x = (c - '0');
        if (x == 0) {
            d[i].z = 1;
        }
        else {
            d[i].z = max(0, d[i].z);
        }
        if (x + v[i] > 9) {
            d[i].h = 1;
        }
        else {
            d[i].h = 0;
        }
        v[i] = (v[i] + x) % 10;
    }
    for (int i = 0; i < n; ++i) {
        char c; cin >> c;
        int x = (c - '0');
        if (x == 0) {
            d[i].z = 1;
        }
        else {
            d[i].z = max(0, d[i].z);
        }
        if (x == v[i]) {
            d[i].n = 0;
        }
        else if (x == (v[i] + 1) % 10) {
            d[i].n = 1;
        }
        else {
            cout << 0;
            return 0;
        }
    }
    long long pp = 0, pm = 0, mp = 0, mm = 0, mpz = 0, mmz = 0;
    for (auto i : d) {
        if (i.h == 1) {
            if (i.n == 1) {
                pp += 1;
            }
            else {
                pm += 1;
            }
        }
        else {
            if (i.n == 1) {
                mp += 1;
                if (i.z == 0) {
                    mpz += 1;
                }
            }
            else {
                mm += 1;
                if (i.z == 0) {
                    mmz += 1;
                }
            }
        }
    }
    long long ans = 0;
    if (mpz != 0) {
        ans += gen(pp, pm, mp - 1, mm, 1) * mpz;
        ans %= mod;
    }
    if (mmz != 0) {
        ans += gen(pp, pm, mp, mm - 1, 0) * mmz;
        ans %= mod;
    }
    cout << ans;
}
/*
01211
12099
23300
*/
