#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>
#include <vector>

#define lng long long
#define lgd long double

using namespace std;

int conv(string s)
{
    if (s.size() == 0)
        return 1;
    int ans = 0;
    int cf = 1;
    for (int i = s.size()-1; i >= 0; i--)
    {
        ans += (s[i] - '0')*cf;
        cf *= 10;
    }
    return ans;
}

int log(int a)
{
    int q = 1;
    int ans = 1;
    while (q <= a)
    {
        q *= 10;
        ans++;
    }
}

bool check(int a)
{
    int q = 1;
    while (q < a)
        q *= 10;
    return (q == a);
}

int pow(int a, int q)
{
    if (q == 0)
        return 1;
    if (q%2)
        return pow(a, q-1) * a;
    else
        return pow(a*a, q/2);
}

struct ans
{
    int op;
    char name;
    int pos;
};
//BAN
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s; cin >> s;
    vector <pair <int, char> > v;
    for (int i = 0 ; i < s.size(); i++)
    {
        int cf;
        int first = i;
        while (s[i] <= '9' && s[i] >= '0')
            i++;
        string toc;
        for (int j = first; j < i; j++)
            toc.push_back(s[j]);
        cf = conv(toc);
        v.push_back(make_pair(cf, s[i]));
    }
    int mn = 1;
    ans mx;
    int sum = 0;
    for (int i = 0; i < v.size(); i++)
    {
        if (v[i].first == 3)
        {
            if (mn < 2) {
                mx.op = 1;
                mn = 2;
                mx.pos = sum + 1;
                if (v[i].second == 'A')
                    mx.name = 'G';
                else
                    mx.name = 'A';
            }
        }
        else if (v[i].first >= 4)
        {
            if (log(v[i].first/2) < log(v[i].first))
            {
                if (check(v[i].first))
                {
                    if (mn < log(v[i].first))
                    {
                        mx.op = 1;
                        mn = log(v[i].first);
                        mx.pos = sum + v[i].first/2;
                        if (v[i].second == 'A')
                            mx.name = 'G';
                        else
                            mx.name = 'A';
                    }
                }
                else
                {
                    if (mn < log(v[i].first + 1))
                    {
                        mx.op = 1;
                        mn = log(v[i].first) + 1;
                        mx.pos = sum + v[i].first - pow(10, log(v[i].first)-1);
                        if (v[i].second == 'A')
                            mx.name = 'G';
                        else
                            mx.name = 'A';
                    }
                }
            }
            else
            {
                if (mn < log(v[i].first + 2))
                {
                    mx.op = 1;
                    mn = log(v[i].first + 2);
                    mx.pos = sum + v[i].first/2;
                    if (v[i].second == 'A')
                        mx.name = 'G';
                    else
                        mx.name = 'A';
                }
            }
        }
        sum += v[i].first;
    }
    /*if (mn == 1)
    {
        mx.op = 1;
        if (v[v.size()-1].second == 'A')
            mx.name = 'G';
        else
            mx.name = 'A';
        mx.pos = sum;
    }*/
    ans nm;
    mn = 0;
    sum = 0;
    for (int i = 0; i < v.size(); i++)
    {
        if (v[i].first == 1)
        {
            if (log(v[i-1].first) + log(v[i+1].first) - log(v[i-1].first + v[i+1].first) - 1 > mn)
            {
                mn = log(v[i-1].first) + log(v[i+1].first) - log(v[i-1].first + v[i+1].first) - 1;
                nm.op = 2;
                nm.pos = sum + 1;
            }
        }
        if (v[i].first == 2)
        {
            if (mn < 1)
            {
                mn = 1;
                nm.op = 2;
                nm.pos = sum + 1;
            }
        }
        if (check(v[i].first))
        {
            if (mn < 1)
            {
                mn = 1;
                nm.op = 2;
                nm.pos = sum+1;
            }
        }
        sum += v[i].first;
    }
    /*if (mn == 0)
    {
        nm.op = 2;
        nm.pos = sum;
    }*/
    cout << nm.op << " " << nm.pos << "\n";
    cout << mx.op << " " << mx.pos << " " << mx.name;

}
