#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <time.h>
#define lng long long
using namespace std;

string conv(lng a)
{
    string ans;
    vector <int> num;
    while (a > 0)
    {
        num.push_back(a%10);
        a/=10;
    }
    for (int i = num.size()-1; i >= 0; i--)
        ans.push_back(num[i] + '0');
    return ans;
}

int conv(string a)
{
    int ans = 0;
    int mod = 1;
    for (int i = a.size() - 1; i >= 0; i--)
    {
        ans += (a[i] - '0')*mod;
        mod *= 10;
    }
    return ans;
}

bool check(string a, bool k)
{
    vector <int> cnt(10);
    for (int i = 0; i < a.size(); i++)
        cnt[a[i] - '0']++;
    for (auto i : cnt)
        if (k && i >= a.size()-1 || (!k && i == a.size()))
            return 1;
    return 0;

}

int solveumnoe(string s, bool k)
{
    //cout << s << "\n";
    char c = s[0];
    if (!k) {
        string a, b;
        for (int i = 0; i < s.size(); i++)
            a.push_back(s[0]);
        for (int i = 0; i < s.size(); i++)
            b.push_back(s[0]+1);
        if (a < s)
            return conv(b);
        else
            return conv(a);
    }
    else
    {
        string a, b;
        string l = s;
        bool flag = 0;
        int j = 1;
        while (s[j] == s[j-1] && j < s.size())
            j++;
        c = s[j-1];
        int q = j+1;
        while (q < s.size() && s[q] == c)
            q++;
        if (q >= s.size())
        {
            return (conv(s));
            return 0;
        }
        if (l[q] > c) {
            if (l[j] != '9')
                l[j]++;
            else {
                flag = 1;
            }
        }
        if (!flag) {
            bool oleg = 0;
            for (int i = 0; i < j; i++)
                a.push_back(c);
            if (j < s.size())
                a.push_back(l[j]);
            for (int i = j+1; i < s.size(); i++) {
                if (l[j] != c)
                    a.push_back(c);
                else {
                    oleg = 1;
                    break;
                }
            }
            if (oleg)
            {
                a.push_back('0');
                for (int i = j+2; i < s.size(); i++)
                    a.push_back(c);
            }

        }
        else
        {
            for (int i = 0 ; i < j-1; i++)
                a.push_back(c);
            a.push_back(c+1);
            for (int i = j; i < s.size(); i++)
                a.push_back(c);
        }
        c = s[1];
        flag = 0;
        j = 2;
        while (s[j] == c && j < s.size())
            j++;
        if (j < s.size() && s[j] > c)
            c++;
        b.push_back(s[0]);
        for (int i = 1; i < s.size(); i++)
            b.push_back(c);
        return (conv(min(a, b)));
    }
}

int solvetupoe(int i, bool k)
{
    while (!check(conv(i), k))
        i++;
    return i;
}


int main()
{
    string s; cin >> s;
    bool k; cin >> k;
    cout << solveumnoe(s, k);
    /*for (int i = 1; i < 1e6; i++)
    {
        if (solveumnoe(conv(i), 1) != solvetupoe(i, 1))
        {
            cout << "AJWDJAWODJAWIODJAWUIHGDUIAWGDAWHDGAWUGDJAWND\n";
            cout << i << "\n";
            cout << solveumnoe(conv(i), 1) << " " << solvetupoe(i, 1);
            return 0;
        }
    }
    cout << "TVOI STRESSY GOVNO.";*/

}
