#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#define lng long long


using namespace std;

string sum(string a, string b)
{
    bool flag = 0;
    for (int i = a.size()-1; i >= 0; i--)
    {
        int temp = 0;
        if (flag)
            temp++;
        flag = 0;
        temp += a[i] - '0' + b[i] - '0';
        if (temp >= 10)
            flag = 1;
        a[i] = '0' + temp%10;
    }
    if (flag)
        return "*";
    else
        return a;
}

bool check(string a)
{
    return (a[0] > '0');
}

bool check(string a, string b, string c)
{
    return (sum(a, b) == c && check(a) && check(b) && check(c));
}

int main()
{
    string a, b, c; cin >> a >> b >> c;
    int n = a.size();
    vector <int> perm(n);
    for (int i = 1; i <= n; i++)
        perm[i-1] = i;
    int ans = 0;
    while (next_permutation(perm.begin(), perm.end()))
    {
        if (check(a, b, c))
            ans = (ans+1)%(1000000007);
        next_permutation(a.begin(), a.end());
        next_permutation(b.begin(), b.end());
        next_permutation(c.begin(), c.end());
    }
    if (check(a, b, c))
        ans++;
    cout << ans;

}
