#include <iostream>
#include <vector>

using namespace std;

int n, dist = 0;
vector<int> ans_perm, m, s;
vector<vector<int>> p;

void solve(vector<int>& perm, vector<int>& used) {
	if (perm.size() == n) {
		ans_perm = perm;
		return;
	}

	int k;
	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			continue;
		}
		k = perm.back();
		if (p[k][0] + dist * m[k] == s[k] + p[i][0]) {
			perm.push_back(i);
			used[i] = 1;
			solve(perm, used);
			perm.pop_back();
			used[i] = 0;
		}
	}
}

int main() {
	cin >> n;
	m.resize(n);
	s.resize(n);
	p.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> m[i] >> s[i];
		p[i].resize(m[i]);
		for (int j = 0; j < m[i]; ++j) {
			cin >> p[i][j];
		}
		if (m[i] > 1) {
			if (!dist) {
				dist = p[i][1] - p[i][0];
			}
			if (dist != p[i][1] - p[i][0]) {
				cout << "No";
				return 0;
			}
			for (int j = 2; j < m[i]; ++j) {
				if (p[i][j] - p[i][j - 1] != p[i][j - 1] - p[i][j]) {
					cout << "No";
					return 0;
				}
			}
		}
	}

	vector<int> perm, used(n, 0);
	for (int i = 0; i < n; ++i) {
		perm.push_back(i);
		used[i] = 1;
		solve(perm, used);
		perm.pop_back();
		used[i] = 0;
	}
	if (!ans_perm.empty()) {
		cout << "Yes\n";
		for (int i : ans_perm) {
			cout << i + 1 << ' ';
		}
	}
	else {
		cout << "No";
	}
	return 0;
}
