#include <iostream>
#include <vector>

using namespace std;

int n, m, c;

vector<int> ans;

bool ok(int x, int y) {
	int a0 = 0, a1 = 0;
	for (int i = 0, u = 1; i < m; ++i, u *= 2) {
		if ((x & u) == (y & u)) {
			if (x & u) {
				++a1;
			} else {
				++a0;
			}
		}
	}
	return a1 < 2 && a0 < 2;
}

void solve(int k, vector<int>& v) {
	if (k == n) {
		/*int a0, a1;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				a0 = a1 = 0;
				for (int w = 0, u = 1; w < m; ++w, u *= 2) {
					if ((v[i] & u) == (v[j] & u)) {
						if (v[i] & u) {
							++a1;
						} else {
							++a0;
						}
					}
				}
				if (a0 > 1 || a1 > 1) {
					return;
				}
			}
		}*/
		ans = v;
		return;
	}

	bool a;
	for (int i = (1 << m) - 1; i >= 0; --i) {
		a = false;
		for (int j : v) {
			if (!ok(i, j)) {
				a = true;
				break;
			}
		}
		if (a) {
			continue;
		}
		v.push_back(i);
		solve(k + 1, v);
		v.pop_back();
	}
}

int main() {
	cin >> n >> m >> c;
	vector<int> v;

	solve(0, v);
	for (int i = 0; i < n; ++i) {
		for (int j = 0, u = 1; j < m; ++j, u *= 2) {
			if (ans[i] & u) {
				cout << "2 ";
			} else {
				cout << "1 ";
			}
		}
		cout << '\n';
	}
	return 0;
}
