#include <bits/stdc++.h>
#define lint long long
using namespace std;

lint ver(lint n, lint m, lint v)
{
    return v*(v+1)/2 * n + n*(n-1)/2 * m * v;
}

lint hor(lint n, lint m, lint h)
{
    return m*h * (m*h + 1) / 2;
}

lint tab(lint n, lint m)
{
    return hor(n, m, n);
}

lint sephor(lint n, lint m, lint h)
{
    lint a = hor(n, m, h);
    lint b = tab(n, m) - a;
    return max(a - b, b - a);
}

lint sepver(lint n, lint m, lint v)
{
    lint a = ver(n, m, v);
    lint b = tab(n, m) - a;
    return max(a - b, b - a);
}

lint bsver(lint n, lint m)
{
    lint l = -1, r = m, mid;
    while(r - l > 1)
    {
        mid = (l + r) / 2;
        if(sepver(n, m, mid) > sepver(n, m, mid + 1)) l = mid;
        else r = mid;
    }
    return r;
}

lint bshor(lint n, lint m)
{
    lint l = -1, r = n, mid;
    while(r - l > 1)
    {
        mid = (l + r) / 2;
        if(sephor(n, m, mid) > sephor(n, m, mid + 1)) l = mid;
        else r = mid;
    }
    return r;
}

void solve()
{
    lint n, m;
    cin >> n >> m;
    lint a = bshor(n, m);
    lint b = bsver(n, m);
    if(sephor(n, m, a) < sepver(n, m, b)) cout << "H " << a + 1 << "\n";
    else cout << "V " << b + 1 << "\n";
}

int main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; i++) solve();
}
