#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5;

vector<pair<int, int>> g[MAXN];
int in[MAXN], out[MAXN], cur[MAXN];
vector<int> answer;

void dfs(int v) {
    while (cur[v] < g[v].size()) {
        int u = g[v][cur[v]].first, id = g[v][cur[v]].second;
        cur[v]++;
        dfs(u);
        answer.emplace_back(id);
    }
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    int ans = -1;
    vector<int> p[n], s(n), first(n), last(n);
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        cin >> s[i];
        p[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> p[i][j];
            if (j > 0) {
                if (ans == -1) {
                    ans = p[i][j] - p[i][j - 1];
                } else if (ans != p[i][j] - p[i][j - 1]) {
                    cout << "No\n";
                    return 0;
                }
            }
        }
        first[i] = p[i][0];
        last[i] = s[i] - p[i][m - 1];
    }
    if (ans != -1) {
        vector<int> vals;
        for (int i = 0; i < n; i++) {
            vals.emplace_back(first[i]);
            vals.emplace_back(ans - last[i]);
        }
        sort(vals.begin(), vals.end());
        vals.resize(unique(vals.begin(), vals.end()) - vals.begin());

        for (int i = 0; i < n; i++) {
            int v = lower_bound(vals.begin(), vals.end(), first[i]) - vals.begin();
            int u = lower_bound(vals.begin(), vals.end(), ans - last[i]) - vals.begin();
            g[v].emplace_back(u, i + 1);
            out[v]++;
            in[u]++;
        }
        for (int i = 0; i < vals.size(); i++) {
            if (in[i] < out[i]) {
                dfs(i);
                if (answer.size() < n) {
                    cout << "No\n";
                    return 0;
                }
                cout << "Yes\n";
                for (int i = n - 1; i >= 0; i--) {
                    cout << answer[i] << ' ';
                }
                cout << '\n';
                return 0;
            }
        }
        dfs(0);
        if (answer.size() < n) {
            cout << "No\n";
            return 0;
        }
        cout << "Yes\n";
        for (int i = n - 1; i >= 0; i--) {
            cout << answer[i] << ' ';
        }
        cout << '\n';
    }
    return 0;
}
