#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>
#include <cmath>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

int n, m, s, total;

const int inf = 1e18 + 123;

int hor(int x) {
    if (x > n) return inf;
    int s2 = x * n;
    return (s2 * (s2 + 1)) / 2;
}

int ver(int x) {
    if (x > m) return inf;
    int x0 = (x * (x + 1)) / 2;
    int d = x * m;
    return ((x0 + x0 + d * (n - 1)) / 2) * n;
}


void solve() {
    cin >> n >> m;
    s = n * m;
    total = (s * (s + 1)) / 2;
    int answer = inf;
    char ans = 'V';
    int index = 1;
    {
        // V
        int L = 0, R = m + 1;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            int x = ver(M), y = total - x;
            int x1 = ver(M + 1), y1 = total - x1;
            if (abs(x - y) < abs(x1 - y1)) {
                R = M;
            } else {
                L = M;
            }
            for (int i = max(0LL, L - 10); i <= min(m, L + 10); ++i) {
                int x = ver(i), y = total - x;
                if (abs(x - y) < answer) {
                    answer = abs(x - y);
                    ans = 'V';
                    index = i + 1;
                }
            }
        }
    }

    {
        // H
        int L = 0, R = n + 1;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            int x = hor(M), y = total - x;
            int x1 = hor(M + 1), y1 = total - x1;
            if (abs(x - y) < abs(x1 - y1)) {
                R = M;
            } else {
                L = M;
            }
            for (int i = max(0LL, L - 10); i <= min(n, L + 10); ++i) {
                int x = hor(i), y = total - x;
                if (abs(x - y) < answer) {
                    answer = abs(x - y);
                    ans = 'H';
                    index = i + 1;
                }
            }
        }
    }

    cout << ans << ' ' << index << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}