#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>
#include <cmath>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

int n, m;
ld s, total;

ld hor(int x) {
    ld s2 = 1.0 * x * m;
    return 1.0 * ((s2 * (s2 + 1)) / 2);
}

ld ver(int x) {
    if (x == 0) return 0;
    /*int res = 0;
    int y = (x * (x + 1)) / 2;
    for (int i = 0; i < n; ++i) {
        res += y;
        y += x * m;
    }
    return res;*/
    ld x1 = 1.0 * (x * (x + 1)) / 2;
    ld xn = 1.0 * x1 + (n - 1) * x * m;
    return 1.0 * ((x1 + xn) / 2) * n;
}


void solve() {
    cin >> n >> m;
    s = n * m;
    total = 1.0 * (s * 1.0 * (s + 1)) / 2;
    ld answer = -1.0;
    char ans = 'V';
    int index = 1;
    {
        // V
        int L = 0, R = m;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            ld x = ver(M), y = total - x;
            ld x1 = ver(M + 1), y1 = total - x1;
            if (abs(x - y) < abs(x1 - y1)) {
                R = M;
            } else {
                L = M;
            }
        }
        for (int i = max(0LL, L - 10); i <= min(m, L + 10); ++i) {
            ld x = ver(i), y = total - x;
            if (answer == -1 || abs(x - y) < answer) {
                answer = abs(x - y);
                ans = 'V';
                index = i + 1;
            }
        }
    }

    {
        // H
        int L = 0, R = n;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            ld x = hor(M), y = total - x;
            ld x1 = hor(M + 1), y1 = total - x1;
            if (abs(x - y) < abs(x1 - y1)) {
                R = M;
            } else {
                L = M;
            }
        }
        for (int i = max(0LL, L - 10); i <= min(n, L + 10); ++i) {
            ld x = hor(i), y = total - x;
            if (abs(x - y) < answer) {
                answer = abs(x - y);
                ans = 'H';
                index = i + 1;
            }
        }
    }

    cout << ans << ' ' << index << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}