#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

int get(int x) {
    if (x == 0) return 0;
    if (x == 1) return 1;
    int res = 0;
    while (x > 0) {
        x /= 10;
        res++;
    }
    return res + 1;
}

int count(pair<int, int> x) {
    return get(x.first) + get(x.second);
}
pair<int, int> br(int x) {
    pair<int, int> res = make_pair(x / 2, x - x / 2);
    for (int i = 10; i <= x; i *= 10) {
        pair<int, int> prob = make_pair(i, x - i);
        if (count(res) < count(prob)) {
            res = prob;
        }
    }
    return res;
}

void solve() {
    string s;
    cin >> s;
    vector<pair<int, char> > v;
    vector<int> lens;
    int l = 0;
    for (auto c : s) {
        if (c >= 'A' && c <= 'Z') {
            if (l == 0) {
                lens.push_back(1);
                v.push_back(make_pair(1, c));
            } else {
                lens.push_back(get(l));
                v.push_back(make_pair(l, c));
            }
            l = 0;
        } else {
            l = 10 * l + c - '0';
        }
    }

    {
        int maxdelta = -1;
        int pos = 0;
        int cur = 0;
        for (int i = 0; i < (int) v.size(); ++i) {
            int delta = get(v[i].first) - get(v[i].first - 1);
            if (i > 0 && i < (int) v.size() - 1) {
                if (v[i].first == 1) {
                    if (v[i - 1].second == v[i + 1].second) {
                        delta += lens[i + 1] + lens[i - 1] - get(v[i - 1].first + v[i + 1].first);
                    }
                }
            }
            if (delta > maxdelta) {
                maxdelta = delta;
                pos = cur;
            }
            cur += v[i].first;
        }
        cout << 2 << ' ' << pos + 1 << '\n';
    }

    {
        int maxdelta = -1;
        char ac = '-';
        int pos = 0, cur = 0;
        for (int i = 0; i < (int) v.size(); ++i) {
            int delta = 0;
            pair<int, int> xx = br(v[i].first);
            int x1 = xx.first, x2 = xx.second;
            set<char> st;
            st.insert('A');
            st.insert('G');
            st.insert('C');
            st.insert('T');
            for (int j = max(0LL, i - 1); j <= min((int) v.size() - 1, i + 1); ++j) {
                st.erase(v[j].second);
            }
            delta = get(x1) + get(x2) + 1 - lens[i];
            if (delta > maxdelta) {
                maxdelta = delta;
                ac = *st.begin();
                pos = cur + x1;
            }
            cur += v[i].first;
        }
        cout << 1 << ' ' << pos << ' ' << ac << '\n';
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}