#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

int FIXED = -1;

struct seg {
    int s;
    int m;
    vector<int> p;
    seg() {}
    void read() {
        cin >> m;
        cin >> s;
        p.resize(m);
        for (int i = 0; i < m; ++i) {
            cin >> p[i];
        }
    }
    int a = -1, b = -1;
    void go() {
        a = p[0], b = s - p.back();
        for (int i = 0; i < (int) p.size() - 1; ++i) {
            if (FIXED == -1) {
                FIXED = p[i + 1] - p[i];
            } else {
                if (FIXED != p[i + 1] - p[i]) {
                    cout << "No\n";
                    exit(0);
                }
            }
        }
    }
};


void solve() {
    int n;
    cin >> n;
    vector<seg> v(n);
    for (int i = 0; i < n; ++i) {
        v[i].read();
    }
    for (int i = 0; i < n; ++i) {
        v[i].go();
    }
    if (v.size() == 1) {
        cout << "Yes\n1\n";
        return;
    }
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    do {
        int nfixed = FIXED;
        bool ok = true;
        for (int i = 0; i < n - 1; ++i) {
            if (nfixed == -1) {
                nfixed = v[p[i]].b + v[p[i + 1]].a;
            } else {
                if (nfixed != v[p[i]].b + v[p[i + 1]].a) {
                    ok = false;
                    break;
                }
            }
        }
        if (ok) {
            cout << "Yes\n";
            for (auto i : p) {
                cout << i + 1 << ' ';
            }
            return;
        }
    } while(next_permutation(all(p)));
    cout << "No\n";
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}