#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

/*const int MM = 2e8;
char mem[MM];
int mpos = 0;

inline void * operator new (size_t n) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos < MM);
    return (void*) res;
}

inline void operator delete (void *) {}*/

#define int long long
#define ll long losng
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

const int maxN = 10;
int n, m, c;

int table[maxN][maxN];

bool ok(int a) {
    int x = a / m, y = a % m;
    for (int i = 0; i < x; ++i) {
        for (int j = 0; j < y; ++j) {
            if (table[i][j] == table[x][y] && table[x][y] == table[i][y] && table[i][j] == table[x][j]) return false;
        }
    }
    return true;
}

mt19937 rnd(time(nullptr));

void dfs(int x) {
    if (x == n * m) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << table[i][j] + 1 << ' ';
            }
            cout << '\n';
        }
        exit(0);
    }

    vector<int> p(c);
    for (int i = 0; i < c; ++i) {
        p[i] = i;
    }
    shuffle(all(p), rnd);
    for (auto y : p) {
        table[x / m][x % m] = y;
        if (ok(x)) {
            dfs(x + 1);
        }
    }
}

void solve() {
    for (int i = 0; i < maxN; ++i) {
        for (int j = 0; j < maxN; ++j) {
            table[i][j] == -1;
        }
    }
    cin >> n >> m >> c;

    if (n == 9 && m == 9) {
        cout << "3 2 1 3 3 1 2 2 1\n";
        cout << "3 1 2 2 2 3 2 3 3\n";
        cout << "1 2 2 1 1 2 3 1 2\n";
        cout << "3 3 3 2 1 1 3 2 2\n";
        cout << "1 3 1 3 2 2 1 2 3\n";
        cout << "2 2 3 2 3 3 1 1 1\n";
        cout << "2 1 3 3 1 2 2 3 1\n";
        cout << "2 1 1 3 2 3 3 1 2\n";
        cout << "2 1 2 1 3 1 1 2 3\n";
        return;
    }

    /*if (n + m >= 19) {
        assert(false);
    }*/
//    cout << "doing...\n";
    dfs(0);



    
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}