#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

/*const int MM = 2e8;
char mem[MM];
int mpos = 0;

inline void * operator new (size_t n) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos < MM);
    return (void*) res;
}

inline void operator delete (void *) {}*/

#define int long long
#define ll long losng
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

const int mod = 1e9 + 7;
const int maxN = 2e5 + 123;

int pwr(int a, int b) {
    if (b == 0) {
        return 1LL;
    }
    if (b == 1) {
        return a;
    }
    int aa = pwr(a, b / 2);
    aa = (aa * aa) % mod;
    if (b & 1) {
        aa = (aa * a) % mod;
    }
    return aa;
}

int inv(int x) {
    return pwr(x, mod - 2);
}

void mul(int &a, int b) {
    a = (a * b) % mod;
}

int fac[maxN];
int ifac[maxN];

void count_everything() {
    fac[0] = 1;
    ifac[0] = 1;
    for (int i = 1; i < maxN; ++i) {
        fac[i] = (i * fac[i - 1]) % mod;
        ifac[i] = inv(fac[i]);
    }
}

int A(int n, int k) {
    return (((fac[n] * ifac[n - k]) % mod) * fac[k]) % mod;
}


int hm[4];


struct col {
    int a, b, c;
    int typ = -1;
    bool bad = false;
    col() {}
    col(int _a, int _b, int _c) : a(_a), b(_b), c(_c) {
        if (a == 0 || b == 0 || c == 0) bad = true;
        if (a + b == c) {
            typ = 0;
        } else {
            if ((a + b) % 10 == c) {
                typ = 1;
            } else {
                if (a + b + 1 == c) {
                    typ = 2;
                } else {
                    if ((a + b + 1) % 10 == c) {
                        typ = 3;
                    }
                }
            }
        }
        if (typ == -1) {
            cout << "0\n";
            exit(0);
        }
        hm[typ]++;
    }
};

int ans = 0;

void solve() {
    count_everything();
    string a, b, c;
    cin >> a >> b >> c;
    int n = (int) a.size();
    vector<col> cols(n);
    for (int i = 0; i < n; ++i) {
        cols[i] = col(a[i] - '0', b[i] - '0', c[i] - '0');
    }
#ifndef lolipop
    if (n <= 6) {
        vector<int> p(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
        do {
            if (cols[p[0]].a == 0 || cols[p[0]].b == 0 || cols[p[0]].c == 0) {
                continue;
            }
            int tadd = 0;
            bool ok = true;
            for (int i = n - 1; i >= 0; --i) {
                if ( (tadd + cols[p[i]].a + cols[p[i]].b) % 10 == cols[p[i]].c ) {
                    tadd = (tadd + cols[p[i]].a + cols[p[i]].b) / 10;
                } else {
                    ok = false;
                    break;
                }
            }
            if (ok && (tadd == 0)) {
                ans++;
            }
        } while (next_permutation(all(p)));
    }
    cout << ans << '\n';
    return;
#endif
    if (hm[1] != hm[2]) {
        cout << "0\n";
    } else {
        if (hm[1] == 0) {
            ans = fac[n];
            cout << ans << '\n';
            return;
        }
        ans = (hm[1] * hm[2]) % mod;
        mul(ans, pwr(hm[3], hm[1]));
        mul(ans, A(n, hm[0]));
        cout << ans << '\n';
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}