#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ll long long
#define lll __int128_t
#define vi vector<ll>
#define pii pair<ll, ll>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define mp make_pair

const ll INF = 1e9;
const ll inf = 1e18;

using namespace std;

int log10(int x) {
    int cnt = 0;
    while (x) x /= 10, ++cnt;
    return cnt;
}

vector<char> u = {'A', 'C', 'T', 'G'};

char mex(vector<char> a) {
    for (int i = 0; i < 4; ++i) {
        bool ok = 1;
        for (char c : a) if (c == u[i]) ok = 0;
        if (ok) return u[i];
    }
}

int power10(int x) {
    int ans = 1;
    while (x--) ans *= 10;
    return ans;
}

int val(pair<int, char> a) {
    if (a.first == 1) return 1;
    return log10(a.first) + 1;
}

int val(int x) {
    if (x == 0) return 0;
    if (x == 1) return 1;
    return log10(x) + 1;
}

pii best(int x) {
    int f = min(power10(log10(x) - 1), x - 1);
    if (val(f) + val(x - f) > val(x / 2) + val(x - x / 2)) return mp(f, x - f);
    return mp(x / 2, x - x / 2);
}

vector<pair<int, char>> trans(string s) {
    int i = 0;
    int n = s.size();
    vector<pair<int, char>> ans;
    while (i < n) {
        int num = 0;
        while (i < n && s[i] - '0' < 10 && s[i] - '0' > -1) num *= 10, num += (s[i] - '0'), ++i;
        ans.push_back(mp(max(num, 1), s[i]));
        ++i;
    }
    return ans;
}

void upd(int &mx_ans, string &s, int val, int pos, char c) {
    if (mx_ans > val) return;
    mx_ans = val;
    s = "1 " + to_string(pos) + " " + c;
}

string min_val(vector<pair<int, char>> a, string s) {
    int mn_ans = s.size();
    int sum = s.size();
    int p = 0;
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        if (a[i].first > 1) {
            if (mn_ans >= sum + val(mp(a[i].first - 1, 'A')) - val(a[i])) {
                s = "2 " + to_string(p + 1);
                mn_ans = sum + val(mp(a[i].first - 1, 'A')) - val(a[i]);
            }
        } else {
            if (i && i < n - 1) {
                if (a[i - 1].second == a[i + 1].second) {
                    if (mn_ans >= sum - val(a[i - 1]) - val(a[i]) - val(a[i + 1]) +
                    val(mp(a[i - 1].first + a[i + 1].first, 'A'))) {
                        s = "2 " + to_string(p + 1);
                        mn_ans = sum - val(a[i - 1]) - val(a[i]) - val(a[i + 1]) +
                                 val(mp(a[i - 1].first + a[i + 1].first, 'A'));
                    }
                } else {
                    if (mn_ans >= sum - 1) {
                        s = "2 " + to_string(p + 1);
                        mn_ans = sum - 1;
                    }
                }
            } else {
                if (mn_ans >= sum - 1) {
                    s = "2 " + to_string(p + 1);
                    mn_ans = sum - 1;
                }
            }
        }
        p += a[i].first;
    }
    return s;
}

string mx_val(vector<pair<int, char>> a, string s) {
    int mx_ans = s.size();
    string ans;
    int p = 0;
    int n = a.size();
    int sum = s.size();
    for (int i = 0; i < n; ++i) {
        if (a[i].first > 1) {
            int f, s; tie(f, s) = best(a[i].first);
            if (mx_ans < sum - val(a[i]) + 1 + val(mp(f, 'A')) + val(mp(s, 'A'))) {
                upd(mx_ans, ans, sum - val(a[i]) + val(mp(f, 'A')) + val(mp(s, 'A')), p + f, mex({a[i].second}));
            }
        }
        upd(mx_ans, ans, sum + 1, p,
            mex({(i > 0 ? a[i - 1].second: '#'), a[i].second}));
        p += a[i].first;
    }
    return ans;
}

void solve() {
     string s; cin >> s;
     cout << min_val(trans(s), s) << "\n";
     cout << mx_val(trans(s), s) << "\n";
}

int main() {
    srand(time(0));

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
//    ll t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
