//#pragma ("Ofast", "fast-math")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ll long long
#define lll __int128_t
#define vi vector<ll>
#define pii pair<ll, ll>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define mp make_pair

const ll INF = 1e9;
const ll inf = 2e18;
const ll mod = 1e9 + 7;
const ll MAXN = 2e5 + 1;

using namespace std;

int cnt[4];
ll fact[MAXN];

ll fast_pow(ll x, ll y) {
    if (!y) return 1;
    if (y % 2) return (x * fast_pow(x, y - 1)) % mod;
    ll c = fast_pow(x, y / 2);
    return (c * c) % mod;
}

ll cc(ll n, ll k) {
    if (k == -1 || n == -1) return 1;
    return ((fact[n] * fast_pow(fact[k], mod - 2)) % mod * fast_pow(fact[n - k], mod - 2)) % mod;
}

void solve() {
    string a, b, c; cin >> a >> b >> c;
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        int an = a[i] - '0', bn = b[i] - '0', cn = c[i] - '0';
        if (an + bn == 9 && cn == 0) {
            cnt[3]++;
            continue;
        }
        if ((an + bn) % 10 > cn) {
            cout << "0\n";
            return;
        }
        if (cn - (an + bn) % 10 > 1) {
            cout << "0\n";
            return;
        }
        cnt[(an + bn) / 10 * 2 + ((an + bn) % 10 < cn)]++;
    }
    if (cnt[1] != cnt[2]) {
        cout << "0\n";
        return;
    }
    if (cnt[3] && !cnt[1]) {
        cout << "0\n";
        return;
    }
    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        fact[i] = (fact[i - 1] * i) % mod;
    }
    cout << (((((cc(cnt[3] + cnt[1] - 1, cnt[1] - 1) * fact[cnt[3]]) % mod * fact[cnt[1] + cnt[0]]) % mod) * fact[cnt[1]]) % mod * fact[cnt[1]]) % mod;
}

int main() {
    srand(time(0));

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
//    ll t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
