#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <map>


using namespace std;

long long k(long long n, long long m, long long mid1){
    return abs(((n * m + 1) * (n * m)) / 2 - (m * mid1 - m + 1) * (m * mid1 - m));
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        long long n, m;
        cin >> n >> m;
        long long s = 0;
        for (int j = 1; j < n; ++j) {
            s += m * j;
        }
        long long l = 1, r = m + 1;
        long long ind;
        while (r - l > 2){
            long long mid1 = l + (r - l) / 3, mid2 = r - (r - l) / 3;
            long long f1 = abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (mid1 - 1) + (((mid1 - 1) * mid1) / 2) * n));
            long long f2 = abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (mid2 - 1) + (((mid2 - 1) * mid2) / 2) * n));
            if (f1 <= f2) {
                r = mid2;
            }
            else {
                l = mid1;
            }
        }
        if (r - l == 2 && abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (l) + (((l - 1) * l) / 2) * n)) <= abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (r - 1) + (((r - 1) * r) / 2) * n))) r = l + 1;
        ind = l;
        if (abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (l - 1) + (((l - 1) * l) / 2) * n)) > abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (r - 1) + (((r - 1) * r) / 2) * n))) ind = r;
        long long ind1;
        l = 1, r = n + 1;
        while (r - l > 2){
            long long mid1 = l + (r - l) / 3, mid2 = r - (r - l) / 3;
            long long f1 = abs(((n * m + 1) * (n * m)) / 2 - (m * mid1 - m + 1) * (m * mid1 - m));
            long long f2 = abs(((n * m + 1) * (n * m)) / 2 - (m * mid2 - m + 1) * (m * mid2 - m));
            if (f1 <= f2) {
                r = mid2;
            }
            else {
                l = mid1;
            }
        }
        if (r - l == 2 && abs(((n * m + 1) * (n * m)) / 2 - (m * l + 1) * (m * l )) <= abs(((n * m + 1) * (n * m)) / 2 - (m * r - m + 1) * (m * r - m))) r = l + 1;
        ind1 = l;
        if (abs(((n * m + 1) * (n * m)) / 2 - (m * l - m + 1) * (m * l - m)) > abs(((n * m + 1) * (n * m)) / 2 - (m * r - m + 1) * (m * r - m))) ind1 = r;
        if (abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (ind - 1) + (((ind - 1) * ind) / 2) * n)) > abs(((n * m + 1) * (n * m)) / 2 - (m * ind1 - m + 1) * (m * ind1 - m))) cout << 'H' << ' ' << ind1 << '\n';
        else cout << 'V' << ' ' << ind << '\n';
    }
}
