#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <map>


using namespace std;
long long n, m, s;


inline long long f(long long mid1){
    return abs(((n * m + 1) * (n * m)) / 2 - 2 * (s * (mid1 - 1) + (((mid1 - 1) * mid1) / 2) * n));
}

inline long long F(long long mid1){
    return abs(((n * m + 1) * (n * m)) / 2 - (m * mid1 - m + 1) * (m * mid1 - m));
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        cin >> n >> m;
        s = 0;
        for (int j = 1; j < n; ++j) {
            s += m * j;
        }
        long long l = 1, r = m + 1;
        long long ind;
        while (r - l > 2){
            long long mid1 = l + (r - l) / 3, mid2 = r - (r - l) / 3;
            long long f1 = f(mid1);
            long long f2 = f(mid2);
            if (f1 <= f2) {
                r = mid2;
            }
            else {
                l = mid1;
            }
        }
        if (r - l == 2 && f(l + 1) <= f(r)) r = l + 1;
        ind = l;
        if (f(l) > f(r)) ind = r;
        long long ind1;
        l = 1, r = n + 1;
        while (r - l > 2){
            long long mid1 = l + (r - l) / 3, mid2 = r - (r - l) / 3;
            long long f1 = F(mid1);
            long long f2 = F(mid2);
            if (f1 <= f2) {
                r = mid2;
            }
            else {
                l = mid1;
            }
        }
        if (r - l == 2 && F(l + 1) <= F(r)) r = l + 1;
        ind1 = l;
        if (F(l) > F(r)) ind1 = r;
        if (f(ind) > F(ind1)) cout << 'H' << ' ' << ind1 << '\n';
        else cout << 'V' << ' ' << ind << '\n';
    }
}
