#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <math.h>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

int n, m;

int gver(int i) {
    int ans = m * (m + 1) / 2 - i * (i + 1);
    ans *= n;
    int kolvo = m - i - i;
    ans += kolvo * m * (n - 1);
    return ans;
}

int ghor(int i) {
    int ans = n * m * (n * m + 1) / 2 - m * i * (m * i + 1);
    return ans;
}


void solve() {
    cin >> n >> m;
    int l = 0, r = m + 1, mid;
    while (r - l > 1) {
        mid = (r + l) / 2;
        if (gver(mid) < 0) r = mid;
        else l = mid;
    }
    int ver = gver(l), ansv = l;
    if (l + 1 <= m && -gver(l + 1) < ver) {
        ver = -gver(l + 1);
        ansv = l + 1;
    }

    l = 0; r = n + 1;
    while (r - l > 1) {
        mid = (r + l) / 2;
        if (ghor(mid) < 0) r = mid;
        else l = mid;
    }
    int hor = ghor(l), ansh = l;
    if (l + 1 <= n && -ghor(l + 1) < hor) {
        hor = -ghor(l + 1);
        ansh = l + 1;
    }
    if (ver <= hor) {
        cout << "V " << ansv + 1 << '\n';
    } else {
        cout << "H " << ansh + 1 << '\n';
    }
}

int32_t main() {
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i{}; i < t; ++i) solve();
    return 0;
}
