#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <math.h>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

int len(int a) {
    int res = 0;
    while (a > 0) {
        res++;
        a /= 10;
    }
    return res;
}

int get(int a, int b) {
    int res = 0;
    for (int i{}; i < b; ++i) {
        res *= 10;
        res += a;
    }
    return res;
}

void solve1(int x) {
    int l = len(x);
    int t = x;
    while (t >= 10) {
        t /= 10;
    }
    if (get(t, l) >= x) {
        for (int i{}; i < l; ++i) cout << t;
        return;
    }
    t = (t + 1) % 10;
    if (get(t, l + 1) >= x) {
        for (int i{}; i < l; ++i) cout << t;
        return;
    }
    for (int i{}; i <= l; ++i) cout << 1;
}

int check (int x, int y, int l, int m) {
    int res = 1e18;
    vector<int> chk;
    chk.push_back(0);
    for (int i{}; i < l; ++i) {
        chk.push_back((1ll << i));
    }
    for (int i{}; i < l; ++i) {
        chk.push_back((1ll << (l + 1)) - 1 - (1ll << i));
    }
    for (auto i : chk) {
        int ii = i;
        int tmp = 0;
        for (int j{}; j < l; ++j) {
            tmp *= 10;
            if (ii & 1) tmp += x;
            else tmp += y;
            ii >>= 1;
        }
        if (tmp >= m && res > tmp) res = tmp;
    }
    return res;
}

void solve2(int x) {
    int l = len(x);
    int ans = 1e18;
    for (int i{}; i < 10; ++i) {
        for (int j{}; j < 10; ++j) {
            int t = check(i, j, l, x);
            if (t < ans) ans = t;
        }
    }
    cout << ans;
}

int32_t main() {
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    int x, k;
    cin >> x >> k;
    if (k == 0) {
        solve1(x);
    } else {
        solve2(x);
    }
    return 0;
}