#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <math.h>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

int n, m, c;
vector<vector<short>> a;
vector<int> pr(10000);
int mx = 1;

bool rek(int r) {
    if (r == n) return true;
    vector<short> tmp(m);
    for (int i{}; i < mx; ++i) {
        for (int ii = i, j = 0; j < m; ++j, ii /= c) {
            tmp[j] = ii % c;
        }
        vector<int> added;
        for (int j{}; j < m; j++) {
            for (int k{}; k < j; ++k) {
                if (tmp[j] != tmp[k]) continue;
                int ind = j + 10 * k + 100 * tmp[j];
                if (pr[ind] == 1) {
                    for (auto ttt : added) pr[ttt]--;
                    return false;
                }
                pr[ind]++;
                added.push_back(ind);
            }
        }
        if (!rek(r + 1)) {
            for (auto ttt : added) pr[ttt]--;
            continue;
        }
        for (int j{}; j < m; ++j) {
            a[r][j] = tmp[j];
        }
        return true;
    }
    return false;
}

int32_t main() {
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    cin >> n >> m >> c;
    a.resize(n, vector<short>(m));
    for (int i{}; i < m; ++i) {
        mx *= c;
    }
    // cout << mx << " " << rek(0) << '\n';
    rek(0);
    for (int i{}; i < n; ++i) {
        for (int j{}; j < m; ++j) {
            cout << a[i][j] + 1 << " ";
        }
        cout << '\n';
    }
    return 0;
}