#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <math.h>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

int n, m, c;
vector<vector<short>> a;
vector<int> pr(100000);
int mx = 1, sm = 0;

bool rek(int r) {
    if (r == n) return true;
    for (int i{}; i < mx; ++i) {
        for (int ii = i, j = 0; j < m; ++j, ii /= c) {
            a[r][j] = ii % c;
        }
        vector<int> added;
        bool flag = true;
        for (int j{}; j < m && flag; j++) {
            for (int k{}; k < j && flag; ++k) {
                if (a[r][j] != a[r][k]) continue;
                int ind = j + 10 * k + 100 * a[r][j];
                if (pr[ind] == 1) {
                    for (auto ttt : added) {
                        pr[ttt]--;
                        sm--;
                    }
                    flag = false;
                    break;
                }
                pr[ind]++;
                sm++;
                added.push_back(ind);
            }
        }
        if (!flag) continue;

        if (!rek(r + 1)) {
            for (auto ttt : added) {
                pr[ttt]--;
                sm--;
            }
            added.clear();
            continue;
        }
        return true;
    }
    return false;
}

int32_t main() {
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    cin >> n >> m >> c;
    a.resize(n, vector<short>(m));
    for (int i{}; i < m; ++i) {
        mx *= c;
    }
    // cout << mx << " " << rek(0) << '\n';
    rek(0);
    //cout << sm << '\n';
    for (int i{}; i < n; ++i) {
        for (int j{}; j < m; ++j) {
            cout << a[i][j] + 1 << " ";
        }
        cout << '\n';
    }
    return 0;
}