#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <math.h>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

int n, m, c;
vector<vector<short>> a;
vector<bool> pr(100000);
int mx = 1;
vector<int> goi;

bool rek(int r) {
    if (r == n) return true;
    //if (a[0][0] != 0) return false;
    for (auto i : goi) {
        for (int ii = i, j = 0; j < m; ++j, ii /= c) {
            a[r][j] = ii % c;
        }
        vector<int> added;
        bool flag = true;
        for (int j{}; j < m && flag; j++) {
            for (int k{}; k < j && flag; ++k) {
                if (a[r][j] != a[r][k]) continue;
                int ind = j + 10 * k + 100 * a[r][j];
                if (pr[ind] == 1 || a[0][0] == 0) {
                    for (auto ttt : added) {
                        pr[ttt] = false;
                    }
                    flag = false;
                    break;
                }
                pr[ind] = true;
                added.push_back(ind);
            }
        }
        if (!flag) continue;

        if (!rek(r + 1)) {
            for (auto ttt : added) {
                pr[ttt] = false;
            }
            added.clear();
            continue;
        }
        return true;
    }
    return false;
}

int32_t main() {
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    cin >> n >> m >> c;
    a.resize(n, vector<short>(m));
    for (int i{}; i < m; ++i) {
        mx *= c;
    }

    vector<pair<int, int>> ttt;
    for (int i{}; i < mx; ++i) {
        int t1{}, t2{}, t3{};
        for (int j{}, ii = i; j < m; ++j, ii /= c) {
            if (ii % c == 0) t1++;
            else if (ii % c == 1) t2++;
            else t3++;
        }
        ttt.push_back({t1 * (t1 - 1) / 2 + t2 * (t2- 1) / 2 + t3 * (t3 - 1) / 2, i});
    }
    sort(all(ttt));
    for (auto i : ttt) goi.push_back(i.y);

    if (c == 2) {
        rek(0);
        for (int i{}; i < n; ++i) {
            for (int j{}; j < m; ++j) {
                cout << a[i][j] + 1 << " ";
            }
            cout << '\n';
        }
        return 0;
    }
    rek(0);
    for (int i{}; i < n; ++i) {
        for (int j{}; j < m; ++j) {
            cout << a[i][j] + 1 << " ";
        }
        cout << '\n';
    }
    return 0;
}