#include <bits/stdc++.h>
using namespace std;

struct x {
    int val;
    char tp;
    x() {}
    x(int val, char tp) : val(val), tp(tp) {}
};

int get_cost(x now) {
    if (now.val == 0)
        return 0;
    if (now.val == 1)
        return 1;
    auto s = to_string(now.val);
    return s.size() + 1;
}

vector<pair<int, int>> gen_st10(int n) {
    vector<pair<int, int>> res;
    //if (n > 2)
    //    res.push_back({2, n - 2});
    for (int st10 = 1; st10 < n; st10 *= 10)
        res.push_back({st10, n - st10});
    return res;
}

int pw10(int st) {
    int res = 1;
    for (int i = 0; i < st; ++i)
        res *= 10;
    return res;
}

inline bool isdig(char c) {
    return '0' <= c && c <= '9';
}

signed main() {
    string ins;
    cin >> ins;
    vector<x> s;
    for (int i = 0, now = 0; i < ins.size(); ++i) {
        if (isdig(ins[i]))
            now = (now * 10 + ins[i] - '0');
        else
            s.push_back(x(max(now, 1), ins[i])), now = 0;
    }
    //for (auto now : s)
    //    cout << now.val << ' ' << now.tp << endl;
    pair<int, string> ansmn = {0, ""};
    for (int i = 0, sum = 0; i < s.size(); sum += s[i].val, ++i) {
        if (s[i].val > 1 || i == 0 || i + 1 == s.size() || s[i - 1].tp != s[i + 1].tp) {
            int cur = get_cost(s[i]);
            int will = get_cost(x(s[i].val - 1, s[i].tp));
            if (cur - will > ansmn.first) {
                ansmn.first = cur - will;
                ansmn.second = "2 " + to_string(sum + 1);
            }
        } else {
            int cur = get_cost(s[i]) + get_cost(s[i - 1]) + get_cost(s[i + 1]);
            int will = get_cost(x(s[i -1].val + s[i + 1].val, s[i - 1].tp));
            if (cur - will > ansmn.first) {
                ansmn.first = cur - will;
                ansmn.second = "2 " + to_string(sum + 1);
            }
        }
    }
    cout << ansmn.second << endl;
    pair<int, string> ansmx;
    if (s[0].tp == 'A')
        ansmx = {1, "1 0 T"};
    else
        ansmx = {1, "1 0 A"};
    for (int i = 0, sum = 0; i < s.size(); sum += s[i].val, ++i) {
        if (s[i].val > 1) {
            int cur = get_cost(s[i]);
            auto st10 = gen_st10(s[i].val);
            for (int j = 0; j < st10.size(); ++j) {
                auto now = st10[j];
                int will = get_cost(x(now.first, '-')) + get_cost(x(now.second, '-')) + 1;
                if (will - cur > ansmx.first) {
                    ansmx.first = will - cur;
                    ansmx.second = "1 " + to_string(sum + pw10(j)) + " ";
                    if (s[i].tp == 'A')
                        ansmx.second += 'T';
                    else
                        ansmx.second += 'A';
                }
            }
            if (s[i].val > 2) {
                int will = get_cost(x(2, '-')) + get_cost(x(s[i].val - 2, '-')) + 1;
                if (will - cur > ansmx.first) {
                    ansmx.first = will - cur;
                    ansmx.second = "1 " + to_string(sum + 2) + " ";
                    if (s[i].tp == 'A')
                        ansmx.second += 'T';
                    else
                        ansmx.second += 'A';
                }
            }
        }
    }
    cout << ansmx.second << endl;
    return 0;
}
