#include <bits/stdc++.h>
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    random_device rd;
    mt19937 gen(rd());
    uniform_real_distribution<> randd(0, 1);
    int n, m, k;
    cin >> n >> m >> k;
    int a[n][m];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            a[i][j] = gen() % k;
        }
    }

    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int i1 = i + 1; i1 < n; ++i1) {
                for (int j1 = j + 1; j1 < m; ++j1) {
                    if (a[i][j] == a[i][j1] && a[i][j1] == a[i1][j1] && a[i1][j1] == a[i1][j])
                        ++cnt;
                }
            }
        }
    }
    double temp = 1.;
    while (clock() < 0.9 * CLOCKS_PER_SEC) {
        int i = gen() % n, j = gen() % m;
        int wasval = a[i][j];
        int curval = gen() % k;
        int was = 0, cur = 0;

        //a[i][j] = gen() % k;
        for (int i1 = 0; i1 < n; ++i1) {
            if (i1 == i)
                continue;
            for (int j1 = 0; j1 < m; ++j1) {
                if (j == j1)
                    continue;
                if (wasval == a[i][j1] && a[i][j1] == a[i1][j1] && a[i1][j1] == a[i1][j]) ++was;
                if (curval == a[i][j1] && a[i][j1] == a[i1][j1] && a[i1][j1] == a[i1][j]) ++cur;
            }
        }
        if (cur <= was || exp((was - cur) / temp) >= randd(gen)) {
            a[i][j] = curval;
            cnt += cur - was;
        }
        temp *= 0.9999;
        //cout << cnt << ' ' << temp << endl;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j)
            cout << 1 + a[i][j] << ' ';
        cout << '\n';
    }
    //cout << cnt << endl;
    return 0;
}
