#include <bits/stdc++.h>
using namespace std;

const int mod = 1e9 + 7;
const int maxn = 2e5 + 5;

long long fact[maxn];

int bpw(int a, int n) {
    if (n == 0)
        return 1;
    long long res = bpw(a, n / 2);
    res = (res * res) % mod;
    if (n & 1)
        res = (res * a) % mod;
    return res;
}

int inv(int a) {
    return bpw(a, mod - 2);
}

int c(int n, int k) {
    if (k < 0 || k > n) return 0;
    long long r1 = fact[n], r2 = fact[k], r3 = fact[n - k];
    r2 = inv(r2), r3 = inv(r3);
    r1 = (r1 * r2) % mod;
    r1 = (r1 * r3) % mod;
    return r1;
}

bool check(char _t1, char _t2, char _sum) {
    int t1 = (int)(_t1 - '0');
    int t2 = (int)(_t2 - '0');
    int sum = (int)(_sum - '0');
    return true;
    return ((t1 + t2) % 10 == sum && t1 + t2 > 9) || ((t1 + t2) % 10 != sum && t1 + t2 <= 9);
}

int solve1(string s1, string s2, string s) {
    int n = s.size();
    vector<int> perm(n);
    int ans = 0;
    for (int i = 0; i < n; ++i)
        perm[i] = i;
    do {
        string t1 = s1, t2 = s2, t = s;
        for (int i = 0; i < n; ++i) {
            t[i] = s[perm[i]];
            t1[i] = s1[perm[i]];
            t2[i] = s2[perm[i]];
        }
        if (t[0] != '0' && t1[0] != '0' && t2[0] != '0' && stoi(t1) + stoi(t2) == stoi(t)) {
            ++ans;
        }
    } while (next_permutation(perm.begin(), perm.end()));
    return ans;
}

string gen1, gen2, gen3;

bool gen(int i, int j) {
    int fst = i, scd = j, sum = fst + scd;
    string s1 = to_string(fst), s2 = to_string(scd), s3 = to_string(sum);
    int n = s3.size();
    while (s1.size() < n) s1 = "0" + s1;
    while (s2.size() < n) s2 = "0" + s2;
    while (s3.size() < n) s3 = "0" + s3;
    //for (int j = 0; j < n; ++j)
    //    cout << (char)('1' + rand() % 9);
    //cout << endl;
    bool ok = true;
    for (auto c : s1) if (c == '0') ok = false;
    for (auto c : s2) if (c == '0') ok = false;
    for (auto c : s3) if (c == '0') ok = false;
    if (ok) {
        gen1 = s1;
        gen2 = s2;
        gen3 = s3;
    }
    return ok;
}

long long solve(string s1, string s2, string s) {
    int n = s.size();
    vector<int> t1(n), t2(n), sum(n);
    for (int i = 0; i < n; ++i) {
        t1[i] = s1[i] - '0';
        t2[i] = s2[i] - '0';
        sum[i] = s[i] - '0';
    }
    vector<int> a(4);
    vector<int> cnt1(4);
    for (int i = 0; i < n; ++i) {
        if ((t1[i] + t2[i]) % 10 == sum[i]) {
            // 0
            if (t1[i] + t2[i] > 9) {
                // 1
                a[1]++;
                if (t1[i] && t2[i] && sum[i]) ++cnt1[1];
            } else {
                // 0
                a[0]++;
                if (t1[i] && t2[i] && sum[i]) ++cnt1[0];
            }
        } else if ((t1[i] + t2[i] + 1) % 10 == sum[i]) {
            // 1
            if (t1[i] + t2[i] + 1 > 9) {
                // 1
                a[3]++;
                if (t1[i] && t2[i] && sum[i]) ++cnt1[3];
            } else {
                // 0
                a[2]++;
                if (t1[i] && t2[i] && sum[i]) ++cnt1[2];
            }
        } else {
            return 0;
            cout << 0 << endl;
            return 0;
        }
    }
    //swap(a[1], a[2]);
    long long ans = 0;
    int temp = 1;
    for (int i = 0; i < 4; ++i)
        temp = (temp * fact[a[i]]) % mod;
    if ((a[1] == a[2] || a[2] == a[1] + 1)) {
        long long cur = 1;
        if (a[0]) {
            cur *= c(a[0] - 1 + a[2], a[0]);
            cur %= mod;
        }
        if (a[3]) {
            cur *= c(a[3] - 1 + a[1], a[3]);
            cur %= mod;
        }
        cur *= temp;
        cur %= mod;
        ans += cur;
        ans %= mod;
    }
    //cout << ans << endl;
    int ttt = a[0];
    for (int i = 1; i <= ttt; ++i) {
        a[0] -= i;

        if ((a[1] == a[2] || a[2] == a[1] + 1)) {
            long long cur = 1;
            if (a[0]) {
                cur *= c(a[0] - 1 + a[2], a[0]);
                cur %= mod;
            }
            if (a[3]) {
                cur *= c(a[3] - 1 + a[1], a[3]);
                cur %= mod;
            }
            cur *= temp;
            cur %= mod;
            ans += cur;
            ans %= mod;
        }

        a[0] += i;
    }

    ans %= mod;
    //ans = (ans * temp) % mod;
    //cout << ans << endl;
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    string s1, s2, s;
    cin >> s1 >> s2 >> s;
    int n = s.size();
    vector<int> perm(n);
    for (int i = 0; i < n; ++i)
        perm[i] = i;
    long long ans = 0;
    if (n <= 6 && false) {
        do {
            string t1 = s1, t2 = s2, t = s;
            for (int i = 0; i < n; ++i) {
                t[i] = s[perm[i]];
                t1[i] = s1[perm[i]];
                t2[i] = s2[perm[i]];
            }
            if (t[0] != '0' && t1[0] != '0' && t2[0] != '0' && stoi(t1) + stoi(t2) == stoi(t)) {
                ++ans;
            }
        } while (next_permutation(perm.begin(), perm.end()));
        cout << ans << endl;
        return 0;
    }
    fact[0] = 1;
    for (int i = 1; i < maxn; ++i)
       fact[i] = (fact[i - 1] * 1ll * i) % mod;
    cout << solve(s1, s2, s) << endl;
   //string s1, s2, s;
   //cin >> s1 >> s2 >> s;
   //int n = s.size();
    return 0;
}
