#include <bits/stdc++.h>
#define int long long

using namespace std;

int n;
vector <int> path;
map <pair <int, int>, vector <int>> ending;
map <int, vector <int>> g;

void dfs(int v, int tar, map <int, vector <int>>& in_to_out, map <pair <int, int>, vector <int>>& ee) {
    while (!in_to_out[v].empty()) {
        int x = in_to_out[v].back();
        in_to_out[v].pop_back();
        dfs(tar - x, tar, in_to_out, ee);
        path.push_back(ee[{v, x}].back());
        ee[{v, x}].pop_back();
    }
}


void check(int v, map <int, vector <int>>& in, map <int, vector <int>>& out) {
    vector <int> notok;

    int start = -1;

    for (const auto& pa : in) {
        auto val = pa.first;
        auto vec = pa.second;
        if (out.count(v - val)) {
            if (vec.size() != out[v - val].size()) {
                notok.push_back(val);
                if (vec.size() - out[v - val].size() == 1)
                    start = val;
            }
        } else {
            notok.push_back(val);
            if (vec.size() == 1)
                start = val;
        }
    }

    auto in_to_out = g;
    auto ee = ending;
    path.clear();

    if (notok.empty()) {
        dfs(in.begin() -> first, v, in_to_out, ee);
        if ((int) path.size() == n) {
            reverse(path.begin(), path.end());

            cout << "Yes" << endl;
            for (int i : path)
                cout << i + 1 << " ";
            cout << endl;
            exit(0);
        }
    } else if (notok.size() <= 2) {
        if (start == -1)
            return;
        dfs(start, v, in_to_out, ee);
        if ((int) path.size() == n) {
            reverse(path.begin(), path.end());

            cout << "Yes" << endl;
            for (int i : path)
                cout << i + 1 << " ";
            cout << endl;
            exit(0);
        }
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;

    map <int, vector <int>> in, out;
    vector <int> st(n), fin(n);

    int tar = -1;

    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        if (m == 1) {
            int x;
            cin >> x;
            in[x].push_back(i);
            out[s - x].push_back(i);
            st[i] = x;
            fin[i] = s - x;
            ending[{x, s - x}].push_back(i);
            g[x].push_back(s - x);
        } else {
            vector <int> x(m);
            for (int& j : x)
                cin >> j;
            if (tar == -1)
                tar = x[1] - x[0];
            for (int j = 0; j < m - 1; j++) {
                if (x[j + 1] - x[j] != tar) {
                    cout << "No" << endl;
                    return 0;
                }
            }
            in[x.front()].push_back(i);
            out[s - x.back()].push_back(i);
            st[i] = x.front();
            fin[i] = s - x.back();
            ending[{x.front(), s - x.back()}].push_back(i);
            g[x.front()].push_back(s - x.back());
        }
    }

    if (tar != -1) {
        check(tar, in, out);
    } else {
        vector <int> inn, outt;
        for (const auto& pa : in) {
            auto coord = pa.first;
            auto cnt = pa.second;
            inn.push_back(coord);
            if (inn.size() == 3)
                break;
        }
        auto it = out.rbegin();
        outt.push_back(it->first);
        if (out.size() > 1) {
            it++;
            outt.push_back(it->first);
        }
        if (out.size() > 2) {
            it++;
            outt.push_back(it->first);
        }

        for (int i : inn) {
            for (int j : outt) {
                check(i + j, in, out);
            }
        }
    }
    cout << "No" << endl;
    return 0;
}
