#include <iostream>
#include <vector>

#define int long long

using namespace std;


string solve(const string &s) {
    bool ok = true;
    for (int i = 1; i < (int) s.size(); i++) {
        if (s[i] > s[0]) {
            ok = false;
        }
        if (s[i] != s[0])
            break;
    }

    if (ok) {
        return string(s.size(), s[0]);
    } else {
        if (s[0] == '9')
            return string(s.size() + 1, '1');
        else
            return string(s.size(), s[0] + 1);
    }
}

bool isok(string s) {
    bool ok = true;
    for (int i = 1; i < (int) s.size(); i++) {
        if (s[i] > s[0]) {
            ok = false;
        }
        if (s[i] != s[0])
            break;
    }
    return ok;
}

signed main() {
    vector<int> pow(19);
    pow[0] = 1;
    for (int i = 1; i < 19; i++)
        pow[i] = pow[i - 1] * 10;

    int x, k;
    cin >> x >> k;

    string s = to_string(x);
    if (k == 0) {
        cout << solve(s) << endl;
    } else {
        int ans = stoll(solve(s));

//        int now = stoll(s[0] + solve(s.substr(1, s.size())));
//        if (now < x)
//            now += pow[s.size() - 1];
//        ans = min(ans, now);
//
//        for (int i = 1; i < (int) s.size(); i++) {
//            if (s[i] == '9')
//                continue;
//
//            if (stoll(s.substr(i, s.size())) <= stoll(string(s.size() - i - 1, s[0]))) {
//                ans = min(ans, stoll(s.substr(0, i) + s[i] + string(s.size() - i - 1, s[0])));
//            } else {
//                ans = min(ans, stoll(s.substr(0, i) + (char) (s[i] + 1) + string(s.size() - i - 1, s[0])));
//            }
//            if (i > 0 && s[i] != s[i - 1])
//                break;
//        }

        for (int i = 0; i < (int) s.size(); i++) {
            string q;
            if (i == 0 || s[i] == '9')
                q = solve(s.substr(0, i) + s.substr(i + 1, s.size()));
            else
                q = solve(s.substr(0, i) + string(s.size() - i - 1, '0'));
            string w = solve(q);

            for (char c = '0'; c <= '9'; c++) {
                int now = stoll(q.substr(0, i) + c + q.substr(i, s.size()));
                if (now >= x && now < ans)
                    ans = now;
            }
        }
        cout << ans << endl;
    }
    return 0;
}
