#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <cmath>
#include <utility>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ii = pair<int, int>;
using vi = vector<int>;
using vii = vector<ii>;
using vvi = vector<vi>;

const ll INF = 1e18;

template<typename Functor>
ll ternarySearch(ll lo, ll hi, const Functor& check) {
    for (int i = 0; i < 100; ++i) {
        ll m1 = (2*lo+hi)/3;
        ll m2 = (lo + 2*hi)/3;
        if (check(m1) > check(m2)) {
            lo = m1;
        } else {
            hi = m2;
        }
    }
    return hi;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    for (int q = 0; q < t; ++q) {
        ll n, m;
        cin >> n >> m;
        ll s = n*m*(2 + (n*m - 1))/2;
        ll c1 = n + n*(n-1)*m/2;
        ll r1 = m + m*(m-1)/2;
        ll curr = -1;
        //ll num = 10000000000;
        //cout << 2*num << '\n';
        //cout << "s=" << s << " c1=" << c1 << " r1=" << r1 << '\n';
        char type;
        ll x;
        ll vx = ternarySearch(0ll, m-1, [c1, s, n, m](ll i) {
            ll sum_c1 = c1*i + i*(i-1)*n/2;
            ll ans = abs(2*sum_c1 - s);
            return ans;
        });
        for (ll i = max(0ll, vx-5); i < min(m, vx+5); ++i) {
            ll sum_c1 = c1*i + i*(i-1)*n/2;
            ll ans = abs(2*sum_c1 - s);
            //cout << "2*sum_c1=" << 2*sum_c1 << '\n';
            if (ans < curr || curr == -1) {
                curr = ans;
                type = 'V';
                x = i + 1;
            }
        }
        ll vy = ternarySearch(0ll, n-1, [r1, s, n, m](ll i) {
            ll sum_r1 = r1*i + i*(i-1)*m*m/2;
            ll ans = abs(2*sum_r1 - s);
            return ans;
        });
        for (ll i = max(0ll, vy-5); i < min(n, vy+5); ++i) {
            ll sum_r1 = r1*i + i*(i-1)*m*m/2;
            ll ans = abs(2*sum_r1 - s);
            //cout << "2*sum_r1=" << 2*sum_r1 << '\n';
            if (ans < curr || curr == -1) {
                curr = ans;
                type = 'H';
                x = i + 1;
            }
        }
        cout << type << ' ' << x << '\n';
    }

}
