#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <cmath>
#include <utility>
#include <algorithm>
#include <string>
#include <sstream>
#include <numeric>

using namespace std;
using ll = long long;
using ii = pair<int, int>;
using vi = vector<int>;
using vii = vector<ii>;
using vvi = vector<vi>;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vi m(n);
    vi s(n);
    vvi p(n);
    for (int i = 0; i < n; ++i) {
        cin >> m[i] >> s[i];
        for (int j = 0; j < m[i]; ++j) {
            int inp;
            cin >> inp;
            p[i].push_back(inp);
        }
    }

    vi perm(n);
    iota(perm.begin(), perm.end(), 0);
    bool found = false;
    do {
        found = true;
        int r = -1;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m[perm[i]]-1; ++j) {
                int curr = p[perm[i]][j+1] - p[perm[i]][j];
                if (r == -1) r = curr;
                if (curr != r) {
                    found = false;
                    goto BREAK;
                }
            }
            if (i != n-1) {
                int curr = p[perm[i+1]][0] + s[perm[i]] - p[perm[i]][m[perm[i]]-1];
                if (r == -1) r = curr;
                if (curr != r) {
                    found = false;
                    goto BREAK;
                }
            }
        }
        break;
        BREAK:;
    } while (next_permutation(perm.begin(), perm.end()));

    if (found) {
        cout << "Yes\n";
        for (int i = 0; i < n; ++i) {
            cout << perm[i]+1 << ' ';
        }
        cout << '\n';
    } else {
        cout << "No\n";
    }
}
