#define __GLIBCXX_DEBUG
#include <iostream>
#include<vector>
#include<set>
#include <algorithm>
#include <map>
#include <string>
#include <cmath>
#define ll long long
using namespace std;
bool cif(char c) {
    return c >= '0' && c <= '9';
}
int len(string  s) {
    if (s.size() == 1 && (s == "1"||s=="0"))
        return 0;
    else
        return s.size();
}
bool ten_pow(string  s) {
    if (s[0] != '1')
        return 0;
    for (int i = 1; i < s.size(); ++i) {
        if (s[i] != '0')
            return 0;
    }
    return 1;
}
string sum(string  s1, string  s2) {
    reverse(s1.begin(), s1.end());
    reverse(s2.begin(), s2.end());
    string s;
    int add = 0;
    int i;
    for (i = 0; i < s1.size() && i < s2.size(); ++i) {
        int cur = add + s1[i] - '0' + s2[i] - '0';
        s += '0' + cur % 10;
        add = cur / 10;
    }
    for (; i < s1.size(); ++i) {
        int cur = add + s1[i] - '0';
        s += '0' + cur % 10;
        add = cur / 10;
    }
    for (; i < s2.size(); ++i) {
        int cur = add + s2[i] - '0';
        s += '0' + cur % 10;
        add = cur / 10;
    }
    if(add!=0)
        s+=char('0'+add);
    while(s.back()=='0')
        s.pop_back();
    if(s.empty())
        s="0";
    reverse(s.begin(), s.end());

    return s;
}

string pw10(int a) {
    string s = "1";
    while (s.size() != a)
        s += '0';
    return s;
}
string pw5(int a) {
    string s = "5";
    while (s.size() != a)
        s += '0';
    return s;
}
signed main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    string s;
    cin >> s;
    vector<pair<string, char>> a;
    for (int i = 0; i < s.size();) {
        int j = i - 1;
        string cur;
        while (j + 1 < s.size() && cif(s[j + 1])) {
            j++;
            cur += s[j];
        }
        j++;
        if (cur.empty())
            cur = "1";
        a.push_back({cur, s[j]});
        i = j + 1;
    }
    ll ans_max = 0, ans_min = 2e12;
    string max_s, min_s;
    int n = a.size();
    ll s_len = s.size();
    min_s = "2 1";
    {// delete element
        int ind = -1;
        for (int i = 0; i < a.size(); ++i) {
            if (!ten_pow(a[i].first))//len is the same
            {
                continue;
            }
            if (a[i].first == "1") {
                ll cur = s_len - 1;
                if (n >= 3 && i != 0 && i + 1 < n && a[i - 1].second == a[i + 1].second) {
                    cur -= (len(a[i - 1].first) + 1);
                    cur -= (len(a[i + 1].first) + 1);
                    cur += 1 + len(sum(a[i - 1].first, a[i + 1].first));
                    if (ans_min > cur)
                        ans_min = cur, ind = i;
                } else if (ans_min > s_len - 1)
                    ans_min = s_len - 1, ind = i;
            } else {
                if (ans_min > s.size() - 1)
                    ans_min = s.size() - 1, ind = i;
            }
        }
        if (ind != -1) {
            string x = "1";
            for (int j = 0; j < ind; ++j)
                x = sum(x, a[j].first);
            min_s = "2 " + x;
        }
    }


    {//insert element/ find max_ans
        int ind = -1;
        ans_max = s_len + 1;
        max_s = "1 0 ";
        if (a[0].second == 'A')
            max_s += 'C';
        else
            max_s += 'A';
        for (int i = 0; i < n; ++i) {
            if (a[i].first == "1")
                continue;
            if (a[i].first.size() == 1) {
                if (a[i].first[0] >= '4') {
                    if (ans_max < s_len + 3)
                        ans_max = s_len + 3, ind = i;
                } else if (a[i].first[0] == '3') {
                    if (ans_max < s_len + 2)
                        ans_max = s_len + 2, ind = i;
                } else {
                    if (ans_max < s_len + 1)
                        ans_max = s_len + 1, ind = i;
                }
            } else {
                if (a[i].first[0] >= '2') {
                    if (ans_max < s_len + 2 + a[i].first.size())
                        ans_max = s_len + 2 + a[i].first.size(), ind = i;
                } else {//a[i].first[0]==1
                    if (a[i].first[1] != '0') {
                        if (ans_max < s_len + 1 + a[i].first.size())
                            ans_max = s_len + 1 + a[i].first.size(), ind = i;
                    } else {
                        if (ans_max < s_len + a[i].first.size())
                            ans_max = s_len + a[i].first.size(), ind = i;
                    }
                }
            }
        }

        if (ind != -1) {
            char z;
            if (a[ind].second == 'A')
                z = 'C';
            else
                z = 'A';
            string x = "0";
            for (int j = 0; j < ind; ++j) {
                x = sum(x, a[j].first);
            }
            if (a[ind].first.size() == 1) {
                if (a[ind].first[0] >= '4') {
                    x = sum(x, "2");
                } else if (a[ind].first[0] == '3')
                    x = sum(x, "2");
                else {
                    x = sum(x, "1");
                }
            } else {
                if (a[ind].first[0] >= '2') {
                    x = sum(x, pw10(a[ind].first.size()));
                } else {
                    if (a[ind].first[1] != '0')
                        x = sum(x, pw10(a[ind].first.size()));
                    else
                        x = sum(x, pw5(a[ind].first.size() - 1));
                }
            }
            max_s = "1 " + x + " " + z;
        }
    }
    cout << min_s << endl << max_s<<endl;
    return 0;
}