#pragma GCC optimize("Ofast")
#include <iostream>
#include<vector>
#include<set>
#include <algorithm>
#include <map>
#include <string>
#include <cmath>
#include <string.h>
#define ll long long
using namespace std;
int dp[7000000][4];
ll mod=1e9+7;
ll n1, n2, n3, n4;
ll f(int a1, int a2, int a3, int a4, int c) {
    ll ans = 0;
    if(a1==0&&a2==0&&a3==0&&a4==0)
    {
        return c==1||c==3;
    }
    ll mask = a1 * n2 * n3 * n4 + a2 * n3 * n4 + a3 * n4 + a4;
    if (dp[mask][c - 1] != -1)
        return dp[mask][c - 1];
    if (c == 1) {
        if (a1 != 0)
            ans += a1*f(a1 - 1, a2, a3, a4, 1), ans%=mod;
        if (a2 != 0)
            ans += a2*f(a1, a2 - 1, a3, a4, 2), ans%=mod;
    }
    if (c == 2) {
        if (a3 != 0)
            ans += a3*f(a1, a2, a3 - 1, a4, 3), ans%=mod;
        if (a4 != 0)
            ans += a4*f(a1, a2, a3, a4 - 1, 4), ans%=mod;
    }
    if (c == 3) {
        if (a1 != 0)
            ans += a1*f(a1 - 1, a2, a3, a4, 1), ans%=mod;
        if (a2 != 0)
            ans += a2*f(a1, a2 - 1, a3, a4, 2), ans%=mod;
    }
    if (c == 4) {
        if (a3 != 0)
            ans += a3*f(a1, a2, a3 - 1, a4, 3), ans%=mod;
        if (a4 != 0)
            ans +=a4* f(a1, a2, a3, a4 - 1, 4), ans%=mod;
    }
    return dp[mask][c - 1] = ans;
}
ll bp(ll a, ll n) {
    if (n == 0)
        return 1;
    if (n % 2 == 0) {
        ll b = bp(a, n / 2);
        return b * b % mod;
    }
    return a * bp(a, n - 1) % mod;
}
ll inv(ll a)
{
    return bp(a, mod-2);
}
const int N=200005;
ll fact[N], invfact[N];
ll C(ll n, ll k) {
    if (k > n)
        return 0;
    return fact[n] * invfact[k] % mod * invfact[n - k] % mod;
}
ll clc(ll n, ll k) {
    vector<vector<ll>> d(n + 1, vector<ll>(k + 1));
    for (int i = 0; i <= n; ++i) {
        for (int j = 1; j <= k; ++j) {
            if (i == 0) {
                d[i][j] = 1;
                continue;
            }
            if (j == 1) {
                d[i][j] = 1;
                continue;
            }
            for (int l = 0; l <= i; ++l) {
                d[i][j] += C(i, l) * d[i - l][j - 1] % mod;
                d[i][j] %= mod;
            }
        }
    }
    return d[n][k];
}
signed main() {
    std::ios_base::sync_with_stdio(0);
    cin.tie(0);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int a1 = 0, a2 = 0, a3 = 0, a4 = 0, g1 = 0, g2 = 0;
    int n = s1.size();
    for (int i = 0; i < n; ++i) {
        int c1 = s1[i] - '0';
        int c2 = s2[i] - '0';
        int c3 = s3[i] - '0';
        if ((c1 + c2) % 10 == c3) {
            if (c1 + c2 < 10) {
                a1++;
                if (c1 && c2 && c3)
                    g1++;
            } else
                a3++;

        } else if ((c1 + c2 + 1) % 10 == c3) {
            if (c1 + c2 + 1 < 10) {
                a2++;
                if (c1 && c2 && c3)
                    g2++;
            } else
                a4++;
        } else {
            cout << 0;
            return 0;
        }
    }
    if (a2 != a3) {
        cout << 0;
        return 0;
    }
    n1 = a1 + 1, n2 = a2 + 1, n3 = a3 + 1, n4 = a4 + 1;
    ll ans = 0;
    if (n <= 200) {
        memset(dp, -1, sizeof(dp));
        if (g1)
            ans += 1ll * g1 * f(a1 - 1, a2, a3, a4, 1) % mod, ans %= mod;
        if (g2)
            ans += 1ll * g2 * f(a1, a2 - 1, a3, a4, 2) % mod, ans %= mod;
        cout << ans;
        return 0;
    }
    ll k = a2;
    if (k == 1) {
        cout << 1;
        return 0;
    }

    cout << bp(k, a1) * bp(k, a4) % mod;
    return 0;
}