#include <iostream>
#include <map>
#include <vector>

using namespace std;

long long f(int a, int b, int c, int d, int flag, int s, int a0, int c0, vector<long long> &fs){
    if (a < 0 || b < 0 || c < 0 || d < 0){
        return 0;
    }
    if (a + b + c + d == 0){
        return 1;
    }
    if (flag == 1){
        return f(a - 1, b, c, d, 0, 0, a0, c0, fs) * (a - a0) + f(a, b, c - 1, d, 0, 1, a0, c0, fs) * (c - c0);
    }

    long long key;
    key = a + b * 6 + c * 36 + d * 216 + s * 1296;

    if (fs[key] != -1){
        return fs[key];
    }

    long long r;
    if (s == 1){
        r = f(a, b - 1, c, d, 0, 0, a0, c0, fs) * b + f(a, b, c, d - 1, 0, 1, a0, c0, fs) * d;
    }
    else{
        r = f(a - 1, b, c, d, 0, 0, a0, c0, fs) * a + f(a, b, c - 1, d, 0, 1, a0, c0, fs) * c;
    }
    //int r1 = r % 1000000007;
    fs[key] = r;
    return r;
}

int main(){
    string A;
    string B;
    string C;
    cin >> A;
    cin >> B;
    cin >> C;

    int n = A.size();

    int a = 0;
    int b = 0;
    int c = 0;
    int d = 0;
    int a0 = 0;
    int c0 = 0;
    int w = 1;

    vector<long long> fs;

    for (int i = 0; i < 2592; i++){
        fs.push_back(-1);
    }

    for (int i = 0; i < n; i++){
        int Ai=A[i]-48;
        int Bi=B[i]-48;
        int Ci=C[i]-48;

        int inp = 0;
        int outp = 0;
        if ((Ai + Bi) % 10 == Ci){
            if (Ai + Bi >= 10){
                outp = 1;
            }
        }
        else if ((Ai + Bi + 1) % 10 == Ci){
            inp = 1;
            if (Ai + Bi + 1 >= 10){
                outp = 1;
            }
        }
        else{
            //cout<<Ai<<Bi<<Ci;
            w = 0;
            break;
        }

        if (inp == 0 && outp == 0){
            a++;
            if (Ai * Bi * Ci == 0){
                a0++;
            }
        }
        else if (inp == 0 && outp == 1){
            b++;
        }
        else if (inp == 1 && outp == 0){
            c++;
            if (Ai * Bi * Ci == 0){
                c0++;
            }
        }
        else{
            d++;
        }
    }
    if (b != c){
        w = 0;
    }
    if (a + b < 1){
        w = 0;
    }
    //cout << a << b << c << d;
    if (w == 0){
        cout << 0;
    }
    else{
        cout << (f(a, b, c, d, 1, 0, a0, c0, fs) % (1000000007));
    }
}
