#include <bits/stdc++.h>

using namespace std;
#define int long long

int sum(int a, int b) {
    return a * b;
}

#define P 1000
int n, m;

int calcArithmetic(int start, int step, int cnt) {
    return start * cnt + step * cnt * (cnt - 1) / 2;
}

int total() {
    return calcArithmetic(1, 1, n * m);
}

int sumH(int ptr) {
    int D = calcArithmetic(0,m,ptr)*m;
    int first = D + ptr * calcArithmetic(1, 1, m);
    int second = total() - first;
    return abs(first - second);
}

int sumV(int ptr) {
    int D = calcArithmetic(0,1,ptr)*n;
    int first = D + ptr * calcArithmetic(1, m, n);
    int second = total() - first;
    return abs(first - second);
}

#define INF 2000000000000000000

void solve() {
    cin >> n >> m;
    string sans = "";
    int dans = INF;
    for (int i = 1; i < n; ++i) {
        int cur = sumH(i);
        string cans = "H " + to_string(i + 1);
        if (cur < dans) {
            sans = cans;
            dans = cur;
        }
    }
    for (int i = 1; i < m; ++i) {
        int cur = sumV(i);
        string cans = "V " + to_string(i + 1);
        if (cur < dans) {
            sans = cans;
            dans = cur;
        }
    }
    cout <<sans<<"\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
