#include <bits/stdc++.h>

using namespace std;
#define int long long

int n, m;

int calcArithmetic(int start, int step, int cnt) {
    return start * cnt + step * cnt * (cnt - 1) / 2;
}

int total() {
    return calcArithmetic(1, 1, n * m);
}

int sumH(int ptr) {
    int D = calcArithmetic(0, m, ptr) * m;
    int first = D + ptr * calcArithmetic(1, 1, m);
    int second = total() - first;
    return (first - second);
}

int sumV(int ptr) {
    int D = calcArithmetic(0, 1, ptr) * n;
    int first = D + ptr * calcArithmetic(1, m, n);
    int second = total() - first;
    return (first - second);
}

#define INF LONG_LONG_MAX

int bnH() {
    int l = 0;
    int r = n;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (sumH(mid) >= 0) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r;
}

int bnV() {
    int l = 0;
    int r = m;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (sumV(mid) >= 0) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r;
}

int D = 100;

void solve() {
    cin >> n >> m;
    string sans = "";
    int dans = INF;
    int lH = bnH();
    int lV = bnV();
    for (int i = lH - D; i <= lH + D; ++i) {
        if (i < 0 || i > n) {
            continue;
        }
        int cur = abs(sumH(i));
        string cans = "H " + to_string(i + 1);
        if (cur < dans) {
            sans = cans;
            dans = cur;
        }
    }
    for (int i = lV - D; i <= lV + D; ++i) {
        if (i < 0 || i > m) {
            continue;
        }
        int cur = abs(sumV(i));
        string cans = "V " + to_string(i + 1);
        if (cur < dans) {
            sans = cans;
            dans = cur;
        }
    }
    cout << sans << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
