#include <bits/stdc++.h>

using namespace std;
#define int long long
#define INF 2000000000
#define ends ends228
map<int, vector<int>> starts, ends;
int n;
#define MAXN 100000
int nxt[MAXN];
int pw[MAXN];

void dfs(int i) {
    cout << i + 1 << " ";
    pw[i] = -1;
    if (pw[nxt[i]] != -1) {
        dfs(nxt[i]);
    }
}

set<int> tmp;
vector<int> t1, t2;

void connect(vector<int> &a, vector<int> &b, int y) {
    for (int i = 0; i < y; ++i) {
        auto it = lower_bound(b.begin(), b.begin() + y, a[i]);
        if (*it == a[i]) {
            tmp.insert(a[i]);
        }
    }
    for (int i = 0; i < y; ++i) {
        if (tmp.count(a[i])) {
            t1.push_back(a[i]);
        }
        if (tmp.count(b[i])) {
            t2.push_back(b[i]);
        }
    }
    for (int i = 0; i < y; ++i) {
        if (!tmp.count(a[i])) {
            t1.push_back(a[i]);
        }
        if (!tmp.count(b[i])) {
            t2.push_back(b[i]);
        }
    }
    for (int i = 0; i < y; ++i) {
        int j = i+1;
        if(j>=t2.size()){
            j = 0;
        }
        nxt[t2[j]] = t1[i];
        pw[t1[i]]++;
    }
    tmp.clear();
    t1.clear();
    t2.clear();
}

void check(int x) {
    int cnt = 0;
    for (const auto &e:starts) {
        int a = e.second.size();
        int b = ends[x - e.first].size();
        int y = min(a, b);
        if (a + b - 2 * y > 1) {
            break;
        }
        cnt += y;
    }
    if (cnt >= n - 1) {
        memset(nxt, 255, sizeof(nxt));
        memset(pw, 0, sizeof(pw));
        for (auto &e:starts) {
            vector<int> &vec2 = ends[x - e.first];
            vector<int> &vec1 = e.second;
            int y = min(vec1.size(), vec2.size());
            connect(vec1, vec2, y);
        }
        cout << "Yes\n";
        if (cnt == n) {
            pw[0] = 0;
        }
        for (int i = 0; i < n; ++i) {
            if (pw[i] == 0) {
                dfs(i);
                break;
            }
        }
        exit(0);
    }
}

void rec2(int x) {
    {
        auto it = ends.begin();
        check(x + it->first);
        it++;
        if (it != ends.end()) {
            check(x + it->first);
        }
    }
    {
        auto it = ends.rbegin();
        check(x + it->first);
        it++;
        if (it != ends.rend()) {
            check(x + it->first);
        }
    }
}

void rec1() {
    {
        auto it = starts.begin();
        rec2(it->first);
        it++;
        if (it != starts.end()) {
            rec2(it->first);
        }
    }
    {
        auto it = starts.rbegin();
        rec2(it->first);
        it++;
        if (it != starts.rend()) {
            rec2(it->first);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    set<int> all;
    for (int i = 0; i < n; ++i) {
        int m, s;
        cin >> m >> s;
        int start = INF, end = INF;
        int last = -1;
        for (int j = 0; j < m; ++j) {
            int x;
            cin >> x;
            start = min(start, x);
            end = min(end, s - x);
            if (last != -1) {
                all.insert(x - last);
            }
            last = x;
        }
        starts[start].push_back(i);
        ends[end].push_back(i);
    }

    if (all.size() > 1) {
        cout << "No";
        return 0;
    }
    if (all.size() == 1) {
        check(*all.begin());
    }
    rec1();
    cout << "No";
    return 0;
}
