#include <bits/stdc++.h>

using namespace std;
#define int long long
#define INF 2000000000
#define ends ends228
map<int, vector<int>> starts, ends;
int n;
#define MAXN 100000
bool used[MAXN];
bool was[MAXN];
int nxt[MAXN];

int dsu[MAXN];

void reset() {
    for (int i = 0; i < MAXN; ++i) {
        dsu[i] = i;
    }
}

int pre(int v) {
    if (dsu[v] == v) {
        return v;
    }
    return dsu[v] = pre(dsu[v]);
}

void merge(int u, int v) {
    u = pre(u);
    v = pre(v);
    if (u == v) {
        return;
    }
    if (rand() % 2 == 0) {
        dsu[u] = v;
    } else {
        dsu[v] = u;
    }
}

vector<int> ans;

void dfs(int i) {
    was[i] = 1;
    ans.push_back(i + 1);
    if (nxt[i] >= 0 && nxt[i] < n && !was[nxt[i]]) {
        dfs(nxt[i]);
    }
}

void check(int x) {
    int ind = 0;
    memset(used, 0, sizeof(used));
    memset(nxt, 255, sizeof(nxt));
    reset();
    int c = 0;
    for (auto &e:starts) {
        vector<int> &vec1 = e.second;
        vector<int> &vec2 = ends[x - e.first];
        set<int> prior1, prior2;
        for (int u:vec1) {
            bool f = true;
            for (int v:vec2) {
                if (u == v) {
                    prior1.insert(u);
                    f = 0;
                    break;
                }
            }
            if (f) {
                prior2.insert(u);
            }
        }
        for (int u:prior1) {
            for (int v:vec2) {
                if (v == u) {
                    continue;
                }
                if (!used[v] && pre(u) != pre(v)) {
                    used[v] = 1;
                    nxt[u] = v;
                    c++;
                    merge(u, v);
                    break;
                }
            }
        }
        for (int u:prior2) {
            for (int v:vec2) {
                if (v == u) {
                    continue;
                }
                if (!used[v] && pre(u) != pre(v)) {
                    used[v] = 1;
                    nxt[u] = v;
                    c++;
                    merge(u, v);
                    break;
                }
            }
        }
    }
    if (c >= n - 1) {
        if (c == n) {
            used[0] = 0;
        }
        cout << "Yes\n";
        memset(was, 0, sizeof(was));
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs(i);
            }
        }
        while (ans.size() > 0) {
            cout << ans.back() << " ";
            ans.pop_back();
        }
        exit(0);
    }
}

void rec2(int x) {
    {
        auto it = ends.begin();
        check(x + it->first);
        it++;
        if (it != ends.end()) {
            check(x + it->first);
        }
    }
    {
        auto it = ends.rbegin();
        check(x + it->first);
        it++;
        if (it != ends.rend()) {
            check(x + it->first);
        }
    }
}

void rec1() {
    {
        auto it = starts.begin();
        rec2(it->first);
        it++;
        if (it != starts.end()) {
            rec2(it->first);
        }
    }
    {
        auto it = starts.rbegin();
        rec2(it->first);
        it++;
        if (it != starts.rend()) {
            rec2(it->first);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    set<int> all;
    for (int i = 0; i < n; ++i) {
        int m, s;
        cin >> m >> s;
        int start = INF, end = INF;
        int last = -1;
        for (int j = 0; j < m; ++j) {
            int x;
            cin >> x;
            start = min(start, x);
            end = min(end, s - x);
            if (last != -1) {
                all.insert(x - last);
            }
            last = x;
        }
        starts[start].push_back(i);
        ends[end].push_back(i);
    }

    if (all.size() > 1) {
        cout << "No";
        return 0;
    }
    if (all.size() == 1) {
        check(*all.begin());
    }
    rec1();
    cout << "No";
    return 0;
}
