#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
string s;
int L = 0;
char smb[4] = { 'A', 'C', 'G', 'T' };

int gets(int num)
{
    if (num == 1)
        return 0;
    int cnt = 0;
    while (num != 0)
    {
        ++cnt;
        num = num / 10;
    }
    return cnt;
}

int get_sz(string& ss)
{
    int ans = 0;
    char lst = 'B';
    int cnt = 0;
    for (int i = 0; i < ss.size(); ++i)
    {
        if (lst != ss[i])
        {
            if (cnt > 0)
                ans += 1 + gets(cnt);
            cnt = 0;
            lst = ss[i];
        }
        ++cnt;
    }
    ans += 1 + gets(cnt);
    return ans;
}

//next 3 functions return size of a new string
int ins(int x, char d)
{
    string ns = "";
    for (int i = 0; i < L; ++i)
    {
        if (i == x)
            ns.push_back(d);
        ns.push_back(s[i]);
    }
    return get_sz(ns);
}

int dlt(int x)
{
    string ns = "";
    for (int i = 0; i < L; ++i)
        if (i != x)
            ns.push_back(s[i]);
    return get_sz(ns);
}

int zam(int x, char nw)
{
    string ns = "";
    for (int i = 0; i < L; ++i)
    {
        if (i == x)
            ns.push_back(nw);
        else
            ns.push_back(s[i]);
    }
    return get_sz(ns);
}

void solve()
{
    int f = 2;
    int fm = 2;
    int x = 0;
    int xm = 0;
    char d = 'B';
    char dm = 'B';
    int mnsz = dlt(0);
    int mxsz = mnsz;
    for (int i = 0; i < L; ++i)
    {
        int nw = dlt(i);
        if (nw < mnsz)
        {
            f = 2;
            x = i;
            mnsz = nw;
        }
        if (nw > mxsz)
        {
            fm = 2;
            xm = i;
            mxsz = nw;
        }
        for (int j = 0; j < 4; ++j)
        {
            nw = ins(i, smb[j]);
            if (nw < mnsz)
            {
                f = 1;
                x = i - 1;
                d = smb[j];
                mnsz = nw;
            }
            if (nw > mxsz)
            {
                fm = 1;
                xm = i - 1;
                dm = smb[j];
                mxsz = nw;
            }
        }
        for (int j = 0; j < 4; ++j)
        {
            nw = zam(i, smb[j]);
            if (nw < mnsz)
            {
                f = 3;
                x = i;
                d = smb[j];
                mnsz = nw;
            }
            if (nw > mxsz)
            {
                fm = 3;
                xm = i;
                dm = smb[j];
                mxsz = nw;
            }
        }
    }
    for (int j = 0; j < 4; ++j)
    {
        int nw = ins(L, smb[j]);
        if (nw < mnsz)
        {
            f = 1;
            x = L;
            d = smb[j];
            mnsz = nw;
        }
        if (nw > mxsz)
        {
            fm = 1;
            xm = L;
            dm = smb[j];
            mxsz = nw;
        }
    }
    cout << f << ' ' << (x + 1);
    if (f != 2)
        cout << ' ' << d;
    cout << '\n';
    cout << fm << ' ' << (xm + 1);
    if (fm != 2)
        cout << ' ' << dm;
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    string str;
    cin >> str;
    int i = 0;
    while (i != str.size())
    {
        int nw = 0;
        while ('0' <= str[i] && str[i] <= '9')
        {
            nw = 10 * nw + str[i] - '0';
            ++i;
        }
        if (nw == 0)
            nw = 1;
        L += nw;
        for (int j = 0; j < nw; ++j)
            s.push_back(str[i]);
        ++i;
    }
    solve();
}
