#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
string s;
int L = 0;
char smb[4] = { 'A', 'C', 'G', 'T' };
int sm[100001];
vector<int> hm;
vector<int> wh;
vector<int> pr;
vector<int> lk;

int gets(int num)
{
    if (num == 1)
        return 0;
    int cnt = 0;
    while (num != 0)
    {
        ++cnt;
        num = num / 10;
    }
    return cnt;
}

int get_sz(string& ss)
{
    int ans = 0;
    char lst = 'B';
    int cnt = 0;
    for (int i = 0; i < ss.size(); ++i)
    {
        if (lst != ss[i])
        {
            if (cnt > 0)
                ans += 1 + sm[cnt];
            cnt = 0;
            lst = ss[i];
        }
        ++cnt;
    }
    ans += 1 + sm[cnt];
    return ans;
}

int getpr(int l, int r)
{
    if (l > r)
        return 0;
    if (r >= pr.size())
        r = pr.size() - 1;
    if (l > 0 && r >= 0)
        return pr[r] - pr[l - 1];
    if (r >= 0)
        return pr[r];
    return 0;
}

int get_wh(int i)
{
    int ans = 0;
    while (ans < lk.size() && lk[ans] <= i)
        ++ans;
    if (ans == lk.size())
        --ans;
    return ans;
}

pair<int, int> dvd(int i, int x)
{
    if (i == 0)
        return make_pair(x, lk[i] - x);
    else
        return make_pair(x - lk[i - 1], lk[i] - x);
}

//next 3 functions return size of a new string
int ins(int x, char d)
{
    int l = get_wh(x);
    int ans = getpr(0, l - 1) + getpr(l + 1, pr.size());
    if (d == wh[l])
    {
        ans += sm[hm[l] + 1] + 1;
        return ans;
    }
    pair<int, int> bb = dvd(l, x);
    ans += 3 + sm[bb.first] + sm[bb.second];
    return ans;
}

int dlt(int x)
{
    int l = get_wh(x);
    int ans = getpr(0, l - 1) + getpr(l + 1, pr.size());
    int hh = hm[l];
    --hh;
    if (hh != 0 || l == 0 || l == pr.size() - 1 || wh[l- 1] != wh[l + 1])
        return ans + 1 + sm[hh];
    ans = getpr(0, l - 2) + getpr(l + 2, pr.size()) + sm[hm[l - 1] + hm[l + 1]] + 1;
    return ans;
}

int zam(int x, char d)
{
    int l = get_wh(x);
    int ans = getpr(0, l - 1) + getpr(l + 1, pr.size());
    if (d == wh[l])
    {
        ans += sm[hm[l]] + 1;
        return ans;
    }
    pair<int, int> bb = dvd(l, x);
    --bb.second;
    if (l != 0 && l != pr.size() - 1 && hm[l] == 1 && wh[l - 1] == d && wh[l + 1] == d)
        return getpr(0, l - 2) + getpr(l + 2, pr.size()) + sm[hm[l - 1] + hm[l + 1] + 1] + 1;
    if (bb.first == 0 && l != 0 && wh[l - 1] == d)
        return getpr(l + 1, pr.size()) + 1 + sm[hm[l] - 1] + sm[hm[l - 1] + 1] + 1 + getpr(0, l - 2);
    if (bb.second == 0 && l != pr.size() - 1 && wh[l + 1] == d)
        return getpr(0, l - 1) + 1 + sm[hm[l] - 1] + sm[hm[l + 1] + 1] + 1 + getpr(l + 2, pr.size());
    ans += 3 + sm[bb.first] + sm[bb.second];
    return ans;
}

void solve()
{
    int f = 2;
    int fm = 2;
    int x = 0;
    int xm = 0;
    char d = 'B';
    char dm = 'B';
    int mnsz = dlt(0);
    int mxsz = mnsz;
    for (int i = 0; i < L; ++i)
    {
        int nw = dlt(i);
        if (nw < mnsz)
        {
            f = 2;
            x = i;
            mnsz = nw;
        }
        if (nw > mxsz)
        {
            fm = 2;
            xm = i;
            mxsz = nw;
        }
        for (int j = 0; j < 4; ++j)
        {
            nw = ins(i, smb[j]);
            if (nw < mnsz)
            {
                f = 1;
                x = i - 1;
                d = smb[j];
                mnsz = nw;
            }
            if (nw > mxsz)
            {
                fm = 1;
                xm = i - 1;
                dm = smb[j];
                mxsz = nw;
            }
        }
        for (int j = 0; j < 4; ++j)
        {
            nw = zam(i, smb[j]);
            if (nw < mnsz)
            {
                f = 3;
                x = i;
                d = smb[j];
                mnsz = nw;
            }
            if (nw > mxsz)
            {
                fm = 3;
                xm = i;
                dm = smb[j];
                mxsz = nw;
            }
        }
    }
    for (int j = 0; j < 4; ++j)
    {
        int nw = ins(L, smb[j]);
        if (nw < mnsz)
        {
            f = 1;
            x = L;
            d = smb[j];
            mnsz = nw;
        }
        if (nw > mxsz)
        {
            fm = 1;
            xm = L;
            dm = smb[j];
            mxsz = nw;
        }
    }
    cout << f << ' ' << (x + 1);
    if (f != 2)
        cout << ' ' << d;
    cout << '\n';
    cout << fm << ' ' << (xm + 1);
    if (fm != 2)
        cout << ' ' << dm;
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    sm[0] = -1;
    for (int i = 1; i <= 100000; ++i)
        sm[i] = gets(i);
    string str;
    cin >> str;
    int i = 0;
    while (i != str.size())
    {
        int nw = 0;
        while ('0' <= str[i] && str[i] <= '9')
        {
            nw = 10 * nw + str[i] - '0';
            ++i;
        }
        if (nw == 0)
            nw = 1;
        L += nw;
        for (int j = 0; j < nw; ++j)
            s.push_back(str[i]);
        hm.push_back(nw);
        wh.push_back(str[i]);
        pr.push_back(i + 1);
        if (lk.size() == 0)
            lk.push_back(nw);
        else
            lk.push_back(nw + lk[lk.size() - 1]);
        ++i;
    }
    solve();
}
