#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
int used[6];
vector<int> nw;
string a, b, c;
int n;

int check()
{
    int ai = 0;
    int bi = 0;
    int ci = 0;
    for (int i = 0; i < n; ++i)
    {
        int j = nw[i];
        if (i == 0 && (a[j] == '0' || b[j] == '0' || c[j] == '0'))
            return 0;
        ai = 10 * ai + a[j] - '0';
        bi = 10 * bi + b[j] - '0';
        ci = 10 * ci + c[j] - '0';
    }
    return (ai + bi == ci);
}

int per(int i)
{
    if (i == n)
        return check();
    int ans = 0;
    for (int j = 0; j < n; ++j)
        if (used[j] == 0)
        {
            used[j] = 1;
            nw.push_back(j);
            ans += per(i + 1);
            used[j] = 0;
            nw.pop_back();
        }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> a >> b >> c;
    n = a.size();
    cout << per(0);
}
