#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC optimize("avx,avx2")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

int n;
vector<int> a, b;
unordered_map<int, int> acnt, bcnt;

int getbcnt(int k) {
    if (k < 0) return 0;
    return bcnt[k];
}

int getacnt(int k) {
    if (k < 0) return 0;
    return acnt[k];
}

bool valid(int x, int maxs) {
    int founda = 0;
    int foundb = 0;
    if (n <= 1000) {
        for (int i = 0; i < n; ++i) {
            if (getacnt(a[i]) == getbcnt(x - a[i]) + 1) {
                founda += 1;
            } else if (getacnt(a[i]) > getbcnt(x - a[i]) + 1) {
                return false;
            }
            if (getbcnt(b[i]) == getacnt(x - b[i]) + 1) {
                foundb += 1;
            } else if (getbcnt(b[i]) > getacnt(x - b[i]) + 1) {
                return false;
            }
        }
    } else {
        for (int k = 0; k <= maxs; ++k) {
            if (getacnt(k) == getbcnt(x - k) + 1) {
                founda += 1;
            } else if (getacnt(k) > getbcnt(x - k) + 1) {
                return false;
            }
            if (getbcnt(k) == getacnt(x - k) + 1) {
                foundb += 1;
            } else if (getbcnt(k) > getacnt(x - k) + 1) {
                return false;
            }
        }
    }
    if ((founda == 1 && foundb == 1) || (founda == 0 && foundb == 0)) {
        return true;
    }
    return false;
}

signed main() {
    int n; cin >> n;
    int L = 0, M = 0;
    a.resize(n); b.resize(n);
    int d = -1;
    for (int i = 0; i < n; ++i) {
        int m, s; cin >> m >> s;
        M += m; L += s;
        vector<int> p (m);
        for (int j = 0; j < m; ++j) {
            cin >> p[j];
        }
        a[i] = p[0];
        b[i] = s - p[m - 1];
        if (m > 1) {
            if (d == -1) d = p[1] - p[0];
            for (int j = 1; j + 1 < m; ++j) {
                if (p[j + 1] - p[j] != d) {
                    cout << "No" << '\n';
                    return 0;
                }
            }
        }
    }
    int maxa = 0, maxb = 0;
    for (int i = 0; i < n; ++i) {
        acnt[a[i]] += 1; maxa = max(maxa, a[i]);
        bcnt[b[i]] += 1; maxb = max(maxb, b[i]);
    }
    /*if (d == -1) {
        for (int x = 0; x <= maxa + maxb; ++x) {
            if (valid(x, maxa + maxb)) {
                //cout << "Yes" << '\n';
                d = x;
            }
        }
        if (d == -1) {
            cout << "No" << '\n';
            return 0;
        }
    }
    int start = 0, end = 0;
    for (int i = 0; i < n; ++i) {
        if (getacnt(a[i]) == getbcnt(d - a[i]) + 1) {
            start = i;
        }
        if (getbcnt(b[i]) == getacnt(d - b[i]) + 1) {
            end = i;
        }
    }*/
    if (n == 1) {
        cout << "Yes" << '\n' << "1" << '\n';
        return 0;
    }
    vector<int> order (n);
    for (int i = 0; i < n; ++i) order[i] = i;
    do {
        int cd = b[order[0]] + a[order[1]];
        if (d != -1 && cd != d) continue;
        bool ok = true;
        for (int i = 1; i + 1 < n; ++i) {
            if (b[order[i]] + a[order[i + 1]] != cd) {
                ok = false;
                break;
            }
        }
        if (!ok) continue;
        cout << "Yes" << '\n';
        for (int i = 0; i < n; ++i) {
            cout << order[i] + 1 << ' ';
        } cout << '\n';
        return 0;
    } while (next_permutation(order.begin(), order.end()));
    cout << "No" << '\n';
}