#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<ll> good;
vector<ll> almost_good;

ll get_number(int len, int digit, int pos, int diff_digit) {
    ll x = 0;
    for (int i = 0; i < len; ++i) {
        x *= 10;
        if (i != pos) x += digit;
        else x += diff_digit;
    }
    return x;
}

void fill_good() {
    for (int len = 0; len < 19; ++len) {
        for (int d = 0; d <= 9; ++d) {
            good.push_back(get_number(len, d, -1, 0));

            for (int pos = 0; pos < len; ++pos) {
                for (int dd = 0; dd <= 9; ++dd) {
                    if (dd == d) continue;
                    almost_good.push_back(get_number(len, d, pos, dd));
                }
            }
        }
    }
}

signed main() {
    fill_good();
    ll x; cin >> x;
    int w; cin >> w;
    ll ans = 1e18 + 1329;
    for (ll y : good) {
        if (y >= x && y - x < ans - x) {
            ans = y;
        }
    }
    if (w) {
        for (ll y : almost_good) {
            if (y >= x && y - x < ans - x) {
                ans = y;
            }
        }
    }
    cout << ans << '\n';
}