#include <iostream>
#include <vector>

using namespace std;

int n, m;

int count_rect(int** state) {
    int ans = 0;
    for (int i1 = 0; i1 < n; ++i1) {
        for (int j1 = 0; j1 < m; ++j1) {
            for (int i2 = 0; i2 < i1; ++i2) {
                for (int j2 = 0; j2 < m; ++j2) {
                    if (j1 == j2 || state[i1][j1] != state[i2][j2]) continue;
                    int c = state[i1][j1];
                    if (state[i1][j2] == c && state[i2][j1] == c) ans += 1;
                }
            }
        }
    }
    return ans;
}

signed main() {
    int n, m; cin >> n >> m;
    int c; cin >> c;
    if (c == 2) {
        if (n == 2) {
            for (int i = 0; i < m; ++i) {
                cout << 1 << ' ';
            } cout << '\n';
            for (int i = 0; i < m; ++i) {
                cout << 2 << ' ';
            } cout << '\n';
            return 0;
        }
        if (m == 6) {
            vector<vector<int>> ans = {{1, 1, 1, 2, 2, 2}, {1, 2, 2, 2, 1, 1}, {2, 2, 1, 1, 1, 2}, {2, 1, 2, 1, 2, 1}};
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << ans[i][j] << ' ';
                } cout << '\n';
            }
            return 0;
        }
        vector<vector<int>> ans = {{1, 1, 2, 2, 2}, {1, 2, 2, 1, 1}, {2, 2, 1, 1, 2}, {2, 1, 1, 2, 1}, {2, 1, 2, 1, 2}};
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << ans[i][j] << ' ';
            } cout << '\n';
        }
    } else { // c = 3

    }
}