#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define int long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define ld long double

const ll inf = 5e18;

int n, m;
ll total;

ll sumV(int x) {
	ll ans = n * x * (x - 1) / 2;
	ans += (ll)(x - 1) * m * n * (n - 1) / 2;
	return ans;
}

ll sumH(int x) {
	ll ans = (ll)(m * (x - 1)) * (m * (x - 1) + 1) / 2;
	return ans;
}


// bool operator<(pair<char, int> a, pair<char, int> b) {
// 	return tie(b.first, a.second) < tie(a.first, b.second);
// }

void solve() {
	cin >> n >> m;

	// cout << "n = " << n << " m = " << m << " : \n";
	total = (ll)(n * m) * (n * m + 1) / 2;
	// cout << "total = " << total << '\n';

	// cout << "sumV(3) = " << sumV(3) << '\n';

	pair<char, int> ans = {'V', 1};
	ll abs1 = inf;

	int l = 1;
	int r = m + 1;
	while (l + 1 < r) {
		int m1 = (l + r) >> 1;
		if (2 * sumV(m1) <= total) {
			l = m1;
		} else {
			r = m1;
		}
	}

	if (abs(total - 2 * sumV(l)) < abs1) {
		abs1 = abs(total - 2 * sumV(l));
		ans = {'V', l};
	}
	if (abs(total - 2 * sumV(r)) < abs1) {
		abs1 = abs(total - 2 * sumV(r));
		ans = {'V', r};
	}


	l = 1;
	r = n + 1;

	while (l + 1 < r) {
		int m1 = (l + r) >> 1;
		if (2 * sumH(m1) <= total) {
			l = m1;
		} else {
			r = m1;
		}
	}

	if (abs(total - 2 * sumH(l)) < abs1) {
		abs1 = abs(total - 2 * sumH(l));
		ans = {'H', l};
	}
	if (abs(total - 2 * sumH(r)) < abs1) {
		abs1 = abs(total - 2 * sumH(r));
		ans = {'H', r};
	}

	cout << ans.first << ' ' << ans.second << '\n';
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}
