#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define ld long double


int n;
vector<pii> a;


map<int, vector<int>> group;

vector<int> key;
int pos(int s) {
	int pos1 = lower_bound(all(key), s) - key.begin();
	if (pos1 != key.end() - key.begin() && key[pos1] == s) return pos1;
	return -1;
}

vector<vector<pii>> g;
vector<int> in;

void go_way(int v) {
	while (g[v].size()) {
		pii p1 = g[v].back();
		g[v].pop_back();
		cout << p1.second + 1 << ' ';
		go_way(p1.first);
	}
}


void solvel(int len) {
	g.assign(group.size(), vector<pii> (0));
	in.assign(group.size(), 0);

	pii final = {-1, -1};

	for (auto v : group) {
		int me = pos(a[v.second[0]].first);

		for (auto i : v.second) {
			int p1 = pos(len - a[i].second);
			if (p1 == -1) {
				if (final.first != -1) return;
				final = {me, i};
			} else {
				g[me].push_back({p1, i});
				in[p1]++;			
			}
		}
	}

	// for (int i = 0; i < g.size(); i++) {
	// 	cout << i + 1 << " : ";
	// 	for (auto j : g[i]) {
	// 		cout << j.first + 1 << ' ';
	// 	}
	// 	cout << endl;
	// }

	if (final.first == -1) {
		int end = -1;
		int start = -1;
		for (int i = 0; i < g.size(); i++) {
			if (g[i].size() > in[i]) {
				if (g[i].size() > in[i] + 1 || start != -1) return;
				start = i;
			} else if (g[i].size() < in[i]) {
				if (g[i].size() < in[i] - 1 || end != -1) return;
				end = i;
			}
		}
		cout << "Yes\n";
		go_way(start + (start == -1));
		exit(0);
	} else {
		int end = -1;
		int start = -1;
		for (int i = 0; i < g.size(); i++) {
			if (g[i].size() > in[i]) {
				if (g[i].size() > in[i] + 1 || start != -1) return;
				start = i;
			} else if (g[i].size() < in[i]) {
				if (g[i].size() < in[i] - 1 || end != -1) return;
				end = i;
			}
		}
		if (end == -1 || end == final.first) {
			cout << "Yes\n";
			if (start == -1) {
				go_way(final.first);
			} else {
				go_way(start);
			}
			cout << final.second + 1 << '\n';
			exit(0);
		}
		return;
	}
}

void solve0() {
	for (int i = 0; i <= 200; i++) {
		solvel(i);
	}
	cout << "No\n";
}

int len = -1;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	a.resize(n);

	for (int i = 0; i < n; i++) {
		int m, s;
		cin >> m >> s;
		vector<int> p(m);
		for (int j = 0; j < m; j++) {
			cin >> p[j];
		}
		a[i] = {p[0], s - p.back()};
		key.push_back(p[0]);

		for (int i = 1; i < m; i++) {
			if (len != -1 && p[i] - p[i - 1] != len) {
				cout << "No\n";
				exit(0);
			}
			len = p[i] - p[i - 1];
		}
	}

	for (int i = 0; i < n; i++) {
		group[a[i].first].push_back(i);
	}

	// for (auto p : group) {
	// 	cout << p.first << " : ";
	// 	for (auto i : p.second) {
	// 		cout << i + 1 << ' ';
	// 	}
	// 	cout << endl;
	// }

	sort(all(key));
	key.resize(unique(all(key)) - key.begin());

	if (len == 0) {
		solve0();
	} else {
		solvel(len);
		cout << "No\n";
		exit(0);
	}

	return 0;
}
