#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define ld long double


int n;
vector<pii> a;


map<int, vector<int>> group;

vector<int> key;
int pos(int s) {
	int pos1 = lower_bound(all(key), s) - key.begin();
	if (pos1 != key.end() - key.begin() && key[pos1] == s) return pos1;
	return -1;
}

vector<vector<pii>> g;
vector<int> in;

void find_way(int u, vector<pii> &v) {
	if (g[u].size() == 0) return;
	pii p1 = g[u].back();
	g[u].pop_back();
	v.push_back(p1);
	find_way(p1.first, v);
}


vector<pii> total;

void go_way(int start, int fin, vector<pii> &way) {
	vector<pii> ans;
	find_way(start, ans);
	if (ans.size() == 0) {
		assert(0);
	}
	int last = start;
	for (int i = 0; i < ans.size(); i++) {
		if (g[last].size() != 0) {
			vector<pii> v1;
			go_way(last, last, v1);
			for (auto j : v1) {
				way.push_back(j);
			}
		}
		way.push_back(ans[i]);
		last = ans[i].first;
	}
	if (g[last].size() != 0) {
		vector<pii> v1;
		go_way(last, last, v1);
		for (auto j : v1) {
			way.push_back(j);
		}
	}
}

bool e_way(int start, int fin) {
	int sum = 0;
	for	(auto i : in) {
		sum += i;
	}

	if (sum == 0) {
		total.resize(0);
		return 1;
	}

	vector<pii> way;
	go_way(start, fin, way);

	if (way.size() < sum) return 0;
	// if (way.size() > sum) {
	// 	assert(0);
	// }
	total = way;
	return 1;
}

void draw(int start, int fin) {
	for (auto i : total) {
		cout << i.second + 1 << ' ';
	}
}


void solvel(int len) {
	g.assign(group.size(), vector<pii> (0));
	in.assign(group.size(), 0);

	pii final = {-1, -1};

	for (auto v : group) {
		int me = pos(a[v.second[0]].first);

		for (auto i : v.second) {
			int p1 = pos(len - a[i].second);
			if (p1 == -1) {
				if (final.first != -1) return;
				final = {me, i};
			} else {
				g[me].push_back({p1, i});
				in[p1]++;			
			}
		}
	}

	// for (int i = 0; i < g.size(); i++) {
	// 	cout << i + 1 << " : ";
	// 	for (auto j : g[i]) {
	// 		cout << j.first + 1 << ' ';
	// 	}
	// 	cout << endl;
	// }

	if (final.first == -1) {
		int end = -1;
		int start = -1;
		for (int i = 0; i < g.size(); i++) {
			if (g[i].size() > in[i]) {
				if (g[i].size() > in[i] + 1 || start != -1) return;
				start = i;
			} else if (g[i].size() < in[i]) {
				if (g[i].size() < in[i] - 1 || end != -1) return;
				end = i;
			}
		}

		if (e_way(start + (start == -1), end + (end == -1))) {
			cout << "Yes\n";
			draw(start + (start == -1), end + (end == -1));
			exit(0);
		}

	} else {
		int end = -1;
		int start = -1;
		for (int i = 0; i < g.size(); i++) {
			if (g[i].size() > in[i]) {
				if (g[i].size() > in[i] + 1 || start != -1) return;
				start = i;
			} else if (g[i].size() < in[i]) {
				if (g[i].size() < in[i] - 1 || end != -1) return;
				end = i;
			}
		}
		if (end == -1 || end == final.first) {
			if (start == -1) {
				if (!e_way(final.first, final.first)) return;
				cout << "Yes\n";
				draw(final.first, final.first);
				cout << final.second + 1 << '\n';
				exit(0);
			} else {
				if (!e_way(start, final.first)) return;
				cout << "Yes\n";
				draw(start, final.first);
				cout << final.second + 1 << '\n';
				exit(0);
			}
		}
		return;
	}
}

void solve0() {
	// for (int i = 0; i < 200; i++) {
	// 	solvel(i);
	// }
	// cout << "No\n";
	// exit(0);
	vector<int> f;
	for (auto i : a) {
		f.push_back(i.first);
	}

	vector<int> s;
	for (auto i : a) {
		s.push_back(i.second);
	}
	sort(all(f));
	sort(s.rbegin(), s.rend());

	for (int i = 0; i < f.size() && i < 3; i++) {
		for (int j = 0; j < s.size() && j < 3; j++) {
			if (f[i] + f[j] > 200) continue;
			solvel(f[i] + s[j]);
		}
	}

	cout << "No\n";
	exit(0);
}

int len = -1;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	a.resize(n);

	for (int i = 0; i < n; i++) {
		int m, s;
		cin >> m >> s;
		vector<int> p(m);
		for (int j = 0; j < m; j++) {
			cin >> p[j];
		}
		a[i] = {p[0], s - p.back()};
		key.push_back(p[0]);

		for (int i = 1; i < m; i++) {
			if (len != -1 && p[i] - p[i - 1] != len) {
				cout << "No\n";
				exit(0);
			}
			len = p[i] - p[i - 1];
		}
	}

	if (n == 1) {
		cout << "Yes\n1\n";
		exit(0);
	}

	for (int i = 0; i < n; i++) {
		group[a[i].first].push_back(i);
	}

	sort(all(key));
	key.resize(unique(all(key)) - key.begin());

	if (len == -1) {
		solve0();
	} else {
		solvel(len);
		cout << "No\n";
		exit(0);
	}

	return 0;
}
