#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define ld long double

const int mod = 1e9 + 7;

int sum(int a, int b) {
	return (a + b) % mod; 
}
int mul(int a, int b) {
	return (ll)a * b % mod;
}

int n;
string sa, sb, sc;
vector<int> a, b, c;

bool check(vector<int> v) {
	if (a[v[0]] == 0 || b[v[0]] == 0 || c[v[0]] == 0) return 0;

	int nxt = 0;
	for (int i = v.size() - 1; i >= 0; i--) {
		int h = a[v[i]] + b[v[i]] + nxt;
		if (h % 10 != c[v[i]]) return 0;
		nxt = h / 10;
	}
	if (nxt) return 0;
	return 1;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> sa >> sb >> sc;
	n = sa.size();
	a.resize(n);
	b.resize(n);
	c.resize(n);

	for (int i = 0; i < n; i++) {
		a[i] = sa[i] - '0';
		b[i] = sb[i] - '0';
		c[i] = sc[i] - '0';
	}


	vector<int> v;
	for (int i = 0; i < n; i++){
		v.push_back(i);
	}

	int ans = check(v);

	while (next_permutation(all(v))) {
		ans += check(v);
	}

	cout << ans << '\n';

	return 0;
}

// g++ -o main main.cpp && time ./main
