#include <bits/stdc++.h>
using namespace std;
using ll = long long;

char getNextChar(char x, char y) {
    for (char nw: "ACGT") {
        if (nw != x && nw != y) return nw;
    }
}

int log10(int n) {
    if (n == 1) return 0;
    if (n == 0) return -1;
    int res = 0;
    while (n > 0) {
        ++res;
        n /= 10;
    }
    return res;
}

struct Block {
    int c;
    char type;
    int size;
    Block(int c, char type) {
        this->c = c;
        this->type = type;
        size = log10(c) + 1;
    }
};

int main() {
    vector<Block> a;
    char x;
    int cur = 0;
    while (cin >> x) {
        if ('0' <= x && x <= '9') {
            x -= 48;
            cur = cur * 10;
            cur = cur + x;
        }
        else {
            if (cur == 0) cur = 1;
            a.push_back(Block(cur, x));
            cur = 0;
        }
    }
    int profit = 0;
    int pos = 0;
    int curpos = 0;
    int maxprofit = 0;
    int maxpos = 0;
    char maxt = 'A'; // a g c t
    for (int i = 0; i < a.size(); curpos += a[i++].c) {
        if (i > 0 && i < a.size() - 1) {
            if (a[i].c == 1) {
                if (a[i - 1].type == a[i + 1].type) {
                    int np = (a[i - 1].size + a[i + 1].size - log10(a[i - 1].c + a[i + 1].c + 1));
                    if (np > profit) {
                        pos = curpos;
                        profit = np;
                    }
                }
                else {
                    if (1 > profit) {
                        pos = curpos;
                        profit = 1;
                    }
                }
            }
        }
        int np = a[i].size - log10(a[i].c - 1) - 1;
        if (np > profit) {
            pos = curpos;
            profit = np;
        }
        //////////////////////////////////
        int kek1 = a[i].c / 2;
        int kek2 = a[i].c - kek1;
        int nw = log10(kek1) + log10(kek2) + 3;
        int was = log10(a[i].c) + 1;
        if (nw - was > maxprofit) {
            maxpos = curpos + kek2 - 1;
            maxprofit = nw - was;
            maxt = getNextChar(a[i].type, (i == a.size() - 1 ? 'X' : a[i + 1].type));
        }
    }
    cout << 2 << ' ' << 1 + pos << '\n';
    cout << 1 << ' ' << maxpos + 1 << ' ' << maxt;
    return 0;
}
