#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <math.h>
#include <sstream>
using namespace std;

string code_dna(string str){
    string res="";
    int i,j,k;
    for(i=0;i<str.size();i++){
        k=0;
        j=1;
        while(isdigit(str[i])){
           k+=j*(int(str[i])-48);
           i++;
           j*=10;
        }
        for(j=0;j<k;j++){
            res+=str[i];
        }
        if(k==0){
            res+=str[i];
        }
    }
    return res;
}

string dna_code(string str){
    int i,j,k;
    string res="";
    stringstream con;
    for(i=0;i<str.size()-1;i++){
        k=1;
        while(str[i]==str[i+1]){
            k++;
            i++;
        }
        con.clear();
        if(k!=1){
            con<<k;
            string w;
            con>>w;
            res+=w;
            res+=str[i];
        }else{
            res+=str[i];
        }
    }
    if(str[str.size()-1]!=str[str.size()-2]){
        res+=str[str.size()-1];
    }
    return res;
}

int main(){
    string code,strcode,dna,str;
    int i,y,x,minlen,maxlen=0,b,a;
    char s,g;
    getline(cin,code);
    dna=code_dna(code);
    minlen=code.size();
    for(i=0;i<dna.size();i++){
        str=dna;
        str[i]='A';
        strcode=dna_code(str);
        if(minlen>strcode.size()){
            minlen=strcode.size();
            y=3;
            x=i+1;
            s='A';
        }
        if(maxlen<strcode.size()){
            maxlen=strcode.size();
            b=3;
            a=i+1;
            g='A';
        }
        str[i]='G';
        strcode=dna_code(str);
        if(minlen>strcode.size()){
            minlen=strcode.size();
            y=3;
            x=i+1;
            s='G';
        }
        if(maxlen<strcode.size()){
            maxlen=strcode.size();
            b=3;
            a=i+1;
            g='G';
        }
        str[i]='C';
        strcode=dna_code(str);
        if(minlen>strcode.size()){
            minlen=strcode.size();
            y=3;
            x=i+1;
            s='C';
        }
        if(maxlen<strcode.size()){
            maxlen=strcode.size();
            b=3;
            a=i+1;
            g='C';
        }
        str[i]='T';
        strcode=dna_code(str);
        if(minlen>strcode.size()){
            minlen=strcode.size();
            y=3;
            x=i+1;
            s='T';
        }
        if(maxlen<strcode.size()){
            maxlen=strcode.size();
            b=3;
            a=i+1;
            g='T';
        }
        str.clear();
        str=dna;
        str.erase(i,1);
        strcode=dna_code(str);
        if(minlen>strcode.size()){
            y=2;
            x=i+1;
            s='B';
        }
        if(maxlen<strcode.size()){
            b=2;
            a=i+1;
            g='B';
        }
        str=dna;
        str.insert(i,"A");
        strcode=dna_code(str);
        if(maxlen<strcode.size()){
            b=1;
            a=i+1;
            g='A';
        }
        str=dna;
        str.insert(i,"G");
        strcode=dna_code(str);
        if(maxlen<strcode.size()){
            b=1;
            a=i+1;
            g='G';
        }
        str=dna;
        str.insert(i,"C");
        strcode=dna_code(str);
        if(maxlen<strcode.size()){
            b=1;
            a=i+1;
            g='C';
        }
        str=dna;
        str.insert(i,"T");
        strcode=dna_code(str);
        if(maxlen<strcode.size()){
            b=1;
            a=i+1;
            g='T';
        }
    }
    cout<<y<<" "<<x<<" "<<s<<endl;
    cout<<b<<" "<<a<<" "<<g<<endl;
    return 0;
}
