#include <iostream>

using namespace std;

#define INF 1e9;
#define LINF 1e18;

int t, n, m;

inline int64_t sum0(int64_t n) {
	return (n*(n+1)) / 2;
}

inline int64_t sumd(int64_t s, int64_t e) {
	return sum0(e) - sum0(s);
}

inline int64_t V_cut1(int64_t p) {
	//cout << sum0(p - 1) << ' ' << sumd(p-1, m) << ' ';
	return abs(sum0(p - 1) - sumd(p-1, m));
}

int main() {
	cin >> t;
	for (int i = 0; i < t; i++) {
		cin >> n >> m;
		if (n == 1) {
			int s = 1;
			int e = m;
			for (int i = 0; i < 100; i++) {
				int t1 = (2 * s + e) / 3;
				int t2 = (s + 2 * e) / 3;
				int64_t v1 = V_cut1(t1);
				int64_t v2 = V_cut1(t2);
				//cout << t1 << ':' << v1 << ' ' << t2 << ':' << v2 << '\n';
				if (v1 < v2) {
					e = t2;
				}
				else if(v2 < v1){
					s = t1;
				}
				else {
					s = t1;
					e = t2;
				}
				if (s == e)break;
			}
			int64_t mind = LINF;
			int minp = s;
			for (int q = s; q <= e; q++) {
				int64_t val = V_cut1(q);
				if (val < mind) {
					mind = val;
					minp = q;
				}
			}
			//cout << s << ' ' << e << ' ';
			cout << "V " << minp << '\n';
		}
		else cout << "err";
	}
	return 0;
}