#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int64_t mod = 1e9 + 7;

string str[3];
vector<int> diffs;

inline void swap(string& s, int i1, int i2) {
	int len = s.length();
	if (i1 < len && i2 < len) {
		char tmp = s[i1];
		s[i1] = s[i2];
		s[i2] = tmp;
	}
}

int64_t fac(int n) {
	int64_t res = 1;
	for (int i = 2; i <= n; i++)res = (res * i) % mod;
	return res;
}

inline int getDif(int id) {
	int val = str[1][id] + str[0][id] - '0' - str[2][id];
	if (val >= 10)val -= 9;
	return val;
}

int main() {
	cin >> str[0] >> str[1] >> str[2];
	int64_t count = 0;
	diffs.reserve(str[0].length());
	int diffSum = 0;
	int udiffSum = 0;
	int len = str[0].length();
	for (int i = 0; i < str[0].length(); i++) {
		int val = getDif(i);
		if (abs(val) > 1) {
			cout << 0;
			return 0;
		}
		diffSum += val;
		udiffSum += abs(val);
	}
	udiffSum /= 2;
	if (diffSum != 0) {
		cout << 0;
		return 0;
	}
	count = fac(udiffSum);
	count *= count;
	count %= mod;
	count *= fac(len-udiffSum);
	count %= mod;
	cout << count;
	return 0;
}