#include <bits/stdc++.h>

using namespace std;

#define PB push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void TL(){
	int t = 0;
	while(t + 1)
		t++;
}

int n; 
vector <ll> s;
vector <vector <ll>> m;

ll d = -1;
ll er = 0;
vector <vector <ll>> L;
vector <int> A;
vector <int> used;

void normalize(){
	for(int i = 0; i < n; ++i){
		int p = m[i].size();
		for(int j = 1; j < p; ++j){
			ll curd = m[i][j] - m[i][j - 1];
			if(d == -1)
				d = curd;
			else if(d != curd)
				er = 1;
		}
		
		ll beg = m[i][0], end = s[i] - m[i][p -1];
		L.PB({beg, end, i});
	}
}

void solve(ll d){
	er = 0;
	ll S = 0;
	for(auto line : L)
		S += (line[0] + line[1]);
		
	int beg = -1, end = -1;
		
	for(int i = 0; i < n; ++i){
		for(int j = 0; j < n; j++){
			if(i == j) continue;
			
			ll curt = L[i][0] + L[j][1];
			
			if(S - curt == d or d != 0 and ((S - curt) % d == 0  and (S - curt) / d == (n - 1) )){
				beg = i, end = j;
			}
		}
	}
	
	if(beg == - 1){
		er = 1;
		return;
	}
	
	used.resize(n);
	used[beg] = 1;
	used[end] = 1;
	A.PB(beg);
	
	
	ll head = L[beg][1]; 
	for(int i = 0; i < n - 2; ++i){
		bool find = 0;
		
		for(int j = 0; j < n; ++j){
			ll tail = L[j][0];
			if(not used[j] and (tail + head) == d){
				used[j] = 1;
				A.PB(j);
				head = L[j][1];
				find = 1;
				break;
			}
		}
		
		if(not find){
			er = 1;
			return;
		}
	}
	
	A.PB(end);
	return;
	
}

void printAns(){
	if(er){
		cout << "No\n";
	} else {
		cout << "Yes\n";
		for(auto i : A){
			cout << i + 1 << " ";
		}
		cout << "\n";
	}
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	cin >> n;
	s.resize(n);
	m.resize(n);
	
	int cnt = 0;
	
	for(int i = 0; i < n; ++i){
		int t; cin >> t >> s[i];
		for(int j = 0; j < t; ++j){
			ll a; cin >> a;
			m[i].PB(a);
			cnt++;
		}
	}
	
	if(cnt == 1 or cnt == 2){
		cout << "Yes\n";
		for(int i = 0;  i < n; ++i)
			cout << i  + 1 << " ";
		cout << "\n";
		return 0;
	}
	
	normalize();
	
	
	if(er){
		cout << "No\n";
		return 0;
	}
	
	if(d != -1){
		solve(d);
		printAns();
		return 0;
	} else {
		for(int i = 0; i <= 100; ++i){
			solve(i);
			if(!er){
				printAns();
				return 0;
			}
		}
	}
	
	printAns();
	
	
	
	return 0;
}
