#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ull unsigned long long
#define pb push_back
#define fi first
#define se second

template<class T>
istream& operator >>(istream &in, vector<T> &a){
    for(auto &i: a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator <<(ostream &out, vector<T> &a){
    for(auto &i: a) {
        out << i << ' ';
    }
    return out;
}

int n, m, c;

int getval(int k, int x, int y) {
    int pos = m*x + y;
    return (k >> pos) & 1;
}

int cur[11][11];
bool success = false;

int cnt1 = 0, cnt2 = 0, cnt3 = 0;

void upd1(int t) {
    if(t == 0)
        cnt1 ++;
    else if(t == 1)
        cnt2 ++;
    else
        cnt3 ++;
}
void upd2(int t) {
    if(t == 0)
        cnt1 --;
    else if(t == 1)
        cnt2 --;
    else
        cnt3 --;
}

void d(int x, int y) {
    int nx = (x + 1) % n, ny = y;
    if(nx == 0) {
        ny ++;
    }
    bool tr = true;
    for (int x1 = 0; x1 < n; ++x1) {
        if (!tr) break;
        for (int y1 = 0; y1 < y; ++y1) {
            if (!tr) break;
            for (int x2 = x1 + 1; x2 < n; ++x2) {
                if (!tr) break;
                for (int y2 = y1 + 1; y2 < y; ++y2) {
                    if (cur[x1][y1] != -1 && cur[x1][y1] == cur[x1][y2] && cur[x1][y2] == cur[x2][y1] && cur[x2][y1] == cur[x2][y2]) {
                        tr = false;
                        break;
                    }
                }
            }
        }
    }
    if(y >= m){
        success = tr;
        return;
    }
    if(!tr) {
        return;
    }
    vector<pair<int, int>> v = {{cnt1, 0}, {cnt2, 1}, {cnt3, 2}};
    sort(all(v));

    cur[x][y] = v[0].se;
    upd1(v[0].se);
    d(nx, ny);
    if(success) return;
    upd2(v[0].se);

    cur[x][y] = v[1].se;
    upd1(v[1].se);
    d(nx, ny);
    if(success) return;
    upd2(v[1].se);

    cur[x][y] = v[2].se;
    upd1(v[2].se);
    d(nx, ny);
    upd2(v[2].se);
}

signed main() {
    cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(false);//cout.precision(4);

    cin >> n >> m >> c;
    if(c == 2) {
        int ans = 0;
        for (int k = 0; k < (1 << (n * m)); ++k) {
            bool tr = true;
            for (int x1 = 0; x1 < n; ++x1) {
                if (!tr) break;
                for (int y1 = 0; y1 < m; ++y1) {
                    if (!tr) break;
                    for (int x2 = x1 + 1; x2 < n; ++x2) {
                        if (!tr) break;
                        for (int y2 = y1 + 1; y2 < m; ++y2) {
                            if (getval(k, x1, y1) == getval(k, x1, y2) && getval(k, x1, y2) == getval(k, x2, y1) &&
                                getval(k, x2, y1) == getval(k, x2, y2)) {
                                tr = false;
                                break;
                            }
                        }
                    }
                }
            }
            if (tr) {
                ans = k;
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        cout << getval(ans, i, j) + 1 << ' ';
                    }
                    cout << '\n';
                }
                return 0;
            }

        }

    }else{
        for(int i = 0; i < n; ++i) {
            for(int j = 0; j < m; ++j) {
                cur[i][j] = -1;
            }
        }
        cur[0][0] = 0;
        cnt1 ++;
        d(1, 0);
        for(int i = 0; i < n; ++i) {
            for(int j = 0; j < m; ++j) {
                cout << cur[i][j] + 1 << ' ';
            }
            cout << '\n';
        }

    }
    return 0;
}
