#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ull unsigned long long
#define pb push_back
#define fi first
#define se second

template<class T>
istream& operator >>(istream &in, vector<T> &a){
    for(auto &i: a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator <<(ostream &out, vector<T> &a){
    for(auto &i: a) {
        out << i << ' ';
    }
    return out;
}

ll mod = 1e9 + 7;

struct State {
    ll a, b, c, d;
    State(): a(0), b(0), c(0), d(0) {};
    State(ll a, ll b, ll c, ll d): a(a), b(b), c(c), d(d) {};
};

ll solve(State st, ll start, ll fcnt = -1) {
    //cout << st.a << ' ' << st.b << ' ' << st.c << ' ' << st.d << '\n';
    ll ans = 0;
    if(st.a + st.b + st.c + st.d == 1) {
        if (start == 0 && st.a == 1) {
            return 1;
        }
        if (start == 1 && st.b == 1) {
            return 1;
        }
        if (start == 2 && st.c == 1) {
            return 1;
        }
        if (start == 3 && st.d == 1) {
            return 1;
        }
        return 0;
    }
    if(start == 0 && st.a > 0) {
        ll cur = (fcnt == -1) ? st.a : fcnt;
        ans = (ans + (cur*solve(State(st.a - 1, st.b, st.c, st.d), 0) % mod)) % mod;
        ans = (ans + (cur*solve(State(st.a  -1, st.b, st.c, st.d), 2) % mod)) % mod;
    }
    if(start == 1 && st.b > 0) {
        ll cur = (fcnt == -1) ? st.b : fcnt;
        ans = (ans + (cur*solve(State(st.a, st.b - 1, st.c, st.d), 0) % mod)) % mod;
        ans = (ans + (cur*solve(State(st.a, st.b - 1, st.c, st.d), 2) % mod)) % mod;
    }
    if(start == 2 && st.c > 0) {
        ll cur = (fcnt == -1) ? st.c : fcnt;
        ans = (ans + (cur*solve(State(st.a, st.b, st.c - 1, st.d), 1) % mod)) % mod;
        ans = (ans + (cur*solve(State(st.a, st.b, st.c - 1, st.d), 3) % mod)) % mod;
    }
    if(start == 3 && st.d > 0) {
        ll cur = (fcnt == -1) ? st.d : fcnt;
        ans = (ans + (cur*solve(State(st.a, st.b, st.c, st.d - 1), 1) % mod)) % mod;
        ans = (ans + (cur*solve(State(st.a, st.b, st.c, st.d - 1), 3) % mod)) % mod;
    }
    return ans;
}

signed main() {
    cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(false);//cout.precision(4);
    string a, b, c;
    cin >> a >> b >> c;
    ll n = a.length();
    vector<ll> x(n), y(n);
    ll fcnta = 0, fcntc = 0;
    for(ll i = 0; i < n; ++i) {
        ll k = (a[i] - '0') + (b[i] - '0');
        //cout << k << '\n';
        ll nx = 0;
        if(k >= 10) {
            nx = 1;
            k -= 10;
        }
        ll prev;
        if(k == c[i] - '0') {
            prev = 0;
        }else if(k == (c[i] - '0') - 1) {
            prev = 1;
        }else if(k == 9 && c[i] - '0' == 0) {
            prev = 1;
            nx = 1;
        }

        x[i] = nx;
        y[i] = prev;

        if(x[i] == 0 && y[i] == 0 && (a[i] == '0' || b[i] == '0' || c[i] == '0')) {
            fcnta ++;
        }
        if(x[i] == 0 && y[i] == 1 && (a[i] == '0' || b[i] == '0' || c[i] == '0')) {
            fcntc ++;
        }
    }
    State st = State(0, 0, 0, 0);
    for(ll i = 0; i < n; ++i) {
        //cout << x[i] << ' ' << y[i] << '\n';
        if(x[i] == 0 && y[i] == 0)
            st.a ++;
        if(x[i] == 1 && y[i] == 0)
            st.b ++;
        if(x[i] == 0 && y[i] == 1)
            st.c ++;
        if(x[i] == 1 && y[i] == 1)
            st.d ++;
    }
    //cout << st.a << ' ' << st.b << ' ' << st.c << ' ' << st.d << '\n';
    ll ans = (solve(st, 0, st.a - fcnta) + solve(st, 2, st.c - fcntc)) % mod;
    cout << ans;

    return 0;
}

/*
01211
12099
23300
 */