#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

#define int long long

using namespace std;

const int INF = 2e18 + 109;

struct vert {
    int d1, d2;
    vert(int d1_, int d2_) {
        d1 = d1_, d2 = d2_;
    }
    vert() {}
};

vector<vert> v;
vector<int> order, used;

int n;

void go(int ind) {
    if (ind == n) {
        /* cout << "order = \n";
        for (int i : order) {
            cout << i + 1 << " ";
        }
        cout << "\n\n"; */

        int x = 0, D = -INF, st = 0;
        while (st < n && v[order[st]].d1 == -INF) {
            st++;
        }
        if (st >= n) {
            cout << "Yes\n";
            for (int i : order) {
                cout << i + 1 << " ";
            }
            cout << "\n";
            exit(0);
        }

        x += v[order[st]].d2;
        st++;
        for (int i = st; i < n; i++) {
            if (v[order[i]].d1 == -INF) {
                x += v[order[i]].d2;
            } else {
                x += v[order[i]].d1;
                if (D == -INF) {
                    D = x;
                } else {
                    if (x != D) {
                        return;
                    }
                }
                //cout << "OK " << i << " " << x << " " << D << "\n";
                x = v[order[i]].d2;
            }
        }

        cout << "Yes\n";
        for (int i : order) {
            cout << i + 1 << " ";
        }
        cout << "\n";

        exit(0);
    }

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = 1;
            order.push_back(i);
            go (ind + 1);
            order.pop_back();
            used[i] = 0;
        }
    }
}

vector<int> a;

signed main() {

    cin >> n;

    v.resize(n);

    int D = -INF;
    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;

        a.resize(m);
        for (int j = 0; j < m; j++) {
            cin >> a[j];
        }

        if (sz(a) > 1) {
            //cout << "FATAL " << i << "\n";
            if (D == -INF) {
                D = a[1] - a[0];
            }
            for (int j = 0; j < m - 1; j++) {
                if (a[j + 1] - a[j] != D) {
                    cout << "No\n";
                    return 0;
                }
            }
        }
        if (sz(a)) {
            v[i] = {a.front(), s - a.back()};
        } else {
            v[i] = {-INF, s};
        }
    }

    /*cout << "v = \n";
    for (int i = 0; i < n; i++) {
        cout << i << " " << v[i].d1 << " " << v[i].d2 << "\n";
    }
    cout << "\n\n";*/

    used.assign(n, 0);
    go(0);

    cout << "No\n";
    return 0;
}
