#include <bits/stdc++.h>

#define ll long long
using namespace std;

struct seg {
    int n, l, r;
};
vector<seg> segs;
int dist = -1;
int n;
vector<int> ans;
vector<bool> used;

void dfs(int v, int d, vector<int> &perm) {
    used[v] = true;
    perm.push_back(segs[v].n);
    if (perm.size() == n) {
        ans = perm;
        return;
    }
    for (int u = 0; u < n; u++) {
        if (!used[u]) {
            if (d == -1) {
                dfs(u, segs[v].r + segs[u].l, perm);
            }else{
                if(segs[v].r + segs[u].l == d) dfs(u, d, perm);
            }
        }
        if (!ans.empty()) return;
    }
    perm.pop_back();
    used[v] = false;
}

int main() {
    cin >> n;
    segs.resize(n);
    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        segs[i].n = i + 1;
        int a = 0;
        for (int _ = 0; _ < m; _++) {
            int ai;
            cin >> ai;
            if (_ == m - 1) segs[i].r = s - ai;
            if (_ == 0) segs[i].l = ai;
            else {
                if (dist == -1) dist = ai - a;
                else if (dist != ai - a) {
                    cout << "No";
                    return 0;
                }
            }
            a = ai;
        }
    }
    used.resize(n, false);
    vector<int> p;
    for (int i = 0; i < n; i++) {
        dfs(i, dist, p);
        if (!ans.empty())break;
    }
    if (!ans.empty()) {
        cout << "Yes\n";
        for (int i = 0; i < n; i++) {
            cout << ans[i] << ' ';
        }
    } else {
        cout << "No";
    }
    return 0;
}

