#include <iostream>
#define ll long long
using namespace std;
ll difV(ll x, ll n, ll m)
{
    return abs(n * x * x + (n * m * (n - 1) + n) * x - (n * m * (n * m + 1) / 2));
}
ll difH(ll x, ll n, ll m)
{
    return abs(m * m * x * x + m * x - (n * m * (n * m + 1) / 2));
}
ll t, n, m;
int main()
{
    cin >> t;
    for (ll i(0); i < t; i++)
    {
        cin >> n >> m;
        ll ansV, ansH, l = 0, r = m, mid1, mid2;
        while (r - l > 2)
        {
            mid1 = (r - l) / 3 + l;
            mid2 = r - (r - l) / 3;
            if (difV(mid1, n, m) > difV(mid2, n, m))
            {
                l = mid1;
            }
            else
            {
                r = mid2;
            }
        }
        ansV = l;
        for (ll i(l); i <= r; i++)
        {
            if (difV(ansV, n, m) > difV(i, n, m))
            {
                ansV = i;
            }
        }
        l = 0; r = n;
        while (r - l > 2)
        {
            mid1 = (r - l) / 3 + l;
            mid2 = r - (r - l) / 3;
            if (difH(mid1, n, m) > difH(mid2, n, m))
            {
                l = mid1;
            }
            else
            {
                r = mid2;
            }
        }
        ansH = l;
        for (ll i(l); i <= r; i++)
        {
            if (difH(ansH, n, m) > difH(i, n, m))
            {
                ansH = i;
            }
        }
        if (difH(ansH, n, m) > difV(ansV, n, m))
        {
            cout << "V " << ansV + 1 << endl;
        }
        else
        {
            cout << "H " << ansH + 1 << endl;
        }
    }
}
