#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define x first
#define y second
#define DEBUGs
//#define int long long

/*






*/

const ll MOD = 1e9 + 7;

const ll MAXN = 4e5;

ll fact[MAXN], obr[MAXN];

ll mul(ll a, ll b) {
    return a * b % MOD;
}

ll sum(ll a, ll b) {
    if (a + b >= MOD)
        return a + b - MOD;
    return a + b;
}

ll pw(ll a, ll b = MOD - 2) {
    ll ans = 1;
    while (b) {
        if (b & 1)
            mul(ans, a);
        a = mul(a, a);
        b >>= 1;
    }
    return ans;
}

void gg() {
    cout << "0\n";
    exit(0);
}

ll gg(ll a, ll b) {
    --b;
    if (b < 0)
        return 1;
    return mul(fact[a + b], mul(obr[a], obr[b]));
}

ll get(ll a, ll b, ll c, ll d) {
    if (b + c == 0) {
        if (max(a, d) != a + d)
            gg();
        return fact[max(a, d)];
    }
    ll ans = mul(fact[b], fact[c]);
    ans = mul(ans, gg(a, b));
    ans = mul(ans, gg(d, c));
    return ans;
}

 string a, b, c;

void silly() {
    int n = a.size();
    vector<pair<ll, ll>> dp((1 << n));
    dp[0] = {1, 0};
    for (int mask = 0; mask < (1 << n); ++mask) {
        for (int bit = 0; bit < n; ++bit) {
            if (mask & (1 << bit))
                continue;
            int A = a[bit] - '0';
            int B = b[bit] - '0';
            int C = c[bit] - '0';
            if ((A + B) % 10 == C) {
                if (A + B >= 10) {
                    dp[mask + (1 << bit)].y = sum(dp[mask + (1 << bit)].y, dp[mask].x);
                } else {
                    dp[mask + (1 << bit)].x = sum(dp[mask + (1 << bit)].x, dp[mask].x);
                }
            } else {
                if (A + B >= 10) {
                    dp[mask + (1 << bit)].y = sum(dp[mask + (1 << bit)].y, dp[mask].y);
                } else {
                    dp[mask + (1 << bit)].x = sum(dp[mask + (1 << bit)].x, dp[mask].y);
                }
            }
        }
    }
    cout << dp.back().x << '\n';
    exit(0);
}

void solve() {
    cin >> a >> b >> c;
    int ok = 1;
    for (int i = 0; i < a.size(); ++i) {
        int A = a[i] - '0';
        int B = b[i] - '0';
        int C = c[i] - '0';
        if ((A + B) % 10 != C && (A + B + 1) % 10 != C)
            gg();
        if (A == 0 || B == 0 || C == 0)
            ok = 0;
    }
    if (a.size() <= 18)
        silly();
    assert(ok);
    vector<int> cnt(4);
    for (int i = 0; i < a.size(); ++i) {
        int A = a[i] - '0';
        int B = b[i] - '0';
        int C = c[i] - '0';
        int mask = 0;
        if ((A + B) % 10 != C) {
            mask += 2;
        }
        if  (A + B >= 10)
            ++mask;
        ++cnt[mask];
    }
    if (abs(cnt[1] - cnt[2]) > 1)
        gg();
    cout << get(cnt[0], cnt[1], cnt[2], cnt[3]) << '\n';
}

void precalc() {
    fact[0] = obr[0] = 1;
    for (ll i = 1; i < MAXN; ++i) {
        fact[i] = mul(fact[i - 1], i);
        obr[i] = pw(fact[i]);
    }
}

signed main() {
    precalc();
    #ifdef DEBUG
        freopen("silly.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    int t = 1;//cin >> t;
    while (t--)
        solve();
    return 0;
}
