#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
using namespace std;

long long mod = 1000000007;

long long factorial(long long n) {
	long long ans = 1;
	for (long long i = 1; i <= n; ++i) {
		ans *= i;
		ans %= mod;
	}
	return ans;
}

long long dp[1000][1000];

long long A(long long n, long long k, long long m) {
	if (m > n)
		return 0;
	if (k == 1)
		return 1;
	if (n == 0 || k == 0)
		return 1;
	if (dp[n][k] != 0)
		return dp[n][k];
	long long ans = 0;
	for (int i = m; i <= n; ++i) {
		ans += A(n - i, k - 1, i) * k;
		ans %= mod;
	}
	dp[n][k] = ans;
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	string a, b, c;
	cin >> a >> b >> c;
	long long can_beg = a.size();
	long long b_begin = 0, b_end = 0, b_in = 0, free = 0;

	for (long long i = 0; i < a.size(); ++i) {
		long long o = 0, x = a[i] - '0', y = b[i] - '0', z = c[i] - '0';
		if ((x + y) % 10 != z && (x + y + 1) % 10 != z) {
			cout << 0;
			return 0;
		}
		

		if (x + y >= 10) {
			if ((x + y) % 10 != z) {
				b_in++;
			}
			else
				b_end++;
			can_beg--;
		}
		else if ((x + y) % 10 != z) {
			if(x == 0 || y == 0 || z == 0)
				can_beg--;
			if (x + y == 9)
				b_in++;
			else
				b_begin++;
		}
		else {
			if(x == 0 || y == 0 || z == 0)
				can_beg--;
			free++;
		}
	}
	if (b_begin != b_end) {
		cout << 0;
		return 0;
	}

	cout << (((can_beg * factorial(b_end + free - 1) % mod) * A(b_in, b_end, 0)) % mod * factorial(b_end)) % mod;
	return 0;
}