#include <bits/stdc++.h>

using namespace std;

int main() {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        int t;
        cin >> t;
        while (t--) {
                int n, m;
                cin >> n >> m;
                long long sum = (long long) (n * m) * (n * m + 1) / 2;
                auto count_horizontal = [&](int y) {
                        return (long long) (m * y) * (m * y + 1) / 2;
                };
                auto count_vertical = [&](int x) {
                        return (long long) m * ((long long) n * (n - 1) / 2) * x + (long long) n * ((long long)x * (x + 1) / 2);
                };
                pair<long long, int> res_horizontal, res_vertical;
                { // horizontal
                        int left = 0;
                        int right = n - 1;
                        while (right > left + 1) {
                                int mid = left + (right - left) / 2;
                                long long upper = count_horizontal(mid);
                                long long lower = sum - upper;
                                if (upper - lower < 0) {
                                        left = mid;
                                } else {
                                        right = mid;
                                }
                        }
                        if (right != 0) {
                                long long upper = count_horizontal(right);
                                long long lower = sum - upper;
                                res_horizontal = {llabs(upper - lower), right};
                                if (right > 1) {
                                        upper = count_horizontal(right - 1);
                                        lower = sum - upper;
                                        if (llabs(upper - lower) < res_horizontal.first) {
                                                res_horizontal = {llabs(upper - lower), right - 1};
                                        }
                                }
                        } else {
                                res_horizontal.first = -1;
                        }
                }
                { // vertical
                        int left = 0;
                        int right = m - 1;
                        while (right > left + 1) {
                                int mid = left + (right - left) / 2;
                                long long leftmost = count_vertical(mid);
                                long long rightmost = sum - leftmost;
                                if (leftmost - rightmost < 0) {
                                        left = mid;
                                } else {
                                        right = mid;
                                }
                        }
                        if (right != 0) {
                                long long leftmost = count_vertical(right);
                                long long rightmost = sum - leftmost;
                                res_vertical = {llabs(leftmost - rightmost), right};
                                if (right > 1) {
                                        leftmost = count_vertical(right - 1);
                                        rightmost = sum - leftmost;
                                        if (llabs(leftmost - rightmost) < res_vertical.first) {
                                                res_vertical = {llabs(leftmost - rightmost), right - 1};
                                        }
                                }
                        } else {
                                res_vertical.first = -1;
                        }
                }
                if (res_horizontal.first != -1 && (res_horizontal.first <= res_vertical.first || res_vertical.first == -1)) {
                        cout << "H " << res_horizontal.second + 1;
                } else {
                        cout << "V " << res_vertical.second + 1;
                }
                cout << '\n';
        }
}
