#include <bits/stdc++.h>

using namespace std;


int get_num_length(int n) {
        int res = 0;
        while (n > 0) {
                n /= 10;
                ++res;
        }
        return res;
}

int compressed_len(string &s) {
        int num = 1;
        int res = 0;
        for (size_t i = 1; i < s.size(); ++i) {
                if (s[i] == s[i - 1]) {
                        ++num;
                } else {
                        res += (num == 1 ? 0 : get_num_length(num)) + 1;
                        num = 1;
                }
        }
        res += (num == 1 ? 0 : get_num_length(num)) + 1;
        return res;
}

int main() {
        string s;
        cin >> s;
        string res;
        bool is_number = false;
        int current_num = 0;
        for (char c : s) {
                if (!is_number) {
                        if ('0' <= c && c <= '9') {
                                is_number = true;
                                current_num = current_num * 10 + (c - '0');
                        } else {
                                res.push_back(c);
                        }
                } else {
                        if ('0' <= c && c <= '9') {
                                current_num = current_num * 10 + (c - '0');
                        } else {
                                is_number = false;
                                for (int k = 0; k < current_num; ++k) {
                                        res.push_back(c);
                                }
                                current_num = 0;
                        }
                }
        }
        string other = res;
        auto count_insert = [&](int index, char c) {
                other.insert(other.begin() + index, c);
                int ans = compressed_len(other);
                other.erase(other.begin() + index);
                return ans;
        };
        auto count_replace = [&](int index, char c) {
                char last = other[index];
                other[index] = c;
                int ans = compressed_len(other);
                other[index] = last;
                return ans;
        };
        auto count_erase = [&](int index) {
                char last = other[index];
                other.erase(other.begin() + index);
                int ans = compressed_len(other);
                other.insert(other.begin() + index, last);
                return ans;
        };
        pair<int, tuple<int, int, char>> max_res = {-1, {0, 0, '\0'}};
        pair<int, tuple<int, int, char>> min_res = {-1, {0, 0, '\0'}};
        for (int i = 0; i < s.size(); ++i) {
                for (char c : "ACGT") {
                        int ins = count_insert(i, c);
                        int repl = count_replace(i, c);
                        if (max_res.first == -1 || ins > max_res.first) {
                                max_res = {ins, {1, i, c}};
                        }
                        if (max_res.first == -1 || repl > max_res.first) {
                                max_res = {repl, {3, i + 1, c}};
                        }
                        if (min_res.first == -1 || ins < min_res.first) {
                                min_res = {ins, {1, i, c}};
                        }
                        if (min_res.first == -1 || repl < min_res.first) {
                                min_res = {repl, {3, i + 1, c}};
                        }
                }
                int ers = count_erase(i);
                if (max_res.first == -1 || ers > max_res.first) {
                        max_res = {ers, {2, i + 1, '\0'}};
                }
                if (min_res.first == -1 || ers < min_res.first) {
                        min_res = {ers, {2, i + 1, '\0'}};
                }
        }
        int i = s.size();
        for (char c : "ACGT") {
                int ins = count_insert(i, c);
                if (max_res.first == -1 || ins > max_res.first) {
                        max_res = {ins, {1, i, c}};
                }
                if (min_res.first == -1 || ins < min_res.first) {
                        min_res = {ins, {1, i, c}};
                }
        }
        if (get<0>(min_res.second) != 2) {
                cout << get<0>(min_res.second) << ' ' << get<1>(min_res.second) << ' ' <<  get<2>(min_res.second) << '\n';
        } else {
                cout << get<0>(min_res.second) << ' ' << get<1>(min_res.second) << '\n';
        }
        if (get<0>(max_res.second) != 2) {
                cout << get<0>(max_res.second) << ' ' << get<1>(max_res.second) << ' ' <<  get<2>(max_res.second) << '\n';
        } else {
                cout << get<0>(max_res.second) << ' ' << get<1>(max_res.second) << '\n';
        }
}
