#include <bits/stdc++.h>

using namespace std;

struct block {
        char symbol;
        int count;

        block(int _count, char _symbol) : count(_count), symbol(_symbol) {

        }
};

int max_10_power(int n) {
        int res = 1;
        while (n > 0) {
                n /= 10;
                ++res;
        }
        return res;
}

char get_other(char c) {
        switch(c) {
                case 'A':
                        return 'C';
                case 'C':
                        return 'G';
                case 'G':
                        return 'T';
                case 'T':
                        return 'A';
                default:
                        return '\0';
        }
}

int main() {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        string s;
        cin >> s;
        vector<block> parsed;
        vector<int> prefix_len = {0};
        bool is_number = false;
        int current_num = 0;
        for (char c : s) {
                if (!is_number) {
                        if ('0' <= c && c <= '9') {
                                is_number = true;
                                current_num = current_num * 10 + (c - '0');
                        } else {
                                parsed.emplace_back(1, c);
                                prefix_len.push_back(prefix_len.back() + 1);
                        }
                } else {
                        if ('0' <= c && c <= '9') {
                                current_num = current_num * 10 + (c - '0');
                        } else {
                                is_number = false;
                                parsed.emplace_back(current_num, c);
                                prefix_len.push_back(prefix_len.back() + current_num);
                                current_num = 0;
                        }
                }
        }
        int max_block = 0;
        for (size_t i = 0; i < parsed.size(); ++i) {
               if (parsed[i].count > parsed[max_block].count) {
                        max_block = i;
               }
        }
        int block_index = -1;
        for (size_t i = 0; i + 2 < parsed.size(); ++i) {
                if (parsed[i + 1].count == 1 && parsed[i].symbol == parsed[i + 2].symbol) {
                        if (block_index == -1 || parsed[i].count + parsed[i + 2].count > parsed[block_index].count + parsed[block_index + 2].count) {
                                block_index = i;
                        }
                }
        }
        if (block_index != -1) {
                cout << "3 " << prefix_len[block_index + 1] + 1 << ' ' << parsed[block_index].symbol << '\n';
        } else {
                int one_block_index = -1;
                for (size_t i = 0; i < parsed.size(); ++i) {
                        if (parsed[i].count <= 2) {
                                one_block_index = i;
                                break;
                        }
                }
                if (one_block_index != -1) {
                        cout << "2 " << prefix_len[one_block_index] + 1 << '\n';
                } else {
                        int some_block_index = -1;
                        for (size_t i = 1; i < parsed.size(); ++i) {
                                if (max_10_power(parsed[i - 1].count + 1) == max_10_power(parsed[i - 1].count)) {
                                        some_block_index = i;
                                        break;
                                }
                        }
                        if (some_block_index != -1) {
                                cout << "3 " << prefix_len[some_block_index] + 1 << ' ' << parsed[some_block_index - 1].symbol << '\n';
                        } else {
                                int other_block_index = 0;
                                for (size_t i= 0; i < parsed.size(); ++i) {
                                        if (max_10_power(parsed[i].count - 1) != max_10_power(parsed[i].count)) {
                                                other_block_index = i;
                                                break;
                                        }
                                }
                                cout << "2 " << prefix_len[other_block_index] + 1 << '\n';
                        }
                }
        }
        if (parsed[max_block].count > 2) {
                int max_power = max_10_power(parsed[max_block].count);
                int max_res = 2 + 1 + max_10_power(parsed[max_block].count - 2);
                int current_power_num = 10;
                int max_res_index = 2;
                for (int current_power = 1; current_power < max_power; ++current_power) {
                        int current_res = current_power + 1 + max_10_power(parsed[max_block].count - current_power_num);
                        if (current_res > max_res) {
                                max_res = current_res;
                                max_res_index = current_power_num;
                        }
                        current_power_num *= 10;
                }
                cout << "1 " << prefix_len[max_block] + max_res_index << ' ' << get_other(parsed[max_block].symbol) << '\n';
        } else {
                cout << "1 0 " << get_other(parsed[0].symbol) << '\n';
        }
}
