#include <bits/stdc++.h>

using namespace std;

int main() {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        int n;
        cin >> n;
        vector<pair<vector<int>, int>> a(n);
        int counted_dist = -1;
        for (int i = 0; i < n; ++i) {
                int m;
                cin >> m;
                a[i].first.resize(m);
                cin >> a[i].second;
                for (int j = 0; j < m; ++j) {
                        cin >> a[i].first[j];
                        if (j > 0) {
                                if (counted_dist != -1 && a[i].first[j] - a[i].first[j - 1] != counted_dist) {
                                        cout << "No" << '\n';
                                        return 0;
                                } else if (counted_dist == -1) {
                                        counted_dist = a[i].first[j] - a[i].first[j - 1];
                                }
                        }
                }
        }
        auto can = [&](int i, int j, int dist) -> bool {
                return a[i].second - a[i].first.back() + a[j].first[0] == dist;
        };
        auto count = [&](int dist) -> pair<bool, vector<int>> {
                vector<vector<char>> dp(n, vector<char>((1 << n), 0));
                vector<vector<int>> prev(n, vector<int>(1 << n, -1));
                for (int i = 0; i < n; ++i) {
                        dp[i][1 << i] = 1;
                }
                for (int mask = 0; mask < (1 << n); ++mask) {
                        for (int visited = 0; visited < n; ++visited) {
                                if (!(mask & (1 << visited))) {
                                        continue;       
                                }
                                for (int next_v = 0; next_v < n; ++next_v) {
                                        if (mask & (1 << next_v)) {
                                                continue;
                                        }
                                        if (dp[visited][mask] && can(visited, next_v, dist)) {
                                                dp[next_v][mask + (1 << next_v)] = 1;
                                                prev[next_v][mask + (1 << next_v)] = visited;
                                        }
                                }
                        }
                }
                int last_good = -1;
                int last_mask = (1 << n) - 1;
                for (int last = 0; last < n; ++last) {
                        if (dp[last][last_mask] != 0) {
                                last_good = last;
                                break;
                        }
                }
                if (last_good == -1) {
                        return {false, {}};
                }
                vector<int> res;
                int current = last_good;
                int current_mask = last_mask;
                while (prev[current][current_mask] != -1) {
                        res.push_back(current);
                        int next = prev[current][current_mask];
                        current_mask -= (1 << current);
                        current = next;
                }
                res.push_back(current);
                reverse(res.begin(), res.end());
                return {true, res};
        };
        if (counted_dist == -1) {
                for (int dist = 0; dist <= 100; ++dist) {
                        auto res = count(dist);
                        if (res.first) {
                                cout << "Yes\n";
                                for (int v : res.second) {
                                        cout << v + 1 << ' ';
                                }
                                cout << '\n';
                                return 0;
                        }
                }
                cout << "No";
                cout << '\n';
                return 0;
        } else {
                auto res = count(counted_dist);
                if (res.first) {
                        cout << "Yes\n";
                        for (int v : res.second) {
                                cout << v + 1 << ' ';
                        }
                        cout << '\n';
                        return 0;
                }
                cout << "No\n";
                return 0;
        }
}
