#include <bits/stdc++.h>

using namespace std;

int digit_count(long long n) {
        int res = 0;
        while (n > 0) {
                n /= 10;
                ++res;
        }
        return res;
}

long long repeat_n(int digit, int n) {
        long long res = 0;
        for (int i = 0; i < n; ++i) {
                res = res * 10 + digit;
        }
        return res;
}

template <int i>
int ith_digit(long long n) {
        int cnt = digit_count(n);
        for (int j = 0; j < cnt - i; ++j) {
                n /= 10;
        }
        return n % 10;
}

long long power_of_10(int p) {
        long long res = 1;
        for (int i = 0; i < p; ++i) {
                res *= 10;
        }
        return res;
}

long long concatenate(long long a, long long b, int b_length = -1) {
        if (b_length == -1) {
                b_length = digit_count(b);
        }
        return a * power_of_10(b_length) + b;
}

int main() {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        long long n;
        bool in_the_mood;
        cin >> n;
        cin >> in_the_mood;
        long long candidate;
start:
        if (!in_the_mood) {
                candidate = repeat_n(ith_digit<1>(n), digit_count(n));
        } else {
                candidate = concatenate(ith_digit<1>(n), repeat_n(ith_digit<2>(n), digit_count(n) - 1), digit_count(n) - 1);
        }
        if (candidate >= n) {
                cout << candidate;
        } else {
                if (!in_the_mood) {
                        candidate += power_of_10(digit_count(n) - 1);
                } else {
                        candidate += power_of_10(digit_count(n) - 2);
                }
                n = candidate;
                goto start;
        }
}
