#include <bits/stdc++.h>
#include <ext/random>

using namespace std;

char field[10][10];

int n, m;

bool check() {
        for (short x0 = 0; x0 < m; ++x0) {
                for (short y0 = 0; y0 < n; ++y0) {
                        for (short width = 2; x0 + width - 1 < m; ++width) {
                                short x1 = x0 + width - 1;
                                for (short height = 2; y0 + height - 1 < n; ++height) {
                                        short y1 = y0 + height - 1;
                                        char s1 = field[x0][y0];
                                        char s2 = field[x0][y1];
                                        char s3 = field[x1][y0];
                                        char s4 = field[x1][y1];
                                        if (s1 == s2 && s2 == s3 && s3 == s4) {
                                                return false;
                                        }
                                }
                        }
                }
        }
        return true;
}

int main() {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cin >> n >> m;
        short k;
        cin >> k;
        random_device r;
        __gnu_cxx::sfmt19937 rnd(r());
        int iteration_count = 0;
        auto start = chrono::high_resolution_clock::now();
        auto current = chrono::high_resolution_clock::now();
        chrono::duration<double> diff(current - start);
        while (true) {
                for (short i = 0; i < m; ++i) {
                        for (short j = 0; j < n; ++j) {
                                field[i][j] = rnd() % k;
                        }
                }
                if (check()) {
                        break;
                }
        }
        for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                        cout << field[j][i] + 1 << ' ';
                }
                cout << '\n';
        }
}
