#include <bits/stdc++.h>

using namespace std;

const int MOD = 1000000007;

map<tuple<int, int, int, int, int>, int> results;

template <int end> int count(int up, int down, int zero_eq, int one_eq) {
        if (up < down || up > down + 1) {
                return 0;
        }
        auto it = results.find({up, down, zero_eq, one_eq, end});
        if (it != results.end()) {
                return it->second;
        }
        int res = 0;
        if (end == 0) {
                if (down > 0) {
                        res = (res + count<1>(up, down - 1, zero_eq, one_eq)) % MOD;
                }
                if (zero_eq > 0) {
                        res = (res + count<0>(up, down, zero_eq - 1, one_eq)) % MOD;
                }
                if (down == 0 && zero_eq == 0) {
                        if (up == 0 && down == 0) {
                                res = 1;
                        } else {
                                res = 0;
                        }
                }
        } else {
                if (up > 0) {
                        res = (res + count<0>(up - 1, down, zero_eq, one_eq)) % MOD;
                }
                if (one_eq > 0) {
                        res = (res + count<1>(up, down, zero_eq, one_eq - 1)) % MOD;
                }
                if (up == 0 && one_eq == 0) {
                        res = 0;
                }
        }
        results[{up, down, zero_eq, one_eq, end}] = res;
#ifdef LOCAL
        cerr << up << ':' << down << ':' << zero_eq << ':' << one_eq << ':' << end << '\t' << res << '\n';
#endif
        return res;
}

int main() {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        string a;
        string b;
        string c;
        cin >> a >> b >> c;
        int count_up = 0;
        int count_down = 0;
        int count_zero_eq = 0;
        int count_one_eq = 0;
        bool shit = false;
        for (size_t i = 0; i < a.size(); ++i) {
                int a_d = a[i] - '0';
                int b_d = b[i] - '0';
                int c_d = c[i] - '0';
                if (c_d == a_d + b_d) {
                        ++count_zero_eq;
                } else if (c_d == a_d + b_d + 1) {
                        ++count_up;
                } else if (c_d == (a_d + b_d) % 10) {
                        ++count_down;
                } else if (c_d == (a_d + b_d + 1) % 10) {
                        ++count_one_eq;
                } else {
                        shit = true;
                }
        }
        if (shit) {
                cout << 0 << '\n';
        } else {
                int res = count<0>(count_up, count_down, count_zero_eq, count_one_eq) + count<1>(count_up, count_down, count_zero_eq, count_one_eq);
                auto restore_equal = [&](int equal_cnt) {
                        for (int i = 1; i <= equal_cnt; ++i) {
                                res = ((long long) res * i) % MOD;
                        }
                };
                restore_equal(count_up);
                restore_equal(count_down);
                restore_equal(count_zero_eq);
                restore_equal(count_one_eq);
                cout << res << '\n';
        }
}
