#include <bits/stdc++.h>

using namespace std;


#define int long long
#define ld long double
#define ll long long
#define pii pair <int, int>
#define pld pair<ld, ld>
#define vi vector <int>
#define vld vector <ld>
#define x first
#define y second
#define vpi vector <pii>
#define all(c) (c).begin(), (c).end()
#define pb push_back
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());


template <typename T1, typename T2>
bool amin(T1 &a, T2 b) {
    if(b < a) {
        a = b;
        return true;
    }
    return false;
}

template <typename T1, typename T2>
bool amax(T1 &a, T2 b) {
    if(b > a) {
        a = b;
        return true;
    }
    return false;
}

const int N = 3e5, inf = 1e9, mod = 1e9 + 7, P = 179, lg = 20;

int binpow(int x, int p) {
    int res = 1;
    while(p) {
        if(p % 2)
            res = (res * x) % mod;
        p /= 2;
        x = (x * x) % mod;
    }
    return res;
}

int fac[N], inv[N];

int cnk(int n, int k) {
    if(n < k)
        return 0;
    int res = (fac[n] * inv[k]) % mod;
    res = (res * inv[n - k]) % mod;
    return res;
}

void precalc() {
    fac[0] = inv[0] = 1;
    for (int i = 1; i < N; i++) {
        fac[i] = (fac[i - 1] * i) % mod;
    }
    inv[N - 1] = binpow(fac[N - 1], mod - 2);
    for (int i = N - 2; i >= 0; i--) {
        inv[i] = (inv[i + 1] * (i + 1)) % mod;
    }
}

int distr(int c, int p) {
    if(p == 0 && c != 0)
        return 0;
    if(p == 0 && c == 0)
        return 1;
    int n = p - 1 + c;
    int k = p - 1;
    return cnk(n, k);
}

int n;

int get(char a1, char b1, char c1) {
    int res = 0;
    int a = (int) (a1 - '0');
    int b = (int) (b1 - '0');
    int c = (int) (c1 - '0');
    if((a + b + 1) % 10 == c) {
        res += 2;
        if(a + b + 1 >= 10)
            res ++;
    }
    else {
        if((a + b) % 10 != c) {
            cout << 0;
            exit(0);
        }
        if(a + b >= 10)
            res ++;
    }
    return res;
}

int cnt0[4], cnt[4];

int dp[2][200][200][200][4];

void solve() {

    precalc();

    string a, b, c;
    cin >> a >> b >> c;
    n = a.size();
    bool ZEROS = 1;
    for (int i = 0; i < n; i++) {
        bool f = (a[i] == '0' || b[i] == '0' || c[i] == '0');
        int t = get(a[i], b[i], c[i]);
        cnt[t]++;
        cnt0[t] += f;
        ZEROS |= f;
    }
    if(cnt[2] - cnt[1] != 0 && cnt[2] - cnt[1] != 1) {
        cout << 0;
        exit(0);
    }
    if(ZEROS == 0) {
        int ans = (fac[cnt[0]] * fac[cnt[1]]) % mod;
        ans = (ans * fac[cnt[2]]) % mod;
        ans = (ans * fac[cnt[3]]) % mod;
        int p0 = cnt[1] + 1;
        int p3 = cnt[2];
        int d1 = distr(cnt[0], p0);
        int d3 = distr(cnt[3], p3);
        ans = (ans * d1) % mod;
        ans = (ans * d3) % mod;
        cout << ans;
        exit(0);
    }
    if(cnt[0])
        dp[1][1][0][0][0] = cnt[0] - cnt0[0];
    if(cnt[2])
        dp[1][0][0][1][2] = cnt[2] - cnt0[2];
    vi CNT(n + 1);
    int ans = 0;
    for (int i0 = 1; i0 <= n; i0++) {
        for (int c0 = 0; c0 <= min(cnt[0], i0); c0++) {
            for (int c1 = 0; c1 <= cnt[1] && c0 + c1 <= i0; c1++) {
                for (int c2 = 0; c2 <= cnt[2] && c0 + c1 + c2 <= i0; c2++) {
                    for (int l = 0; l < 4; l++) {
                        int i = i0 % 2;
                        int i1 = 1 - i;
                        if(!dp[i][c0][c1][c2][l])
                            continue;
                        int c3 = i0 - c0 - c1 - c2;
                        if(c3 > cnt[3])
                            continue;
                        int cur = dp[i][c0][c1][c2][l];
                       // cout << i << ' ' << c0 << ' ' << c1 << ' ' << c2 << ' ' << c3 << ' ' << l << ' ' << dp[i][c0][c1][c2][l]<< endl;
                        CNT[i] += cur;
                        if(l == 0) {
                            if(c0 != cnt[0]) {
                                int nxt = - (cur * (c0 - cnt[0])) % mod;
                                dp[i1][c0 + 1][c1][c2][0] = (dp[i1][c0 + 1][c1][c2][0] + nxt) %mod;
                            }
                            if(c2 != cnt[2]) {
                                int nxt = - (cur * (c2 - cnt[2])) % mod;
                                dp[i1][c0][c1][c2 + 1][2] =  (dp[i1][c0][c1][c2 + 1][2] + nxt) %mod;
                            }
                        }
                        if(l == 1) {
                            if(c0 != cnt[0]) {
                                int nxt = - (cur * (c0 - cnt[0])) % mod;
                                dp[i1][c0 + 1][c1][c2][0] =  (dp[i1][c0 + 1][c1][c2][0] + nxt) %mod;
                            }
                            if(c2 != cnt[2]) {
                                int nxt = - (cur * (c2 - cnt[2])) % mod;
                                dp[i1][c0][c1][c2 + 1][2] =  (dp[i1][c0][c1][c2 + 1][2] + nxt) %mod;
                            }
                        }
                        if(l == 2) {
                            if(c1 != cnt[1]) {
                                int nxt = - (cur * (c1 - cnt[1])) % mod;
                                dp[i1][c0][c1 + 1][c2][1] =  (dp[i1][c0][c1 + 1][c2][1] +nxt) %mod;
                            }
                            if(c3 != cnt[3]) {
                                int nxt = - (cur * (c3 - cnt[3])) % mod;
                                dp[i1][c0][c1][c2][3] =  (dp[i1][c0][c1][c2][3] + nxt) %mod;
                            }
                        }
                        if(l == 3) {
                            if(c1 != cnt[1]) {
                                int nxt = - (cur * (c1 - cnt[1])) % mod;
                                dp[i1][c0][c1 + 1][c2][1] =  (dp[i1][c0][c1 + 1][c2][1] + nxt) %mod;
                            }
                            if(c3 != cnt[3]) {
                                int nxt = - (cur * (c3 - cnt[3])) % mod;
                                dp[i1][c0][c1][c2][3] = (dp[i1][c0][c1][c2][3] + nxt) %mod;
                            }
                        }
                        if(i0 == n) {
                            ans = (ans + cur);
                            ans %= mod;
                        }
                        dp[i][c0][c1][c2][l] = 0;
                    }
                }
            }
        }
     }
    cout << ans;
}

signed main() {
    fast;
    solve();
}
