#include <iostream>
#include <cstdio>
#include <vector>
#include <unordered_map>

using namespace std;
int n, ras = -1;

unordered_map<int, bool> was_ras, was_fra;

void fu(int &need, vector<pair<int, vector<int>>> &a, vector<int> &end) {
    if (!was_fra[need]) {
        end.push_back(need);
        if (end.size() == n) {
            printf("Yes\n");
            for(int i = 0; i < n; i++) {
                printf("%d ", end[i] + 1);
            }
            exit(0);
        }
        was_fra[need] = true;
        for (int j = 0; j < n; j++) {
            if (!was_fra[j]) {
                    if (a[need].first - a[need].second.back() + a[j].second.front() == ras) {
                        fu(j, a, end);
                    }
            }
        }
        end.pop_back();
        was_fra[need] = false;
    }
}


int main() {
    bool can_ch = true;
    scanf("%d", &n);
    vector<pair<int, vector<int>>> a(n);
    for (int i = 0; i < n; i++) {
        int m, s;
        scanf("%d %d", &m, &s);
        a[i].first = s;
        for (int j = 0; j < m; j++) {
            int tmp;
            scanf("%d", &tmp);
            a[i].second.push_back(tmp);
            if (m > 1 && j > 0) {
                if (!can_ch && a[i].second[j] - a[i].second[j - 1] != ras) {
                    printf("No");
                    exit(0);
                } else if (ras == -1){
                    ras = a[i].second[j] - a[i].second[j - 1];
                }
                can_ch = false;
            }
        }
    }
    vector<int> llh;
    if (!can_ch) {
        for (int i = 0; i < n; i++) {
            fu(i, a, llh);
        }
        printf("No");
    } else {
        if (n == 1) {
            printf("Yes\n1");
            exit(0);
        }
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (i == j) {
                    continue;
                }
                if (!was_ras[a[i].first - a[i].second.back() + a[j].second.front()]) {
                    ras = a[i].first - a[i].second.back() + a[j].second.front();
                    was_ras[a[i].first - a[i].second.back() + a[j].second.front()] = true;
                    for (int k = 0; k < n; k++) {
                        fu(k, a, llh);
                    }
                }
            }
        }
        printf("No");
    }
    return 0;
}
