#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <random>
#include <ctime>
#include <string>

using  namespace std;

// A G C T

int my_log(int n) {
	if (n == 1) return 0;
	int ans = 0;
	while (n > 0) {
		ans++;
		n /= 10;
	}
	return ans;
}

struct ans {
	int t;
	int x;
	int z_code;
	int v;
};

int main() {
	string s;
	cin >> s;
	vector <pair <int, int>> v;
	int step = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] > '9' || s[i] < '0') {
			if (step == 0) step = 1;
			int next = 1;
			if (s[i] == 'G') next = 2;
			if (s[i] == 'C') next = 3;
			if (s[i] == 'T') next = 4;
			v.push_back(make_pair(step, next));
			step = 0;
		}
		else {
			step *= 10;
			step += s[i] - '0';
		}
	}
	ans f;
	f.v = 0;
	f.t = 2;
	f.x = 1;
	int ind = 0;
	for (int i = 0; i < v.size(); i++) {
		if (v[i].first == 1) {
			if (i != 0 && i != v.size() - 1 && v[i - 1].second == v[i + 1].second) {
				int k = -my_log(v[i - 1].first + v[i + 1].first) + my_log(v[i - 1].first) + my_log(v[i + 1].first) + 2;
				if (k > f.v) {
					f.v = k;
					f.t = 2;
					f.x = ind + 1;
				}
			}
			else {
				if (f.v < 1) {
					f.v = 1;
					f.t = 2;
					f.x = ind + 1;
				}
			}
		} 
		if (v[i].first == 2) {
			if (f.v < 1) {
				f.v = 1;
				f.t = 2;
				f.x = ind + 1;
			}
		}
		if (v[i].first % 10 == 0) {
			if (f.v < 1) {
				f.v = 1;
				f.t = 2;
				f.x = ind + 1;
			}
		}
		ind += v[i].first;
	}
	ind = 0;
	cout << "2 " << f.x << "\n";
	f.t = 1;
	f.v = 1;
	f.x = 0;
	f.z_code = 1;
	if (v[0].second == 1) f.z_code = 2;
	for (int i = 0; i < v.size(); i++) {
		if (v[i].first > 1) {
			int j = 1;
			while (j < v[i].first) {
				int k = (my_log(j) + my_log(v[i].first - j)) - my_log(v[i].first) + 2;
				if (k > f.v) {
					f.v = k;
					f.x = ind + j;
					f.t = 1;
					f.z_code = 1;
					if (v[i].second == 1) f.z_code = 2;
				}
				j *= 10;
			}
			if (v[i].first == 2) continue;
			j = 2;
			int k = (my_log(j) + my_log(v[i].first - j)) - my_log(v[i].first) + 2;
			if (k > f.v) {
				f.v = k;
				f.x = ind + j;
				f.t = 1;
				f.z_code = 1;
				if (v[i].second == 1) f.z_code = 2;
			}
		}
		ind += v[1].first;
	}
	cout << f.t << " " << f.x << " " << "AGCT"[f.z_code - 1];
}