#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <random>
#include <ctime>

using  namespace std;

struct one {
	int s, v, i;
	vector <int> d;
};

int random(int l, int r) {
	return l + rand() % (r - l);
}

int f(vector <one> a) {
	int min_one = 1e9;
	int max_one = 0;
	int last_one = -1;
	int len_of = 0;
	for (int i = 0; i < a.size(); i++) {
		for (int j = 0; j < a[i].d.size(); j++) {
			if (last_one == -1) {
				last_one = len_of + a[i].d[j];
				continue;
			}
			int k = (len_of + a[i].d[j] - last_one);
			last_one = len_of + a[i].d[j];
			min_one = min(min_one, k);
			max_one = max(max_one, k);
		}
		len_of += a[i].v;
	}
	if (max_one == 0) return 0;
	return max_one - min_one;
}

int main() {
	srand(time(0));
	int n;
	cin >> n;
	vector <one> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].s >> a[i].v;
		a[i].i = i;
		a[i].d.resize(a[i].s);
		for (int j = 0; j < a[i].s; j++) {
			cin >> a[i].d[j];
		}
	}
	long double temp = 1;
	while (temp > 0.000001) {
		int i = random(0, n);
		int j = random(0, n);
		int s1 = f(a);
		swap(a[i], a[j]);
		int s2 = f(a);
		swap(a[i], a[j]);
		int d_s = s1 - s2;
		if (d_s > 0 || exp(d_s / temp)) {
			swap(a[i], a[j]);
		}
		temp *= 0.9;
	}
	int k = f(a);
	if (f(a) == 0) {
		cout << "Yes\n";
		for (int i = 0; i < n; i++) {
			cout << a[i].i + 1 << " ";
		}
	}
	else {
		cout << "NO";
	}
}