#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <random>
#include <ctime>

using  namespace std;

const long double p = 0.1;

struct one {
	int s, v, i;
	vector <int> d;
};

int random(int l, int r) {
	return l + rand() % (r - l);
}

int f(vector <one> a) {
	int min_one = 1e9;
	int max_one = 0;
	int last_one = -1;
	int len_of = 0;
	set <int> num;
	for (int i = 0; i < a.size(); i++) {
		for (int j = 0; j < a[i].d.size(); j++) {
			if (last_one == -1) {
				last_one = len_of + a[i].d[j];
				continue;
			}
			int k = (len_of + a[i].d[j] - last_one);
			num.insert(k);
			last_one = len_of + a[i].d[j];
			min_one = min(min_one, k);
			max_one = max(max_one, k);
		}
		len_of += a[i].v;
	}
	return max((int)num.size() - 1, 0);
}

int main() {
	srand(time(0));
	int n;
	cin >> n;
	vector <one> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].s >> a[i].v;
		a[i].i = i;
		a[i].d.resize(a[i].s);
		for (int j = 0; j < a[i].s; j++) {
			cin >> a[i].d[j];
		}
	}
	long double temp = 1;
	int i = random(0, n);
	int j = random(0, n);
	while (temp > 0.000000001) {
		while (i * 2 >= j || i > j) {
			i = random(0, n);
			j = random(0, n);
		}
		int k = random(0, i - j);
		int s1 = f(a);
		for (int l = 0; l < j - i + 1; l++) {
			swap(a[i + l], a[k + l]);
		}
		int s2 = f(a);
		for (int l = 0; l < j - i + 1; l++) {
			swap(a[i + l], a[k + l]);
		}
		int d_s = s1 - s2;
		if (d_s > 0 || (rand() / (long double) RAND_MAX) > exp(d_s / temp) * p) {
			for (int l = 0; l < j - i + 1; l++) {
				swap(a[i + l], a[k + l]);
			}
		}
		if (s2 == 0) break;
		temp *= 0.99;
	}
	int k = f(a);
	if (f(a) == 0) {
		cout << "Yes\n";
		for (int i = 0; i < n; i++) {
			cout << a[i].i + 1 << " ";
		}
	}
	else {
		cout << "No";
	}
}