#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <random>
#include <ctime>
#include <string>

using  namespace std;
const int mod = 1e9 + 7;

int my_pow(int a, int p) {
	if (p == 0) return 1;
	if (p == 1) return a;
	return my_pow((a * a) % mod, p / 2) * my_pow(a, p % 2);
}

int my_fac(int a) {
	if (a == 0) return 1;
	int ans = 1;
	for (int i = 1; i <= a; i++) {
		ans *= i;
		ans %= mod;
	}
	return ans;
}

int my_c(int n, int k) {
	if (k == 0) return 1;
	return ((my_fac(n) * my_pow(my_fac(n - k), mod - 2)) % mod * my_pow(my_fac(k), mod - 2)) % mod;
}

int mult(int a, int b) {
	return a * b % mod;
}

int main() {
	string as;
	string bs;
	string cs;
	cin >> as >> bs >> cs;
	vector <int> next;
	int n = as.size();
	if (n < 2) {
		for (int i = 0; i < n; i++) {
			next.push_back(i);
		}
		vector <int> n_next;
		n_next = next;
		int ans = 0;
		do {
			string d_a;
			string d_b;
			string d_c;
			for (auto i : n_next) {
				d_a.push_back(as[i]);
				d_b.push_back(bs[i]);
				d_c.push_back(cs[i]);
			}
			if (d_a[0] == '0') {
				next_permutation(n_next.begin(), n_next.end());
				continue;
			}
			if (d_b[0] == '0') {
				next_permutation(n_next.begin(), n_next.end());
				continue;
			}
			if (d_c[0] == '0') {
				next_permutation(n_next.begin(), n_next.end());
				continue;
			}
			int f = 0;
			bool f2 = true;
			for (int i = n - 1; i > -1; i--) {
				if (!((f + d_a[i] - '0' + d_b[i] - '0') % 10 == d_c[i] - '0')) {
					f2 = false;
					break;
				}
				if ((f + d_a[i] - '0' + d_b[i] - '0') >= 10) f = 1;
				else f = 0;
			}
			if (f2) ans++;
			next_permutation(n_next.begin(), n_next.end());
		} while (next != n_next);
		cout << ans;
	}
	else {
		int a, b, c, d;
		a = 0; b = 0; c = 0; d = 0;
		for (int i = 0; i < n; i++) {
			if (as[i] - '0' + bs[i] - '0' == cs[i] - '0') a++;
			else if (as[i] - '0' + bs[i] - '0' == cs[i] - '0' - 1) b++;
			else if (as[i] - '0' + bs[i] - '0' - 10 == cs[i] - '0') d++;
			else if (as[i] - '0' + bs[i] - '0' - 10 + 1 == cs[i] - '0') c++;
			else {
				cout << 0;
				return 0;
			}
		}
		if (b != d) {
			cout << 0;
			return 0;
		}
		int k = my_fac(b);
		k = mult(k, my_fac(c));
		k = mult(k, my_fac(b));
		k = mult(k, my_c(b + a, a));
		k = mult(k, my_c(c + b - 1, b - 1));
		k = mult(k, my_fac(a));
		cout << k;
	}
}