#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

int mrg(vector<int> &a, vector<int>&p){
    int ans = 0;
    for(int i = 0; i < p.size(); ++i){
        ans *= 10;
        ans += a[p[i]];
    }
    return ans;
}

int main()
{
    int n;
    string(s);
    cin >> s;
    n = s.size();
    vector<int>a(n);
    vector<int>b(n);
    vector<int>c(n);
    vector<int>p(n);
    for(int i = 0; i < n; ++i){
        a[i] = s[i]-'0';
    }
    cin >> s;
    for(int i = 0; i < n; ++i){
        b[i] = s[i]-'0';
    }
    cin >> s;
    for(int i = 0; i < n; ++i){
        c[i] = s[i]-'0';
    }
    for(int i = 0; i < n; ++i){
        p[i] = i;
    }
    vector<int>ab(n);
    for(int i = 0; i < n; ++i){
        ab[i] = a[i] + b[i];
    }
    int k = 1;
    ll ans = 0;

    if(mrg(ab, p) == mrg(c, p) && a[p[0]] && b[p[0]] && c[p[0]]) ++ans;
    while(next_permutation(p.begin(), p.end())){
        if(ab[p[0]] > c[p[0]]){
            k = p[0];
            p[0] = k+1;
            for(int i = 0; i < n; ++i){
                p[i+1] = i + i<k;
            }
        }
        if(mrg(ab, p) == mrg(c, p) && a[p[0]] && b[p[0]] && c[p[0]]) ++ans;
    }

    cout << ans;
    return 0;
}
