#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <cmath>

using namespace std;

// #define int long long
#define ft first
#define sd second
#define rs resize
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

int n, len = -1;
vector<pair<int, int>> sht;

bool check(vector<int> p)
{
    int l = len;
    for (int i = 1; i < n; i++)
    {
        int temp = sht[p[i]].ft + sht[p[i - 1]].sd;
        if (l != -1 && temp != l)
        {
            return false;
        }
        l = temp;
    }
    return true;
}

signed main()
{
    cin >> n;
    sht.rs(n);
    for (int i = 0; i < n; i++)
    {
        int m, s;
        cin >> m >> s;
        vector<int> p(m);
        for (int i = 0; i < m; i++)
        {
            cin >> p[i];
            if (i)
            {
                int temp = p[i] - p[i - 1];
                if (len != -1 && temp != len)
                {
                    cout << "No\n";
                    return 0;
                }
                len = temp;
            }
        }
        sht[i] = {p[0], s - p.back()};
    }
    vector<int> p(n);
    iota(all(p), 0);
    do
    {
        // cout << "here\n";
        if (check(p))
        {
            cout << "Yes\n";
            for (auto elem : p)
            {
                cout << elem + 1 << " ";
            }
            return 0;
        }
    } while(next_permutation(all(p)));
    cout << "No\n";
    return 0;
}
