#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <numeric>

using namespace std;

//#define int long long
#define ft first
#define sd second
#define rs resize
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

ll get_len(ll num)
{
    ll cnt = 0;
    while (num > 0)
    {
        cnt++;
        num /= 10;
    }
    return cnt;
}

ll get_num(ll cnt, char c)
{
    ll num = 0;
    while (cnt--)
    {
        num = num * 10 + (c - '0');
    }
    return num;
}

char get_first(ll num)
{
    ll res = num;
    while (num > 0)
    {
        res = num;
        num /= 10;
    }
    return res + '0';
}

ll pow10(int num)
{
    if (num == 0)
    {
        return 1;
    }
    if (num % 2 == 1)
    {
        return 10 * pow10(num - 1);
    }
    ll temp = pow10(num / 2);
    return temp * temp;
}

signed main()
{
    ll x, k;
    cin >> x >> k;
    ll len = get_len(x);
    if (k == 0)
    {
        ll temp = get_num(len, get_first(x));
        if (temp >= x)
        {
            cout << temp;
        }
        else
        {
            for (int i = 0; i <= len; i++)
            {
                cout << 1;
            }
        }
    }
    else
    {
        ll f = get_first(x)- '0';
        ll temp1 = f * pow10(len - 1);
        ll temp2 = temp1 + get_num(len - 2, f +'0');
        if (temp1 >= x)
        {
            cout << temp1;
        }
        else if (temp2 >= x)
        {
            cout << temp2;
        }
        else
        {
            cout << pow10(len);
        }
    }
    return 0;
}
