#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
#define pii pair<int,int>
#define pll pair <ll,ll>
#define fi first
#define se second
#define vi vector <int>
#define vll vector <ll>
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define pb push_back

const int MAXN=3e5+100;
const int INF = 1e9;
const ll INFLL = 1e18;
const int mod1=1e9+7;
const int mod2=1e9+9;
int par[MAXN],ranks[MAXN];
void make_set(int s)
{
    ranks[s]=0;
    par[s]=s;
}
int find_set(int s)
{
    if (par[s]==s)
        return s;
    return par[s]=find_set(par[s]);
}
void union_sets(int u,int v)
{
    u=find_set(u);
    v=find_set(v);
    if (u!=v)
    {
        if (ranks[u]<ranks[v])
            swap(u,v);
        par[v]=u;
        if (ranks[u]==ranks[v])
            ranks[u]++;
    }
}
vector <vector <pair <int,int> > > g;
vector <bool> used;
vector <int> which;
vector <int> path;
int n;
int sz;
void dfs(int s,int was)
{
    for (;which[s]<g[s].size();)
    {
        pii to=g[s][which[s]];
        if (used[to.se]) {
            which[s]++;
            continue;
        }
        used[to.se]=true;
        which[s]++;
        dfs(to.fi,to.se);
    }
    if (was!=-1&&was!=n)
        path.pb(was);
}
void solve()
{
    cin>>n;
    vector <pii> a(n);
    int mod=-1;
    int max_s=0;
    for (int i=0;i<n;i++)
    {
        int m,s;
        cin>>m>>s;
        max_s=max(max_s,s);
        vector <int> b(m);
        for (auto &to:b)
            cin>>to;
        for (int j=0;j+1<m;j++)
        {
            if (mod==-1)
                mod=b[j+1]-b[j];
            else
            {
                if (mod!=b[j+1]-b[j])
                {
                    cout<<"No\n";
                    return;
                }
            }
        }
        a[i]={b[0],s-b.back()};
    }
    if (n==1)
    {
        cout<<"Yes\n1\n";
        return;
    }
    vector <int> poss;
    if (mod==-1)
    {
        if (n<=1000)
        {
            for (int i=0;i<n;i++)
            {
                for (int j=0;j<n;j++)
                {
                    if (i==j)
                        continue;
                    poss.pb(a[i].se+a[j].fi);
                }
            }
        }
        else if (max_s<=100)
        {
            for (int i=0;i<=2*max_s;i++)
                poss.pb(i);
        }
        else {
            mt19937 rng(228);
            int x=rng()%n;
            for (int i=0;i<n;i++)
            {
                if (i==x)
                    continue;
                poss.pb(a[x].se+a[i].fi);
            }
        }
    }
    else
        poss.pb(mod);
    sort(all(poss));
    poss.resize(unique(all(poss))-poss.begin());
    vector <int> c(n);
    for (int i=0;i<n;i++)
    {
        c[i]=a[i].fi;
    }
    sort(all(c));
    c.resize(unique(all(c))-c.begin());
    unordered_map<int,int> m;
    for (int i=0;i<c.size();i++)
        m[c[i]]=i;
    sz=c.size();
    for (auto check:poss)
    {
        g=vector <vector <pii> >(sz+1);
        vector <int> in_deg(sz+1),out_deg(sz+1);
        int chet=0;
        for (int i=0;i<n;i++)
        {
            int x=m[a[i].fi],y=a[i].se;
            int val=check-y;
            out_deg[x]++;
            if (val<0||m.find(val)==m.end()) {
                chet++;
                g[x].pb({sz,i});
                in_deg[sz]++;
                if (chet>1)
                    break;
                continue;
            }
            in_deg[m[val]]++;
            g[x].pb({m[val],i});
        }
        if (chet>1)
            continue;
        int cnt=0;
        bool ok=true;
        for (int i=0;i<=sz;i++)
        {
            if (abs(in_deg[i]-out_deg[i])>1)
            {
                ok=false;
            }
        }
        if (!ok)
            continue;
        vector <int> x,y;
        for (int i=0;i<=sz;i++)
        {
            if (in_deg[i]!=out_deg[i])
            {
                if (in_deg[i]>out_deg[i])
                    x.pb(i);
                else
                    y.pb(i);
            }
        }
        if (x.size()>1||y.size()>1)
            continue;
        int st=0;
        if (x.size()+y.size()>0)
        {
            if (x.empty()||y.empty())
                continue;
            st=x[0];
            g[x[0]].pb({y[0],n});
            reverse(all(g[x[0]]));
        }
        which=vi(sz+1);
        used=vector <bool>(n+1);
        dfs(st,-1);
        reverse(all(path));
        if (path.size()!=n)
            continue;
        cout<<"Yes\n";
        for (int i=0;i<n;i++)
            cout<<path[i]+1<<" ";
        cout<<'\n';
        return;
    }
    cout<<"No\n";
}

int main()
{
    #ifdef Mip182
    freopen("a.in","r",stdin);
    #else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #endif
    int _t=1;
    while (_t--)
        solve();
}
