// Задача Числа.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
using namespace std;
typedef long long ll;
const ll INF = pow(10, 18);

vector<ll> make(ll x) {
	vector<ll> a;
	while (x > 0) {
		a.push_back(x % 10);
		x /= 10;
	}
	reverse(a.begin(), a.end());
	return a;
}

ll good(ll x) {
	vector<ll> a = make(x);
	ll res = a[0];
	for (ll i = 1; i < a.size(); i++) {
		if (a[i] > res) {
			res++;
			break;
		}
	}
	ll result = res;
	for (ll i = 0; i < a.size() - 1; i++) {
		result = result * 10 + res;
	}
	return result;
}

bool is_ok(ll x) {
	vector<ll> a = make(x);
	map<ll, ll> res;
	for (auto c : a) {
		if (res.find(c) == res.end()) {
			res[c] = 1;
		}
		else
			res[c]++;
	}
	if (res.size() <= 2 && res[0] >= a.size() - 1 || res[1] >= a.size() - 1)
		return true;
	return false;
}

ll bad(ll x) {
	vector<ll> a = make(x);
	if (is_ok(x)) return x;
	ll pos = -1;
	for (ll i = 1; i < a.size(); i++) {
		if (a[i] != a[0]) {
			pos = i;
			break;
		}
	}
	ll res2 = INF;
	if (pos == 1) {
		ll power = (ll)pow(10, a.size() - 1);
		ll cur = good(x % ((ll)pow(10, a.size()-1)));
		res2 = a[0]*power + cur;
	}
	for (ll i = pos + 1; i < a.size(); i++) {
		if (a[i] > a[0]) {
			ll p = pow(10, a.size() - 1 - pos);
			x = x+p-(x%p);
			return min(bad(x), res2);
		}
	}
	ll result = a[0];
	for (ll i = 1; i < a.size(); i++) {
		if (i == pos) {
			result = result * 10 + a[pos];
		}
		else {
			result = result * 10 + a[0];
		}
	}
	return min(res2, result);
}

ll bad2(ll x) {
	while (!is_ok(x)) {
		x++;
	}
	return x;
}

int main()
{
	ll x, k;
	cin >> x >> k;
	if (k == 0) {
		cout << good(x);
	}
	else
		cout << bad2(x);
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
