#include <bits/stdc++.h>

#define int long long
#define pb push_back

using namespace std;

const int inf = 1e17;

int get(int a) {
	return a * (a + 1) / 2;
}

void solve() {
	int n, m;
	cin >> n >> m;
	

	// horisontal
	int total = get(n * m);
	int need = total / 2;
	int sq = sqrt(need);
	sq /= m;
	sq *= m;
	int ans1_index = -1;
	int ans1 = inf;
	for (int i = -100; i <= 100; i++) {
		int x = sq + i * m;
		if (0 < x && x <= n * m) {
			// check
			int t = abs(get(x) - (total - get(x)));
			if (t < ans1) {
				ans1 = t;
				ans1_index = x;
			}
		}
	}
	ans1_index /= m;
	// cout << "total = " << total << endl;
	// cout << "Ans1 = " << ans1 << endl;
	// cout << "D " << ans1_index << "\n";

	// vertical
	int ans2 = inf;
	int ans2_index = -1;
	int l = 1, r = m, mid;

	int f = n + m * n * (n - 1) / 2;
	// cout << "f = " << f << endl;

	while (l <= r) {
		mid = (l + r) / 2;

		int tek = f * mid + n * (mid - 1) * (mid) / 2;

		if (tek <= (total - tek)) {
			l = mid + 1;
		} else {
			r = mid - 1;
		}
	}
	// cout << "l r = " << l << " " << r << "\n";

	mid = l;
	int tek = f * mid + n * (mid - 1) * (mid) / 2;
	ans2 = abs(tek - (total - tek));
	ans2_index = l;

	mid = r;
	tek = f * mid + n * (mid - 1) * (mid) / 2;
	if (abs(tek - (total - tek)) < ans2) {
		ans2 = abs(tek - (total - tek));
		ans2_index = r;
	}

	mid = r - 1;
	tek = f * mid + n * (mid - 1) * (mid) / 2;
	if (abs(tek - (total - tek)) < ans2) {
		ans2 = abs(tek - (total - tek));
		ans2_index = r;
	}

	mid = l + 1;
	tek = f * mid + n * (mid - 1) * (mid) / 2;
	if (abs(tek - (total - tek)) < ans2) {
		ans2 = abs(tek - (total - tek));
		ans2_index = r;
	}

	// cout << "H " << ans1 << " " << ans1_index << "\n";
	// cout << "V " << ans2 << " " << ans2_index << "\n" << endl;
	// return;

	if (ans1 < ans2) {
		cout << "H " << ans1_index + 1 << "\n";
	} else {
		cout << "V " << ans2_index + 1 << "\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
