//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")


#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <set>

#define INF 1e9
#define INF_LL 1e18
#define endl '\n'

using namespace std;

typedef int64_t ll;

//
//d = B^2 - 4AC
//
//(-b +- sqrt(d)) / 2a

int fc(char x) {
    return x - '0';
}

ll check(vector<vector<int>>& ar) {
    int per = 0;
    bool ok = true;
    bool isn = false;
    for (int i = 0; i < ar.size(); ++i) {
        int cur = ar[i][0] + ar[i][1] + per;
        per = cur >= 10;
        if (cur % 10 != ar[i][2]) {
            ok = 0;
            break;
        }
        if (ar[i][2] == 0 || ar[i][1] == 0 || ar[i][0] == 0) isn = true;
        else isn = false;
    }
    if (per || isn)
        ok = 0;
    return ok;
}

ll rec(multiset<vector<int>> kk, vector<vector<int>>& cur) {
    if (kk.size() == 0) {
        return check(cur);
    }
    int ans = 0;
    for (auto& it : kk) {
        multiset<vector<int>> nw = kk;
        nw.erase(nw.find(it));
        cur.push_back(it);
        ans += rec(nw, cur);
        cur.pop_back();
    }
    return ans;
}


signed main() {
    string a, b, c; cin >> a >> b >> c;
    vector<vector<int>> ar(a.size());
    for (int i = 0; i < a.size(); ++i) {
        ar[i] = {fc(a[i]), fc(b[i]), fc(c[i])};
    }
    multiset<vector<int>> br;
    for (auto& it : ar) br.insert(it);
    vector<vector<int>> cur;
    cout << rec(br, cur);
//    sort(ar.begin(), ar.end());
//    ll ans = 0;
//    while (true) {
//        int per = 0;
//        bool ok = 1;
//        bool isn = 0;
//
//        if (!next_permutation(ar.begin(), ar.end())) break;
//    }
//    cout << ans;
    return 0;
}

//01211
//12099
//23300