#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <cmath>
using namespace std;

bool check(vector <int>&l, vector <int>&r, vector <int>&p, int d, int n){
//	for(int i : p)
//		cout << i;
	//cout << endl;
	//cout << d << endl;
	for(int i = 1; i < n; i++){
		//cout << l[p[i]] + r[p[i-1]];
		if(d == -1)
			d = l[p[i]] + r[p[i-1]];
		else if(l[p[i]] + r[p[i-1]] != d){
			return false;
		}
			
	}
	return 1;
}

bool perebor(vector <bool> used, int n, vector <int>& ans, vector <int> posl, int d, vector<int>&l, vector<int>&r){
	if(posl.size() == n){
		if(check(l, r, posl, d, n)){
			ans = posl;
			return 1;
		}
		return 0;
	}
	for(int i = 0; i < n; i++){
		if(!used[i]){
			posl.push_back(i);
			used[i] = 1;
			if(perebor(used, n, ans, posl, d, l, r))
				return 1;
			posl.pop_back();
			used[i] = 0;
		}
	}
	return 0;
}

int main(){
	int n;
	cin >> n;
	vector<int> l(n), r(n), s(n);
	int d = -1;
	for(int i = 0; i < n; i++){
		int m;
		cin >> m >> s[i];
		int px = -1;
		for(int j = 0; j < m; j++){
			int x;
			cin >> x;
			if(px != -1){
				if(d == -1)
					d = x - px;
				else if(d != x - px){
					cout << "No";
					return 0;
				}
			}
			px = x;
			if(j == 0)
				l[i] = x;
			if(j+1 == m)
				r[i] = s[i]-x;
		}
	}
	
//	for(int i : l)
//		cout << i;
//	cout << endl;
//	for(int i : r)
//		cout << i;
//	cout << endl;
	
	vector<bool> used(n);
	vector <int> ans;
	vector <int> posl;
	perebor(used, n, ans, posl, d, l, r);
	if(ans.empty()){
		cout << "No";
	}
	else{
		cout << "Yes\n";
		for(int i : ans)
			cout << i+1 << " ";
	}
}
