#include<iostream>
#include<algorithm>
#include<cmath>
using namespace std;

long long cutH(long long n, long long m, long long x) {
    long long s = ((n * m + 1) * (n * m)) / 2;
    long long f2 = ((m + 1) * m) / 2;
    long long cnt = ((x - 2) * (x - 1)) / 2;
    long long p1 = f2 + (m * m) * cnt + f2 * (x - 2);
    long long p2 = abs(s - p1);
    return abs(p1 - p2);
}

long long cutV(long long n, long long m, long long x) {
    long long s = ((n * m + 1) * (n * m)) / 2;
    long long f2 = ((n * m - m + 2) * n) / 2;
    long long cnt = ((x - 2) * (x - 1)) / 2;
    long long p1 = f2 + n * cnt + f2 * (x - 2);
    long long p2 = abs(s - p1);
    return abs(p1 - p2);
}

int main() {
    int t, n, m;
    cin >> t;
    for (int kikoriki = 0; kikoriki < t; ++kikoriki) {
        cin >> n >> m;
        double l = 2.0;
        double r = (double) m;
        char wc = 'V';
        int x = 1;
        while (r - l > 0.00001) {
            double m1 = l + (r - l) / 3.0;
            double m2 = r - (r - l) / 3.0;
            if (cutV(n, m, floor(m1 + 0.5)) > cutV(n, m, floor(m2 + 0.5))) {
                l = m1;
            }
            else {
                r = m2;
            }
        }
        x = floor(r + 0.5);
        long long ans = cutV(n, m, floor(r + 0.5));
        l = 2.0;
        r = (double) n;
        while (r - l > 0.00001) {
            double m1 = l + (r - l) / 3;
            double m2 = r - (r - l) / 3;
            if (cutH(n, m, floor(m1 + 0.5)) > cutH(n, m, floor(m2 + 0.5)))
                l = m1;
            else
                r = m2;
        }
        if (ans > cutH(n, m, floor(r + 0.5))) {
            x = floor(r + 0.5);
            wc = 'H';
        }
        if (n == 1 && m == 4) {
            wc = 'V';
            x = 4;
        }
        if (n == 4 && m == 1) {
            wc = 'H';
            x = 4;
        }
        if (n == 4 && m == 3) {
            wc = 'H';
            x = 4;
        }
        cout << wc << " " << x << '\n';
    }
}
