#include <iostream>
#include <vector>

using namespace std;

int table[11][11];

inline bool checkRect(int x1, int y1, int x2, int y2) {
    if (x1 == x2 || y1 == y2) return true;
    return !(table[x1][y1] == table[x1][y2] && table[x1][y1] == table[x2][y1] && table[x1][y1] == table[x2][y2]);
}

void rec(int i, int n, int m, int c) {
    if (i == n * m) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << table[i][j] << ' ';
            }
            cout << endl;
        }
        exit(0);
        return;
    }
    int x = i / m;
    int y = i % m;
    for (int color = 1; color <= c; color++) {
        table[x][y] = color;
        bool flag = true;
        for (int i = 0; i < x; i++) {
            for (int j = 0; j < y; j++) {
                if (!checkRect(i, j, x, y)) flag = false;
            }
        }
        if (flag) {
            rec(i + 1, n, m, c);
        }
    }
}

int main() {
    int n, m, c; cin >> n >> m >> c;
    rec(0, n, m, c);
}