#include <iostream>
#include <vector>
#include <set>

using namespace std;

struct Column {
    int a, b, c;
    explicit Column() {

    }
    Column(int a_, int b_, int c_) : a(a_), b(b_), c(c_) {

    }
};

set<int> currentCols;
Column allCols[20];

int ans = 0;

void rec(int i, int n, int added) {
    if (i == n) {
        ans += 1;
        return;
    }
    vector<int> cols(currentCols.begin(), currentCols.end());
    for (int ind : cols) {
        int a = allCols[ind].a, b = allCols[ind].b, c = allCols[ind].c;
        if ((a + b + added) == c) {
            currentCols.erase(ind);
            rec(i + 1, n, 0);
            currentCols.insert(ind);
        }
        if ((a + b + added) == c + 10) {
            currentCols.erase(ind);
            rec(i + 1, n, 1);
            currentCols.insert(ind);
        }
    }
}

int main() {
    string a; cin >> a;
    string b; cin >> b;
    string c; cin >> c;
    int n = a.length();
    for (int i = 0; i < n; i++) {
        currentCols.insert(i);
        allCols[i].a = a[i] - '0';
        allCols[i].b = b[i] - '0';
        allCols[i].c = c[i] - '0';
    }
    rec(0, n, 0);
    cout << ans << endl;
}
