#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, m;

int GetH(int ind)
{
    return ind * m * (m + 1) / 2 + m * m * ind * (ind - 1) / 2;
}

int GetV(int ind)
{
    return n * ind * (ind + 1) / 2 + ind * m * n * (n - 1) / 2;
}

int Abs(int x)
{
    if (x < 0)
    {
        return -x;
    }
    return x;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    //freopen("input.txt", "r", stdin);
    int t;
    cin >> t;
    while (t--)
    {
        cin >> n >> m;

        int sum = GetH(n);

        int l = 0, r = n;
        while (r - l > 1)
        {
            int mm = (l + r) / 2;
            int gmm = GetH(mm);
            if (2 * gmm < sum)
            {
                l = mm;
            }
            else
            {
                r = mm;
            }
        }

        int ans1 = 0;
        if (Abs(2 * GetH(l) - sum) <= Abs(2 * GetH(r) - sum))
        {
            ans1 = l;
        }
        else
        {
            ans1 = r;
        }

        l = 0, r = m;
        while (r - l > 1)
        {
            int mm = (l + r) / 2;
            int gmm = GetV(mm);
            if (2 * gmm < sum)
            {
                l = mm;
            }
            else
            {
                r = mm;
            }
        }

        int ans2 = 0;
        if (Abs(2 * GetV(l) - sum) <= Abs(2 * GetV(r) - sum))
        {
            ans2 = l;
        }
        else
        {
            ans2 = r;
        }

        if (Abs(2 * GetH(ans1) - sum) < Abs(2 * GetV(ans2) - sum))
        {
            cout << "H " << ans1 + 1 << '\n';
        }
        else
        {
            cout << "V " << ans2 + 1 << '\n';
        }
    }

    return 0;
}
