#include <bits/stdc++.h>

using namespace std;

#define int long long

mt19937 rnd(1337);

const long long MOD = 1000000007;

vector <vector <int> > g;

long long B(long long n, long long k)
{
    long long ans = 1;
    for (long long i = n - k + 1; i <= n; ++i)
    {
        ans = (ans * i) % MOD;
    }
    return max(1ll, ans);
}

long long m = 0;
long long k = 0;

long long Calc()
{
    if (g[1][0] != g[0][1])
    {
        return 0;
    }

    if (g[0][1] == 0 && g[1][0] + g[1][1] != 0)
    {
        return 0;
    }

    vector <long long> p(g[1][0] + 1);
    p[0] = 1;
    for (int i = 1; i < p.size(); ++i)
    {
        p[i] = (((long long) p[i - 1]) * i) % MOD;
    }

    long long ans = (p[g[1][0]] * p[g[1][0]]) % MOD;

    ans = (ans * B(g[1][0] + g[0][0], g[0][0])) % MOD;
    ans = (ans * B(g[1][0] + g[1][1] - 1ll, g[1][1])) % MOD;

    return ans;
}

map <pair <vector <vector <int> >, int >, long long> mem;

long long Go(int last)
{
    if (mem.count({ g, last }))
    {
        return mem[{ g, last }];
    }

    if (g[0][0] + g[0][1] + g[1][0] + g[1][1] == 0)
    {
        if (last == 0)
        {
            return 1;
        }
        return 0;
    }

    long long ans = 0;
    if (g[last][0] > 0)
    {
        g[last][0]--;
        ans += Go(0) * (g[last][0] + 1);
        g[last][0]++;
    }
    if (g[last][1] > 0)
    {
        g[last][1]--;
        ans += Go(1) * (g[last][1] + 1);
        g[last][1]++;
    }
    ans = ans % MOD;
    mem[{ g, last }] = ans;
    return ans;
}

long long Stupid()
{
    return Go(0);
}

long long Pow(long long a, long long b)
{
    if (b == 0)
    {
        return 1;
    }
    if (b == 1)
    {
        return a;
    }
    if (b % 2 == 0)
    {
        long long x = Pow(a, b / 2);
        return x * x;
    }
    else
    {
        return a * Pow(a, b - 1);
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    g.resize(2, vector <int>(2));

    //freopen("input.txt", "r", stdin);


    string a, b, c;
    cin >> a >> b >> c;

    int n = a.size();

    for (int i = 0; i < n; ++i)
    {
        int xa = a[i] - '0';
        int xb = b[i] - '0';
        int xc = c[i] - '0';


        if (xa == 0 || xb == 0)
        {
            if (xc == xa + xb)
            {
                m++;
            }
            if (xc == xa + xb + 1)
            {
                k++;
            }
        }

        if (xc == (xa + xb) % 10)
        {
            if (xa + xb >= 10)
            {
                g[0][1]++;
            }
            else
            {
                g[0][0]++;
            }
        }
        else
        {
            if (xc == (xa + xb + 1) % 10)
            {
                if (xa + xb + 1 >= 10)
                {
                    g[1][1]++;
                }
                else
                {
                    g[1][0]++;
                }
            }
            else
            {
                cout << 0;
                return 0;
            }
        }
    }

    long long ans = Calc();

    long long mans = 0;
    if (g[0][0] > 0)
    {
        g[0][0]--;
        mans = m * Calc();
        g[0][0]++;
    }

    if (g[1][0] > 0)
    {
        vector <long long> p(g[1][0] + 1);
        p[0] = 1;
        for (int i = 1; i < p.size(); ++i)
        {
            p[i] = (((long long) p[i - 1]) * i) % MOD;
        }
        long long nans = (p[g[1][0]] * p[g[1][0] - 1]) % MOD;

        nans = (nans * B(g[1][0] + g[0][0] - 1ll, g[0][0])) % MOD;
        nans = (nans * B(g[1][0] + g[1][1] - 1ll, g[1][1])) % MOD;
        mans += k * nans;
    }
    mans = mans % MOD;
    ans -= mans;
    ans = (ans + MOD) % MOD;

    cout << ans;

    /*
    int n;
    cin >> n;
    int counter = 0;
    while (true)
    {
        cout << counter++ << '\n';
        for (int i = 0; i < 2; ++i)
        {
            for (int j = 0; j < 2; ++j)
            {
                g[i][j] = 0;
            }
        }

        vector <int> p(n);
        for (int i = 0; i < n; ++i)
        {
            p[i] = rnd() % 4;
            g[p[i] % 2][p[i] / 2]++;
        }

        long long st = Stupid();
        long long sm = Calc();
        if (st != sm)
        {
            for (int i = 0; i < 2; ++i)
            {
                for (int j = 0; j < 2; ++j)
                {
                    cout << g[i][j] << ' ';
                }
                cout << '\n';
            }
            cout << "STUPID : " << st << '\n';
            cout << "SMART : " << sm << '\n';
            break;
        }
    }
*/
    return 0;
}
