#include <bits/stdc++.h>

#define all(a) begin(a), end(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

int bit(int mask, int pos) {
    return (mask >> pos) & 1;
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll fact[100];
    fact[0] = 1;
    for (ll i = 1; i < 100; ++i)
        fact[i] = fact[i - 1] * i;

    string a_str;
    string b_str;
    string c_str;

    cin >> a_str >> b_str >> c_str;

    reverse(all(a_str));
    reverse(all(b_str));
    reverse(all(c_str));

    int n = a_str.size();

    vector<int> a(n), b(n), c(n);

    for (int i = 0; i < n; ++i) {
        a[i] = a_str[i] - '0';
    }

    for (int i = 0; i < n; ++i) {
        b[i] = b_str[i] - '0';
    }

    for (int i = 0; i < n; ++i) {
        c[i] = c_str[i] - '0';
    }

    int c_cnt[10] = { 0 };
    for (int i = 0; i < n; ++i) {
        c_cnt[c[i]]++;
    }


    ll ans = 0;

    int max_mask = (1  << n);
    for (int mask = 0; mask < max_mask; ++mask) {
        int ones_cnt = __builtin_popcount(mask);
        int tr_cnt = 0;
        bool mask_ok = true;
        int ideal_cnt[10] = { 0 };

        int ones_tr_cnt = 0;

        for (int i = 0; i < n; ++i) {
            ideal_cnt[a[i] + b[i] + bit(mask, i)]++;
            if (a[i] + b[i] + bit(mask, i) >= 10) {
                if (i == n - 1) {
                    mask_ok = false;
                }
                tr_cnt++;
                if (bit(mask, i)) {
                    ones_tr_cnt++;
                }
            }
        }

        if (tr_cnt != ones_cnt || ones_tr_cnt == tr_cnt) {
            mask_ok = false;
        }

        for (int i = 0; i < 10; ++i) {
            if (c_cnt[i] != ideal_cnt[i]) {
                mask_ok = false;
            }
        }

        if (!mask_ok)
            continue;

        ans += fact[n - 2 * ones_cnt] * fact[ones_cnt] * fact[ones_cnt - 1];
    }

    cout << ans;


    return 0;
}
