#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
typedef long long ll;
using namespace std;

int main() {
    int n, m, c;
    cin >> n >> m >> c;
    vector<vector<int>> q;
    for (int i = 0; i < n; ++i) {
        q.push_back({});
        for (int j = 0; j < m; ++j) {
            q[i].push_back(1);
        }
    }
    for (int i = 0; i < n; i += 3) {
        int x = i, y = 0;
        while (x >= 0 && y < m) {
            q[x][y] = 2;
            --x;
            ++y;
        }
        if (i < n - 1) {
            x = i + 1, y = 0;
            while (x >= 0 && y < m) {
                q[x][y] = 2;
                --x;
                ++y;
            }
        }
    }
    for (int i = n - 1; i >= 0; i -= 3) {
        int x = i, y = m - 1;
        while (x < n && y >= 0) {
            q[x][y] = 2;
            ++x;
            --y;
        }
        if (i < n - 1) {
            x = i + 1, y = m - 1;
            while (x < n && y >= 0) {
                q[x][y] = 2;
                ++x;
                --y;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << q[i][j] << ' ';
        }
        cout << '\n';
    }
    return 0;
}