#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <deque>
#include <stack>
#include <unordered_map>
#include <unordered_set>
#include <math.h>
#include <map>
#include <queue>
#include <utility>
#include <cmath>
#include <ctime>
#include <algorithm>
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#define int long long
#define f first
#define s second

/*
vector<vector<int>> gr;
vector<bool> used;
void dfs(int v) {
    used[v] = 1;
    for (auto &u : gr[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}
*/


/*

vector<int> z_func(string s) {
    int n = s.size();
    z[0] = 0;
    int l = 0, r = 1;
    for (int i = 1; i < n; ++i) {
        if (i > r) z[i] = 0;
        else
            z[i] = min(z[i-left], r - i + 1);
        while (i + z[i] < n && z[i+z[i]] == z[i]) {
            ++z[i];
        }
    }
    return z;
}
 */



/*

vector<int> pr_func(string s) {
    int n = s.size();
    pr[0] = 0;
    for (int i = 1; i < n; ++i) {
        int k = pr[i-1];
        while (i + k < n && s[i+k] == s[k]) {
            ++k;
        }
        pr[i] = k + (s[i] == s[k]);
    }
    return pr;
}

 */
using namespace std;


void solve() {
    int n, m; cin >> n >> m;


    vector<vector<int>> sum_h(n, vector<int>(m, 0));
    vector<vector<int>> sum_v(m, vector<int>(n, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (j) sum_h[i][j] = sum_h[i][j-1];
            if (i) sum_v[j][i] = sum_v[j][i-1];
            sum_h[i][j] += m * i + j + 1;
            sum_v[j][i] += m * i + j + 1;
        }

    }
    int ans = 1e18;
    int ans_i = 0;
    char c;
    for (int i = 0; i < n; ++i) {
        int sum1 = 0;
        int sum2 = 0;
        for (int j = 0; j < m; ++j) {
            if (i) sum1 += sum_v[j][i-1];
            sum2 += sum_v[j][n-1];
            if (i) sum2 -= sum_v[j][i-1];
        }
        //out  << "--- " << i + 1 << ' ' << abs(sum1 - sum2) << ' ' << sum1 << ' ' << sum2 << '\n';
        if (abs(sum1 - sum2) < ans) {
            ans = abs(sum1 - sum2);
            ans_i = i  + 1;
            c = 'H';
        }
    }



    for (int j = 0; j < m; ++j) {
        int sum1 = 0;
        int sum2 = 0;
        for (int i = 0; i < n; ++i) {
            if (j) sum1 += sum_h[i][j-1];
            sum2 += sum_h[i][m-1];
            if (j) sum2 -= sum_h[i][j-1];
        }
        //cout << "+++ " << j + 1 << ' ' << abs(sum1 - sum2) << ' ' << sum1 << ' ' << sum2 << '\n';
        if (abs(sum1 - sum2) < ans) {
            ans = abs(sum1 - sum2);
            ans_i = j + 1;
            c = 'V';
        }
    }
    cout << c << ' ' << ans_i << '\n';
}



signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    // srand(time(nullptr));

    int t; cin >> t;
    while (t--) {
        solve();
    }
}


/*

 5
 1 3
 4 7
 1 10
 3 3
 3 5



 */

