#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <deque>
#include <stack>
#include <unordered_map>
#include <unordered_set>
#include <math.h>
#include <map>
#include <queue>
#include <utility>
#include <cmath>
#include <ctime>
#include <algorithm>
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#define int long long
#define f first
#define s second

/*
vector<vector<int>> gr;
vector<bool> used;
void dfs(int v) {
    used[v] = 1;
    for (auto &u : gr[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}
*/


/*

vector<int> z_func(string s) {
    int n = s.size();
    z[0] = 0;
    int l = 0, r = 1;
    for (int i = 1; i < n; ++i) {
        if (i > r) z[i] = 0;
        else
            z[i] = min(z[i-left], r - i + 1);
        while (i + z[i] < n && z[i+z[i]] == z[i]) {
            ++z[i];
        }
    }
    return z;
}
 */



/*

vector<int> pr_func(string s) {
    int n = s.size();
    pr[0] = 0;
    for (int i = 1; i < n; ++i) {
        int k = pr[i-1];
        while (i + k < n && s[i+k] == s[k]) {
            ++k;
        }
        pr[i] = k + (s[i] == s[k]);
    }
    return pr;
}

 */
using namespace std;

int get_v(int j, int n, int m) {
    int sum1 = n * (j) * (j + 1) / 2 + n * (n - 1) / 2 * m * j;
    int sum2 = n * m * (n * m + 1) / 2 - sum1;
    return abs(sum2 - sum1);
}


pair<int, int> bin1(int n, int m) {
    int l = 0, r = m + 2;
    for (int i = 0; i < 100; ++i) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        int sum1 = get_v(m1, n, m);
        int sum2 = get_v(m2, n, m);
        if (sum1 < sum2) {
            r = m2;
        } else {
            l = m1;
        }
    }

    int mn_ans = 1e18;
    int mn_i = 0;
    for (int i = l; i <= r; ++i) {
        int ans = get_v(i, n, m);
        if (ans < mn_ans) {
            mn_ans = ans;
            mn_i = i;
        }
    }
    return {mn_i, mn_ans};
}

int get_h(int i, int n, int m) {
    int sum1 = m * (i) * (m * (i) + 1) / 2;
    int sum2 = m * n * (n * m + 1) / 2 - sum1;
    return abs(sum2 - sum1);
}


pair<int, int> bin2(int n, int m) {
    int l = 0, r = n + 2;
    for (int i = 0; i < 100; ++i) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        int sum1 = get_h(m1, n, m);
        int sum2 = get_h(m2, n, m);
        if (sum1 < sum2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    int mn_ans = 1e18;
    int mn_i = 0;
    for (int i = l; i <= r; ++i) {
        int ans = get_h(i, n, m);
        if (ans < mn_ans) {
            mn_ans = ans;
            mn_i = i;
        }
    }
    return {mn_i, mn_ans};
}















void solve() {
    int n, m;
    cin >> n >> m;
    int sum1, sum2;

    auto p1 = bin1(n, m);
    auto p2 = bin2(n, m);
   // cout << "-------- " << p1.f << ' ' << p1.s << '\n';
   // cout << "++++++++ " << p2.f << ' ' << p2.s << '\n';
    if (p1.s < p2.s) {
        cout << "V " << p1.f + 1 << '\n';
    } else {
        cout << "H " << p2.f + 1 << '\n';

    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    // srand(time(nullptr));

    int t; cin >> t;
    while (t--) {
        solve();
    }
}


/*

 5
 1 3
 4 7
 1 10
 3 3
 3 5



 */

