#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <deque>
#include <stack>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <map>
#include <queue>
#include <utility>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <bitset>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#define int long long
#define f first
#define s second

using namespace std;


vector<vector<int>> v;

map<pair<pair<int, int>, pair<int, int>>, bool> mp;


void rec(int n, int m, int k, int i, int j, bool debil = 0) {
    if (i == n) {
        if (debil == 0) {
            for (auto &x : v) {
                for (auto &y : x) {
                    cout << y << ' ';
                }
                cout << '\n';
            }
        } else {
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    cout << v[i][j] << ' ';
                }
                cout << '\n';
            }
        }
        exit(0);
    }


    for (int c = 1; c <= k; ++c) {
        bool check = 1;
        for (int j1 = 0; j1 < j; ++j1) {
            if (mp[{{j1, v[i][j1]},
                    {j,  c}}] == 1) {
                check = 0;
            }
        }
        if (check) {
            v[i][j] = c;

            for (int j1 = 0; j1 < j; ++j1) {
                mp[{{j1, v[i][j1]},
                    {j,  v[i][j]}}] = 1;
            }

            rec(n, m, c, i + (j == m - 1), (j + 1) % m);


            for (int j1 = 0; j1 < j; ++j1) {
                mp[{{j1, v[i][j1]},
                    {j,  v[i][j]}}] = 0;
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    v.resize(min(n, m), vector<int>(max(n, m), 0));
    rec(min(n, m), max(n, m), k, 0, 0, n > m);
}