#include <bits/stdc++.h>

#define pb push_back
#define int long long
using namespace std;
const int N = 200009;
set<int> g[N];
vector<int> euler;

void dfs(int v, int par = -1) {
    if (par != -1) {
        g[par].erase(v);
    }
    while (!g[v].empty()) {
        int u = *g[v].begin();
        dfs(u, v);
    }
    euler.pb(v);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> S(n);
    vector<vector<int>> P(n);
    bool all1 = true;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m >> S[i];
        all1 &= (m <= 1);
        while (m--) {
            int x;
            cin >> x;
            P[i].pb(x);
        }
    }
    if (all1) {
        if (n == 1) {
            cout << "Yes\n1\n";
            exit(0);
        }
        vector<int> p(n), d(n);
        for (int i = 0; i < n; i++) {
            p[i] = P[i][0];
            d[i] = S[i] - p[i];
        }
        vector<int> perm;
        for (int x = 0; x < n; x++) perm.pb(x);
        for (int _ = 0; _ < 5040 * 8; _++) {
            next_permutation(perm.begin(), perm.end());
            int num = p[perm[1]] + d[perm[0]];
            for (int i = 2; i < n; i++) {
                if (num != p[perm[i]] + d[perm[i - 1]]) {
                    num = -1;
                    break;
                }
            }
            if (num != -1) {
                cout << "Yes\n";
                for (auto x : perm) cout << x + 1 << ' ';
                cout << '\n';
                exit(0);
            }
        }
        cout << "No\n";
        exit(0);
    } else {
        int d1 = 1e18, d2 = -1e18;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < (int) P[i].size() - 1; j++) {
                d1 = min(d1, P[i][j + 1] - P[i][j]);
                d2 = max(d2, P[i][j + 1] - P[i][j]);
            }
        }
        if (d1 != d2) {
            cout << "No\n";
            exit(0);
        }
        if (n == 1) {
            cout << "Yes\n";
            cout << "1\n";
        }
        int d = d1;
        vector<int> L(n), R(n);
        for (int i = 0; i < n; i++) {
            L[i] = P[i][0];
            R[i] = S[i] - P[i].back();
        }
        for (int i = 0; i < n; i++) {
            R[i] = d - R[i];
        }
        vector<int> compress;
        for (int i = 0; i < n; i++) {
            compress.pb(L[i]);
            compress.pb(R[i]);
        }
        sort(compress.begin(), compress.end());
        for (int i = 0; i < n; i++) {
            L[i] = (int) (lower_bound(compress.begin(), compress.end(), L[i]) - compress.begin());
            R[i] = (int) (lower_bound(compress.begin(), compress.end(), R[i]) - compress.begin());
        }
        vector<int> kek(2 * n + 1);
        for (int i = 0; i < n; i++) {
            g[R[i]].insert(L[i]);
            kek[R[i]]++;
            kek[L[i]]++;
            // cout << L[i] << ' ' << R[i] << '\n';
        }
        vector<int> odd;
        for (int i = 0; i < 2 * n; i++) {
            if (kek[i] % 2) {
                odd.pb(i);
            }
        }
        if (odd.size() != 2) {
            cout << "No\n";
            exit(0);
        }
        if (g[odd[0]].size() > kek[odd[0]] / 2) {
            g[odd[1]].insert(odd[0]);
            swap(odd[0], odd[1]);
        } else {
            g[odd[0]].insert(odd[1]);
        }
        // cout << "fake " << compress[odd[0]] << ' ' << compress[odd[1]] << '\n';
        dfs(0);
        euler.pop_back();
        int kz = (int) euler.size();
        for (int i = 0; i < kz; i++) {
            euler.pb(euler[i]);
        }
        vector<int> euler2;
        for (int i = 0; i < (int) euler.size() - 1; i++) {
            if (euler[i] == odd[0] && euler[i + 1] == odd[1]) {
                for (int j = i + 1; j <= i + kz; j++) {
                    euler2.pb(euler[j]);
                }
                break;
            }
        }
        euler = euler2;
        cout << "Yes\n";
        map<pair<int, int>, int> ans;
        for (int i = 0; i < (int) euler.size() - 1; i++) {
            ans[{euler[i + 1], euler[i]}] = i;
        }
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            p[i] = ans[{L[i], R[i]}];
        }
        for (int i = n - 1; i >= 0; i--) {
            cout << 1 + p[p[i]] << ' ';
        }
        cout << '\n';
    }

}
