#include <bits/stdc++.h>

#define pb push_back
#define int long long
using namespace std;
const int N = 200009;
multiset<int> g[N];
vector<int> euler;

void dfs(int v, int par = -1) {
    if (par != -1) {
        g[par].erase(g[par].find(v));
    }
    while (!g[v].empty()) {
        int u = *g[v].begin();
        dfs(u, v);
    }
    euler.pb(v);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> S(n);
    vector<vector<int>> P(n);
    bool all1 = true;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m >> S[i];
        all1 &= (m <= 1);
        while (m--) {
            int x;
            cin >> x;
            P[i].pb(x);
        }
    }
    if (all1) {
        if (n == 1) {
            cout << "Yes\n1\n";
            exit(0);
        }
        vector<int> p(n), d(n);
        for (int i = 0; i < n; i++) {
            p[i] = P[i][0];
            d[i] = S[i] - p[i];
        }
        vector<int> perm;
        for (int x = 0; x < n; x++) perm.pb(x);
        for (int _ = 0; _ < 5040 * 8; _++) {
            next_permutation(perm.begin(), perm.end());
            int num = p[perm[1]] + d[perm[0]];
            for (int i = 2; i < n; i++) {
                if (num != p[perm[i]] + d[perm[i - 1]]) {
                    num = -1;
                    break;
                }
            }
            if (num != -1) {
                cout << "Yes\n";
                for (auto x : perm) cout << x + 1 << ' ';
                cout << '\n';
                exit(0);
            }
        }
        cout << "No\n";
        exit(0);
    } else {
        int d1 = 1e18, d2 = -1e18;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < (int) P[i].size() - 1; j++) {
                d1 = min(d1, P[i][j + 1] - P[i][j]);
                d2 = max(d2, P[i][j + 1] - P[i][j]);
            }
        }
        if (d1 != d2) {
            cout << "No\n";
            exit(0);
        }
        if (n == 1) {
            cout << "Yes\n";
            cout << "1\n";
            exit(0);
        }
        int d = d1;
        vector<int> L(n), R(n);
        for (int i = 0; i < n; i++) {
            L[i] = P[i][0];
            R[i] = S[i] - P[i].back();
        }
        vector<int> perm;
        for (int x = 0; x < n; x++) perm.pb(x);
        for (int _ = 0; _ < 5040 * 8; _++) {
            next_permutation(perm.begin(), perm.end());
            int num = 777;
            for (int i = 1; i < n; i++) {
                if (L[perm[i]] != d-R[perm[i-1]]) {
                    num = -1;
                    break;
                }
            }
            if (num != -1) {
                cout << "Yes\n";
                for (auto x : perm) cout << x + 1 << ' ';
                cout << '\n';
                exit(0);
            }
        }
        cout << "No\n";
        exit(0);
    }

}
