#include <bits/stdc++.h>

#define pb push_back
#define int long long
using namespace std;
int cnt[4];
int zero[4];
const int N = 200009;
const int M = 1000000007;
int fact[N];
int inv_fact[N];

int binpow(int a, int x) {
    int ans = 1;
    while (x) {
        if (x % 2) {
            ans *= a;
            ans %= M;
        }
        a *= a;
        a %= M;
        x /= 2;
    }
    return ans;
}

int C(int k, int n) {
    if (n < 0 || k > n) return 0;
    return ((fact[n] * inv_fact[k]) % M * inv_fact[n - k]) % M;
}

int roflan(int sh, int per) {
    if (sh == 0 && per == 0) {
        return 1;
    }
    return C(per - 1, sh + per - 1);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    fact[0] = 1;
    inv_fact[0] = 1;
    for (int x = 1; x < N; x++) {
        fact[x] = (x * fact[x - 1]) % M;
        inv_fact[x] = binpow(fact[x], M - 2);
    }
    string a, b, c;
    cin >> a >> b >> c;
    int n = (int) a.size();
    for (int i = 0; i < n; i++) {
        int a0 = a[i] - '0';
        int b0 = b[i] - '0';
        int c0 = c[i] - '0';
        if ((a0 + b0) % 10 == c0) {
            if (a0 + b0 < 10) {
                cnt[0]++;
                if (!a0 || !b0 || !c0) {
                    zero[0]++;
                }
            } else {
                cnt[1]++;
                if (!a0 || !b0 || !c0) {
                    zero[1]++;
                }
            }
        } else if ((a0 + b0 + 1) % 10 == c0) {
            if (a0 + b0 + 1 < 10) {
                cnt[2]++;
                if (!a0 || !b0 || !c0) {
                    zero[2]++;
                }
            } else {
                cnt[3]++;
                if (!a0 || !b0 || !c0) {
                    zero[3]++;
                }
            }
        } else {
            cout << "0\n";
            exit(0);
        }
    }
    if ((cnt[1] < cnt[2]) || (cnt[1] > cnt[2] + 1)) {
        cout << "0\n";
        exit(0);
    }

    if (cnt[1] == 0) {
        if (cnt[2] || cnt[3]) {
            cout << "0\n";
        } else {
            cout << fact[n - 1] * (n - zero[0]) % M << '\n';
        }
        exit(0);
    }

    int ans = 1;
    ans *= C(cnt[0], cnt[0] + cnt[1]);
    ans %= M;

    ans *= roflan(cnt[3], cnt[1]);
    ans %= M;

    for (auto x : cnt) {
        ans *= fact[x];
        ans %= M;
    }

    int ans2 = zero[0];

    if (cnt[0]) {
        cnt[0]--;
        ans2 *= C(cnt[0], cnt[0] + cnt[1]);
        ans2 %= M;

        ans2 *= roflan(cnt[3], cnt[1]);
        ans2 %= M;

        for (auto x : cnt) {
            ans2 *= fact[x];
            ans2 %= M;
        }

        cnt[0]++;
    }

    int ans3 = 1;
    if (cnt[1] == cnt[2]) {
        ans3 = zero[2];
        ans3 *= cnt[1];
        ans3 %= M;

        cnt[1]--;
        cnt[2]--;

        ans3 *= C(cnt[0], cnt[0] + cnt[1]);
        ans3 %= M;

        ans3 *= roflan(cnt[3], cnt[1]);
        ans3 %= M;
        for (auto x : cnt) {
            ans3 *= fact[x];
            ans3 %= M;
        }

        cnt[1]++;
        cnt[2]++;
    } else {
        ans3 = zero[1];
        cnt[1]--;
        ans3 *= C(cnt[0], cnt[0] + cnt[1]);
        ans3 %= M;

        ans3 *= roflan(cnt[3], cnt[1]);
        ans3 %= M;

        for (auto x : cnt) {
            ans3 *= fact[x];
            ans3 %= M;
        }

        cnt[1]++;
    }

    ans += (M - ans2);
    ans %= M;
    ans += (M - ans3);
    ans %= M;

    cout << ans << '\n';

}
