#include <bits/stdc++.h>

#define endl "\n"


using namespace std;


void setup() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #else
    ios::sync_with_stdio(0);
    cin.tie(0);
    #endif
}
vector<int> x, y, z;
int n;
long long total = 0;

void dfs(int ind, bool ls, vector<bool>& visited) {
    if (ind == n) {
        total++;
        return;
    }
    for (int i = 0; i < n; i++) {
        if (!visited[i]) {
            if (ls) {
                if ((x[i] + y[i] + 1) % 10 != z[i]){
                    continue;
                }
            }
            if (ind == n - 1 && (z[i] == 0 || y[i] == 0 || x[i] == 0)) {
                continue;
            }
            if (!ls && (x[i] + y[i]) % 10 != z[i]) {
                continue;
            }
            visited[i] = true;
            if (x[i] + y[i] > 9) {
                if (ind != n - 1)
                    dfs(ind + 1, true, visited);
            } else {
                dfs(ind + 1, false, visited);
            }
            visited[i] = false;
        }
    }
}


int main()
{
    setup();
    string a, b, c;
    cin >> a >> b >> c;
    n = a.size();
    x.resize(n); y.resize(n); z.resize(n);
    for (int i = 0; i < n; i++) {
        x[i] = a[i] - 48;
        y[i] = b[i] - 48;
        z[i] = c[i] - 48;
        if ((x[i] + y[i] + 1) % 10 != z[i] && (x[i] + y[i]) % 10 != z[i]) {
            cout << 0 << endl;
            return 0;
        }
    }
    vector<bool> visited(n);
    dfs(0, false, visited);
    cout << total << endl;
}
