#include <bits/stdc++.h>

using namespace std;

#define int long long
#define f first
#define s second
#define ld lond double
#define pii pair<int, int>
#define all(a) (a.begin(), a.end())
#define forn(i, n) for (int i = 0; i < n; i++)
#define coutall(a) for (auto i : a) cout << i << " "; cout << "\n";

const long double EPS = 0.0000001;
const int MOD = 1e9 + 7;
const long long INF = 1e18;
const int MAXPOWER = 63;
const long long MAXVALUE = 9223372036854775807LL;
const int MAXN = 2e5;

int binpow(int a, int n) {
    if (n == 1)
        return a;
    if (n % 2 == 0) {
        int x = binpow(a, n / 2);
        return x * x;
    }
    return binpow(a, n - 1) * a;
}

void speed_up() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(8);
}

int sum(int x) {
    return x * (x + 1) / 2;
}

int n, m;
pii ans1, ans2;

int hor (int w) {
    return sum(w) * n + sum(n - 1) * m * w;
}

int vert (int h) {
    return sum(h * m);
}

pii solve() {
    pii zn1, zn2;
    int l = 1, r = m + 1;
    if (m != 1) {
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (hor(m) - hor(mid) * 2 < 0)
                r = mid;
            else
                l = mid;
        }
        int d1 = abs(hor(m) - hor(l) * 2), d2 = abs(hor(m) - hor(l + 1) * 2);
        if (d1 <= d2)
            zn1 = {d1, l};
        else
            zn1 = {d2, l + 1};
    } else {
        zn1 = {INF, 0};
    }
    l = 1, r = n + 1;
    if (n != 1) {
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (vert(n) - vert(mid) * 2 < 0)
                r = mid;
            else
                l = mid;
        }
        int d1 = abs(vert(n) - vert(l) * 2), d2 = abs(vert(n) - vert(l + 1) * 2);
        if (d1 <= d2)
            zn2 = {d1, l};
        else
            zn2 = {d2, l + 1};
    } else {
        zn2 = {INF, 0};
    }

    if (zn1.f <= zn2.f)
        return {1, zn1.s + 1};
    else
        return {2, zn2.s + 1};
}

pii check() {
    int mx = sum(n * m);
    pii ans = {0, INF};
    int v = 0, h = 0, mn = INF;
    if (m != 1) {
        for (int i = 1; i <= m - 1; i++) {
            for (int j = 1; j <= n; j++) {
                v += (j - 1) * m + i;
            }
            if (abs(mx - v * 2) < mn) {
                ans = {1, i + 1};
                mn = abs(mx - v * 2);
            }
        }
    }
    if (n != 1) {
        for (int i = 1; i <= n - 1; i++) {
            for (int j = 1; j <= m; j++) {
                h += (i - 1) * m + j;
            }
            if (abs(mx - h * 2) < mn) {
                ans = {2, i + 1};
                mn = abs(mx - h * 2);
            }
        }
    }
    return ans;
}

signed main() {
    speed_up();
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        pii zn1, zn2;
        int l = 1, r = m + 1;
        if (m != 1) {
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if (hor(m) - hor(mid) * 2 < 0)
                    r = mid;
                else
                    l = mid;
            }
            int d1 = abs(hor(m) - hor(l) * 2), d2 = abs(hor(m) - hor(l + 1) * 2);
            if (d1 <= d2)
                zn1 = {d1, l};
            else
                zn1 = {d2, l + 1};
        } else {
            zn1 = {INF, 0};
        }
        l = 1, r = n + 1;
        if (n != 1) {
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if (vert(n) - vert(mid) * 2 < 0)
                    r = mid;
                else
                    l = mid;
            }
            int d1 = abs(vert(n) - vert(l) * 2), d2 = abs(vert(n) - vert(l + 1) * 2);
            if (d1 <= d2)
                zn2 = {d1, l};
            else
                zn2 = {d2, l + 1};
        } else {
            zn2 = {INF, 0};
        }
        if (zn1.f <= zn2.f)
            cout << "V " << zn1.s + 1 << "\n";
        else
            cout << "H " << zn2.s + 1 << "\n";
    }
}
