
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define f first
#define s second
#define ld lond double
#define pii pair<int, int>
#define all(a) (a.begin(), a.end())
#define forn(i, n) for (int i = 0; i < n; i++)
#define coutall(a) for (auto i : a) cout << i << " "; cout << "\n";

const long double EPS = 0.0000001;
const int MOD = 1e9 + 7;
const long long INF = 1e18;
const int MAXPOWER = 63;
const long long MAXVALUE = 9223372036854775807LL;
const int MAXN = 2e5;

int binpow(int a, int n) {
    if (n == 1)
        return a;
    if (n % 2 == 0) {
        int x = binpow(a, n / 2);
        return x * x;
    }
    return binpow(a, n - 1) * a;
}

void speed_up() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(8);
}

string s;
int n;
map<char, bool> mp;
vector <int> nxts;
vector <int> pref;

void solve_min() {
    cout << "2 ";
    for (int i = 0; i < n - 4; i++) {
        if (mp[s[i]] && !mp[s[i + 1]] && !mp[s[i + 2]] && mp[s[i + 3]] && s[nxts[i + 4]] == s[i + 1]) {
            cout << pref[i + 2];
            return;
        }
    }
    for (int i = 0; i < n - 3; i++) {
        if (!mp[s[i]] && !mp[s[i + 1]] && mp[s[i + 2]] && s[i] == s[nxts[i + 3]]) {
            cout << pref[i + 1];
            return;
        }
    }
    for (int i = 0; i < n - 3; i++) {
        if (mp[s[i]] && !mp[s[i + 1]] && !mp[s[i + 2]] && !mp[s[i + 3]] && s[i + 1] == s[i + 3]) {
            cout << pref[i + 2];
            return;
        }
    }
    if (mp[s[0]] && !mp[s[1]] && s[0] == '2') {
        cout << pref[1];
        return;
    }
    if (!mp[s[n - 2]] && !mp[s[n - 1]]) {
        cout << pref[n - 1];
        return;
    }
    if (!mp[s[0]]) {
        cout << pref[0];
        return;
    }
    for (int i = 0; i < n - 2; i++) {
        if (!mp[s[i]] && mp[s[i + 1]] && !mp[s[i + 2]] && s[i + 1] == '2') {
            cout << pref[i + 2];
            return;
        }
    }
    for (int i = 0; i < n - 2; i++) {
        if (!mp[s[i]] && !mp[s[i + 1]]) {
            cout << pref[i + 1];
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        if (s[i] == '1') {
            bool flag = true;
            for (int j = i + 1; j < nxts[i]; j++)
                flag = flag & (s[j] == '0');
            if (flag) {
                cout << pref[nxts[i]];
                return;
            }
        }
    }
    cout << 1;
}

void solve_max() {
    cout << "1 ";
    if (pref[nxts[0]] >= 4) {
        cout << pref[nxts[0]] / 2 << " ";
        if (s[1] == 'A')
            cout << 'G';
        else
            cout << 'A';
        return;
    }
    for (int i = 0; i < n - 1; i++) {
        if (!mp[s[i]] && mp[s[i + 1]]) {
            if (pref[nxts[s[i + 1]]] - pref[s[i]] >= 4) {
                cout << (pref[nxts[s[i + 1]]] + pref[s[i]]) / 2 << " ";
                if (s[i + 1] == 'A')
                    cout << "G";
                else
                    cout << "A";
                return;
            }
        }
    }
    if (mp[s[0]] && !mp[s[1]]) {
        cout << "1 ";
        if (s[1] == 'A')
            cout << 'G';
        else
            cout << 'A';
        return;
    }
    for (int i = 0; i < n - 1; i++) {
        if (!mp[s[i]] && mp[s[i + 1]]) {
            cout << (pref[nxts[s[i + 1]]] + pref[s[i]]) / 2 << " ";
            if (s[i + 1] == 'A')
                cout << "G";
            else
                cout << "A";
            return;
        }
    }
    cout << pref[n - 1] << " ";
    if (s[n - 1] == 'A')
        cout << "G";
    else
        cout << "A";
    return;
}

signed main() {
    //speed_up();
    while (true) {
    cin >> s;
    n = s.size();
    for (int i = 0; i <= 9; i++) {
        mp['0' + i] = true;
    }
    mp['A'] = false;
    mp['G'] = false;
    mp['C'] = false;
    mp['T'] = false;

    pref.assign(n, 0);
    int ind = 0, cnt = 0;
    int last = -1;
    nxts.resize(n);
    for (int i = n - 1; i >= 0; i--) {
        if (!mp[s[i]])
            last = i;
        nxts[i] = last;
    }
    while (ind < n) {
        if (!mp[s[ind]]) {
            cnt++;
            pref[ind] = cnt;
            ind++;
            continue;
        }
        int c = 1;
        for (int i = nxts[ind] - 1; i >= ind; i--) {
            cnt += (s[i] - '0') * c;
            c *= 10;
        }
        pref[nxts[ind]] = cnt;
        ind = nxts[ind] + 1;
    }

    solve_min();
    cout << "\n";
    solve_max();
    cout << "\n";
    }
}
