#include <bits/stdc++.h>

using namespace std;

#define int long long
#define f first
#define s second
#define ld lond double
#define pii pair<int, int>
#define all(a) (a.begin(), a.end())
#define forn(i, n) for (int i = 0; i < n; i++)
#define coutall(a) for (auto i : a) cout << i << " "; cout << "\n";

const long double EPS = 0.0000001;
const int MOD = 1e9 + 7;
const long long INF = 1e18;
const int MAXPOWER = 63;
const long long MAXVALUE = 9223372036854775807LL;
const int MAXN = 2e5;

int binpow(int a, int n) {
    if (n == 1)
        return a;
    if (n % 2 == 0) {
        int x = binpow(a, n / 2);
        return x * x;
    }
    return binpow(a, n - 1) * a;
}

void speed_up() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(8);
}

vector <int> used;
vector <int> que;
vector <pii> edges;
int n, d;
bool ans = false;
bool fd = false;

void check() {
    int dd;
    dd = edges[que[1]].f + edges[que[0]].s;
    if (fd)
        dd = d;
    bool flag = true;
    for (int i = 0; i < n - 1; i++) {
        flag = flag && (edges[que[i]].s + edges[que[i + 1]].f == dd);
    }
    if (flag)
        ans = true;
}

void tr(int k) {
    if (k == n) {
        check();
        return;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = true;
            que[k] = i;
            tr(k + 1);
            if (ans)
                return;
            used[i] = false;
        }
    }
}

signed main() {
    speed_up();
    cin >> n;
    forn(i, n) {
        int m, s;
        cin >> m >> s;
        if (m == 1) {
            int k;
            cin >> k;
            edges.push_back({k, s - k});
            continue;
        }
        vector <int> ms(m);
        forn(i, m)
            cin >> ms[i];
        if (!fd) {
            d = ms[1] - ms[0];
            fd = true;
        }
        bool flag = true;
        for (int i = 1; i < m; i++) {
            flag = flag && (ms[i] - ms[i - 1] == d);
        }
        if (flag) {
            edges.push_back({ms[0], s - ms[m - 1]});
        } else {
            cout << "No";
            return 0;
        }
    }
    if (n == 1) {
        cout << "Yes\n1";
        return 0;
    }
    used.assign(n, false);
    que.resize(n);
    tr(0);
    if (ans) {
        cout << "Yes\n";
        for (auto i : que) cout << i + 1 << " ";
    } else {
        cout << "No";
    }
    /*for (auto i : edges) {
        cout << i.f << " " << i.s << "\n";
    }*/
}
