#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline bool chkmin(T1 &a, const T2 &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &a, const T2 &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
#define files(FILENAME) read(FILENAME); write(FILENAME)
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define left left228
#define right right228
#define y1 y1228
#define mp make_pair
#define pb push_back
#define y2 y2228
using ll = long long;
using ld = long double;
const string FILENAME = "input";
const int MAXN = 200228;


int n;
vector<int> st[MAXN];
int len[MAXN];
bool was = false;
int target;
int l[MAXN], r[MAXN];
vector<int> g[MAXN];
int in[MAXN];
int k;
int start = -1;
map<int, vector<int> > who[MAXN];
vector<int> order;


void dfs(int u) {
	while (!g[u].empty()) {
		int a = g[u].back();
		g[u].pop_back();
		dfs(a);
		order.pb(u);
	}
}


bool solve(int target) {
	vector<int> vx;
	for (int i = 0; i < n; i++) {
		vx.pb(l[i]);
	}		
	for (int i = 0; i < n; i++) {
		vx.pb(target - r[i]);
	}
	sort(all(vx));
	vx.resize(distance(vx.begin(), unique(all(vx))));
	k = sz(vx);
	for (int i = 0; i < k; i++) {
		g[i].clear();
		in[i] = 0;
	}
	vector<pair<int, int> > st;
	for (int i = 0; i < n; i++) {
		int a = lower_bound(all(vx), l[i]) - vx.begin();
		int b = lower_bound(all(vx), target - r[i]) - vx.begin();
		st.pb(mp(a, b));
		g[a].pb(b);
		in[b]++;
	}
	vector<int> ste;
	for (int i = 0; i < k; i++) {
		if (sz(g[i]) != in[i]) {
			ste.pb(i);
		}
	}
	if (sz(ste) != 2) {
		return false;
	}
	int sa = ste[0];
	int sb = ste[1];
	if (sz(g[sa]) > in[sa]) {
		swap(sa, sb);
	}
	if (sz(g[sa]) != in[sa] - 1 || sz(g[sb]) != in[sb] + 1) {
		return false;
	}
	who[sa][sb].pb(-1);
	g[sa].pb(sb);
	dfs(0);
	if (sz(order) != n + 1) {
		return false;
	}
	cout << "Yes\n";
	reverse(all(order));
	int it = 0;
	for (auto x: st) {
		who[x.first][x.second].pb(it);
		it++;
	}
	vector<int> pres;
	for (int i = 0; i < sz(order); i++) {
		pres.pb(who[order[i]][order[(i + 1) % sz(order)]].back());
		who[order[i]][order[(i + 1) % sz(order)]].pop_back();
	}
	for (int i = 0; i < sz(pres); i++) {
		if (pres[i] == -1) {
			for (int j = i + 1; j < sz(pres); j++) {
				cout << pres[j] + 1 << ' ';
			}
			for (int j = 0; j < i; j++) {
				cout << pres[j] + 1 << ' ';
			}
			cout << '\n';
			break;
		}
	}
	exit(0);
}


int  main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//read(FILENAME);
	cin >> n;
	for (int i = 0; i < n; i++) {
		int m;
		cin >> m >> len[i];
		for (int j = 0; j < m; j++) {
			int pos;
			cin >> pos;
			st[i].pb(pos);
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 1; j < sz(st[i]); j++) {
			if (!was) {
				was = true;
				target = st[i][j] - st[i][j - 1];
			} else {
				if (target != st[i][j] - st[i][j - 1]) {
					cout << "No\n";
					return 0;
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		l[i] = st[i][0];
		r[i] = len[i] - st[i].back();
	}
	if (was) {
		vector<int> vx;
		for (int i = 0; i < n; i++) {
			vx.pb(l[i]);
		}		
		for (int i = 0; i < n; i++) {
			vx.pb(target - r[i]);
		}
		sort(all(vx));
		vx.resize(distance(vx.begin(), unique(all(vx))));
		k = sz(vx);
		for (int i = 0; i < k; i++) {
			g[i].clear();
			in[i] = 0;
		}
		vector<pair<int, int> > st;
		for (int i = 0; i < n; i++) {
			int a = lower_bound(all(vx), l[i]) - vx.begin();
			int b = lower_bound(all(vx), target - r[i]) - vx.begin();
			st.pb(mp(a, b));
			g[a].pb(b);
			in[b]++;
		}
		vector<int> ste;
		for (int i = 0; i < k; i++) {
			if (sz(g[i]) != in[i]) {
				ste.pb(i);
			}
		}
		if (sz(ste) != 2) {
			cout << "No\n";
			return 0;
		}
		int sa = ste[0];
		int sb = ste[1];
		if (sz(g[sa]) > in[sa]) {
			swap(sa, sb);
		}
		if (sz(g[sa]) != in[sa] - 1 || sz(g[sb]) != in[sb] + 1) {
			cout << "No\n";
			return 0;
		}
		who[sa][sb].pb(-1);
		g[sa].pb(sb);
		dfs(0);
		cout << "Yes\n";
		reverse(all(order));
		int it = 0;
		for (auto x: st) {
			who[x.first][x.second].pb(it);
			it++;
		}
		vector<int> pres;
		for (int i = 0; i < sz(order); i++) {
			pres.pb(who[order[i]][order[(i + 1) % sz(order)]].back());
			who[order[i]][order[(i + 1) % sz(order)]].pop_back();
		}
		for (int i = 0; i < sz(pres); i++) {
			if (pres[i] == -1) {
				for (int j = i + 1; j < sz(pres); j++) {
					cout << pres[j] + 1 << ' ';
				}
				for (int j = 0; j < i; j++) {
					cout << pres[j] + 1 << ' ';
				}
				cout << '\n';
				break;
			}
		}
		return 0;
	}
	vector<int> f;
	for (int i = 1; i < n; i++) {
		f.pb(r[0] + l[i]);
		f.pb(l[0] + r[i]);
	}
	f.pb(0);
	sort(all(f));
	f.resize(distance(f.begin(), unique(all(f))));
	for (auto x: f) {
		solve(x);
	}
	cout << "No\n";
	return 0;
}