#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline bool chkmin(T1 &a, const T2 &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &a, const T2 &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
#define files(FILENAME) read(FILENAME); write(FILENAME)
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define left left228
#define right right228
#define y1 y1228
#define mp make_pair
#define pb push_back
#define y2 y2228
using ll = long long;
using ld = long double;
const string FILENAME = "input";


int n, m, c;
int a[11][11];
vector<int> bads[11][4];
vector<pair<int, int> > order;
bool was;


void get(int k) {
	int i = order[k].first, j = order[k].second;
	if (k == n * m) {
		if (was) {
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++) {
					cout << a[j][i] << ' ';
				}
				cout << '\n';
			}
		} else {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					cout << a[i][j] << ' ';
				}
				cout << '\n';
			}
		}
		exit(0);	
	}
	for (int t = 1; t <= c; t++) {
		if (k == 0 && t != 1) {
			break;
		}
		bool bad = false;
		for (auto x: bads[j][t]) {
			if (a[i][x] == t) {
				bad = true;
				break;
			}
		}
		if (!bad) {
			a[i][j] = t;
			for (int f = 0;f < j; f++) {
				if (a[i][f] == t) {
					bads[j][t].pb(f);
				}
			}
			get(k + 1);
			for (int f = 0;f < j; f++) {
				if (a[i][f] == t) {
					bads[j][t].pop_back();
				}
			}
		}
	}
}



bool comp(pair<int, int> a, pair<int, int> b) {
	int ca = max(a.first, a.second);
	int cb = max(b.first, b.second);
	if (ca != cb) {
		return ca < cb;
	}
	return a < b;
}

int  main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//read(FILENAME);
	cin >> n >> m >> c;
	
	vector<vector<int> > res = {
	{1,1,1,1,1,2,2,3,3},
	{1,2,2,2,3,3,3,1,3},
	{1,2,3,3,2,2,3,3,1},
	{1,3,2,3,2,1,1,2,3},
	{2,1,3,2,3,2,1,2,1},
	{2,3,2,1,3,1,2,3,1},
	{2,3,3,1,2,3,1,1,2},
	{3,1,3,2,2,1,2,1,3},
	{3,2,1,3,3,1,2,2,2}
	};
	if (max(n, m) <= 9 && c == 3) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << res[i][j] << ' ';
			}
			cout << '\n'; 
		}
		return 0;
	}
	if (n > m) {  
		swap(n, m);
		was = true;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			order.pb(mp(i, j));
		}
	}
	sort(all(order), comp);
	get(0);
	return 0;
}
