#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> solve1(vector<int> len, vector<vector<int> > a)
{
    vector<int> p(len.size());
    iota(p.begin(), p.end(), 0);
    while (1)
    {
        vector<int> positions;
        int L = 0;
        for (int i = 0; i < len.size(); i++)
        {
            for (auto e : a[p[i]])
                positions.push_back(e + L);
            L += len[p[i]];
        }
        int t = 1;
        for (int i = 0; i + 2 < positions.size(); i++)
        {
            if (positions[i + 2] - positions[i + 1] != positions[i + 1] - positions[i])
                t = 0;
        }
        if (t)
            return p;
        if (!next_permutation(p.begin(), p.end()))
            break;
    }
    return {};
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> len(n);
    vector<vector<int> > a(n);
    for (int i = 0; i < n; i++)
    {
        int m;
        cin >> m >> len[i];
        a[i] = vector<int>(m);
        for (int j = 0; j < m; j++)
        {
            cin >> a[i][j];
        }
    }
    vector<int> ans = solve1(len, a);
    if (ans.size() == 0)
        cout << "No\n";
    else
    {
        cout << "Yes\n";
        for (auto e : ans)
            cout << e + 1 << " ";
    }
}
