#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const long long MOD = 1e9 + 7;
const int N = 500000;

long long fact[N];
long long ifact[N];
long long rev[N];

long long cnk(long long n, long long k)
{
    if (k == 0) return 1;
    long long ans = fact[n];
    ans = ans * ifact[k] % MOD;
    ans = ans * ifact[n - k] % MOD;
    return ans;
}

int main()
{
    ifact[0] = fact[0] = 1;
    rev[1] = 1;
    for (int i = 2; i < N; i++) rev[i] = MOD - rev[MOD % i] * (MOD / i) % MOD;
    for (int i = 1; i < N; i++) fact[i] = fact[i - 1] * i % MOD;
    for (int i = 1; i < N; i++) ifact[i] = ifact[i - 1] * rev[i] % MOD;

    string a, b, c;
    cin >> a >> b >> c;
    vector<int> items;
    int n = a.size();
    for (int i = 0; i < n; i++)
    {
        int kek = 0;
        int x = a[i] - '0';
        int y = b[i] - '0';
        int z = c[i] - '0';
        //if (x == 0 || y == 0 || z == 0) kek += 4;
        int need = 0;
        if ((x + y) % 10 == z) ;
        else if ((x + y + 1) % 10 == z) need = 1;
        else cout << 0, exit(0);
        if (need) kek += 1;
        if (x + y + need >= 10) kek += 2;
        if ((kek & 6) == 6) cout << 0, exit(0);
        items.push_back(kek);
    }
    int cnt_out = 0, cnt_in = 0;
    for (int i = 0; i < n; i++)
    {
        if (items[i] == 2) cnt_out++;
        if (items[i] == 1) cnt_in++;
    }
    if (cnt_in != cnt_out) cout << 0, exit(0);
    int k = cnt_in;
    int stable = 0;
    for (int i = 0; i < n; i++) if (items[i] == 0) stable++;
    int chain = 0;
    for (int i = 0; i < n; i++) if (items[i] == 3) chain++;

    if (chain > 0 && k == 0) cout << 0, exit(0);

    while ((double)clock() / CLOCKS_PER_SEC < 0.1) ;
    //cout << stable << " " << k << " " << chain << endl;
    long long result = cnk(stable + k, k);
    //cout << result << endl;
    result = result * cnk(chain + k - 1, chain);
    //cout << result << endl;
    result = result * fact[k] % MOD;
    result = result * fact[k] % MOD;
    result = result * fact[chain] % MOD;
    result = result * fact[stable] % MOD;
    cout << result << endl;
}










