#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const long long MOD = 1e9 + 7;
const int N = 500000;

long long fact[N];
long long ifact[N];
long long rev[N];

long long cnk(long long n, long long k)
{
    if (k == 0) return 1;
    long long ans = fact[n];
    ans = ans * ifact[k] % MOD;
    ans = ans * ifact[n - k] % MOD;
    return ans;
}

int naive(string a, string b, string c)
{
    int n = a.size();
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    int ans = 0;
    while (1)
    {
        string A(n, '.'), B(n, '.'), C(n, '.');
        for (int i = 0; i < n; i++)
        {
            A[p[i]] = a[i];
            B[p[i]] = b[i];
            C[p[i]] = c[i];
        }
        int fl = 0, t = 1;
        for (int i = n - 1; i >= 0; i--)
        {
            int x = A[i] - '0';
            int y = B[i] - '0';
            int z = C[i] - '0';
            int nfl = (x + y + fl) / 10;
            if ((x + y + fl) % 10 != z)
                t = 0;
            fl = nfl;
        }
        if (fl != 0)
            t = 0;
        if (A[0] == '0' || B[0] == '0' || C[0] == '0')
            t = 0;
        ans += t;
        if (!next_permutation(p.begin(), p.end()))
        {
            return ans;
        }
    }
}

int solve(string a, string b, string c)
{
    vector<int> items;
    int n = a.size();
    for (int i = 0; i < n; i++)
    {
        int kek = 0;
        int x = a[i] - '0';
        int y = b[i] - '0';
        int z = c[i] - '0';

        if (x == 0 || y == 0 || z == 0) kek += 4;

        int need = 0;
        if ((x + y) % 10 == z) ;
        else if ((x + y + 1) % 10 == z) need = 1;
        else return 0;
        if (need) kek += 1;
        if (x + y + need >= 10) kek += 2;
        //if ((kek & 6) == 6) return 0;
        items.push_back(kek);
    }
    int cnt_out = 0, cnt_in = 0;
    int type01_zeroes = 0, type01 = 0;
    int type00_zeroes = 0, type00 = 0;
    for (int i = 0; i < n; i++)
    {
        if (items[i] % 4 == 2) cnt_out++;
        if (items[i] % 4 == 1) cnt_in++;
        if (items[i] == 4) type00++, type00_zeroes++;
        if (items[i] == 0) type00++;
        if (items[i] == 5) type01++, type01_zeroes++;
        if (items[i] == 1) type01++;
    }
    if (cnt_in != cnt_out) return 0;
    int k = cnt_in;
    int stable = 0;
    for (int i = 0; i < n; i++) if (items[i] % 4 == 0) stable++;
    int chain = 0;
    for (int i = 0; i < n; i++) if (items[i] % 4 == 3) chain++;

    //cout << chain << " " << k << endl;

    if (chain > 0 && k == 0) return 0;

    //cout << stable << " " << k << " " << chain << endl;
    long long result = 0;
    //cout << stable << " " << k << " " << chain << endl;
    if (stable > 0)
    { // place "stable" as a first element
        long long res = cnk(k + stable - 1, k);
        res = res * cnk(chain + k - 1, chain) % MOD;
        res = res * fact[chain] % MOD;
        res = res * fact[k] % MOD;
        res = res * fact[k] % MOD;
        res = res * fact[stable] % MOD;
        res = res * (type00 - type00_zeroes) % MOD;
        res = res * rev[type00] % MOD;
        result = (result + res) % MOD;
    }
    if (k > 0)
    { // place "chain_end" as a first element
        long long res = cnk(k + stable - 1, k - 1);
        res = res * cnk(chain + k - 1, chain) % MOD;
        res = res * fact[chain] % MOD;
        res = res * fact[k] % MOD;
        res = res * fact[k] % MOD;
        res = res * fact[stable] % MOD;
        res = res * (type01 - type01_zeroes) % MOD;
        res = res * rev[type01] % MOD;
        result = (result + res) % MOD;
    }
    return result;
}

int main()
{
    ifact[0] = fact[0] = 1;
    rev[1] = 1;
    for (int i = 2; i < N; i++) rev[i] = MOD - rev[MOD % i] * (MOD / i) % MOD;
    for (int i = 1; i < N; i++) fact[i] = fact[i - 1] * i % MOD;
    for (int i = 1; i < N; i++) ifact[i] = ifact[i - 1] * rev[i] % MOD;

    string a, b, c;
    cin >> a >> b >> c;
    cout << solve(a, b, c);
    return 0;

    for (int _ = 0; ; _++)
    {
        if (_ % 10000 == 0)
            cout << _ << endl;
        //cout << "SE" << endl;
        int nn = 6;
        a = string(nn, '0');
        b = string(nn, '0');
        c = string(nn, '0');
        for (int i = 0; i < nn; i++)
        {
            a[i] = rand() % 10 + '0';
            b[i] = rand() % 10 + '0';
            c[i] = rand() % 10 + '0';
        }
        //cin >> a >> b >> c;

        int ans = naive(a, b, c);
        int result = solve(a, b, c);

        if (result != ans)
        {
            cout << a << "\n" << b << "\n" << c << "\n" << ans << "\n" << result << endl;
            return 0;
        }
    }
}










