#include <bits/stdc++.h>

#define ft first
#define sd second
#define pb push_back
#define all(s) s.begin(), s.end()
#define all2(s) s.begin(), s.begin() + n
#define int long long

using namespace std;

const int MAXN = 2e5 + 10;
const int MOD = 1e9 + 7;

array<int, MAXN> a, b, c, fact;

int fastpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int x = fastpow(a, n / 2);
        return x * x % MOD;
    } else {
        return fastpow(a, n - 1) * a % MOD;
    }
}

int fc(int n, int k) {
    return fact[n] * fastpow(fact[k], MOD - 2) % MOD * fastpow(fact[n - k], MOD - 2) % MOD;
}

signed solvefast(string sa, string sb, string sc) {
    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        fact[i] = fact[i - 1] * i;
    }
    int n = sa.size();
    for (int i = 0; i < n; ++i) {
        a[i] = sa[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        b[i] = sb[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        c[i] = sc[i] - '0';
    }
    int t1 = 0, t2 = 0, t3 = 0, t4 = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] == c[i]) {
            t1++;
            continue;
        }
        if (a[i] + b[i] == c[i] + 10) {
            t3++;
            continue;
        }
        if (a[i] + b[i] + 1 == c[i]) {
            t2++;
            continue;
        }
        if (a[i] + b[i] + 1 == c[i] + 10) {
            t4++;
            continue;
        }
        return 0;
    }
    //cout << t1 << ' ' << t2  << ' ' << t3 << ' ' << t4 << endl;
    if (t2 != t3) {
        return 0;
    }
    if (t2 == 0) {
        if (t3 == 0 && t4 == 0) {
            return fact[t1];
        } else {
            return 0;
        }
    }
    if (t3 == 0) {
        if (t4 != 0) {
            return 0;
        }
    }
    int ans1 = fc(t3 + t1, t1);
    int ans2 = fc(t2 - 1 + t4, t4);
    //cout << ans1 << ' ' << ans2 << endl;
    return ans1 * ans2 % MOD * fact[t1]% MOD * fact[t2] % MOD * fact[t3] % MOD * fact[t4] % MOD;
}

tuple<string, string, string> testgen() {
    int n = abs(rand()) % 7 + 2;
    string s1;
    for (int i = 0; i < n; ++i) {
        char c = '1' + abs(rand()) % 9;
        //cout << c << endl;
        s1 += c;
    }
    string s2;
    for (int i = 0; i < n; ++i) {
        s2 += char('1' + abs(rand()) % 9);
    }
    string s3;
    for (int i = 0; i < n; ++i) {
        s3 += char('1' + abs(rand()) % 9);
    }
    //cout << s1 << endl;
    return make_tuple(s1, s2, s3);
}

signed solveslow(string sa, string sb, string sc) {
    int n = sa.size();
    for (int i = 0; i < n; ++i) {
        a[i] = sa[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        b[i] = sb[i] - '0';
    }
    for (int i = 0; i < n; ++i) {
        c[i] = sc[i] - '0';
    }
    vector<int> ind(n);
    for (int i = 0; i < n; ++i) {
        ind[i] = i;
    }
    int ans = 0;
    do {
        int prev = 0;
        bool found = false;
        if (a[ind[0]] == 0 || b[ind[0]] == 0 || c[ind[0]] == 0) continue;
        for (int i = n - 1; i >= 0; --i) {
            if ((a[ind[i]] + b[ind[i]] + prev) % 10 != c[ind[i]]) {
                found = true;
                break;
            }
            prev = (a[ind[i]] + b[ind[i]] + prev) >= 10;
        }
        if (!found && prev == 0) ans++;
    } while(next_permutation(ind.begin(), ind.end()));
    return ans;
}

signed main() {
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    cout << solvefast(s1, s2, s3);
    return 0;
    int i = 0;
    while (true) {
        i++;
        auto t = testgen();
        string sa = get<0>(t);
        string sb = get<1>(t);
        string sc = get<2>(t);
        //cout << sa << ' ' << sb << ' ' << sc << endl;
        //return 0;
        if (solvefast(sa, sb, sc) != solveslow(sa, sb, sc)) {
            cout << "WA " << "(strings: " << sa << ", " << sb << ", " << sc << "; right answer: " << solveslow(sa, sb, sc) << "), your answer: " << solvefast(sa, sb, sc) << endl;
            return 0;
        }
        if (i % 1000 == 0) {
            cout << "OK " << i<< endl;
        }
    }
    return 0;
}

