#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second


struct ant {
    int ln;
    int sz;
    vector<int> pos;
};

int n;
vector<ant> all;


void gen(vector<int> in, map<int, int> mp) {
    if (in.size() == n) {
        int dist = -1;
        int now = 0;
        bool fl = false;
        int pr = 0;
        vector<int> res;
        for (auto x : in) {
            if (all[x].sz == 0) {
                continue;
            }
            if (!fl) {
                for (int j = 0; j < all[x].sz; ++j) {
                    if (j == 0) {
                        res.push_back(now + all[x].pos[j] + pr);
                        now += all[x].pos[j] + pr;
                    } else {
                        res.push_back(now + pr);
                        now += pr;
                    }
                    if (j == all[x].sz - 1) {
                        pr = all[x].ln - all[x].pos[j];
                    } else {
                        pr = all[x].pos[j + 1] - all[x].pos[j];
                    }

                }
            }
        }
        if (res.size() == 1) {
            cout << "Yes\n";
            for (auto x : in) {
                cout << x + 1 << " ";
            }
            cout << "\n";
            exit(0);
        }
        dist = res[1] - res[0];
        for (int i = 0; i < res.size() - 1; ++i) {
            if (res[i + 1] - res[i] != dist) {
                return;
            }
        }
        cout << "Yes\n";
        for (auto x : in) {
            cout << x + 1 << " ";
        }
        exit(0);
    } else {
        for (int i = 0; i < n; ++i) {
            if (!mp[i]) {
                mp[i] = 1;
                in.push_back(i);
                gen(in, mp);
                in.pop_back();
                mp[i] = 0;
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int cnt = 1;
    cin >> n;
    all.resize(n);
    for (int i = 0; i < n; ++i) {
        ant now;
        cin >> now.sz >> now.ln;
        now.pos.resize(now.sz);
        for (int j = 0; j < now.sz; ++j) {
            cin >> now.pos[j];
        }
        all[i] = now;
    }
    map<int, int> mp;
    vector<int> st;
    gen(st, mp);
    cout << "No\n";
    return 0;
}
/*
3
1 7
3
1 8
6
2 8
1 6
*/
