#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct col {
    long long a, b, c;
    col(long long a, long long b, long long c): a(a), b(b), c(c) {};
};

long long P = 1e9 + 7;

signed main() {
    string a, b, c; cin >> a >> b >> c;
    long long n = a.size();
    bool isz = false;
    for (int i = 0; i < n; ++i) {
        if (a[i] == '0') {
            isz = true;
            break;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (b[i] == '0') {
            isz = true;
            break;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (c[i] == '0') {
            isz = true;
            break;
        }
    }
    if (isz) {
        vector<col> t;
        for (long long i = 0; i < n; ++i) {
            t.push_back({a[i] -'0', b[i] -'0', c[i] - '0'});
        }
        vector<long long> stats(n, 0);
        bool psbl = true;
        for (long long i = 0; i < n; ++i) {
            if (t[i].a + t[i].b == t[i].c) {
                stats[i] = 0;
            } else {
                long long r = (t[i].c - t[i].a - t[i].b + 20) % 10;
                if (r < 0 or r > 1) {
                    psbl = false;
                    break;
                } else if (r == 1) {
                    if (t[i].a + t[i].b + 1 >= 10) {
                        stats[i] = 2;
                    } else {
                        stats[i] = -1;
                    }
                } else {
                    stats[i] = 1;
                }
            }
        }
        if (not psbl) {
            cout << 0 << endl;
            return 0;
        }
        long long k = 0, l = 0, m = 0, p = 0;
        long long k1 = 0, l1 = 0, m1 = 0, p1 = 0;
        for (long long i = 0; i < n; ++i) {
            if (stats[i] == 0) {
                k++;
                if (t[i].a == 0 or t[i].b == 0 or t[i].c == 0) {
                    k1++;
                }
            } else if (stats[i] == -1) {
                l++;
                if (t[i].a == 0 or t[i].b == 0 or t[i].c == 0) {
                    l1++;
                }
            } else if (stats[i] == 1) {
                m++;
                if (t[i].a == 0 or t[i].b == 0 or t[i].c == 0) {
                    m1++;
                }
            } else {
                p++;
                if (t[i].a == 0 or t[i].b == 0 or t[i].c == 0) {
                    p1++;
                }
            }
        }
        //cout << k << " " << l << " " << m << " " << p << endl;
        //cout << k1 << " " << l1 << " " << m1 << " " << p1 << endl;
        if (l != m or l == 0 and p > 0) {
            cout << 0 << endl;
            return 0;
        }
        long long ansg = 0;
        long long ans = 1;
        for (long long i = 1; i <= l; ++i) {
            ans *= i;
            ans %= P;
            ans *= i;
            ans %= P;
        }
        for (long long i = 0; i < k - 1; ++i) {
            ans *= (l + i + 1);
            ans %= P;
        }
        for (long long i = 0; i < p; ++i) {
            ans *= (l + i);
            ans %= P;
        }
        ans *= (k - k1);
        ansg += ans;
        ans = 1;
        for (long long i = 1; i < l; ++i) {
            ans *= i;
            ans %= P;
            ans *= i;
            ans %= P;
        }
        ans *= (l - l1);
        ans %= P;
        ans *= l;
        ans %= P;
        for (long long i = 0; i < k; ++i) {
            ans *= (l + i);
            ans %= P;
        }
        for (long long i = 0; i < p; ++i) {
            ans *= (l + i);
            ans %= P;
        }
        ansg += ans;
        cout << ansg << endl;
        return 0;
    }
    vector<col> t;
    for (long long i = 0; i < n; ++i) {
        t.push_back({a[i] -'0', b[i] -'0', c[i] - '0'});
    }
    vector<long long> stats(n, 0);
    bool psbl = true;
    for (long long i = 0; i < n; ++i) {
        if (t[i].a + t[i].b == t[i].c) {
            stats[i] = 0;
        } else {
            long long r = t[i].c - (t[i].a + t[i].b) % 10;
            if (r < 0 or r > 1) {
                psbl = false;
                break;
            } else if (r == 1) {
                if (t[i].a + t[i].b + 1 >= 10) {
                    stats[i] = 2;
                } else {
                    stats[i] = -1;
                }
            } else {
                stats[i] = 1;
            }
        }
    }
    if (not psbl) {
        cout << 0 << endl;
        return 0;
    }
    long long k = 0, l = 0, m = 0, p = 0;
    for (long long i = 0; i < n; ++i) {
        if (stats[i] == 0) {
            k++;
        } else if (stats[i] == -1) {
            l++;
        } else if (stats[i] == 1) {
            m++;
        } else {
            p++;
        }
    }
    //cout << k << " " << l << " " << m << " " << p << endl;
    if (l != m or l == 0 and p > 0) {
        cout << 0 << endl;
        return 0;
    }
    long long ans = 1;
    for (long long i = 1; i <= l; ++i) {
        ans *= i;
        ans %= P;
        ans *= i;
        ans %= P;
    }
    for (long long i = 0; i < k; ++i) {
        ans *= (l + i + 1);
        ans %= P;
    }
    for (long long i = 0; i < p; ++i) {
        ans *= (l + i);
        ans %= P;
    }
    cout << ans << endl;
}