//#include <pch.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <limits.h>

typedef long long ll;
typedef long double ld;

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)x.size()

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t;
	cin >> t;

	for (int _ = 0; _ < t; ++_) {
		ll n, m;
		cin >> n >> m;
		swap(n, m);
		int i_vert = -1, i_hor = -1;
		ll ans_vert = LLONG_MAX, ans_hor = LLONG_MAX;
		ll left = -1, right = n;
		while (right - left > 2) {
			ll m1 = left + (right - left) / 3,
				m2 = right - (right - left) / 3;
			ll sl1 = m1 * n * m * (m - 1) / 2 + m1 * (m1 + 1) / 2 * m;
			ll sr1 = n * m * (n * m + 1) / 2 - sl1;
			ll sl2 = m2 * n * m * (m - 1) / 2 + m2 * (m2 + 1) / 2 * m;
			ll sr2 = n * m * (n * m + 1) / 2 - sl2;
			ll ans1 = abs(sl1 - sr1), ans2 = abs(sl2 - sr2);
			//cout << m1 << ": " << sl1 << " " << sr1 << "\n" << m2 << ": " << sl2 << " " << sr2 << "\n";
			if (ans1 > ans2) {
				left = m1;
			}
			else {
				right = m2;
			}
		}
		for (ll x = left; x <= right; ++x) {
			if (x == -1 || x == n) continue;
			ll sl = x * n * m * (m - 1) / 2 + x * (x + 1) / 2 * m;
			ll sr = n * m * (n * m + 1) / 2 - sl;
			ll ans = abs(sl - sr);
			if (ans < ans_vert) {
				i_vert = x + 1;
				ans_vert = ans;
			}
		}
		left = -1, right = m;
		while (right - left > 2) {
			ll m1 = left + (right - left) / 3,
				m2 = right - (right - left) / 3;
			ll sl1 = n * m1 * (n * m1 + 1) / 2;
			ll sr1 = n * m * (n * m + 1) / 2 - sl1;
			ll sl2 = n * m2 * (n * m2 + 1) / 2;
			ll sr2 = n * m * (n * m + 1) / 2 - sl2;
			ll ans1 = abs(sl1 - sr1), ans2 = abs(sl2 - sr2);
			if (ans1 > ans2) {
				left = m1;
			}
			else {
				right = m2;
			}
		}
		for (ll x = left; x <= right; ++x) {
			if (x == -1 || x == m) continue;
			ll sl = n * x * (n * x + 1) / 2;
			ll sr = n * m * (n * m + 1) / 2 - sl;
			ll ans = abs(sl - sr);
			if (ans < ans_hor) {
				i_hor = x + 1;
				ans_hor = ans;
			}
		}
		if (ans_vert < ans_hor) {
			cout << "V " << i_vert << "\n";
		}
		else {
			cout << "H " << i_hor << "\n";
		}
	}

	return 0;
}