//#include "pch.h"
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <bitset>

typedef long long ll;
typedef long double ld;

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)x.size()

ll x; int k;

string itos(ll i) {
	string ans = "";
	while (i) {
		ans += (char)('0' + (i % 10));
		i /= 10;
	}
	reverse(all(ans));
	return ans;
}

string good() {
	string s = itos(x);
	bool ok = 1;
	for (char i : s)
		if (i > s[0])
			ok = 0;
	string ans = "";
	for (int i = 0; i < sz(s); ++i)
		ans += s[0];
	if (ans >= s)
		return ans;
	for (int i = 0; i < sz(s); ++i)
		++ans[i];
	return ans;
}

string bad() {
	string s = itos(x);
	string all_equal = good();
	string first_is_different = "";
	{
		first_is_different += s[0];
		for (int i = 0; i < sz(s) - 1; ++i)
			first_is_different += s[1];
		if (first_is_different < s) {
			for (int i = 1; i <= sz(s); ++i)
				++first_is_different[i];
		}
	}
	string different_in_centre = "";
	{
		// xxxxcxxxx
		int pos = -1;
		for (int i = 1; i < sz(s); ++i) {
			if (s[i] != s[i - 1]) {
				pos = i;
				break;
			}
		}
		if (pos == -1) {
			different_in_centre = all_equal;
		}
		else {
			for (int i = 0; i <= pos; ++i) {
				different_in_centre += s[i];
			}
			for (int i = pos + 1; i < sz(s); ++i) {
				different_in_centre += s[0];
			}
			if (different_in_centre < s) {
				different_in_centre = all_equal;
			}
		}
		// xxxx(c + 1)xxxxx
		string p = "";
		for (int i = 0; i <= pos; ++i) {
			p += s[i];
		}
		for (int i = pos + 1; i < sz(s); ++i) {
			p += s[0];
		}
		if (p[pos] != '9') {
			++p[pos];
		}
		if (p >= s) {
			different_in_centre = min(different_in_centre, p);
		}
		// xxx(x + 1)xxxxx
		p = "";
		for (int i = 0; i < sz(s); ++i) {
			p += s[0];
		}
		if (s[0] != '9') {
			++p[pos - 1];
		}
		if (p >= s) {
			different_in_centre = min(different_in_centre, p);
		}
	}
	return min(all_equal, min(first_is_different, different_in_centre));
}

string badd() {
	string s = itos(x);
	string ans = good();
	for (int i = 0; i < sz(s); ++i) {
		for (int j = 0; j < 10; ++j) {
			string p = "";
			for (int t = 0; t < i; ++t) {
				p += (char)('0' + j);
			}
			p += s[i];
			for (int t = i + 1; t < sz(s); ++t) {
				p += (char)('0' + j);
			}
			if (p >= s) {
				ans = min(ans, p);
			}
			p = "";
			for (int t = 0; t < i; ++t) {
				p += (char)('0' + j);
			}
			p += (s[i] == '9' ? s[i] : (char)(s[i] + 1));
			for (int t = i + 1; t < sz(s); ++t) {
				p += (char)('0' + j);
			}
			if (p >= s) {
				ans = min(ans, p);
			}
		}
	}
	return ans;
}

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> x >> k;

	if (k) {
		cout << badd();
	}
	else {
		cout << good();
	}

	return 0;
}
