//#include "pch.h"
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <bitset>

typedef long long ll;
typedef long double ld;

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)x.size()

int n, m, c;
vector<int> a(10);
vector<vector<int>> b(10, vector<int>(10, -1));
bool printed = 0;
int pow3 = 1;

void print() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << a[i] % 2 + 1 << " ";
			a[i] >>= 1;
		}
		cout << "\n";
	}
}

void dif_print(int y) {
	for (int i = 0; i <= y; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << b[i][j] + 1 << " ";
		}
		cout << "\n";
	}
}

bool check(int x, int y) {
	int z = (x & y);
	bitset<10> zz = z;
	if (zz.count() > 1)
		return false;
	z = (x | y);
	zz = z;
	if (zz.count() < m - 1)
		return false;
	return true;
}

bool dif_check(int j, int i) {
	for (int i1 = 0; i1 < m; ++i1)
		for (int i2 = i1 + 1; i2 < m; ++i2)
			if (b[j][i1] == b[j][i2] && b[j][i1] == b[i][i1] && b[j][i1] == b[i][i2])
				return false;
	return true;
}

void gen(int i) {
	if (printed) {
		return;
	}
	if (i == n) {
		print();
		printed = 1;
		return;
	}
	for (int mask = 0; mask < (1 << m); ++mask) {
		bool ok = 1;
		for (int j = 0; j < i; ++j) {
			if (!check(a[j], mask)) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			a[i] = mask;
			gen(i + 1);
		}
	}
}

void dif_gen(int i) {
	if (printed) {
		return;
	}
	if (i == n) {
		dif_print(n - 1);
		printed = 1;
		return;
	}
	for (int mask = 0; mask < pow3; ++mask) {
		bool ok = 1;
		int mmask = mask;
		for (int j = 0; j < m; ++j) {
			b[i][j] = mmask % 3;
			mmask /= 3;
		}
		for (int j = 0; j < i; ++j) {
			if (!dif_check(j, i)) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			dif_gen(i + 1);
		}
	}
}

void masks() {
	gen(0);
}

void dif_masks() {
	dif_gen(0);
}

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> m >> c;

	for (int i = 0; i < m; ++i) {
		pow3 *= 3;
	}

	if (c == 2) {
		masks();
	}
	else {
		dif_masks();
	}

	return 0;
}
