#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	int expdist = -1;

	vector< pair<int, int> > a(n);
	for(int i = 0; i < n; i++) {
		int m, s;
		cin >> m >> s;

		vector<int> p(m);
		for(int j = 0; j < m; j++) {
			cin >> p[j];
		}

		if(m >= 2) {
			for(int j = 1; j < m; j++) {
				if(expdist != -1 && expdist != p[j] - p[j - 1]) {
					cout << "No" << endl;
					return 0;
				}
				expdist = p[j] - p[j - 1];
			}
		}

		a[i] = {p[0], s - p[m - 1]};
	}

	if(n == 1) {
		cout << "Yes" << endl << 1 << endl;
		return 0;
	}

	if(expdist != -1) {
		for(int first = 0; first < n; first++) {
			for(int last = 0; last < n; last++) {
				if(first == last) {
					continue;
				}

				map<int, vector<int> > by_left;
				for(int i = 0; i < n; i++) {
					if(i != first && i != last) {
						by_left[a[i].first].push_back(i);
					}
				}

				int space = a[first].second;
				bool ok = true;
				vector<int> order{first};
				for(int i = 0; i < n - 2; i++) {
					int next = expdist - space;
					if(by_left[next].size() > 0) {
						int j = by_left[next].back();
						order.push_back(j);
						space = a[j].second;
						by_left[next].pop_back();
					} else {
						ok = false;
						break;
					}
				}
				int next = expdist - space;
				if(a[last].first == next) {
					order.push_back(last);
				} else {
					ok = false;
				}
				if(ok) {
					cout << "Yes" << endl;
					for(int i: order) {
						cout << i + 1 << " ";
					}
					cout << endl;
					return 0;
				}
			}
		}
		cout << "No" << endl;
		return 0;
	}

	vector<int> order(n);
	for(int i = 0; i < n; i++) {
		order[i] = i;
	}

	do {
		int curexpdist = expdist;
		int space = 0;
		bool had = false;
		bool ok = true;
		for(int i: order) {
			if(had) {
				space += a[i].first;
				if(curexpdist != -1 && curexpdist != space) {
					ok = false;
					break;
				}
				curexpdist = space;
			}
			had = true;
			space = a[i].second;
		}
		if(ok) {
			cout << "Yes" << endl;
			for(int i: order) {
				cout << i + 1 << " ";
			}
			cout << endl;
			return 0;
		}
	} while(next_permutation(order.begin(), order.end()));

	cout << "No" << endl;
	return 0;
}