#include <bits/stdc++.h>

using namespace std;

#define int long long

int n;
int expdist = -1;
vector< pair<int, int> > a;

bool assertfalse;

void gogogo() {
	vector<int> xx;
	for(int i = 0; i < n; i++) {
		xx.push_back(a[i].first);
		xx.push_back(expdist - a[i].second);
	}
	sort(xx.begin(), xx.end());
	xx.erase(unique(xx.begin(), xx.end()), xx.end());
	vector< vector< pair<int, int> > > adj(xx.size());
	vector<int> adjinsz(xx.size());
	for(int i = 0; i < n; i++) {
		int u = lower_bound(xx.begin(), xx.end(), a[i].first) - xx.begin();
		int v = lower_bound(xx.begin(), xx.end(), expdist - a[i].second) - xx.begin();
		adj[u].emplace_back(v, i);
		adjinsz[v]++;
	}
	int from = -1;
	int to = -1;
	for(int i = 0; i < xx.size(); i++) {
		if(adj[i].size() > adjinsz[i]) {
			// More outputs than inputs
			if(adj[i].size() - adjinsz[i] >= 2) {
				cout << "No" << endl;
				exit(0);
			}
			if(from != -1) {
				cout << "No" << endl;
				exit(0);
			}
			from = i;
		}
		if(adj[i].size() < adjinsz[i]) {
			// More inputs than outputs
			if(adjinsz[i] - adj[i].size() >= 2) {
				cout << "No" << endl;
				exit(0);
			}
			if(to != -1) {
				cout << "No" << endl;
				exit(0);
			}
			to = i;
		}
	}

	list<int> order;
	vector<decltype(order.cend())> posof(n);

	/*
	adj.clear();
	xx.clear();
	adj.resize(3);
	adj[0].emplace_back(1, 0);
	adj[1].emplace_back(2, 2);
	adj[1].emplace_back(0, 1);
	adj[2].emplace_back(1, 3);
	xx.resize(3);
	xx.push_back(0);
	xx.push_back(1);
	xx.push_back(2);
	from = 0;
	*/

	int u = from == -1 ? 0 : from;
	auto it = order.cend();
	while(adj[u].size() > 0) {
		auto [v, j] = adj[u].back();
		adj[u].pop_back();
		it = posof[j] = order.insert(it, j);
		++it;
		u = v;
	}

	for(int i: order) {
		int u = lower_bound(xx.begin(), xx.end(), expdist - a[i].second) - xx.begin();
		auto it = posof[i];
		++it;
		while(adj[u].size() > 0) {
			auto [v, j] = adj[u].back();
			adj[u].pop_back();
			it = posof[j] = order.insert(it, j);
			++it;
			u = v;
		}
	}

	cout << "Yes" << endl;
	for(int i: order) {
		cout << i + 1 << " ";
	}
	cout << endl;
	exit(0);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;

	a.resize(n);
	for(int i = 0; i < n; i++) {
		int m, s;
		cin >> m >> s;

		vector<int> p(m);
		for(int j = 0; j < m; j++) {
			cin >> p[j];
		}

		if(m >= 2) {
			for(int j = 1; j < m; j++) {
				if(expdist != -1 && expdist != p[j] - p[j - 1]) {
					cout << "No" << endl;
					return 0;
				}
				expdist = p[j] - p[j - 1];
			}
		}

		a[i] = {p[0], s - p[m - 1]};
	}

	if(n == 1) {
		cout << "Yes" << endl << 1 << endl;
		return 0;
	}

	if(expdist != -1) {
		gogogo();
	}

	vector<int> order(n);
	for(int i = 0; i < n; i++) {
		order[i] = i;
	}

	do {
		int curexpdist = expdist;
		int space = 0;
		bool had = false;
		bool ok = true;
		for(int i: order) {
			if(had) {
				space += a[i].first;
				if(curexpdist != -1 && curexpdist != space) {
					ok = false;
					break;
				}
				curexpdist = space;
			}
			had = true;
			space = a[i].second;
		}
		if(ok) {
			assert(!assertfalse);
			cout << "Yes" << endl;
			for(int i: order) {
				cout << i + 1 << " ";
			}
			cout << endl;
			return 0;
		}
	} while(next_permutation(order.begin(), order.end()));

	cout << "No" << endl;
	return 0;
}