#include <bits/stdc++.h>

#define int long long

using namespace std;

int a[10][10];

int n, m, c;

vector< pair<int, int> > order;

void gen(int pos) {
	if(pos == order.size()) {
		for(int i = 0; i < n; i++) {
			for(int j = 0; j < m; j++) {
				cout << a[i][j] + 1 << " ";
			}
			cout << endl;
		}
		exit(0);
	}

	auto [i, j] = order[pos];

	int forbidden[3];
	forbidden[0] = forbidden[1] = forbidden[2] = 0;
	for(int i1 = 0; i1 < i; i1++) {
		for(int j1 = 0; j1 < j; j1++) {
			if(a[i1][j1] == a[i][j1] && a[i][j1] == a[i1][j]) {
				forbidden[a[i1][j]] = 1;
			}
		}
	}

	for(int x = 0; x < c; x++) {
		if(!forbidden[x]) {
			a[i][j] = x;
			gen(pos + 1);
		}
	}
}

signed main() {
	cin >> n >> m >> c;

	assert(n != 10 || m != 10);

	for(int s = 0; s < n + m - 1; s++) {
		for(int i = 0; i <= s && i < n; i++) {
			int j = s - i;
			if(j < m) {
				order.emplace_back(i, j);
			}
		}
	}

	gen(0);

	return 0;
}