#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	string s(n, '#');
	string carry(n, '#');
	string d(n, '#');
	for(int i = 0; i < n; i++) {
		a[i] -= '0';
		b[i] -= '0';
		c[i] -= '0';
		s[i] = a[i] + b[i];
		carry[i] = (10 + c[i] - s[i]) % 10;
		if(carry[i] > 1) {
			cout << 0 << endl;
			return 0;
		}
		d[i] = s[i] + carry[i] >= 10;
	}

	vector<int> order(n);
	for(int i = 0; i < n; i++) {
		order[i] = i;
	}

	int ans = 0;

	do {
		string c1;
		for(int i: order) {
			c1.push_back(c[i]);
		}

		bool carry = false;
		bool ok = true;
		for(int i = n - 1; i >= 0; i--) {
			int x = s[order[i]] + carry;
			ok = ok && (s[order[i]] + carry - c1[i]) % 10 == 0;
			carry = x >= 10;
		}

		if(!carry && ok && a[order[0]] != 0 && b[order[0]] != 0 && c[order[0]] != 0) {
			ans++;
		}
	} while(next_permutation(order.begin(), order.end()));

	ans %= 1000000007;

	cout << ans << endl;

	return 0;
}



/*
	for(int order0 = 0; order0 < n; order0++) {
		if(a[order0] == 0 || b[order0] == 0 || c[order0] == 0 || carry[order0] != 0) {
			continue;
		}

		vector< pair<bool, bool> > edges(n - 1);
		for(int i = 0; i < n - 1; i++) {
			int j = i < order0 ? i : i + 1;
			edges[i] = {carry[j], d[j]};
		}

		vector<int> order;
		for(int i = 0; i < n - 1; i++) {
			order.push_back(i);
		}

		do {
			bool ok = true;
			for(int i = 0; i < n - 2; i++) {
				ok = ok && edges[order[i]].second == edges[order[i + 1]].first;
			}
			if(d[order0] == edges[order[0]].first && edges[order.back()].second == 0 && ok) {
				ans++;
			}
		} while(next_permutation(order.begin(), order.end()));
	}

*/