#include <bits/stdc++.h>

using namespace std;

#define int long long

int numseparat(int num, int n) {
	if(num == 0 || n == 0) {
		return num == 0;
	}
	int total = 0;
	for(int x = 0; x <= num; x++) {
		total += numseparat(num - x, n - 1);
	}
	return total % 1000000007;
}

signed main() {
	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	string s(n, '#');
	string carry(n, '#');
	string d(n, '#');
	for(int i = 0; i < n; i++) {
		a[i] -= '0';
		b[i] -= '0';
		c[i] -= '0';
		s[i] = a[i] + b[i];
		carry[i] = (10 + c[i] - s[i]) % 10;
		if(carry[i] > 1) {
			cout << 0 << endl;
			return 0;
		}
		d[i] = s[i] + carry[i] >= 10;
	}

	int ans = 0;

	for(int first = 0; first < n; first++) {
		if(!(!d[first] && a[first] != 0 && b[first] != 0 && c[first] != 0)) {
			continue;
		}

		vector< pair<int, int> > edges;
		for(int i = 0; i < n; i++) {
			edges.emplace_back(d[i], carry[i]);
		}

		vector< pair<int, int> > order;
		int cnt_by_type[4];
		memset(cnt_by_type, 0, sizeof(cnt_by_type));
		for(int i = 0; i < n; i++) {
			if(i != first) {
				cnt_by_type[edges[i].first * 2 + edges[i].second]++;
				if(edges[i].first != edges[i].second) {
					order.push_back(edges[i]);
				}
			}
		}
		sort(order.begin(), order.end());

		int localans = 0;

		if(order.size() == 0) {
			localans = carry[first] == 0;
		} else {
			do {
				bool ok = carry[first] == order[0].first;
				for(int i = 0; i < order.size() - 1; i++) {
					ok = ok && order[i].second == order[i + 1].first;
				}
				ok = ok && order.back().second == 0;
				localans += ok;
			} while(next_permutation(order.begin(), order.end()));
		}

		for(int x: cnt_by_type) {
			for(int i = 1; i <= x; i++) {
				localans *= i;
				localans %= 1000000007;
			}
		}

		int to[2];
		to[0] = to[1] = 0;
		to[carry[first]]++;
		for(int i = 0; i < order.size(); i++) {
			to[order[i].second]++;
		}
		int coeff = numseparat(cnt_by_type[0], to[0]) * numseparat(cnt_by_type[3], to[1]) % 1000000007;

		localans *= coeff;
		localans %= 1000000007;

		ans += localans;
	}

	ans %= 1000000007;

	cout << ans << endl;

	return 0;
}