#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define len(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, l, r) for (int i = (l); i < (r); i++)

#ifdef LOCAL
#include "/home/olymp/codes/debug.h"
#else
#define dbg(...)
#endif

map<char, int> toInt{{'A', 0}, {'G', 1}, {'C', 2}, {'T', 3}};
map<int, char> toChar{{0, 'A'}, {1, 'G'}, {2, 'C'}, {3, 'T'}};

struct Res {
	ll sz;
	int type;
	int x;
	int z;

	Res() {}
	Res(ll sz, int type, int x, int z) : sz(sz), type(type), x(x), z(z) {}

	bool operator < (const Res res) const {
		return sz < res.sz;
	}

	bool operator > (const Res res) const {
		return sz > res.sz;
	}

	inline void print() {
		cout << type << ' ' << x;
		if (type != 2) cout << ' ' << toChar[z];
		cout << '\n';
	}
};

inline int getLen(int x) {
	if (x == 0) return -1;
	if (x == 1) return 0;
	return len(to_string(x));
}

void solveMin(vector<pair<ll, int>> t, ll lenAll) {
	Res res(LLONG_MAX, -1, -1, -1);

	// 2
	ll before = 0;
	forn (i, 0, len(t)) {
		auto [cnt, ch] = t[i];
		if (cnt != 1) {
			ll curLen = lenAll;
			curLen -= getLen(t[i].first) + 1;
			curLen += getLen(t[i].first - 1) + 1;
			res = min(res, Res(curLen, 2, before + 1, -1));
		} else {
			if (!i) {
				if (i == len(t) - 1) {
					res = min(res, Res(0, 2, before + 1, -1));
				} else {
					res = min(res, Res(lenAll - getLen(cnt) - 1, 2, before + 1, -1));
				}
			} else if (i == len(t) - 1) {
				assert(i);
				res = min(res, Res(lenAll - getLen(cnt) - 1, 2, before + 1, -1));
			} else {
				int prev = t[i - 1].second;
				int nxt = t[i + 1].second;
				if (prev != nxt) {
					res = min(res, Res(lenAll - getLen(cnt) - 1, 2, before + 1, -1));
				} else { // adsfjkhasljkdfhalsjkdfh maybe it is not correct
					ll curLen = lenAll;
					forn (j, i - 1, i + 2) curLen -= getLen(t[j].first) + 1;
					curLen += getLen(t[i - 1].first + t[i + 1].first) + 1;
					res = min(res, Res(curLen, 2, before + 1, -1));
				}
			}
		}
		before += t[i].first;
	}

	assert(res.sz <= lenAll);
	res.print();
}

// TODO: improve this!
pair<int, int> solve1Max(int cnt) {
	pair<int, int> ans{-1, -1};
	auto relax = [&](int a) {
		int b = cnt - a;
		int cur = getLen(a) + 1 + getLen(b) + 1 + 1;
		ans = max(ans, pair<int, int>{cur, a});
	};

	forn (a, 0, min(cnt, 1000)) relax(a);
	assert(ans.first != -1);
	return ans;
}

void solveMax(vector<pair<ll, int>> t, ll lenAll) {
	Res res(-1, -1, -1, -1);

	// 1
	ll before = 0;
	for (auto [cnt, ch] : t) {
		int prev = getLen(cnt) + 1;
		auto [cur, pos] = solve1Max(cnt);
		assert(cur >= prev);
		res = max(res, Res(lenAll - prev + cur, 1, before + pos, (ch + 1) % 4));
		before += cnt;
	}

	res.print();
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	string s;
	cin >> s;

	vector<pair<ll, int>> t;
	forn (i, 0, len(s)) {
		if ('A' <= s[i] && s[i] <= 'Z') {
			t.emplace_back(1, toInt[s[i]]);
			continue;
		}

		assert(isdigit(s[i]));
		int j = i;
		int x = 0;
		for (; j < len(s) && isdigit(s[j]); j++) {
			x *= 10;
			x += s[j] - '0';
		}
		t.emplace_back(x, toInt[s[j]]);
		i = j;
	}

	forn (i, 1, len(t)) assert(t[i - 1].second != t[i].second);

	ll lenAll = 0;
	for (auto [cnt, ch] : t) {
		lenAll += getLen(cnt) + 1;
	}

	solveMin(t, lenAll);
	solveMax(t, lenAll);	
}
