#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define len(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, l, r) for (int i = (l); i < (r); i++)

#ifdef LOCAL
#include "/home/olymp/codes/debug.h"
#else
#define dbg(...)
#endif

map<pair<int, int>, vector<vector<int>>> prec{
	{pair<int, int>{1, 1}, {{0}}},
	{pair<int, int>{1, 2}, {{0, 0}}},
	{pair<int, int>{2, 1}, {{0}, {0}}},
	{pair<int, int>{1, 3}, {{0, 0, 0}}},
	{pair<int, int>{3, 1}, {{0}, {0}, {0}}},
	{pair<int, int>{1, 4}, {{0, 0, 0, 0}}},
	{pair<int, int>{4, 1}, {{0}, {0}, {0}, {0}}},
	{pair<int, int>{2, 2}, {{1, 0}, {0, 0}}},
	{pair<int, int>{1, 5}, {{0, 0, 0, 0, 0}}},
	{pair<int, int>{5, 1}, {{0}, {0}, {0}, {0}, {0}}},
	{pair<int, int>{6, 1}, {{0}, {0}, {0}, {0}, {0}, {0}}},
	{pair<int, int>{3, 2}, {{1, 0}, {1, 0}, {0, 0}}},
	{pair<int, int>{1, 6}, {{0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{2, 3}, {{1, 1, 0}, {0, 0, 0}}},
	{pair<int, int>{1, 7}, {{0, 0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{7, 1}, {{0}, {0}, {0}, {0}, {0}, {0}, {0}}},
	{pair<int, int>{2, 4}, {{1, 1, 1, 0}, {0, 0, 0, 0}}},
	{pair<int, int>{4, 2}, {{1, 0}, {1, 0}, {1, 0}, {0, 0}}},
	{pair<int, int>{1, 8}, {{0, 0, 0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{8, 1}, {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}}},
	{pair<int, int>{1, 9}, {{0, 0, 0, 0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{3, 3}, {{2, 1, 0}, {1, 1, 0}, {0, 0, 0}}},
	{pair<int, int>{9, 1}, {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}}},
	{pair<int, int>{1, 10}, {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{10, 1}, {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}}},
	{pair<int, int>{5, 2}, {{1, 0}, {1, 0}, {1, 0}, {1, 0}, {0, 0}}},
	{pair<int, int>{2, 5}, {{1, 1, 1, 1, 0}, {0, 0, 0, 0, 0}}},
	{pair<int, int>{3, 4}, {{2, 2, 1, 0}, {1, 1, 1, 0}, {0, 0, 0, 0}}},
	{pair<int, int>{6, 2}, {{1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {0, 0}}},
	{pair<int, int>{2, 6}, {{1, 1, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{4, 3}, {{2, 1, 0}, {2, 1, 0}, {1, 1, 0}, {0, 0, 0}}},
	{pair<int, int>{7, 2}, {{1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {0, 0}}},
	{pair<int, int>{2, 7}, {{1, 1, 1, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{5, 3}, {{2, 1, 0}, {2, 1, 0}, {2, 1, 0}, {1, 1, 0}, {0, 0, 0}}},
	{pair<int, int>{3, 5}, {{2, 2, 2, 1, 0}, {1, 1, 1, 1, 0}, {0, 0, 0, 0, 0}}},
	{pair<int, int>{8, 2}, {{1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {0, 0}}},
	{pair<int, int>{2, 8}, {{1, 1, 1, 1, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{4, 4}, {{2, 1, 2, 0}, {2, 2, 1, 0}, {1, 1, 1, 0}, {0, 0, 0, 0}}},
	{pair<int, int>{2, 9}, {{1, 1, 1, 1, 1, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{9, 2}, {{1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {1, 0}, {0, 0}}},
	{pair<int, int>{3, 6}, {{2, 2, 2, 2, 1, 0}, {1, 1, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{6, 3}, {{2, 1, 0}, {2, 1, 0}, {2, 1, 0}, {2, 1, 0}, {1, 1, 0}, {0, 0, 0}}},
	{pair<int, int>{7, 3}, {{2, 1, 0}, {2, 1, 0}, {2, 1, 0}, {2, 1, 0}, {2, 1, 0}, {1, 1, 0}, {0, 0, 0}}},
	{pair<int, int>{3, 7}, {{2, 2, 2, 2, 2, 1, 0}, {1, 1, 1, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0, 0}}},
	{pair<int, int>{3, 9}, {{2, 2, 2, 2, 2, 2, 2, 1, 0}, {1, 1, 1, 1, 1, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0}}}
};

const vector<int> p3{13, 9, 27, 81, 243, 729, 2187, 6561, 19683, 59049, 177147};

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

inline int r(int l, int r) {
	return l + rng() % (r - l + 1);
}

// vector<vector<int>> precc{ // (4, 7), (5, 7)
// 	{3,2,2,3,3,1,1,0,0,0},
// 	{1,3,2,2,3,3,1,1,0,0},
// 	{2,1,3,2,2,3,3,1,1,0},
// 	{1,1,1,3,2,2,3,3,1,1},
// 	{2,2,1,1,3,2,2,3,3,1},
// 	{1,0,2,1,1,3,2,2,3,3},
// 	{0,0,0,2,1,1,3,2,2,3},
// 	{0,0,0,0,2,1,1,3,2,2},
// 	{0,0,0,0,0,2,1,1,3,2},
// 	{0,0,0,0,0,0,2,1,1,3},
// };

vector<vector<int>> precc{ // (4, 7), (5, 7), (6, 7)?
	{3,2,2,3,3,1,1,0,0,0},
	{1,3,2,2,3,3,1,1,0,0},
	{2,1,3,2,2,3,3,1,1,0},
	{1,1,1,3,2,2,3,3,1,1},
	{2,2,1,1,3,2,2,3,3,1},
	{1,3,2,1,1,1,2,2,3,3},
	{0,0,0,2,1,1,3,2,2,3},
	{0,0,0,0,2,1,1,3,2,2},
	{0,0,0,0,0,2,1,1,3,2},
	{0,0,0,0,0,0,2,1,1,3},
};

// vector<vector<int>> precc{
// 	{3,2,1,3,2,1,2,0,0,0},
// 	{2,3,2,1,3,2,1,2,0,0},
// 	{1,2,3,2,1,3,2,1,2,0},
// 	{3,1,2,3,2,1,3,2,1,2},
// 	{0,3,1,2,3,2,1,3,2,1},
// 	{0,0,3,1,2,3,2,1,3,2},
// 	{0,0,0,3,1,2,3,2,1,3},
// 	{0,0,0,0,3,1,2,3,2,1},
// 	{0,0,0,0,0,3,1,2,3,2},
// 	{0,0,0,0,0,0,3,1,2,3}
// };





// vector<vector<int>> precc{
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// 	{0,0,0,0,0,0,0,0,0,0},
// };

bool correct(vector<vector<int>> grid, int n, int m) {
	forn (i, 0, n) {
		forn (j, 0, m) if (grid[i][j] < 1 || grid[i][j] > 3) return false;
	}
	forn (i, 0, n) {
		forn (j, 0, m) {
			forn (ii, i + 1, n) {
				forn (jj, j + 1, m) {
					if (grid[i][j] == grid[ii][j] && grid[i][j] == grid[ii][jj] && grid[i][j] == grid[i][jj]) {
						dbg(i, j, ii, jj);
						return false;
					}
				}
			}
		}
	}
	return true;
}

void bruteSolve(int n, int m, int c) {
	vector<int> pc(n * m + 1, 1);
	forn (i, 1, n * m + 1) pc[i] = pc[i - 1] * c;

	auto getBit = [&](int mask, int bit) {
		return (mask / pc[bit]) % c;
	};

	forn (mask, 0, pc.back()) {
		vector<vector<int>> grid(n, vector<int>(m));
		forn (i, 0, n) {
			forn (j, 0, m) grid[i][j] = getBit(mask, i * m + j);
		}

		bool ok = true;
		forn (i, 0, n) {
			forn (j, 0, m) {
				forn (ii, i + 1, n) {
					forn (jj, j + 1, m) {
						if (grid[i][j] == grid[ii][j] && grid[i][j] == grid[ii][jj] && grid[i][j] == grid[i][jj]) {
							ok = false;
							break;
						}
					}
					if (!ok) break;
				}
				if (!ok) break;
			}
			if (!ok) break;
		}
		if (!ok) continue;

		forn (i, 0, n) {
			forn (j, 0, m) cout << grid[i][j] + 1 << " \n"[j == m - 1];
		}
		exit(0);
	}
	assert(false);
}

vector<int> solve(vector<pair<int, int>> &edges, vector<int> &masks, int m) {
	shuffle(all(masks), rng);
	for (auto mask : masks) {
		vector<int> cur(m);
		forn (i, 0, m) cur[i] = (mask / p3[i]) % 3;
		bool ok = true;
		for (auto [i, j] : edges) {
			if (cur[i] == cur[j]) {
				ok = false;
				break;
			}
		}
		if (ok) return cur;
	}
	assert(false);
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	dbg(correct(precc, 6, 7));

	int n, m, c;
	cin >> n >> m >> c;

	if (c == 2) bruteSolve(n, m, c);

	if (n == 2) {
		forn (i, 0, m - 1) cout << 2 << ' ';
		cout << "1\n";
		forn (i, 0, m) cout << 1 << " \n"[i == m - 1];
		return 0;
	}
	if (m == 2) {
		forn (i, 0, n) {
			if (i) cout << 2;
			else cout << 1;
			cout << ' ' << 1 << '\n';
		}
		exit(0);
	}
	if (n == 3) {
		forn (i, 0, n) {
			forn (j, 0, m) cout << i + 1 << " \n"[j == m - 1];
		}
		exit(0);
	}
	if (m == 3) {
		forn (i, 0, n) {
			forn (j, 0, m) cout << j + 1 << " \n"[j == m - 1];
		}
		exit(0);
	}

	// forn (i, n, 11) {
	// 	forn (j, m, 11) {
	// 		if (prec.find({i, j}) != prec.end()) {
	// 			auto res = prec[{i, j}];
	// 			forn (i, 0, n) {
	// 				forn (j, 0, m) cout << res[i][j] + 1 << " \n"[j == m - 1];
	// 			}
	// 			exit(0);
	// 		}
	// 		if (prec.find({j, i}) != prec.end()) {
	// 			auto rotRes = prec[{j, i}];
	// 			vector<vector<int>> res(n, vector<int>(m));
	// 			forn (i, 0, m) {
	// 				forn (j, 0, n) res[i][n - 1 - j] = rotRes[i][j];
	// 			}
	// 			forn (i, 0, n) {
	// 				forn (j, 0, m) cout << res[i][j] + 1 << " \n"[j == m - 1];
	// 			}
	// 			exit(0);
	// 		}
	// 	}
	// }

	forn (i, 0, n) {
		forn (j, 0, m) cout << precc[i][j] << " \n"[j == m - 1];
	}
	exit(0);

	// vector<int> masks(p3[m]);
	// iota(all(masks), 0);

	// vector<pair<int, int>> edges;
	// forn (i, 0, n) {
	// 	vector<int> cur = solve(edges, masks, m);
	// 	assert(len(cur) == m);
	// 	forn (j, 0, m) {
	// 		forn (k, j + 1, m) {
	// 			if (cur[j] != cur[k]) continue;
	// 			edges.emplace_back(j, k);
	// 		}
	// 	}
	// 	forn (j, 0, m) cout << cur[j] + 1 << " \n"[j == m - 1];
	// 	cout << flush;
	// 	dbg(edges);
	// }
}
