#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define len(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, l, r) for (int i = (l); i < (r); i++)

#ifdef LOCAL
#include "/home/olymp/codes/debug.h"
#else
#define dbg(...)
#endif

const int MOD = int(1e9) + 7;
const int N = 2'000'00 + 4;

inline int mult(int a, int b) {
	return 1ll * a * b % MOD;
}

inline int add(int a, int b) {
	a += b;
	return a - MOD * (a >= MOD);
}

inline int sub(int a, int b) {
	a -= b;
	return a + MOD * (a < 0);
}

inline int power(int a, int b) {
	if (!b) return 1;
	if (b % 2) return mult(a, power(a, b - 1));
	return power(mult(a, a), b / 2);
}

inline int rev(int x) {
	return power(x, MOD - 2);
}

int fact[N];
int rfact[N];

inline void init() {
	fact[0] = 1;
	forn (i, 1, N) fact[i] = mult(fact[i - 1], i);
	rfact[N - 1] = rev(fact[N - 1]);
	for (int i = N - 1; i; i--)
		rfact[i - 1] = mult(rfact[i], i);
}

inline int C(int n, int k) {
	if (k == -1) return 1;
	if (k > n) return 0;
	return mult(fact[n], mult(rfact[k], rfact[n - k]));
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	init();

	string as, bs, cs;
	cin >> as >> bs >> cs;

	int n = len(as);
	assert(len(bs) == n && len(cs) == n);

	vector<int> a(n);
	vector<int> b(n);
	vector<int> c(n);
	forn (i, 0, n) {
		a[i] = as[i] - '0';
		b[i] = bs[i] - '0';
		c[i] = cs[i] - '0';
	}

	// auto brute = [&]() {
	// 	vector<int> inds(n);
	// 	iota(all(inds), 0);
	// 	int ans = 0;
	// 	do {
	// 		if (min({c[inds.back()], a[inds.back()], b[inds.back()]}) == 0) continue;
	// 		int add = 0;
	// 		bool ok = true;
	// 		for (auto i : inds) {
	// 			if ((a[i] + b[i] + add) % 10 != c[i]) {
	// 				ok = false;
	// 				break;
	// 			}
	// 			add = a[i] + b[i] + add >= 10;
	// 		}
	// 		ok &= add == 0;
	// 		ans += ok;
	// 	} while (next_permutation(all(inds)));
	// 	cout << ans << '\n';
	// 	exit(0);
	// };
	// if (n <= 6) brute();

	int correct = 0;
	int correctZero = 0;
	int correct1 = 0;
	int correctZero1 = 0;
	int bad = 0;
	int bad1 = 0;

	forn (i, 0, n) {
		if (a[i] + b[i] == c[i]) {
			if (!a[i] || !b[i] || !c[i]) correctZero++;
			else correct++;
		} else if ((a[i] + b[i]) % 10 == c[i]) {
			assert(c[i] != 9);
			if (!a[i] || !b[i] || !c[i]) correctZero1++;
			else correct1++;
		} else if (a[i] + b[i] + 1 == c[i]) {
			bad++;
		} else if ((a[i] + b[i] + 1) % 10 == c[i]) {
			bad1++;
		} else {
			cout << "0\n";
			return 0;
		}
	}

	int ans = 0;
	if (correct1 + correctZero1 == bad) {
		dbg(correct1, bad);
		int cnt = bad;
		int num = mult(fact[cnt], fact[cnt]);
		dbg(num);
		dbg(bad1);
		dbg(bad1 + cnt - 1, cnt - 1, C(bad1 + cnt - 1, cnt - 1));
		int waysBad1 = mult(fact[bad1], C(bad1 + cnt - 1, cnt - 1));
		dbg(waysBad1);
		dbg(correct, correctZero);
		ans = mult(num, mult(waysBad1, mult(fact[correct + correctZero1], C(correct + correctZero + cnt - 1, cnt - 1))));
	}

	cout << ans << '\n';
}
