#include<iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <cstring>
#include <map>
#include <set>

using namespace std;
#define int long long
#define endl '\n'

struct letter {
    char c;
    int num;
    letter(char c = 0, int num = 0) : c(c), num(num){}
};

int nd(int n) {
    int ans = 0;
    while (n) {
        ans++;
        n /= 10;
    }
    return ans;
}

int nd2(int n) {
    if (n <= 1)
        return 0;
    return nd(n);
}
bool is_tp(int n) {
    return nd(n) != nd(n - 1);
}

set<int> tp = {10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000};
vector<int> tp2 = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 99, 100, 999, 1000, 9999, 10000, 99999, 100000, 999999, 1000000, 9999999, 10000000, 99999999, 100000000, 999999999, 1000000000};

signed main(){
    /*
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	*/
	string s;
	cin >> s;
	int n = s.length();
	vector<letter> arr;
	arr.reserve(n);
	for (int i = 0; i < n; i++) {
        char c = s[i];
        int num = 0;
        while (isdigit(c)) {
            num *= 10;
            num += c - '0';
            c = s[++i];
        }
        if (!num)
            num = 1;
        arr.emplace_back(c, num);
	}
	int ans_ma = 0, pos_ma = 1, c_ma = 'A', ans_mi = 1, pos_mi = 0;
	int n2 = arr.size();
	int np = 0;
	for (int i = 0; i < n2; np += arr[i++].num) {
        if (!i) {
            if ((arr[i].num <= 2 || tp.count(arr[i].num)) && ans_mi > -1) {
                ans_mi = -1;
                pos_mi = 0;
            }
            if (ans_ma < 1) {
                ans_ma = 1;
                pos_ma = 0;
                if (arr[i].c == 'G') {
                    c_ma = 'A';
                }
                else {
                    c_ma = 'G';
                }
            }
            for (auto el : tp2) {
                if (el >= arr[i].num) {
                    break;
                }
                int new_cen = nd2(el) + 1 + 1 + nd2(arr[i].num - el) - nd2(arr[i].num);
                if (new_cen > ans_ma) {
                    ans_ma = new_cen;
                    pos_ma = np + el;
                    if (arr[i].c == 'G') {
                        c_ma = 'A';
                    }
                    else {
                        c_ma = 'G';
                    }
                }
            }
        }
        else if (i != n2 - 1) {
            if (arr[i].num == 1 && arr[i - 1].c == arr[i + 1].c) {
                int new_val = nd2(arr[i - 1].num + arr[i + 1].num) - nd2(arr[i - 1].num) - nd2(arr[i - 1].num) - 2;
                int new_val2 = nd2(arr[i - 1].num + arr[i + 1].num + 1) - nd2(arr[i - 1].num) - nd2(arr[i - 1].num) - 2;
                if (new_val2 > ans_ma)
                    abort();
                if (ans_mi > new_val) {
                    ans_mi = new_val;
                    pos_mi = np;
                }
            }
            else if ((arr[i].num <= 2 || tp.count(arr[i].num)) && ans_mi > -1) {
                ans_mi = -1;
                pos_mi = np;
            }
            for (auto el : tp2) {
                if (el >= arr[i].num) {
                    break;
                }
                int new_cen = nd2(el) + 1 + 1 + nd2(arr[i].num - el) - nd2(arr[i].num);
                if (new_cen > ans_ma) {
                    ans_ma = new_cen;
                    pos_ma = np + el;
                    if (arr[i].c == 'G') {
                        c_ma = 'A';
                    }
                    else {
                        c_ma = 'G';
                    }
                }
            }
        }
        else {
            if ((arr[i].num <= 2 || tp.count(arr[i].num)) && ans_mi > -1) {
                ans_mi = -1;
                pos_mi = np;
            }
            for (auto el : tp2) {
                    if (el >= arr[i].num) {
                        break;
                    }
                    int new_cen = nd2(el) + 1 + 1 + nd2(arr[i].num - el) - nd2(arr[i].num);
                    if (new_cen > ans_ma) {
                        ans_ma = new_cen;
                        pos_ma = np + el;
                        if (arr[i].c == 'G') {
                            c_ma = 'A';
                        }
                        else {
                            c_ma = 'G';
                        }
                    }
                }
        }
	}
	cout << 2 << ' ' << pos_mi + 1 << "\n" << 1 << ' ' << pos_ma << ' ' << (char)c_ma;
	return 0;
}
