#include<iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <cstring>
#include <map>

using namespace std;
#define int long long
#define endl '\n'

struct frag{
    int m, s;
    vector<int> obj;
    int start, finish;
    frag(){}
};


signed main(){
    /*
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	*/
	int n;
	cin >> n;
	vector<frag> arr(n);
	int len = -1;
    for (int i = 0;i < n; i++) {
        cin >> arr[i].m >> arr[i].s;
        arr[i].obj.resize(arr[i].m);
        for (int k = 0; k < arr[i].m; k++) {
            cin >> arr[i].obj[k];
            if (k) {
                if (len == -1) {
                    len = arr[i].obj[k] - arr[i].obj[k - 1];
                }
                else if (len != arr[i].obj[k] - arr[i].obj[k - 1]) {
                    cout << "No";
                    return 0;
                }
            }
            if (k == 0) {
                arr[i].start = arr[i].obj[k];
            }
            if (k == arr[i].m - 1) {
                arr[i].finish = arr[i].s - arr[i].obj[k];
            }
        }
    }
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }
    do {
        bool flag = 1;
        int now_len = len;
        for (int i = 1; i < n; i++) {
            if (now_len == -1) {
                now_len = arr[p[i]].start + arr[p[i - 1]].finish;
            }
            else if (arr[p[i]].start + arr[p[i - 1]].finish != now_len) {
                flag = false;
                break;
            }
        }
        if (flag) {
            cout << "Yes\n";
            for (auto el : p) {
                cout << el + 1 << ' ';
            }
            return 0;
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << "No";
	return 0;
}
