#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int n, m, c;
vector<vector<int>> a;

bool check() {
    for (int i1 = 0; i1 < n - 1; ++i1)
        for (int j1 = 0; j1 < m - 1; ++j1)
            for (int i2 = i1 + 1; i2 < n; ++i2)
                for (int j2 = j1 + 1; j2 < m; ++j2)
                    if (a[i1][j1] == a[i1][j2] && a[i1][j1] == a[i2][j2] && a[i1][j1] == a[i2][j1])
                        return false;
    return true;
}

void req(int pos) {
    if (pos == n * m) {
        if (check()) {
            for (auto& i : a) {
                for (auto& j : i)
                    cout << j << ' ';
                cout << '\n';
            }
           exit(0);
       }
    }
    else {
        for (int color = 1; color <= c; ++color) {
            a[pos / m][pos % m] = color;
            req(pos + 1);
        }
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    cin >> n >> m >> c;
    a.assign(n, vector<int>(m, 0));
    req(0);
    return 0;
}
