#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int n, m, c;
vector<vector<int>> a;

bool check(int N = n, int M = m) {
    for (int i1 = 0; i1 < N - 1; ++i1)
        for (int j1 = 0; j1 < M - 1; ++j1)
            for (int i2 = i1 + 1; i2 < N; ++i2)
                for (int j2 = j1 + 1; j2 < M; ++j2)
                    if (a[i1][j1] == a[i1][j2] && a[i1][j1] == a[i2][j2] && a[i1][j1] == a[i2][j1])
                        return false;
    return true;
}

vector<vector<vector<int>>> d;

void req(int pos) {
    if (pos == n * m) {
        if (check()) {
            for (auto& i : a) {
                for (auto& j : i)
                    cout << j << ' ';
                cout << '\n';
            }
            exit(0);
       }
    }
    else {
        int i = pos / m,
            j = pos % m;
        for (int color = 1; color <= c; ++color) {
            for (int k = 0; k < j; ++k)
                if (d[k][j][color] > 0 && a[i][k] == color)
                    continue;
            a[i][j] = color;
            for (int k = 0; k < j; ++k)
                if (a[i][k] == color)
                    d[k][j][color]++;
            req(pos + 1);
            for (int k = 0; k < j; ++k)
                if (a[i][k] == color)
                    d[k][j][color]--;
        }
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    cin >> n >> m >> c;
    a = vector<vector<int>> (n, vector<int>(m, 0));
    d = vector<vector<vector<int>>> (n, vector<vector<int>>(n, vector<int>(c + 1, 0)));
    if (c == 2)
        req(0);
    else {
        a = {{1,2,2,3,3,1}, {2,1,3,3,1,2}, {2,2,1,1,3,3}, {3,3,2,2,1,1}, {1,1,3,2,3,2}, {3,1,1,3,2,2}};
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                cout << a[i][j] << ' ';
            }
            cout << '\n';
        }
    }
    return 0;
}
