#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int main()
{
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.size();
    vector<int> order;
    for (int i = 0; i < n; i++)
        order.push_back(i);
    ll ans = 0, mod = 1e9 + 7;
    do {
        int add = 0;
        bool res = true;
        for (auto i : order) {
            if ((add + (a[i] - '0') + (b[i] - '0')) % 10 != c[i] - '0') {
                res = false;
                break;
            }
            add = (add + (a[i] - '0') + (b[i] - '0')) / 10;
        }
        if (a[order.back()] == '0' || b[order.back()] == '0' || c[order.back()] == '0')
            res = false;
        if (res && add == 0)
            ans = (ans + 1) % mod;
    } while(next_permutation(order.begin(), order.end()));
    cout << ans;
    return 0;
}
