def main():
    from sys import stdin
    from functools import lru_cache
    input = stdin.readline
    
    @lru_cache(maxsize=None)
    def rec(mask, a, b, c, d, f=0):
        #print(mask, a, b, c, d)
        '''if max(a, b, c, d) == 0:
            return mask < 2'''
        if not mask:
            if not a:
                return 0
            if a == 1 and max(b, c, d) == 0:
                return 1
            if f:
                return cnt[0] * (rec(0, a - 1, b, c, d) + rec(2, a - 1, b, c, d))
            return a * (rec(0, a - 1, b, c, d) + rec(2, a - 1, b, c, d))
        if mask == 1:
            if not b:
                return 0
            if b == 1 and max(a, c, d) == 0:
                return 1
            return b * (rec(0, a, b - 1, c, d) + rec(2, a, b - 1, c, d))
        if mask == 2:
            if not c:
                return 0
            if c == 1 and max(a, b, d) == 0:
                return 0
            if f:
                return cnt[2] * (rec(1, a, b, c - 1, d) + rec(3, a, b, c - 1, d))
            return c * (rec(1, a, b, c - 1, d) + rec(3, a, b, c - 1, d))
        if not d:
            return 0
        if d == 1 and max(a, b, c) == 0:
            return 0
        return d * (rec(1, a, b, c, d - 1) + rec(3, a, b, c, d - 1))
    
    def inv(x):
        return pow(x, mod - 2, mod)
    
    def A(n, k):
        if k < 0 or n < k:
            return 0
        return f[n] * inv(f[n - k]) % mod
    
    mod = 1000000007
    
    s1 = input()
    s2 = input()
    s3 = input()
    n = len(s1) -  1
    a = b = c = d = 0
    cnt = [0] * 4
    
    f = [0] * (n + 5)
    f[0] = 1
    for i in range(1, n + 5):
        f[i] = f[i - 1] * i % mod
        
    for i in range(n):
        x, y, z = int(s1[i]), int(s2[i]), int(s3[i])
        if (x + y) % 10 == z:
            if x + y < 10:
                a += 1
                if min(x, y, z):
                    cnt[0] += 1
            else:
                b += 1
        elif (x + y + 1) % 10 == z:
            if x + y + 1 < 10:
                c += 1
                if min(x, y, z):
                    cnt[2] += 1
            else:
                d += 1
        else:
            print(0)
            return
    dp = [[0 for j in range(n + 5)] for i in range(n + 5)]
    for i in range(n + 5):
        dp[0][i] = 1
    for i in range(n + 5):
        for j in range(1, n + 5):
            for k in range(i + 1):
                dp[i][j] += dp[i - k][j - 1] * A(i, k)
    #print(dp[3][1], A(3, 1))
    #return
    if n <= 18:
    #if 0:
        print((rec(0, a, b, c, d, 1) + rec(2, a, b, c, d, 1)) % mod)
    elif b == c:
        print(dp[a][b + 1] * dp[d][c] % mod)
    else:
        print(0)
    #print(a, b, c, d, cnt)
    #print(C(0, 0))
    
main()