#pragma GCC optimize("Ofast,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define IOS ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define pii pair<int, int>
#define vi vector<int>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ost;

const int mod = 1000000007, nax = 205;

ll f[nax], dp[nax][nax], cnt[4];

ll rec(int mask, ll a, ll b, ll c, ll d, int f=0) {
    if (!mask) {
        if (!a)
            return 0;
        if (a == 1 && max(max(b, c), d) == 0)
            return 1;
        if (f)
            return cnt[0] * (rec(0, a - 1, b, c, d) + rec(2, a - 1, b, c, d)) % mod;
        return a * (rec(0, a - 1, b, c, d) + rec(2, a - 1, b, c, d)) % mod;
    }
    if (mask == 1) {
        if (!b)
            return 0;
        if (b == 1 && max(max(a, c), d) == 0)
            return 1;
        return b * (rec(0, a, b - 1, c, d) + rec(2, a, b - 1, c, d)) % mod;
    }
    if (mask == 2) {
        if (!c)
            return 0;
        if (c == 1 && max(max(a, b), d) == 0)
            return 0;
        if (f)
            return cnt[2] * (rec(1, a, b, c - 1, d) + rec(3, a, b, c - 1, d)) % mod;
        return b * (rec(1, a, b, c - 1, d) + rec(3, a, b, c - 1, d)) % mod;
    }
    if (!d)
        return 0;
    if (d == 1 && max(max(a, b), c) == 0)
        return 0;
    return d * (rec(1, a, b, c, d - 1) + rec(3, a, b, c, d - 1)) % mod;
}

ll power(ll a, ll b) {
    ll res = 1;
    for (; b; a = a * a % mod, b >>= 1) {
        if (b & 1)
            res = res * a % mod;
    }
    return res;
}

ll inv(ll x) {
    return power(x, mod - 2);
}

ll A(int n, int k) {
    if (k < 0 || n < k)
        return 0;
    return f[n] * inv(f[n - k]) % mod;
}

int main() {
    IOS
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size(), a = 0, b = 0, c = 0, d = 0;
    f[0] = 1;
    for (int i = 1; i < n + 5; ++i)
        f[i] = f[i - 1] * i % mod;
    for (int i = 0; i < n; ++i) {
        int x = s1[i] - '0',
            y = s2[i] - '0',
            z = s3[i] - '0';
        if ((x + y) % 10 == z) {
            if (x + y < 10) {
                a += 1;
                if (min(min(x, y), z))
                    cnt[0] += 1;
            } else
                b += 1;
        } else if ((x + y + 1) % 10 == z) {
            if (x + y + 1 < 10) {
                c += 1;
                if (min(min(x, y), z))
                    cnt[2] += 1;
            } else
                d += 1;
        } else {
            cout << 0 << '\n';
            return 0;
        }
    }
    for (int i = 0; i < n + 5; ++i)
        dp[0][i] = 1;
    for (int i = 1; i < n + 5; ++i)
        for (int j = 1; j < n + 5; ++j)
            for (int k = 0; k <= i; ++k)
                dp[i][j] = (dp[i][j] + dp[i - k][j - 1] * A(i, k)) % mod;
    if (n <= 18)
        cout << (rec(0, a, b, c, d, 1) + rec(2, a, b, c, d, 1)) % mod << '\n';
    else if (b == c)
        cout << dp[a][b + 1] * dp[d][c] % mod << '\n';
    else {
        assert(0);
        cout << 0 << '\n';
    }
    return 0;
}
