#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define all(x) (x).begin(), x.end()
#define sz(x) (int)x.size()
#ifndef MY
    #define endl '\n'
#endif // MY

typedef long double db;
typedef long long ll;
typedef pair < int, int > pii;

const int N = 2e5 + 10;
vector < int > lst[N];
vector < pii > gr[N];
vector < pii > cgr[N];
int len[N];
int n;
bool used[N];
int st[N], fn[N];
vector < int > cor;
int in[N], out[N];

void stop() {
    cout << "No";
    exit(0);
}

void rever() {
    for (auto i : cor) {
        for (auto j : gr[i]) {
            cgr[j.F].pb({i, j.S});
        }
    }
    for (auto i : cor) {
        gr[i] = cgr[i];
    }
}

vector < int > result;

void dfs(int v) {
    for (auto k : gr[v]) {
        int u = k.F, i = k.S;
        if (used[i]) {
            continue;
        }
        used[i] = 1;
        result.pb(i);
        dfs(u);
    }
}

vector < int > line;

void stupid(int t) {
    if (t == n) {
        int prv = 0;
        int dist = -1;
        bool fl = 1;
        int add = 0;
        for (int t = 0; t < n && fl; t++) {
            int i = line[t];
            for (int j = 0; j < sz(lst[i]); j++) {
                if (t == 0 && j == 0) {
                    prv = lst[i][j];
                    continue;
                }
                if (dist == -1) {
                    dist = lst[i][j] + add - prv;
                }
                if (dist != add + lst[i][j] - prv) {
                    fl = 0;
                    break;
                }
                prv = add + lst[i][j];
            }
            add += len[i];
        }
        if (fl) {
            cout << "Yes" << endl;
            for (int i = 0; i < n; i++) {
                cout << line[i] + 1 << ' ';
            }
            exit(0);
        }
        return;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = 1;
            line.pb(i);
            stupid(t + 1);
            used[i] = 0;
            line.pop_back();
        }
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    if (n == 1) {
        int m, prv, dist = -1;
        cin >> m >> len[0] >> prv;
        for (int i = 1; i < m; i++) {
            int x;
            cin >> x;
            if (dist == -1) {
                dist = x - prv;
            } else {
                if (x - prv != dist) {
                    stop();
                }
            }
            prv = x;
        }
        cout << "Yes\n 1" << endl;
        return 0;
    }
    int dist = -1;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m >> len[i];
        lst[i].resize(m);
        int cur = -1;
        for (int j = 0; j < m; j++) {
            cin >> lst[i][j];
            if (j) {
                int now = lst[i][j] - lst[i][j - 1];
                if (cur == -1) {
                    cur = now;
                } else if (cur != now) {
                    stop();
                }
            }
            if (cur != -1) {
                if (dist == -1) {
                    dist = cur;
                } else if (dist != cur) {
                    stop();
                }
            }
        }
    }
//    if (n <= 8) {
//        stupid(0);
//        stop();
//    }
    if (dist == -1) {
        stupid(0);
        stop();
    } else {
        for (int i = 0; i < n; i++) {
            if (lst[i][0] <= dist) {
                cor.pb(lst[i][0]);
            } else {
                cor.pb(dist + 1);
            }
            st[i] = cor.back();

            int a = len[i] - lst[i].back();
            if (a <= dist) {
                cor.pb(dist - a);
            } else {
                cor.pb(dist + 2);
            }
            fn[i] = cor.back();
        }
        sort(all(cor));
        cor.resize(unique(all(cor)) - cor.begin());
        for (int i = 0; i < n; i++) {
            st[i] = lower_bound(all(cor), st[i]) - cor.begin();
            fn[i] = lower_bound(all(cor), fn[i]) - cor.begin();
            gr[st[i]].pb({fn[i], i});
            out[st[i]]++;
            in[fn[i]]++;
        }
        vector < int > beg, bac;
        for (int i = 0; i < sz(cor); i++) {
            if (abs(out[i] - in[i]) > 1) {
                stop();
            }
            if (out[i] > in[i]) {
                beg.pb(i);
            }
            if (in[i] > out[i]) {
                bac.pb(i);
            }
        }
        if (sz(beg) > 1 || sz(bac) > 1) {
            stop();
        }
        bool r = 0;
        int s = 0;
        if (sz(beg) == 0 && sz(bac) == 1) {
            r = 1;
            s = bac[0];
            rever();
        }
        if (sz(beg)) {
            s = beg[0];
        }
        dfs(s);
        if (sz(result) != n) {
            stop();
        }
        if (r) {
            reverse(all(result));
        }
        cout << "Yes" << endl;
        for (auto a : result) {
            cout << a + 1 << ' ';
        }
//        vector < int > st;
//        vector < int > fn;
//        for (int i = 0; i < n; i++) {
//            int a = 0;
//            if (lst[i][0] > dist) {
//                st.pb(i);
//                a++;
//            }
//            if (len[i] - lst[i].back() > dist) {
//                fn.pb(i);
//                a++;
//            }
//            if (a == 2) {
//                stop();
//            }
//        }
//        if (sz(st) > 1 || sz(fn) > 0) {
//            stop();
//        }
    }
    return 0;
}
