// 7.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <iomanip>
#include <vector>

using namespace std;
long long fact(int n, long long mod) {
    long long ans = 1;
    for (int i = 1; i <= n; i++) {
        ans *= i;
        ans %= mod;
    }
    return ans;
}
long long pow(long long a, long long n, long long mod) {
    long long ans = 1;
    while (n != 0) {
        if (n % 2 == 1) {
            ans *= a;
            ans %= mod;
        }
        a *= a;
        a %= mod;
        n /= 2;
    }
    return ans;

}
int main() {
    long long mod = 1000000007;
    string a1, b1, c1;
    cin >> a1;
    cin >> b1;
    cin >> c1;
    long long n = a1.length();
    vector<int> a(n), b(n), c(n);
    for (long long i = 0; i < n; i++) {
        a[i] = a1[i] - '0';
        b[i] = b1[i] - '0';
        c[i] = c1[i]- '0';
    }
    vector<int> d(n);
    int minus = 0;
    int plus = 0;
    int per = 0;
    for (int i = 0; i < n; i++) {
        d[i] = a[i] + b[i] - c[i];
        if (d[i] == 10) {
            plus++;
        }
        else if (d[i] == -1) {
            minus++;
        }
        else if (d[i] != 0) {
            cout << "0";
            return 0;
        }
    }
    if (plus != minus) {
        cout << "0";
        return 0;
    }
    long long ans = 1;
    ans *= fact(plus, mod);
    ans %= mod;
    ans *= fact(n - plus * 2, mod);
    ans %= mod;
    ans *= fact(n - plus, mod);
    ans %= mod;
    ans *= pow(fact(plus, mod), mod - 2, mod);
    ans %= mod;
    ans *= pow(fact(n - plus * 2, mod), mod - 2, mod);
    ans %= mod;
    cout << ans;
    return 0;


}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
