//#pragma comment(linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")
#ifdef _MSC_VER
	#define _CRT_SECURE_NO_WARNINGS
	#include <__msvc_all_public_headers.hpp>	
	#include <Windows.h>
#else
	#define _MSC_VER 2000
	#include <bits/stdc++.h>
	#pragma GCC optimize("Ofast")
	#pragma GCC optimize("fast-math")
	#pragma GCC optimize ("unroll-loops")
	#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#endif

#define nl					"\n"
#define int					long long
#define uint				unsigned int
#define double				long double
#define len(Q)				(int)Q.size()
#define all(Q)				Q.begin(), Q.end()

using namespace std;

template <typename T> ostream &operator <<(ostream &out, vector <T> &a)
{
	for (auto &p : a)
		out << p << " ";
	return out;
}
template <typename T> istream &operator >>(istream &inp, vector <T> &a)
{
	for (auto &p : a)
		inp >> p;
	return inp;
}

string sm(string a, string b)
{
	int add = 0;
	string ret;
	while (len(a) < len(b))
		a.push_back('0');
	while (len(b) < len(a))
		b.push_back('0');
	for (int j = 0; j < len(a); j++)
	{
		int numl = a[j] - '0', numr = b[j] - '0';
		if (numl + numr + add > 9)
			ret.push_back('0' + numl + numr + add - 10), add = 1;
		else
			ret.push_back('0' + numl + numr + add), add = 0;
	}
	if (add)
		ret.push_back('1');
	return ret;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	srand((signed)time(NULL));

	int n;
	cin >> n;

	vector <pair <int, vector <int>>> sh(n);
	for (auto &p : sh)
	{
		int a;
		cin >> a;
		cin >> p.first;
		p.second.resize(a);
		for (auto &q : p.second)
			cin >> q;
	}

	vector <int> a;
	if (n == 1)
	{
		for (int a8 = 0; a8 < 8; a8++)
		{
			a.push_back(a8);
			vector <int> per;
			int div = 0;
			for (auto &p : a)
			{
				per.push_back(div + sh[p].second[0]);
				for (int i = 1; i < len(sh[p].second); i++)
					per.push_back(sh[p].second[i] - sh[p].second[i - 1]);
				div += sh[p].first - sh[p].second[len(sh[p].second) - 1];
			}

			if (len(per) == 1)
			{
				cout << "Yes\n";
				for (auto &p : a)
					cout << p + 1 << " ";
				return 0;
			}
			bool okay = true;
			for (int i = 1; i < len(per); i++)
			{
				if (per[1] != per[i])
				{
					okay = false;
					break;
				}
			}
			if (okay)
			{
				cout << "Yes\n";
				for (auto &p : a)
					cout << p + 1 << " ";
				return 0;
			}
			a.pop_back();
		}
	}
	else if (n == 2)
	{
		for (int a7 = 0; a7 < 8; a7++)
		{
			a.push_back(a7);
			for (int a8 = 0; a8 < 8; a8++)
			{
				if (a8 != a7)
				{
					a.push_back(a8);
					vector <int> per;
					int div = 0;
					for (auto &p : a)
					{
						per.push_back(div + sh[p].second[0]);
						for (int i = 1; i < len(sh[p].second); i++)
							per.push_back(sh[p].second[i] - sh[p].second[i - 1]);
						div += sh[p].first - sh[p].second[len(sh[p].second) - 1];
					}

					if (len(per) == 1)
					{
						cout << "Yes\n";
						for (auto &p : a)
							cout << p + 1 << " ";
						return 0;
					}
					bool okay = true;
					for (int i = 1; i < len(per); i++)
					{
						if (per[1] != per[i])
						{
							okay = false;
							break;
						}
					}
					if (okay)
					{
						cout << "Yes\n";
						for (auto &p : a)
							cout << p + 1 << " ";
						return 0;
					}
					a.pop_back();
				}
				a.pop_back();
			}
		}
	}
	else if (n == 3)
	{
		for (int a6 = 0; a6 < 8; a6++)
		{
				a.push_back(a6);
				for (int a7 = 0; a7 < 8; a7++)
				{
					if (a7 != a6)
					{
						a.push_back(a7);
						for (int a8 = 0; a8 < 8; a8++)
						{
							if (a8 != a7 && a8 != a6)
							{
								a.push_back(a8);
								vector <int> per;
								int div = 0;
								for (auto &p : a)
								{
									per.push_back(div + sh[p].second[0]);
									for (int i = 1; i < len(sh[p].second); i++)
										per.push_back(sh[p].second[i] - sh[p].second[i - 1]);
									div += sh[p].first - sh[p].second[len(sh[p].second) - 1];
								}

								if (len(per) == 1)
								{
									cout << "Yes\n";
									for (auto &p : a)
										cout << p + 1 << " ";
									return 0;
								}
								bool okay = true;
								for (int i = 1; i < len(per); i++)
								{
									if (per[1] != per[i])
									{
										okay = false;
										break;
									}
								}
								if (okay)
								{
									cout << "Yes\n";
									for (auto &p : a)
										cout << p + 1 << " ";
									return 0;
								}
								a.pop_back();
							}
						}
						a.pop_back();
					}
				}
				a.pop_back();
			}
		}

	else if (n == 4)
	{
		for (int a5 = 0; a5 < 8; a5++)
		{
			a.push_back(a5);
			for (int a6 = 0; a6 < 8; a6++)
			{
				if (a6 != a5)
				{
					a.push_back(a6);
					for (int a7 = 0; a7 < 8; a7++)
					{
						if (a7 != a6 && a7 != a5)
						{
							a.push_back(a7);
							for (int a8 = 0; a8 < 8; a8++)
							{
								if (a8 != a7 && a8 != a6 && a8 != a5)
								{
									a.push_back(a8);
									vector <int> per;
									int div = 0;
									for (auto &p : a)
									{
										per.push_back(div + sh[p].second[0]);
										for (int i = 1; i < len(sh[p].second); i++)
											per.push_back(sh[p].second[i] - sh[p].second[i - 1]);
										div += sh[p].first - sh[p].second[len(sh[p].second) - 1];
									}

									if (len(per) == 1)
									{
										cout << "Yes\n";
										for (auto &p : a)
											cout << p + 1 << " ";
										return 0;
									}
									bool okay = true;
									for (int i = 1; i < len(per); i++)
									{
										if (per[1] != per[i])
										{
											okay = false;
											break;
										}
									}
									if (okay)
									{
										cout << "Yes\n";
										for (auto &p : a)
											cout << p + 1 << " ";
										return 0;
									}
									a.pop_back();
								}
							}
							a.pop_back();
						}
					}
					a.pop_back();

				}
				a.pop_back();
			}
		}
	}
	else if (n == 5)
{
for (int a4 = 0; a4 < 8; a4++)
{
		a.push_back(a4);
		for (int a5 = 0; a5 < 8; a5++)
		{
			if (a5 != a4)
			{
				a.push_back(a5);
				for (int a6 = 0; a6 < 8; a6++)
				{
					if (a6 != a5 && a6 != a4)
					{
						a.push_back(a6);
						for (int a7 = 0; a7 < 8; a7++)
						{
							if (a7 != a6 && a7 != a5 && a7 != a4)
							{
								a.push_back(a7);
								for (int a8 = 0; a8 < 8; a8++)
								{
									if (a8 != a7 && a8 != a6 && a8 != a5 && a8 != a4)
									{
										a.push_back(a8);
										vector <int> per;
										int div = 0;
										for (auto &p : a)
										{
											per.push_back(div + sh[p].second[0]);
											for (int i = 1; i < len(sh[p].second); i++)
												per.push_back(sh[p].second[i] - sh[p].second[i - 1]);
											div += sh[p].first - sh[p].second[len(sh[p].second) - 1];
										}

										if (len(per) == 1)
										{
											cout << "Yes\n";
											for (auto &p : a)
												cout << p + 1 << " ";
											return 0;
										}
										bool okay = true;
										for (int i = 1; i < len(per); i++)
										{
											if (per[1] != per[i])
											{
												okay = false;
												break;
											}
										}
										if (okay)
										{
											cout << "Yes\n";
											for (auto &p : a)
												cout << p + 1 << " ";
											return 0;
										}
										a.pop_back();
									}
								}
								a.pop_back();
							}
						}
						a.pop_back();
					}
				}
				a.pop_back();
			}
		}
		a.pop_back();
	
}
 }
	else if (n == 6)
	{

 }
	else if (n == 7)
	{

 }
	else if (n == 8)
	{

		for (int a1 = 0; a1 < 8; a1++)
		{
			a.push_back(a1);
			for (int a2 = 0; a2 < 8; a2++)
			{
				if (a2 != a1)
				{
					a.push_back(a2);
					for (int a3 = 0; a3 < 8; a3++)
					{
						if (a3 != a2 && a3 != a1)
						{
							a.push_back(a3);
							for (int a4 = 0; a4 < 8; a4++)
							{
								if (a4 != a3 && a4 != a2 && a4 != a1)
								{
									a.push_back(a4);
									for (int a5 = 0; a5 < 8; a5++)
									{
										if (a5 != a4 && a5 != a3 && a5 != a2 && a5 != a1)
										{
											a.push_back(a5);
											for (int a6 = 0; a6 < 8; a6++)
											{
												if (a6 != a5 && a6 != a4 && a6 != a3 && a6 != a2 && a6 != a1)
												{
													a.push_back(a6);
													for (int a7 = 0; a7 < 8; a7++)
													{
														if (a7 != a6 && a7 != a5 && a7 != a4 && a7 != a3 && a7 != a2 && a7 != a1)
														{
															a.push_back(a7);
															for (int a8 = 0; a8 < 8; a8++)
															{
																if (a8 != a7 && a8 != a6 && a8 != a5 && a8 != a4 && a8 != a3 && a8 != a2 && a8 != a1)
																{
																	a.push_back(a8);
																	vector <int> per;
																	int div = 0;
																	for (auto &p : a)
																	{
																		per.push_back(div + sh[p].second[0]);
																		for (int i = 1; i < len(sh[p].second); i++)
																			per.push_back(sh[p].second[i] - sh[p].second[i - 1]);
																		div += sh[p].first - sh[p].second[len(sh[p].second) - 1];
																	}

																	if (len(per) == 1)
																	{
																		cout << "Yes\n";
																		for (auto &p : a)
																			cout << p + 1 << " ";
																		return 0;
																	}
																	bool okay = true;
																	for (int i = 1; i < len(per); i++)
																	{
																		if (per[1] != per[i])
																		{
																			okay = false;
																			break;
																		}
																	}
																	if (okay)
																	{
																		cout << "Yes\n";
																		for (auto &p : a)
																			cout << p + 1 << " ";
																		return 0;
																	}
																	a.pop_back();
																}
															}
															a.pop_back();
														}
													}
													a.pop_back();
												}
											}
											a.pop_back();
										}
									}
									a.pop_back();
								}
							}
							a.pop_back();
						}
					}
					a.pop_back();
				}
			}
			a.pop_back();
		}
	}

	cout << "No";

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}