//#pragma comment(linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")
#ifdef _MSC_VER
	#define _CRT_SECURE_NO_WARNINGS
	#include <__msvc_all_public_headers.hpp>	
	#include <Windows.h>
#else
	#define _MSC_VER 2000
	#include <bits/stdc++.h>
	#pragma GCC optimize("Ofast")
	#pragma GCC optimize("fast-math")
	#pragma GCC optimize ("unroll-loops")
	#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#endif

#define nl					"\n"
#define len(Q)				(int)Q.size()
#define all(Q)				Q.begin(), Q.end()

using namespace std;

template <typename T> ostream &operator <<(ostream &out, vector <T> &a)
{
	for (auto &p : a)
		out << p << " ";
	return out;
}
template <typename T> istream &operator >>(istream &inp, vector <T> &a)
{
	for (auto &p : a)
		inp >> p;
	return inp;
}

int n, m, c;
bool swaps = false;

int a[10][10];

map<int, int> x[10], y[10];

void rec(int i, int j)
{
	for (int itt = 1; itt <= c; itt++)
	{
		bool isok = true;
		for (int i1 = 0; i1 < i; i1++)
		{
			for (int j1 = 0; j1 < j; j1++)
			{
				if (a[i1][j] == itt && itt == a[i][j1] && a[i][j1] == a[i1][j1])
				{
					isok = false;
					break;
				}
			}
		}

		if (!isok)
			continue;

		a[i][j] = itt;
		x[i][itt]++, y[j][itt]++;
		if (j == m - 1)
		{
			if (i == n - 1)
			{			
				if (swaps)
				{
					for (int i = 0; i < m; i++)
					{
						for (int j = 0; j < n; j++)
							cout << a[j][i] << " ";
						cout << nl;
					}
				}
				else
				{
					for (int i = 0; i < n; i++)
					{
						for (int j = 0; j < m; j++)
							cout << a[i][j] << ' ';
						cout << nl;
					}
				}

				exit(0);
			}
			else
				rec(i + 1, 0);
		}
		else
			rec(i, j + 1);
		x[i][itt]--, y[j][itt]--;
	}
}


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	srand((signed)time(NULL));

	cin >> n >> m >> c;
	if (n < m)
		swap(n, m), swaps = true;
	rec(0, 0);

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}