#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 1e5 + 100;
ll n;

map<ll, vector<pair<ll, ll>>> ins, ins2;
map<ll, ll> outt, outt2, cnt;
vector<pair<ll, ll>> vec;
ll gt[SZ];

void check(ll d) {
	ins.clear();
	outt = outt2;
	set<ll> st;

	for (int i = 0; i < vec.size(); i++) {
		ll lft = d - vec[i].second;
		if (cnt[lft] < gt[vec[i].second]) {
			ins[vec[i].first].push_back({ vec[i].second, i });
		}
	}

	for (int i = 0; i < vec.size(); i++) {
		ll lft = d - vec[i].second;
		if (cnt[lft] >= gt[vec[i].second]) {
			ins[vec[i].first].push_back({ vec[i].second, i });
		}
	}
	
	for (int i = 0; i < vec.size(); i++) {
		if (vec[i].first + vec[i].second == d) {
			int j;
			for (j = 0; j < ins[vec[i].first].size(); j++) {
				if (ins[vec[i].first][j].first == vec[i].second && ins[vec[i].first][j].second == i) {
					break;
				}
			}

			ins[vec[i].first].erase(ins[vec[i].first].begin() + j);
			ins[vec[i].first].push_back({ vec[i].second, i });
			st.insert(vec[i].first);
			ll str = (*ins.begin()).first;
			if (st.size() > 0) str = (*st.begin());

			vector<ll> ans;

			ans.push_back(ins[str].back().second);
			ins[str].pop_back();

			while (ans.size() != n) {
				ll lft = d - gt[ans.back()];

				if (ins[lft].size() == 0) {
					return;
				}
				ll v = ins[lft].back().second;
				ans.push_back(v);
				ins[lft].pop_back();
			}

			cout << "Yes\n";
			for (auto cur : ans) cout << cur + 1 << " ";

			exit(0);
		}
	}


	for (auto cur : ins) {
		//if (cur.first > d) return;

		ll lft = d - cur.first;
		if (cur.second.size() > outt[lft]) {
			if (cur.second.size() - outt[lft] >= 2) return;

			st.insert(cur.first);
		}

		if (st.size() >= 2) return;
	}

	ll str = (*ins.begin()).first;
	if (st.size() > 0) str = (*st.begin());

	vector<ll> ans;
	
	ans.push_back(ins[str].back().second);
	ins[str].pop_back();

	while (ans.size() != n) {
		ll lft = d - gt[ans.back()];

		if (ins[lft].size() == 0) {
			return;
		}
		ll v = ins[lft].back().second;
		ans.push_back(v);
		ins[lft].pop_back();
	}
	
	cout << "Yes\n";
	for (auto cur : ans) cout << cur + 1 << " ";

	exit(0);
}

int main() {
	fastInp;
	
	cin >> n;

	set<ll> st;
	for (int i = 0; i < n; i++) {
		ll m, s;
		cin >> m >> s;
		vector<ll> ps(m);
		for (auto &cur : ps) cin >> cur;

		for (int i = 0; i < ps.size() - 1; i++) {
			st.insert(ps[i + 1] - ps[i]);
		}
		ins[ps[0]].push_back({ s - ps.back(), i });
		outt[s - ps.back()]++;
		gt[i] = s - ps.back();
		cnt[ps[0]]++;
		
		vec.push_back({ ps[0], s - ps.back() });
	}

	ins2 = ins;
	outt2 = outt;
	if (st.size() > 1) {
		cout << "No";
		return 0;
	}

	if (st.size() == 1) {
		check(*(st.begin()));
	}
	else {
		vector<ll> perm;
		for (int i = 0; i < n; i++) perm.push_back(i);

		do {
			bool f = 1;
			ll pr = -1;
			for (int i = 0; i < perm.size() - 1; i++) {
				ll v = perm[i], u = perm[i + 1];
				if (pr == -1 || vec[v].second + vec[u].first == pr) {
					if (vec[v].second + vec[u].first == 0) {

					}
					else {
						pr = vec[v].second + vec[u].first;
					}
				}
				else {
					f = 0;
				}
			}

			if (f) {
				cout << "Yes\n";
				for (auto c : perm) cout << c << " ";

				return 0;
			}
		} while (next_permutation(perm.begin(), perm.end()));
	}

	cout << "No";

	return 0;
}


/*
3
1 7
3
1 8
6
2 8
1 6

4
1 5
0
1 0
0
1 3
3
1 0
0

4
1 5
2
1 3
2
1 5
4
1 6
4
*/