#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 1e5 + 100;


vector<ll> good;
string cur;

void rec(ll lng = 0, ll dif = 0) {
	if (lng >= 19 || dif >= 3) return;

	for (int i = 0; i <= 9; i++) {
		cur.push_back(i + '0');
		set<char> s;
		for (auto c : cur) s.insert(c);
		rec(lng + 1, s.size());
		cur.pop_back();
	}

	if (lng) good.push_back(stoll(cur));
}

int main() {
	fastInp;

	string num;
	cin >> num;
	ll tp;
	cin >> tp;

	ll a = stoll(num);
	string nm1, nm2;
	for (int i = 0; i < num.size(); i++) {
		nm1.push_back(num[0]);
		if (num[0] != '9') nm2.push_back(num[0] + 1);
	}

	if (num[0] == '9') {
		nm2.push_back('1');
		for (int i = 0; i < num.size(); i++) nm2.push_back('1');
	}

	good.push_back(stoll(nm1));
	good.push_back(stoll(nm2));

	
	if (tp == 1) {
		rec();

		/*if (num[0] == '9') {
			nm2.clear();
			nm2.push_back('1');
			for (int i = 0; i < num.size(); i++) nm2.push_back('0');

			good.push_back(stoll(nm2));
		}

		string curN;
		ll mx = 0;
		for (int i = 0; i < num.size(); i++) {
			curN.clear();
			for (int j = 0; j < i; j++) curN.push_back(mx + '0');
			curN.push_back(num[i]);
			for (int t = i + 1; t < num.size(); t++) curN.push_back(min(int(mx + '0'), num[i] + 0));
			good.push_back(stoll(curN));

			curN.clear();
			for (int j = 0; j < i; j++) curN.push_back(mx + '0');
			curN.push_back(num[i]);
			for (int t = i + 1; t < num.size(); t++) curN.push_back(max(int(mx + '0'), num[i] + 0));
			good.push_back(stoll(curN));
			if (num[i] == '9') {
				mx = 9;
				continue;
			}
			curN.clear();

			for (int j = 0; j < i; j++) curN.push_back(mx + '0');
			curN.push_back(num[i] + 1);
			for (int t = i + 1; t < num.size(); t++) curN.push_back(min(int(mx + '0'), num[i] + 1));
			mx = max(mx, ll(num[i] - '0'));
			good.push_back(stoll(curN));
		
			curN.clear();
			
		}*/
	}

	sort(good.begin(), good.end());

	for (int i = 0; i < good.size(); i++) {
		string s = to_string(good[i]);
		set<char> st;
		for (auto c : s) st.insert(c);

		if (st.size() == 1 + tp && good[i] >= a) {
			cout << good[i];
			return 0;
		}
	}

	return 0;
}