#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 1e5 + 100;

ll grid[12][12];

void tle() {
	tle();
}

bool check(ll n, ll m) {
	for (int i = 0; i < n; i++) {
		for (int i2 = i + 1; i2 < n; i2++) {
			for (int j = 0; j < m; j++) {
				for (int j2 = j + 1; j2 < m; j2++) {
					if (grid[i][j] == grid[i2][j] && grid[i2][j] == grid[i2][j2] && grid[i2][j2] == grid[i][j2]) return false;
				}
			}
		}
	}

	return true;
}

ll n, m, c;
void out() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << grid[i][j] + 1 << " ";
		}
		cout << "\n";
	}
}
int main() {
	fastInp;

	cin >> n >> m >> c;

	if (c == 2) {
		ll pw = (1ll << (n * m));

		for (int i = 0; i < pw; i++) {
			ll c = 0;
			for (int k = 0; k < n; k++) {
				for (int j = 0; j < m; j++) {
					grid[k][j] = (i >> c) & 1;
					c++;
				}
			}
			if (check(n, m)) {
				out();
				return 0;
			}
		}
	}
	
	if (n * m >= 20) {
		return 1;
	}

	return 0;
	bool f = 0;
	if (n > m) {
		swap(n, m);
		f = 1;
	}

	set<ll> lft[3];
	vector<ll> l2[12];
	for (int i = 0; i < n; i++) {
		for (int t = 0; t < c; t++) {
			lft[t].insert(i);
			l2[i].push_back(t);
		}
		random_shuffle(l2[i].begin(), l2[i].end());
	}
	ll c1 = 0;
	for (int j = 0; j < m; j++) {
		vector<bool> used(n);
		for (int t = 0; t < c; t++) {
			if (lft[t].size() != n) {
				ll v = 0;
				for (int k = 0; k < n; k++) {
					if (lft[t].find(k) == lft[t].end()) v = k;
				}
				grid[v][j] = t;
				used[v] = 1;
			}
		}
		for (int i = 0; i < n; i++) {
			if (used[i]) continue;

			lft[l2[i][0]].erase(i);
			grid[i][j] = (l2[i][0]);
			l2[i].erase(l2[i].begin());
			
			c1++;
			c1 %= c;
		}
	}

	if (f) {
		swap(n, m);
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ll i1 = i, j1 = j;
			if (f) swap(i1, j1);

			cout << grid[i1][j1] + 1 << " ";
		}
		cout << "\n";
	}

	return 0;
}