#include <iostream>
#include <vector>

using namespace std;

int t(char c) {
    return (int)c - (int)'1' + 1;
}

struct col{
    bool o, s, valid, z;
    col(int a, int b, int c) {
        s = (a + b + 1) % 10 == c;
        o = (a + b >= 10) || ((a + b == 9) && s);
        valid = ((a + b) % 10 == c) || s;
        z = (a == 0) || (b == 0) || (c == 0);
    }
};

int n;
vector<col> g;
vector<bool> used;

int f(int cur, int left, bool first = false) {
    if (left == 0) return 1;
    used[cur] = true;
    int res = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i] && (!first || !g[i].z) && !(g[cur].s ^ g[i].o) && !(left == 1 && g[i].s)) {
            res += f(i, left - 1);
            used[i] = false;
        }
    }
    return res;
}

int main() {
    string a, b, c;
    cin >> a >> b >> c;
    n = a.length();
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        col q = col(t(a[i]), t(b[i]), t(c[i]));
        if (!q.valid) {
            cout << 0;
            return 0;
        }
        g.push_back(q);
    }
    g.emplace_back(0, 0, 0);
    cout << f(n, n, true);
}
