#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <ctime>
#include <map>
#include <random>
#include <iomanip>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <bitset>
#include <deque>
#include <utility>
#include <fstream>

using namespace std;

const int MAX_MEM = 2e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new( size_t n ) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos <= MAX_MEM);
    return (void *)res;
}
inline void operator delete ( void * ) { }


/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")*/


#define int long long

const int INF = 1e18;
const int MAXL = 1e7 + 10;


char S[MAXL];


char another(char &c)
{
    if (c == 'A')
        return 'G';
    if (c == 'G')
        return 'C';
    if (c == 'C')
        return 'T';
    if (c == 'T')
        return 'A';
}

int32_t main()
{
    string s; cin >> s;
    vector<pair<int, char>> blocks;
    int num = 0, lst = 0;
    for (int i = 0; i < s.size(); i++)
    {
        if ('0' <= s[i] && s[i] <= '9')
        {
            num *= 10;
            num += (s[i] - '0');
        }
        else
        {
            /*int bar = lst + num;
            for (; lst < bar; lst++)
                S[lst] = s[i];*/
            blocks.push_back({max(num, (int)1), s[i]});
            num = 0;
        }
    }
    int n = (int)s.size();
    int before = 0;
    char symb = another(blocks[0].second);
    int type = 1, pos = 0, new_sz = n + 1;
    for (int i = 0; i < blocks.size(); i++)
    {
        int nwn = blocks[i].first + 1;
        int st = 1, szn = 1;
        while ((st * 10) <= blocks[i].first)
        {
            st *= 10;
            szn++;
        }
        int was = szn;
        while ((st * 10) <= nwn)
        {
            st *= 10;
            szn++;
        }
        if (n + (szn - was) > new_sz)
        {
            new_sz = n + (szn - was);
            pos = before;
            symb = blocks[i].second;
        }

        st = 1, szn = 1;
        while ((st * 10) <= blocks[i].first)
            st *= 10;
        int num1 = max(blocks[i].first % st, (int)1);
        int num2 = blocks[i].first - num1;
        int sz1 = 1, st1 = 1, sz2 = 1, st2 = 1;
        if (num1 > 0 && num2 > 0)
        {
            while ((10 * st1) <= num1)
            {
                sz1++;
                st1 *= 10;
            }
            while ((10 * st2) <= num2)
            {
                sz2++;
                st2 *= 10;
            }
            int mbans = n + (sz1 + sz2 - was) + 2;
            if (num1 == 1)
                mbans--;
            if (num2 == 1)
                mbans--;
            if (mbans > new_sz)
            {
                new_sz = mbans;
                pos = before + num1;
                symb = another(blocks[i].second);
            }
        }
        num1 = blocks[i].first / 2;
        num2 = blocks[i].first - num1;
        sz1 = 1, st1 = 1, sz2 = 1, st2 = 1;
        if (num1 > 0 && num2 > 0)
        {
            while ((10 * st1) <= num1)
            {
                sz1++;
                st1 *= 10;
            }
            while ((10 * st2) <= num2)
            {
                sz2++;
                st2 *= 10;
            }
            int mbans = n + (sz1 + sz2 - was) + 2;
            if (num1 == 1)
                mbans--;
            if (num2 == 1)
                mbans--;
            if (mbans > new_sz)
            {
                new_sz = mbans;
                pos = before + num1;
                symb = another(blocks[i].second);
            }
        }
        before += blocks[i].first;
    }
    vector<vector<int>> result;
    result.push_back(vector<int>{type, pos, symb - 'A'});


    new_sz = INF;
    symb = blocks[0].second;
    type = 2, pos = 0;
    before = 0;
    for (int i = 0; i < blocks.size(); i++)
    {
        int nwn = blocks[i].first - 1;
        int st = 1, szn = 1, was = 0;
        while ((st * 10) <= blocks[i].first)
        {
            st *= 10;
            szn++;
        }
        was = szn;
        st = 1, szn = 1;
        while ((st * 10) <= nwn)
        {
            st *= 10;
            szn++;
        }

        if (nwn == 0)
        {
            int dif = -1;
            if (0 < i && i < (int)blocks.size() - 1 && (blocks[i - 1].second == blocks[i + 1].second))
            {
                int sz1 = 1, st1 = 1, sz2 = 1, st2 = 1, sz3 = 1, st3 = 1;
                while ((10 * st1) <= blocks[i - 1].first)
                {
                    st1 *= 10;
                    sz1++;
                }
                while ((10 * st2) <= blocks[i + 1].first)
                {
                    st2 *= 10;
                    sz2++;
                }
                nwn = blocks[i - 1].first + blocks[i + 1].first;
                while ((10 * st3) <= nwn)
                {
                    st3 *= 10;
                    sz3++;
                }
                dif = -(sz1 + 1) - (sz2 + 1) - 1 + (sz3 + 1);
            }
            int nw_ans = n + dif;
            if (nw_ans < new_sz)
            {
                new_sz = nw_ans;
                symb = blocks[i].second;
                pos = before + 1;
            }
        }
        else
        {
            int nw_ans = n + (szn - was);
            if (nw_ans < new_sz)
            {
                new_sz = nw_ans;
                symb = blocks[i].second;
                pos = before + 1;
            }
        }
        before += blocks[i].first;
    }
    cout << type << " " << pos << endl;
    cout << result[0][0] << " " << result[0][1] << " " << (char)('A' + result[0][2]) << endl;
    return 0;
}
