#include <bits/stdc++.h>
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

struct block {
    int x, len;
    char symb;
};

int get_len_of_number(int x) {
    if (x == 1)
        return 0;
    int res = 0;
    while (x) {
        res++;
        x /= 10;
    }
    return res;
}

int code(string s) {
    int len = 0;
    int i = 0, n = (int)s.size();
    while (i < n) {
        int j = i;
        while (j < n && s[j] == s[i])
            j++;
        len += (get_len_of_number(j - i) + 1);
        i = j;
    }
    return len;
}

pair <int, int> solve_min(string t) {
    int n = (int)t.size();
    int ans = n, pos = 0;
    for (int i = 0; i < n; i++) {
        string new_t = "";
        for (int j = 0; j < i; j++)
            new_t += t[j];
        for (int j = i + 1; j < n; j++)
            new_t += t[j];
        if (code(new_t) < ans) {
            ans = code(new_t);
            pos = i;
        }
    }
    return {ans, pos};
}

pair <int, pair <int, char> > solve_max(string t) {
    int n = (int)t.size();
    int ans = 0, pos = 0;
    char need;
    vector <char> all = {'A', 'C', 'G', 'T'};
    for (int i = 0; i <= n; i++) {
        string new_t = "";
        for (int j = 0; j < i; j++)
            new_t += t[j];
        for (char nxt : all) {
            string kek = new_t + nxt;
            for (int j = i; j < n; j++)
                kek += t[j];
            if (code(kek) > ans) {
                ans = code(kek);
                pos = i;
                need = nxt;
            }
        }
    }
    return {ans, {pos, need}};
}

pair <int, pair <int, int> > get_best(int x) {
    int res = -1;
    pair <int, int> smth;
    if (x <= 500ll) {
        for (int i = 1; i < x; i++) {
            //cout << i << " " << x - i << " " << get_len_of_number(i) + get_len_of_number(x - i) << " aa\n";
            if (get_len_of_number(i) + get_len_of_number(x - i) > res) {
                res = get_len_of_number(i) + get_len_of_number(x - i);
                smth = {i, x - i};
            }
        }
        return {res, smth};
    }
    int deg = 1;
    for (int i = 0; i < 13; i++) {
        if (deg < x) {
            if (res < get_len_of_number(deg) + get_len_of_number(x - deg) > res) {
                smth = {deg, x - deg};
                res = get_len_of_number(deg) + get_len_of_number(x - deg);
            }
        }
        else
            break;
        deg *= 10;
    }
    return {res, smth};
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string s;
    cin >> s;
    int n = (int)s.size();
    int i = 0;
    vector <block> bl;
    int smth = 0;
    while (i < n) {
        block new_block;
        if (!('0' <= s[i] && s[i] <= '9')) {
            new_block.x = 1;
            new_block.symb = s[i];
            new_block.len = 0;
            bl.push_back(new_block);
            smth++;
            i++;
            //t += s[i];
            continue;
        }
        int j = i;
        vector <int> kek;
        while (j < n && s[j] >= '0' && '9' >= s[j]) {
            kek.push_back(s[j] - '0');
            j++;
        }
        new_block.symb = s[j];
        reverse(kek.begin(), kek.end());
        int lol = 0, now = 1;
        for (int q = 0; q < (int)kek.size(); q++) {
            lol += kek[q] * now;
            now *= 10;
        }
        new_block.x = lol;
        new_block.len = (int)kek.size();
        i = j + 1;
        bl.push_back(new_block);
        smth += new_block.x;
       // cout << new_block.symb << " " << new_block.x << " " << new_block.len << "\n";
    }

    set <int> degs;
    int now = 10;
    for (int i = 0; i < 12; i++) {
        degs.insert(now);
        now *= 10;
    }
    int min_ans = n, pos = -1, cur_pos = 0;
    for (int i = 0; i < (int)bl.size(); i++) {
        block cur = bl[i];
        if (cur.x == 1) {
            if (i && i < (int)bl.size() - 1) {
                //cout << i << " nvdjfi\n";
                if (bl[i - 1].symb == bl[i + 1].symb) {
                    if (min_ans > n - 1 - 2 - bl[i + 1].len - bl[i - 1].len + get_len_of_number(bl[i + 1].x + bl[i - 1].x) + 1) {
                        min_ans = n - 1 - 2 - bl[i + 1].len - bl[i - 1].len + get_len_of_number(bl[i + 1].x + bl[i - 1].x) + 1;
                        pos = cur_pos;
                    }
                }
                else {
                    if (n - 1 < min_ans) {
                        min_ans = n - 1;
                        pos = cur_pos;
                    }
                }
            }
            else {
                if (n - 1 < min_ans) {
                    min_ans = n - 1;
                    pos = cur_pos;
                }
            }
        }
        if (degs.find(cur.x) != degs.end() && n - 1 < min_ans) {
            min_ans = n - 1;
            pos = cur_pos;
        }
        if (cur.x == 2) {
            if (n - 1 < min_ans) {
                min_ans = n - 1;
                pos = cur_pos;
            }
        }
        cur_pos += bl[i].x;
    }
    //cout << min_ans << " aaaa\n";
   // auto rofl = solve_min(t);
    //cout << rofl.first << " min_correct\n";
   // cout << 2 << " " << rofl.second + 1 << " correct\n";
    if (pos == -1)
        cout << 2 << " " << cur_pos << "\n";
    else
        cout << 2 << " " << pos + 1 << "\n";


    int max_ans = n;
    pos = -1;
    cur_pos = 0;
    char need;
    for (int i = 0; i < (int)bl.size(); i++) {
        block cur = bl[i];
        if (cur.x != 1) {
            auto more = get_best(cur.x);
            int res = n - bl[i].len - 1 + more.first + 3;
            if (res > max_ans) {
                max_ans = res;
                if (bl[i].symb == 'A')
                    need = 'G';
                else
                    need = 'A';
                pos = cur_pos + more.second.first;
            }
        }
        cur_pos += bl[i].x;
    }
    //cout << max_ans << " nvud\n";
    if (pos == -1) {
        cout << 1 << " " << cur_pos << " ";
        if (s.back() == 'A')
            cout << "G\n";
        else
            cout << "A\n";
    }
    else
        cout << 1 << " " << pos << " " << need << "\n";
    //auto lol = solve_max(t);
    //cout << lol.first << " hbvfuginbfgiu\n";
   //cout << 1 << " " << lol.second.first << " " << lol.second.second << "\n";
   //19A2G14C
    return 0;
}
