#include <bits/stdc++.h>
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

int n;
vector <pair <int, vector <int> > > a;
vector <vector <int> > combs, gr;
vector <multiset <int> > edges;

void calc(vector <int> cur) {
    if ((int)cur.size() == n) {
        combs.push_back(cur);
        return;
    }
    for (int i = 0; i < n; i++) {
        bool fl = true;
        for (int j = 0; j < (int)cur.size(); j++) {
            if (cur[j] == i) {
                fl = false;
                break;
            }
        }
        if (fl) {
            cur.push_back(i);
            calc(cur);
            cur.pop_back();
        }
    }
}

vector <int> cycle, used;

void dfs(int v) {
    used[v] = 1;
    cycle.push_back(v);
    for (int to : gr[v]) {
        if (!used[to])
            dfs(to);
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    a.resize(n);
    int len[n];
    set <int> all;
    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        len[i] = s;
        a[i].first = s;
        vector <int> kek(m);
        for (int j = 0; j < m; j++)
            cin >> kek[j];
        a[i].second = kek;
        for (int j = 0; j < m - 1; j++)
            all.insert(kek[j + 1] - kek[j]);
    }
    if ((int)all.size() > 1) {
        cout << "No\n";
        return 0;
    }
    map <int, vector <vector <int> > > smth;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
            int w = a[j].second[0] + len[i] - a[i].second.back();
           // cout << w << " " << i << " " << j << " jvbiuf\n";
            if (smth.find(w) == smth.end()) {
                smth[w].resize(n);
            }
            smth[w][i].push_back(j);
        }
    }
    for (auto el : smth) {
        //cout << el.first << " nvbjk\n";
        //edges.clear();
        cycle.clear();
      //  edges.resize(n);
        gr = el.second;
      // for (int i = 0; i < n; i++) {
           // for (int j : gr[i]) {
                //edges[i].insert(j);
           // }
        //}
        for (int i = 0; i < n; i++) {
            if (!gr[i].empty()) {
                used.clear();
                used.resize(n);
                cycle.clear();
                dfs(i);
                if ((int)cycle.size() == n) {
                    cout << "Yes\n";
                    for (int v : cycle)
                        cout << v + 1 << " ";
                    cout << "\n";
                    return 0;
                }
            }
        }
    }
    cout << "No\n";
    /*calc({});

    for (auto el : combs) {
        vector <int> points;
        int now = 0;
        for (int i = 0; i < n; i++) {
            for (int x : a[el[i]].second)
                points.push_back(now + x);
            now += len[el[i]];
        }
        bool fl = true;
        for (int i = 1; i < (int)points.size() - 1; i++) {
            if (points[i] - points[i - 1] != points[i + 1] - points[i]) {
                fl = false;
                break;
            }
        }
        if (fl) {
            cout << "Yes\n";
            for (int x : el)
                cout << x + 1 << " ";
            cout << "\n";
            return 0;
        }
    }
    cout << "No\n";*/
    return 0;
}
