#include <bits/stdc++.h>
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

int get_len(int x) {
    int res = 0;
    while (x) {
        res++;
        x /= 10;
    }
    return res;
}

vector <int> get_digits(int x) {
    vector <int> res;
    while (x) {
        res.push_back(x % 10);
        x /= 10;
    }
    reverse(res.begin(), res.end());
    return res;
}

int get_number(vector <int> d) {
    int res = 0;
    reverse(d.begin(), d.end());
    int now = 1;
    for (int x : d) {
        res += x * now;
        now *= 10;
    }
    return res;
}

void solve_bad(int x) {
    vector <int> d = get_digits(x);
    for (int fd = 1; fd <= 9; fd++) {
        vector <int> kek;
        for (int i = 0; i < (int)d.size(); i++) {
            kek.push_back(fd);
        }
        int y = get_number(kek);
        if (y >= x) {
            cout << y << "\n";
            return;
        }
    }
    for (int i = 0; i < (int)d.size() + 1; i++)
        cout << "1";
    cout << "\n";
}

void solve_good(int x) {
    cout << x << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int x, k;
    cin >> x >> k;
    if (!k)
        solve_bad(x);
    else
        solve_good(x);
    return 0;
}
