#include <bits/stdc++.h>
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

vector <int> get_digits(int x) {
    vector <int> res;
    while (x) {
        res.push_back(x % 10);
        x /= 10;
    }
    reverse(res.begin(), res.end());
    return res;
}

int get_number(vector <int> d) {
    int res = 0;
    reverse(d.begin(), d.end());
    int now = 1;
    for (int x : d) {
        res += x * now;
        now *= 10;
    }
    return res;
}

int solve_bad(int x) {
    vector <int> d = get_digits(x);
    for (int fd = 1; fd <= 9; fd++) {
        vector <int> kek;
        for (int i = 0; i < (int)d.size(); i++) {
            kek.push_back(fd);
        }
        int y = get_number(kek);
        if (y >= x) {
            return y;
        }
    }
    vector <int> kek;
    for (int i = 0; i < (int)d.size() + 1; i++)
        kek.push_back(1);
    return get_number(kek);
}

int solve_good(int x) {
    vector <int> d = get_digits(x);
    int len = (int)d.size();
    int ans = 4e18;
    for (int i = 0; i < len; i++) {
        for (int d1 = 0; d1 <= 9; d1++) {
            if (!i && !d1)
                continue;
            for (int d2 = 0; d2 <= 9; d2++) {
                if (i && !d2)
                    continue;
                vector <int> y_digits;
                for (int j = 0; j < i; j++)
                    y_digits.push_back(d2);
                y_digits.push_back(d1);
                for (int j = i + 1; j < len; j++)
                    y_digits.push_back(d2);
                int y = get_number(y_digits);
                if (y >= x)
                    ans = min(ans, y);
            }
        }
    }
    if (ans != 4e18) {
        return ans;
    }
    vector <int> kek = {1};
    for (int i = 0; i < len; i++)
        kek.push_back(0);
    return get_number(kek);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int x, k;
    cin >> x >> k;
    if (!k)
        cout << solve_bad(x);
    else
        cout << min(solve_good(x), solve_bad(x));
    return 0;
}
