#include <iostream>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <functional>
#include <bitset>
#include <queue>
#include <deque>
#include <cassert>
#include <chrono>
#include <random>
#include <ctime>
#include <cstdio>
#include <cmath>
#include <stack>
#include <string>
#include <iomanip>
#include <utility>
#include <algorithm>

/*
#pragma GCC optimize("Ofast")
#pragma	GCC optimize("unroll-loops")
#pragma	GCC optimize("O3")
#pragma	GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,mmx,abm,avx,avx2,tune=native")
*/

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define siz(x) (long long)x.size()
#define all(x) x.begin(),x.end()
#define left left1337
#define right right1337
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto&x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)

using namespace std;

template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}
template<typename T>ostream& operator << (ostream &os, const vector<T> &a) {
	fx(x, a)
		os << x << ' ';
	return os;
}

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vch;
typedef vector<vch> vvch;
typedef vector<str> vs;


const int MOD = (int)1e9 + 7; //998244353
const int INF = (int)1e9 + 50;
const ll BIG = (ll)2e18 + 50;
const int MX = (int)2e5 + 50;
const double EPS = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

vch alp = {'A', 'G', 'C', 'T'};

bool isd(char c) {
	return c >= '0' && c <= '9';
}

str decode(const str & s) {
	int n = (int)s.size();
	int i = 0;
	str res;
	while (i < n) {
		if (isd(s[i])) {
			int j = i;
			while (j < n && isd(s[j]))
				++j;
			res += str(stoi(s.substr(i, j - i)), s[j]);
			i = j + 1; 
		} else {
			res += s[i++];
		}
	}
	return res;
}

int encode(const str & s) {
	int n = (int)s.size();
	int i = 0;
	str res;
	while (i < n) {
		if (i != n - 1 && s[i + 1] == s[i]) {
			int j = i + 2;
			while (j < n && s[j] == s[i]) {
				++j;
			}
			res += to_string(j - i);
			res += s[i];
			i = j;
		} else {
			res += s[i++];
		}
	}
	return res.size();
}

void smin(str s) {
	int n = (int)s.size();
	int mn = INF;
	int ans = 0;
	fi(0, n) {
		str kek = s.substr(0, i) + s.substr(i + 1);
		int res = encode(kek);
		if (res < mn) {
			ans = i + 1;
			mn = res;
		}
	}
	//dbg(mn);
	cout << 2 << ' ' << ans << '\n';
}

void smax(str s) {
	int n = (int)s.size();
	int mx = 0;
	int ans = 0;
	char ansc = 'A';
	fi(0, n + 1) {
		fx(c, alp) {
			if (i > 0 && c == s[i - 1]) continue;
			if (i < n && c == s[i]) continue;
			str kek = s.substr(0, i) + str(1, c) + s.substr(i);
			int res = encode(kek);
			if (res > mx) {
				ans = i;
				ansc = c;
				mx = res;
			}
			break;
		}
	}
	//dbg(mx);
	cout << 1 << ' ' << ans << ' ' << ansc << '\n';
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	str s;
	cin >> s;
	str d = decode(s);
	smin(d);
	smax(d);
}
