#include <iostream>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <functional>
#include <bitset>
#include <queue>
#include <deque>
#include <cassert>
#include <chrono>
#include <random>
#include <ctime>
#include <cstdio>
#include <cmath>
#include <stack>
#include <string>
#include <iomanip>
#include <utility>
#include <algorithm>

/*
#pragma GCC optimize("Ofast")
#pragma	GCC optimize("unroll-loops")
#pragma	GCC optimize("O3")
#pragma	GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,mmx,abm,avx,avx2,tune=native")
*/

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

#define int long long
#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define siz(x) (long long)x.size()
#define all(x) x.begin(),x.end()
#define left left1337
#define right right1337
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto&x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)

using namespace std;

template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}
template<typename T>ostream& operator << (ostream &os, const vector<T> &a) {
	fx(x, a)
		os << x << ' ';
	return os;
}

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vch;
typedef vector<vch> vvch;
typedef vector<str> vs;


const int MOD = (int)1e9 + 7; //998244353
const int INF = (int)1e9 + 50;
const ll BIG = (ll)2e18 + 50;
const int MX = (int)2e5 + 50;
const double EPS = 1e-9;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int add(int a, int b) {
	a += b;
	if (a >= MOD) return a - MOD;
	return a;
}

int sub(int a, int b) {
	a -= b;
	if (a < 0) return a + MOD;
	return a;
}

int mult(int a, int b) {
	return 1ll * a * b % MOD;
}

int cnt[12];
int unb[12];
int cnt2[12];
bool z[MX];
int rc() {
	char x;
	cin >> x;
	return (int)(x - '0');
}

const vi pos = {-1, 0, 9, 10};


int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	str s;
	cin >> s;
	int n = s.size();
	vi a(n);
	fi(0, n) {
		a[i] = (int)(s[i] - '0');
		z[i] |= a[i] == 0; 
	}
	fi(0, n) {
		int x = rc();
		z[i] |= x == 0;
		a[i] += x;
	}
	fi(0, n) {
		int x = rc();
		z[i] |= x == 0;
		a[i] -= x;
		if (a[i] != -1 && a[i] != 0 && a[i] != 9 && a[i] != 10) {
			cout << "0\n";
			return 0;
		}
		++cnt[a[i] + 1];
		if (!z[i]) ++unb[a[i] + 1];
	}
	int ans = 0;
	for (int mask = 0; mask < (1 << n); mask += 2) {
		fx(x, pos)
			cnt2[x + 1] = cnt[x + 1];
		int need = 0;
		int cur = 1;
		for (int i = 0; i < n; ++i) {
			need -= (mask >> i) & 1;
			if (i > 0) {
				if (!cnt2[need + 1]) {
					cur = 0;
					break;
				}
				cur = mult(cur, cnt2[need + 1]);
			} else {
				if (!unb[need + 1]) {
					cur = 0;
					break;
				}
				cur = mult(cur, unb[need + 1]);
			}
			--cnt2[need + 1];
			need = (mask >> i) & 1;
			need *= 10;
		}
		ans = add(ans, cur);
	}
	cout << ans << '\n';
}
