#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>

/*
#include <immintrin.h>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2,tune=native,popcnt")
*/

using namespace std;

#define int long long

int fine(int a, int b) {
    int lst = a * b;
    return lst * (lst + 1) / 2;
}

int fn(int n, int m, int k) {
    int left = fine(k, m);
    int right = fine(n, m) - left;
    return abs(left - right);
}

int fn1(int n, int m, int k) {
    int left = (2 + m * (n - 1)) * n / 2;
    left *= k;
    left += k * (k - 1) / 2;
    int right = fine(n, m) - left;
    return abs(left - right);
}

void solve() {
    int n, m;
    cin >> n >> m;
    int l = 0, r = n;
    char tp;
    int ans = 4e18;
    int id = -1;
    while (l + 3 < r) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        int f1 = fn(n, m, m1);
        int f2 = fn(n, m, m2);
        if (f1 < f2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    for (int i = l; i <= r; ++i) {
        int curr = fn(n, m, i);
        if (curr < ans) {
            ans = curr;
            tp = 'H';
            id = i + 1;
        }
    }
    l = 0, r = m;
    while (l + 3 < r) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        int f1 = fn1(n, m, m1);
        int f2 = fn1(n, m, m2);
        if (f1 < f2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    for (int i = l; i <= r; ++i) {
        int curr = fn1(n, m, i);
        if (curr < ans) {
            ans = curr;
            tp = 'V';
            id = i + 1;
        }
    }
    cout << tp << ' ' << id << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
