#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <unordered_map>
#include <deque>

/*
#include <immintrin.h>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2,tune=native,popcnt")
*/

using namespace std;

#define int long long

string to_str(int x) {
    string res;
    while (x) {
        res += char('0' + (x % 10));
        x /= 10;
    }
    reverse(res.begin(), res.end());
    return res;
}

vector<char> can = {'A', 'G', 'C', 'T'};

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    vector<pair<int, char>> st;
    int curr = 0;
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        if (!isdigit(s[i])) {
            if (curr == 0) {
                st.push_back({1, s[i]});
            } else {
                st.push_back({curr, s[i]});
                curr = 0;
            }
        } else {
            curr *= 10;
            curr += (s[i] - '0');
        }
    }
    int min_len = 1e18;
    int max_len = 0;
    int min_t = -1, max_t = -1, min_pos = -1, max_pos = -1;
    char min_c = 'B', max_c = 'B';
    n = st.size();
    vector<int> pref(n + 1, 0);
    vector<int> suff(n + 1, 0);
    vector<int> id(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] + to_str(st[i - 1].first).size() + 1;
        if (st[i - 1].first == 1) {
            --pref[i];
        }
        id[i] = id[i - 1] + st[i - 1].first;
    }
    for (int i = n - 1; i >= 0; --i) {
        suff[i] = suff[i + 1] + to_str(st[i].first).size() + 1;
        if (st[i].first == 1) {
            --suff[i];
        }
    }
    //delete
    for (int i = 0; i < n; ++i) {
        if (st[i].first == 1) {
            if (i - 1 >= 0 && i + 1 < n) {
                int curr = pref[i - 1] + suff[i + 2];
                if (st[i - 1].second == st[i + 1].second) {
                    curr += to_str(st[i - 1].first + st[i + 1].first).size() + 1;
                } else {
                    curr = pref[i] + suff[i + 1];
                }
                if (curr < min_len) {
                    min_len = curr;
                    min_pos = id[i] + 1;
                    min_t = 2;
                }
            } else {
                int curr = pref[i] + suff[i + 1];
                if (curr < min_len) {
                    min_len = curr;
                    min_pos = id[i] + 1;
                    min_t = 2;
                }
            }
        }
    }

    // change
    for (int i = 0; i < st.size(); ++i) {
        if (st[i].first == 1) {
            int curr = pref[i] + suff[i + 1] + 1;
            if (curr > max_len) {
                max_len = curr;
                max_pos = id[i] + 1;
                max_t = 3;
                for (char x : can) {
                    if (x != st[i - 1].second && x != st[i + 1].second && x != st[i].second) {
                        max_c = x;
                    }
                }
            }
        }
    }

    // delete el

    for (int i = 0; i < st.size(); ++i) {
        if (st[i].first != 1) {
            int now = st[i].first - 1;
            int curr = pref[i] + suff[i + 1] + to_str(now).size() + 1;
            if (now == 1) {
                --curr;
            }
            if (curr < min_len) {
                min_len = curr;
                min_t = 2;
                min_pos = id[i] + 1;
            }
        }
    }

    //  add el

    for (int i = 0; i < st.size(); ++i) {
        if (st[i].first > 1) {
            int left = st[i].first / 2;
            int right = st[i].first - left;
            int curr = pref[i] + suff[i + 1];
            curr += to_str(left).size();
            curr += to_str(right).size();
            if (left == 1) {
                --curr;
            }
            if (right == 1) {
                --curr;
            }
            curr += 3;
            if (curr > max_len) {
                max_len = curr;
                max_pos = id[i] + left;
                max_t = 1;
                for (char x : can) {
                    if (x != st[i].second) {
                        max_c = x;
                    }
                }
            }
        }
    }
    if (min_t == 2) {
        cout << 2 << ' ' << min_pos << '\n';
    } else {
        return 1;
    }
    if (max_t == 3) {
        cout << 3 << ' ' << max_pos << ' ' << max_c;
    } else if (max_t == 1) {
        cout << 1 << ' ' << max_pos << ' ' << max_c;
    } else {
        return 1;
    }
}

/*
 3A4C
*/

