#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <unordered_map>
#include <deque>

/*
#include <immintrin.h>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2,tune=native,popcnt")
*/

using namespace std;

#define int long long

string to_str(int x) {
    string res;
    while (x) {
        res += char('0' + (x % 10));
        x /= 10;
    }
    reverse(res.begin(), res.end());
    return res;
}

vector<char> can = {'A', 'G', 'C', 'T'};

int pack(string t) {
    int cnt = 0;
    vector<pair<int, char>> ll;
    char p = 'B';
    for (char x : t) {
        if (x == p) {
            ++cnt;
        } else {
            if (cnt != 0)
                ll.push_back({cnt, p});
            p = x;
            cnt = 1;
        }
    }
    if (cnt != 0) {
        ll.push_back({cnt, p});
    }
    int len = 0;
    for (auto& [cnt, c] : ll) {
        len += 1;
        len += to_str(cnt).size();
        if (cnt == 1) {
            --len;
        }
    }
    return len;
}

string pack1(string t) {
    int cnt = 0;
    vector<pair<int, char>> ll;
    char p = 'B';
    for (char x : t) {
        if (x == p) {
            ++cnt;
        } else {
            if (cnt != 0)
                ll.push_back({cnt, p});
            p = x;
            cnt = 1;
        }
    }
    string res;
    int len = 0;
    for (auto& [cnt, c] : ll) {
        if (cnt != 1) {
            res += to_str(cnt);
        }
        res += c;
    }
    return res;
}

pair<int, int> solve(string s) {
    vector<pair<int, char>> st;
    int curr = 0;
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        if (!isdigit(s[i])) {
            if (curr == 0) {
                st.push_back({1, s[i]});
            } else {
                st.push_back({curr, s[i]});
                curr = 0;
            }
        } else {
            curr *= 10;

            curr += (s[i] - '0');
        }
    }
    string t;
    for (auto& [cnt, c] : st) {
        for (int j = 0; j < cnt; ++j) {
            t += c;
        }
    }
    int min_len = 1e10;
    int max_len = 0;
    int max_pos, min_pos;
    int min_t = -1, max_t = -1;
    char max_c, min_c;
    n = t.size();
    for (int j = 0; j < n; ++j) {
        for (char x : can) {
            if (t[j] == x) continue;
            string l = t;
            l[j] = x;
            int curr = pack(l);
            if (curr > max_len) {
                max_len = curr;
                max_pos = j + 1;
                max_c = x;
                max_t = 3;
            }
            if (curr < min_len) {
                min_len = curr;
                min_pos = j + 1;
                min_c = x;
                min_t = 3;
            }
        }
    }
    for (int j = 0; j <= n; ++j) {
        for (char x : can) {
            string l = t.substr(0, j);
            l += x;
            l += t.substr(j, n - j);
            int curr = pack(l);
            if (curr > max_len) {
                max_len = curr;
                max_pos = j;
                max_c = x;
                max_t = 1;
            }
            if (curr < min_len) {
                min_len = curr;
                min_pos = j;
                min_c = x;
                min_t = 1;
            }
        }
    }
    for (int j = 0; j < n; ++j) {
        string l = t.substr(0, j);
        l += t.substr(j + 1, n - j - 1);
        int curr = pack(l);
        if (curr > max_len) {
            max_len = curr;
            max_pos = j + 1;
            max_t = 2;
        }
        if (curr < min_len) {
            min_len = curr;
            min_pos = j + 1;
            min_t = 2;
        }
    }
    if (min_t == 1) {
        cout << 1 << ' ' << min_pos << ' ' << min_c << endl;
    } else if (min_t == 2) {
        cout << 2 << ' ' << min_pos << endl;
    } else {
        cout << 3 << ' ' << min_pos << ' ' << min_c << endl;
    }
    if (max_t == 1) {
        cout << 1 << ' ' << max_pos << ' ' << max_c << endl;
    } else if (max_t == 2) {
        cout << 2 << ' ' << max_pos << endl;
    } else {
        cout << 3 << ' ' << max_pos << ' ' << max_c << endl;
    }
    return {min_len, max_len};
}

pair<int, int> me(string s) {
    vector<pair<int, char>> st;
    int curr = 0;
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        if (!isdigit(s[i])) {
            if (curr == 0) {
                st.push_back({1, s[i]});
            } else {
                st.push_back({curr, s[i]});
                curr = 0;
            }
        } else {
            curr *= 10;
            curr += (s[i] - '0');
        }
    }
    int min_len = 1e18;
    int max_len = 0;
    int min_t = -1, max_t = -1, min_pos = -1, max_pos = -1;
    char min_c = 'B', max_c = 'B';
    n = st.size();
    vector<int> pref(n + 1, 0);
    vector<int> suff(n + 1, 0);
    vector<int> id(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] + to_str(st[i - 1].first).size() + 1;
        if (st[i - 1].first == 1) {
            --pref[i];
        }
        id[i] = id[i - 1] + st[i - 1].first;
    }
    for (int i = n - 1; i >= 0; --i) {
        suff[i] = suff[i + 1] + to_str(st[i].first).size() + 1;
        if (st[i].first == 1) {
            --suff[i];
        }
    }
    //delete
    for (int i = 0; i < n; ++i) {
        if (st[i].first == 1) {
            if (i - 1 >= 0 && i + 1 < n) {
                int curr = pref[i - 1] + suff[i + 2];
                if (st[i - 1].second == st[i + 1].second) {
                    curr += to_str(st[i - 1].first + st[i + 1].first).size() + 1;
                } else {
                    curr = pref[i] + suff[i + 1];
                }
                if (curr < min_len) {
                    min_len = curr;
                    min_pos = id[i] + 1;
                    min_t = 2;
                }
            } else {
                int curr = pref[i] + suff[i + 1];
                if (curr < min_len) {
                    min_len = curr;
                    min_pos = id[i] + 1;
                    min_t = 2;
                }
            }
        }
    }

    // change
    for (int i = 0; i < st.size(); ++i) {
        if (st[i].first == 1) {
            int curr = pref[i] + suff[i + 1] + 1;
            if (curr > max_len) {
                max_len = curr;
                max_pos = id[i] + 1;
                max_t = 3;
                for (char x : can) {
                    if (x != st[i - 1].second && x != st[i + 1].second && x != st[i].second) {
                        max_c = x;
                    }
                }
            }
        }
    }

    // delete el

    for (int i = 0; i < st.size(); ++i) {
        if (st[i].first != 1) {
            int now = st[i].first - 1;
            int curr = pref[i] + suff[i + 1] + to_str(now).size() + 1;
            if (now == 1) {
                --curr;
            }
            if (curr < min_len) {
                min_len = curr;
                min_t = 2;
                min_pos = id[i] + 1;
            }
        }
    }

    //  add el

    for (int i = 0; i < st.size(); ++i) {
        if (st[i].first > 1) {
            int left = st[i].first / 2;
            int right = st[i].first - left;
            int curr = pref[i] + suff[i + 1];
            curr += to_str(left).size();
            curr += to_str(right).size();
            if (left == 1) {
                --curr;
            }
            if (right == 1) {
                --curr;
            }
            curr += 3;
            if (curr > max_len) {
                max_len = curr;
                max_pos = id[i] + left;
                max_t = 1;
                for (char x : can) {
                    if (x != st[i].second) {
                        max_c = x;
                    }
                }
            }
        }
    }

    // add el to block
    for (int i = 0; i < st.size(); ++i) {
        int curr = pref[i] + suff[i + 1];
        curr += to_str(st[i].first + 1).size();
        ++curr;
        if (curr > max_len) {
            max_len = curr;
            max_t = 1;
            max_pos = id[i];
            max_c = st[i].second;
        }
    }

    if (max_len < pref[n] + 1) {
        max_len = pref[n] + 1;
        max_t = 1;
        max_pos = 0;
        for (char x : can) {
            if (x != st[0].second) {
                max_c = x;
            }
        }
    }

    /*if (min_t == 2) {
        cout << 2 << ' ' << min_pos << '\n';
    } else {
        return 1;
    }
    if (max_t == 3) {
        cout << 3 << ' ' << max_pos << ' ' << max_c;
    } else if (max_t == 1) {
        cout << 1 << ' ' << max_pos << ' ' << max_c;
    } else {
        return 1;
    }*/
    return {min_len, max_len};
}

int32_t main() {
    /*int i = 0;
    while (true) {
        string kek;
        for (int i = 0; i < 1000; ++i) {
            kek.push_back(can[rand() % 4]);
        }
        cout << "Test # : " << ++i << endl;
        kek = pack1(kek);
        if (solve(kek) != me(kek)) {
            cout << "NOOOO!!!" << endl;
            cout << kek;
            return 1;
        }
    }*/
    string s;
    cin >> s;
    solve(s);
}

/*
 3A4C
*/

