#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <stdlib.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2")

using namespace std;

int n, m, c;

void print(vector<vector<int>> &matr) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << matr[i][j] << ' ';
        }
        cout << '\n';
    }
}
vector<pair<int, int>> ord;

void gen(int i, int j, int left, vector<vector<int>> &matr, int id) {
    if (left == 0) {
        print(matr);
        exit(0);
    }
    for (int curr = 1; curr <= c; ++curr) {
        bool ok = true;
        matr[i - 1][j - 1] = curr;
        for (int d1 = 1; i - d1 > 0; ++d1) {
            for (int d2 = 1; j - d2 > 0; ++d2) {
                if (matr[i - 1][j - 1] == matr[i - d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j - d2 - 1] && matr[i - 1][j - 1] == matr[i - d1 - 1][j - d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        for (int d1 = 1; i + d1 <= n; ++d1) {
            for (int d2 = 1; j + d2 <= m; ++d2) {
                if (matr[i - 1][j - 1] == matr[i + d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j + d2 - 1] && matr[i - 1][j - 1] == matr[i + d1 - 1][j + d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        for (int d1 = 1; i + d1 <= n; ++d1) {
            for (int d2 = 1; j - d2 > 0; ++d2) {
                if (matr[i - 1][j - 1] == matr[i + d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j - d2 - 1] && matr[i - 1][j - 1] == matr[i + d1 - 1][j - d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        for (int d1 = 1; i - d1 > 0; ++d1) {
            for (int d2 = 1; j + d2 <= m; ++d2) {
                if (matr[i - 1][j - 1] == matr[i - d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j + d2 - 1] && matr[i - 1][j - 1] == matr[i - d1 - 1][j + d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        int i1 = ord[id + 1].first;
        int j1 = ord[id + 1].second;
        if (ok) {
            gen(i1, j1, left - 1, matr, id + 1);
        }
    }
}

vector<vector<int>> res = {
        {1, 1, 2, 3, 2, 2, 2, 1},
        {2, 1, 2, 2, 1, 1, 1, 3},
        {2, 1, 1, 1, 3, 3, 2, 2},
        {3, 2, 1, 2, 3, 1, 2, 1},
        {1, 3, 3, 2, 1, 2, 3, 2},
        {1, 2, 2, 1, 3, 1, 3, 2},
        {2, 2, 3, 1, 2, 3, 1, 1},
        {1, 2, 1, 3, 3, 2, 1, 3}
};

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> c;
    vector<vector<int>> matr(n, vector<int> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ord.push_back({i + 1, j + 1});
        }
    }
    random_shuffle(ord.begin(), ord.end());
    if (c == 2) {
        gen(1, 1, n * m, matr, 0);
    }
    if (n <= 8 && m <= 8) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << res[i][j] << ' ';
            }
            cout << '\n';
        }
    } else {
        gen(ord[0].first, ord[0].second, n * m, matr, 0);
    }
}
