#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <stdlib.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2")

#define int long long

using namespace std;

const int mod = 1e9 + 7;

/*int bp(int x, int n = mod - 2) {
    if (n == 0) {
        return 1;
    }
    if (n & 1) {
        return (bp(x, n - 1) * x) % mod;
    }
    int y = bp(x, n / 2);
    return (y * y) % mod;
}

int fact[300000];

int C(int n, int k) {
    int ans = fact[n];
    ans *= bp(fact[k]);
    ans %= mod;
    ans *= bp(fact[n - k]);
    ans %= mod;
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s1[i] - '0';
        b[i] = s2[i] - '0';
        c[i] = s3[i] - '0';
    }
    vector<bool> go(n, false);
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] > 9) {
            go[i] = 1;
        } else if (a[i] + b[i] > c[i]) {
            go[i] = 1;
        }
    }
    vector<bool> need(n, false);
    for (int i = 0; i < n; ++i) {
        if ((a[i] + b[i]) % 10 != c[i]) {
            if ((a[i] + b[i] + 1) % 10 != c[i]) {
                cout << 0;
                return 0;
            } else {
                need[i] = 1;
            }
        }
    }
    int can_go = 0, needed = 0;
    for (int i : need) {
        needed += i;
    }
    for (int i : go) {
        can_go += i;
    }
    if (needed != can_go) {
        cout << 0;
        return 0;
    }
    // stupid
    vector<int> p;
    vector<int> ms;
    for (int i = 0; i < n; ++i) {
        if (need[i]) {
            ms.push_back(i);
        }
        if (go[i]) {
            p.push_back(i);
        }
    }
    int cnt = 0;
    do {
        bool ok = true;
        for (int i = 0; i < needed; ++i) {
            if (p[i] == ms[i]) {
                ok = false;
            }
        }
        cnt += ok;
    } while (next_permutation(p.begin(), p.end()));
    fact[0] = 1;
    for (int i = 1; i < 300000; ++i) {
        fact[i] = fact[i - 1] * i;
        fact[i] %= mod;
    }
    int left = n - 2 * needed;
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        if (go[i] || need[i]) {
            mx += (1 << i);
        }
    }
    int ans = cnt;
    vector<vector<int>> dp(needed + 1, vector<int> (left + 1, 0));
    int sum = 0;
    for (int i = 0; i <= left; ++i) {
        dp[0][i] = 1;
    }
    for (int i = 1; i < needed; ++i) {
        for (int j = 0; j <= left; ++j) {
            for (int k = j; k >= 0; --k) {
                dp[i][j] += dp[i - 1][k];
                dp[i][j] %= mod;
            }
        }
    }
    if (needed > 0) {
        for (int i = 0; i <= left; ++i) {
            sum += dp[needed - 1][i];
        }
    } else {
        sum = 1;
    }
    ans *= sum;
    ans %= mod;
    ans *= fact[needed];
    ans %= mod;
    ans *= fact[n - needed * 2];
    ans %= mod;
    cout << ans;
}*/


#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <stdlib.h>
#include <time.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2")

using namespace std;

int n, m, c;

void print(vector<vector<int>> &matr) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << matr[i][j] << ' ';
        }
        cout << '\n';
    }
}
vector<pair<int, int>> ord;
vector<vector<bool>> used;

double TL = 2.0;

bool is_tl() {
    if (clock() / CLOCKS_PER_SEC > TL) {
        //cout << clock() / CLOCKS_PER_SEC << ' ' << TL << endl;
        return true;
    } else {
        return false;
    }
}

void gen(int i, int j, int left, vector<vector<int>> &matr, int id) {
    if (is_tl()) {
        return;
    }
    if (left == 0) {
        print(matr);
        exit(0);
    }
    for (int curr = 1; curr <= c; ++curr) {
        bool ok = true;
        matr[i - 1][j - 1] = curr;
        for (int d1 = 1; i - d1 > 0; ++d1) {
            for (int d2 = 1; j - d2 > 0; ++d2) {
                if (matr[i - 1][j - 1] == matr[i - d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j - d2 - 1] && matr[i - 1][j - 1] == matr[i - d1 - 1][j - d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        for (int d1 = 1; i + d1 <= n; ++d1) {
            for (int d2 = 1; j + d2 <= m; ++d2) {
                if (matr[i - 1][j - 1] == matr[i + d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j + d2 - 1] && matr[i - 1][j - 1] == matr[i + d1 - 1][j + d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        for (int d1 = 1; i + d1 <= n; ++d1) {
            for (int d2 = 1; j - d2 > 0; ++d2) {
                if (matr[i - 1][j - 1] == matr[i + d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j - d2 - 1] && matr[i - 1][j - 1] == matr[i + d1 - 1][j - d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        for (int d1 = 1; i - d1 > 0; ++d1) {
            for (int d2 = 1; j + d2 <= m; ++d2) {
                if (matr[i - 1][j - 1] == matr[i - d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j + d2 - 1] && matr[i - 1][j - 1] == matr[i - d1 - 1][j + d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        int i1 = ord[id + 1].first;
        int j1 = ord[id + 1].second;
        if (ok) {
            gen(i1, j1, left - 1, matr, id + 1);
        }
    }
}

void gen1(int i, int j, int left, vector<vector<int>> &matr) {
    if (left == 0) {
        print(matr);
        exit(0);
    }
    for (int curr = 1; curr <= c; ++curr) {
        bool ok = true;
        matr[i - 1][j - 1] = curr;
        for (int d1 = 1; i - d1 > 0; ++d1) {
            for (int d2 = 1; j - d2 > 0; ++d2) {
                if (matr[i - 1][j - 1] == matr[i - d1 - 1][j - 1] && matr[i - 1][j - 1] == matr[i - 1][j - d2 - 1] && matr[i - 1][j - 1] == matr[i - d1 - 1][j - d2 - 1]) {
                    ok = false;
                    break;
                }
            }
        }
        int i1 = i;
        int j1 = j + 1;
        if (j1 == m + 1) {
            j1 = 1;
            i1 = i + 1;
        }
        if (ok) {
            gen1(i1, j1, left - 1, matr);
        }
    }
}

vector<vector<int>> res = {
{3, 2, 2, 1, 2, 3, 1, 1, 3},
{2, 2, 3, 1, 1, 1, 3, 2, 3},
{1, 2, 1, 2, 3, 3, 2, 3, 1},
{2, 3, 2, 2, 3, 1, 3, 1, 1},
{1, 3, 3, 2, 2, 1, 1, 3, 2},
{1, 1, 3, 3, 1, 3, 2, 1, 2},
{3, 1, 3, 2, 3, 2, 1, 2, 1},
{2, 3, 1, 3, 2, 2, 2, 1, 3},
{3, 2, 1, 3, 1, 2, 3, 3, 2}
};

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    cin >> n >> m >> c;
    vector<vector<int>> matr(n, vector<int> (m));
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            ord.push_back({i, j});
        }
    }
    random_shuffle(ord.begin(), ord.end());
    if (c == 2) {
        gen1(1, 1, n * m, matr);
    }
    if (n <= 9 && m <= 9) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << res[i][j] << ' ';
            }
            cout << '\n';
        }
    } else if (max(n, m) <= 9 && min(n, m) <= 8) {
        if (n > m) {
            vector<vector<int>> res1(9, vector<int> (8));
            for (int i = 0; i < 8; ++i) {
                for (int j = 0; j < 9; ++j) {
                    res1[j][i] = res[i][j];
                }
            }
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << res1[i][j] << ' ';
                }
                cout << '\n';
            }
        } else {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << res[i][j] << ' ';
                }
                cout << '\n';
            }
        }
    } else {
        gen(ord[0].first, ord[0].second, n * m, matr, 0);
    }
}
