#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <stdlib.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4.1,sse4.2")

#define int long long

using namespace std;

const int mod = 1e9 + 7;

int bp(int x, int n = mod - 2) {
    if (n == 0) {
        return 1;
    }
    if (n & 1) {
        return (bp(x, n - 1) * x) % mod;
    }
    int y = bp(x, n / 2);
    return (y * y) % mod;
}

int fact[300000];

int C(int n, int k) {
    int ans = fact[n];
    ans *= bp(fact[k]);
    ans %= mod;
    ans *= bp(fact[n - k]);
    ans %= mod;
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s1[i] - '0';
        b[i] = s2[i] - '0';
        c[i] = s3[i] - '0';
    }
    vector<bool> go(n, false);
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] > 9) {
            go[i] = 1;
        } else if (a[i] + b[i] > c[i]) {
            go[i] = 1;
        }
    }
    vector<bool> need(n, false);
    for (int i = 0; i < n; ++i) {
        if ((a[i] + b[i]) % 10 != c[i]) {
            if ((a[i] + b[i] + 1) % 10 != c[i]) {
                cout << 0;
                return 0;
            } else {
                need[i] = 1;
            }
        }
    }
    int can_go = 0, needed = 0;
    for (int i : need) {
        needed += i;
    }
    for (int i : go) {
        can_go += i;
    }
    if (needed != can_go) {
        cout << 0;
        return 0;
    }
    // stupid
    vector<vector<int>> dp((1 << n), vector<int> (n, 0));
    dp[0][0] = 1;
    for (int i = 0; i < (1 << n); ++i) {
        for (int j = 0; j < n; ++j) {
            for (int p = 0; p < n; ++p) {
                if ((1 << p) & i) {
                    if (!go[p] && !need[p]) continue;
                    int t = 1;
                    if (need[p] == go[p]) {
                        t = 0;
                    }
                    if (go[p] && j - 1 < 0) {
                        continue;
                    } else if (go[p] && !need[p]) {
                        t = -1;
                    }
                    if (j + t < n) {
                        dp[i][j] += dp[i ^ (1 << p)][j + t];
                        dp[i][j] %= mod;
                    }
                }
            }
        }
    }
    fact[0] = 1;
    for (int i = 1; i < 300000; ++i) {
        fact[i] = fact[i - 1] * i;
        fact[i] %= mod;
    }
    int left = n - 2 * needed;
    int ans = 0;
    for (int i = 0; i < needed; ++i) {
        ans += C(left + 1, i + 1);
    }
    if (needed == 0) {
        ans = 1;
    }
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        if (go[i] || need[i]) {
            mx += (1 << i);
        }
    }
    ans *= dp[mx][0];
    ans %= mod;
    ans *= fact[n - needed * 2];
    ans %= mod;
    cout << ans;
}