#include <bits/stdc++.h>

#define int long long 

#define pii pair<int, int>

#define x1 x1228 
#define y1 y1228 

#define left left228 
#define right right228 

#define pb push_back 
#define eb emplace_back 

#define mp make_pair

#define ff first 
#define ss second 

#define all(x) (x).begin(), (x).end()
#define TIME (ld)clock()/CLOCKS_PER_SEC 

using namespace std; 
typedef long long ll; 
typedef long double ld; 

const int maxn = 3e5 + 7, mod = 1e9 + 7, MAXN = 2e6 + 7; 
const double eps = 1e-9; 
const ll INF = 1e18, inf = 1e15; 
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
int n; 
string s; 
vector<pii> tet; 
map<char, int> alf; 

int get(int x) {
    if (x == 1) return 0; 
    int len = 0; 
    while (x) {
        ++len; 
        x /= 10; 
    }
    return len; 
}

struct req {
    int type; 
    int x;
    int alf; 
    int ans; 
};            

bool operator<(req a, req b) {
    return a.ans < b.ans;
}

int mex(vector<int> tet) {
    for (int i = 0; i < 4; ++i) {
        bool ok = false; 
        for (auto v : tet) ok |= (v == i); 
        if (!ok) return i; 
    }            
    return -1; 
}

int f(string s) {
    int ans = 0; 
    int lst = s[0], cnt = 1;
    for (int i = 1; i < (int)s.size(); ++i) {
        if (lst == s[i]) ++cnt;
        else {
            ans++;
            ans += get(cnt); 
            cnt = 1; 
            lst = s[i]; 
        } 
    }
    ans++; 
    ans += get(cnt);
    return ans; 
}

string del(string a, int id) {
    string nw = "";
    for (int i = 0; i < (int)a.size(); ++i) {
        if (i != id) nw += a[i]; 
    }
    return nw; 
}

string add(string a, int id, char alf) {
    string nw = ""; 
    for (int i = 0; i < (int)a.size(); ++i) {
        if (i == id) nw += alf;
        nw += a[i]; 
    }
    if (id == (int)a.size()) nw += alf; 
    return nw; 
}

string hui = "ACGT"; 

int check(req a) {
    string nw = ""; 
    int id = 0; 
    while (id < n) {
        if (s[id] >= '0' && s[id] <= '9') {
            int cur = 0;
            while (id < n && s[id] >= '0' && s[id] <= '9') {
                cur *= 10;
                cur += (s[id] - '0'); 
                ++id; 
            }
            for (int i = 0; i < cur; ++i) nw += s[id]; 
            id++; 
        } else {
            nw += s[id];
            id++;
        }
    }
    if (a.type == 1) {
        nw = add(nw, a.x, hui[a.alf]); 
        return f(nw); 
    }
    if (a.type == 2) {
        nw = del(nw, a.x - 1); 
        return f(nw); 
    }
    if (nw[a.x - 1] == hui[a.alf]) return -inf; 
    nw[a.x - 1] = hui[a.alf];
    return f(nw); 
}

void solve() {

    alf['A'] = 0; 
    alf['C'] = 1; 
    alf['G'] = 2; 
    alf['T'] = 3; 
    cin >> s;
    n = s.size();
    int id = 0; 
    while (id < n) {
        if (s[id] >= '0' && s[id] <= '9') {
            int cur = 0;
            while (id < n && s[id] >= '0' && s[id] <= '9') {
                cur *= 10;
                cur += (s[id] - '0'); 
                ++id; 
            }
            tet.eb(cur, alf[s[id++]]); 
        } else {
            tet.eb(1, alf[s[id++]]);                        
        }
    }
    int rem = 0; 
    req mx = {-1, -1, -1, -inf}; 
    req mn = {-1, -1, -1, inf};     

    ////add
    for (int i = 0; i < (int)tet.size(); ++i) {
        if (true) {
            req cur;
            cur.ans = n;
            cur.type = 1;
            cur.x = rem;
            cur.alf = tet[i].ss;

            cur.ans -= (1 + get(tet[i].ff));
            cur.ans += (1 + get(tet[i].ff + 1)); 

            mn = min(mn, cur);
            mx = max(mx, cur); 
        }

        if (tet[i].ff >= 2) {
            req cur; 
            cur.ans = n; 
            cur.type = 1; 
            vector<int> t = {tet[i].ss};
            if (i) t.pb(tet[i - 1].ss);
            if (i + 1 < (int)tet.size()) {
                t.pb(tet[i + 1].ss); 
            }
            cur.alf = mex(t); 
            int add = (tet[i].ff + 1) / 2; 
            cur.x = rem + add;
            cur.ans -= (1 + get(tet[i].ff)); 
            cur.ans += (2 + get(add) + get(tet[i].ff - add) + 1); 
            mn = min(mn, cur); 
            mx = max(mx, cur);
        }    
        

        rem += tet[i].ff; 

        req cur1; 
        cur1.ans = n; 
        cur1.type = 1; 
        cur1.x = rem; 
        vector<int> t; 
        t.pb(tet[i].ss); 
        if (i + 1 < (int)tet.size()) t.pb(tet[i + 1].ss); 
        cur1.alf = mex(t); 
        cur1.ans += 1;  

        mn = min(mn, cur1); 
        mx = max(mx, cur1); 
    }
    /*
    if (mn.ans == 3) {
        cout << "fgdfg\n";
        return; 
    }
    */
    rem = 0; 
    ///del 
    for (int i = 0; i < (int)tet.size(); ++i) {
        if (tet[i].ff != 1) {        
            req cur;
            cur.ans = n;
            cur.type = 2;
            cur.alf = -1; 
            cur.x = rem + 1;                 

            cur.ans -= get(tet[i].ff);
            cur.ans += get(tet[i].ff - 1); 
            mn = min(mn, cur); 
            mx = max(mx, cur); 
        } else {
            req cur; 
            cur.ans = n; 
            cur.type = 2; 
            cur.alf = -1;
            cur.x = rem + 1; 
            cur.ans--; 
//            cout << n; 
//            return; 
        bool ok = false; 
            if (i && i + 1 < (int)tet.size()) {
                if (tet[i - 1].ss == tet[i + 1].ss) {                    
                    ok = true; 
                    cur.ans -= (2 + get(tet[i - 1].ff) + get(tet[i + 1].ff)); 
                    cur.ans += (1 + get(tet[i - 1].ff + tet[i + 1].ff)); 
                }
            }
            mn = min(mn, cur);
            mx = max(mx, cur);
        }
        rem += tet[i].ff; 
    }

    rem = 0; 
    for (int i = 0; i < (int)tet.size(); ++i) {
        bool ok = false; 
        if (tet[i].ff == 1 && i && i + 1 < (int)tet.size() && tet[i - 1].ss == tet[i + 1].ss) {
            ok = true; 
            req cur; 
            cur.type = 3; 
            cur.x = rem + 1; 
            cur.alf = tet[i + 1].ss; 
            cur.ans = n; 
            cur.ans -= (3 + get(tet[i - 1].ff) + get(tet[i + 1].ff));
            cur.ans += (1 + get(tet[i - 1].ff + tet[i + 1].ff + 1));
            mn = min(mn, cur); 
            mx = max(mx, cur); 
        }
        if (true) {
            req cur;
            cur.type = 3;
            cur.x = rem + 1;
            vector<int> t = {tet[i].ss};
            if (i) {
                t.pb(tet[i - 1].ss);
            }
            if (i + 1 < (int)tet.size()) {
                t.pb(tet[i + 1].ss);
            }
            cur.alf = mex(t); 
            cur.ans = n; 
            cur.ans -= (1 + get(tet[i].ff)); 
            cur.ans++;
            if (tet[i].ff - 1 != 0) {
                cur.ans += (1 + get(tet[i].ff - 1)); 
            }
            mn = min(mn, cur); 
            mx = max(mx, cur); 
        }
        if (i && !ok) {
            req cur; 
            cur.type = 3; 
            cur.x = rem + 1; 
            cur.alf = tet[i - 1].ss; 
            cur.ans = n; 
            cur.ans -= (1 + get(tet[i].ff));
            cur.ans -= get(tet[i - 1].ff); 
            if (tet[i].ff - 1 != 0) {
                cur.ans += 1 + get(tet[i].ff - 1); 
            } 
            cur.ans += get(tet[i - 1].ff + 1);  

            mn = min(mn, cur); 
            mx = max(mx, cur);
        }
        ///split half
        if (tet[i].ff > 2) {
           int add = (tet[i].ff + 1) / 2;           
           req cur; 
           cur.type = 3;
           cur.ans = n; 
           cur.x = rem + add; 
           cur.ans -= (1 + get(tet[i].ff)); 
           vector<int> t = {tet[i].ss}; 
           cur.alf = mex(t); 
           cur.ans += (1 + get(add - 1)); 
           cur.ans += 1; 
           cur.ans += (1 + get(tet[i].ff - add)); 

           mn = min(mn, cur); 
           mx = max(mx, cur); 
        } 
        rem += tet[i].ff; 
        if (i + 1 < (int)tet.size() && !ok) {
            req cur; 
            cur.type = 3; 
            cur.x = rem; 
            cur.alf = tet[i + 1].ss; 
            cur.ans = n; 
            cur.ans -= (1 + get(tet[i].ff)); 
            cur.ans -= get(tet[i + 1].ff); 
            if (tet[i].ff - 1 != 0) {
                cur.ans += (1 + get(tet[i].ff - 1)); 
            }
            cur.ans += get(tet[i + 1].ff + 1); 
            mn = min(mn, cur);
            mx = max(mx, cur); 
        }

    }
    if (check(mn) != mn.ans) {
        exit(1); 
    }
    if (check(mx) != mx.ans) {
        exit(1);
    }
//    cout << mn.ans << ' ' << mx.ans << '\n';
    cout << mn.type << " " << mn.x << " "; 
    if (mn.type == 2) cout << '\n'; 
    else cout << hui[mn.alf] << '\n'; 

    cout << mx.type << " " << mx.x << " ";
    if (mx.type == 2) cout << '\n';
    else cout << hui[mx.alf] << '\n';  
}

signed main() {
#ifdef LOCAL 
    freopen("TASK.in", "r", stdin);
    freopen("TASK.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    int t = 1;
    for (int i = 0; i < t; ++i) {
        solve();             
    }
    return 0; 
}