#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;

int main() {
  int n;
  cin >> n;
  vi s(n);
  vvi a(n);
  for (int i = 0; i < n; i++) {
    int m;
    cin >> m >> s[i];
    a[i].resize(m);
    for (int j = 0; j < m; j++)
      cin >> a[i][j];
  }
  vector <int> p(n);
  iota(p.begin(), p.end(), 0);
  do {
    vector <int> d;
    for (int i = 0; i + 1 < n; i++)
      d.push_back(a[p[i + 1]][0] + s[p[i]] - a[p[i]][0]);
    if (n > 1 && *min_element(d.begin(), d.end()) != *max_element(d.begin(), d.end()))
      continue;
    cout << "Yes\n";
    for (auto &now : p)
      cout << now + 1 << ' ';
    return 0;
  } while (next_permutation(p.begin(), p.end()));
  cout << "No";
  return 0;
}