#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vi l(n), r(n);
  vi tmp;
  {
    for (int i = 0; i < n; i++) {
      int m, s;
      cin >> m >> s;
      vector<int> a(m);
      for (int j = 0; j < m; j++)
        cin >> a[j];
      for (int j = 0; j + 1 < m; j++)
        tmp.push_back(a[j + 1] - a[j]);
      l[i] = a[0], r[i] = s - a.back();
    }
    sort(tmp.begin(), tmp.end());
    if (tmp.size() > 0 && tmp[0] != tmp.back()) {
      cout << "No\n";
      return 0;
    }
  }
  if (n == 1) {
    cout << "Yes\n";
    cout << 1;
    return 0;
  }
  vi p(n);
  iota(p.begin(), p.end(), 0);
  do {
    vi x;
    for (int i = 0; i + 1 < n; i++)
      x.push_back(r[p[i]] + l[p[i + 1]]);
    int mi = *min_element(x.begin(), x.end());
    int ma = *max_element(x.begin(), x.end());
    if (mi != ma || (!tmp.empty() && mi != tmp[0]))
      continue;
    cout << "Yes\n";
    for (auto &now : p)
      cout << now + 1 << ' ';
    return 0;
  } while (next_permutation(p.begin(), p.end()));
  cout << "No";
  return 0;
}