#include <stdio.h>
long long n, m, c0, r0;
void find0()
{
	r0 = (m * (m + 1)) / 2;
	c0 = 1;
	for (int i = 1; i < n; i++)
	{
		c0 += 1 + i * m;
	}
}
long long absF(long long a)
{
	if (a < 0)
	{
		return -a;
	}
	return a;
}
long long cntCol(int x)
{
	x++;
	long long c1 = x * c0 + (n * (x - 1) * x) / 2;
	long long c2 = m * c0 + (n * m * (m - 1)) / 2;
	c2 -= c1;
	return absF(c1 - c2);
}
long long cntRow(int x)
{
	x++;
	long long c1 = x * r0 + (m * m * (x - 1) * x) / 2;
	long long c2 = n * r0 + (m * m * (n - 1) * n) / 2;
	c2 -= c1;
	return absF(c1 - c2);
}
int main()
{
	int q;
	scanf("%d", &q);
	int l, r, mid;
	int bestCol, bestRow;
	for (int z = 0; z < q; z++)
	{
		scanf("%lld%lld", &n, &m);
		find0();
		l = -1;
		r = m - 1;
		while (r - l > 1)
		{
			mid = (r + l) / 2;
			if (cntCol(mid) <= cntCol(mid + 1))
			{
				r = mid;
			}
			else
			{
				l = mid;
			}
		}
		//cout << "V " << r + 2 << "\n";
		bestCol = r;
		l = -1;
		r = n - 1;
		while (r - l > 1)
		{
			mid = (r + l) / 2;
			if (cntRow(mid) <= cntRow(mid + 1))
			{
				r = mid;
			}
			else
			{
				l = mid;
			}
		}
		bestRow = r;
		if (cntRow(bestRow) < cntCol(bestCol))
		{
			//cout << "H " << bestRow + 2;
			printf("%c %d\n", 'H', bestRow + 2);
		}
		else
		{
			//cout << "V " << bestCol + 2;
			printf("%c %d\n", 'V', bestCol + 2);
		}
		//cout << "\n";
	}
}