#include <iostream>
#include <map>
#include <vector>
using namespace std;
typedef long long int ll;
int main()
{
	int n;
	cin >> n;
	vector<ll> m(n);
	vector<ll> s(n);
	vector<vector<ll>> p(n);
	map<ll, vector<ll>> st;
	map<ll, vector<ll>> fi;
	map<ll, vector<bool>> usedSt;
	map<ll, vector<bool>> usedFi;
	ll S = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> m[i] >> s[i];
		p[i].resize(m[i]);
		for (int j = 0; j < m[i]; j++)
		{
			cin >> p[i][j];
		}
		if (m[i] >= 2)
		{
			S = p[i][1] - p[i][0];
		}
		st[p[i][0]].push_back(i);
		st[p[i][0]].push_back(false);
		fi[s[i] - p[i][p[i].size() - 1]].push_back(i);
		fi[s[i] - p[i][p[i].size() - 1]].push_back(false);
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m[i] - 1; j++)
		{
			if (p[i][j + 1] - p[i][j] != S)
			{
				cout << "No";
				return 0;
			}
		}
	}
	vector<pair<ll, ll>> ans(n, make_pair(-1, -1));
	ll curSt, curFi;
	for (auto elem : st)
	{
		curSt = elem.first;
		curFi = S - curSt;
		for (ll i = 0; i < elem.second.size(); i++)
		{
			for (ll j = 0; j < fi[curFi].size(); j++)
			{
				if (fi[curFi][j] != elem.second[i] && ans[fi[curFi][j]].first != elem.second[i] && !usedFi[curFi][j])
				{
					ans[elem.second[i]].first = fi[curFi][j];
					ans[fi[curFi][j]].second = elem.second[i];
					usedFi[curFi][j] = true;
				}
			}
		}
	}
	vector<ll> ansSorted;
	ll curI = -1;
	ll iFirst;
	for (int i = 0; i < ans.size(); i++)
	{
		if (ans[i].first == -1)
		{
			curI = i;
			iFirst = ans[curI].first;
		}
	}
	if (curI == -1)
	{
		cout << "No";
		return 0;
	}
	while (curI != -1 && curI != iFirst)
	{
		ansSorted.push_back(curI + 1);
		curI = ans[curI].second;
	}
	if (ansSorted.size() != n)
	{
		cout << "No";
		return 0;
	}
	cout << "Yes\n";
	for (int i = 0; i < ansSorted.size(); i++)
	{
		cout << ansSorted[i] << " ";
	}
	return 0;
}