#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;
vector<ll> cnt;
ll maxF(ll a, ll b)
{
	if (a > b)
	{
		return a;
	}
	return b;
}
vector<ll> minF(vector<ll> a, vector<ll> b)
{
	if (a < b)
	{
		return a;
	}
	return b;
}
vector<ll> minF(vector<ll> a, vector<ll> b, vector<ll> c, vector<ll> d)
{
	return minF(minF(a, b), minF(c, d));
}
ll minF(ll a, ll b)
{
	if (a < b)
	{
		return a;
	}
	return b;
}
ll findMaxDigit(ll x)
{
	ll maxD = x % 10;
	while (x != 0)
	{
		maxD = maxF(maxD, x % 10);
		x /= 10;
	}
	return maxD;
}
ll findSize(ll x)
{
	ll sz = 0;
	while (x != 0)
	{
		sz++;
		x /= 10;
	}
	return sz;
}
ll findFirstDigit(ll x)
{
	ll last = x % 10;
	while (x != 0)
	{
		last = x % 10;
		x /= 10;
	}
	return last;
}
ll powF(ll a, ll b)
{
	if (b == 0)
	{
		return 1;
	}
	if (b % 2 == 0)
	{
		ll tmp = powF(a, b / 2);
		return tmp * tmp;
	}
	return powF(a, b - 1) * a;
}
vector<ll> toArr(ll x)
{
	vector<ll> res;
	while (x != 0)
	{
		res.push_back(x % 10);
		x /= 10;
	}
	reverse(res.begin(), res.end());
	return res;
}
ll toNum(vector<ll> arr)
{
	ll res = 0;
	for (int i = 0; i < arr.size(); i++)
	{
		res += arr[i] * powF(10, arr.size() - i - 1);
	}
	return res;
}
bool allDigits(vector<ll> a)
{
	ll fD = a[0];
	for (int i = 0; i < a.size(); i++)
	{
		if (a[i] != fD)
		{
			return false;
		}
	}
	return true;
}
ll delFirstDigit(ll x)
{
	vector<ll> digits = toArr(x);
	digits.erase(digits.begin());
	return toNum(digits);
}
ll countRes(ll x, bool k)
{
	if (k == 1)
	{
		vector<ll> arr = toArr(x);
		if (arr.size() == 1)
		{
			return x;
		}
		if (arr.size() == 2)
		{
			return x;
		}
		ll minD = arr[1];
		for (int i = 1; i < arr.size(); i++)
		{
			if (arr[i] < minD)
			{
				minD = arr[i];
			}
		}
		if (minD == 9)
		{
			return x;
		}
		vector<ll> c1, c2, c3, c4;
		c1.resize(arr.size());
		c2.resize(arr.size());
		c3.resize(arr.size());
		c4.resize(arr.size());
		c1[0] = arr[0];
		ll maxD = arr[1];
		for (int i = 1; i < arr.size(); i++)
		{
			if (arr[i] > maxD)
			{
				maxD = arr[i];
			}
		}
		for (int i = 1; i < c1.size(); i++)
		{
			c1[i] = maxD;
		}
		while (c1[0] >= 0 && c1 >= arr)
		{
			c1[0]--;
		}
		c1[0]++;
		maxD = arr[0];
		for (int i = 0; i < arr.size() - 1; i++)
		{
			if (arr[i] > maxD)
			{
				maxD = arr[i];
			}
		}
		for (int i = 0; i < c4.size() - 1; i++)
		{
			c4[i] = maxD;
		}
		c4[c4.size() - 1] = arr[arr.size() - 1];
		while (c4[c4.size() - 1] >= 0 && c4 >= arr)
		{
			c4[c4.size() - 1]--;
		}
		c4[c4.size() - 1]++;
		c2.assign(arr.size(), arr[0]);
		int curI = 1;
		ll allDigits = c2[0];
		c2[curI] = 9;
		while (curI < c2.size() - 1 && c2 >= arr)
		{
			c2[curI] = allDigits;
			c2[++curI] = 9;
		}
		c2[curI--] = allDigits;
		c2[curI] = 9;
		while (c2[curI] >= 0 && c2 >= arr)
		{
			c2[curI]--;
		}
		c2[curI]++;
		c3.assign(arr.size(), arr[arr.size() - 1]);
		curI = 1;
		allDigits = c3[0];
		c3[curI] = 9;
		while (curI < c3.size() - 1 && c3 >= arr)
		{
			c3[curI] = allDigits;
			c3[++curI] = 9;
		}
		c3[curI--] = allDigits;
		c3[curI] = 9;
		while (c3[curI] >= 0 && c3 >= arr)
		{
			c3[curI]--;
		}
		c3[curI]++;
		return toNum(minF(c1, c2, c3, c4));
	}
	//ll maxD = findMaxDigit(x);
	ll fd = findFirstDigit(x);
	ll sz = findSize(x);
	ll resX = 0;
	for (int i = 0; i < sz; i++)
	{
		resX *= 10;
		resX += fd;
	}
	if (resX < x)
	{
		fd++;
		resX = 0;
		for (int i = 0; i < sz; i++)
		{
			resX *= 10;
			resX += fd;
		}
	}
	return resX;
}
int main()
{
	ll x;
	cin >> x;
	bool k;
	cin >> k;
	cout << countRes(x, k);
	return 0;
}