#include <iostream>
#include <vector>
#include <set>
#include <queue>
using namespace std;
int main()
{
	int n, m, c;
	cin >> n >> m >> c;
	vector<vector<int>> a(n, vector<int>(m));
	vector<vector<set<int>>> b(n, vector<set<int>>(m));
	vector<vector<bool>> used(n, vector<bool>(m));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			for (int k = 1; k <= c; k++)
			{
				b[i][j].insert(k);
			}
		}
	}
	for (int j = 0; j < m; j++)
	{
		a[0][j] = j % 2 + 1;
		b[0][j].clear();
		used[0][j] = true;
	}
	queue<pair<int, int>> q;
	for (int i = 0; i < n; i++)
	{
		a[i][0] = i % 2 + 1;
		b[i][0].clear();
		used[i][0] = true;
		for (int j = 1; j < m; j++)
		{
			if (j % 2 == i % 2 && j % 2 == 0 % 2)
			{
				b[i][j].erase(i % 2 + 1);
				if (b[i][j].size() == 1)
				{
					q.push(make_pair(i, j));
				}
			}
		}
	}
BEGIN:
	pair<int, int> cur;
	while (!q.empty())
	{
		cur = q.front();
		q.pop();
		a[cur.first][cur.second] = *b[cur.first][cur.second].begin();
		b[cur.first][cur.second].clear();
		used[cur.first][cur.second] = 1;
		for (int i1 = 0; i1 < n; i1++)
		{
			for (int j1 = 0; j1 < m; j1++)
			{
				for (int i2 = 0; i2 < n; i2++)
				{
					for (int j2 = 0; j2 < m; j2++)
					{
						for (int i3 = 0; i3 < n; i3++)
						{
							for (int j3 = 0; j3 < m; j3++)
							{
								if (used[i1][j1] && used[i2][j2] && used[i3][j3])
								{
									continue;
								}
								if ((i1 != cur.first || j1 != cur.second) && (i2 != cur.first || j2 != cur.second) && (i3 != cur.first || j3 != cur.second))
								{
									if (used[i1][j1] && used[i2][j2])
									{
										if (a[i1][j1] == a[cur.first][cur.second] && a[i2][j2] == a[cur.first][cur.second])
										{
											b[i3][j3].erase(a[cur.first][cur.second]);
											q.push(make_pair(i3, j3));
										}
									}
									else if (used[i1][j1] && used[i3][j3])
									{
										if (a[i1][j1] == a[cur.first][cur.second] && a[i3][j3] == a[cur.first][cur.second])
										{
											b[i2][j2].erase(a[cur.first][cur.second]);
											q.push(make_pair(i2, j2));
										}
									}
									else if (used[i2][j2] && used[i3][j3])
									{
										if (a[i2][j2] == a[cur.first][cur.second] && a[i3][j3] == a[cur.first][cur.second])
										{
											b[i1][j1].erase(a[cur.first][cur.second]);
											q.push(make_pair(i1, j1));
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (!used[i][j])
			{
				q.push(make_pair(i, j));
				goto BEGIN;
			}
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cout << a[i][j] << " ";
		}
		cout << "\n";
	}
	return 0;
}