#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        int vans, hans, vcalc, hcalc;
        int total = (n * m * (n * m + 1)) / 2;
        if (m > 1) {
            int fir = (n * (2 + m * (n - 1))) / 2;
            int l = 1, r = m;
            while (l < r - 1) {
                int mid = (l + r) / 2;
                int tmp = fir * mid + n * (mid * (mid - 1)) / 2;
                if (2 * tmp <= total)
                    l = mid;
                else
                    r = mid;
            }
            int tmp1 = fir * l + n * (l * (l - 1)) / 2;
            int tmp2 = fir * (l + 1) + n * (l * (l + 1)) / 2;
            if (abs(2 * tmp1 - total) <= abs(2 * tmp2 - total)) {
                vans = l;
                vcalc = tmp1;
            }
            else {
                vans = l + 1;
                vcalc = tmp2;
            }
        }
        else {
            vans = 0;
            vcalc = 0;
        }
        if (n > 1) {
            int fir = (m * (m + 1)) / 2;
            int l = 1, r = n;
            while (l < r - 1) {
                int mid = (l + r) / 2;
                int tmp = fir * mid + m * m * (mid * (mid - 1)) / 2;
                if (2 * tmp <= total)
                    l = mid;
                else
                    r = mid;
            }
            int tmp1 = fir * l + m * m * (l * (l - 1)) / 2;
            int tmp2 = fir * (l + 1) + m * m * (l * (l + 1)) / 2;
            if (abs(2 * tmp1 - total) <= abs(2 * tmp2 - total)) {
                hans = l;
                hcalc = tmp1;
            }
            else
            {
                hans = l + 1;
                hcalc = tmp2;
            }
        }
        else {
            hans = 0;
            hcalc = 0;
        }
        if (abs(2 * vcalc - total) <= abs(2 * hcalc - total))
            cout << "V " << vans + 1 << '\n';
        else
            cout << "H " << hans + 1<< '\n';
    }
}