#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define int long long

using namespace std;

vector<int> _tpow(200000, -1);

int tpow(int y);

int get_tpow(int y) {
    if (_tpow[y] != -1)
        return _tpow[y];
    else
        return _tpow[y] = tpow(y);
}

int tpow(int y) {
    if (y == 0)
        return 1;
    int tmp = tpow(y / 2);
    if (y % 2)
        return tmp * tmp * 10;
    else
        return tmp * tmp;
}

int intlen(int x) {
    if (x == 1) return 0;
    if (x == 0) return -1;
    int l = 0, r = 10;
    while (l < r - 1) {
        int mid = (l + r) / 2;
        if (tpow(mid) > x)
            r = mid;
        else
            l = mid;
    }
    return l + 1;
}

struct seg {
    char c;
    int n;
};

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    vector<seg> dna;
    int dnalen = 0;
    for (int i = 0; i < s.length(); ++i) {
        if (s[i] >= '0' && s[i] <= '9') {
            int num = s[i] - '0';
            while (s[++i] >= '0' && s[i] <= '9')
                num = num * 10 + s[i] - '0';
            dna.push_back({ s[i], num });
        }
        else
            dna.push_back({ s[i], 1 });
        dnalen += dna.back().n;
    }
    int minn = 0;
    int mini = -1;
    for (int i = 0; i < dna.size() && mini == -1; ++i)
        if (intlen(dna[i].n - 1) < intlen(dna[i].n) && (i == 0 || i == dna.size() - 1 || dna[i - 1].c != dna[i + 1].c))
        {
            minn = 1;
            mini = i;
        }
    for (int i = 0; i + 2 < dna.size(); ++i)
        if (dna[i].c == dna[i + 2].c && dna[i + 1].n == 1) {
            int tmp = 3 + intlen(dna[i].n) + intlen(dna[i + 2].n) - 2 - intlen(dna[i].n + dna[i + 2].n);
            if (tmp > minn)
            {
                mini = i + 1;
                minn = tmp;
            }
        }
    if (mini == -1)
        cout << "2 1\n";
    else
    {
        int cnt = 1;
        for (int i = 0; i < mini; ++i) cnt += dna[i].n;
        cout << "2 " << cnt << '\n';
    }
    int maxn = 1;
    int maxi = -1;
    for (int i = 0; i < dna.size(); ++i) {
        int tmp;
        if (dna[i].n < 3)
            tmp = 1;
        else if (dna[i].n == 3) {
            tmp = 2;
        }
        else {
            int len = intlen(dna[i].n);
            if (dna[i].n <= tpow(len - 1) + 1)
                tmp = len;
            else if (dna[i].n < 2 * tpow(len - 1))
                tmp = 1 + len;
            else
                tmp = 2 + len;
        }
        if (tmp > maxn)
        {
            maxn = tmp;
            maxi = i;
        }
    }
    if (maxn <= 1)
    {
        if (dna.back().c == 'A')
            cout << "1 " << dnalen << " C\n";
        else
            cout << "1 " << dnalen << " A\n";
    }
    else {
        int cnt = 0;
        for (int i = 0; i < maxi; ++i)
            cnt += dna[i].n;
        int len = intlen(dna[maxi].n);
        if (dna[maxi].n <= tpow(len - 1) + 1)
            cnt += dna[maxi].n / 2;
        else
            cnt += max(2LL, tpow(len - 1));
        if (dna[maxi].c == 'A')
            cout << "1 " << cnt << " C\n";
        else
            cout << "1 " << cnt << " A\n";
    }
}