#include <vector>
#include <iostream>
using namespace std;
#define int long long
int t[400 * 1000];
int v[100 * 1000];
void upd(int p, int l, int r, int ind)
{
    if (r - l == 1) {
        t[p] = v[ind];
        return;
    }
    int m = (l + r) / 2;
    if (m > ind) {
        upd(2 * p + 1, l, m, ind);
    }
    else {
        upd(2 * p + 2, m, r, ind);
    }
}

int get(int p, int l, int r, int lq, int rq) {
    if (l >= lq && r <= rq) {
        return t[p];
    }
    if (l >= rq) {
        return 0;
    }
    if (r <= lq) {
        return 0;
    }
    int m = (l + r) / 2;
    return get(2 * p + 1, l, m, lq, rq) + get(2 * p + 2, m, r, lq, rq);
}
int n, m;

int get_row(int i) {
    return m * (m + 1) / 2 + i * m * m;
}

int get_rows(int i) {
    return (i + 1) * m * (m + 1) / 2 + i * (i + 1) / 2 * m * m;
}

int get_col(int j) {
    return m * n * (n - 1) / 2 + n + j * n;
}

int get_cols(int j) {
    return (j + 1) * (m * n * (n - 1) / 2 + n) + j * (j + 1) / 2 * n;
}


pair<int, int> stupid() {
    int summ_all = get_rows(n - 1);
    int minn = 2e18;
    int minn_t = 0;
    int minn_pos = 0;
    for (int i = n - 1; i >= -1; i--) {
        if (abs(summ_all - 2 * get_rows(i)) <= minn) {
            minn = abs(summ_all - 2 * get_rows(i));
            minn_t = 0;
            minn_pos = i;
        }
    }
    for (int j = m - 1; j >= -1; j--)
    {
        if (abs(summ_all - 2 * get_cols(j)) <= minn) {
            minn = abs(summ_all - 2 * get_cols(j));
            minn_t = 1;
            minn_pos = j;
        }
    }
    return {minn_t, minn_pos + 2};
}

pair<int, int> stupid_bounds(int x1, int x2, int y1, int y2) {
    int summ_all = get_rows(n - 1);
    int minn = 2e18;
    int minn_t = 0;
    int minn_pos = 0;
    for (int i = min(x2, n - 1); i >= max(-1LL, x1); i--) {
        if (abs(summ_all - 2 * get_rows(i)) <= minn) {
            minn = abs(summ_all - 2 * get_rows(i));
            minn_t = 0;
            minn_pos = i;
        }
    }
    for (int j = min(m - 1, y2); j >= max(-1LL, y1); j--)
    {
        if (abs(summ_all - 2 * get_cols(j)) <= minn) {
            minn = abs(summ_all - 2 * get_cols(j));
            minn_t = 1;
            minn_pos = j;
        }
    }
    return {minn_t, minn_pos + 2};
}

pair<int, int> clever() {
    int summ_all = get_rows(n - 1);
    double l = -1;
    double r = n - 1;
    while (r - l > 1e-4) {
        double m1 = (l + (r - l) / 3);
        double m2 = (l + (r - l) * 2 / 3);
        if (abs(summ_all - 2 * get_rows(m1)) < (abs(summ_all - 2 * get_rows(m2)))) {
            r = m2;
        }
        else {
            l = m1;
        }
    }
    int x1 = (l - 30);
    int x2 = (l + 30);
    l = -1;
    r = m - 1;
    while (r - l > 1e-4) {
        double m1 = (l + (r - l) / 3);
        double m2 = (l + (r - l) * 2 / 3);
        if (abs(summ_all - 2 * get_cols(m1)) < (abs(summ_all - 2 * get_cols(m2)))) {
            r = m2;
        }
                else {
            l = m1;
        }
    }
    int y1 = l - 30;
    int y2 = l + 30;
    return stupid_bounds(x1, x2, y1, y2);
}


signed main() {
    int t;
    cin >> t;
    for (int _i = 0; _i < t; _i++) {
        cin >> n >> m;
        auto [t, pos] = clever();
        if (t == 0) {
            cout << "H ";
        }
        else {
            cout << "V ";
        }
        cout << pos << endl;
    }
}
