#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
using namespace std;
#define int long long
int fact[200001];
const int mod = 1e9 + 7;

int binup(int x, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int pre = binup(x, p / 2);
        return pre * pre % mod;
    }
    return binup(x, p - 1) * x % mod;
}

int inv(int x) {
    return binup(x, mod - 2);
}

int C(int n, int k) {
    if (n < 0 || k < 0) {
        return 0;
    }
    return fact[n] % mod * inv(fact[n - k]) % mod * inv(fact[k]) % mod;
}

int stupid(int a, int b) {
    int dp[751];
    for (int i = 0; i <= b; i++) {
        dp[i] = 1;
    }
    for (int j = 2; j <= a; j++) {
        int pref = 0;
        for (int i = 0; i <= b; i++) {
            pref += dp[i];
            pref %= mod;
            dp[i] = pref;
        }
    }
    return dp[b];
}
int stupidd(int a, int b, int pos) {
    int dp[751];
    for (int i = 0; i <= b; i++) {
        dp[i] = 0;
    }
    dp[pos] = 1;
    for (int j = 2; j <= a; j++) {
        int pref = 0;
        for (int i = 0; i <= b; i++) {
            pref += dp[i];
            pref %= mod;
            dp[i] = pref;
        }
    }
    return dp[b];
}

int clever(int a, int b) {
    if (a < 2) {
        return 1;
    }
    int ans = 0;
    for (int i = 0; i <= b; i++) {
        ans += C(a - i + b - 2, b - i);
        ans %= mod;
    }
    return ans;
}

signed main() {

}




