#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#define int long long
using namespace std;
int n, m;
int c;
int anss[10][10];
bool fl = false;
pair<int, int> next(int i, int j) {
    if (fl) {
        if (i == j) {
            return {0, j + 1};
        }
        if (i < j) {
            return {j, i};
        }
        return {j + 1, i};
    }
    if (j == m - 1) {
        return {i + 1, 0};
    }
    return {i, j + 1};
}
int real_n, real_m;
void sol(int i, int j) {
    if (i == n) {
        for (int ii = 0; ii < real_n; ii++) {
            for (int jj = 0; jj < real_m; jj++) {
                cout << anss[ii][jj] << ' ';
            }
            cout << endl;
        }
        exit(0);
    }
    for (int now = 1; now <= c; now++) {
        anss[i][j] = now;
        bool fl = false;
        for (int ii = 0; ii < i; ii++) {
            for (int jj = 0; jj < j; jj++) {
                if (anss[ii][jj] == anss[ii][j] && anss[ii][jj] == anss[i][j] && anss[ii][jj] == anss[i][jj]) {
                    fl = true;
                    break;
                }
            }
            if (fl) {
                break;
            }
        }
        if (!fl) {
            sol(next(i, j).first, next(i, j).second);
        }
        anss[i][j] = 0;

    }
}

int ans[12][12];
int f() {
    int cnt = 0;
    for (int i = 0; i < 9; i++) {
        for (int j = 0; j < 9; j++) {
            for (int i2 = i + 1; i2 < 9; i2++) {
                for (int j2 = j + 1; j2 < 9; j2++) {
                    if (ans[i][j] == ans[i2][j] && ans[i][j] == ans[i2][j2] && ans[i][j] == ans[i][j2]) {
                        cnt++;
                    }
                }
            }
        }
    }
    return cnt;
}

signed main() {
    cin >> real_n >> real_m;
    cin >> c;
    n = real_n;
    m = real_m;
    if (c == 2) {
        sol(0, 0);
    }
    for (int i = 0; i < 9; i++) {
        ans[0][i] = 1 + i / 3;
    }
    int step[4] = {0, 0, 0, 0};
    for (int i = 1; i < 9; i++) {
        for (int j = 0; j < 3; j++) {
            if (i % 3 != j) {
                step[j]++;
            }
            for (int k = 0; k < 3; k++) {
                ans[i][j * 3 + k] = 1 + (k + step[k]) % 3;
            }
        }
    }
    int now = f();
    double t = 1;
    for (int i = 0; i < 1000000; i++) {
        int x = rand() % 9;
        int y = rand() % 9;
        int was = ans[x][y];
        ans[x][y] = rand() % 3 + 1;
        int val = f();
        if (val == 0) {
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    cout << ans[x][y] << ' ';
                }
                cout << endl;
            }
            return 0;
        }
        if (val < now || (double)rand() / RAND_MAX < exp((now - val) / t)) {
            now = val;
        }
        else {
            ans[x][y] = was;
        }
        t *= 0.99;
    }
}