//#define __GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second
#define int long long
#define ld long double

mt19937 rnd(time(0));

const int mod = 1e9 + 7;

bool relax(int a, int b, int c, vector<int> &t) {
    if (a == -1)
        return 0;
    if (a + b >= 10) {
        if (c == a + b - 10) {
            t[3]++;
        } else if (c == a + b - 10 + 1) {
            t[2]++;
        } else {
            return 1;
        }
    } else {
        if (c == a + b) {
            t[0]++;
        } else if (c == a + b + 1) {
            t[1]++;
        } else if (c == a + b - 10 + 1) {
            t[3]++;
        } else {
            return 1;
        }
    }
    return 0;
}

void fact(int &ans, int a) {
    for (int i = 2; i <= a; i++) {
        ans *= i;
        ans %= mod;
    }
}

int getans(vector<int> &v1, vector<int> &v2, vector<int> &v3, int n) {
    vector<int> a(4);
    for (int i = 0; i < n; i++) {
        if (relax(v1[i], v2[i], v3[i], a)) {
            return 0;
        }
    }
    int ans = 1;
    if (a[1] != a[3]) {
        return 0;
    }
    for (int i = 0; i < a[0]; i++) {
        ans *= (a[3] + 1 + i);
        ans %= mod;
    }
    for (int i = 0; i < a[2]; i++) {
        ans *= (a[1] + i);
        ans %= mod;
    }
    fact(ans, a[1]);
    fact(ans, a[3]);
    return ans;
}

signed main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    //cout.tie(0);
    cout << fixed << setprecision(3);

    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    vector<int> v1(n), v2(n), v3(n);
    for (int i = 0; i < n; i++) {
        v1[i] = s1[i] - '0';
    }
    for (int i = 0; i < n; i++) {
        v2[i] = s2[i] - '0';
    }
    for (int i = 0; i < n; i++) {
        v3[i] = s3[i] - '0';
    }

    if (n <= 6) {
        vector<int> r(n);
        for (int i = 0; i < n; i++) {
            r[i] = i;
        }
        int ans = 0;
        do {
            int a1 = 0, a2 = 0, a3 = 0;
            int p = 1;
            if (v1[r[0]] == 0 || v2[r[0]] == 0 || v3[r[0]] == 0)
                continue;
            for (int k = n - 1; k >= 0; k--) {
                a1 += v1[r[k]] * p;
                a2 += v2[r[k]] * p;
                a3 += v3[r[k]] * p;
                p *= 10;
            }
            if (a1 + a2 == a3) {
                ans++;
            }
        } while (next_permutation(all(r)));
        cout << ans << '\n';
        return 0;
    }

    int ans = getans(v1, v2, v3, n);
    for (int i = 0; i < n; i++) {
        if (v1[i] == 0 || v2[i] == 0 || v3[i] == 0) {
            int q = v1[i];
            v1[i] = -1;
            ans -= getans(v1, v2, v3, n);
            v1[i] = q;
        }
    }
    cout << ans << '\n';

    return 0;
}
/*
1 1 1 2 1
s
2 3 2 2 1
1 2 2 1 2
*/
