#include <iostream>

using namespace std;

typedef long long ll;

int n, m;
ll sum;

ll get_sum_line(int a)
{
	ll c = m * 1ll * a;
	return c * (c + 1) / 2;
}

ll get_sum_column(int b)
{
	return b * 1ll * (b + 1ll) / 2 * n + b * 1ll * m * n * (n - 1ll) / 2;
}

ll get_line_diff(int a)
{
	ll s1 = get_sum_line(a);
	ll s2 = sum - s1;
	return abs(s1 - s2);
}

ll get_column_diff(int b)
{
	ll s1 = get_sum_column(b);
	ll s2 = sum - s1;
	return abs(s1 - s2);
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		cin >> n >> m;
		sum = get_sum_line(n);
		int l, r;
		l = 1, r = n - 1;
		while (r - l > 2)
		{
			int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
			if (get_line_diff(m1) < get_line_diff(m2))
			{
				r = m2;
			}
			else
			{
				l = m1;
			}
		}
		ll line = l;
		for (int j = l + 1; j <= r; j++)
		{
			if (get_line_diff(j) < get_line_diff(line))
				line = j;
		}

		l = 1, r = m - 1;
		while (r - l > 2)
		{
			int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
			if (get_column_diff(m1) < get_column_diff(m2))
			{
				r = m2;
			}
			else
			{
				l = m1;
			}
		}
		ll column = l;
		for (int j = l + 1; j <= r; j++)
		{
			if (get_column_diff(j) < get_column_diff(column))
				column = j;
		}
		if (get_line_diff(line) < get_column_diff(column))
			cout << "H " << line + 1 << "\n";
		else
			cout << "V " << column + 1 << "\n";
	}
}
