#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;

vector<pair<int, char>> blocks;

int get_length(int a)
{
	if (a <= 1)
		return 0;
	int length = 0;
	while (a > 0)
	{
		length++;
		a /= 10;
	}
	return length;
}

int get_max_sum_2(int a)
{
	ll p10 = 2;
	int k = 0;
	while (a >= p10 * 10)
	{
		k++;
		p10 *= 10;
	}
	return (k + 1) * 2;
}

char another(char c)
{
	if (c == 'A')
		return 'C';
	return 'A';
}

int main()
{
	string s;
	cin >> s;
	int num = 0;
	for (char c : s)
	{
		if (c >= '0' && c <= '9')
		{
			num = num * 10 + (c - '0');
		}
		else
		{
			if (num == 0)
				blocks.push_back({ 1, c });
			else
				blocks.push_back({ num, c });
			num = 0;
		}
	}
	int min_length = s.size(), now;
	string ans = "2 1";
	int j = 0;
	for (int i = 0; i + 1 < blocks.size(); i++)
	{
		if (blocks[i].first == 1 && i > 0 && blocks[i - 1].second == blocks[i + 1].second)
		{
			now = s.size()
				- get_length(blocks[i - 1].first) - get_length(blocks[i].first) - get_length(blocks[i + 1].first) - 3
				+ get_length(blocks[i - 1].first + blocks[i + 1].first) + 1;
		}
		else
		{
			now = s.size()
				- get_length(blocks[i].first) - get_length(blocks[i + 1].first)
				+ get_length(blocks[i].first - 1) + get_length(blocks[i + 1].first);
			if (blocks[i].first == 1)
				now--;
		}
		if (now <= min_length)
		{
			min_length = now;
			ans = "2 " + to_string(j + blocks[i].first);
		}

		if (blocks[i + 1].first == 1 && i + 2 < blocks.size() && blocks[i + 2].second == blocks[i].second)
		{
			now = s.size()
				- get_length(blocks[i + 2].first) - get_length(blocks[i].first) - get_length(blocks[i + 1].first) - 3
				+ get_length(blocks[i + 2].first + blocks[i].first) + 1;
		}
		else
		{
			now = s.size()
				- get_length(blocks[i].first) - get_length(blocks[i + 1].first)
				+ get_length(blocks[i].first) + get_length(blocks[i + 1].first - 1);
			if (blocks[i + 1].first == 1)
				now--;
		}
		if (now <= min_length)
		{
			min_length = now;
			ans = "2 " + to_string(j + blocks[i].first + 1);
		}
		j += blocks[i].first;
	}
	cout << ans << "\n";

	int max_length = s.size() + 1;
	ans = "1 0 ";
	ans += another(blocks[0].second);

	j = 0;
	for (int i = 0; i < blocks.size(); i++)
	{
		if (blocks[i].first == 1)
		{
			j++;
			continue;
		}
		now = s.size() - get_length(blocks[i].first) + get_max_sum_2(blocks[i].first) + 2;
		if (now > max_length)
		{
			max_length = now;
			ans = "1 " + to_string(j + blocks[i].first / 2) + " " + another(blocks[i].second);
		}
		j += blocks[i].first;
	}
	cout << ans << "\n";
}
