#include <iostream>
#include <string>
#include <vector>

using namespace std;

int get_num_length(int a)
{
	if (a <= 1)
		return 0;
	int length = 0;
	while (a > 0)
	{
		length++;
		a /= 10;
	}
	return length;
}

string s;

int get_length()
{
	int length = 0, cnt = 0;
	for (int i = 0; i < s.size(); i++)
	{
		cnt++;
		if (i == s.size() - 1 || s[i + 1] != s[i])
		{
			length += get_num_length(cnt) + 1;
			cnt = 0;
		}
	}
	return length;
}

int min_length, max_length;
string min_ans, max_ans;

void check(string operation)
{
	int length = get_length();
	if (length <= min_length)
	{
		min_length = length;
		min_ans = operation;
	}
	if (length >= max_length)
	{
		max_length = length;
		max_ans = operation;
	}
}

vector<char> chars = { 'A', 'G', 'C', 'T' };

int main()
{
	string ss;
	cin >> ss;
	//string s;
	int num = 0;
	for (char c : ss)
	{
		if (c >= '0' && c <= '9')
			num = num * 10 + (c - '0');
		else
		{
			if (num == 0)
				num = 1;
			for (int i = 0; i < num; i++)
				s += c;
			num = 0;
		}
	}
	int n = s.size();
	min_length = ss.size(), max_length = ss.size();
	//string min_ans, max_ans;
	int length;
	//string min_ans = ""
	for (int i = 0; i < n; i++)
	{
		char c = s[i];
		s.erase(s.begin() + i);
		check("2 " + to_string(i + 1));
		s.insert(s.begin() + i, c);

		for (char c2 : chars)
		{
			s[i] = c2;
			check("3 " + to_string(i + 1) + " " + c2);
		}
		s[i] = c;
	}
	for (int i = 0; i <= n; i++)
	{
		for (char c : chars)
		{
			s.insert(s.begin() + i, c);
			check("1 " + to_string(i) + " " + c);
			s.erase(s.begin() + i);
		}
	}
	//cout << min_length << " " << max_length << "\n";
	cout << min_ans << "\n" << max_ans << "\n";
}
