#include <iostream>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

int get_len(ll a)
{
	int length = 0;
	while (a >= 1)
	{
		length++;
		a /= 10;
	}
	return length;
}

int get_x0(ll x)
{
	int ans;
	while (x >= 1)
	{
		ans = x;
		x /= 10;
	}
	return ans;
}

vector<ll> get_all_good(int length)
{
	vector<ll> nums;
	for (int main = 0; main <= 9; main++)
	{
		for (int second = 0; second <= 9; second++)
		{
			for (int pos = 0; pos < length; pos++)
			{
				ll now = 0;
				for (int i = 0; i < length; i++)
				{
					if (i == pos)
						now = now * 10 + second;
					else
						now = now * 10 + main;
				}
				nums.push_back(now);
			}
		}
	}
	return nums;
}

int main()
{
	ll x;
	cin >> x;
	int length = get_len(x);
	bool k;
	cin >> k;
	if (!k)
	{
		int x0 = get_x0(x);
		ll ans = 0;
		for (int i = 0; i < length; i++)
		{
			ans = ans * 10 + x0;
		}
		if (ans >= x)
		{
			cout << ans << "\n";
			return 0;
		}
		x0++;
		ans = 0;
		for (int i = 0; i < length; i++)
		{
			ans = ans * 10 + x0;
		}
		cout << ans << "\n";
		/*bool is_good = true;
		int i = 0;
		int x0 = x[0];
		while (i < x.size())
		{
			if (x[i] > x0)
			{
				is_good = false;
				break;
			}
			if (x[i] < x0)
			{
				break;
			}
		}
		if (is_good)
		{
			for (i = 0; i < x.size(); i++)
			{
				cout << x0;
			}
			cout << "\n";
		}
		else
		{
			x0++;
			for (int i = 0; i < x.size(); i++)
			{
				cout << x0;
			}
			cout << "\n";
		}*/
	}
	else
	{
		auto nums = get_all_good(length);
		ll ans = 1e18;
		for (auto num : nums)
		{
			if (num >= x)
				ans = min(ans, num);
		}
		cout << ans << "\n";
	}
}
