#include <bits/stdc++.h>

using namespace std;

#define int long long

map<int, vector<int> > mpbegin, mpend;

int n;
int smin = 1e10;
int smax = -1;

struct frag{
    int m, s, ind, begin, end;
    vector<int> p;
    frag(int a, int b, int c){
        m = a;
        s = b;
        ind = c;
        build();
    }
    void build(){
        for (int i = 0; i < m; ++i) {
            int x;
            cin >> x;
            if (p.empty()) {
                p.push_back(x);

            }
            else {
                p.push_back(x - p.back());
                smax = max(smax, p.back());
                smin = min(smin, p.back());
            }
            if (i == m - 1){
                p.push_back(s - x);
            }
        }

        mpbegin[p[0]].push_back(ind);
        mpend[p.back()].push_back(ind);
        begin = p[0];
        end = p.back();
    }
};



vector <frag> kek;

vector <int> get(int s){
    map <int, vector<int> > map_begin = mpbegin;
    map <int, vector<int> > map_end = mpend;
    vector <bool> visited(n);
    int ans_begin = -1, ans_end = -1;
    vector <int> next(n, -1);
    int now = 0;
    while (map_begin[s - kek[now].end].size() != 0) {
        visited[now] = true;
        while (!map_begin[s - kek[now].end].empty() && visited[map_begin[s - kek[now].end].back()]) {
            map_begin[s - kek[now].end].pop_back();
        }
        if (map_begin[s - kek[now].end].empty()) {
            break;
        }
        next[now] = map_begin[s - kek[now].end].back();
        map_begin[s - kek[now].end].pop_back();
        now = next[now];
    }
    visited[now] = true;

    ans_end = now;
    now = 0;
    while (map_end[s - kek[now].begin].size() != 0) {
        visited[now] = true;
        while (!map_end[s - kek[now].begin].empty() && visited[map_end[s - kek[now].begin].back()]){
            map_end[s - kek[now].begin].pop_back();
        }
        if (map_end[s - kek[now].begin].empty()){
            break;
        }
        next[map_end[s - kek[now].begin].back()] = now;
        int x = map_end[s - kek[now].begin].back();
        map_end[s - kek[now].begin].pop_back();
        now = x;
    }
    vector <int> ans(n);
    int ind = 0;

    while (now >= 0){
        ans[ind] = now + 1;
        now = next[now];
        ind++;
    }
    if (ind < n)
        ans[0] = -1;
    return ans;
}

signed main() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        kek.push_back(frag(a, b, i));
    }
    for (int s = 0; s < 100; ++s) {
        auto v = get(s);
        if (v[0] != -1){
            cout << "YES" << endl;
            for (int i = 0; i < n; ++i) {
                cout << v[i] << " ";
            }
            cout << endl;
            return 0;
        }
    }
    cout << "NO";
}

