#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define ll long long
#define ld long double
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

#define prev prev228
#define dist dist228
#define left left228
#define right right228

using namespace std;
mt19937 rnd(time(nullptr));
const ll INF = 1e18 + 10, inf = 1e9 + 10, P = 1e9 + 7;


map<char, int> mp;
int ans_min = INF, ans_max = -INF;
int id_min = -1, id_max = -1;
char c_min, c_max;
int type_min = -1, type_max = -1;
int to_get_id = 0;
int n;
vector<int> to_check;
vector<pair<int, char> > a;
vector<char> cool = {'A', 'C', 'G', 'T'};

int get_len(int x) {
    int len = 0;
    while (x > 0) {
        len++;
        x /= 10;
    }
    return len;
}

int get_size(int x) {
    if (x == 0) {
        return 0;
    }
    if (x == 1) {
        return 1;
    }
    return get_len(x) + 1;
}

void add_symb(int i, int x, int cut, char new_c, int t) {
    char c = a[i].second;
    int x1, x2, c1, c2;
    int dt = 0;
    x1 = cut;
    x2 = x - cut;
    c1 = c2 = c;
    //cout << "in the begin " << x1 << ' ' << x2 << "\n";
    dt -= get_size(x);
    //cout << "x " << x << " dt " << dt << "\n";
    if (x2 == 0 && i < n - 1) {
        c2 = a[i + 1].second;
        x2 = a[i + 1].first;
        dt -= get_size(a[i + 1].first);
    }
    if (x2 == 0) {
        c2 = '!';
    }

    if (x1 == 0 && i > 0) {
        c1 = a[i - 1].second;
        x1 = a[i - 1].first;
        dt -= get_size(a[i - 1].first);
    }
    if (x1 == 0) {
        c1 = '!';
    }
    //cout << "after " << x1 << ' ' << x2 << ' ' << c1 << ' ' << c2 << "\n";
    //cout << "dt "  << dt << "\n";

    if (new_c == c1 && new_c == c2) {
        //cout << "merged all\n";
        x1 += x2 + 1;
        dt += get_size(x1);
    } else if (new_c == c1) {
        x1++;
        dt += get_size(x1) + get_size(x2);
        //cout << "merged 1 and new_c\n";
    } else if (new_c == c2) {
        x2++;
        dt += get_size(x1) + get_size(x2);
        //cout << "merged new_c and 2\n";
    } else {
        dt += get_size(x1) + get_size(x2) + 2;
        //cout << "nothing merged\n";
    }
    //cout << "adding " << i << ' ' << x << ' ' << cut << " " << new_c << ' ' << t << "\n";
   // cout << "total dt " << dt << "\n";
    if (ans_max < dt) {
        ans_max = dt;
        id_max = to_get_id + cut;
        type_max = t;
        c_max = new_c;
    }
    if (ans_min > dt) {
        ans_min = dt;
        id_min = to_get_id + cut;
        type_min = t;
        c_min = new_c;
    }

}

vector<int> get_sas(int x) {
    vector<int> sas;
    for (int cut : to_check) {
        if (cut <= x) {
            sas.push_back(cut);
            sas.push_back(x - cut);

        }
    }
    if (x >= 2) {
        sas.push_back(2);
        sas.push_back(x - 2);
    }
    return sas;
}

void do_1(int i) {
    int x = a[i].first;
    vector<int> sas = get_sas(x);

    for (int cut : sas) {
        for (char new_c : cool) {
            //cout << "----\n";
            //cout << "doing cut new_c " << cut << ' ' << new_c << "\n";
            add_symb(i, x, cut, new_c, 1);
            //cout << "----\n";
        }
    }
}

void do_2(int i) {
    int x = a[i].first;
    { /// add 2
        int dt = 0;
        if (x == 1) {
            dt -= 2;
            int x1 = 0, x2 = 0, c1 = '!', c2 = '?';
            if (i > 0) {
                x1 = a[i - 1].first;
                c1 = a[i - 1].second;
            }
            if (i < n - 1) {
                x2 = a[i + 1].first;
                c2 = a[i + 1].second;
            }
            if (c1 == c2) {
                dt -= get_size(x1) + get_size(x2);
                dt += get_size(x1 + x2);
            }
        } else {
            dt = get_size(x - 1) - get_size(x);
        }
        if (ans_max < dt) {
            ans_max = dt;
            id_max = to_get_id + 1;
            type_max = 2;
        }
        if (ans_min > dt) {
            ans_min = dt;
            id_min = to_get_id + 1;
            type_min = 2;
        }
    }
}

void do_3(int i) {
    int x = a[i].first;
    x--;
    char c = a[i].second;
    vector<int> sas = get_sas(x);

    for (int cut : sas) {
        for (char new_c : cool) {
            if (new_c == c) {
                continue;
            }
            add_symb(i, x, cut, new_c, 3);
        }
    }
}

void solve() {
    mp['A'] = 1;
    mp['G'] = 1;
    mp['C'] = 1;
    mp['T'] = 1;
    string s;
    cin >> s;
    for (int i = 0; i < s.size(); i++) {
        int x = 0, j = i;
        while (j < s.size() && mp[s[j]] == 0) {
            x = x * 10 + (s[j] - '0');
            j++;
        }
        if (j == i) {
            x = 1;
        }
        char c = s[j];
        a.push_back({x, c});
        i = j;
    }
    n = a.size();

    for (int i = 0; i < 1e10 + 10;) {
        to_check.push_back(i);
        if (i > 1) {
            to_check.push_back(i - 1);
        }
        if (i == 0) {
            i = 1;
        } else {
            i *= 10;
        }
    }
    cool = {'A', 'C', 'G', 'T'};
    for (int i = 0; i < n; i++) {
        do_1(i);
        do_2(i);
        //do_3(i);
        to_get_id += a[i].first;
    }
    do_1(0);
    cout << type_min << ' ' << id_min << ' ';
    if (type_min != 2) {
        cout << c_min;
    }
    cout << "\n";
    cout << type_max << ' ' << id_max << ' ';
    if (type_max != 2) {
        cout << c_max;
    }
    cout << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
}

/*
5AC5A2C
*/
