#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define ll long long
#define ld long double
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

#define prev prev228
#define dist dist228
#define left left228
#define right right228

using namespace std;
mt19937 rnd(time(nullptr));

const ll INF = 1e18 + 10, inf = 1e9 + 10, P = 1e9 + 7, N = 1e5 + 10;
int f[N], l[N], n, x, cnt_take[N], cnt_give[N];
deque<int> g[N];

bool check(vector<int> a) {
    set<int> st;
    for (int i = 0; i < n - 1; i++) {
        st.insert(f[a[i + 1]] + l[a[i]]);
    }
    if (x != -1) {
        st.insert(x);
    }
    return (st.size() <= 1);
}

void solve_1() {
    vector<int> id(n);
    for (int i = 0; i < n; i++) {
        id[i] = i;
    }
    while (1) {
        if (check(id)) {
            cout << "Yes\n";
            for (int elem : id) {
                cout << elem + 1 << " ";
            }
            cout << "\n";
            return;
        }
        if (!next_permutation(all(id))) {
            cout << "No\n";
            return;
        }
    }
}

vector<int> solve_4_5(int x) {
    map<int, int> cnt_give, cnt_take;
    for (int i = 0; i < n; i++) {
        int a = f[i], b = x - l[i];
        cnt_give[a]++;
        cnt_take[b]++;
    }
    map<int, deque<int> > g;
    for (int i = 0; i < n; i++) {
        int a = f[i], b = x - l[i];
        if (cnt_take[b] - cnt_give[b] > 0) {
            g[a].push_front(i);
        } else {
            g[a].push_back(i);
        }
    }
    /*cout << "g\n";
    for (pair<int, deque<int> > p : g) {
        cout << p.first << ' ';
        for (int elem : p.second) {
            cout << elem << ' ';
        }
        cout << "\n";
    }*/
    int id = 0;
    for (int i = 0; i < n; i++) {
        int a = f[i];
        if (cnt_give[a] > cnt_take[a]) {
            id = i;
            break;
        }
    }
    int v = id;
    vector<int> used(n), ans;
    while (ans.size() < n) {
        //cout << "at v " << v << "\n";
        ans.push_back(v);
        int a = f[v], b = x - l[v];
        //cout << a << ' ' << b << "\n";
        int u = -1;
        used[v] = 1;
        while (g[b].size() > 0) {
            int pos = g[b].back();
            g[b].pop_back();
            if (!used[pos]) {
                u = pos;
                break;
            }
        }
        //cout << "gone to u " << u << "\n";
        if (u == -1 && ans.size() < n) {
            return {};
        }
        v = u;
    }

    return ans;
}

void clean() {
    for (int i = 0; i < n; i++) {
        int a = f[i], b = x - l[i];
        if (b >= 0) {
            cnt_take[b] = 0;
        }
        cnt_give[a] = 0;

    }
    for (int i = 0; i < n; i++) {
        int a = f[i], b = x - l[i];

        g[a] = {};
    }
}

vector<int> solve_5(int x) {
    for (int i = 0; i < n; i++) {
        int a = f[i], b = x - l[i];
        if (b >= 0) {
            cnt_take[b]++;
        }
        cnt_give[a]++;

    }
    for (int i = 0; i < n; i++) {
        int a = f[i], b = x - l[i];

        if (b < 0 || cnt_take[b] - cnt_give[b] > 0) {
            g[a].push_front(i);
        } else {
            g[a].push_back(i);
        }
    }
    /*cout << "\n";
    for (int i = 0; i < 10; i ++) {
        if (g[i].size() > 0) {
            cout << i << " : ";
            for (int j : g[i]) {
                cout << j << ' ';
            }
            cout << "\n";
        }
    }*/
    int id = 0;
    for (int i = 0; i < n; i++) {
        int a = f[i];
        if (cnt_give[a] > cnt_take[a]) {
            id = i;
            break;
        }
    }
    int v = id;
    vector<int> used(n), ans;
    while (ans.size() < n) {
        //cout << "at v " << v << "\n";
        ans.push_back(v);
        if (ans.size() == n) {
            break;
        }
        int a = f[v], b = x - l[v];
        if (b < 0) {
            clean();
            return {};
        }
        //cout << a << ' ' << b << "\n";
        int u = -1;
        used[v] = 1;
        while (g[b].size() > 0) {
            int pos = g[b].back();
            g[b].pop_back();
            if (!used[pos]) {
                u = pos;
                break;
            }
        }
        //cout << "gone to u " << u << "\n";
        if (u == -1 && ans.size() < n) {
            clean();
            return {};
        }
        v = u;
    }

    clean();
    return ans;
}

void solve() {
    cin >> n;
    x = -1;
    set<int> sas;
    int MAX_S = -1;
    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        MAX_S = max<int>(MAX_S, s);
        int last = -1;
        for (int j = 0; j < m; j++) {
            int p;
            cin >> p;
            if (j == 0) {
                f[i] = p;
            }
            if (j == m - 1) {
                l[i] = s - p;
            }
            if (last != -1) {
                sas.insert(p - last);
            }
            last = p;
        }
    }
    if (sas.size() > 1) {
        cout << "No\n";
        return;
    }
    if (sas.size() == 1) {
        x = *sas.begin();
    }
    if (n <= 8) {
        solve_1();
        return;
    }
    /*if (x != -1) {
        vector<int> ans = solve_4_5(x);
        if (ans.size() > 0) {
            cout << "Yes\n";
            for (int elem : ans) {
                cout << elem + 1 << " ";
            }
            cout << "\n";
        } else {
            cout << "No\n";
        }
        return;
    }*/
    if (MAX_S <= 100) {
        for (int x = 0; x <= 100; x++) {
            vector<int> ans = solve_5(x);
            if (ans.size() > 0) {
                cout << "Yes\n";
                for (int elem : ans) {
                    cout << elem + 1 << " ";
                }
                cout << "\n";
                return;
            }
        }
        cout << "No\n";
        return;
    }
}


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
}

/*
3
1 7
3
1 8
6
2 8
1 6

1
1 7
5

1
3 10
2 5 9

3
1 5
3
1 3
3
1 6
3

4
1 5
0
1 0
0
1 3
3
1 0
0

*/
