#pragma comment(linker, "/STACK:36777216")
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cassert>
#include <deque>
#include <set>
#include <numeric>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <cmath>
#include <random>
#include <ctime>
using namespace std;
#define sp system("pause")
#define pbc push_back
#define pob pop_back()
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define rev(v) reverse(all(v))
#define vin(v) for(auto &i:v)cin>>i;
#define vout(v,c) for(auto i:v)cout<<v<<c;
#define fastio() ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define uniq(v) sort(all(v));v.resize(unique(all(v))-v.begin());
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
const int MAXN = 2e5 + 1;
const int inf = 1000 * 1000 * 1000 + 1;
const ll INF = 1000ll * 1000 * 1000 * 1000 * 1000 * 1000;
const ld PI = acos(-1);
const ld EPS = 1e-9;
const int mod = 1000000007;
int cnt[2][2];
int add(int a, int b)
{
	a += b;
	if (a >= mod) a -= mod;
	if (a < 0) a += mod;
	return a;
}
int mul(int a, int b)
{
	return 1ll * a * b % mod;
}
int binpow(int a, int b)
{
	int res = 1;
	while (b)
	{
		if (b & 1) res = mul(res, a);
		b >>= 1;
		a = mul(a, a);
	}
	return res;
}
int fact[MAXN];
int ifact[MAXN];
int cnk(int n, int k)
{
	if (k > n || k < 0) return 0;
	return mul(fact[n], mul(ifact[k], ifact[n - k]));
}
int blocks(int n, int k)
{
	return cnk(n + k - 1, k - 1);
}
int befirst[2][2];
signed main()
{
	fact[0] = 1;
	for (int i = 1; i < MAXN; ++i) fact[i] = mul(fact[i - 1], i);
	for (int i = 0; i < MAXN; ++i) ifact[i] = binpow(fact[i], mod - 2);
	string a, b, c;
	cin >> a >> b >> c;
	vector<int> aa, bb, cc;
	int n = a.size();
	for (int i = 0; i < n; ++i)
	{
		aa.pbc(a[i] - '0');
		bb.pbc(b[i] - '0');
		cc.pbc(c[i] - '0');
	}
	for (int i = 0; i < n; ++i)
	{
		int carry = (aa[i] + bb[i]) / 10;
		int needcarry = aa[i] + bb[i];
		if ((aa[i] + bb[i]) % 10 == cc[i])
		{
			needcarry = 0;
		}
		else if ((aa[i] + bb[i] + 1) % 10 == cc[i])
		{
			needcarry = 1;
		}
		else
		{
			cout << 0;
			sp;
			return 0;
		}
		++cnt[carry][needcarry];
		if (aa[i] && bb[i] && cc[i]) befirst[carry][needcarry]++;
	}
	if (cnt[0][0] == n)
	{
		int left = fact[n - 1];
		int can = mul(left, befirst[0][0]);
		cout << can;
		sp;
		return 0;
	}
	if (cnt[1][1] == n || cnt[0][1] != cnt[1][0])
	{
		cout << 0;
		sp;
		return 0;
	}
	if (cnt[1][1] && !cnt[0][1])
	{
		cout << 0;
		sp;
		return 0;
	}

	int endneedcarry = 1;
	for (int i = 0; i < 4; ++i)
	{
		int x = i / 2, y = i % 2;
		if (x || !y) endneedcarry = mul(endneedcarry, fact[cnt[x][y]]);
		else
			endneedcarry = mul(endneedcarry, mul(befirst[x][y], fact[cnt[x][y] - 1]));
	}
	endneedcarry = mul(endneedcarry, add(mul(blocks(cnt[1][1], cnt[0][1]), blocks(cnt[0][0], cnt[0][1] - 1)), mul(blocks(cnt[0][0] - 1, cnt[0][1]), blocks(cnt[1][1], cnt[0][1]))));
	int endnocarry = 1;
	for (int i = 0; i < 2; ++i)
		for (int j = 0; j < 2; ++j)
		{
			if (i || j)
			{
				endnocarry = mul(endnocarry, fact[cnt[i][j]]);
			}
			else endnocarry = mul(endnocarry, mul(befirst[i][j], fact[cnt[i][j] - 1]));
		}
	int no00 = mul(blocks(cnt[1][1], cnt[0][1]), blocks(cnt[0][0] - 1, cnt[0][1]));
	int is00 = mul(blocks(cnt[1][1], cnt[0][1]), blocks(cnt[0][0] - 2, cnt[0][1] + 1));
	endnocarry = mul(endnocarry, add(no00, is00));
	cout << add(endnocarry, endneedcarry);
	sp;
}


/*
123
123
246

01
02
03

01211
12099
23300

121
214
999



*/