#include <iostream>
using namespace std;

long long n, m;

long long ans_ver(long long kol) {
    long long k = (n + ((n) * (n - 1)) / 2 * m);
    return abs(k * kol + kol * (kol - 1) / 2 * n - k * (m - kol) - (m + kol - 1) * (m - kol) / 2 * n);
}

long long ans_hor(long long kol) {
    return abs((1 + m * kol) * (m * kol) / 2 - (m * kol + 1 + m*n) * (m * (n - kol)) / 2);
}

int main()
{
    long long t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        cin >> n >> m;

        long long L = 0, R = m + 1, tum = -1;

        while (R - L > 2) {
            long long kol1 = L + (R - L) / 3, kol2 = L + 2 * (R - L) / 3;
            long long ans1 = ans_ver(kol1), ans2 = ans_ver(kol2);

            if (ans1 < ans2) {
                R = kol2;
            }
            else if (ans1 > ans2) {
                L = kol1;
            }
            else {
                L = kol1;
                R = kol2;
            }
        }

        long long mini = 1e18, otv = 0;
        for (int i = L; i < R + 1; i++) {
            if (ans_ver(i) < mini) {
                mini = ans_ver(i);
                otv = i;
                tum = 0;
            }
        }

        L = 0; R = n + 1;

        while (R - L > 2) {
            long long kol1 = L + (R - L) / 3, kol2 = L + 2 * (R - L) / 3;
            long long ans1 = ans_hor(kol1), ans2 = ans_hor(kol2);

            if (ans1 < ans2) {
                R = kol2;
            }
            else if (ans1 > ans2) {
                L = kol1;
            }
            else {
                L = kol1;
                R = kol2;
            }
        }

        for (int i = L; i < R + 1; i++) {
            if (ans_hor(i) < mini) {
                mini = ans_hor(i);
                otv = i;
                tum = 1;
            }
        }

        if (tum == 0) {
            cout << "V " << otv + 1 << endl;
        }
        else {
            cout << "H " << otv + 1 << endl;
        }
    }
}