#include <iostream>
#include <vector>
#include <set>

using namespace std;

bool all_d_same(long long x){
    long long d = x % 10;
    x /= 10;
    while (x > 0){
        if (x % 10 != d){
            return false;
        }
        x /= 10;
    }
    return true;
}

bool except_one(long long x){
    set <long long> st;
    while (x > 0){
        st.insert(x % 10);
        x /= 10;
    }
    if (st.size() <= 2){
        return true;
    }
    return false;
}

long long len_num(long long x){
    long long len = 0;
    while (x > 0){
        len++;
        x /= 10;
    }
    return len;
}

long long create_num(long long d, long long len){
    long long num = d;
    for (long long i = 0; i < len - 1; i++){
        num = num * 10 + d;
    }
    return num;
}

long long create_except_one(long long d1, long long d2, long long id2, long long len){
    long long num = 0;
    for (long long id = 1; id <= len; id++){
        if (id == id2){
            num = num * 10 + d2;
        }
        else{
            num = num * 10 + d1;
        }
    }
    return num;
}

long long x, k, len_x;

int main()
{
    cin >> x >> k;
    len_x = len_num(x);
    vector <long long> ten_pow(len_x + 1);
    long long cur_pow = 1;
    for (long long i = 0; i <= len_x; i++){
        ten_pow[i] = cur_pow;
        cur_pow *= 10;
    }
    if (k == 0){
        long long min_num = create_num(9, len_x);
        for (long long i = 1; i <= 9; i++){
            long long new_num_same = create_num(i, len_x);
            if (new_num_same >= x){
                min_num = min(new_num_same, min_num);
            }
        }
        cout << min_num;
        return 0;
    }
    else{
        long long min_num = create_num(9, len_x);
        for (long long i = 0; i <= 9; i++){
            for (long long o = 0; o <= 9; o++){
                for (long long id = 1; id <= len_x; id++){
                    long long new_num1 = create_except_one(i, o, id, len_x);
                    long long new_num2 = create_except_one(o, i, id, len_x);
                    if (new_num1 >= x){
                        min_num = min(min_num, new_num1);
                    }
                    if (new_num2 >= x){
                        min_num = min(min_num, new_num2);
                    }
                }
                for (long long id = len_x; id >= 1; id--){
                    long long new_num1 = create_except_one(i, o, id, len_x);
                    long long new_num2 = create_except_one(o, i, id, len_x);
                    if (new_num1 >= x){
                        min_num = min(min_num, new_num1);
                    }
                    if (new_num2 >= x){
                        min_num = min(min_num, new_num2);
                    }
                }
            }
        }
        cout << min_num;
        return 0;
    }
    return 0;
}
