#include <iostream>
#include <vector>

using namespace std;

long long n, m, c;
bool break_flag = false;
long long rest_to_paint;

void rec_dfs(long long i, long long o, long long color, vector <vector <long long> >&g){
    if (break_flag){
        return;
    }
    g[i][o] = color;
    rest_to_paint--;
    if (rest_to_paint == 0){
        bool not_bad = true;
        for (long long x1 = 0; x1 < n; x1++){
            for (long long x2 = x1 + 1; x2 < n; x2++){
                for (long long y1 = 0; y1 < m; y1++){
                    for (long long y2 = y1 + 1; y2 < m; y2++){
                        if ((g[x1][y1] == g[x2][y1]) && (g[x2][y1] == g[x1][y2]) && (g[x1][y2] == g[x2][y2])){
                            not_bad = false;
                            break;
                        }
                    }
                }
            }
        }
        if (not_bad){
            for (long long i = 0; i < n; i++){
                for (long long o = 0; o < m; o++){
                    cout << g[i][o] << ' ';
                }
                cout << '\n';
            }
            break_flag = true;
            return;
        }
    }
    if (i > 0){
        if (g[i - 1][o] == 0){
            for (long long col = 1; col <= c; col++){
                rec_dfs(i - 1, o, col, g);
                if (break_flag){
                    return;
                }
            }
        }
    }
    if (i < n - 1){
        if (g[i + 1][o] == 0){
            for (long long col = 1; col <= c; col++){
                rec_dfs(i + 1, o, col, g);
                if (break_flag){
                    return;
                }
            }
        }
    }
    if (o > 0){
        if (g[i][o - 1] == 0){
            for (long long col = 1; col <= c; col++){
                rec_dfs(i, o - 1, col, g);
                if (break_flag){
                    return;
                }
            }
        }
    }
    if (o < m - 1){
        if (g[i][o + 1] == 0){
            for (long long col = 1; col <= c; col++){
                rec_dfs(i, o + 1, col, g);
                if (break_flag){
                    return;
                }
            }
        }
    }
    rest_to_paint++;
    g[i][o] = 0;
}

int main()
{
    cin >> n >> m >> c;
    rest_to_paint = n * m;
    vector <long long> g1(m, 0);
    vector <vector <long long> > g(n, g1);
    for (long long i = 1; i <= c; i++){
        rec_dfs(0, 0, i, g);
        if (break_flag){
            break;
        }
    }
    return 0;
}
