#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const long long mod = 1000000007;
string a, b, c;
long long ans = 0;

string sum_str(string a, string b){
    string sum = "";
    long long cur_dop = 0;
    for (long long i = a.size() - 1; i >= 0; i--){
        long long d_a = (long long)(a[i]) - 48;
        long long d_b = (long long)(b[i]) - 48;
        if (d_a + d_b + cur_dop >= 10){
            sum += (char)(d_a + d_b + cur_dop - 10 + 48);
            cur_dop = 1;
        }
        else{
            sum += (char)(d_a + d_b + cur_dop + 48);
            cur_dop = 0;
        }
    }
    if (cur_dop == 1){
        sum += '1';
    }
    reverse(sum.begin(), sum.end());
    return sum;
}

void rec(long long i, string&a1, string&b1, string&c1, vector <bool>&used){
    used[i] = true;
    a1 += a[i];
    b1 += b[i];
    c1 += c[i];
    if (a1.size() == a.size()){
        if (sum_str(a1, b1) == c1){
            ans++;
        }
    }
    for (long long o = 0; o < a.size(); o++){
        if (!used[o]){
            rec(o, a1, b1, c1, used);
        }
    }
    used[i] = false;
    a1.pop_back();
    b1.pop_back();
    c1.pop_back();
}

int main()
{
    cin >> a;
    cin >> b;
    cin >> c;
    string a1 = "";
    string b1 = "";
    string c1 = "";
    vector <bool> used(a.size(), false);
    for (long long i = 0; i < a.size(); i++){
        if ((a[i] == '0') || (b[i] == '0') || (c[i] == '0')){
            continue;
        }
        rec(i, a1, b1, c1, used);
    }
    cout << ans;
    return 0;
}
