#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <time.h>
#define all(x) x.begin(), x.end()
#define mp make_pair
#define int ld

typedef long long ll;
typedef long double ld;
using namespace std;
const ll INF = 1e18 + 7, N = 5e6 + 5;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }

ll n, m, k, t;


ll vf(ll x) {
	ll num = ((m + 1) * m) / 2;
	ll tmp = (m * m * x * (x - 1)) / 2;
	return num * x + tmp;
}


ll hf(ll x) {
	ll num = (x * (x + 1)) / 2;
	ll tmp = (n * (n - 1) * m * x) / 2;
	return num * n + tmp;
}


void solve() {

	cin >> n >> m;
	ll l, r, ans = INF, ind = -1;
	char lid = '-';

	ans = abs(vf(n) - 2 * vf(n / 2));
	ind = n / 2 + 1;
	lid = 'H';

	l = 0, r = n + 1;

	while (l + 1 < r) {
		long long mid = (l + r) / 2;

		ll num1 = vf(mid);
		ll num2 = vf(n) - num1;

		if (num2 > num1) {
			l = mid;
		}
		else {
			r = mid;
		}
	}

	ll num1 = abs(vf(n) - 2 * vf(l));
	ll num2 = abs(vf(n) - 2 * vf(r));

	if (ans > num1) {
		ans = num1;
		ind = l + 1;
		lid = 'H';
	}
	if (ans > num2) {
		ans = num2;
		ind = r + 1;
		lid = 'H';
	}


	l = 0, r = m + 1;

	while (l + 1 < r) {
		long long mid = (l + r) / 2;

		ll num1 = hf(mid);
		ll num2 = hf(m) - num1;

		if (num2 > num1) {
			l = mid;
		}
		else {
			r = mid;
		}
	}

	num1 = abs(hf(m) - 2 * hf(l));
	num2 = abs(hf(m) - 2 * hf(r));

	if (ans >= num1) {
		ans = num1;
		ind = l + 1;
		lid = 'V';
	}
	if (ans >= num2) {
		ans = num2;
		ind = r + 1;
		lid = 'V';
	}


	cout << lid << " " << ind << '\n';

}



signed main()
{
	//srand(time(NULL));
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> t;

	while (t--) {
		solve();
	}


}