#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <time.h>
#define all(x) x.begin(), x.end()
#define mp make_pair
//#define int ll

typedef long long ll;
typedef long double ld;
using namespace std;
const ll INF = 1e18 + 7, N = 5e6 + 5;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }

ll n, m, k, t;

ll sz(ll x) {
	if (x == 0) return 0;
	if (x == 1) return 1;
	ll len = 0;
	while (x) {
		len++;
		x /= 10;
	}
	return len + 1;
}


void solve() {

	string s;
	cin >> s;
	m = s.size();
	vector<pair<int, char>> tmp;

	for (int i = 0; i < m; i++) {
		char x = s[i];

		if ('0' <= x && x <= '9') {

			ll num = x - '0';

			while (i + 1 < m && '0' <= s[i + 1] && s[i + 1] <= '9') {
				i++;
				num *= 10;
				num += s[i] - '0';
			}
			i++;

			tmp.push_back(mp(num, s[i]));
			n += num;

		}
		else {
			tmp.push_back(mp(1, x));
			n += 1;
		}
	}

	char chL = ' ', chR = ' ';
	ll indL = -1, indR = -1;
	ll spL = -1, spR = -1;
	ll mini = m, maxi = m + 1;

	map<char, char> next;
	next['A'] = 'T';
	next['T'] = 'G';
	next['G'] = 'C';
	next['C'] = 'A';


	indR = 0;
	spR = 1;
	chR = next[tmp[0].second];


	ll pref = 0;

	for (int i = 0; i < tmp.size(); i++) {
		ll a, b;

		auto p = tmp[i];
		char ch = tmp[i].second;

		ll num = m - sz(tmp[i].first) + sz(tmp[i].first - 1);
		if (mini >= num) {
			mini = num;
			spL = 2;
			chL = ' ';
			indL = pref + 1;
		}
		if (maxi <= num) {
			maxi = num;
			spR = 2;
			chR = ' ';
			indR = pref + 1;
		}


		num = m - sz(p.first) + sz(p.first + 1);
		if (mini >= num) {
			mini = num;
			spL = 1;
			chL = ch;
			indL = pref + 1;
		}
		if (maxi <= num) {
			maxi = num;
			spR = 1;
			chR = ch;
			indR = pref + 1;
		}
		

		if (p.first > 1) {
			a = p.first / 2;
			b = p.first - a;
			ll n_ = m - sz(p.first) + sz(a) + sz(b) + 1;
			if (maxi <= n_) {
				maxi = n_;
				spR = 1;
				chR = next[ch];
				indR = pref + a;
			}
			if (mini >= n_) {
				mini = n_;
				spL = 1;
				chL = next[ch];
				indR = pref + a;
			}
		}
		else if (i && i < tmp.size() - 1 && tmp[i - 1].second == tmp[i + 1].second) {

			ll ab = tmp[i - 1].first + tmp[i + 1].first;
			ll n_ = m - sz(tmp[i - 1].first) - sz(tmp[i].first) - sz(tmp[i + 1].first) + sz(ab);

			if (maxi <= n_) {
				maxi = n_;
				spR = 2;
				chR = ' ';
				indR = pref + 1;
			}
			if (mini >= n_) {
				mini = n_;
				spL = 2;
				chL = ' ';
				indL = pref + 1;
			}
		}
		if (tmp[i].first == 1) {
			set<char> st;
			st.insert('A');
			st.insert('T');
			st.insert('G');
			st.insert('C');
			if (i) {
				st.erase(tmp[i - 1].second);
			}
			st.erase(ch);
			if (i < tmp.size() - 1) {
				st.erase(tmp[i + 1].second);
			}


			if (maxi <= m) {
				maxi = m;
				spR = 3;
				chR = *st.begin();
				indR = pref + 1;
			}
			if (mini >= m) {
				mini = m;
				spL = 3;
				chL = *st.begin();
				indL = pref + 1;
			}
		}

		pref += tmp[i].first;

	}

	cout << spL << " " << indL << " " << chL << '\n';
	cout << spR << " " << indR << " " << chR;

}



signed main()
{
	//srand(time(NULL));
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);


	solve();
	


}