#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <time.h>
#define all(x) x.begin(), x.end()
#define mp make_pair
//#define int ll

typedef long long ll;
typedef long double ld;
using namespace std;
const ll INF = 1e18 + 7, N = 4e6 + 5;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }


ll n, m, k;

ll solve0(ll x) {
	vector<int> arr;
	ll x_ = x;

	while (x_) {
		arr.push_back(x_ % 10);
		x_ /= 10;
	}

	reverse(all(arr));
	vector<int> ans = arr;

	for (int i = 0; i < ans.size(); i++) {
		ans[i] = arr[0];
	}

	ll num;
	num = 0;

	for (int i = 0; i < ans.size(); i++) {
		num *= 10;
		num += ans[0];
	}

	if (x <= num) {
		return num;
	}
	else {
		ans[0]++;
	}

	num = 0;

	for (int i = 0; i < ans.size(); i++) {
		num *= 10;
		num += ans[0];
	}

	return num;
}

bool check(ll x) {
	vector<int> cnt(10);
	ll x_ = x;

	while (x_) {
		cnt[x_ % 10]++;
		x_ /= 10;
	}

	ll num = 0, count = 0;
	for (ll p : cnt) {
		if (p != 0) {
			num++;
		}
		if (p == 1) {
			count++;
		}
	}
	if (num == 2 && count > 0 || num == 1) {
		return true;
	}
	return false;
}


ll solve1(ll x) {
	vector<int> arr;
	ll x_ = x;

	while (x_) {
		arr.push_back(x_ % 10);
		x_ /= 10;
	}

	reverse(all(arr));
	vector<int> ans = arr;

	if (check(x)) {
		return x;
	}


	ll answ = INF;

	for (int i = 0; i <= 9; i++) {
		for (int ind = 0; ind < arr.size(); ind++) {
			vector<int> tmp;
			for (int cc = 0; cc <= 9; cc++) {
				tmp.push_back(cc);
			}

			for (int p : tmp) {

				vector<int> cur(arr.size(), i);
				cur[ind] = p;

				ll num = 0;

				for (int pp : cur) {
					num *= 10;
					num += pp;
				}

				if (num >= x) {
					answ = min(answ, num);
				}
			}
		}
	}

	return answ;

}



signed main()
{
	srand(time(nullptr));
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	ll x, ask;

	cin >> x >> ask;

	if (ask == 0) {
		cout << solve0(x);
	}
	else {
		cout << min(solve1(x), solve0(x));
	}


}