#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

const int C = 1000000007;
vector<int> fact, fact1;

int pow1(int x, int y, int z=C){
    if (y == 0){
        return 1;
    }
    if (y % 2 == 0){
        return pow1(x*x % z, y/2, z);
    }
    return pow1(x, y-1, z)*x % z;
}

void facts(int n){
    fact = {1}, fact1 = {1};
    for (int q = 1; q <= n; q++){
        fact.push_back(fact.back()*q % C);
        fact1.push_back(fact1.back()*pow1(q, C-2) % C);
    }
}

int c(int k, int n){
    if (k < 0 || k > n){
        return 0;
    }
    return fact[n]*fact1[k] % C*fact1[n-k] % C;
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    facts(2*n+3);
    vector<pair<p, int>> a;
    for (int q = 0; q < n; q++){
        a.push_back({{s1[q]-'0', s2[q]-'0'}, s3[q]-'0'});
    }
    int num00 = 0, num01 = 0, num10 = 0, num11 = 0;
    for (pair<p, int> q: a){
        if ((q.first.first+q.first.second) % 10 == q.second){
            if (q.first.first+q.first.second < 10){
                num00++;
            }else{
                num10++;
            }
        }else if ((q.first.first+q.first.second+1) % 10 == q.second){
            if (q.first.first+q.first.second+1 < 10){
                num01++;
            }else{
                num11++;
            }
        }else{
            cout << 0 << endl;
            return 0;
        }
    }
    int answer = 0;
    for (auto q: a){
        if (q.first.first != 0 && q.first.second != 0 && q.second != 0){
            int ind = -1;
            if ((q.first.first+q.first.second) % 10 == q.second){
                if (q.first.first+q.first.second < 10){
                    ind = 0;
                }else{
                    ind = 2;
                }
            }else{
                if (q.first.first+q.first.second+1 < 10){
                    ind = 1;
                }else{
                    ind = 3;
                }
            }
            if (ind >= 2){
                continue;
            }
            num00 -= (ind == 0), num01 -= (ind == 1), num10 -= (ind == 2), num11 -= (ind == 3);
            int ans = 0;
            if (ind == 0 && num01 == num10) {
                ans = fact[num00]*fact[num01] % C*fact[num10] % C*fact[num11] % C*c(num00, num01+num00) % C*(num11 == 0 ? 1 : c(num11, num01+num11-1)) % C;
            }else if (ind >= 2 && num01+1 == num10){
                ans = fact[num00]*fact[num01] % C*fact[num10] % C*fact[num11] % C*c(num00, num01+num00) % C*c(num11, num01+num11) % C;
            }
            answer += ans;
            num00 += (ind == 0), num01 += (ind == 1), num10 += (ind == 2), num11 += (ind == 3);
        }
    }
    cout << answer % C << endl;
    return 0;
}
/*
123
123
246

01
02
03

01211
12099
23300

121
214
999

*/
