#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")

using namespace std;

#define x first
#define y second
#define forn(i, n) for (int (i) = 0; (i) < (n); i++)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define firn(i, n) for (int (i) = 1; (i) < (n); i++)
typedef long long ll;
typedef long double ld;

const int inf = 1e9, mod = 1000'000'007;
const ll llinf = 1e18;
const char el = '\n';

mt19937 rnd(time(nullptr));

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    bool ok = false;
    int dist = -1;
    int n;
    cin >> n;
    vector<int> l(n), r(n);
    forn(i, n) {
        int m, s;
        cin >> m >> s;
        vector<int> a(m);
        forn(j, m) cin >> a[j];
        if (m == 1) {
            l[i] = a[0];
            r[i] = s - a[0];
        } else {
            ok = true;
            if (dist != -1 && dist != a[1] - a[0]) return cout << "No" << el, 0;
            dist = a[1] - a[0];
            firn(j, a.size())
                if (dist != a[j] - a[j - 1]) return cout << "No" << el, 0;
            l[i] = a[0];
            r[i] = s - a.back();
        }
    }
    if (ok) {
        map<int, int> L, R;
        forn(i, n) {
//            if (l[i] > dist || r[i] > dist) return cout << "No" << el, 0;
            L[l[i]]++;
            R[r[i]]++;
        }
        int ll = 0, rr = 0;
        int st = -1, fn = -1;
        for (auto &to : L) {
            int a = to.y, b = R[dist - to.x];
            if (a == b) continue;
            if (abs(a - b) > 1) return cout << "No" << el, 0;
            if (a > b) {
                ll++;
                st = to.x;
            }
            else {
                rr++;
                fn = dist - to.x;
            }
            to.y = 0;
            R[dist - to.x] = 0;
        }
        for (auto &to : R) {
            int b = to.y, a = L[dist - to.x];
            if (a == b) continue;
            if (abs(a - b) > 1) return cout << "No" << el, 0;
            if (a > b) {
                ll++;
                st = dist - to.x;
            }
            else {
                rr++;
                fn = to.x;
            }
        }
        if (ll > 1 || rr > 1) return cout << "No" << el, 0;
        int i = -1;
        forn(j, n) {
            if (l[j] == st || st == -1) {
                i = j;
                break;
            }
        }
        vector<int> ans(1, i);
        set<pair<int, int>> q;
        forn(j, n) {
            if (i == j) continue;
            q.emplace(l[j], j);
        }
        while(!q.empty()) {
            auto j = q.lower_bound(pair<int, int>{dist - r[i], 0});
            assert(j->x == dist - r[i]);
            if (r[j->y] == fn && (int)ans.size() < n - 1) {
                j++;
                if (j == q.end() || j->x != dist - r[i]) j--;
            }
            i = j->y;
            q.erase(j);
            ans.push_back(i);
        }
        cout << "Yes" << el;
        forn(j, ans.size())
            cout << ans[j] + 1 << ' ';
        cout << el;
    }
    return 0;
}
