/*
 * 0000000
 * 0     0
 * 0     0
 * 0     0
 * 0000000
 */

#include <iostream>
#include <vector>
#include <cmath>
#include <string.h>

#define int long long

using namespace std;

int solve(int n, int m)
{
    int ans = 1e18 + 1303, ansidx;
    char ansch;
    int l = 0;
    int r = m;
    while (r - l > 1)
    {
        //cout << l << ' ' << r << endl;
        int mid1 = l + (r - l)/3, mid2 = l + max((r - l)/3*2, (int)1);
        int ans1 = abs(n*m*(n*m + 1)/2 - n*mid1*(1 + mid1 + n*m - m));
        int ans2 = abs(n*m*(n*m + 1)/2 - n*mid2*(1 + mid2 + n*m - m));
        if (ans1 > ans2)
            l = mid1 + 1;
        if (ans1 < ans2)
            r = mid2 - 1;
    }
    int ans11 = abs(n*m*(n*m + 1)/2 - n*l*(1 + l + n*m - m));
    int ans22 = abs(n*m*(n*m + 1)/2 - n*r*(1 + r + n*m - m));
    if (ans11 < ans)
    {
        ans = ans11;
        ansch = 'V';
        ansidx = l;
    }
    if (ans22 < ans)
    {
        ans = ans22;
        ansch = 'V';
        ansidx = r;
    }
    l = 0;
    r = n;
    while (r - l > 1)
    {
        int mid1 = l + (r - l)/3, mid2 = l + max(2*(r - l)/3*2, (int)1);
        int ans1 = abs(n*m*(n*m + 1)/2 - (mid1 * m)*(mid1*m + 1));
        int ans2 = abs(n*m*(n*m + 1)/2 - (mid2 * m)*(mid2*m + 1));
        if (ans1 > ans2)
            l = mid1 + 1;
        if (ans1 < ans2)
            r = mid2 - 1;
    }
    ans11 = abs(n*m*(n*m + 1)/2 - (l * m)*(l*m + 1));
    ans22 = abs(n*m*(n*m + 1)/2 - (r * m)*(r*m + 1));
    if (ans11 < ans)
    {
        ans = ans11;
        ansidx = l;
        ansch = 'H';
    }
    if (ans22 < ans)
    {
        ans = ans22;
        ansidx = r;
        ansch = 'H';
    }
    cout << ansch << ' ' << ansidx + 1 << endl;
}


signed main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
    {
        int m, n;
        cin >> n >> m;
        solve(n, m);
    }
}
