/*
 * 0000000  K   K
 * 0     0  K  K
 * 0     0  KKK
 * 0     0  K  K
 * 0000000  K   K
 */

#include <iostream>
#include <vector>
#include <cmath>
#include <string.h>

#define int long long

using namespace std;

int solve(int n, int m)
{
    int ans = n*m*(n*m + 1)/2, ansidx;
    char ansch;
    int l = 0;
    int r = m;
    while (r - l > 2)
    {
        //cout << l << ' ' << r << endl;
        int mid1 = l + (r - l)/3, mid2 = l + max((r - l)/3*2, (int)1);
        int ans1 = abs(n*m*(n*m + 1)/2 - n*mid1*(1 + mid1 + n*m - m));
        int ans2 = abs(n*m*(n*m + 1)/2 - n*mid2*(1 + mid2 + n*m - m));
        if (ans1 > ans2)
            l = mid1 + 1;
        if (ans1 < ans2)
            r = mid2 - 1;
    }
    int ans11 = abs(n*m*(n*m + 1)/2 - n*l*(1 + l + n*m - m));
    int ans22 = abs(n*m*(n*m + 1)/2 - n*r*(1 + r + n*m - m));
    int ans33 = abs(n*m*(n*m + 1)/2 - n*(l + 1)*(1 + l + 1 + n*m - m));
    if (ans11 < ans)
    {
        ans = ans11;
        ansch = 'V';
        ansidx = l;
    }
    if (ans33 < ans)
    {
        ans = ans33;
        ansch = 'V';
        ansidx = l + 1;
    }
    if (ans22 < ans)
    {
        ans = ans22;
        ansch = 'V';
        ansidx = r;
    }
    l = 0;
    r = n;
    while (r - l > 2)
    {
        int mid1 = l + (r - l)/3, mid2 = l + max(2*(r - l)/3*2, (int)1);
        int ans1 = abs(n*m*(n*m + 1)/2 - (mid1 * m)*(mid1*m + 1));
        int ans2 = abs(n*m*(n*m + 1)/2 - (mid2 * m)*(mid2*m + 1));
        if (ans1 > ans2)
            l = mid1 + 1;
        if (ans1 < ans2)
            r = mid2 - 1;
    }
    ans11 = abs(n*m*(n*m + 1)/2 - (l * m)*(l*m + 1));
    ans22 = abs(n*m*(n*m + 1)/2 - (r * m)*(r*m + 1));
    ans33 = abs(n*m*(n*m + 1)/2 - (l + 1 * m)*((l + 1)*m + 1));
    if (ans11 < ans)
    {
        ans = ans11;
        ansidx = l;
        ansch = 'H';
    }
    if (ans33 < ans)
    {
        ans = ans11;
        ansidx = l + 1;
        ansch = 'H';
    }
    if (ans22 < ans)
    {
        ans = ans22;
        ansidx = r;
        ansch = 'H';
    }
    cout << ansch << ' ' << ansidx + 1 << endl;
}

int len(int x)
{
    if (!x)
        return 0;
    int tmp = 1;
    int xx = x;
    while (x)
    {
        ++tmp;
        x /= 10;
    }
    return xx == 1 ? 1 : tmp;
}

int splitnum(int x)
{
    if (x < 3)
        return 1;
    if (x <= 10)
        return 2;
    int tmp = 10;
    int ans = 4;
    int cnt = 2;
    int idx = 2;
    while (tmp < x)
    {
        int st = cnt + 1 + len(x - tmp);
        ans = max(ans, st);
        if (ans == st)
            idx = tmp;
        tmp *= 10;
        ++cnt;
    }
    return idx;
}





signed main()
{
    vector<char> dna = {'A', 'G', 'C', 'T'};
    string s;
    cin >> s;
    vector<pair<int, char>> v;
    int cnt = 0;
    for (auto ch : s)
    {
        if ('0' <= ch && ch <= '9')
            cnt = cnt * 10 + ch - '0';
        else if (!cnt)
            v.push_back({1, ch});
        else
        {
            v.push_back({cnt, ch});
            cnt = 0;
        }
    }
    int mn = 1e18 + 1303, mnt, mnidx, mnch;
    int mx = -1e18 + 1303, mxt, mxidx, mxch;
    cnt = 0;
    for (int i = 0; i < v.size(); ++i)
    {
        if (i + 1 < v.size() && i) {
            int now = len(v[i].first) + len(v[i + 1].first) + len(v[i - 1].first);
            if (v[i].first == 1) {
                if (v[i - 1].second == v[i + 1].second) {
                    int tmp = len(v[i - 1].first + v[i + 1].first + 1) - now;
                    mn = min(tmp, mn);
                    if (mn == tmp) {
                        mnt = 3;
                        mnidx = cnt + 1;
                        mnch = v[i - 1].second;
                    }
                    mx = max(tmp, mx);
                    if (mx == tmp) {
                        mxt = 3;
                        mxidx = cnt + 1;
                        mnch = v[i - 1].second;
                    }
                } else {
                    int tmp1 = len(v[i - 1].first + 1) + len(v[i + 1].first) - now;
                    int tmp2 = len(v[i + 1].first + 1) + len(v[i - 1].first) - now;
                    mn = min(tmp1, mn);
                    if (mn == tmp1) {
                        mnt = 3;
                        mnidx = cnt + 1;
                        mnch = v[i - 1].second;
                    }
                    mx = max(tmp1, mx);
                    if (mx == tmp1) {
                        mxt = 3;
                        mxidx = cnt + 1;
                        mnch = v[i - 1].second;
                    }
                    mn = min(tmp2, mn);
                    if (mn == tmp2) {
                        mnt = 3;
                        mnidx = cnt + 1;
                        mnch = v[i + 1].second;
                    }
                    mx = max(tmp2, mx);
                    if (mx == tmp2) {
                        mxt = 3;
                        mxidx = cnt + 1;
                        mnch = v[i + 1].second;
                    }
                }
                int tmp = 0;
                mn = min(tmp, mn);
                if (mn == tmp) {
                    mnt = 3;
                    mnidx = cnt + 1;
                    if ('A' != v[i].second && 'A' != v[i - 1].second && 'A' != v[i + 1].second)
                        mnch = 'A';
                    if ('G' != v[i].second && 'G' != v[i - 1].second && 'G' != v[i + 1].second)
                        mnch = 'G';
                    if ('C' != v[i].second && 'C' != v[i - 1].second && 'C' != v[i + 1].second)
                        mnch = 'C';
                    if ('T' != v[i].second && 'T' != v[i - 1].second && 'T' != v[i + 1].second)
                        mnch = 'T';
                }
                mx = max(tmp, mx);
                if (mn == tmp) {
                    mnt = 3;
                    mnidx = cnt + 1;
                    if ('A' != v[i].second && 'A' != v[i - 1].second && 'A' != v[i + 1].second)
                        mnch = 'A';
                    if ('G' != v[i].second && 'G' != v[i - 1].second && 'G' != v[i + 1].second)
                        mnch = 'G';
                    if ('C' != v[i].second && 'C' != v[i - 1].second && 'C' != v[i + 1].second)
                        mnch = 'C';
                    if ('T' != v[i].second && 'T' != v[i - 1].second && 'T' != v[i + 1].second)
                        mnch = 'T';
                }
            }

        }
        int now = len(v[i].first);
        int sn = splitnum(v[i].first);
        int tmp = len(sn) + len(v[i].first - sn) + 1 - now;
        mn = min(tmp, mn);
        if (tmp == mn)
        {
            mnt = 1;
            mnidx = cnt + sn;
            if ('A' != v[i].second)
                mnch = 'A';
            else
                mnch = 'G';
        }
        mx = max(tmp, mx);
        if (tmp == mx)
        {
            mxt = 1;
            mxidx = cnt + sn;
            if ('A' != v[i].second)
                mxch = 'A';
            else
                mxch = 'G';
        }
        cnt += v[i].first;
        tmp = 1;
        mn = min(mn, tmp);
        if (tmp == mn)
        {
            mnt = 1;
            mnidx = cnt;
            if ('A' != v[i].second && (i + 1 == v.size() || 'A' != v[i + 1].second))
                mnch = 'A';
            if ('G' != v[i].second && (i + 1 == v.size() || 'G' != v[i + 1].second))
                mnch = 'G';
            if ('C' != v[i].second && (i + 1 == v.size() || 'C' != v[i + 1].second))
                mnch = 'C';
        }
        mx = max(mx, tmp);
        if (tmp == mx)
        {
            mxt = 1;
            mxidx = cnt;
            if ('A' != v[i].second && (i + 1 == v.size() || 'A' != v[i + 1].second))
                mnch = 'A';
            if ('G' != v[i].second && (i + 1 == v.size() || 'G' != v[i + 1].second))
                mnch = 'G';
            if ('C' != v[i].second && (i + 1 == v.size() || 'C' != v[i + 1].second))
                mnch = 'C';
        }
        tmp = len(v[i].first - 1) - len(v[i].first);
        mn = min(mn, tmp);
        if (tmp == mn)
        {
            mnt = 2;
            mnidx = cnt;
            mnch = v[i].second;
        }
        mx = max(mx, tmp);
        if (tmp == mx)
        {
            mxt = 2;
            mxidx = cnt;
            mxch = v[i].second;
        }

    }
    if (mnt == 2)
        cout << 2 << ' ' << mnidx << endl;
    else
        cout << mnt << ' ' << mnidx << ' ' << (char)mnch << endl;
    if (mxt == 2)
        cout << 2 << ' ' << mxidx << endl;
    else
        cout << mxt << ' ' << mxidx << ' ' << (char)mxch << endl;
}
// 5AC5A2C