#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

struct MyStruct {
	string x;
	bool digit;
};

bool isdigit(char c) {
	if (c >= '0' && c <= '9')
		return true;
	return false;
}

ll get_size1(ll k) {
	ll ans = 0;
	while (k > 0) {
		k /= 10;
		ans++;
	}
	return ans;
}

ll get_size(string k1) {
	ll k = stoi(k1);
	if (k <= 1)
		return k;
	return get_size1(k) + 1;
}

bool check(string s) {
	if (s[0] != '1')
		return false;
	for (ll i = 1; i < s.size() - 1; ++i) {
		if (s[i] != '0')
			return false;
	}
	if (s.back() != '1' && s.back() != '0')
		return false;
	return true;
}

ll power(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n % 2 == 0) {
		ll tmp = power(a, n / 2);
		return tmp * tmp;
	}
	return power(a, n - 1) * a;
}

int main() {
	string s1;
	cin >> s1;
	vector<MyStruct> s = { {" ", false} };
	for (auto i : s1) {
		if (isdigit(i)) {
			if (s.back().digit)
				s[s.size() - 1].x += i;
			else {
				string tmp = " ";
				tmp[0] = i;
				s.push_back({ tmp, true });
			}
		}
		else {
			if (s.size() == 1 || !s.back().digit)
				s.push_back({ "1", true });
			string tmp = " ";
			tmp[0] = i;
			s.push_back({ tmp, false });
		}
	}
	ll n = s.size();
	s.push_back({ "0", true });
	s.push_back({ "#", false });


	//
	ll ans = -1;
	ll now = 0;
	ll mn = s1.size();
	for (ll i = 1; i < n; ++i) {
		if (s[i].digit) {
			ll tmp = stoi(s[i].x);
			now += tmp;
			ll len = s1.size();
			if (tmp == 1) {
				if (s[i - 1].x == s[i + 3].x) {
					len -= 1;
					len -= get_size(s[i - 2].x);
					len -= get_size(s[i + 2].x);
					len += get_size1(stoi(s[i - 2].x) + stoi(s[i + 2].x)) + 1;
				}
				else {
					len -= 1;
				}
			}
			else {
				len -= get_size(s[i].x);
				len += get_size(to_string(stoi(s[i].x) - 1));
			}
			if (len < mn) {
				ans = now;
				mn = len;
			}
		}
	}
	if (ans == -1)
		ans = 1; 
	cout << 2 << " " << ans << "\n";


	//
	ans = -1;
	char ansc;
	now = 0;
	ll mx = s1.size();
	for (ll i = 1; i < n; ++i) {
		if (s[i].digit)
			now += stoi(s[i].x);
		if (s[i].digit && s[i].x != "1") {
			ll len = s1.size();
			len -= get_size(s[i].x);
			ll tmp = power(10, get_size1(stoi(s[i].x)) - 1);
			if (tmp == 2)
				tmp++;
			len += get_size(to_string(tmp));
			len += get_size(to_string(stoi(s[i].x) - tmp));
			len++;
			if (len > mx) {
				mx = len;
				ans = now - (stoi(s[i].x) - tmp);
				if (s[i + 1].x == "C")
					ansc = 'A';
				else
					ansc = 'C';
			}
		}
	}
	if (ans == -1) {
		ans = 0;
		if (s1[0] == 'C')
			ansc = 'A';
		else
			ansc = 'C';
	}
	cout << 1 << " " << ans << " " << ansc << endl;
}