#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

bool check(const vector<vector<int>>& a, int n, int m) {
	bool res = true;
	for (int x1 = 0; x1 < n - 1; ++x1) {
		for (int x2 = x1 + 1; x2 < n; ++x2) {
			for (int y1 = 0; y1 < m - 1; ++y1) {
				for (int y2 = y1 + 1; y2 < m; ++y2) {
					if (a[x1][y1] != 0 && a[x1][y1] == a[x2][y1] && a[x1][y1] == a[x1][y2] && a[x1][y1] == a[x2][y2])
						res = false;
				}
			}
		}
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m, c;
	cin >> n >> m >> c;
	vector<vector<int>> a(n, vector<int>(m, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			for (int g = 1; g <= c; ++g) {
				int tmp = a[i][j];
				a[i][j] = g;
				if (!check(a, n, m))
					a[i][j] = tmp;
			}
		};
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cout << a[i][j] << " ";
		}
		cout << "\n";
	}
}