#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <utility>
#include <algorithm>
#define int long long
#define pb push_back
#define eb emplace_back
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
using namespace std;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using vb = vector<bool>;


inline int S(int a, int b)
{
    if (b < a)
        return 0;
    return (a+b)*(b-a+1)/2;
}


inline int costv(int n, int m, int k)
{
    int res = n*(S(k, m) - S(1, k-1)) + S(1, n-1)*m*(m - 2*k + 2);
    return abs(res);
}


inline int costh(int n, int m, int k)
{
    int res = S(1, m) * (n-2*k+2) + m*m * (S(k-1, n-1) - S(1, k-2));
    //cout << S(1, m) * (n-2*k+2) << ' ' <<  m*m * (S(k-1, n-1) - S(1, k-2)) << endl;
    return abs(res);
}


inline void solve()
{
    int n, m;
    cin >> n >> m;

    int lv = 0, rv = m;
    while (rv - lv > 1)
    {
        int mv = (lv + rv) >> 1;
        if (costv(n, m, mv) > costv(n, m, mv+1))
            lv = mv;
        else
            rv = mv;
    }
    int ansv = costv(n, m, rv);

    int lh = 0, rh = n;
    while (rh - lh > 1)
    {
        int mh = (lh + rh) >> 1;
        if (costh(n, m, mh) > costh(n, m, mh+1))
            lh = mh;
        else
            rh = mh;
    }
    int ansh = costh(n, m, rh);

    //cout << ansv << ' ' << ansh << '\n';
    if (ansv <= ansh)
        cout << "V " << rv;
    else
        cout << "H " << rh;
    cout << '\n';
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    /*cout << costv(1, 3, 3) << endl;
    cout << costv(4, 7, 5) << endl;
    cout << costv(1, 10, 8) << endl;*/
    //cout << costh(3, 3, 0) << endl;
    //cout << costh(3, 3, 1) << endl;
    //cout << costh(3, 3, 2) << endl;
    //cout << costh(3, 3, 3) << endl;
    /*cout << costv(3, 5, 4) << endl;*/

    int T;
    cin >> T;
    while (T--)
        solve();

    return 0;
}
