#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <utility>
#include <algorithm>
#define int long long
#define pb push_back
#define eb emplace_back
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pass (void)0
using namespace std;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using vb = vector<bool>;
using t3i = tuple<int, int, int>;


template <typename T>
inline void rmax(int &a, int b, T &c, T d)
{
    if (b > a)
    {
        a = b;
        c = d;
    }
}


inline int binpow(int x, int n)
{
    int res = 1;
    while (n)
    {
        if (n & 1)
            res *= x;
        x *= x;
        n >>= 1;
    }
    return res;
}


inline int digs(int n)
{
    if (n == 1)
        return 0;

    int res = 0;
    while (n)
    {
        res++;
        n /= 10;
    }
    return res;
}


inline int fdig(int n)
{
    while (n >= 10)
        n /= 10;
    return n;
}


map<char, int> cti = {
    {'A', 0},
    {'G', 1},
    {'C', 2},
    {'T', 3},
};

map<int, char> itc = {
    {0, 'A'},
    {1, 'G'},
    {2, 'C'},
    {3, 'T'},
};


inline void find_min(const vector<pii> &a)
{
    int n = a.size();

    int ans = -1; // Max shortening
    int opt1 = 2, opt2 = 0, opt3 = 0;

    int pos = 0;
    for (int i = 0; i < n; i++)
    {
        int nc = a[i].first, c = a[i].second;

        int res = 0;
        if (nc == 1)
        {
            if (i > 0 && i < n && a[i-1].second == a[i+1].second)
            {
                int n1 = a[i-1].first, n2 = a[i+1].first;
                res = 2 + digs(n1) + digs(n2) - digs(n1 + n2);
            }
            else
                res = 1;
        }
        else
        {
            res = digs(nc) - digs(nc - 1);
        }

        //cout << res << ' ' << ans << '\n';
        if (res > ans)
        {
            ans = res;
            opt1 = 2, opt2 = pos+1;
        }

        pos += nc;
    }

    cout << opt1 << ' ' << opt2 << '\n';
}


inline void find_max(const vector<pii> &a)
{
    int n = a.size();

    int ans = -1;
    int opt2 = 0, opt3 = 0;

    int pos = 0;
    for (int i = 0; i < n; i++)
    {
        int nc = a[i].first, c = a[i].second;

        int res = 0;
        int copt2, copt3;
        if (nc == 1)
        {
            res = 1;
            copt2 = pos, copt3 = c;
        }
        else if (nc == 2)
        {
            res = 1;
            copt2 = pos+1, copt3 = (c+1)%4;
        }
        else if (nc == 3)
        {
            res = 2;
            copt2 = pos+1, copt3 = (c+1)%4;
        }
        else if (nc <= 9)
        {
            res = 3;
            copt2 = pos + nc/2, copt3 = (c+1)%4;
        }
        else
        {
            int dg = digs(nc);
            int fd = fdig(nc);
            int tp = binpow(10, digs(nc)-1);
            copt3 = (c+1)%4;

            if (fd >= 2)
            {
                copt2 = pos + tp;
                res = 2 + dg;
            }
            else if (nc == tp)
            {
                copt2 = pos + nc/2;
                res = dg - 2;
            }
            else
            {
                int t1 = digs(tp) + digs(nc - tp);
                int t2 = 2*dg - 2;

                if (t1 > t2)
                {
                    copt2 = pos + tp;
                    res = t1 - dg;
                }
                else
                {
                    copt2 = pos + nc/2;
                    res = t2 - dg;
                }
            }
        }


        //cout << res << ' ' << ans << '\n';
        if (res > ans)
        {
            ans = res;
            opt2 = copt2, opt3 = copt3;
        }

        pos += nc;
    }

    cout << "1 " << opt2 << ' ' << itc[opt3] << '\n';
}


inline void print(t3i x)
{
    int a = get<0>(x), b = get<1>(x);
    char c = itc[get<2>(x)];
    if (a == 2)
        cout << a << ' ' << b << '\n';
    else
        cout << a << ' ' << b << ' ' << c << '\n';
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    string s;
    cin >> s;

    int n = s.size();

    vi chp = {-1};
    for (int i = 0; i < n; i++)
        if (s[i] >= 'A')
            chp.pb(i);

    vector<pii> a;
    for (int i = 1; i < chp.size(); i++)
    {
        int x = cti[s[chp[i]]];
        int d = chp[i] - chp[i-1];
        if (d == 1)
            a.eb(1, x);
        else
            a.eb(stoll(s.substr(chp[i-1]+1, d-1)), x);
    }

    /*for (auto &P : a)
        cout << P.first << ' ' << P.second << '\n';*/

    find_min(a);
    find_max(a);

    return 0;
}
/* 5AC5A2C */



