#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pb push_back
#define eb emplace_back
#define int long long
using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using pii = pair<int, int>;


inline void digs(int n, vi &a)
{
    a.clear();
    while (n)
    {
        a.pb(n % 10);
        n /= 10;
    }
    reverse(all(a));
}


inline void solve1(int n)
{
    vi dg;
    digs(n, dg);

    int d0 = dg[0];
    int k = dg.size();

    bool ok = true;
    for (int i = 1; i < k && ok; i++)
    {
        if (dg[i] < d0)
            break;
        if (dg[i] > d0)
            ok = false;
    }

    int fd = d0;
    if (!ok)
        fd++;

    for (int i = 0; i < k; i++)
        cout << fd;
}


inline void solve2(int n)
{
    ;
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    if (k == 0)
        solve1(n);
    else
        solve2(n);

    return 0;
}



