#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pb push_back
#define eb emplace_back
#define int long long
#define pass (void)0;
using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using pii = pair<int, int>;


constexpr int mod{1000000007};


inline int add(int a, int b)
{
    return (a + b) % mod;
}

inline int sub(int a, int b)
{
    return ((a - b) % mod + mod) % mod;
}

inline int mul(int a, int b)
{
    return (a * b) % mod;
}


constexpr int N3{200};
int fact[N3+1];

inline void fact_calc(int n)
{
    fact[0] = 1;
    for (int i = 1; i <= n; i++)
        fact[i] = fact[i-1] * i;
}


int a[2][2];
int nz[2][2];

constexpr int N{200};
int dp[2*N+1][N+1][N+1];

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    {
        string sa, sb, sc;
        cin >> sa >> sb >> sc;
        n = sa.size();

        for (int pos = 0; pos < n; pos++)
        {
            int d1 = sa[pos] - '0';
            int d2 = sb[pos] - '0';
            int d3 = sc[pos] - '0';

            int i = 0, j = 0; // i - need, j - give
            if (d3 == d1+d2)
                i = j = 0;
            else if (d3 == d1+d2+1)
                i = 1;
            else if (d3 == d1+d2-10)
                j = 1;
            else if (d3 == d1+d2-10+1)
                i = j = 1;
            else
            {
                cout << "0";
                return 0;
            }

            a[i][j]++;
            if (d1 == 0 || d2 == 0 || d3 == 0)
                nz[i][j]++;
        }
    }

    fact_calc(n);

    int a00{a[0][0]}, a01{a[0][1]}, a10{a[1][0]}, a11{a[1][1]};
    //cout << a00 << ' ' << a01 << '\n' << a10 << ' ' << a11 << '\n';

    if (a01 != a10)
    {
        cout << "0";
        return 0;
    }
    int k = a01;

    dp[0][0][0] = 1;
    for (int s = 0; s <= 2*k; s++)
    {
        for (int x0 = 0; x0 <= a00; x0++)
        {
            for (int x1 = 0; x1 <= a11; x1++)
            {
                if (!s && !x0 && !x1)
                    continue;

                if (s % 2 == 0 && x0 > 0)
                    dp[s][x0][x1] += dp[s][x0-1][x1];
                if (s % 2 == 1 && x1 > 0)
                    dp[s][x0][x1] += dp[s][x0][x1-1];
                if (s > 0)
                    dp[s][x0][x1] += dp[s-1][x0][x1];
            }
        }
    }

    /*for (int s = 0; s <= 2*k; s++)
    {
        for (int x0 = 0; x0 <= a00; x0++)
        {
            for (int x1 = 0; x1 <= a11; x1++)
                cout << dp[s][x0][x1] << ' ';
            cout << '\n';
        }
        cout << "---\n";
    }*/

    int ans = dp[2*k][a00][a11];
    ans = mul(ans, fact[k]);
    ans = mul(ans, fact[k]);
    ans = mul(ans, fact[a00]);
    ans = mul(ans, fact[a11]);
    cout << ans;

    return 0;
}
/*
19243
19132
38375
*/
