#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

int get_len(string &s) {
    int cnt = 1;
    int ans = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (s[i] == s[i - 1]) {
            cnt += 1;
        } else {
            ans += 1;
            if (cnt != 1) {
                ans += to_string(cnt).size();
            }
            cnt = 1;
        }
    }
    if (cnt != 1) {
        ans += to_string(cnt).size();
    }
    ans += 1;
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    string s;
    cin >> s;
    string t;
    string cnt = "";
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] >= '0' && s[i] <= '9') {
            cnt += s[i];
        } else {
            if (cnt.size() == 0) {
                t += s[i];
            } else {
                for (int j = 0; j < stoi(cnt); ++j) {
                    t += s[i];
                }
            }
            cnt = "";
        }
    }
    vector<char> all_chars = {'A', 'G', 'C', 'T'};
    int ans_mx = 0;
    int posmx = 0;
    int opmx = 0;
    int ans_mn = 1000000000;
    int posmn = 0;
    int opmn = 0;
    char ans_charmx;
    char ans_charmn;
    for (int i = 0; i < t.size() + 1; ++i) {
        string t1;
        for (auto j : all_chars) {
            if (i == t.size()){
                t1 = t + j;
            }else{
                t1 = t.substr(0, i) + j + t.substr(i, t.size() - i);
            }
            int ln = get_len(t1);
            if (ln > ans_mx) {
                ans_mx = ln;
                posmx = i;
                opmx = 1;
                ans_charmx = j;
            }
            if (ln < ans_mn) {
                ans_mn = ln;
                posmn = i;
                opmn = 1;
                ans_charmn = j;
            }
        }
    }
    for (int i = 0; i < t.size(); ++i) {
        string t1 = t;
        for (auto j : all_chars) {
            if (j != t[i]) {
                t1[i] = j;
                int ln = get_len(t1);
                if (ln > ans_mx) {
                    ans_mx = ln;
                    posmx = i + 1;
                    opmx = 3;
                    ans_charmx = j;
                }
                if (ln < ans_mn) {
                    ans_mn = ln;
                    posmn = i + 1;
                    opmn = 3;
                    ans_charmn = j;
                }
            }
        }
    }
    for (int i = 0; i < t.size() + 1; ++i) {
        string t1;
        if (i == t.size()){
            t1 = t.substr(0, t.size() - 1);
        }else{
            t1 = t.substr(0, i) + t.substr(i + 1, t.size() - i - 1);
        }
        int ln = get_len(t1);
        if (ln > ans_mx) {
            ans_mx = ln;
            posmx = i + 1;
            opmx = 2;
        }
        if (ln < ans_mn) {
            ans_mn = ln;
            posmn = i + 1;
            opmn = 2;
        }
    }
    cout << opmn << " " << posmn << " ";
    if (opmn != 2){
        cout << ans_charmn;
    }
    cout << "\n";
    cout << opmx << " " << posmx << " ";
    if (opmx != 2){
        cout << ans_charmx;
    }
}