#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

vector<int> s;
vector<vector<int>> a;
vector<int> an;
vector<bool> use;

bool f(int v, int pr = -1, int kl = 1) {
    if (kl == a.size()) {
        return 1;
    }
    for (int i = 0; i < use.size(); ++i) {
        if (use[i]) { continue; }
        if (pr == -1 || pr == v + a[i][0]) {
            use[i] = 1;
            an.push_back(i + 1);
            if (f(s[i] - a[i].back(), v + a[i][0], kl + 1)) {
                return 1;
            }
            an.pop_back(); use[i] = 0;
        }
    }
    return 0;
}

int main()
{
    int n;
    cin >> n;
    a.resize(n);
    s.resize(n);
    use.resize(n, 0);
    int pr = -1;
    for (int i = 0; i < n; ++i) {
        int m; cin >> m >> s[i]; a[i].resize(m);
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
        if (m > 1) {
            for (int j = 1; j < m; ++j) {
                int x = a[i][j] - a[i][j - 1];
                if (pr != -1 && pr != x) {
                    cout << "No"; return 0;
                }
                pr = x;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        use[i] = 1; an.push_back(i + 1);
        if (f(s[i] - a[i].back(), pr)) {
            cout << "Yes" << "\n";
            for (int j = 0; j < n; ++j) {
                cout << an[j] << " ";
            }
            return 0;
        }
        use[i] = 0; an.pop_back();
    }
    cout << "No";
}
