#include <iostream>
#include <vector>
#include <algorithm>
#include <stdlib.h>
using namespace std;
#define int long long

long long f(int k, int a, int x){
    return max(k - a, (long long)0) * x;
}

signed main() {
    int k, a, x, b, y;
    cin >> k >> a >> x >> b >> y;
    if (a == 0 && x == 0) {
        return (long long) max(k - b, (long long) 0) * y;
    } else if (a == 0 && b == 0) {
        return (long long) (k * y + k * x);
    } else if (a == b) {
        return max(k - a, (long long) 0) * max(x, y) + max(k - a - b, (long long) 0) * min(x, y);
    } else if (x == y) {
        return max(k - min(a, b), (long long) 0) * x + max(k - max(a, b), (long long) 0) * y;
    } else {
        long long first_way = f(k, a, x) + f(k - a, b, y);
        long long second_way = f(k, b, y) + f(k - b, a, x);
        return max(first_way, second_way);
    }
}

/*
int main2(int k, int a, int x, int b, int y) {
    long long first_way = max(k - a , (long long) 0) * x + max(k - a - b, (long long) 0) * y;
    long long second_way = max(k - b, (long long) 0) * y + max(k - a - b, (long long) 0) * x;
    return max(first_way, second_way);
}

signed main() {
    for (int i = 0; i < 10000; ++i){
        int k, a, x, b, y;
        //cin >> k >> a >> x >> b >> y;
        k = rand() % 100000;
        a = 0;
        x = 0;
        b = rand() % 100000;
        y = rand() % 100000;
        if (main1(k, a, x, b, y) != main2(k, a, x, b, y)){
            cout << k << ' ' << a << ' ' << x << ' ' << b << ' ' << y << endl;
        }
    }
}*/
