#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int len_n(int x){
    int cnt = 0;
    while (x > 0){
        cnt++;
        x -= x % 10;
        x /= 10;
    }
    return cnt;
}

int len_s(vector<int> &len){
    int cnt = 0;
    for (int i = 0; i < len.size(); ++i) {
        if (len[i] > 1) {
            cnt++;
            cnt += len_n(len[i]);
        }
        else if (len[i] == 1){
            cnt++;
        }
    }
    return cnt;
}

int make_blocks(string t){
    vector<char> sym;
    vector<int> lens;
    sym.push_back(t[0]);
    lens.push_back(1);
    for (int i = 1; i < t.size(); ++i) {
        if (t[i] == sym[sym.size() - 1]){
            lens[lens.size() - 1]++;
        }
        else{
            sym.push_back(t[i]);
            lens.push_back(1);
        }
    }
    return len_s(lens);
}

int main(){
    string s;
    getline(cin, s);
    vector<char> sym;
    vector<int> len;
    int x = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == 'A' || s[i] == 'T' || s[i] == 'G' || s[i] == 'C'){
            if (x == 0) {
                len.push_back(1);
                sym.push_back(s[i]);
            }
            else {
                len.push_back(x);
                sym.push_back(s[i]);
                x = 0;
            }
        }
        else{
            x *= 10;
            x += (s[i] - '0');
        }
    }
    string t;
    for (int i = 0; i < sym.size(); ++i) {
        for (int j = 0; j < len[i]; ++j) {
            t += sym[i];
        }
    }
/*    cout << t << endl;*/
    pair<int, pair<int, int>>  ans_min = {s.size(), {-1, -1}};
    pair<int, pair<int, int>>  ans_max = {s.size(), {-1, -1}};
    for (int i = 0; i < t.size(); ++i) {
        if (i != 0){
            char save = t[i];
            t[i] = t[i - 1];
            ans_min = min(ans_min, {make_blocks(t), {0, i}});
            ans_max = max(ans_max, {make_blocks(t), {0, i}});
            t[i] = save;
        }
        if (i != 0 && i != t.size() - 1 && t[i] == t[i + 1] && t[i] == t[i - 1]){
            if (t[i] == 'A'){
                t[i] = 'G';
                ans_min = min(ans_min, {make_blocks(t), {1, i}});
                ans_max = max(ans_max, {make_blocks(t), {1, i}});
                t[i] = 'A';
            }
            else {
                char save = t[i];
                t[i] = 'A';
                ans_min = min(ans_min, {make_blocks(t), {1, i}});
                ans_max = max(ans_max, {make_blocks(t), {1, i}});
                t[i] = save;
            }
        }
        if (true){
            char save = t[i];
            t.erase(i, 1);
            ans_min = min(ans_min, {make_blocks(t), {2, i}});
            ans_max = max(ans_max, {make_blocks(t), {2, i}});
            if (save == 'A') {
                t.insert(i, "A");
            }
            else if (save == 'G'){
                t.insert(i, "G");
            }
            else if (save == 'T'){
                t.insert(i, "T");
            }
            else{
                t.insert(i, "C");
            }
        }
        if (true){
            if (t[i] == 'A') {
                t.insert(i + 1, "A");
            }
            else if (t[i] == 'G'){
                t.insert(i + 1, "G");
            }
            else if (t[i] == 'T'){
                t.insert(i + 1, "T");
            }
            else{
                t.insert(i + 1, "C");
            }
            ans_min = min(ans_min, {make_blocks(t), {3, i}});
            ans_max = max(ans_max, {make_blocks(t), {3, i}});
            t.erase(i + 1, 1);
        }
    }
    if (ans_min.second.first == 0){
        cout << 3 << ' ' << ans_min.second.second + 1 << ' ' << t[ans_min.second.second - 1] << endl;
    }
    else if (ans_min.second.first == 1){
        if (t[ans_min.second.second] == 'A') {
            cout << 3 << ' ' << ans_min.second.second + 1 << ' ' << "G" << endl;
        }
        else{
            cout << 3 << ' ' << ans_min.second.second + 1 << ' ' << "A" << endl;
        }
    }
    else if (ans_min.second.first == 2){
        cout << 2 << ' ' << ans_min.second.second + 1 << endl;
    }
    else if (ans_min.second.first == 3){
        cout << 2 << ' ' << ans_min.second.second + 1 << ' ' << t[ans_min.second.second] <<  endl;
    }

    if (ans_max.second.first == 0){
        cout << 3 << ' ' << ans_max.second.second + 1 << ' ' << t[ans_max.second.second - 1] << endl;
    }
    else if (ans_max.second.first == 1){
        if (t[ans_max.second.second] == 'A') {
            cout << 3 << ' ' << ans_max.second.second + 1 << ' ' << "G" << endl;
        }
        else{
            cout << 3 << ' ' << ans_max.second.second + 1 << ' ' << "A" << endl;
        }
    }
    else if (ans_max.second.first == 2){
        cout << 2 << ' ' << ans_max.second.second + 1 << endl;
    }
    else if (ans_max.second.first == 3){
        cout << 2 << ' ' << ans_max.second.second + 1 << ' ' << t[ans_max.second.second] <<  endl;
    }
    /*cout << ans_min.first << ' ' << ans_min.second.first << ' ' << ans_min.second.second << endl;
    cout << ans_max.first << ' ' << ans_max.second.first << ' ' << ans_max.second.second << endl;
*/

}