#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;
#define int long long
const long long Prime = 1e9 + 7;

int n;
vector<bool> m;
vector<bool> p;

vector<int> fac;
vector<int> unfac;

long long bin(long long x, long long n){
    if (n == 0){
        return 1;
    }
    if (n % 2 == 0){
        long long res = bin(x, n / 2);
        return ((long long)res * res + Prime) % Prime;
    }
    else{
        return ((long long)bin(x, n - 1) * x + Prime) % Prime;
    }
}

long long C(long long n, long long k) {
    return (((fac[n] * unfac[n - k]) % Prime) * unfac[k]) % Prime;
}


signed main(){
    string a1, b1, c1;
    getline(cin, a1);
    getline(cin, b1);
    getline(cin, c1);
    n = a1.size();
    fac.resize(4 * n);
    unfac.resize(4 * n);
    fac[0] = 1;
    for (int i = 1; i < 4 * n; ++i) {
        fac[i] = fac[i - 1] * i;
        fac[i] %= Prime;
    }
    unfac[4 * n - 1] = bin(fac[4 * n - 1], Prime - 2);
    for (int i = 4 * n - 2; i >= 0; --i) {
        unfac[i] = bin(fac[i], Prime - 2);
        unfac[i] %= Prime;
    }
//    for (int i = 0; i < 4 * n; ++i) {
//        cout << i << ' ' << fac[i] << ' ' << unfac[i] << endl;
//    }
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = a1[i] - '0';
        b[i] = b1[i] - '0';
        c[i] = c1[i] - '0';
    }
    vector<int> ab(n);
    for (int i = 0; i < n; ++i) {
        ab[i] = a[i] + b[i];
    }

    p.assign(n, false); // plus есть перенос
    m.assign(n, false); // minus нужен перенос
    for (int i = 0; i < n; ++i) {
        if ((ab[i] + 1) % 10 == c[i] % 10){
            m[i] = true;
        }

    }

    for (int i = 0; i < n; ++i) {
        if (ab[i] + m[i] >= 10){
            p[i] = true;
        }
        if (ab[i] % 10 != c[i] && (ab[i] + 1) % 10 != c[i]){
            cout << 0 << endl;
            return 0;
        }
    }
    vector<bool> first_zero(n, false);
    for (int i = 0; i < n; ++i) {
        if (a[i] == 0 || b[i] == 0 || c[i] == 0){
            first_zero[i] = true;
        }
    }
    int cnt_1 = 0;
    int cnt_2 = 0;
    int cnt_3 = 0;
    int cnt_4 = 0;
    for (int i = 0; i < n; ++i) {
        if (m[i] && p[i]){
            cnt_4++;
        }
        else if (m[i] && !p[i]){
            cnt_3++;
        }
        else if (!m[i] && p[i]){
            cnt_2++;
        }
        else if (!m[i] && !p[i]){
            cnt_1++;
        }
    }
    if (cnt_2 != cnt_3){
        cout << 0 << endl;
        return 0;
    }
    else{
        long long ans = 1;
        ans *= fac[cnt_1];
        ans %= Prime;
        ans *= fac[cnt_2];
        ans %= Prime;
        ans *= fac[cnt_3];
        ans %= Prime;
        ans *= fac[cnt_4];
        ans %= Prime;
        long long x = C(cnt_1 + cnt_2, cnt_2);
        ans *= x;
        ans %= Prime;
        x = C(max(cnt_4 + cnt_2 - 1, (long long)0), max(cnt_2 - 1, (long long)0));
        ans *= x;
        ans %= Prime;
        cout << ans << endl;
    }
}
/*
11322
22199
43511
 */