#include <algorithm>
#include <iostream>
#include <vector>
#define int long long
using namespace std;

int n, m;

int check(int x) {
	return abs(x - (n * m * (n * m + 1) / 2 - x));
}

int checkH(int M) {
	if (0 < M && M < n)
		return check(M * m * (M * m + 1) / 2);
	return 1e18;
}

int checkV(int M) {
	if (0 < M && M < m)
		return check(M * (M + 1) / 2 * n + (n - 1) * n / 2 * m * M);
	return 1e18;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		int Lh = 0, Rh = n - 1;
		while (Lh + 1 < Rh) {
			int M = Lh + (Rh - Lh + 1) / 2;
			if (checkH(M) <= checkH(M + 1)) {
				Rh = M;
			} else {
				Lh = M;
			}
		}
		int Lv = 0, Rv = m - 1;
		while (Lv + 1 < Rv) {
			int M = Lv + (Rv - Lv + 1) / 2;
			if (checkV(M) <= checkV(M + 1)) {
				Rv = M;
			} else {
				Lv = M;
			}
		}
		if (checkH(Rh) < checkV(Rv)) {
			cout << "H" << " " << Rh + 1 << endl;
		} else {
			cout << "V" << " " << Rv + 1 << endl;
		}
	}
	return 0;
}
