#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#define endl '\n'
#define int long long
using namespace std;

int len(int x) {
	if (x == 0) {
		return 0;
	}
	if (x == 1) {
		return 1;
	}
	return to_string(x).size() + 1;
}

int solveMax(int x) {
	int ans = 0;
	if (2 <= x && len(ans) + len(x - ans) <= len(2) + len(x - 2)) {
		ans = 2;
	}
	for (int i = 1; i <= x; i *= 10) {
		if (len(ans) + len(x - ans) <= len(i) + len(x - i)) {
			ans = i;
		}
	}
	return ans;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
	string s;
	cin >> s;
	int n = s.size();
	vector<pair<int, char>> v;
	for (int i = 0; i < n; ++i) {
		int x = 0;
		for (; '0' <= s[i] && s[i] <= '9'; ++i) {
			x = x * 10 + (s[i] - '0');
		}
		if (x == 0) {
			x = 1;
		}
		v.emplace_back(x, s[i]);
	}
	int m = v.size();
	int ansMin = 0, ansMinSide = 1, ansMinv = 0;
	for (int i = 0; i < m; ++i) {
		int x = v[i].first;
		char c = v[i].second;
		int ansL = 0, ansR = 0;
		if (0 <= i - 1) {
			if (i + 1 < m && x == 1 && v[i - 1].second == v[i + 1].second) {
				ansL = len(v[i - 1].first + v[i + 1].first) - len(v[i - 1].first) - len(x) - len(v[i + 1].first);
			} else {
				if (v[i - 1].second == c) {
					ansL = len(v[i - 1].first + 1) + len(x - 1) - len(v[i - 1].first) - len(x);
				} else {
					ansL = len(x - 1) - len(x);
				}
		    }
		} else {
			ansL = len(x - 1) - len(x);
		}
		if (i + 1 < m) {
			if (v[i + 1].second == c) {
				ansR = len(v[i + 1].first + 1) + len(x - 1) - len(v[i + 1].first) - len(x);
			} else {
				ansR = len(x - 1) - len(x);
			}
		} else {
			ansR = len(x - 1) - len(x);
		}
		if (ansMinv >= ansL) {
			ansMinv = ansL;
			ansMin = i;
			ansMinSide = 0;
		}
		if (ansMinv >= ansR) {
			ansMinv = ansR;
			ansMin = i;
			ansMinSide = 1;
		}
	}
	int p = 0;
	for (int i = 0; i < ansMin; ++i) {
		p += v[i].first;
	}
	if (ansMinSide == 1) {
		p += v[ansMin].first - 1;
	}
	cout << 2 << " " << p + 1 << endl;
	int ansMax = 0, ansMaxv = 0;
	for (int i = 0; i < m; ++i) {
		int x = v[i].first;
		char c = v[i].second;
		if (ansMaxv <= len(solveMax(x)) + 1 + len(x - solveMax(x)) - len(x)) {
			ansMaxv = len(solveMax(x)) + 1 + len(x - solveMax(x)) - len(x);
			ansMax = i;
		}
	}
	string cs = "AGCT";
	p = 0;
	for (int i = 0; i < ansMax; ++i) {
		p += v[i].first;
	}
	p += solveMax(v[ansMax].first);
	for (const char &c : cs) {
		if (c == v[ansMax].second) {
			continue;
		}
		if (0 <= ansMax - 1 && c == v[ansMax - 1].second) {
			continue;
		}
		if (ansMax + 1 < m && c == v[ansMax + 1].second) {
			continue;
		}
		cout << 1 << " " << p << " " << c;
		break;
	}
	return 0;
}
