#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#define endl '\n'
#define int long long
using namespace std;

pair<char, char> etype(char a, char b, char c) {
	if (a + b == c) {
		return make_pair(0, 0);
	}
	if (a + b + 1 == c) {
		return make_pair(1, 0);
	}
	if (a + b == c + 10) {
		return make_pair(0, 1);
	}
	if (a + b + 1 == c + 10) {
		return make_pair(1, 1);
	}
	return make_pair(-1, -1);
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
	int n, p = 1e9 + 7;
	string a, b, c;
	cin >> a >> b >> c;
	n = a.size();
	vector<vector<int>> v(2, vector<int>(2, 0));
	for (int i = 0; i < n; ++i) {
		pair<char, char> e = etype(a[i] - '0', b[i] - '0', c[i] - '0');
		if (e == pair<char, char>(-1, -1)) {
			cout << 0;
			return 0;
		}
		++v[e.first][e.second];
	}
	if (v[0][1] != v[1][0]) {
		cout << 0;
		return 0;
	}
	int m = max(v[0][0], v[1][1]);
	vector<int> f(m + 1, 1);
	for (int i = 2; i <= m; ++i) {
		f[i] = f[i - 1] * i % p;
	}
	vector<vector<int>> dp(v[0][1] + 2, vector<int>(m + 1, 0));
	dp[0][0] = 1;
	for (int i = 1; i <= v[0][1] + 1; ++i) {
		for (int j = 0; j <= m; ++j) {
			for (int k = 0; k <= j; ++k) {
				dp[i][j] += (dp[i - 1][j - k] * f[k]) % p;
				dp[i][j] %= p;
			}
		}
	}
	cout << dp[v[0][1] + 1][v[0][0]] * dp[v[0][1]][v[1][1]] % p;
	return 0;
}
