#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 mt(seed);

const int mod = 1000000007;

int32_t main()
{
    #ifdef LOCAL
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    #endif
    vector <string> s(3);
    cin >> s[0] >> s[1] >> s[2];
    int n = s[0].size();
    vector <vector <short> > a(n, vector <short>(3));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < 3; j++)
            a[i][j] = s[j][i] - '0';
    if (n <= 18) {
        vector <vector <int> > dp((1 << n), vector <int>(2));
        dp[0][0] = 1;
        for (int mask = 1; mask < (1 << n); mask++) {
            for (int i = 0; i < n; i++) {
                if (!(mask & (1 << i))) continue;
                int cnt = 0;
                for (int j = 0; j < n; j++)
                    if (mask & (1 << j)) cnt++;
                if (cnt == 1 && (!a[i][0] || !a[i][1] || !a[i][2])) continue;
                if (a[i][0] + a[i][1] - 10 == a[i][2]) {
                    dp[mask][0] = (dp[mask][0] + dp[mask - (1 << i)][1]) % mod;
                } else if (a[i][0] + a[i][1] == a[i][2]) {
                    dp[mask][0] = (dp[mask][0] + dp[mask - (1 << i)][0]) % mod;
                }
                if (a[i][0] + a[i][1] - 9 == a[i][2]) {
                    dp[mask][1] = (dp[mask][1] + dp[mask - (1 << i)][1]) % mod;
                } else if (a[i][0] + a[i][1] + 1 == a[i][2]) {
                    dp[mask][1] = (dp[mask][1] + dp[mask - (1 << i)][0]) % mod;
                }
            }
        }
        cout << dp[(1 << n) - 1][0];
        return 0;
    }
    int cnt1 = 0, cnt2 = 0, cnt3 = 0, cnt4 = 0;
    int bad1 = 0, bad2 = 0, bad3 = 0, bad4 = 0;
    for (int i = 0; i < n; i++) {
        if (a[i][0] + a[i][1] == a[i][2]) {
            if (!a[i][0] || !a[i][1] || !a[i][2])
                bad1++; cnt1++;
        }
        if (a[i][0] + a[i][1] - 10 == a[i][2]) {
            if (!a[i][0] || !a[i][1] || !a[i][2])
                bad2++; cnt2++;
        }
        if (a[i][0] + a[i][1] + 1 == a[i][2]) {
            if (!a[i][0] || !a[i][1] || !a[i][2])
                bad3++; cnt3++;
        }
        if (a[i][0] + a[i][1] - 9 == a[i][2]) {
            if (!a[i][0] || !a[i][1] || !a[i][2])
                bad4++; cnt4++;
        }
    }
    if (cnt1 + cnt2 + cnt3 + cnt4 != n) {cout << 0; return 0;}
    vector <vector <vector <pair <int, int> > > > dp(cnt2 + 1, vector <vector <pair <int, int> > >(cnt3 + 1, vector <pair <int, int> >(cnt4 + 1)));
    for (int i2 = 0; i2 <= cnt2; i2++) {
        for (int i3 = 0; i3 <= cnt3; i3++) {
            for (int i4 = 0; i4 <= cnt4; i4++) {
                if (!i2 && !i3 && !i4) {
                    dp[0][0][0].first = 1; continue;
                }
                if (i2) {
                    if (i2 == cnt2 && i3 == cnt3 && i4 == cnt4)
                        dp[i2][i3][i4].second = (dp[i2][i3][i4].second + dp[i2 - 1][i3][i4].first * (i2 - bad2)) % mod;
                    else
                        dp[i2][i3][i4].second = (dp[i2][i3][i4].second + dp[i2 - 1][i3][i4].first * i2) % mod;
                }
                if (i3) {
                    if (i2 == cnt2 && i3 == cnt3 && i4 == cnt4)
                        dp[i2][i3][i4].first = (dp[i2][i3][i4].first + dp[i2][i3 - 1][i4].second * (i3 - bad3)) % mod;
                    else
                        dp[i2][i3][i4].first = (dp[i2][i3][i4].first + dp[i2][i3 - 1][i4].second * i3) % mod;
                }
                if (i4) {
                    if (i2 == cnt2 && i3 == cnt3 && i4 == cnt4)
                        dp[i2][i3][i4].second = (dp[i2][i3][i4].second + dp[i2][i3][i4 - 1].second * (i4 - bad4)) % mod;
                    else
                        dp[i2][i3][i4].second = (dp[i2][i3][i4].second + dp[i2][i3][i4 - 1].second * i4) % mod;
                }
            }
        }
    }
    int ans = dp[cnt2][cnt3][cnt4].first;
    for (int i = 1; i <= cnt1; i++)
        ans = (ans * (cnt3 + i)) % mod;
    cout << ans;
    return 0;
}
