def best_cut(n, m):
    answer = 'H 1'
    total = n * m
    total_sum = total * (total + 1) // 2
    #horizontal
    best_dif = 10**100
    for i in range(1, n):
        x = i * m
        sum1 = x * (x + 1) // 2
        sum2 = total_sum - sum1
        dif = abs(sum1 - sum2)
        if dif < best_dif:
            best_dif = dif
            answer = 'H ' + str(i + 1)

    #vertical
    flag = True
    for k in range(1, m):
        x = n + m * n * (n - 1) // 2
        sum1 = k * x + n * k * (k - 1) // 2
        sum2 = total_sum - sum1
        dif = abs(sum1 - sum2)
        if (dif <= best_dif and flag) or dif < best_dif:
            flag = False
            best_dif = dif
            answer = 'V ' + str(k + 1)
    return answer




t = int(input())

res = []

for i in range(t):
    n, m = map(int, input().split())
    res.append(best_cut(n, m))

for i in res:
    print(i)
