def decode(dnk):
    res = ''
    num = ''
    while dnk[0] in 'AGCT':
        res += dnk[0]
        dnk = dnk[1:]
    for i in dnk:
        if i in '0987654321':
            num += i
        else:
            if num:
                res += i * int(num)
            else:
                res += i
            num = ''
    return res

def recode(dnk):
    x = []
    y = []
    num = ''
    while dnk[0] in 'AGCT':
        x.append(dnk[0])
        y.append(1)
        dnk = dnk[1:]
    for i in dnk:
        if i in '0987654321':
            num += i
        else:
            if num:
                x.append(i)
                y.append(int(num))
            else:
                x.append(i)
                y.append(1)
            num = ''
    return x, y


def code(dnk):
    res = ''
    while dnk:
        num = 0
        symbol = dnk[0]
        while dnk[0] == symbol:
            num += 1
            dnk = dnk[1:]
            if dnk == '':
                break
        if num > 1:
            res += str(num) + symbol
        else:
            res += symbol
    return res


dnk = decode(input()).upper()
min_len = len(dnk) + 10**10

for i in range(1, len(dnk) - 1):
    if dnk[i] != dnk[i - 1] and dnk[i] != dnk[i + 1] and dnk[i - 1] == dnk[i + 1]:
        copy = dnk
        copy = copy[:i] + copy[i + 1:]
        if len(copy) < min_len:
            min_len = len(copy)
            res = '2 ' + str(i + 1)


letters, digits = recode(code(dnk))
index = digits.index(max(digits))
letter = letters[index]
s = sum(digits[:index])
if letter != 'A':
    use = 'A'
else:
    use = 'C'




print(res)
print(1, s + digits[index] // 2, use)







        
