#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>


using namespace std;


#define int long long


struct sumb {
	char c;
	int x;

	sumb() {}
	sumb(int x, char c) : c(c), x(x) {}
};


int n;
vector<sumb> a;
string s;


int get_number(int &i) {
	int res = 0;
	while (i < s.size() && '0' <= s[i] && s[i] <= '9') {
		res = res * 10 + (s[i] - '0');
		++i;
	}
	return max(res, (int)(1));
}


void get_a() {
	for (int i = 0; i < s.size();) {
		int rep = get_number(i);
		a.emplace_back(rep, s[i++]);
	}
}


char not_ch(char c) {
	if (c == 'A') {
		return 'G';
	}
	else {
		return 'A';
	}
}


pair<long long, int> log10(int x) {
	long long res = 1;
	int pow = 0;
	while (res * 10 <= x) {
		res *= 10;
		pow += 1;
	}
	return { res, pow };
}


int get_numb_len(int x) {
	return x == 1 ? 0 : to_string(x).size();
}


void print_max_res() {
	string res = string("1 0 ") + not_ch(a[0].c);
	int rln = 1;
	long long sm = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i].x > 1) {
			string rep = "";
			auto p = log10(a[i].x);
			int ln = 0;
			if (p.second == 0) {
				if (a[i].x == 2) {
					rep = string("1 ") + to_string(sm + 1) + " " + not_ch(a[i].c);
					ln = 1;
				}
				else if(a[i].x == 3){
					rep = string("1 ") + to_string(sm + 1) + " " + not_ch(a[i].c);
					ln = 2;
				}
				else {
					rep = string("1 ") + to_string(sm + 2) + " " + not_ch(a[i].c);
					ln = 3;
				}
			}
			else if (a[i].x == 11) {
				rep = string("1 ") + to_string(sm + 1) + " " + not_ch(a[i].c);
				ln = 2;
			}
			else if (a[i].x >= 2 * p.first) {
				rep = string("1 ") + to_string(sm + p.first) + " " + not_ch(a[i].c);
				ln = 1 + 2 * (p.second + 1);
			}
			else {
				rep = string("1 ") + to_string(sm + (p.first / 10)) + " " + not_ch(a[i].c);
				ln = 1 + p.second + get_numb_len(a[i].x - (p.first / 10));
			}
			if (ln > rln) {
				rln = ln;
				res = rep;
			}
		}
		sm += a[i].x;
	}
	cout << res << "\n";
}


void print_min_res() {
	string res = "";
	int rln = 0;
	long long sm = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i].x > 1) {
			string rep = string("2 ") + to_string(sm + 1);
			int ln = get_numb_len(a[i].x) - get_numb_len(a[i].x - 1);
			if (ln >= rln) {
				rln = ln;
				res = rep;
			}
		}
		else {
			string rep = string("2 ") + to_string(sm + 1);
			int ln = 1;
			if (i < 0 && i < n - 1 && a[i - 1].c == a[i + 1].c) {
				ln += 1 + get_numb_len(a[i - 1].x) + get_numb_len(a[i + 1].x) - get_numb_len(a[i - 1].x + a[i + 1].x);
			}
			if (ln >= rln) {
				rln = ln;
				res = rep;
			}
		}
		sm += a[i].x;
	}
	cout << res << "\n";
}


int32_t main() {
	cin >> s;
	get_a();
	n = a.size();
	print_min_res();
	print_max_res();
	return 0;
}

/*
5AC5A2C
*/