#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>


using namespace std;


int n;
vector<int> m;
vector<int> s;
vector<vector<int>> a;


int main() {
	cin >> n;
	m.resize(n);
	s.resize(n);
	a.resize(n);
	int ln = -1;
	for(int i = 0; i < n; ++i) {
		cin >> m[i] >> s[i];
		a[i].resize(m[i]);
		for (int j = 0; j < m[i]; ++j) {
			cin >> a[i][j];
			if (j != 0) {
				if (ln == -1) {
					ln = a[i][j] - a[i][j - 1];
				}
				else if (ln != a[i][j] - a[i][j - 1]) {
					cout << "No" << "\n";
					return 0;
				}
			}
		}
	}
	if (ln != -1) {
		map<int, vector<int>> bg;
		map<int, vector<int>> nd;
		for (int i = 0; i < n; ++i) {
			bg[a[i][0]].push_back(i);
			nd[ln - (s[i] - a[i][m[i] - 1])].push_back(i);
		}
		int first = -1;
		int last = -1;
		for (int i = 0; i < n; ++i) {
			int prev = a[i][0];
			if ((bg[prev].size() - 1 == nd[prev].size())) {
				first = i;
			}
		}
		for (int i = 0; i < n; ++i) {
			int nxt = ln - (s[i] - a[i][m[i] - 1]);
			if (bg[nxt].size() + 1 == nd[nxt].size()) {
				last = i;
			}
		}
		if (first == -1) {
			first = 0;
		}
		vector<int> res;
		res.push_back(first);
		int x = first;
		while (bg[ln - (s[x] - a[x][m[x] - 1])].size()) {
			while(!bg[ln - (s[x] - a[x][m[x] - 1])].empty() && (bg[ln - (s[x] - a[x][m[x] - 1])].back() == first || bg[ln - (s[x] - a[x][m[x] - 1])].back() == last)) {
				bg[ln - (s[x] - a[x][m[x] - 1])].pop_back();
			}
			if (bg[ln - (s[x] - a[x][m[x] - 1])].empty()) {
				break;
			}
			int nx = bg[ln - (s[x] - a[x][m[x] - 1])].back();
			bg[ln - (s[x] - a[x][m[x] - 1])].pop_back();
			x = nx;
			res.push_back(x);
		}
		if (last != -1) {
			if (ln - (s[x] - a[x][m[x] - 1]) == a[last][0]) {
				res.push_back(last);
			}
		}
		if (res.size() < n) {
			cout << "No" << "\n";
		}
		else {
			cout << "Yes" << "\n";
			for (auto c : res) {
				cout << c + 1 << " ";
			}
		}
	}
	else {

	}
	return 0;
}


/*
4
1 7
3
1 8
6
2 8
1 6
1 4
3


Yes
2 1 3
*/