#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>


using namespace std;


int n;
vector<int> m;
vector<int> s;
vector<vector<int>> a;
map<int, vector<int>> bg;
map<int, vector<int>> nd;
vector<bool> used;
vector<int> x;
int ln;


void dfs(int v) {
	used[v] = true;
	for (auto to : bg[ln - (s[v] - a[v][m[v] - 1])]) {
		if (!used[to]) {
			dfs(to);
		}
	}
	x.push_back(v);
}


bool ok() {
	int nln = -1;
	for (int i = 1; i < n; ++i) {
		if (nln == -1 || nln == (s[x[i - 1]] - a[x[i - 1]].back()) + a[x[i]][0]) {
			nln = (s[x[i - 1]] - a[x[i - 1]].back()) + a[x[i]][0];
		}
		else {
			return false;
		}
	}
	return ln == -1 || nln == -1 || ln == nln;
}



int main() {
	cin >> n;
	m.resize(n);
	s.resize(n);
	a.resize(n);
	ln = -1;
	for(int i = 0; i < n; ++i) {
		cin >> m[i] >> s[i];
		a[i].resize(m[i]);
		for (int j = 0; j < m[i]; ++j) {
			cin >> a[i][j];
			if (j != 0) {
				if (ln == -1) {
					ln = a[i][j] - a[i][j - 1];
				}
				else if (ln != a[i][j] - a[i][j - 1]) {
					cout << "No" << "\n";
					return 0;
				}
			}
		}
	}
	if (ln != -1) {
		for (int i = 0; i < n; ++i) {
			bg[a[i][0]].push_back(i);
			nd[ln - (s[i] - a[i][m[i] - 1])].push_back(i);
		}
		int first = -1;
		int last = -1;
		for (int i = 0; i < n; ++i) {
			int prev = a[i][0];
			if ((bg[prev].size() - 1 == nd[prev].size())) {
				first = i;
			}
		}
		if (first == -1) {
			first = 0;
		}
		used.resize(n, false);
		dfs(first);
		reverse(x.begin(), x.end());
		if (!ok()) {
			cout << "No" << "\n";
		}
		else {
			cout << "Yes" << "\n";
			for (auto c : x) {
				cout << c + 1 << " ";
			}
		}
	}
	else {

	}
	return 0;
}


/*
4
2 10
3 8
1 7
3
1 8
6
2 8
1 6



Yes
2 1 3
*/