#include <bits/stdc++.h>

#pragma GCC optimize ("O3")

using namespace std;
typedef long long ll;


const ll MOD = 1000000007ll;

ll n;
array<array<array<ll, 2>, 2>, 2> stat;

ll fac(ll n) {
    if(n == 0) return 0;
    ll ans = 1;
    for(ll i = 2; i <= n; i++) {
        ans *= i;
        ans %= MOD;
    }

    return ans;
}

ll f(ll a, ll b, ll c, ll depth, array<array<array<ll, 2>, 2>, 2> cstat) {
    if(a == 1 && depth == n) return 0;
    if(a == 0 && depth == n)  {
        //cout << "fret: " << (c == 1) << endl;
        return (c == 1 ? 0 : 1);
    }

    //cout << "f(" << a << ", " << b << ", " << c << ", " << depth << ")" << endl;

    ll ans = 0;
    if(c == 1) {
        array<array<array<ll, 2>, 2>, 2> ncstat = cstat;
        if(cstat[0][1][0] > 0) {
            ncstat[0][1][0]--;
            ans += cstat[0][1][0] * f(0, 1, 0, depth + 1, ncstat);
            ans %= MOD;
        }

        ncstat = cstat;
        if(cstat[0][1][1] > 0) {
            ncstat[0][1][1]--;
            ans += cstat[0][1][1] * f(0, 1, 1, depth + 1, ncstat);
            ans %= MOD;
        }

        ncstat = cstat;
        if(cstat[1][1][0] > 0) {
            ncstat[1][1][0]--;
            ans += cstat[1][1][0] * f(1, 1, 0, depth + 1, ncstat);
            ans %= MOD;
        }

        ncstat = cstat;
        if(cstat[1][1][1] > 0) {
            ncstat[1][1][1]--;
            ans += cstat[1][1][1] * f(1, 1, 1, depth + 1, ncstat);
            ans %= MOD;
        }
    }
    else {
        array<array<array<ll, 2>, 2>, 2> ncstat = cstat;
        if(cstat[0][0][0] > 0) {
            ncstat[0][0][0]--;
            ans += cstat[0][0][0] * f(0, 0, 0, depth + 1, ncstat);
            ans %= MOD;
        }

        ncstat = cstat;
        if(cstat[0][0][1] > 0) {
            ncstat[0][0][1]--;
            ans += cstat[0][0][1] * f(0, 0, 1, depth + 1, ncstat);
            ans %= MOD;
        }

        ncstat = cstat;
        if(cstat[1][0][0] > 0) {
            ncstat[1][0][0]--;
            ans += cstat[1][0][0] * f(1, 0, 0, depth + 1, ncstat);
            ans %= MOD;
        }

        ncstat = cstat;
        if(cstat[1][0][1] > 0) {
            ncstat[1][0][1]--;
            ans += cstat[1][0][1] * f(1, 0, 1, depth + 1, ncstat);
            ans %= MOD;
        }
    }

    return ans;
}

int main() {
    string a, b, c; cin >> a >> b >> c;

    for(ll i = 0; i < 2; i++) {
        for(ll u = 0; u < 2; u++) {
            for(ll w = 0; w < 2; w++) stat[i][u][w] = 0;
        }
    }

    n = a.length();

    for(ll i = 0; i < a.length(); i++) {
        bool isnull = (a[i] == '0') || (b[i] == '0') || (c[i] == '0');
        bool carryin = ((((ll)(a[i] - '0') + (ll)(b[i] - '0')) + 1) % 10) == (ll)(c[i] - '0');
        bool nocarryin = ((((ll)(a[i] - '0') + (ll)(b[i] - '0'))) % 10) == (ll)(c[i] - '0');

        if(!carryin && !nocarryin) {
            cout << '0' << endl;
            return 0;
        }

        bool carryout = carryin ? ((((ll)(a[i] - '0') + (ll)(b[i] - '0')) + 1) >= 10) : ((((ll)(a[i] - '0') + (ll)(b[i] - '0'))) >= 10);

        stat[isnull][carryin][carryout]++;
    }

    for(ll i = 0; i < 2; i++) {
        for(ll u = 0; u < 2; u++) {
            for(ll w = 0; w < 2; w++) {
                //cout << i << ';' << u << ';' << w << ": " << stat[i][u][w] << endl;
            }
        }
    }

    ll ans = 0;
        array<array<array<ll, 2>, 2>, 2> ncstat = stat;
        if(stat[0][0][0] > 0) {
            ncstat[0][0][0]--;
            ans += stat[0][0][0] * f(0, 0, 0, 1, ncstat);
            ans %= MOD;
        }

        ncstat = stat;
        if(stat[0][0][1] > 0) {
            ncstat[0][0][1]--;
            ans += stat[0][0][1] * f(0, 0, 1, 1, ncstat);
            ans %= MOD;
        }

        ncstat = stat;
        if(stat[1][0][0] > 0) {
            ncstat[1][0][0]--;
            ans += stat[1][0][0] * f(1, 0, 0, 1, ncstat);
            ans %= MOD;
        }

        ncstat = stat;
        if(stat[1][0][1] > 0) {
            ncstat[1][0][1]--;
            ans += stat[1][0][1] * f(1, 0, 1, 1, ncstat);
            ans %= MOD;
        }

    cout << ans << endl;

    return 0;
}
