#include <iostream>
#include <vector>
#include <sstream>
#include <string>

#define cin(a) for(auto& elem: a) cin >> elem;
#define cout(a) { for(auto& elem: a) cout << elem << " "; cout << endl; }

using namespace std;

bool answ_for2(int n, int m, vector<vector<int>>& answ, int i, int j) {
    if (i >= n || j >= m) return true;

    bool is_ok1 = true;
    bool is_ok2 = true;
    for (int x = 0; x < j; x++) {
        for (int y = 0; y < i; y++) {
            int cnt_1 = 0, cnt_2 = 0;
            if (answ[i][x] == 1) cnt_1++;
            else cnt_2++;
            if (answ[y][j] == 1) cnt_1++;
            else cnt_2++;
            if (answ[y][x] == 1) cnt_1++;
            else cnt_2++;
            if (cnt_1 == 3) is_ok1 = false;
            if (cnt_2 == 3) is_ok2 = false;
            if (!is_ok1 && !is_ok2) return false;
        }
    }

    if (is_ok1) {
        answ[i][j] = 1;
        if (j < m - 1) {
            if (answ_for2(n, m, answ, i, j + 1)) return true;
        }
        else if (answ_for2(n, m, answ, i + 1, 0)) return true;
    }
    if (is_ok2) {
        answ[i][j] = 2;
        if (j < m - 1) {
            if (answ_for2(n, m, answ, i, j + 1)) return true;
        }
        else if (answ_for2(n, m, answ, i + 1, 0)) return true;
    }
    return false;
}

bool is_ok_for_c2(int n, int m) {
    switch(n) {
    case 2:
        if (m <= 10) return true;
        break;
    case 3:
        if (m <= 6) return true;
        break;
    case 4:
        if (m <= 6) return true;
        break;
    case 5:
        if (m <= 4) return true;
        break;
    case 6:
        if (m <= 4) return true;
        break;
    default:
        if (m <= 2) return true;
        break;
    }
    return false;
}

int main () {
    int n, m, c;
    cin >> n >> m >> c;



    if (c == 3) {
        vector<vector<int>> answ(n, vector<int>(m, 0));
        if (is_ok_for_c2(n, m)) answ_for2(n, m, answ, 0, 0);
        else if (is_ok_for_c2(n - 1, m - 1)) {
            vector<vector<int>> small_answ(n - 1, vector<int>(m - 1, 0));
            answ_for2(n - 1, m - 1, small_answ, 0, 0);
            for (int i = 0; i < n - 1; i++) {
                for (int j = 0; j < m - 1; j++) {
                    answ[i][j] = small_answ[i][j];
                }
            }
            for (int i = 0; i < n; i++) answ[i][m-1] = 3;
            for (int i = 0; i < m; i++) answ[n-1][i] = 3;
        }
        else return -1;
        for (auto& line: answ) cout(line);
    }
    if (c == 2) {
        vector<vector<int>> answ(n, vector<int>(m, 0));
        if (answ_for2(n, m, answ, 0, 0)) {
            for (auto& line: answ) cout(line);
        }
        else {
            cout << "Nope\n";
        }
    }
}
