#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define int ll

const ll INF = 1e18 + 239;

ll V_cut(int n, int m, int x) {
	//cerr << n * (n - 1) * m / 2 << endl;
	return (ll)x * (x + 1) * n / 2 + (ll)x * (n)  * (n - 1) * m / 2;
}

pair<ll, int> solve_V(int n, int m) {
	ll ans = INF;
	ll all = ((ll)n * m) * (n * m + 1) / 2;
	int best = 0;
	for (int i = 1; i < m; i++) {
		ans = min(ans, abs(all - 2 * V_cut(n, m, i)));
		if (ans == abs(all - 2 * V_cut(n, m, i))) best = i;				
	}
	return {ans, best};	
}

ll H_cut(int n, int m, int x) {
	return ((ll)x * m) * ((ll)x * m + 1) / 2;
} 

pair<ll, int> solve_H(int n, int m) {               
	ll ans = INF;
	ll all = ((ll)n * m) * (n * m + 1) / 2;
	int best = 0;
	for (int i = 1; i < n; i++) {
		ans = min(ans, abs(all - 2 * H_cut(n, m, i)));
		if (ans == abs(all - 2 * H_cut(n, m, i))) best = i;				
	}
	return {ans, best}; 	
}

void solve() {
	int n, m;
	cin >> n >> m;
	auto H = solve_H(n, m);
	auto V = solve_V(n, m);
	if (H.first < V.first) {
		cerr << H.first << endl;
		cout << "H " << H.second + 1 << endl; 
	} else {
		cerr << V.first << endl;
		cout << "V " << V.second + 1 << endl;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("test", "r", stdin);
	#endif

	//cerr << V_cut(3, 5, 3) << endl;
	//exit(0);

	int q;
	cin >> q;
	while (q--) {
		solve();
	}
}
