#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 7;

int n;
int pf[N];
int su[N];

int gsz;
vector<int> ie;

int pe = 0;
int pnt[N];
int used[N];
int ed[N];
int alive[N];

map<pair<int, int>, int> cnt;
map<pair<int, int>, vector<int>> ind;

vector<pair<int, int>> g[8 * N];

void dfs(int cur) {
	used[cur] = 1;
	while (pnt[cur] < (int)g[cur].size()) {
		int ind = g[cur][pnt[cur]].first;
		pnt[cur]++;
		if (alive[ind]) {
			alive[ind] = 0;
			dfs(cur ^ ed[ind]);
		}
	}
	ie.push_back(cur);
}

void init() {
	pe = 0;
	for (int i = 0; i < gsz; i++) {
		used[i] = 0;
		g[i].clear();
		pnt[i]= 0;
	}
	cnt.clear();
	ind.clear();
	ie.clear();
}

void ae(int u, int v, int I) {
	ind[{u, v}].push_back(I);
    //cerr << "e " << u << ' ' << v << endl;
	ed[pe] = (u ^ v);
	alive[pe] = 1;
	g[u].push_back({pe, I});
	pe++;
	cnt[{u, v}]++;
}

int et(int st) {
	//cerr << "st " << st << endl;
	assert(st != -1);
	ie.clear();
	dfs(st);
	reverse(ie.begin(), ie.end());
	/*cerr << "et\n";
	for (auto t : ie) {
		cerr << t << ' ';
	}
	cerr << endl;*/
	int ok = 1; 
	map<pair<int, int>, int> now;
	for (int i = 0; i + 1 < (int)ie.size(); i++) {
		int u = ie[i];
		int v = ie[i + 1];
		now[{u, v}]++;
		ok &= (cnt[{u, v}] >= now[{u, v}]); 	
	}
	if (!ok) {
		return 0;
	}
	return 1;
}

int check(int X) {
	int st = -1;
	int en = -1;
	vector<int> v;
	set<int> sv;
	for (int i = 0; i < n; i++) {
		//cerr << pf[i] << ' ' << su[i] << endl;
		if (pf[i] > X) {
			if (st != -1) return 0;
			st = i;
		}
		if (su[i] > X) {
			if (en != -1) return 0;
			en = i;
		}
		if (pf[i] <= X && su[i] <= X) {
			sv.insert(pf[i]);
			v.push_back(pf[i]);
		}
		if (pf[i] > X && su[i] > X) return 0;
	}

	sort(v.begin(), v.end());
	v.resize(unique(v.begin(), v.end()) - v.begin());
	auto gi = [&](int x) {
		if (!sv.count(x)) return -1;
		return (int)(lower_bound(v.begin(), v.end(), x) - v.begin());
	};

	int sz = (int)v.size();
	gsz = sz;
	init();
	
	for (int i = 0; i < n; i++) {
		int u = gi(pf[i]);
		int v = gi(X - su[i]);
		if (u == -1 || v == -1) continue;
		ae(u, v, i);	
	}

	int E = 0;
    if (st == -1) {
    	E = et(gi(pf[0]));
    } else {    
    	int o = gi(X - su[st]);
    	if (o == -1) return 0;
    	E = et(o); 
    }
    if (!E) return 0;    
    int c = 0;
    c += (st != -1);
    c += (en != -1);
    c += (int)ie.size() - 1;
    if (c == n) {
    	cout << "Yes\n";
    	if (st != -1) cout << st + 1 << ' ';
    	for (int i = 0; i + 1 < (int)ie.size(); i++) {
     		int u = ie[i];
     		int v = ie[i + 1];
     		cout << ind[{u, v}].back() + 1 << ' ';
     		ind[{u, v}].pop_back();
    	}
    	if (en != -1) cout << en + 1 << '\n';
    	exit(0);
    }
    return 0;
}               

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("test", "r", stdin);
	#endif

	map<int, int> in;
	int c = 0;
	cin >> n;
	int sm = 0;  
	for (int i = 0; i < n; i++) {
		int m, S;
		cin >> m >> S;
		vector<int> v(m);
		for (auto &t : v) {
			cin >> t;
		}
		sm += m;
		for (int i = 0; i + 1 < m; i++) {
			in[v[i + 1] - v[i]]++;
			c++;			
		}
		pf[i] = v.front();
		su[i] = S - v.back();
	}
	if (sm == 1) {
		cout << "Yes\n";
		cout << 1 << endl;
		exit(0);
	}
	if (!in.empty()) {
		for (auto [i, sn] : in) {
			if (sn == c) check(i);
		}
		cout << "No\n";
		return 0;
	} else {
		for (int i = 0; i <= 200; i++) {
			check(i);
		}
		cout << "No\n";
	}
}
