#include <iostream>
typedef __int128 ll;
using namespace std;

ll sum(ll x)
{
    return x * (x + 1) / 2;
}

ll f1(ll n, ll m, ll x)
{
    return abs(sum(n * m) - 2 * sum(x * m));
}

ll f2(ll n, ll m, ll x)
{
    return abs(sum(n * m) - 2 * (sum(x) * n + sum(n - 1) * m * x));
}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        long long _n, _m;
        cin >> _n >> _m;
        ll n = _n, m = _m, l = 0, r = n;
        while (r - l > 2) {
            ll m1 = (l * 2 + r) / 3, m2 = (l + r * 2) / 3;
            if (f1(n, m, m1) < f1(n, m, m2))
                r = m2;
            else
                l = m1;
        }
        long long ans1 = l;
        if (f1(n, m, ans1) > f1(n, m, l + 1))
            ans1 = l + 1;
        if (f1(n, m, ans1) > f1(n, m, r))
            ans1 = r;
        l = 0, r = m;
        while (r - l > 2) {
            ll m1 = (l * 2 + r) / 3, m2 = (l + r * 2) / 3;
            if (f2(n, m, m1) < f2(n, m, m2))
                r = m2;
            else
                l = m1;
        }
        long long ans2 = l;
        if (f2(n, m, ans2) > f2(n, m, l + 1))
            ans2 = l + 1;
        if (f2(n, m, ans2) > f2(n, m, r))
            ans2 = r;
        if (f1(n, m, ans1) < f2(n, m, ans2))
            cout << "H " << ans1 + 1 << '\n';
        else
            cout << "V " << ans2 + 1 << '\n';
    }
}
