#include <iostream>
#include <vector>
typedef long long ll;
using namespace std;

int n;
ll dif = -1;
vector<ll> a, b, len;
vector<int> ans;
vector<bool> used;

bool gen(int depth, ll add)
{
    if (depth == n) {
        ll _dif = dif;
        if (_dif == -1)
            _dif = b[1] - b[0];
        for (int i = 1; i < n; ++i) {
            if (b[i] - b[i - 1] != _dif)
                return false;
        }
        return true;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            used[i] = true;
            b.push_back(a[i] + add);
            if (gen(depth + 1, add + len[i])) {
                ans.push_back(i + 1);
                return true;
            }
            used[i] = false;
            b.pop_back();
        }
    }
    return false;
}

int main()
{
    cin >> n;
    a.resize(n);
    len.resize(n);
    bool ch = true;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x >> len[i] >> a[i];
        if (x > 1) {
            ll prv = a[i], curr;
            for (int j = 1; j < x; ++j) {
                cin >> curr;
                if (curr - prv != dif) {
                    if (dif == -1)
                        dif = curr - prv;
                    else
                        ch = false;
                }
                prv = curr;
            }
            len[i] = a[i] + len[i] - curr;
        }
    }
    if (!ch) {
        cout << "No" << endl;
        return 0;
    }
    if (n == 1) {
        cout << "Yes\n1" << endl;
        return 0;
    }
    used.assign(n, false);
    if (!gen(0, 0))
        cout << "No" << endl;
    else {
        cout << "Yes\n";
        for (int i = n - 1; i >= 0; --i)
            cout << ans[i] << ' ';
    }
}
