#include <iostream>
#include <vector>
typedef long long ll;
using namespace std;

const ll MOD = 1e9 + 7;
int n;
string s1, s2, s3, _s1, _s2, _s3;
vector<bool> used;

ll gen(int depth)
{
    if (depth == n) {
        if (stoi(_s1) + stoi(_s2) == stoi(_s3))
            return 1;
        else
            return 0;
    }
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i] && (depth != 0 || s1[i] != '0' && s2[i] != '0' && s3[i] != '0')) {
            used[i] = true;
            _s1.push_back(s1[i]);
            _s2.push_back(s2[i]);
            _s3.push_back(s3[i]);
            res = (res + gen(depth + 1)) % MOD;
            used[i] = false;
            _s1.pop_back();
            _s2.pop_back();
            _s3.pop_back();
        }
    }
    return res;
}

int main()
{
    cin >> s1 >> s2 >> s3;
    n = s1.size();
    if (n > 6) {
        ll a = 0, b = 0, c = 0, d = 0;
        for (int i = 0; i < n; ++i) {
            int x = s1[i] - '0', y = s2[i] - '0', z = s3[i] - '0';
            bool ch1 = false, ch2 = false;
            if ((x + y) % 10 != z && (x + y + 1) % 10 != z) {
                cout << 0 << endl;
                return 0;
            }
            if ((x + y + 1) % 10 == z)
                ch2 = true;
            if (x + y + (int) ch2 >= 10)
                ch1 = true;
            if (!ch1 && !ch2)
                ++a;
            else if (ch1 && !ch2)
                ++b;
            else if (!ch1)
                ++c;
            else
                ++d;
        }
        if (b != c || (b == 0 && d > 0)) {
            cout << 0 << endl;
            return 0;
        }
        ll ans = 1;
        if (b == 0) {
            for (ll i = 1; i <= a; ++i)
                ans = (ans * i) % MOD;
        } else {
            for (ll i = 2; i <= b; ++i)
                ans = (((ans * i) % MOD) * i) % MOD;
            for (ll i = b; i < b + d; ++i)
                ans = (ans * i) % MOD;
            for (ll i = b + 1; i <= a + b; ++i)
                ans = (ans * i) % MOD;
        }
        cout << ans << endl;
    }
    else {
        used.assign(n, false);
        cout << gen(0) << endl;
    }
}
