#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ll long long
#define ii pair <int, int>
#define debug(x) cout<<#x<<": "<<x<<endl;
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define app push_back
#define Time (double)clock()/CLOCKS_PER_SEC

const int MOD = 1e9+7, N = 5e5+7;

void gg() {
    cout << 0 << endl;
    exit(0);
}	

int f[N], inv[N];
int mul(int a, int b) {
	return (a * b) % MOD;
}
int C(int n, int k) {
	assert(n >= k);
	return mul(f[n], mul(inv[k], inv[n - k]));
}	
int part(int n, int k) {
	if (n && k == 0)
		return 0;
	if (n == 0 && k == 0)	
		return 1;
	return C(n + k - 1, k - 1);
}

int fp(int a, int p) {
    int cur = a, ans = 1;
    for (int i = 0; (1ll << i) <= p; ++i) {
        if ((p >> i) & 1)
        	ans = mul(ans, cur);
		cur = mul(cur, cur);
    }	                    
    return ans;
}	

signed main() {
	#ifdef HOME
	freopen("input.txt", "r", stdin);
	#else
	ios_base::sync_with_stdio(0); cin.tie(0);
	#endif


	vector <string> a(3);
	vector <vector <int> > cnt(2, vector <int> (2));
	vector <vector <int> > good(2, vector <int> (2));

	f[0] = 1;
	for (int i = 1; i < N; ++i) {
	    f[i] = mul(f[i - 1], i);
	}	

	for (int i = 0; i < N; ++i)
		inv[i] = fp(f[i], MOD - 2);

	#ifdef HOME
	debug(MOD);
	cout << part(3, 3) << endl;
	#endif

	int n;
	for (int i = 0; i < 3; ++i) {
	    cin >> a[i];
	    n = a[i].size();
	}	

	for (int i = 0; i < n; ++i) {
	    int x = a[0][i] - '0';
	    int y = a[1][i] - '0';
	    int z = a[2][i] - '0';

	    int r = 0;
	    if ((x + y) % 10 == z % 10) {
			r = 0;				
	    }	
	    else {
	        r = 1;
	    }	

	    if ((x + y + r) % 10 != z % 10) {
	    	gg();
	    }

	    int l = (x + y + r) / 10;

	    cnt[l][r]++;
	    if (x * y * z)
	    	good[l][r]++;
	}	

	if (cnt[0][0] == n) {
		int i = 0, j = 0;
	    cout << mul(good[i][j], f[cnt[i][j] - 1]) << endl;
	    exit(0);
	}	

	if (cnt[0][1] != cnt[1][0]) {
		gg();
	}	

	if (cnt[0][1] == 0) {
	    gg();
	}	

	int bl = cnt[0][1];

	#ifdef HOME
	for (int i = 0; i < 2; ++i) {
	    for (int j = 0; j < 2; ++j) {
	        cout << cnt[i][j] << ' ';
	    }	
	    cout << endl;
	}	
	#endif

	/*
	debug(bl);
	debug(f[cnt[0][1]]);
	debug(f[cnt[1][0]]);
	debug(part(cnt[1][1], bl));
	debug(part(cnt[0][0], bl + 1));
	*/

	int ans01 = 1;
	for (int i = 0; i < 2; ++i) {
	    for (int j = 0; j < 2; ++j) {
	    	if (i == 0 && j == 1) {
	    		ans01 = mul(ans01, mul(good[i][j], f[cnt[i][j] - 1]));
	    	}
	    	else {
	    		ans01 = mul(ans01, f[cnt[i][j]]);
	    	}
	    }	
	}	
	ans01 = mul(ans01, mul(part(cnt[1][1], bl), part(cnt[0][0], bl)));	
	
	int ans00 = 1;
	for (int i = 0; i < 2; ++i) {
	    for (int j = 0; j < 2; ++j) {
	    	if (i == 0 && j == 0) {
	    	    ans00 = mul(ans00, mul(good[i][j], f[cnt[i][j] - 1]));
	    	}	
	    	else {
	    	    ans00 = mul(ans00, f[cnt[i][j]]);
	    	}	
	    }	
	}	

	auto ext = [&] (int a, int b) {
	  	return (a + MOD - b) % MOD;
	};

	int sp00 = ext(part(cnt[0][0], bl + 1), part(cnt[0][0], bl));
	ans00 = mul(ans00, mul(part(cnt[1][1], bl), sp00));	

	debug(ans01);
	debug(ans00);

	cout << (ans01 + ans00) % MOD << endl;
}	