def get_diff_row(n, m, k):
    return abs((n*m+1)*(n*m)//2 - (n*k)*(n*k+1))

def get_diff_vert(n, m, k):
    return abs((n*m+1)*(n*m)//2 - (k*n*(m*(n-1) + k + 1)))

def get_best_vert(n, m):
    k2, k1, k0 = n, m*n*(n-1) + n, -(n*m+1)*(n*m)//2
    i, j = 0, m
    i_res, j_res = k0, k2*j**2 + k1*j + k0
    while j > i + 1:
        md = (i + j) >> 1
        md_res = k2*md**2 + k1*md + k0
        if md_res == 0:
            return (md, md_res)
        elif md_res > 0:
            j, j_res = md, md_res
        else:
            i, i_res = md, md_res
    if abs(i_res) > abs(j_res):
        return (j, abs(j_res))
    return (i, abs(i_res))

def get_best_row(n, m):
    k2, k1, k0 = m**2, m, -(n*m+1)*(n*m)//2
    i, j = 0, n
    i_res, j_res = k0, k2*j**2 + k1*j + k0
    while j > i + 1:
        md = (i + j) >> 1
        md_res = k2*md**2 + k1*md + k0
        if md_res == 0:
            return (md, md_res)
        elif md_res > 0:
            j, j_res = md, md_res
        else:
            i, i_res = md, md_res
    if abs(i_res) > abs(j_res):
        return (j, abs(j_res))
    return (i, abs(i_res))

def main(n, m):
    vrt = get_best_vert(n, m)
    rw = get_best_row(n, m)
    if vrt[1] > rw[1]:
        return 'H ' + str(rw[0]+1)
    return 'V ' + str(vrt[0]+1)


rs = []
for _ in range(int(input())):
    rs.append(main(*map(int, input().split())))
print(*rs, sep='\n')
