def sum_seq(fr, to, cnt=None):
    if cnt is None:
        cnt = to - fr + 1
    return (to + fr) * (cnt // 2) + (to + fr) // 2 * (cnt % 2)


def search_v_f(n, m, i):
    i -= 1
    return abs(sum_seq(1, i + m * (n - 1), n * i) - sum_seq(i + 1, m * n, n * (m - i)))


def search_v(nn, mm):
    r = mm
    l = 1
    while r - l > 1:
        m = (r + l) // 2
        if search_v_f(nn, mm, r) > search_v_f(nn, mm, l):
            r = m
        else:
            l = m
    return min((search_v_f(nn, mm, l), l), (search_v_f(nn, mm, r), r))[1]


def search_h_f(n, m, i):
    i -= 1
    return abs(sum_seq(1, m * i, m * i) - sum_seq(m * i + 1, m * n, m * (n - i)))


def search_h(nn, mm):
    r = nn
    l = 1
    while r - l > 1:
        m = (r + l) // 2
        if search_h_f(nn, mm, r) > search_h_f(nn, mm, l):
            r = m
        else:
            l = m
    return min((search_h_f(nn, mm, l), l), (search_h_f(nn, mm, r), r))[1]


for _ in range(int(input())):
    n, m = map(int, input().split())

    idx = search_v(n, m)
    res = 'V ' + str(idx)
    res_val = search_v_f(n, m, idx)

    idx2 = search_h(n, m)
    res2 = 'H ' + str(idx2)
    res2_val = search_h_f(n, m, idx2)

    if res2_val < res_val:
        print(res2)
    else:
        print(res)
