#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 1e5;
struct upd
{
	int newLen;
	int type;
	int ind;
	char x;
};

bool isLess(upd a, upd b) {
	if (a.newLen < b.newLen) return true;
	return false;
}
bool isMore(upd a, upd b) {
	if (a.newLen > b.newLen) return true;
	return false;
}
int sz(int x) {
	return std::to_string(x).size();
}
upd minLen = {(int)1e9 + 10, 0, 0, 0};
upd maxLen = {-1, 0, 0, 0};

void relax(upd x) {
	if (isMore(x, maxLen)) maxLen = x;
	if (isLess(x, minLen)) minLen = x;
}
void print(upd x) {
	if (x.type == 2) {
		std::cout << x.type << ' ' << x.ind << '\n';
	}
	else {
		std::cout << x.type << ' ' << x.ind << ' ' << x.x << '\n';
	}
}

int main() {
	std::vector<std::pair<int,char>> kek;
	std::string s;
	std::cin >> s;
	for (int i = 0; i < (int)s.size(); ++i) {
		if (s[i] >= '0' && s[i] <= '9') {
			int num = 0;
			int r = i;
			while (r < (int)s.size() && s[r] >= '0' && s[r] <= '9') {
				num = num * 10 + (s[r] - '0');
				++r;
			}
			kek.pb({num, s[r]});
			i = r;
		}
		else {
			kek.pb({1, s[i]});
		}
	}
	
	for (int i = 1; i < (int)kek.size(); ++i) {
		assert(kek[i].second != kek[i - 1].second);
	}

	int allSz = 0;
	FOR(i, s.size()) {
		allSz += sz(kek[i].first) + 1;
	}
	int prefLen = 0;
	{
		upd check = {allSz + 2, 1, 1, kek[0].second == 'A' ? 'C' : 'A'};
		relax(check);
	}
	for (int i = 0; i < (int)kek.size(); ++i) {
		int newSz = allSz;

		{ //addToBegin
			std::pair<int, char> newX = kek[i];
			newSz -= sz(newX.first) + 1;
			++newX.first;
			newSz += sz(newX.first) + 1;

			upd check = {newSz, 1, prefLen + 1, kek[i].second};
			relax(check);
		}
		{ //delFromBegin
			std::pair<int, char> newX = kek[i];
			newSz -= sz(newX.first) + 1;
			--newX.first;
			if (newX.first != 0) {
				newSz += sz(newX.first) + 1;

				upd check = {newSz, 2, prefLen + 1, kek[i].second};
				relax(check);
			}
			else {
				if (i != 0 && i != (int)kek.size() - 1) {
					if (kek[i - 1].second == kek[i + 1].second) {
						newSz -= sz(kek[i - 1].first) + sz(kek[i + 1].first) + 2;

						newSz += sz(kek[i - 1].first + kek[i + 1].first) + 1;

						upd check = {newSz, 2, prefLen + 1, kek[i].second};
						relax(check);
					}
					else {
						upd check = {newSz, 2, prefLen + 1, kek[i].second};
						relax(check);
					}
				}
				else {
					upd check = {newSz, 2, prefLen + 1, kek[i].second};
					relax(check);
				}
			}
		}
		{ // addMid
			std::pair<int, char> newX = kek[i];

			newSz -= sz(newX.first) + 1;

			ll num = 1;
			for (int power = 0; power < 10; ++power) {

				if (newX.first > num) {
					ll left = sz(num) + 1;
					ll right = sz(newX.first - num) + 1;

					int new2Sz = newSz + left + right + 2;

					upd check = {new2Sz, 1, prefLen + num + 1, newX.second == 'A' ? 'C' : 'A'};

					relax(check);
				}
				else {
					break;
				}

				num = num * 10;
			}
		}
		prefLen += kek[i].first;
	}

	print(minLen);
	print(maxLen);
}