#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 1e5;
const int Z = 1e9 + 10;
std::map<int, std::vector<std::pair<int,int>>> g;
int n;
std::vector<std::pair<int,int>> sh;
std::map<int, int> used, tin, tout;
std::vector<int> cmp;
void dfs(int v) {
	cmp.pb(v);
	used[v] = 1;
	for (auto e : g[v]) {
		if (!used[e.first]) dfs(e.first);
	}
}
std::vector<int> perm;

void find_cycle(int v) {
	while (!g[v].empty()) {
		auto t = g[v].back();
		g[v].pop_back();

		if (t.second >= 0)
			perm.pb(t.second);
		find_cycle(t.first);
	}
}

void checkNeed(ll need) {
	FOR(i, sh.size()) {
		tout[sh[i].first]++;
		tin[sh[i].second + Z]++;
		// debug(sh[i].first)
		g[sh[i].first].pb({sh[i].second + Z, i});

		tout[sh[i].second + Z]++;
		tin[need - sh[i].second]++;

		// debug(need - sh[i].second)
		// if (need - sh[i].second < 0) {
		// 	return;
		// }
		// debug(sh[i].second + Z)
		g[sh[i].second + Z].pb({need - sh[i].second, -1});
	}
	int start = -Z, end = -Z;
	for (auto e : g) {
		int v = e.first;

		// debug(v << ' ' << tin[v] << ' ' << tout[v])

		if (llabs(tin[v] - tout[v]) > 1) return;
		if (tin[v] == tout[v]) continue;

		if (tin[v] < tout[v]) {
			if (start != -Z) return;
			start = v;
		}
		if (tout[v] > tin[v]) {
			if (end != -Z) return;
			end = v;
		}
	}
	// debug("X")
	if (start == -1) start = g.begin()->first;
	// debug(start)
	dfs(start);
	if (cmp.size() != g.size()) {
		return;
	}

	if (end != -1) {
		g[start].pb({end, 1e9});
	}

	find_cycle(start);

	int ind = perm.size();

	FOR(i, perm.size()) {
		if (perm[i] == 1e9) ind = i;
	}
	std::vector<int> actual;
	FOR(j, ind) {
		actual.pb(perm[j]);
	}
	for (int i = (int)perm.size() - 1; i > ind; --i) {
		actual.pb(perm[i]);
	}
	std::reverse(actual.begin(), actual.end());

	std::cout << "Yes\n";
	for (auto e : actual) {
		std::cout << e + 1 << ' ';
	}
	exit(0);
}

int main() {
	std::cin >> n;
	int need = -1;
	sh.resize(n);
	FOR(i, n) {
		int m, s;
		std::cin >> m >> s;
		std::vector<int> kek(m);
		FOR(i, m) {
			std::cin >> kek[i];
		}
		for (int i = 1; i < m; ++i) {
			int delta = kek[i] - kek[i - 1];
			if (need == -1) need = delta;
			if (need != delta) {
				std::cout << "No";
				return 0;
			}
		}
		sh[i] = {kek[0], s - kek.back()};
	}
	std::vector<int> perm;
	FOR(i, n) perm.pb(i);
	do {
		int curNeed = need;
		bool fl = true;
		for (int i = 1; i < n; ++i) {
			if (curNeed == -1) {
				curNeed = sh[perm[i - 1]].second + sh[perm[i]].first;
			}
			if (sh[perm[i - 1]].second + sh[perm[i]].first != curNeed) {
				fl = false;
			}
		}
		// debug(curNeed)
		if (fl) {
			std::cout << "Yes\n";
			FOR(i, n) {
				std::cout << perm[i] + 1 << ' ';
			}
			return 0;
		}
	} while (std::next_permutation(perm.begin(), perm.end()));
	std::cout << "No\n";
}