#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 1e5;
const int Z = 1e9 + 10;
std::map<int, std::vector<std::pair<int,int>>> g;
int n;
std::vector<std::pair<int,int>> sh;
std::map<int, int> used, tin, tout;
std::vector<int> cmp;
void dfs(int v) {
	cmp.pb(v);
	used[v] = 1;
	for (auto e : g[v]) {
		if (!used[e.first]) dfs(e.first);
	}
}
std::vector<int> perm;

void find_cycle(int v) {
	while (!g[v].empty()) {
		auto t = g[v].back();
		g[v].pop_back();
		// debug(v << "->" << t.first << "." << t.second)
		find_cycle(t.first);
		if (t.second >= 0)
			perm.pb(t.second);
	}
}

void checkNeed(ll need) {
	tin.clear();
	tout.clear();
	cmp.clear();
	used.clear();
	g.clear();
	perm.clear();
	// debug("START")
	std::vector<int> check;
	FOR(i, sh.size()) {
		tout[sh[i].first]++;
		tin[sh[i].second + Z]++;
		// debug(sh[i].first)
		g[sh[i].first].pb({sh[i].second + Z, i});

		check.pb(sh[i].first);
		check.pb(sh[i].second + Z);
		check.pb(need - sh[i].second);


		tout[sh[i].second + Z]++;
		tin[need - sh[i].second]++;

		// debug(need - sh[i].second)
		// if (need - sh[i].second < 0) {
		// 	return;
		// }
		// debug(sh[i].first << ' ' << sh[i].second + Z)
		// debug(sh[i].second + Z << ' ' << need - sh[i].second)

		g[sh[i].second + Z].pb({need - sh[i].second, -1});
	}
	std::sort(check.begin(), check.end());
	check.resize(std::unique(check.begin(), check.end()) - check.begin());
	int start = -Z, end = -Z;
		// debug("ROFL")
	for (auto e : check) {
		int v = e;
		// debug(v << ' ' << tin[v] << ' ' << tout[v])

		if (llabs(tin[v] - tout[v]) > 1) return;
		if (tin[v] == tout[v]) continue;

		if (tin[v] < tout[v]) {
			if (start != -Z) return;
			start = v;
		}
		if (tout[v] < tin[v]) {
			if (end != -Z) return;
			end = v;
		}
	}
	// debug(start << ' ' << end)
	// debug("X")
	// debug(g.begin()->first)
	if (start == -Z) start = g.begin()->first;
	// debug(start)
	dfs(start);
	if (cmp.size() != g.size()) {
		return;
	}
	// debug(end << ' ' << start)
	if (end != -1) {
		g[end].pb({start, 1e9});
	}

	find_cycle(start);

	std::reverse(perm.begin(), perm.end());

	int ind = perm.size();

	FOR(i, perm.size()) {
		if (perm[i] == 1e9) ind = i;
	}
	std::vector<int> actual;
	for (int i = ind + 1; i < (int)perm.size(); ++i) {
		actual.pb(perm[i]);
	}
	FOR(j, ind) {
		actual.pb(perm[j]);
	}
	// debug(ind)
	// std::reverse(actual.begin(), actual.end());

	std::cout << "Yes\n";
	int curNeed = -1;
	bool fl = true;
	// debug(need)
	for (int i = 1; i < n; ++i) {
		if (curNeed == -1) {
			curNeed = sh[actual[i - 1]].second + sh[actual[i]].first;
		}
		if (sh[actual[i - 1]].second + sh[actual[i]].first != curNeed) {
			// debug(actual[i] << ' ' << actual[i - 1])
			// debug(sh[actual[i - 1]].second << ' ' <<  sh[actual[i]].first)
			fl = false;
		}
	}
	if (!fl) {
		std::cout << ":(";
		// exit(0);
	}
	// for (auto e : actual) {
	// 	std::cout << e + 1 << ' ';
	// }
	exit(0);
}

int main() {
	std::cin >> n;
	int need = -1;
	sh.resize(n);
	std::vector<int> beg, end;
	FOR(i, n) {
		int m, s;
		std::cin >> m >> s;
		std::vector<int> kek(m);
		FOR(i, m) {
			std::cin >> kek[i];
		}
		for (int i = 1; i < m; ++i) {
			int delta = kek[i] - kek[i - 1];
			if (need == -1) need = delta;
			if (need != delta) {
				std::cout << "No";
				return 0;
			}
		}
		sh[i] = {kek[0], s - kek.back()};
		beg.pb(kek[0]);
		end.pb(s - kek.back());
		// debug(sh[i].first << ' ' << sh[i].second)
	}
	std::sort(beg.begin(), beg.end());
	std::sort(end.rbegin(), end.rend());
	if (need != -1) {
		checkNeed(need);
		std::cout << "No";
		return 0;
	}
	FOR(i, std::min(2, (int)beg.size())) {
		FOR(j, std::min(2, (int)end.size())) {
			checkNeed(beg[i] + end[j]);
		}
	}
	std::cout << "No";
}