#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 11;
bool rev = false;
int a[N][N];
int n, m, c;
struct check
{
	int i, j, c;	

	friend bool operator==(check a, check b) {
		return a.i == b.i && a.j == b.j && a.c == b.c;
	}

	friend bool operator<(check a, check b) {
		if (a.i == b.i) {
			if (a.j == b.j) {
				return a.c < b.c;
			}
			return a.j < b.j;
		}
		return a.i < b.i;
	}
};
struct mySet
{
	std::set<check> x;

	friend bool operator<(mySet a, mySet b) {
		auto it1 = a.x.begin();
		auto it2 = b.x.begin();
		while (it1 != a.x.end() && it2 != b.x.end()) {
			if (*it1 < *it2) return true;
			if (*it2 < *it1) return false;
			++it1;
			++it2;
		}
		return a.x.size() < b.x.size();
	}	
};
std::map<mySet, int> mapik[N];

int power[N + 10];
void gen(int now, mySet &state, int lastMask = 0) {
	if (mapik[now].count(state)) return;
	mapik[now][state] = 1;
	if (now == n) {
		if (rev) {
			FOR(i, m) {
				FOR(j, n) {
					std::cout << a[j][i] + 1 << ' ';
				}
				std::cout << '\n';
			}
		}
		else {
			FOR(i, n) {
				FOR(j, m) {
					std::cout << a[i][j] + 1 << ' ';
				}
				std::cout << '\n';
			}
		}
		exit(0);
	}
	for (int i = lastMask; i < power[m]; ++i) {
		int nowC = i;
		FOR(j, m) {
			a[now][j] = nowC % c;
			nowC /= c;
		}
		bool fl = true;
		std::vector<check> newCheck;
		FOR(j, m) {
			for (int q = j + 1; q < m; ++q) {
				if (a[now][j] == a[now][q]) {
					check toCheck = {j, q, a[now][j]};

					newCheck.pb(toCheck);

					if (state.x.count(toCheck)) {
						fl = false;
						break;
					}
				}
			}
			if (!fl) break;
		}
		if (fl) {
			for (auto e : newCheck) {
				state.x.insert(e);
			}
			gen(now + 1, state, i);
			for (auto e : newCheck) {
				state.x.erase(e);
			}
		}
	}
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n >> m >> c;
	power[0] = 1;
	FOR(i, N) {
		power[i + 1] = power[i] * c;
	}
	if (n < m) {
		std::swap(n, m);
		rev = true;
	}
	assert(n <= 8 && m <= 8);
	mySet start;
	// debug(n << ' ' << m)
	gen(0, start);
}