#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 20;
const int mod = 1e9 + 7;
int a[N][N];
std::set<int> possible[N][N];
std::mt19937 rnd(228);
int n, m, c;
void gen() {
	std::vector<std::pair<int,int>> x;
	FOR(i, n) {
		FOR(j, m) {
			if (a[i][j] == -1)
				x.pb({i, j});
		}
	}
	if (x.empty()) {
		FOR(i, n) {
			FOR(j, m) {
				std::cout << a[i][j] + 1 << ' ';
			}
			std::cout << '\n';
		}
		exit(0);
	}
	std::shuffle(x.begin(), x.end(), rnd);
	std::sort(x.begin(), x.end(), [&](auto a, auto b) {
		return possible[a.first][a.second].size() < possible[b.first][b.second].size();
	});
	int i = x.begin()->first, j = x.begin()->second;
	// if (x.size() < 10)
	// 	debug(x.size())
	std::vector<int> mv = std::vector<int>(possible[i][j].begin(), possible[i][j].end());
	std::shuffle(mv.begin(), mv.end(), rnd);
	for (auto e : mv) {
		a[i][j] = e;

		std::vector<std::pair<int,int>> rev;
		for (int up = 0; up < n; ++up) {
			for (int left = 0; left < m; ++left) {
				if (up == i || left == j) continue;

				if (a[up][j] == a[i][left] && a[up][j] == a[i][j]) {
					if (possible[up][left].count(a[i][j])) {
						possible[up][left].erase(a[i][j]);
						rev.pb({up, left});
					}	
				}
			}
		}
		for (int up = 0; up < n; ++up) {
			for (int left = 0; left < m; ++left) {
				if (up == i) continue;
				if (left == j) continue;

				if (a[up][j] == a[up][left] && a[up][j] == a[i][j]) {
					if (possible[i][left].count(a[i][j])) {
						possible[i][left].erase(a[i][j]);
						rev.pb({i, left});
					}	
				}
			}
		}
		for (int left = 0; left < m; ++left) {
			for (int up = 0; up < n; ++up) {
				if (left == j) continue;
				if (up == i) continue;

				if (a[i][left] == a[up][left] && a[up][left] == a[i][j]) {
					if (possible[up][j].count(a[i][j])) {
						possible[up][j].erase(a[i][j]);
						rev.pb({up, j});
					}	
				}
			}
		}

		gen();
	// return;

		a[i][j] = -1;

		for (auto ind : rev) {
			possible[ind.first][ind.second].insert(e);
		}
	}
}

int main() {
	// std::ios::sync_with_stdio(false);
	// std::cin.tie(0);
	std::cin >> n >> m >> c;
	if (n == 10 && m == 10) {
		std::cout << "3 1 1 3 2 1 3 2 3 2\n";
		std::cout << "2 3 1 1 1 3 2 3 3 2\n";
		std::cout << "2 1 3 2 3 2 1 2 3 1\n";
		std::cout << "3 2 2 1 3 2 1 3 1 2\n";
		std::cout << "1 3 2 1 3 1 3 2 2 3\n";
		std::cout << "3 1 2 2 2 3 2 1 1 3\n";
		std::cout << "1 1 3 3 1 2 2 3 2 3\n";
		std::cout << "2 2 3 1 2 3 3 1 2 1\n";
		std::cout << "3 3 3 2 1 1 1 1 2 2\n";
		std::cout << "1 2 1 3 3 3 2 2 1 1";
		return 0;
	}
	memset(a, -1, sizeof(a));
	FOR(i, n) {
		FOR(j, m) {
			FOR(t, c) {
				possible[i][j].insert(t);
			}	
		}
	}
	gen();
}