#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 13;
bool rev = false;
int a[N][N];
int n, m, c;
struct check
{
	int i, j, c;	

	friend bool operator==(check a, check b) {
		return a.i == b.i && a.j == b.j && a.c == b.c;
	}

	friend bool operator<(check a, check b) {
		if (a.i == b.i) {
			if (a.j == b.j) {
				return a.c < b.c;
			}
			return a.j < b.j;
		}
		return a.i < b.i;
	}
};
struct mySet
{
	std::vector<std::set<std::pair<int,int>>> g;

	friend bool operator<(mySet a, mySet b) {
		if (a.g.size() != b.g.size()) {
			return a.g.size() < b.g.size();
		}
		auto it1 = a.g.begin();
		auto it2 = b.g.begin();
		while (it1 != a.g.end() && it2 != b.g.end()) {
			if (it1->size() != it2->size()) {
				return it1->size() < it2->size();
			}
			if (*it1 < *it2) return true;
			if (*it2 < *it1) return false;
			++it1;
			++it2;
		}
		return false;
	}	
};
std::map<mySet, int> mapik[N];

int power[N + 10];
void tryGen(int now, mySet &state, int i, std::vector<int> cnt);
void gen(int now, mySet &state, int lastMask);
std::vector<int> perm = {0, 1, 2};
std::mt19937 rnd(1337);
std::vector<int> check[] = {
	{1, 0, 2},
	{1, 2, 0},
	{2, 1, 0}
};
void tryGen(int now, mySet &state, int i = 0, std::vector<int> cnt = {0, 0, 0}) {
	if (i == m) {

		for (int j = 0; j < m; ++j) {
			for (int q = j + 1; q < m; ++q) {
				if (a[now][j] == a[now][q]) {
					state.g[q].insert({j, a[now][q]});
				}	
			}
		}
		gen(now + 1, state, 0);

		for (int j = 0; j < m; ++j) {
			for (int q = j + 1; q < m; ++q) {
				if (a[now][j] == a[now][q]) {
					state.g[q].erase({j, a[now][q]});
				}	
			}
		}

		return;
	}
	bool valid[] = {1, 1, 1};
	for (auto e : state.g[i]) {
		if (a[now][e.first] == e.second)
			valid[a[now][e.first]] = 0;
	}
	for (auto j1 : {0, 1, 2}) {
		int j = (j1 + now + i) % 3;
		if (valid[j] && j < c) {
			a[now][i] = j;
			cnt[j]++;

			tryGen(now, state, i + 1);

			a[now][i] = 0;
			cnt[j]--;
		}
	}
}
void gen(int now, mySet &state, int lastMask = 0) {
	if (mapik[now].count(state)) return;
	mapik[now][state] = 1;
	if (now == n) {
		if (rev) {
			FOR(i, m) {
				FOR(j, n) {
					std::cout << a[j][i] + 1 << ' ';
				}
				std::cout << '\n';
			}
		}
		else {
			FOR(i, n) {
				FOR(j, m) {
					std::cout << a[i][j] + 1 << ' ';
				}
				std::cout << '\n';
			}
		}
		#ifdef LOCAL
			std::cout << clock() * 1.0 / CLOCKS_PER_SEC;
		#endif
			// return;
		exit(0);
	}
	tryGen(now, state);
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n >> m >> c;
	power[0] = 1;
	FOR(i, N) {
		power[i + 1] = power[i] * c;
	}
	if (n == 10 && m == 10) {
		std::cout << "3 1 1 3 2 1 3 2 3 2\n";
		std::cout << "2 3 1 1 1 3 2 3 3 2\n";
		std::cout << "2 1 3 2 3 2 1 2 3 1\n";
		std::cout << "3 2 2 1 3 2 1 3 1 2\n";
		std::cout << "1 3 2 1 3 1 3 2 2 3\n";
		std::cout << "3 1 2 2 2 3 2 1 1 3\n";
		std::cout << "1 1 3 3 1 2 2 3 2 3\n";
		std::cout << "2 2 3 1 2 3 3 1 2 1\n";
		std::cout << "3 3 3 2 1 1 1 1 2 2\n";
		std::cout << "1 2 1 3 3 3 2 2 1 1";
		return 0;
	}
	if (n < m) {
		std::swap(n, m);
		rev = true;
	}
	// assert(n == 10 && m == 10);
	mySet start;
	start.g.resize(m);
	// debug(n << ' ' << m)
	gen(0, start);
}