#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 7e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
ll q;

ll h(ll i) {
	// 1 -> di
	return (m * i * (m * i + 1)) / 2 - (n * m * (m * n + 1) / 2 - (m * i + 1) * m * i / 2);
}

ll v(ll j) {
	// base sum
	ll s = (j + 1) * j / 2;
	// second half
	ll ns = (m * (m + 1)) / 2 - (j * (j + 1)) / 2;
	s *= n, ns *= n;
	ll add = n * (n - 1) / 2 * m;
	s += add * j;
	ns += add * (m - j);
	return s - ns;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	ll t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
//		cout << "H:\n";
		ll diffh = INF, hh;
		ll l = 1, r = n;
		while (r - l > 1) {
			ll m = (l + r) / 2;
			if (h(m) <= 0) {
				l = m;
			}
			else {
				r = m;
			}
		}
		
		for (int i = mmax(1, l - 3); i <= mmin(n - 1, l + 3); ++i) {
			if (mini(diffh, abs(h(i)))) {
				hh = i;
			}
		}

		l = 1, r = m;
		while (r - l > 1) {
			ll m = (l + r) / 2;
			if (v(m) <= 0) {
				l = m;
			}
			else {
				r = m;
			}
		}

		ll diffv = INF;
		ll vv;
		for (int i = mmax(1, l - 3); i <= mmin(m - 1, l + 3); ++i) {
			if (mini(diffv, abs(v(i)))) {
				vv = i;
			}
		}
		if (diffv <= diffh) {
			cout << "V " << vv + 1 << '\n';
		}
		else {
			cout << "H " << hh + 1 << '\n';
		}
	}

	return 0;
}