#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 7e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, k;
ll q;

vector <ll> cur;
vector <bool> used;
vector <ll> m, s;
vector <vector <ll>> a;

void go() {
	if (cur.size() == n) {
		vector <ll> xs;
		ll pref = 0;
		for (int i = 0; i < cur.size(); ++i) {
			for (int j = 0; j < m[cur[i]]; ++j) {
				xs.push_back(pref + a[cur[i]][j]);
			}
			pref += s[cur[i]];
		}
		bool ok = true;
		for (int i = 2; i < xs.size(); ++i) {
			if (xs[i] - xs[i - 1] != xs[i - 1] - xs[i - 2]) {
				// bad
				ok = false;
				break;
			}
		}
		if (ok) {
			cout << "Yes\n";
			for (auto& x : cur) {
				cout << x + 1 << ' ';
			}
			cout << '\n';
			exit(0);
		}
		return;
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			used[i] = true;
			cur.push_back(i);
			go();
			cur.pop_back();
			used[i] = false;
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> n;
	
	m.resize(n);
	a.resize(n);
	s.resize(n);
	used.assign(n, false);
	for (int i = 0; i < n; ++i) {
		cin >> m[i] >> s[i];
		a[i].resize(m[i]);
		for (auto& x : a[i]) {
			cin >> x;
		}
	}
	go();
	cout << "No\n";

	return 0;
}
/*
3
1 7
3
1 8
6
2 8
1 6

1
1 7
5

1
3 10
2 5 9

3
1 5
3
1 3
3
1 6
3

4
1 5
0
1 0
0
1 3
3
1 0 
0
*/