#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 7e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
ll q;

bool check(vector <ll>& a) {
	if (a.size() == 1) return true;
	if (set <ll>(a.begin(), a.end()).size() == 1) return true;
	if (a.back() != a[a.size() - 2]) {
		ll ptr = a.size() - 3;
		while (ptr >= 0) {
			if (a[ptr] != a[a.size() - 2]) return false;
			--ptr;
		}
		return true;
	}
	return false;
}

ll build(vector <ll>& a) {
	ll n = a.back();
	for (int i = a.size() - 2; i >= 0; --i) {
		n = n * 10 + a[a.size() - 2];
	}
	return n;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll beg = clock();

	cin >> n;
	ll x;
	cin >> x;
	if (x == 0) {
		vector <ll> a;
		ll nn = n;
		while (n) {
			a.push_back(n % 10);
			n /= 10;
		}
		ll newnum = 0;
		for (int i = 0; i < a.size(); ++i) {
			newnum = newnum * 10 + a.back();
		}
		if (newnum >= nn) {
			cout << newnum << '\n';
		}
		else {
			if (a.back() == 9) {
				a.pop_back();
				a.push_back(0);
				a.push_back(1);
			}
			else {
				a.back() += 1;
			}
			ll newnum = 0;
			for (int i = 0; i < a.size(); ++i) {
				newnum = newnum * 10 + a.back();
			}
			cout << newnum << '\n';
		}
		return 0;
	}
	else if (x == 1) {
		vector <ll> a;
		ll nn = n;
		while (n) {
			a.push_back(n % 10);
			n /= 10;
		}


		if (check(a)) {
			cout << nn << '\n';
			return 0;
		}

		ll possible = build(a);

		ll ptr = a.size() - 1;
		while (ptr >= 0 && a[ptr] == a.back()) {
			--ptr;
		}
		if (ptr == -1) {
			cout << nn << '\n';
		}
		else if (ptr == 0) {
			cout << nn << '\n';
		}
		else {
			ll ptr2 = ptr - 1;
			while (ptr2 >= 0 && a[ptr2] == a.back()) {
				--ptr2;
			}
			if (ptr2 == -1) {
				cout << nn << '\n';
			}
			else {
				if (a[ptr2] > a.back()) {
					// need +1 in ptr pos
					if (a[ptr] == 9) {
						a[ptr + 1] += 1;
						a[ptr] = mmin(a.back(), a[ptr + 1]);
					}
					else {
						++a[ptr];
					}
					if (ptr && a[ptr] == a.back()) {
						--ptr;
						a[ptr] = 0;
						--ptr;
						while (ptr >= 0) {
							a[ptr] = a.back();
							--ptr;
						}
						ll newnum = 0;
						for (int i = a.size() - 1; i >= 0; --i) {
							newnum = newnum * 10 + a[i];
						}
						if (possible >= nn) mini(newnum, possible);
						cout << newnum << '\n';
					}
					else {
						--ptr;
						while (ptr >= 0) {
							a[ptr] = mmin(a.back(), a[ptr + 1]);
							--ptr;
						}
						ll newnum = 0;
						for (int i = a.size() - 1; i >= 0; --i) {
							newnum = newnum * 10 + a[i];
						}
						if (possible >= nn) mini(newnum, possible);
						cout << newnum << '\n';
					}
				}
				else {
					while (ptr2 >= 0) {
						a[ptr2] = a.back();
						--ptr2;
					}
					ll newnum = 0;
					for (int i = a.size() - 1; i >= 0; --i) {
						newnum = newnum * 10 + a[i];
					}
					if (possible >= nn) mini(newnum, possible);
					cout << newnum << '\n';
				}
			}
		}
	}

	cerr << "Proccess terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";

	return 0;
}
/*
30 12 7
18 1 2021
*/