#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 7e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
ll q;

/*
1 1 1 2 2 2 3 3 3
1 1 2 2 2 3 3 3 1 
1 2 2 2 3 3 3 1 2
2 2 2 3 3 3 1 2 3
2 2 3 3 3 1 2 3 
2 3 3 3 1 2 3
3 3 3 1 2 3 
3 3 1 2 3
3 1 2 3 
*/

bool check(vector <vector <ll>> a) {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			for (int k = i + 1; k < n; ++k) {
				for (int l = j + 1; l < m; ++l) {
					if (a[i][j] == a[i][l] && a[i][j] == a[k][j] &&
						a[i][j] == a[k][l]) {
						cout << "Failed:\n";
						cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << ' ' << l + 1 << '\n';
						return false;
					}
				}
			}
		}
	}
	return true;
}

vector <vector <ll>> kek
{
	{ 1, 1, 2, 2, 3, 3 },
	{ 1, 2, 2, 3, 3, 1 },
	{ 2, 2, 3, 3, 1, 1 },
	{ 2, 3, 3, 1, 1, 2 },
	{ 3, 3, 1, 1, 2, 2 },
	{ 3, 1, 1, 2, 2, 3 }
};

/*
{
	{ 1, 1, 1, 2, 2, 2, 3, 3, 3 },
	{ 1, 1, 2, 2, 2, 3, 3, 3, 1 },
	{ 1, 2, 2, 2, 3, 3, 3, 1, 2 },
	{ 2, 2, 2, 3, 3, 3, 1, 2, 3 },
	{ 2, 2, 3, 3, 3, 1, 2, 3, 1 },
	{ 2, 3, 3, 3, 1, 2, 3, 1, 1 },
	{ 3, 3, 3, 1, 2, 3, 1, 1, 1 },
	{ 3, 3, 1, 2, 3, 1, 1, 1, 2 },
	{ 3, 1, 2, 3, 1, 1, 1, 2, 3 }
};
*/

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll beg = clock();
	
	ll c;
	cin >> n >> m >> c;

	if (c == 3) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				cout << kek[i][j] << ' ';
			}
			cout << '\n';
		}
	}

/*	if (check(kek)) {
		cout << "Ok\n";
	}
	else {
		cout << "No\n";
	}*/

	cerr << "Proccess terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";

	return 0;
}
/*
30 12 7
18 1 2021
*/
//