//
// Created by olymp on 18.01.2021.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

template <typename T>
using vec = vector<T>;

#define int ll

const int MOD = 1e9 + 7;

int pw(int a, int b) {
  int ans = 1;
  while (b > 0) {
    if (b & 1) {
      ans *= a;
      ans %= MOD;
    }
    a *= a;
    a %= MOD;
    b >>= 1;
  }
  return ans;
}

void run() {
  int n;
  string a, b, c;
  cin >> a >> b >> c;
  n = a.size();
  vec<int> fact(n + 10);
  fact[0] = fact[1] = 1;
  for (int i = 2; i < fact.size(); i++) {
    fact[i] = (fact[i - 1] * i) % MOD;
  }
  auto C = [&](int n, int k) {
    return fact[n] * pw(fact[k], MOD - 2) % MOD * pw(fact[n - k], MOD - 2) % MOD;
  };
  int cnt_good = 0, cnt_pr = 0, cnt_suf = 0, cnt_b = 0;
  for (int i = 0; i < n; i++) {
    int ca = a[i] - '0';
    int cb = b[i] - '0';
    int cc = c[i] - '0';
    bool af = false;
    bool pr = false;
    if ((ca + cb) % 10 != cc && (ca + cb + 1) % 10 != cc) {
      cout << "0\n";
      return;
    }
    if ((ca + cb) % 10 != cc && (ca + cb + 1) % 10 == cc) {
      pr = true;
    }
    if ((ca + cb) % 10 != cc) {
      pr = true;
    }
    if ((ca + cb + pr) / 10 == 1) {
      af = true;
    }
    if (!pr && !af)
      cnt_good++;
    if (!pr && af)
      cnt_pr++;
    if (pr && af) {
      cnt_b++;
    }
    if (pr && !af) {
      cnt_suf++;
    }
  }
  if (cnt_suf != cnt_pr || cnt_suf == 0 && cnt_b > 0) {
    cout << "0\n";
    return;
  }
  int ans = fact[cnt_good];
  ans = ans * C(cnt_good + 1 + cnt_suf - 1, cnt_suf) % MOD;
  ans = ans * fact[cnt_suf] % MOD * fact[cnt_suf] % MOD;
  ans = ans * C(cnt_b + cnt_suf - 1, cnt_suf - 1) % MOD;
  ans = ans * fact[cnt_b] % MOD;
  cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  int t = 1;
//  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}