#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <algorithm>
using namespace std;
typedef long long ll;

ll n, m, ob;

ll v(ll x) {
	if (x == 0) {
		return 1e18;
	}
	return ll(abs(n * (x - 1) * (x + m * n - m) - ob));
}

ll h(ll x) {
	if (x == 0) {
		return 1e18;
	}
	return ll(abs(m * (x - 1) * (m * x - m + 1) - ob));
}

int main() {
	ll l, r, x, y1, y2, y3, mv, mh, ot1, ot2;
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		cin >> n >> m;
		ob = n * m * (n * m + 1) / 2;
		l = 1, r = m + 1;
		while (l + 1 < r) {
			x = (l + r) / 2;
			y1 = v(x - 1);
			y2 = v(x);
			y3 = v(x + 1);
			if (y1 <= y2) {
				r = x;
			}
			else if (y3 < y2) {
				l = x + 1;
			}
			else {
				l = x;
				r = l + 1;
			}
		}
		mv = v(l);
		ot1 = l;
		l = 1, r = n + 1;
		while (l + 1 < r) {
			x = (l + r) / 2;
			y1 = h(x - 1);
			y2 = h(x);
			y3 = h(x + 1);
			if (y1 <= y2) {
				r = x;
			}
			else if (y3 < y2) {
				l = x + 1;
			}
			else {
				l = x;
				r = l + 1;
			}
		}
		mh = h(l);
		ot2 = l;
		if (mv <= mh) {
			cout << "V " << ot1 << endl;
		}
		else {
			cout << "H " << ot2 << endl;
		}
	}
}