#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct dna {
	char key;
	int cnt;
	int len;
	long long pos;
	dna(char a, int b) {
		if (b == 0) {
			len = 0;
			key = a;
			cnt = b;
			return;
		}
		key = a;
		cnt = b;
		len = 1;
		if (b > 1) {
			while (b > 0) {
				len++;
				b /= 10;
			}
		}
	}
};

int main()
{
	string s;
	cin >> s;

	vector < dna > a;
	int id = 0;
	int curcnt = 1;
	long long pref = 0;
	while (id < s.size()) {
		long long newnum = 0;
		while (id < s.size() && s[id] >= '0' && s[id] <= '9') {
			newnum *= 10;
			newnum += (s[id] - '0');
			id++;
		}
		if (newnum > 0)
			curcnt = newnum;
		a.push_back({ s[id], curcnt });
		a.back().pos = pref;
		pref += curcnt;
		curcnt = 1;
		id++;
	}
	vector < dna > d = a;

	int length = 0;
	for (int i = 0; i < a.size(); i++) {
		length += a[i].len;
	}

	int mint = 2;
	int minpos = 1;
	long long minlen = 0;
	for (int i = 0; i < a.size(); i++) {
		int temp = a[i].len;
		dna q = dna(a[i].key, a[i].cnt - 1);
		int newlen = q.len;
		long long r = temp - newlen;
		if (q.cnt == 0 && i > 0 && i < a.size() - 1) {
			if (a[i - 1].key == a[i + 1].key) {
				dna w = { a[i - 1].key, a[i - 1].cnt + a[i + 1].cnt };
				r += ((a[i - 1].len + a[i + 1].len) - w.len);
			}
		}
		if (r >= minlen) {
			minlen = r;
			minpos = a[i].pos + 1;
		}
	}
	cout << mint << " " << minpos << "\n";

	int maxt = 1;
	int maxpos = length;
	char toadd = 'A';
	long long maxlen = 1;
	for (int i = 0; i < a.size(); i++) {
		if (a[i].cnt > maxlen) {
			maxlen = a[i].cnt;
			maxpos = a[i].pos;
			if (a[i].key == 'A') {
				toadd = 'C';
			}
			else {
				toadd = 'A';
			}
		}
	}

	cout << maxt << " " << maxpos + (maxlen / 2) << " " << toadd << "\n";
}