#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;

vector < int > order;
vector < bool > used;

vector < pair < long long, int > > st;
vector < pair < long long, int > > fi;

int n;

long long musthave = -1;

bool check() {
    long long key = st[order[0]].first + fi[order[1]].first;
    if (musthave != -1 && key != musthave)
        return false;
    for (int i = 1; i < order.size() - 1; i++) {
        if (st[order[i]].first + fi[order[i + 1]].first != key)
            return false;
    }
    return true;
}

bool ok = false;

void f(int cnt = 0) {
    if (cnt == n) {
        if (check() && !ok) {
            ok = true;
            cout << "Yes\n";
            for (auto e : order) {
                cout << e + 1 << " ";
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = true;
            order.push_back(i);
            f(cnt + 1);
            order.pop_back();
            used[i] = false;
        }
    }
}

int main()
{
    cin >> n;

    set < long long > ltoget;
    int m;
    vector < vector < long long > > l(n);
    vector < long long > s(n);
    for (int i = 0; i < n; i++) {
        cin >> m >> s[i];
        l[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> l[i][j];
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 1; j < l[i].size(); j++) {
            ltoget.insert(l[i][j] - l[i][j - 1]);
        }
    }
    if (ltoget.size() > 1) {
        cout << "No";
        return 0;
    }
    if (ltoget.size() == 1) {
        musthave = *ltoget.begin();
    }

    if (n == 1) {
        cout << "Yes\n1";
        return 0;
    }
    
    long long sts = 0;
    long long fs = 0;
    for (int i = 0; i < n; i++) {
        fi.push_back({ l[i][0], i });
        st.push_back({ s[i] - l[i].back(), i });
    }

    used.assign(n, false);
    f();

    if (!ok) {
        cout << "No";
    }
}