#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int n, m;
int c;
bool fnd = false;

vector < vector < int > > k;

void f(int x, int y) {
	if (fnd)
		return;
	if (x == n) {
		fnd = true;
		for (auto e : k) {
			for (auto ee : e) {
				cout << ee + 1 << " ";
			}
			cout << "\n";
		}
		return;
	}

	for (int i = 0; i < c; i++) {
		bool ok = true;
		for (int j = 0; j < x; j++) {
			if (!ok)
				break;
			for (int t = 0; t < y; t++) {
				if (i == k[x][t] && i == k[j][t] && i == k[j][y]) {
					ok = false;
					break;
				}
			}
		}
		if (ok) {
			k[x][y] = i;
			int nx = x;
			int ny = y + 1;
			if (ny == m) {
				ny = 0;
				nx++;
			}
			f(nx, ny);
		}
	}
}

int main()
{
	map < pair < int, int >, vector < vector < int > > > ans3;

	ans3[{2, 8}] = { { 0, 0, 0, 0, 0, 0, 0, 0 },
					{ 1, 1, 1, 1, 1, 1, 1, 1 } };
	ans3[{2, 9}] = { { 0, 0, 0, 0, 0, 0, 0, 0, 0 },
					{ 1, 1, 1, 1, 1, 1, 1, 1, 1 } };
	ans3[{2, 10}] = { { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
					{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 } };

	ans3[{3, 6}] = { { 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1 },
					 { 0, 1, 2, 2, 2, 2 } };
	ans3[{3, 7}] = { { 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1, 1 },
					 { 0, 1, 2, 2, 2, 2, 2 } };
	ans3[{3, 8}] = { { 0, 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1, 1, 1 },
					 { 0, 1, 2, 2, 2, 2, 2, 2 } };
	ans3[{3, 9}] = { { 0, 0, 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1, 1, 1, 1 },
					 { 0, 1, 2, 2, 2, 2, 2, 2, 2 } };
	ans3[{3, 10}] = { { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
					 { 0, 1, 2, 2, 2, 2, 2, 2, 2, 2 } };

	ans3[{4, 4}] = { { 0, 0, 0, 0 },
					 { 0, 1, 1, 1 },
					 { 0, 1, 2, 2 },
					 { 0, 2, 1, 2 } };

	ans3[{4, 5}] = { { 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1 },
					 { 0, 1, 2, 2, 2 },
					 { 1, 2, 0, 1, 2 } };

	ans3[{4, 6}] = { { 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1 },
					 { 1, 0, 1, 2, 2, 2 },
					 { 1, 2, 2, 0, 1, 2 } };

	ans3[{4, 7}] = { { 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1, 2 },
					 { 1, 0, 1, 2, 2, 2, 1 },
					 { 1, 2, 2, 0, 1, 2, 2 } };

	ans3[{4, 8}] = { { 0, 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1, 2, 2 },
					 { 1, 0, 1, 2, 2, 2, 1, 1 },
					 { 2, 2, 2, 0, 1, 2, 1, 2 } };

	ans3[{4, 9}] = { { 0, 0, 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 1, 2, 2, 2 },
					 { 1, 0, 1, 2, 2, 2, 1, 1, 2 },
					 { 2, 2, 2, 0, 1, 2, 1, 2, 1 } };

	ans3[{4, 10}] = { { 0, 0, 0, 0, 0, 0, 0, 0, 0, 3444 },
					 { 0, 1, 1, 1, 1, 1, 2, 2, 2, 3444 },
					 { 1, 0, 1, 2, 2, 2, 1, 1, 2, 3444 },
					 { 2, 2, 2, 0, 1, 2, 1, 2, 1, 3444 } };

	ans3[{5, 5}] = { { 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1 },
					 { 0, 1, 2, 2, 2 },
					 { 1, 2, 0, 1, 2 },
					 { 1, 2, 0, 2, 1 } };

	ans3[{5, 6}] = { { 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 2 },
					 { 0, 1, 2, 2, 2, 1 },
					 { 1, 2, 0, 1, 2, 1 },
					 { 1, 2, 0, 2, 1, 2 } };

	ans3[{5, 7}] = { { 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 2, 2 },
					 { 0, 1, 2, 2, 2, 1, 1 },
					 { 1, 2, 0, 1, 2, 1, 2 },
					 { 1, 2, 0, 2, 1, 2, 1 } };

	ans3[{5, 8}] = { { 0, 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 2, 2, 2 },
					 { 0, 1, 2, 2, 2, 1, 1, 2 },
					 { 1, 2, 0, 1, 2, 1, 2, 1 },
					 { 2, 2, 0, 2, 1, 2, 1, 1 } };

	ans3[{5, 9}] = { { 0, 0, 0, 0, 0, 0, 0, 0, 344 },
					 { 0, 1, 1, 1, 1, 2, 2, 2, 344 },
					 { 0, 1, 2, 2, 2, 1, 1, 2, 344 },
					 { 1, 2, 0, 1, 2, 1, 2, 1, 344 },
					 { 2, 2, 0, 2, 1, 2, 1, 1, 344 } };

	ans3[{6, 6}] = { { 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 1, 2 },
					 { 0, 1, 2, 2, 2, 1 },
					 { 1, 2, 0, 1, 2, 1 },
					 { 1, 2, 0, 2, 1, 2 },
					 { 2, 2, 2, 0, 1, 1 } };

	ans3[{6, 7}] = { { 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 2, 2, 2 },
					 { 0, 1, 2, 2, 1, 1, 2 },
					 { 1, 2, 0, 2, 1, 2, 1 },
					 { 1, 2, 2, 1, 2, 1, 0 },
					 { 2, 0, 1, 2, 2, 1, 1 } };

	ans3[{6, 8}] = { { 0, 0, 0, 0, 0, 0, 0, 1 },
					 { 0, 1, 1, 1, 2, 2, 2, 0 },
					 { 1, 1, 2, 2, 0, 1, 2, 0 },
					 { 1, 2, 1, 2, 1, 2, 0, 0 },
					 { 1, 2, 2, 1, 2, 0, 1, 0 },
					 { 2, 0, 1, 2, 2, 1, 1, 0 } };

	ans3[{7, 7}] = { { 0, 0, 0, 0, 0, 0, 0 },
					 { 0, 1, 1, 1, 2, 2, 2 },
					 { 0, 1, 2, 2, 1, 1, 2 },
					 { 1, 2, 1, 2, 1, 2, 0 },
					 { 1, 2, 2, 1, 2, 1, 0 },
					 { 2, 0, 1, 2, 2, 1, 1 },
					 { 2, 0, 2, 1, 1, 2, 1 } };

	ans3[{7, 8}] = { { 0, 0, 0, 0, 0, 0, 0, 1 },
					 { 0, 1, 1, 1, 2, 2, 2, 0 },
					 { 1, 1, 2, 2, 0, 1, 2, 0 },
					 { 1, 2, 1, 2, 1, 2, 0, 0 },
					 { 1, 2, 2, 1, 2, 0, 1, 0 },
					 { 2, 0, 1, 2, 2, 1, 1, 0 },
					 { 2, 1, 2, 0, 1, 2, 1, 0 } };

	cin >> n >> m;
	cin >> c;
	k.assign(n, vector < int >(m, -1));
	if (c == 2 || (c == 3 && n * m <= 15)) {
		f(0, 0);
		return 0;
	}

//	f(0, 0);return 0;

	vector < vector < int > > ans;
	bool rev = false;
	if (n > m) {
		swap(n, m);
		rev = true;
	}
	ans = ans3[{n, m}];
	if (rev) {
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				cout << ans[i][j] + 1 << " ";
			}
			cout << "\n";
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << ans[i][j] + 1 << " ";
			}
			cout << "\n";
		}
	}
}