#include <iostream>
#include <vector>

using namespace std;
vector<pair<int, int>> a;
vector<int> now;
int n, delta = -1;

void check() {
    int last = -1;
    for (int i = 0; i < n - 1; ++i) {
        if (last == -1) {
            last = a[now[i]].second + a[now[i + 1]].first;
        } else if (last != a[now[i]].second + a[now[i + 1]].first) {
            return;
        }
    }
    if (n != 1 && last != delta && delta != -1) {
        return;
    }
    cout << "Yes" << '\n';
    for (auto elem: now) {
        cout << elem + 1 << ' ';
    }
    exit(0);
}

vector<int> used;

void f(int l = 0) {
    if (l == 0) {
        check();
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            used[i] = 1;
            now.push_back(i);
            f(l - 1);
            now.pop_back();
            used[i] = 0;
        }
    }
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> n;

    for (int _ = 0; _ < n; ++_) {
        int m, s;
        cin >> m >> s;
        int last = 0;
        pair<int, int> temp;
        for (int i = 0; i < m; ++i) {
            int x;
            cin >> x;
            if (i == 0) {
                temp.first = x;
            }
            if (i == m - 1) {
                temp.second = s - x;
            }
            if (i != 0 && delta == -1) {
                delta = x - last;
            } else if (i != 0 && x - last != delta) {
                cout << "No";
                return 0;
            }
            last = x;
        }
        a.push_back(temp);
    }
    used.resize(n, 0);
    f(n);
    cout << "No";
    return 0;
}

/*
3
1 7
3
1 8
6
2 8
1 6
 */