#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <deque>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using mset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

int r() {
    int ans = rand();
    for (int i = 0; i < rand() % 3; ++i) {
        ans = rand();
    }
    return ans;
}

signed main() {
    int n, m, c;
    cin >> n >> m >> c;
    vector<vector<int>> tab(n, vector<int> (m, 1));
    //i1, j16
    for (int k = 0; k < 1000; ++k)
    for (int i1 = 0; i1 < n; i1++) {
        for (int j1 = 0; j1 < m; j1++) {
            //i2, j2
            for (int i2 = i1 + 1; i2 < n; i2++) {
                int j2 = j1;
                //i3, j3
                for (int j3 = j2 + 1; j3 < m; j3++) {
                    int i3 = i2;
                    //i4, j4
                    int i4 = i1, j4 = j3;
                    vector<pair<int, int>> v = {{i1, j1}, {i2, j2}, {i3, j3}, {i4, j4}};
                    if (tab[i1][j1] == tab[i2][j2] && tab[i3][j3] == tab[i2][j2] && tab[i4][j4] == tab[i3][j3]) {
                        auto x = v[r() % 4];
                        int nw = r() % c + 1;
                        while (nw == tab[i1][j1]) nw = r() % c + 1;
                        //cout << nw << " " << r() << endl;
                        tab[x.first][x.second] =  nw;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << tab[i][j] << " ";
        }
        cout << endl;
     }
}
