#include <iostream>
#include <vector>

using namespace std;

#define int long long

int n, m;

pair<int, int> cntv(int x) {
    int v1 = n*x*(x + 1 + m*(n - 1))/2;
    int v2 = n*m*(n*m + 1)/2 - v1;
    return {v1, v2};
}

pair<int, int> cnth(int x) {
    int v1 = x*m*(x*m + 1)/2;
    int v2 = n*m*(n*m + 1)/2 - v1;
    return {v1, v2};
}

signed main() {
    int t;
    cin >> t;
    for (int q = 0; q < t; ++q) {
        cin >> n >> m;
        /**vector<vector<int>> a(n, vector<int>(m));
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                a[i][j] = i * m + j + 1;
            }
        }
        //for (int i = 0; i < n; ++i) {
        //    for (int j = 0; j < m; ++j) {
        //        cout << a[i][j] << '\t';
        //    }
        //    cout << '\n';
        //}**/

        int l = 0;
        int r = m + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            pair<int, int> ans = cntv(m);
            // cout << "(" << l << ", " << m << ", " << r << ") " << ans.first << ' ' << ans.second << '\n';
            if (ans.first < ans.second) {
                l = m;
            } else {
                r = m;
            }
        }
        // pair<int, int> ans = cntv(r);
        // cout << "(" << l << ", " << r << ") " << ans.first << ' ' << ans.second << '\n';
        int ans1;
        {
            pair<int, int> ansa = cntv(l);
            pair<int, int> ansb = cntv(r);
            if (std::abs(ansa.first - ansa.second) < std::abs(ansb.first - ansb.second)) {
                ans1 = l;
            } else {
                ans1 = r;
            }
        }

        l = 0;
        r = n + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            pair<int, int> ans = cnth(m);
            // cout << "(" << l << ", " << m << ", " << r << ") " << ans.first << ' ' << ans.second << '\n';
            if (ans.first < ans.second) {
                l = m;
            } else {
                r = m;
            }
        }
        // ans = cnth(r);
        // cout << "(" << l << ", " << r << ") " << ans.first << ' ' << ans.second << '\n';
        int ans2;
        {
            pair<int, int> ansa = cnth(l);
            pair<int, int> ansb = cnth(r);
            if (std::abs(ansa.first - ansa.second) < std::abs(ansb.first - ansb.second)) {
                ans2 = l;
            } else {
                ans2 = r;
            }
        }

        pair<int, int> v1 = cntv(ans1);
        pair<int, int> v2 = cnth(ans2);
        if (std::abs(v2.second - v2.first) < std::abs(v1.second - v1.first)) {
            // TODO: extra check
            cout << "H " << ans2 + 1 << '\n';
        } else {
            cout << "V " << ans1 + 1 << '\n';
        }
    }
}
