#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
#include <cassert>
#include <tuple>
#include <random>
#include <ctime>

#define int long long

using namespace std;

int next(int x, int c) {
    if (c == 2) {
        return x ^ 1 ^ 2;
    } else {
        if (x == 1) {
            return 2;
        }
        if (x == 2) {
            return 3;
        }
        if (x == 3) {
            return 1;
        }
    }
    cout << 1 / 0;
}

signed main() {
    srand(time(0));
    int n, m, c;
    cin >> n >> m >> c;

    vector<vector<int>> a(n, vector<int>(m, 1));

    bool chan = 1;
    while (chan) {
        chan = 0;
        for (int i = 0; i < n * m; ++i) {
            for (int j = 0; j < n * m; ++j) {
                int x1 = i % n;
                int x2 = j % n;
                int y1 = i / n;
                int y2 = j / n;
                if (x1 == x2 || y1 == y2) {
                    continue;
                }
                // cout << ">>" << i << ' ' << j << ' ' << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << '\n';
                // cout << ">>" << a[x1][y1] << ' ' << a[x1][y2] << ' ' << a[x2][y1] << ' ' << a[x2][y2] << '\n';
                vector<pair<int, int>> cell = {{x1, y1}, {x1, y2}, {x2, y1}, {x2, y2}};
                vector<int> cnt(3, 0);
                for (const pair<int, int> tmp : cell) {
                    int x, y;
                    tie(x, y) = tmp;
                    ++cnt[a[x][y]];
                }
                int ma = max_element(cnt.begin(), cnt.end()) - cnt.begin();
                // cout << ">>>>" << cnt[ma] << '\n';
                if (cnt[ma] != 4) {
                    continue;
                }
                {
                    int x, y;
                    tie(x, y) = cell[0];
                    a[x][y] = next(a[x][y], c);
                    chan = 1;
                }
                /**for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        cout << a[i][j] << ' ';
                    }
                    cout << '\n';
                }**/
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << a[i][j] << ' ';
        }
        cout << '\n';
    }
}

