#include <bits/stdc++.h>

using namespace std;

int cnt[4];

const int mod = 1e9 + 7;

long long bin(long long x, long long n) {
    if (n == 0) {
        return 1;
    }
    if (n == 1) {
        return 0;
    }
    if (n % 2 == 0) {
        return bin((x * x) % mod, n / 2);
    }
    return ((bin((x * x) % mod, n / 2)) * x) % mod;
}

long long f(long long x) {
    long long ans = 1;
    if (x == 0) {
        return 0;
    }
    for (long long i = 1; i <= x; i++) {
        ans *= i;
        ans %= mod;
    }
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string a, b, c;
    cin >> a >> b >> c;
    int len = a.size();
    for (int i = 0; i < len; i++) {
        int A = a[i] - '0';
        int B = b[i] - '0';
        int C = c[i] - '0';
        if (A + B == C) {
            cnt[0]++;
            continue;
        }
        if (A + B + 1 == C) {
            cnt[1]++;
            continue;
        }
        if ((A + B) % 10 == C) {
            cnt[2]++;
            continue;
        }
        if ((A + B + 1) % 10 == C) {
            cnt[3]++;
            continue;
        }
        cout << 0;
        return 0;
    }

    if (abs(cnt[1] - cnt[2]) > 1) {
        cout << 0;
        return 0;
    }

    long long ans = 0;

    if (cnt[1] == 0 && cnt[2] == 0 && cnt[3] == 0) {
        cout << f(cnt[0]);
        return 0;
    }

    if (cnt[0] >= 1 && cnt[1] >= 1) {
        ans = bin(cnt[3], cnt[2]) * bin(cnt[0] - 1, cnt[1]);
        ans %= mod;
    }

    if (cnt[2] >= 1) {
        ans += bin(cnt[3], cnt[2]) * bin(cnt[0], cnt[1]);
        ans %= mod;
    }

    if (cnt[0] >= 2 && cnt[1] >= 1 && cnt[2] >= 1) {
        ans += bin(cnt[3], cnt[2] - 1) * bin(cnt[0] - 2, cnt[1]);
        ans %= mod;
    }

    if (cnt[0] >= 1 && cnt[2] >= 1) {
        ans += bin(cnt[3], cnt[2] - 1) * bin(cnt[0] - 1, cnt[1]);
        ans %= mod;
    }
    cout << ans;
    return 0;
}
