//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <assert.h>
#include <map>

using namespace std;

/*
const int mx_MEM = 2 * 1e8;
int mpos = 0;
char mem[mx_MEM];

inline void *operator new(size_t n) {
    assert((mpos += n) <= mx_MEM);
    return (void *) (mem + mpos - n);
}

inline void operator delete(void *) noexcept {}
*/

#define int long long

int n;
vector<vector<int> > ms;
vector<int> d;

vector<int> pereb;
vector<int> used;

void f(int cur) {
    if (cur == n) {
        int cnt = 0;
        vector<int> vt;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < ms[pereb[i]].size(); ++j) {
                vt.push_back(cnt + ms[pereb[i]][j]);
            }
            cnt += d[pereb[i]];
        }
        if (n == 1) {
            cout << "Yes\n";
            cout << "1";
            exit(0);
        }
        cnt = vt[1] - vt[0];
        for (int k = 1; k < vt.size(); ++k) {
            if (vt[k] - vt[k - 1] != cnt) {
                return;
            }
        }
        cout << "Yes\n";
        for (int l = 0; l < n; ++l) {
            cout << pereb[l] + 1 << " ";
        }
        exit(0);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            pereb[cur] = i;
            used[i] ^= 1;
            f(cur + 1);
            used[i] ^= 1;
        }
    }
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    ms.resize(n);
    d.resize(n);
    for (int i = 0; i < n; ++i) {
        int m, s;
        cin >> m >> s;
        ms[i].resize(m);
        for (int j = 0; j < m; ++j) {
            cin >> ms[i][j];
        }
        d[i] = s;
    }

    pereb.resize(n);
    used.resize(n);
    for (int k = 0; k < n; ++k) {
        pereb[k] = 0;
        used[k] = 0;
    }

    f(0);
    cout << "No";

    return 0;
}
