//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <assert.h>
#include <map>

using namespace std;

/*
const int mx_MEM = 2 * 1e8;
int mpos = 0;
char mem[mx_MEM];

inline void *operator new(size_t n) {
    assert((mpos += n) <= mx_MEM);
    return (void *) (mem + mpos - n);
}

inline void operator delete(void *) noexcept {}
*/

#define int long long

int mod = 1e9 + 7;

int mult(int a, int b) {
    a %= mod;
    b %= mod;
    return (a * b) % mod;
}

int fact(int x) {
    int ans = 1;
    for (int i = 2; i <= x; ++i) {
        ans = mult(ans, i);
    }
    return ans;
}

int obr(int st, int deg) {
    if (deg == 0) return 1;
    int k = deg / 2;
    int x = obr(st, k);
    if (deg % 2 == 0) {
        return mult(x, x);
    } else {
        return mult(x, mult(x, st));
    }
}

int c0(int n, int k) {
    if (k <= 0) return 1;
    if (n < 0) return 1;
    int a = fact(n);
    int b = mult(fact(n - k), fact(k));
    b = obr(b, mod - 2);
    return mult(a, b);
}

void stop() {
    cout << 0;
    exit(0);
}

int sum(int a, int b) {
    a %= mod;
    b %= mod;
    return (a + b + 2 * mod) % mod;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.size();
    int x = 0, y = 0, t1 = 0, t2 = 0;
    int t0 = 0;
    int y0 = 0;
    for (int i = 0; i < n; ++i) {
        int p = a[i] - '0';
        int q = b[i] - '0';
        int r = c[i] - '0';
        if (p + q == r) {
            if (p == 0 || q == 0 || r == 0) y0++;
            y++;
        } else if (p + q == r + 10) t2++;
        else if (p + q + 1 == r) {
            if (p == 0 || q == 0 || r == 0) t0++;
            t1++;
        } else if (p + q + 1 == r + 10) x++;
        else {
            stop();
        }
    }
    if (t1 != t2) {
        stop();
    } else {
        int t = t1;
        if (t == 0 && x != 0) {
            stop();
        }

        if (y == y0 && t1 == t0) {
            stop();
        }
        int cons = mult(fact(x), c0(x + t - 1, x));

        int cur = mult(fact(t), mult(t1 - t0, fact(t - 1)));
        cur = mult(cur, mult(fact(y), c0(y + t - 1, t - 1)));
        int first = mult(cur, cons);

        cur = mult(fact(t), fact(t));
        cur = mult(cur, y - y0);
        cur = mult(cur, mult(fact(y + y0 - 1), c0(y - 1 + t - 1, t - 1)));
        int second = mult(cur, cons);

        cout << sum(first, second);
    }
    return 0;
}
