#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <iomanip>
#include <math.h>
#include <string>

using namespace std;

int n;

long long dk(int pr, int d, int a1, int a2, int a3, int a4, int i) {
	if (i == n )return 1;
	long long s = 0;
	if (pr == 0) {
		if (a1 > 0)s += a1 * dk(0, 0, a1 - 1, a2, a3, a4, i + 1);
		if (a3 > 0)s += a3 * dk(1, 0, a1, a2, a3 - 1, a4, i + 1);
	}
	else {
		if (a2 > 0)s += a2 * dk(0, 1, a1, a2 - 1, a3, a4, i + 1);
		if (a4 > 0)s += a4 * dk(1, 1, a1, a2, a3, a4 - 1, i + 1);
	}
	return s;
}

int main() {
	string a, b, c;
	cin >> a >> b >> c;
	n = a.size();
	int a1 = 0, a2 = 0, a3 = 0, a4 = 0;
	for (int i = 0; i < a.size(); ++i) {
		int ab = a[i] - 48, bb = b[i] - 48, cb = c[i] - 48;
		if (ab + bb == cb)a1 += 1;
		else if (ab + bb + 1 == cb)a3 += 1;
		else if ((ab + bb) % 10 == cb)a2 += 1;
		else if ((ab + bb + 1) % 100 == cb)a4 += 1;
		else {
			cout << 0;
			return 0;
		}
	}
	//cout << a1 << " " << a2 << " " << a3 << " " << a4 << endl;
	cout << dk(0, 0, a1, a2, a3, a4, 0) % long long(1e9 + 7);
}
/*
int main() {
	int n, m, c;
	cin >> n >> m >> c;
	vector<vector<int>> a(n, vector<int>(m, c));
	vector<vector<vector<vector<int>>>> cl(n, vector<vector<vector<int>>>(m, vector<vector<int>>(n, vector<int>(m))));
	int gg = 1;
	while (gg == 1) {
	//	cout << 1 << endl;
		gg = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				for (int q = i + 1; q < n; ++q) {
					for (int e = j + 1; e < m; ++e) {
						if (a[i][j] == a[i][e] && a[i][j] == a[q][j] && a[i][j] == a[q][e]) {
							gg = 1;
							cl[i][j][q][e] += 1;
							if (cl[i][j][q][e] % 4 == 0)a[i][j] = a[i][j] % c + 1;
							else if (cl[i][j][q][e] % 4 == 3)a[i][e] = a[i][e] % c + 1;
							else if (cl[i][j][q][e] % 4 == 1)a[q][j] = a[q][j] % c + 1;
							else a[q][e] = a[q][e] % c + 1;
						}
					}
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)
			cout << a[i][j] << " ";
		cout << endl;
	}
}
*/
/*
int main() {
	long long d, m, w, i, j, k;
	cin >> d >> m >> w >> i >> j >> k;
	long long e = i + (j - 1) * d + (k - 1) * d * m;
	//cout << e << endl;
	cout << char((e - 1) % w + 97);
}
*/