#include <iostream>
#include <stdio.h>
#define ull unsigned long long

using namespace std;

ull n, m;

double j(ull x) {
	return (double)(x + 1) * n + (double)m * (n - 1) * n / 2;
}
double sum_j(ull x) {
	return (j(0) + j(x - 1)) * x / 2;
}
double i(ull x) {
	return (double)x*m*m + (m + 1)*m / 2;
}
double sum_i(ull x) {
	return (i(0) + i(x - 1)) * x / 2;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;

	double naim, nm, cur;
	ull x, l, r;
	char orient;
	while (t--) {
		cin >> n >> m;
		naim = 1e10 * 1e10;
		nm = n * m; nm *= (nm + 1); nm /= 2;
		x = 0;

		l = 0, r = m;
		while (l < r) {
			int mid = (l + r) / 2;
			if (sum_j(mid) * 2 - nm > 0.0)
				r = mid;
			else
				l = mid + 1;
		}
		orient = 'V';
		for (ull edge = max(0ull, r - 1); edge < min(m, r + 2); ++edge) {
			cur = abs(sum_j(edge) * 2 - nm);
			if (cur < naim) {
				naim = cur;
				x = edge;
			}
		}

		ull l = 0, r = n;
		while (l < r) {
			int mid = (l + r) / 2;
			if (sum_i(mid) * 2 - nm > 0.0)
				r = mid;
			else
				l = mid + 1;
		}
		for (ull edge = max(0ull, r - 1); edge < min(n, r + 2); ++edge) {
			cur = abs(sum_i(edge) * 2 - nm);
			if (cur < naim) {
				naim = cur;
				x = edge;
				orient = 'H';
			}
		}

		cout << orient << ' ' << x + 1 << '\n';
	}

}
