// #include "pch.h"
#define max(X, Y) (X > Y ? X : Y)
#include <iostream>
#include <stdio.h>
#include <cstring>
#include <vector>
#include <map>

using namespace std;

vector<int> *g;
vector<int> *gr;
bool *used;
int *to;

int dfs(int u, int len) {
	used[u] = true;
	to[u] = -1;
	int ma = 0, cur;
	for (auto v : g[u]) {
		if (used[v])
			continue;
		cur = dfs(v, len + 1);
		if (cur > ma) {
			ma = cur;
			to[u] = v;
		}
	}
	return ma;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	int *m = new int[n];
	int *s = new int[n];
	int **p = new int*[n];
	int cur, *row;
	for (int i = 0; i < n; ++i) {
		cin >> cur >> s[i];
		m[i] = cur;
		row = p[i];
		row = new int[cur];
		for (int j = 0; j < cur; ++j)
			cin >> row[j];
	}

	map<int, vector<int> > left;
	map<int, vector<int> > right;
	bool f = false;
	int freq;
	for (int i = 0; i < n; ++i) {
		cur = m[i];
		row = p[i];
		// if (!left.count(row[0])) left.emplace(row[0]);
		left[row[0]].push_back(i);
		// if (!right.count(s[i] - row[cur - 1])) right.emplace();
		right[s[i] - row[cur - 1]].push_back(i);
		if (cur == 1)
			continue;
		if (!f) {
			freq = row[1] - row[2];
			f = true;
		}
		for (int j = 1; j < cur; ++j)
			if (row[j] - row[j - 1] != freq) {
				cout << "No\n";
				return 0;
			}
	}

	g = new vector<int>[n];
	gr = new vector<int>[n];
	vector<int> *lst;
	for (int i = 0; i < n; ++i) {
		cur = freq - p[i][0];
		if (!right.count(cur)) {
			// cout << "No\n";
			// return 0;
			continue;
		}
		lst = &g[i];
		for (auto j : right[cur]) {
			lst->push_back(j);
			gr[j].push_back(i);
		}
	}

	used = new bool[n];
	memset(used, 0, n);
	to = new int[n];
	int res = -1;
	for (int i = 0; i < n; ++i) {
		if (!used[i])
			cur = dfs(i, 0);
		if (cur == n) {
			res = i;
			break;
		}
	}

	if (res == -1) {
		cout << "No\n";
		return 0;
	}
	cout << "Yes\n";
	for (int i = res; to[i] != -1; i = to[i])
		cout << i << ' ';
	cout << '\n';
}
