#include <iostream>
#include <stdio.h>
#include <string>
#define mod 1000000007ull
#define ull unsigned long long

using namespace std;

ull solve(ull n0e0, ull n1e0, ull n0e1, ull n1e1, ull carry) {
    if(carry) {
        if(n1e0 + n1e1 == 1 && n0e0 + n0e1 == 0)
            return 1;
        if(n1e0 + n1e1 == 0)
            return 0;
        return (((solve(n0e0, n1e0-1, n0e1, n1e1, 0) * n1e0) % mod) +
               ((solve(n0e0, n1e0, n0e1, n1e1-1, 1) * n1e1) % mod)) % mod;
    }
    else {
        if(n0e0 + n0e1 == 1 && n1e0 + n1e1 == 0)
            return 1;
        if(n0e0 + n0e1 == 0)
            return 0;
        return (((solve(n0e0-1, n1e0, n0e1, n1e1, 0) * n0e0) % mod) +
               ((solve(n0e0, n1e0, n0e1-1, n1e1, 1) * n0e1) % mod)) % mod;
    }
}

int main() {
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.length();

    ull // n0e0z = 0, n1e0z = 0, n0e1z = 0, n1e1z = 0,
        n0e0 = 0, n1e0 = 0, n0e1 = 0, n1e1 = 0, cur;
    bool need, carry, zero;
    for(int i = 0; i < n; ++i) {
        cur = a[i] - '0' + b[i] - '0';
        carry = cur > 9;
        if(cur % 10 == c[i] - '0')
            need = false;
        else if((cur + 1) % 10 == c[i] - '0')
            need = true;
        else {
            cout << 0 << '\n';
            return 0;
        }
        zero = c[i] == '0';
        if(need) {
            if(carry) {
                // if(zero) ++n1e1z;
                // else
                    ++n1e1;
            } else {
                // if(zero) ++n1e0z;
                // else
                    ++n1e0;
            }
        } else {
            if(carry) {
                // if(zero) ++n0e1z;
                // else
                    ++n0e1;
            } else {
                // if(zero) ++n0e0z;
                // else
                    ++n0e0;
            }
        }
    }

    ull res = solve(n0e0, n1e0, n0e1, n1e1, 0);

    cout << res << '\n';
}
