#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <cstring>
#define mod 1000000007ull
#define ull unsigned long long
#define pb push_back

using namespace std;

vector<int> cnt;
vector<vector<bool> > matrix;

ull solve(int u, int len) {
    if(len == 1){
        if((u & 1) | (u & 2)) return 0;
        if(cnt[u] == 0) return 0;
        return 1;
    }
    --len;
    --cnt[u];
    ull rez = 0;
    for(int v = 0; v < 8; ++v)
        if(matrix[u][v])
            rez = (rez + (solve(v, len) * cnt[v]) % mod) % mod;
    ++cnt[u];
    // cout << "solve " << u << ' ' << len + 1 << ' ' << rez << '\n';
    return rez;
}

int main() {
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.length();

    vector<bool> e0matrix = {1, 1, 1, 1, 0, 0, 0, 0};
    vector<bool> e1matrix = {0, 0, 0, 0, 1, 1, 1, 1};
    matrix = {e0matrix, e0matrix, e1matrix, e1matrix, e0matrix, e0matrix, e1matrix, e1matrix};
    cnt.assign(8, 0);
    int cur;
    bool need, carry, zero;
    for(int i = 0; i < n; ++i) {
        cur = a[i] - '0' + b[i] - '0';
        carry = cur > 9;
        if(cur % 10 == c[i] - '0')
            need = false;
        else if((cur + 1) % 10 == c[i] - '0')
            need = true;
        else {
            cout << 0 << '\n';
            return 0;
        }
        zero = c[i] == '0';
        if(need) {
            if(carry) {
                if(zero) ++cnt[0b111];
                else ++cnt[0b110];
            } else {
                if(zero) ++cnt[0b101];
                else ++cnt[0b101];
            }
        } else {
            if(carry) {
                if(zero) ++cnt[0b011];
                else ++cnt[0b010];
            } else {
                if(zero) ++cnt[0b001];
                else ++cnt[0b000];
            }
        }
    }
/*
    cout << "cnt: ";
    for(int v = 0; v < 8; ++v)
        cout << cnt[v] << ' ';
    cout << '\n';
*/
    ull rez = 0;
    for(int v = 0; v < 8; ++v)
        if((v & 4) == 0)
            rez = (rez + (solve(v, n) * cnt[v]) % mod) % mod;

    cout << rez << '\n';
}
