#include <bits/stdc++.h>
using namespace std;

template<typename T> void uin(T & a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T & a, T b) {
	if (b > a) {
		a = b;
	}
}

#define int long long

const int INF = 1e18 + 228;

bool is_digit(char c) {
	return '0' <= c && c <= '9';
}

int get_len(int x) {
	if (x == 0 || x == 1) return 0;
	int res = 0;
	while (x) {
		++res;
		x /= 10;
	}
	return res;
}

string s;
vector< pair<int, char> > v;

void getMin() {
	int type = 2, before = 1;

	int delta = 0;
	int sz = (int)v.size();
	int bef = 0;
	for (int i = 0; i < sz; ++i) {
		// try to delete 1 symbol from block i

		if (v[i].first == 1) {
			int old = 0;
			int nw = 0;

			old += 2;
			if (i > 0) {
				old += 1 + get_len(v[i - 1].first);
			}
			if (i + 1 < sz) {
				old += 1 + get_len(v[i + 1].first);
			}
			int all_len = v[i].first;
			if (i > 0) {
				if (v[i - 1].second != v[i].second) {
					old += 1 + get_len(v[i - 1].first);
				} else {
					all_len += v[i - 1].first;
				}
			}
			if (i + 1 < sz) {
				if (v[i + 1].second != v[i].second) {
					old += 1 + get_len(v[i + 1].first);
				} else {
					all_len += v[i + 1].first;
				}
			}
			old += get_len(all_len);
			old += 1;

			if (old - nw > delta) {
				delta = old - nw;
				type = 2; // DELETE
				before = bef + 1;
			}
		} else {
			if (get_len(v[i].first) - get_len(v[i].first - 1) > delta) {
				delta = get_len(v[i].first) - get_len(v[i].first - 1);
				type = 2; // DELETE
				before = bef + 1;
			}
		}
		bef += v[i].first;
	}

	cout << type << " " << before << '\n';
}

string out() {
	string res = "";
	for (auto p : v) {
		for (int i = 0; i < p.first; ++i) {
			res += p.second;
		}
	}
	return res;
}

int get_val(string s) {
	int sz = (int)s.size();
	int i = 0;
	int res = 0;
	while (i < sz) {
		int j = i;
		while (j + 1 < sz && s[j + 1] == s[j]) ++j;
		res += get_len(j - i + 1) + 1;
		i = j + 1;
	}
	return res;
}

void getMax() {
	string t = out();
	int sz = (int)t.size();
	int ans = 0;
	int type = 3, pos = 1;
	char symb = 'A';
	for (int i = 0; i < sz; ++i) {
		char old_c = t[i];
		for (char c : {'A', 'G', 'C', 'T'}) {
			t[i] = c;
			if (get_val(t) > ans) {
				ans = get_val(t);
				type = 3;
				pos = i + 1;
				symb = c;
			}
		}
		t[i] = old_c;

		for (char c : {'A', 'G', 'C', 'T'}) {
			string new_t = t.substr(0, i) + c + t.substr(i, sz - i);
			if (get_val(new_t) > ans) {
				ans = get_val(new_t);
				type = 1;
				pos = i;
				symb = c;
			}
		}
	}

	cout << type << " " << pos << " " << symb << endl;
}

void solve() {
	cin >> s;
	int n = (int)s.size();

	{
		int i = 0;
		int cur_len = 0;
		while (i < n) {
			if (is_digit(s[i])) {
				int len = 0;
				len = len * 10 + (s[i] - '0');
				int j = i;
				while (j + 1 < n && is_digit(s[j + 1])) {
					len = len * 10 + (s[j + 1] - '0');
					++j;
				}
				cur_len = len;
				i = j + 1;
			} else {
				if (cur_len == 0) {
					v.emplace_back(1, s[i]);
				} else {
					v.emplace_back(cur_len, s[i]);
				}
				cur_len = 0;
				++i;
			}
		}
	}

	getMin();
	getMax();
}

signed main() {
	solve();
	return 0;
}

/*
5AC5A2C


*/