#include <bits/stdc++.h>
using namespace std;

template<typename T> void uin(T & a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T & a, T b) {
	if (b > a) {
		a = b;
	}
}

#define int long long

int n, m, c;

int a[11][11];

void solve2() {
	for (int mask = 0; mask < (1 << (n * m)); ++mask) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				int num = (i - 1) * m + j;
				a[i][j] = (mask >> (num - 1)) & 1;
			}
		}
		bool OK = true;
		for (int x1 = 1; x1 <= n; ++x1) {
			for (int x2 = x1 + 1; x2 <= n; ++x2) {
				for (int y1 = 1; y1 <= m; ++y1) {
					for (int y2 = y1 + 1; y2 <= m; ++y2) {
						if (a[x1][y1] == a[x1][y2] && a[x1][y2] == a[x2][y1] && a[x2][y1] == a[x2][y2]) {
							OK = false;
							break;
						}
					}
				}
			}
		}
		if (OK) {
			for (int i = 1; i <= n; ++i) {
				for (int j = 1; j <= m; ++j) {
					cout << a[i][j] + 1 << " ";
				}
				cout << endl;
			}
			return;
		}
	}
}

int bubu = 1;
int base[25];

bool oke(int mask1, int mask2) {
	int cnt = 0;
	for (int i = 0; i < m; ++i) {
		if (mask1 % 3 == mask2 % 3) {
			++cnt;
		}
		if (cnt >= 2) return false;
		mask1 /= 3;
		mask2 /= 3;
	}
	return cnt < 2;
}

int get(int mask, int i) {
	--i;
	return (mask / base[i]) % 3;
}

int masks[11];

int mex(int x, int y) {
	for (int i = 0; i < 3; ++i) {
		if (i != x && i != y) return i;
	}
	return 0;
}

void gen(int row) {

	if (row == n + 1) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				cout << get(masks[i], j) + 1 << " ";
			}
			cout << endl;
		}
		exit(0);
	}
	if (row == 1) {
		
		for (int mask = 0; mask < bubu; ++mask) {
			masks[1] = mask;
			gen(row + 1);
		}
	} else if (row == 2) {
		for (int c = 1; c <= m; ++c) {
			for (int msk = 0; msk < (1 << (m - 1)); ++msk) {
				int ma = msk;
				int mask = 0;
				for (int i = 1; i <= m; ++i) {
					if (i == c) {
						mask += base[i - 1] * get(masks[1], i);
					} else {
						vector<int> kek;
						for (int j = 0; j < 3; ++j) {
							if (j != get(masks[1], i)) {
								kek.emplace_back(j);
							}
						}
						mask += base[i - 1] * kek[ma % 2];
						ma /= 2;
					}
				}
				if (oke(mask, masks[1])) {
					masks[row] = mask;
					gen(row + 1);
				}
			}
		}
	} else {
		int mask = 0;
		for (int i = 1; i <= m; ++i) {
			mask = base[i - 1] * mex(get(masks[1], i), get(masks[2], i));
		}
		bool ok = 1;
		for (int i = 1; i < row; ++i) {
			if (!oke(masks[i], mask)) {
				ok = 0;
				break;
			}
		}
		int _mask = mask;
		if (ok) {
			masks[row] = mask;
			gen(row + 1);
		}
		for (int x = 1; x <= m; ++x) {
			for (int y = x; y <= m; ++y) {
				for (int val1 : {0, 1, 2}) {
					for (int val2 : {0, 1, 2}) {
						if (x == y && val1 != val2) {
							continue;
						}
						if (x == y) {
							mask = _mask - get(_mask, x) * base[x - 1];
							mask += val1 * base[x - 1];
						} else {
							mask = _mask - get(_mask, x) * base[x - 1] - get(_mask, y) * base[y - 1];
							mask += val1 * base[x - 1] + val2 * base[y - 1];
						}

						ok = 1;
						for (int i = 1; i < row; ++i) {
							if (!oke(masks[i], mask)) {
								ok = 0;
								break;
							}
						}

						if (ok) {
							masks[row] = mask;
							gen(row + 1);
						}
					}
				}
			}
		}
	}
}

void solve3() {
	if (n <= 3) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				cout << i << " ";
			}
			cout << endl;
		}
		exit(0);
	}
	if (m <= 3) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				cout << j << " ";
			}
			cout << endl;
		}
		exit(0);
	}
	bubu = 1;
	base[0] = 1;
	for (int i = 1; i <= m; ++i) {
		bubu *= 3;
		base[i] = base[i - 1] * 3;
	}
	gen(1);
}

void solve() {
	if (c == 2) {
		solve2();
	} else {
		solve3();
	}
}


signed main() {
	cin >> n >> m >> c;
	solve();
	// a[1][1] = 1;
	// a[1][2] = 2;
	// a[2][1] = 2;
	// a[2][2] = 2;
	// for (int h = 4; h <= 10; h *= 2) {
	// 	for (int i = h / 2 + 1; i <= h; ++i) {
	// 		for (int j = h / 2 + 1; j <= h; ++j) {
	// 			a[i][j] = a[i - h / 2][j - h / 2];
	// 		}
	// 	}
	// 	for (int i = h / 2 + 1; i <= h; ++i) {
	// 		for (int j = 1; j <= h / 2; ++j) {
	// 			a[i][j] = a[i - h / 2][j] % 3 + 1;
	// 		}
	// 	}
	// 	for (int i = 1; i <= h / 2; ++i) {
	// 		for (int j = h / 2 + 1; j <= h; ++j) {
	// 			a[i][j] = a[i][j - h / 2] % 3 + 1;
	// 		}
	// 	}
	// }
	// for (int i = 1; i <= 8; ++i) {
	// 	for (int j = 1; j <= 8; ++j) {
	// 		cout << a[i][j];
	// 	}
	// 	cout << endl;
	// }
	// while (1) {
	// 	bool OK = true;
	// 	for (int x1 = 1; x1 <= n; ++x1) {
	// 		for (int x2 = x1 + 1; x2 <= n; ++x2) {
	// 			for (int y1 = 1; y1 <= m; ++y1) {
	// 				for (int y2 = y1 + 1; y2 <= m; ++y2) {
	// 					if (a[x1][y1] == a[x1][y2] && a[x1][y2] == a[x2][y1] && a[x2][y1] == a[x2][y2]) {
	// 						OK = false;
	// 						a[x1][y1] = a[x1][y1] % 3 + 1;
	// 						a[x2][y2] = a[x2][y2] % 3 + 1;
	// 						// cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
	// 						break;
	// 					}
	// 				}
	// 			}
	// 		}
	// 	}
	// 	if (OK) break;
	// }
	// for (int i = 1; i <= 8; ++i) {
	// 	for (int j = 1; j <= 8; ++j) {
	// 		cout << a[i][j];
	// 	}
	// 	cout << endl;
	// }
	return 0;
}

/*
5AC5A2C


*/