#include <bits/stdc++.h>
using namespace std;

template<typename T> void uin(T & a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T & a, T b) {
	if (b > a) {
		a = b;
	}
}

// #define int long long
#define all(v) v.begin(), v.end()
#define list list228

const int N = 228228;
const int MOD = 1e9 + 7;

int mod(long long x) {
	x %= MOD;
	if (x < 0) x += MOD;
	return x;
}

int n;
int a[N], b[N], c[N];
int dp[205][205][205][5];
int ndp[205][205][205][5];
bool ok[5][5];
int f[N];

void solve() {
	string sa, sb, sc;
	cin >> sa >> sb >> sc;
	n = (int)sa.size();
	{
		f[0] = 1;
		for (int i = 1; i <= n; ++i) {
			f[i] = mod(f[i - 1] * i);
		}
	}
	int cnt[5];
	memset(cnt,0,sizeof cnt);
	for (int i = 1; i <= n; ++i) {
		a[i] = (sa[i - 1] - '0');
		b[i] = (sb[i - 1] - '0');
		c[i] = (sc[i - 1] - '0');
		if ((a[i] + b[i]) % 10 == c[i]) {
			if (a[i] + b[i] < 10) {
				++cnt[1];
			} else {
				++cnt[3];
			}
		} else if ((a[i] + b[i] + 1) == c[i]){
			if (a[i] + b[i] < 10) {
				++cnt[2];
			} else {
				++cnt[4];
			}
		} else {
			cout << 0 << endl;
			return ;
		}
	}
	{
		// set ok
		ok[1][1] = ok[2][1] = 1;
		ok[3][2] = ok[4][2] = 1;
		ok[1][3] = ok[2][3] = 1;
		ok[3][4] = ok[4][4] = 1;
	}
	if (cnt[1]) {
		dp[1][0][0][1] = 1;
	}
	if (cnt[2]) {
		dp[0][1][0][2] = 1;
	}
	if (cnt[3]) {
		dp[0][0][1][3] = 1;
	}
	if (cnt[4]) {
		dp[0][0][1][4] = 1;
	}
	for (int i = 1; i < n; ++i) {
		for (int x = 0; x <= cnt[1]; ++x) {
			for (int y = 0; y <= cnt[2]; ++y) {
				for (int z = 0; z <= cnt[3]; ++z) {
					for (int w = 1; w <= 4; ++w) {
						ndp[x][y][z][w] = 0;
					}
				}
			}
		}
		for (int x = 0; x <= cnt[1]; ++x) {
			for (int y = 0; y <= cnt[2]; ++y) {
				for (int z = 0; z <= cnt[3]; ++z) {
					for (int last = 1; last <= 4; ++last) {
						if (dp[x][y][z][last]) {
							for (int new_last = 1; new_last <= 4; ++new_last) {
								if (ok[last][new_last]) {
									if (new_last == 1) {
										if (x + 1 > cnt[1]) continue;
										ndp[x + 1][y][z][new_last] = mod(ndp[x + 1][y][z][new_last] + dp[x][y][z][last]);
									} else if (new_last == 2) {
										if (y + 1 > cnt[2]) continue;
										ndp[x][y + 1][z][new_last] = mod(ndp[x][y + 1][z][new_last] + dp[x][y][z][last]);
									} else if (new_last == 3) {
										if (z + 1 > cnt[3]) continue;
										ndp[x][y][z + 1][new_last] = mod(ndp[x][y][z + 1][new_last] + dp[x][y][z][last]);
									} else {
										if (i - x - y - z + 1 > cnt[4]) continue;
										ndp[x][y][z][new_last] = mod(ndp[x][y][z][new_last] + dp[x][y][z][last]);
									}
								}
							}
						}
					}
				}
			}
		}
		for (int x = 0; x <= cnt[1]; ++x) {
			for (int y = 0; y <= cnt[2]; ++y) {
				for (int z = 0; z <= cnt[3]; ++z) {
					for (int w = 1; w <= 4; ++w) {
						dp[x][y][z][w] = ndp[x][y][z][w];
					}
				}
			}
		}
	}
	int ans = mod(dp[cnt[1]][cnt[2]][cnt[3]][1] + dp[cnt[1]][cnt[2]][cnt[3]][2]);
	ans = mod((long long)ans * f[cnt[1]]);
	ans = mod((long long)ans * f[cnt[2]]);
	ans = mod((long long)ans * f[cnt[3]]);
	cout << ans << endl;
}

signed main() {
	solve();
	return 0;
}


/*
3 
1 7
3
1 8
6
2 8
1 6



1
1 7
5



1
3 10
2 5 9



3
1 5
3
1 3
3
1 6
3



4
1 5
0
1 0
0
1 3
3
1 0
0




*/