#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int f1(int n, int m, int x) {
    return n * (n - 1) / 2 * m * x + x * (x + 1) / 2 * n;
}

int f2(int m, int x) {
    return x * m * (x * m + 1) / 2;
}

void sol() {
    int n, m;
    cin >> n >> m;
    int sm = n * m * (n * m + 1) / 2;
    int l = 1, r = m;
    while (r - l > 1) {
        int x = (l + r) / 2;
        if (f1(n, m, x) * 2 <= sm) {
            l = x;
        } else {
            r = x;
        }
    }
    vector<tuple<int, int, int>> res = {{abs(sm - 2 * f1(n, m, l)),     0, l},
                                        {abs(sm - 2 * f1(n, m, l + 1)), 0, l + 1}};
    l = 1, r = n;
    while (r - l > 1) {
        int x = (l + r) / 2;
        if (f2(m, x) * 2 <= sm) {
            l = x;
        } else {
            r = x;
        }
    }
    res.emplace_back(abs(sm - 2 * f2(m, l)), 1, l);
    res.emplace_back(abs(sm - 2 * f2(m, l + 1)), 1, l + 1);
    sort(all(res));
//    for (auto el : res) {
//        cout << get<0>(el) << ' ' << get<1>(el) << ' ' << get<2>(el) << '\n';
//    }
    auto ans = res[0];
    cout << (get<1>(ans) ? 'H' : 'V') << ' ' << get<2>(ans) + 1 << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        sol();
    }
}

/*
5
1 3
4 7
1 10
3 3
3 5
 */