#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> s(n);
    vector<pair<int, int>> ms(n);
    set<int> kek;
    for (int i = 0; i < n; i++) {
        int m, s_;
        cin >> m >> s_;
        s[i] = s_;
        vector<int> now(m);
        for (int &el : now) {
            cin >> el;
        }
        for (int j = 0; j < m - 1; j++) {
            kek.insert(now[j + 1] - now[j]);
        }
        ms[i] = {now[0], now.back()};
    }
    if ((int) kek.size() > 1) {
        cout << "No\n";
        return 0;
    }
    if (n == 1) {
        cout << "Yes\n1\n";
        return 0;
    }
    if (!kek.empty()) {
        int x = *kek.begin();
        map<int, int> beg, end;
        set<int> pr_len1, pr_len2;
        for (int i = 0; i < n; i++) {
            if (ms[i].first > x) {
                pr_len1.insert(i);
            }
            if (s[i] - ms[i].second > x) {
                pr_len2.insert(i);
            }
            beg[ms[i].first]++;
            end[s[i] - ms[i].second]++;
        }
        set<int> beg_with = pr_len1, end_with = pr_len2;
        set<int> prob;
        for (auto el : beg) {
            if (end[x - el.first] != el.second) {
                prob.insert(el.first);
            }
        }
        for (auto el : end) {
            if (beg[x - el.first] != el.second) {
                prob.insert(x - el.first);
            }
        }
        int cnt1 = 0, cnt2 = 0;
        int pr1 = -1, pr2 = -1;
        for (int el : prob) {
            if (beg[el] > end[x - el]) {
                cnt1++;
                pr1 = el;
            } else {
                cnt2++;
                pr2 = x - el;
            }
        }
        if (cnt1 + cnt2 != 0 && cnt1 + cnt2 != 2) {
            cout << "No\n";
            return 0;
        }
        vector<int> used(n);
        map<int, vector<int>> b, e;
        for (int i = 0; i < n; i++) {
            b[ms[i].first].push_back(i);
            e[s[i] - ms[i].second].push_back(i);
        }
        int start = -1, finish = -1;
        if (cnt1 + cnt2 == 2) {
            for (int i = 0; i < n; i++) {
                if (ms[i].first == pr1) {
                    for (int j = 0; j < n; j++) {
                        if (s[j] - ms[j].second == pr2 && i != j) {
                            start = i;
                            finish = j;
                            break;
                        }
                    }
                    if (start != -1) {
                        break;
                    }
                }
            }
        } else {
            start = 0, finish = 0;
            if (!beg_with.empty()) {
                start = *beg_with.begin();
            }
            if (!end_with.empty()) {
                finish = *beg_with.begin();
            }
        }
        if ((int) beg_with.size() > 1 || (int) end_with.size() > 1) {
            cout << "No\n";
            return 0;
        }
        if (start == -1) {
            cout << "No\n";
            return 0;
        }
        if (!beg_with.empty() && start != *beg_with.begin()) {
            cout << "No\n";
            return 0;
        }
        if (!end_with.empty() && finish != *end_with.begin()) {
            cout << "No\n";
            return 0;
        }
        vector<int> res = {start};
        used[start] = 1;
        while (true) {
            int dist = x - (s[res.back()] - ms[res.back()].second);
            bool flag = false;
            for (int i = (int) b[dist].size() - 1; i >= 0; i--) {
                if (!used[b[dist][i]]) {
                    if (cnt1 + cnt2 > 0 && b[dist][i] == finish && (int) res.size() < n - 1) {
                        continue;
                    }
                    flag = true;
                    used[b[dist][i]] = 1;
                    res.push_back(b[dist][i]);
                } else {
                    b[dist].pop_back();
                }
            }
            if (!flag) {
                break;
            }
        }
        cout << "Yes\n";
        for (int el : res) {
            cout << el + 1 << ' ';
        }
        cout << '\n';
    }
}