#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int mod = (int) 1e9 + 7;

int pow_(int n, int power) {
    if (power == 0) {
        return 1;
    }
    if (power % 2) {
        return n * pow_(n, power - 1) % mod;
    }
    int val = pow_(n, power / 2);
    return val * val % mod;
}

const int MAXN = 400500;

int factor[MAXN];

int f(int n, int k) {
    int val1 = factor[n + k - 1];
    int val2 = pow_(factor[n], mod - 2) * pow_(factor[k - 1], mod - 2) % mod;
    return val1 * val2 % mod;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    factor[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        factor[i] = factor[i - 1] * i % mod;
    }
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.size();
    int mm = 0, mp = 0, pm = 0, pp = 0;
    int ok = 0;
    for (int i = 0; i < n; i++) {
        int a1 = a[i] - '0', b1 = b[i] - '0', c1 = c[i] - '0';
        int val = (a1 + b1) % 10;
        if (val != c1 && (val + 1) % 10 != c1) {
            cout << 0 << '\n';
            return 0;
        }
        if (a1 + b1 > c1) {
            if (c1 == val) {
                mp++;
            } else {
                pp++;
            }
        } else {
            if (c1 == val) {
                mm++;
            } else {
                pm++;
            }
            if (a1 != 0 && b1 != 0 && c1 != 0) {
                ok++;
            }
        }
    }
    if (pm != mp) {
        cout << 0 << '\n';
        return 0;
    }
    int kek = ok * pow_(pm + mm, mod - 2) % mod;
    if (pm == 0) {
        if (pp > 0) {
            cout << 0 << '\n';
            return 0;
        }
        cout << factor[n] * kek % mod << '\n';
        return 0;
    }
    int val = f(pp, pm) * f(mm, pm + 1) % mod;
    val = val * factor[pm] % mod;
    val = val * factor[pp] % mod;
    val = val * factor[mm] % mod;
    val = val * factor[mp] % mod;
    cout << val * kek % mod << '\n';
}