//#pragma GCC optimize("Ofast,unroll-loops,fast-math")
//#pragma GCC target("avx,avx2,abm,sse,popcnt")

#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <cctype>
#include <string>
#include <cmath>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

const int MAXN = 10;

int a[MAXN][MAXN];

bool check(int n, int m)
{
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			for (int k = i + 1; k < n; ++k)
				for (int p = j + 1; p < m; ++p)
					if (a[i][j] == a[i][p] && a[i][j] == a[k][j] && a[i][j] == a[k][p])
						return false;

	return true;
}

int main()
{
	ios::sync_with_stdio(false);
	cout.tie(0), cin.tie(0);

	int n = 0, m = 0, c = 0;
	cin >> n >> m >> c;

	if (n * m > 60)
		return -1;

	for (ll mask = 0; mask < (1ll << (n * m)); ++mask)
	{
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				a[i][j] = 1 + ((mask >> (m * i + j)) & 1);

		if (check(n, m))
		{
			for (int i = 0; i < n; ++i)
			{
				for (int j = 0; j < m; ++j)
					cout << a[i][j] << " ";
				cout << "\n";
			}
			break;
		}
	}



	return 0;
}