//package com.company;

import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.lang.StringBuilder;

public class C {

    public void solve() throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        String s = br.readLine();
        int L = s.length();
        StringBuilder sa = new StringBuilder();
        ArrayList<Token> v = new ArrayList<Token>();
        for (int i = 0; i < L; ++i) {
            sa.append(s.charAt(i));
            if (s.charAt(i) <= '9') {
                continue;
            }
            v.add(new Token(sa));
            sa = new StringBuilder();
        }

        // less...

        int n = v.size();
        int ansl = 0;
        int indl = 0;
        int typl = 0;
        int ans = 0;
        int ind = 0;
        int typ = 0;
        for (int i = 0; i < n; ++i) {
            if (i != 0 && i != n - 1) {
                if (v.get(i - 1).c == v.get(i + 1).c && v.get(i).cnt == 1) {
                    int preans = v.get(i - 1).merge(v.get(i + 1)) + 1;
                    if (preans > ans) {
                        ans = preans;
                        ind = i;
                        typ = 1;
                    }
                }
                int preans = v.get(i).dec();
                if (preans > ans) {
                    ans = preans;
                    ind = i;
                    typ = 0;
                }
            }
        }
        ansl = ans;
        indl = ind;
        typl = typ;

        // MORE!!!

        ans = 1;
        ind = 0;
        typ = -2;
        for (int i = 0; i < n; ++i) {
            int prei = v.get(i).split();
            int preans = v.get(i).splitCnt(prei);
            if (preans > ans) {
                ans = preans;
                ind = i;
                typ = prei;
            }
            preans = v.get(i).inc();
            if (preans > ans) {
                ans = preans;
                ind = i;
                typ = -1;
            }
        }
        int lenn = 0;
        for (int i = 0; i < indl; ++i) {
            lenn += v.get(i).cnt;
        }
        out.println("2 " + (lenn + 1));
        lenn = 0;
        if (typ == -2) {
            out.println("1 1 " + v.get(0).inv());
        } else {
            for (int i = 0; i < ind; ++i) {
                lenn += v.get(i).cnt;
            }
            if (typ == -1) {
                out.println("1 " + (lenn) + " " + v.get(ind).c);
            } else if (typ == -3) {
                out.println("1 " + (lenn + 1) + " " + v.get(ind).inv());
            } else {
                out.println("1 " + (lenn + Token.ten[typ]) + " " + v.get(ind).inv());
            }
        }
    }

    public void run() {
        try {
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    PrintWriter out;

    public static void main(String[] args) {
        new C().run();
    }
}

class Token {
    static int[] ten = {2, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000};

    int cnt;
    char c;

    Token() {}
    Token(StringBuilder s) {
        int n = s.length();
        c = s.charAt(n - 1);
        if (n != 1) {
            cnt = Integer.parseInt(s.substring(0, n - 1));
        } else {
            cnt = 1;
        }
    }
    int log() {
        return (int)Math.floor(Math.log10(cnt));
    }
    int len() {
        if (cnt <= 1) {
            return cnt;
        } else {
            return 2 + log();
        }
    }
    int dec() {
        Token ans = new Token();
        ans.cnt = cnt - 1;
        return len() - ans.len();
    }
    int merge(Token b) {
        Token ans = new Token();
        ans.cnt = cnt + b.cnt;
        return len() + b.len() - ans.len();
    }
    int inc() {
        Token ans = new Token();
        ans.cnt = cnt + 1;
        return ans.len() - len();
    }
    int splitCnt(int i) {
        if (i == -1) {
            return 1;
        } else if (i == -3) {
            return 1;
        }
        Token a = new Token();
        a.cnt = ten[i];
        Token b = new Token();
        b.cnt = cnt - ten[i];
        return 1 + a.len() + b.len() - len();
    }
    int split() {
        if (cnt == 1) {
            return -1;
        } else if (cnt == 2) {
            return -3;
        }
        int ans = 0;
        int ind = 0;
        for (int i = 0; i < ten.length && ten[i] <= cnt; ++i) {
            int ab = splitCnt(i);
            if (ab > ans) {
                ans = ab;
                ind = i;
            }
        }
        return ind;
    }
    char inv() {
        switch (c) {
            case 'A':
                return 'C';
            case 'C':
                return 'T';
            case 'T':
                return 'G';
            default:
                return 'A';
        }
    }
}
