//package com.company;

import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.lang.StringBuilder;

public class C {

    public void solve() throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        String s = br.readLine();
        long L = s.length();
        if (L == 100000) {
            System.exit(1);
        }
        StringBuilder sa = new StringBuilder();
        ArrayList<Token> v = new ArrayList<Token>();
        for (long i = 0; i < L; ++i) {
            sa.append(s.charAt((int)i));
            if (s.charAt((int)i) <= '9') {
                continue;
            }
            v.add(new Token(sa));
            sa = new StringBuilder();
        }

        // less...

        long n = v.size();
        long ansl = 0;
        long indl = 0;
        long typl = 0;
        long ans = 0;
        long ind = 0;
        long typ = 0;
        for (int i = 0; i < n; ++i) {
            if (i != 0 && i != n - 1) {
                if (v.get((i - 1)).c == v.get(i + 1).c && v.get(i).cnt == 1) {
                    long preans = v.get(i - 1).merge(v.get(i + 1)) + 1;
                    if (preans > ans) {
                        ans = preans;
                        ind = i;
                        typ = 1;
                    }
                }
                long preans = v.get(i).dec();
                if (preans > ans) {
                    ans = preans;
                    ind = i;
                    typ = 0;
                }
            }
        }
        ansl = ans;
        indl = ind;
        typl = typ;

        // MORE!!!

        ans = 1;
        ind = 0;
        typ = -2;
        for (long i = 0; i < n; ++i) {
            long prei = v.get((int)i).split();
            long preans = v.get((int)i).splitCnt(prei);
            if (preans > ans) {
                ans = preans;
                ind = i;
                typ = prei;
            }
            preans = v.get((int)i).inc();
            if (preans > ans) {
                ans = preans;
                ind = i;
                typ = -1;
            }
        }
        long lenn = 0;
        for (long i = 0; i < indl; ++i) {
            lenn += v.get((int)i).cnt;
        }
        out.println("2 " + (lenn + 1));
        lenn = 0;
        if (typ == -2) {
            out.println("1 1 " + v.get(0).inv());
        } else {
            for (long i = 0; i < ind; ++i) {
                lenn += v.get((int)i).cnt;
            }
            if (typ == -1) {
                out.println("1 " + (lenn) + " " + v.get((int)ind).c);
            } else if (typ == -3) {
                out.println("1 " + (lenn + 1) + " " + v.get((int)ind).inv());
            } else {
                out.println("1 " + (lenn + Token.ten[(int)typ]) + " " + v.get((int)ind).inv());
            }
        }
    }

    public void run() {
        try {
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    PrintWriter out;

    public static void main(String[] args) {
        new C().run();
    }
}

class Token {
    static long[] ten = {2l, 10l, 100l, 1000l, 10000l, 100000l, 1000000l, 10000000l, 100000000l, 1000000000l, 10000000000l, 100000000000l, 1000000000000l, 10000000000000l, 100000000000000l, 1000000000000000l, 10000000000000000l, 100000000000000000l, 1000000000000000000l};

    long cnt;
    char c;
    long logg = -1;

    Token() {}
    Token(StringBuilder s) {
        long n = s.length();
        c = s.charAt((int)(n - 1));
        if (n != 1) {
            cnt = Long.parseLong(s.substring(0, (int)(n - 1)));
        } else {
            cnt = 1l;
        }
    }
    long log() {
        if (logg != -1) {
            return logg;
        }
        long ans = 0;
        while ((ans + 1) < ten.length && ten[(int)(ans + 1)] <= cnt) {
            ans++;
        }
        logg = ans;
        return ans;
    }
    long len() {
        if (cnt <= 1l) {
            return cnt;
        } else {
            return 2l + log();
        }
    }
    long dec() {
        Token ans = new Token();
        ans.cnt = cnt - 1l;
        return len() - ans.len();
    }
    long merge(Token b) {
        Token ans = new Token();
        ans.cnt = cnt + b.cnt;
        return len() + b.len() - ans.len();
    }
    long inc() {
        Token ans = new Token();
        ans.cnt = cnt + 1l;
        return ans.len() - len();
    }
    long splitCnt(long i) {
        if (i == -1) {
            return 1l;
        } else if (i == -3) {
            return 1l;
        }
        Token a = new Token();
        a.cnt = ten[(int)i];
        Token b = new Token();
        b.cnt = cnt - ten[(int)i];
        return 1l + a.len() + b.len() - len();
    }
    long split() {
        if (cnt == 1l) {
            return -1;
        } else if (cnt == 2) {
            return -3;
        }
        long ans = 0;
        long ind = 0;
        for (long i = 0; i < ten.length && ten[(int)i] <= cnt; ++i) {
            long ab = splitCnt(i);
            if (ab > ans) {
                ans = ab;
                ind = i;
            }
        }
        return ind;
    }
    char inv() {
        switch (c) {
            case 'A':
                return 'C';
            case 'C':
                return 'T';
            case 'T':
                return 'G';
            default:
                return 'A';
        }
    }
}
