//package com.company;

import java.io.*;
import java.util.*;

public class C {
    public void print(int[][] ans, int n, int m) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                int i1 = i;
                int j1 = j;
                if (n > m) {
                    i1 = j;
                    j1 = i;
                }
                out.print(ans[i1][j1] + " ");
            }
            out.println();
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int c = nextInt();
        if (Math.min(n, m) <= c) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (n < m && i == 0 || n >= m && j == 0) {
                        out.print("1 ");
                    } else if (n < m && i == 1 || n >= m && j == 1) {
                        out.print("2 ");
                    } else {
                        out.println("3 ");
                    }
                }
                out.println();
            }
        } else {
            if (c == 2) {
                int[][] ans = {{1, 2, 2, 1, 1, 2}, {2, 1, 1, 2, 1, 2}, {1, 2, 1, 2, 2, 1}, {2, 1, 2, 1, 2, 1}};
                print(ans, n, m);
            } else {
                if (Math.max(n, m) == 10 && Math.min(n, m))
                int[][] ans = {
                        {1, 2, 3, 2, 3, 1, 3, 1, 2},
                        {2, 3, 1, 3, 1, 2, 1, 2, 3},
                        {3, 1, 2, 1, 2, 3, 2, 3, 1},
                        {2, 3, 1, 2, 3, 1, 2, 3, 1},
                        {3, 1, 2, 3, 1, 2, 3, 1, 2},
                        {1, 2, 3, 1, 2, 3, 1, 2, 3},
                        {3, 1, 2, 2, 3, 1, 1, 2, 3},
                        {1, 2, 3, 3, 1, 2, 2, 3, 1},
                        {2, 3, 1, 1, 2, 3, 3, 1, 2},
                };
                print(ans, n, m);
            }
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new C().run();
    }

}