#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <tuple>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
void solve() {
    long long n, m;
    cin >> n >> m;
    long long sum1 = 0, sum2 = (n * m + 1) * (n * m) / 2;
    long long res_v = sum2, ans_v = 1;
    for (int k = 2; k <= m; ++k) {
        long long t = (2 * (k - 1) + m * (n - 1)) * n / 2;
        sum1 += t;
        sum2 -= t;
        if (abs(sum1 - sum2) < res_v) {
            res_v = abs(sum1 - sum2);
            ans_v = k;
        }
    }
    sum1 = 0, sum2 = (n * m + 1) * (n * m) / 2;
    long long res_h = sum2, ans_h = 1;
    for (int k = 2; k <= n; ++k) {
        long long t = m * ((k - 2) * m + 1 + (k - 1) * m) / 2;
        sum1 += t;
        sum2 -= t;
        if (abs(sum1 - sum2) < res_h) {
            res_h = abs(sum1 - sum2);
            ans_h = k;
        }
    }
    if (res_v <= res_h)
        cout << 'V' << ' ' << ans_v << '\n';
    else
        cout << 'H' << ' ' << ans_h << '\n';
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}