#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <tuple>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <numeric>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
bool check(string & s, int k) {
    if (s.size() <= 1 + k)
        return true;
    if (k)
        return count(s.begin(), s.end(), s[0]) >= s.size() - 1 || count(s.begin(), s.end(), s[1]) >= s.size() - 1;
    else
        return count(s.begin(), s.end(), s[0]) == s.size();
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    string s;
    int k;
    cin >> s >> k;
    if (check(s, k)) {
        cout << s;
        return 0;
    }
    int i = s.find_first_not_of(s[0]);
    if (k == 0)
        cout << string(s.size(), s[0] + (s[i] > s[0]));
    else {
        int j = s.find_first_not_of(s[i], i);
        int c = s.find_first_not_of(s[0], i + 1);
        if (s[0] < s[i]) {
            if (s[c] < s[0]) {
                for (int r = c; r < s.size(); ++r)
                    s[r] = s[0];
            } else if (s[j] < s[i]) {
                for (int r = j; r < s.size(); ++r)
                    s[r] = s[i];
            } else {
                ++s[i];
                for (int r = c; r < s.size(); ++r)
                    s[r] = s[0];
            }
        } else {
            if (s[j] < s[i]) {
                for (int r = j; r < s.size(); ++r)
                    s[r] = s[i];
            } else if (s[c] < s[0]) {
                for (int r = c; r < s.size(); ++r)
                    s[r] = s[0];
            } else {
                ++s[i];
                if (s[i] != s[0]) {
                    for (int r = i + 1; r < s.size(); ++r)
                        s[r] = s[0];
                } else {
                    s[i + 1] = '0';
                    for (int r = i + 2; r < s.size(); ++r)
                        s[r] = s[0];
                }
            }
        }
    }
    cout << s;
    return 0;
}