#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <tuple>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
int mask[3];
bool cmp(const int & a, const int & b) {
    return __builtin_popcount(mask[a]) < __builtin_popcount(mask[b]);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, c;
    cin >> n >> m >> c;
    int a[n][m];
    vector<int> order(c), k(c);
    for (int i = 0; i < c; ++i)
        order[i] = i;
    for (int i = 0; i < n; ++i) {
        fill(k.begin(), k.end(), -1);
        for (int j = 0; j < m; ++j)
            for (auto it : order)
                if (k[it] == -1 && (mask[it] >> j) & 1) {
                    k[it] = j;
                    a[i][j] = it + 1;
                    break;
                }
        for (int j = 0; j < m; ++j) {
            if (find(k.begin(), k.end(), j) != k.end())
                break;
            for (auto it : order) {
                if (((mask[it] >> j) & 1) == 0) {
                    mask[it] |= 1 << j;
                    a[i][j] = it + 1;
                    break;
                }
            }
            sort(order.begin(), order.end(), cmp);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j)
            cout << a[i][j] << ' ';
        cout << '\n';
    }
    return 0;
}