#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <tuple>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <numeric>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int MOD = 1e9 + 7;
int to_int(string & s) {
    int ans = 0;
    for (auto c : s)
        ans = 10 * ans + (c - '0');
    return ans;
}
bool check(string & a, string & b, string & c) {
    if (a[0] == '0' || b[0] == '0' || c[0] == '0')
        return false;
    int x = to_int(a), y = to_int(b), z = to_int(c);
    return x + y == z;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.size(), ans = 0;
    vector<bool> have_zero(n), inc_next(n), need_inc(n);
    vector<int> p(1 << 3);
    for (int i = 0; i < 1 << 3; ++i)
        p[i] = i;
    for (int i = 0; i < n; ++i) {
        have_zero[i] = a[i] == '0' || b[i] == '0' || c[i] == '0';
        int sum = (a[i] - '0') + (b[i] - '0');
        need_inc[i] = (sum + 1) % 10 == c[i] - '0';
        if (!need_inc[i] && sum % 10 != c[i] - '0') {
            cout << 0;
            return 0;
        }
        inc_next[i] = sum + need_inc[i] >= 10;
    }
    cout << ans;
    return 0;
}
