#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <tuple>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <numeric>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
int to_int(string & s) {
    int ans = 0;
    for (auto c : s)
        ans = 10 * ans + (c - '0');
    return ans;
}
bool check(string & a, string & b, string & c) {
    if (a[0] == '0' || b[0] == '0' || c[0] == '0')
        return false;
    int x = to_int(a), y = to_int(b), z = to_int(c);
    return x + y == z;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.size(), ans = 0;
    string x(n, ' '), y(n, ' '), z(n, ' ');
    vector<int> p(n);
    for (int i = 1; i < n; ++i)
        p[i] = i;
    do {
        for (int i = 0; i < n; ++i) {
            int j = p[i];
            x[i] = a[j];
            y[i] = b[j];
            z[i] = c[j];
        }
        ans += check(x, y, z);
    } while (next_permutation(p.begin(), p.end()));
    cout << ans;
    return 0;
}
